/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var te=["require","exports","vs/base/common/lifecycle","vs/base/common/event","vs/base/common/platform","vs/platform/log/common/log","vs/platform/instantiation/common/instantiation","vs/base/common/uri","vs/base/common/async","vs/base/common/path","vs/nls!vs/code/electron-main/main","vs/nls","vs/base/common/types","vs/base/common/network","vs/base/common/errors","electron","vs/platform/files/common/files","vs/base/common/buffer","vs/platform/configuration/common/configuration","vs/base/common/resources","vs/platform/lifecycle/electron-main/lifecycleMainService","vs/base/node/pfs","vs/base/common/cancellation","vs/base/common/arrays","vs/platform/product/common/productService","vs/platform/environment/electron-main/environmentMainService","vs/platform/telemetry/common/telemetry","vs/base/common/strings","os","vs/platform/workspace/common/workspace","vs/platform/windows/electron-main/windows","vs/base/common/map","vs/base/common/uuid","vs/base/common/extpath","vs/platform/state/node/state","vs/base/common/process","vs/platform/environment/common/environment","vs/base/common/objects","vs/base/parts/ipc/electron-main/ipcMain","vs/platform/policy/common/policy","vs/platform/uriIdentity/common/uriIdentity","vs/platform/userDataProfile/common/userDataProfile","vs/base/parts/ipc/common/ipc","vs/platform/registry/common/platform","vs/base/common/json","fs","vs/base/common/labels","child_process","vs/platform/update/common/update","vs/base/common/errorMessage","vs/platform/request/common/request","vs/platform/telemetry/common/telemetryUtils","vs/platform/userDataProfile/electron-main/userDataProfile","vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/base/common/decorators","vs/base/common/hash","vs/base/common/ternarySearchTree","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteHosts","vs/platform/dialogs/electron-main/dialogMainService","vs/platform/utilityProcess/electron-main/utilityProcess","vs/base/common/stream","vs/platform/environment/node/argvHelper","vs/platform/backup/electron-main/backup","vs/platform/files/common/watcher","vs/base/common/performance","vs/platform/log/electron-main/loggerService","vs/platform/theme/electron-main/themeMainService","vs/platform/window/common/window","vs/platform/native/electron-main/nativeHostMainService","vs/base/common/iterator","vs/base/common/lazy","vs/base/common/stopwatch","vs/base/common/severity","vs/base/common/codicons","vs/base/common/processes","vs/base/common/marshalling","vs/platform/instantiation/common/descriptors","vs/platform/product/common/product","vs/platform/protocol/electron-main/protocol","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/platform/storage/electron-main/storageMainService","vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/base/common/functional","vs/base/common/normalization","crypto","vs/base/node/id","net","vs/base/node/processes","vs/platform/environment/node/environmentService","vs/platform/diagnostics/common/diagnostics","vs/platform/instantiation/common/serviceCollection","vs/platform/files/node/diskFileSystemProvider","vs/platform/shell/node/shellEnv","vs/platform/sign/common/sign","vs/platform/window/electron-main/window","vs/platform/storage/common/storage","vs/platform/workspaces/common/workspaces","vs/platform/workspaces/node/workspaces","vs/base/parts/ipc/node/ipc.net","vs/platform/update/electron-main/abstractUpdateService","vs/base/common/linkedList","vs/base/common/themables","vs/base/node/ports","vs/base/common/glob","vs/base/node/extpath","vs/base/node/powershell","vs/base/node/ps","vs/base/node/shell","vs/base/parts/ipc/common/ipc.net","vs/base/parts/ipc/electron-main/ipc.mp","vs/base/parts/storage/common/storage","vs/platform/environment/node/argv","path","vs/platform/contextkey/common/contextkey","vs/platform/dialogs/common/dialogs","vs/platform/encryption/common/encryptionService","vs/platform/extensionManagement/common/extensionManagement","vs/platform/files/common/io","vs/platform/configuration/common/configurationModels","vs/platform/extensions/common/extensions","vs/platform/state/node/stateService","vs/platform/telemetry/common/commonProperties","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariable","vs/platform/terminal/common/terminal","vs/platform/tunnel/common/tunnel","vs/platform/url/common/url","vs/platform/extensionManagement/common/extensionsScannerService","vs/platform/windows/electron-main/windowsFinder","vs/base/node/unc","vs/platform/diagnostics/electron-main/diagnosticsMainService","vs/base/common/arraysFind","vs/base/common/collections","vs/base/common/color","vs/base/common/assert","vs/base/common/jsonFormatter","vs/base/common/jsonEdit","vs/base/common/numbers","vs/base/common/skipList","vs/base/common/cache","vs/base/common/symbols","vs/base/node/crypto","vs/base/node/macAddress","vs/base/parts/contextmenu/common/contextmenu","vs/base/parts/ipc/common/ipc.electron","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/nls!vs/base/common/platform","vs/base/common/console","vs/base/common/uriIpc","util","vs/base/parts/ipc/common/ipc.mp","vs/base/parts/contextmenu/electron-main/contextmenu","vs/base/parts/ipc/electron-main/ipc.electron","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/node/storage","vs/nls!vs/code/electron-main/app","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/dialogs/common/dialogs","vs/nls!vs/platform/dialogs/electron-main/dialogMainService","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/environment/node/argvHelper","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/electron-main/diskFileSystemProviderServer","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/issue/electron-main/issueMainService","vs/nls!vs/platform/menubar/electron-main/menubar","vs/nls!vs/platform/native/electron-main/nativeHostMainService","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/shell/node/shellEnv","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/terminal/common/terminalPlatformConfiguration","vs/nls!vs/platform/terminal/common/terminalProfiles","vs/nls!vs/platform/update/common/update.config.contribution","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/windows/electron-main/windowImpl","vs/nls!vs/platform/windows/electron-main/windowsMainService","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/nls!vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/platform/backup/common/backup","vs/platform/backup/node/backup","vs/platform/contextkey/common/scanner","vs/platform/debug/common/extensionHostDebugIpc","vs/platform/environment/common/environmentService","vs/platform/debug/electron-main/extensionHostDebugIpc","vs/platform/environment/node/userDataPath","vs/platform/environment/node/wait","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensions/common/extensionValidator","vs/base/common/semver/semver","vs/platform/externalServices/common/serviceMachineId","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/extensions/common/extensionHostStarter","vs/platform/externalTerminal/common/externalTerminal","vs/platform/externalTerminal/electron-main/externalTerminal","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/files/common/diskFileSystemProviderClient","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/issue/common/issue","vs/platform/encryption/electron-main/encryptionMainService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/platform/files/node/diskFileSystemProviderServer","vs/platform/files/electron-main/diskFileSystemProviderServer","vs/platform/log/common/bufferLog","vs/platform/log/common/logIpc","vs/platform/log/common/logService","vs/platform/log/electron-main/logIpc","vs/platform/log/node/spdlogLog","vs/platform/log/node/loggerService","vs/platform/menubar/common/menubar","vs/platform/policy/common/filePolicyService","vs/platform/policy/common/policyIpc","vs/platform/policy/node/nativePolicyService","vs/platform/profiling/electron-main/windowProfiling","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/remote/common/electronRemoteResources","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteAgentConnection","vs/platform/remote/common/remoteSocketFactoryService","vs/platform/remote/node/wsl","vs/platform/request/common/requestIpc","vs/platform/request/node/proxy","url","vs/platform/sharedProcess/common/sharedProcess","vs/platform/sign/common/abstractSignService","vs/platform/sign/node/signService","vs/platform/diagnostics/node/diagnosticsService","vs/platform/telemetry/common/telemetryIpc","vs/platform/externalServices/common/marketplace","vs/platform/telemetry/common/telemetryService","vs/platform/telemetry/node/telemetryUtils","vs/platform/telemetry/electron-main/telemetryUtils","vs/platform/terminal/common/environmentVariableCollection","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/requestStore","vs/platform/terminal/common/terminalProfiles","vs/platform/terminal/common/terminalPlatformConfiguration","vs/platform/terminal/node/terminalEnvironment","vs/platform/terminal/node/terminalProfiles","vs/platform/terminal/node/ptyHostService","vs/platform/update/common/update.config.contribution","vs/platform/update/common/updateIpc","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/url/common/urlIpc","vs/platform/url/common/urlService","vs/platform/url/electron-main/electronUrlListener","vs/platform/userData/common/fileUserDataProvider","vs/platform/utilityProcess/common/utilityProcessWorkerService","vs/platform/webview/common/webviewManagerService","vs/platform/webview/electron-main/webviewProtocolProvider","vs/platform/windows/node/windowTracker","vs/platform/storage/electron-main/storageIpc","vs/platform/extensionManagement/node/extensionsProfileScannerService","vs/platform/extensionManagement/node/extensionsScannerService","vs/platform/protocol/electron-main/protocolMainService","vs/platform/storage/electron-main/storageMain","vs/platform/userDataProfile/electron-main/userDataProfileStorageIpc","vs/platform/userDataProfile/node/userDataProfile","zlib","vs/platform/backup/electron-main/backupMainService","vs/platform/keyboardLayout/electron-main/keyboardLayoutMainService","vs/platform/request/node/requestService","vs/platform/request/electron-main/requestMainService","vs/platform/tunnel/node/tunnelService","vs/platform/update/electron-main/updateService.darwin","vs/platform/update/electron-main/updateService.snap","vs/code/electron-main/auth","vs/platform/launch/electron-main/launchMainService","vs/platform/userDataProfile/electron-main/userDataProfilesHandler","vs/platform/extensions/electron-main/extensionHostStarter","vs/platform/sharedProcess/electron-main/sharedProcess","vs/platform/terminal/electron-main/electronPtyHostStarter","vs/platform/utilityProcess/electron-main/utilityProcessWorkerMainService","vs/platform/webview/electron-main/webviewMainService","vs/platform/windows/electron-main/auxiliaryWindow","vs/platform/windows/electron-main/windowsStateHandler","vs/platform/issue/electron-main/issueMainService","vs/platform/update/electron-main/updateService.linux","vs/platform/update/electron-main/updateService.win32","vs/platform/windows/electron-main/windowImpl","vs/platform/menubar/electron-main/menubar","vs/platform/menubar/electron-main/menubarMainService","vs/platform/windows/electron-main/windowsMainService","vs/platform/workspaces/electron-main/workspacesMainService","vs/code/electron-main/app","minimist","assert","graceful-fs","@vscode/policy-watcher","string_decoder","vs/code/electron-main/main"],ie=function(Q){for(var e=[],S=0,R=Q.length;S<R;S++)e[S]=te[Q[S]];return e};define(te[132],ie([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rb=e.$qb=e.$pb=e.$ob=e.$nb=e.$mb=e.$lb=e.$kb=e.$jb=e.$ib=e.$hb=e.$gb=e.$fb=void 0;function S(b,$,m){const u=R(b,$);if(u!==-1)return b[u]}e.$fb=S;function R(b,$,m=b.length-1){for(let u=m;u>=0;u--){const l=b[u];if($(l))return u}return-1}e.$gb=R;function s(b,$){const m=M(b,$);return m===-1?void 0:b[m]}e.$hb=s;function M(b,$,m=0,u=b.length){let l=m,E=u;for(;l<E;){const h=Math.floor((l+E)/2);$(b[h])?l=h+1:E=h}return l-1}e.$ib=M;function D(b,$){const m=P(b,$);return m===b.length?void 0:b[m]}e.$jb=D;function P(b,$,m=0,u=b.length){let l=m,E=u;for(;l<E;){const h=Math.floor((l+E)/2);$(b[h])?E=h:l=h+1}return l}e.$kb=P;function f(b,$,m=0,u=b.length){const l=P(b,$,m,u);return l===b.length?-1:l}e.$lb=f;class a{static{this.assertInvariants=!1}constructor($){this.e=$,this.c=0}findLastMonotonous($){if(a.assertInvariants){if(this.d){for(const u of this.e)if(this.d(u)&&!$(u))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this.d=$}const m=M(this.e,$,this.c);return this.c=m+1,m===-1?void 0:this.e[m]}}e.$mb=a;function g(b,$){if(b.length===0)return;let m=b[0];for(let u=1;u<b.length;u++){const l=b[u];$(l,m)>0&&(m=l)}return m}e.$nb=g;function w(b,$){if(b.length===0)return;let m=b[0];for(let u=1;u<b.length;u++){const l=b[u];$(l,m)>=0&&(m=l)}return m}e.$ob=w;function y(b,$){return g(b,(m,u)=>-$(m,u))}e.$pb=y;function d(b,$){if(b.length===0)return-1;let m=0;for(let u=1;u<b.length;u++){const l=b[u];$(l,b[m])>0&&(m=u)}return m}e.$qb=d;function v(b,$){for(const m of b){const u=$(m);if(u!==void 0)return u}}e.$rb=v}),define(te[133],ie([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$M=e.$L=e.$K=e.$J=void 0;function S(D,P){const f=Object.create(null);for(const a of D){const g=P(a);let w=f[g];w||(w=f[g]=[]),w.push(a)}return f}e.$J=S;function R(D,P){const f=[],a=[];for(const g of D)P.has(g)||f.push(g);for(const g of P)D.has(g)||a.push(g);return{removed:f,added:a}}e.$K=R;function s(D,P){const f=[],a=[];for(const[g,w]of D)P.has(g)||f.push(w);for(const[g,w]of P)D.has(g)||a.push(w);return{removed:f,added:a}}e.$L=s;function M(D,P){const f=new Set;for(const a of P)D.has(a)&&f.add(a);return f}e.$M=M}),define(te[134],ie([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Us=e.$Ts=e.$Ss=e.$Rs=void 0;function S(P,f){const a=Math.pow(10,f);return Math.round(P*a)/a}class R{constructor(f,a,g,w=1){this._rgbaBrand=void 0,this.r=Math.min(255,Math.max(0,f))|0,this.g=Math.min(255,Math.max(0,a))|0,this.b=Math.min(255,Math.max(0,g))|0,this.a=S(Math.max(Math.min(1,w),0),3)}static equals(f,a){return f.r===a.r&&f.g===a.g&&f.b===a.b&&f.a===a.a}}e.$Rs=R;class s{constructor(f,a,g,w){this._hslaBrand=void 0,this.h=Math.max(Math.min(360,f),0)|0,this.s=S(Math.max(Math.min(1,a),0),3),this.l=S(Math.max(Math.min(1,g),0),3),this.a=S(Math.max(Math.min(1,w),0),3)}static equals(f,a){return f.h===a.h&&f.s===a.s&&f.l===a.l&&f.a===a.a}static fromRGBA(f){const a=f.r/255,g=f.g/255,w=f.b/255,y=f.a,d=Math.max(a,g,w),v=Math.min(a,g,w);let b=0,$=0;const m=(v+d)/2,u=d-v;if(u>0){switch($=Math.min(m<=.5?u/(2*m):u/(2-2*m),1),d){case a:b=(g-w)/u+(g<w?6:0);break;case g:b=(w-a)/u+2;break;case w:b=(a-g)/u+4;break}b*=60,b=Math.round(b)}return new s(b,$,m,y)}static i(f,a,g){return g<0&&(g+=1),g>1&&(g-=1),g<1/6?f+(a-f)*6*g:g<1/2?a:g<2/3?f+(a-f)*(2/3-g)*6:f}static toRGBA(f){const a=f.h/360,{s:g,l:w,a:y}=f;let d,v,b;if(g===0)d=v=b=w;else{const $=w<.5?w*(1+g):w+g-w*g,m=2*w-$;d=s.i(m,$,a+1/3),v=s.i(m,$,a),b=s.i(m,$,a-1/3)}return new R(Math.round(d*255),Math.round(v*255),Math.round(b*255),y)}}e.$Ss=s;class M{constructor(f,a,g,w){this._hsvaBrand=void 0,this.h=Math.max(Math.min(360,f),0)|0,this.s=S(Math.max(Math.min(1,a),0),3),this.v=S(Math.max(Math.min(1,g),0),3),this.a=S(Math.max(Math.min(1,w),0),3)}static equals(f,a){return f.h===a.h&&f.s===a.s&&f.v===a.v&&f.a===a.a}static fromRGBA(f){const a=f.r/255,g=f.g/255,w=f.b/255,y=Math.max(a,g,w),d=Math.min(a,g,w),v=y-d,b=y===0?0:v/y;let $;return v===0?$=0:y===a?$=((g-w)/v%6+6)%6:y===g?$=(w-a)/v+2:$=(a-g)/v+4,new M(Math.round($*60),b,y,f.a)}static toRGBA(f){const{h:a,s:g,v:w,a:y}=f,d=w*g,v=d*(1-Math.abs(a/60%2-1)),b=w-d;let[$,m,u]=[0,0,0];return a<60?($=d,m=v):a<120?($=v,m=d):a<180?(m=d,u=v):a<240?(m=v,u=d):a<300?($=v,u=d):a<=360&&($=d,u=v),$=Math.round(($+b)*255),m=Math.round((m+b)*255),u=Math.round((u+b)*255),new R($,m,u,y)}}e.$Ts=M;class D{static fromHex(f){return D.Format.CSS.parseHex(f)||D.red}static equals(f,a){return!f&&!a?!0:!f||!a?!1:f.equals(a)}get hsla(){return this.i?this.i:s.fromRGBA(this.rgba)}get hsva(){return this.j?this.j:M.fromRGBA(this.rgba)}constructor(f){if(f)if(f instanceof R)this.rgba=f;else if(f instanceof s)this.i=f,this.rgba=s.toRGBA(f);else if(f instanceof M)this.j=f,this.rgba=M.toRGBA(f);else throw new Error("Invalid color ctor argument");else throw new Error("Color needs a value")}equals(f){return!!f&&R.equals(this.rgba,f.rgba)&&s.equals(this.hsla,f.hsla)&&M.equals(this.hsva,f.hsva)}getRelativeLuminance(){const f=D.k(this.rgba.r),a=D.k(this.rgba.g),g=D.k(this.rgba.b),w=.2126*f+.7152*a+.0722*g;return S(w,4)}static k(f){const a=f/255;return a<=.03928?a/12.92:Math.pow((a+.055)/1.055,2.4)}getContrastRatio(f){const a=this.getRelativeLuminance(),g=f.getRelativeLuminance();return a>g?(a+.05)/(g+.05):(g+.05)/(a+.05)}isDarker(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3<128}isLighter(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3>=128}isLighterThan(f){const a=this.getRelativeLuminance(),g=f.getRelativeLuminance();return a>g}isDarkerThan(f){const a=this.getRelativeLuminance(),g=f.getRelativeLuminance();return a<g}lighten(f){return new D(new s(this.hsla.h,this.hsla.s,this.hsla.l+this.hsla.l*f,this.hsla.a))}darken(f){return new D(new s(this.hsla.h,this.hsla.s,this.hsla.l-this.hsla.l*f,this.hsla.a))}transparent(f){const{r:a,g,b:w,a:y}=this.rgba;return new D(new R(a,g,w,y*f))}isTransparent(){return this.rgba.a===0}isOpaque(){return this.rgba.a===1}opposite(){return new D(new R(255-this.rgba.r,255-this.rgba.g,255-this.rgba.b,this.rgba.a))}blend(f){const a=f.rgba,g=this.rgba.a,w=a.a,y=g+w*(1-g);if(y<1e-6)return D.transparent;const d=this.rgba.r*g/y+a.r*w*(1-g)/y,v=this.rgba.g*g/y+a.g*w*(1-g)/y,b=this.rgba.b*g/y+a.b*w*(1-g)/y;return new D(new R(d,v,b,y))}makeOpaque(f){if(this.isOpaque()||f.rgba.a!==1)return this;const{r:a,g,b:w,a:y}=this.rgba;return new D(new R(f.rgba.r-y*(f.rgba.r-a),f.rgba.g-y*(f.rgba.g-g),f.rgba.b-y*(f.rgba.b-w),1))}flatten(...f){const a=f.reduceRight((g,w)=>D.o(w,g));return D.o(this,a)}static o(f,a){const g=1-f.rgba.a;return new D(new R(g*a.rgba.r+f.rgba.a*f.rgba.r,g*a.rgba.g+f.rgba.a*f.rgba.g,g*a.rgba.b+f.rgba.a*f.rgba.b))}toString(){return this.u||(this.u=D.Format.CSS.format(this)),this.u}static getLighterColor(f,a,g){if(f.isLighterThan(a))return f;g=g||.5;const w=f.getRelativeLuminance(),y=a.getRelativeLuminance();return g=g*(y-w)/y,f.lighten(g)}static getDarkerColor(f,a,g){if(f.isDarkerThan(a))return f;g=g||.5;const w=f.getRelativeLuminance(),y=a.getRelativeLuminance();return g=g*(w-y)/w,f.darken(g)}static{this.white=new D(new R(255,255,255,1))}static{this.black=new D(new R(0,0,0,1))}static{this.red=new D(new R(255,0,0,1))}static{this.blue=new D(new R(0,0,255,1))}static{this.green=new D(new R(0,255,0,1))}static{this.cyan=new D(new R(0,255,255,1))}static{this.lightgrey=new D(new R(211,211,211,1))}static{this.transparent=new D(new R(0,0,0,0))}}e.$Us=D,function(P){let f;(function(a){let g;(function(w){function y(i){return i.rgba.a===1?`rgb(${i.rgba.r}, ${i.rgba.g}, ${i.rgba.b})`:P.Format.CSS.formatRGBA(i)}w.formatRGB=y;function d(i){return`rgba(${i.rgba.r}, ${i.rgba.g}, ${i.rgba.b}, ${+i.rgba.a.toFixed(2)})`}w.formatRGBA=d;function v(i){return i.hsla.a===1?`hsl(${i.hsla.h}, ${(i.hsla.s*100).toFixed(2)}%, ${(i.hsla.l*100).toFixed(2)}%)`:P.Format.CSS.formatHSLA(i)}w.formatHSL=v;function b(i){return`hsla(${i.hsla.h}, ${(i.hsla.s*100).toFixed(2)}%, ${(i.hsla.l*100).toFixed(2)}%, ${i.hsla.a.toFixed(2)})`}w.formatHSLA=b;function $(i){const c=i.toString(16);return c.length!==2?"0"+c:c}function m(i){return`#${$(i.rgba.r)}${$(i.rgba.g)}${$(i.rgba.b)}`}w.formatHex=m;function u(i,c=!1){return c&&i.rgba.a===1?P.Format.CSS.formatHex(i):`#${$(i.rgba.r)}${$(i.rgba.g)}${$(i.rgba.b)}${$(Math.round(i.rgba.a*255))}`}w.formatHexA=u;function l(i){return i.isOpaque()?P.Format.CSS.formatHex(i):P.Format.CSS.formatRGBA(i)}w.format=l;function E(i){const c=i.length;if(c===0||i.charCodeAt(0)!==35)return null;if(c===7){const o=16*h(i.charCodeAt(1))+h(i.charCodeAt(2)),t=16*h(i.charCodeAt(3))+h(i.charCodeAt(4)),n=16*h(i.charCodeAt(5))+h(i.charCodeAt(6));return new P(new R(o,t,n,1))}if(c===9){const o=16*h(i.charCodeAt(1))+h(i.charCodeAt(2)),t=16*h(i.charCodeAt(3))+h(i.charCodeAt(4)),n=16*h(i.charCodeAt(5))+h(i.charCodeAt(6)),r=16*h(i.charCodeAt(7))+h(i.charCodeAt(8));return new P(new R(o,t,n,r/255))}if(c===4){const o=h(i.charCodeAt(1)),t=h(i.charCodeAt(2)),n=h(i.charCodeAt(3));return new P(new R(16*o+o,16*t+t,16*n+n))}if(c===5){const o=h(i.charCodeAt(1)),t=h(i.charCodeAt(2)),n=h(i.charCodeAt(3)),r=h(i.charCodeAt(4));return new P(new R(16*o+o,16*t+t,16*n+n,(16*r+r)/255))}return null}w.parseHex=E;function h(i){switch(i){case 48:return 0;case 49:return 1;case 50:return 2;case 51:return 3;case 52:return 4;case 53:return 5;case 54:return 6;case 55:return 7;case 56:return 8;case 57:return 9;case 97:return 10;case 65:return 10;case 98:return 11;case 66:return 11;case 99:return 12;case 67:return 12;case 100:return 13;case 68:return 13;case 101:return 14;case 69:return 14;case 102:return 15;case 70:return 15}return 0}})(g=a.CSS||(a.CSS={}))})(f=P.Format||(P.Format={}))}(D||(e.$Us=D={}))}),define(te[54],ie([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ih=e.$hh=e.$gh=void 0;function S(D){return(P,f,a)=>{let g=null,w=null;if(typeof a.value=="function"?(g="value",w=a.value):typeof a.get=="function"&&(g="get",w=a.get),!w)throw new Error("not supported");a[g]=D(w,f)}}function R(D,P,f){let a=null,g=null;if(typeof f.value=="function"?(a="value",g=f.value,g.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof f.get=="function"&&(a="get",g=f.get),!g)throw new Error("not supported");const w=`$memoize$${P}`;f[a]=function(...y){return this.hasOwnProperty(w)||Object.defineProperty(this,w,{configurable:!1,enumerable:!1,writable:!1,value:g.apply(this,y)}),this[w]}}e.$gh=R;function s(D,P,f){return S((a,g)=>{const w=`$debounce$${g}`,y=`$debounce$result$${g}`;return function(...d){this[y]||(this[y]=f?f():void 0),clearTimeout(this[w]),P&&(this[y]=P(this[y],...d),d=[this[y]]),this[w]=setTimeout(()=>{a.apply(this,d),this[y]=f?f():void 0},D)}})}e.$hh=s;function M(D,P,f){return S((a,g)=>{const w=`$throttle$timer$${g}`,y=`$throttle$result$${g}`,d=`$throttle$lastRun$${g}`,v=`$throttle$pending$${g}`;return function(...b){if(this[y]||(this[y]=f?f():void 0),(this[d]===null||this[d]===void 0)&&(this[d]=-Number.MAX_VALUE),P&&(this[y]=P(this[y],...b)),this[v])return;const $=this[d]+D;$<=Date.now()?(this[d]=Date.now(),a.apply(this,[this[y]]),this[y]=f?f():void 0):(this[v]=!0,this[w]=setTimeout(()=>{this[v]=!1,this[d]=Date.now(),a.apply(this,[this[y]]),this[y]=f?f():void 0},$-Date.now()))}})}e.$ih=M}),define(te[14],ie([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cb=e.$bb=e.$ab=e.$_=e.$$=e.$0=e.$9=e.$8=e.$7=e.$6=e.$5=e.$4=e.$3=e.$2=e.$1=e.$Z=e.setUnexpectedErrorHandler=e.$X=e.$W=void 0;class S{constructor(){this.b=[],this.a=function(i){setTimeout(()=>{throw i.stack?l.isErrorNoTelemetry(i)?new l(i.message+`

`+i.stack):new Error(i.message+`

`+i.stack):i},0)}}addListener(i){return this.b.push(i),()=>{this.d(i)}}c(i){this.b.forEach(c=>{c(i)})}d(i){this.b.splice(this.b.indexOf(i),1)}setUnexpectedErrorHandler(i){this.a=i}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(i){this.a(i),this.c(i)}onUnexpectedExternalError(i){this.a(i)}}e.$W=S,e.$X=new S;function R(h){e.$X.setUnexpectedErrorHandler(h)}e.setUnexpectedErrorHandler=R;function s(h){if(!h||typeof h!="object")return!1;const i=h;return i.code==="EPIPE"&&i.syscall?.toUpperCase()==="WRITE"}e.$Z=s;function M(h){a(h)||e.$X.onUnexpectedError(h)}e.$1=M;function D(h){a(h)||e.$X.onUnexpectedExternalError(h)}e.$2=D;function P(h){if(h instanceof Error){const{name:i,message:c}=h,o=h.stacktrace||h.stack;return{$isError:!0,name:i,message:c,stack:o,noTelemetry:l.isErrorNoTelemetry(h)}}return h}e.$3=P;const f="Canceled";function a(h){return h instanceof g?!0:h instanceof Error&&h.name===f&&h.message===f}e.$4=a;class g extends Error{constructor(){super(f),this.name=this.message}}e.$5=g;function w(){const h=new Error(f);return h.name=h.message,h}e.$6=w;function y(h){return h?new Error(`Illegal argument: ${h}`):new Error("Illegal argument")}e.$7=y;function d(h){return h?new Error(`Illegal state: ${h}`):new Error("Illegal state")}e.$8=d;class v extends TypeError{constructor(i){super(i?`${i} is read-only and cannot be changed`:"Cannot change read-only property")}}e.$9=v;function b(h){return h?h.message?h.message:h.stack?h.stack.split(`
`)[0]:String(h):"Error"}e.$0=b;class $ extends Error{constructor(i){super("NotImplemented"),i&&(this.message=i)}}e.$$=$;class m extends Error{constructor(i){super("NotSupported"),i&&(this.message=i)}}e.$_=m;class u extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.$ab=u;class l extends Error{constructor(i){super(i),this.name="CodeExpectedError"}static fromError(i){if(i instanceof l)return i;const c=new l;return c.message=i.message,c.stack=i.stack,c}static isErrorNoTelemetry(i){return i.name==="CodeExpectedError"}}e.$bb=l;class E extends Error{constructor(i){super(i||"An unexpected bug occurred."),Object.setPrototypeOf(this,E.prototype)}}e.$cb=E}),define(te[23],ie([0,1,14,132]),function(Q,e,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ac=e.$_b=e.$$b=e.$0b=e.$9b=e.$8b=e.$7b=e.CompareResult=e.$6b=e.$5b=e.$4b=e.$3b=e.$2b=e.$1b=e.$Zb=e.$Yb=e.$Xb=e.$Wb=e.$Vb=e.$Ub=e.$Tb=e.$Sb=e.$Rb=e.$Qb=e.$Pb=e.$Ob=e.$Nb=e.$Mb=e.$Lb=e.$Kb=e.$Jb=e.$Ib=e.$Hb=e.$Gb=e.top=e.$Eb=e.$Db=e.$Cb=e.$Bb=e.$Ab=e.$zb=e.$yb=e.$xb=e.$wb=e.$vb=e.$ub=e.$tb=e.$sb=void 0;function s(T,W=0){return T[T.length-(1+W)]}e.$sb=s;function M(T){if(T.length===0)throw new Error("Invalid tail call");return[T.slice(0,T.length-1),T[T.length-1]]}e.$tb=M;function D(T,W,V=(ce,de)=>ce===de){if(T===W)return!0;if(!T||!W||T.length!==W.length)return!1;for(let ce=0,de=T.length;ce<de;ce++)if(!V(T[ce],W[ce]))return!1;return!0}e.$ub=D;function P(T,W){const V=T.length-1;W<V&&(T[W]=T[V]),T.pop()}e.$vb=P;function f(T,W,V){return a(T.length,ce=>V(T[ce],W))}e.$wb=f;function a(T,W){let V=0,ce=T-1;for(;V<=ce;){const de=(V+ce)/2|0,ue=W(de);if(ue<0)V=de+1;else if(ue>0)ce=de-1;else return de}return-(V+1)}e.$xb=a;function g(T,W,V){if(T=T|0,T>=W.length)throw new TypeError("invalid index");const ce=W[Math.floor(W.length*Math.random())],de=[],ue=[],fe=[];for(const ye of W){const be=V(ye,ce);be<0?de.push(ye):be>0?ue.push(ye):fe.push(ye)}return T<de.length?g(T,de,V):T<de.length+fe.length?fe[0]:g(T-(de.length+fe.length),ue,V)}e.$yb=g;function w(T,W){const V=[];let ce;for(const de of T.slice(0).sort(W))!ce||W(ce[0],de)!==0?(ce=[de],V.push(ce)):ce.push(de);return V}e.$zb=w;function*y(T,W){let V,ce;for(const de of T)ce!==void 0&&W(ce,de)?V.push(de):(V&&(yield V),V=[de]),ce=de;V&&(yield V)}e.$Ab=y;function d(T,W){for(let V=0;V<=T.length;V++)W(V===0?void 0:T[V-1],V===T.length?void 0:T[V])}e.$Bb=d;function v(T,W){for(let V=0;V<T.length;V++)W(V===0?void 0:T[V-1],T[V],V+1===T.length?void 0:T[V+1])}e.$Cb=v;function b(T,W,V){const ce=[];function de(ye,be,pe){if(be===0&&pe.length===0)return;const Ae=ce[ce.length-1];Ae&&Ae.start+Ae.deleteCount===ye?(Ae.deleteCount+=be,Ae.toInsert.push(...pe)):ce.push({start:ye,deleteCount:be,toInsert:pe})}let ue=0,fe=0;for(;;){if(ue===T.length){de(ue,0,W.slice(fe));break}if(fe===W.length){de(ue,T.length-ue,[]);break}const ye=T[ue],be=W[fe],pe=V(ye,be);pe===0?(ue+=1,fe+=1):pe<0?(de(ue,1,[]),ue+=1):pe>0&&(de(ue,0,[be]),fe+=1)}return ce}e.$Db=b;function $(T,W,V){const ce=b(T,W,V),de=[],ue=[];for(const fe of ce)de.push(...T.slice(fe.start,fe.start+fe.deleteCount)),ue.push(...fe.toInsert);return{removed:de,added:ue}}e.$Eb=$;function m(T,W,V){if(V===0)return[];const ce=T.slice(0,V).sort(W);return l(T,W,ce,V,T.length),ce}e.top=m;function u(T,W,V,ce,de){return V===0?Promise.resolve([]):new Promise((ue,fe)=>{(async()=>{const ye=T.length,be=T.slice(0,V).sort(W);for(let pe=V,Ae=Math.min(V+ce,ye);pe<ye;pe=Ae,Ae=Math.min(Ae+ce,ye)){if(pe>V&&await new Promise(Te=>setTimeout(Te)),de&&de.isCancellationRequested)throw new S.$5;l(T,W,be,pe,Ae)}return be})().then(ue,fe)})}e.$Gb=u;function l(T,W,V,ce,de){for(const ue=V.length;ce<de;ce++){const fe=T[ce];if(W(fe,V[ue-1])<0){V.pop();const ye=(0,R.$kb)(V,be=>W(fe,be)<0);V.splice(ye,0,fe)}}}function E(T){return T.filter(W=>!!W)}e.$Hb=E;function h(T){let W=0;for(let V=0;V<T.length;V++)T[V]&&(T[W]=T[V],W+=1);T.length=W}e.$Ib=h;function i(T,W,V){T.splice(V,0,T.splice(W,1)[0])}e.$Jb=i;function c(T){return!Array.isArray(T)||T.length===0}e.$Kb=c;function o(T){return Array.isArray(T)&&T.length>0}e.$Lb=o;function t(T,W=V=>V){const V=new Set;return T.filter(ce=>{const de=W(ce);return V.has(de)?!1:(V.add(de),!0)})}e.$Mb=t;function n(T){const W=new Set;return V=>{const ce=T(V);return W.has(ce)?!1:(W.add(ce),!0)}}e.$Nb=n;function r(T,W){return T.length>0?T[0]:W}e.$Ob=r;function p(T,W){return T.length>0?T[T.length-1]:W}e.$Pb=p;function A(T,W,V=(ce,de)=>ce===de){let ce=0;for(let de=0,ue=Math.min(T.length,W.length);de<ue&&V(T[de],W[de]);de++)ce++;return ce}e.$Qb=A;function C(T){return[].concat(...T)}e.$Rb=C;function k(T,W){let V=typeof W=="number"?T:0;typeof W=="number"?V=T:(V=0,W=T);const ce=[];if(V<=W)for(let de=V;de<W;de++)ce.push(de);else for(let de=V;de>W;de--)ce.push(de);return ce}e.$Sb=k;function I(T,W,V){return T.reduce((ce,de)=>(ce[W(de)]=V?V(de):de,ce),Object.create(null))}e.$Tb=I;function j(T,W){return T.push(W),()=>U(T,W)}e.$Ub=j;function U(T,W){const V=T.indexOf(W);if(V>-1)return T.splice(V,1),W}e.$Vb=U;function z(T,W,V){const ce=T.slice(0,W),de=T.slice(W);return ce.concat(V,de)}e.$Wb=z;function ne(T,W){let V;if(typeof W=="number"){let ce=W;V=()=>{const de=Math.sin(ce++)*179426549;return de-Math.floor(de)}}else V=Math.random;for(let ce=T.length-1;ce>0;ce-=1){const de=Math.floor(V()*(ce+1)),ue=T[ce];T[ce]=T[de],T[de]=ue}}e.$Xb=ne;function _(T,W){const V=T.indexOf(W);V>-1&&(T.splice(V,1),T.unshift(W))}e.$Yb=_;function ae(T,W){const V=T.indexOf(W);V>-1&&(T.splice(V,1),T.push(W))}e.$Zb=ae;function se(T,W){for(const V of W)T.push(V)}e.$1b=se;function oe(T,W){return Array.isArray(T)?T.map(W):W(T)}e.$2b=oe;function K(T){return Array.isArray(T)?T:[T]}e.$3b=K;function J(T){return T[Math.floor(Math.random()*T.length)]}e.$4b=J;function G(T,W,V){const ce=q(T,W),de=T.length,ue=V.length;T.length=de+ue;for(let fe=de-1;fe>=ce;fe--)T[fe+ue]=T[fe];for(let fe=0;fe<ue;fe++)T[fe+ce]=V[fe]}e.$5b=G;function N(T,W,V,ce){const de=q(T,W);let ue=T.splice(de,V);return ue===void 0&&(ue=[]),G(T,de,ce),ue}e.$6b=N;function q(T,W){return W<0?Math.max(W+T.length,0):Math.min(W,T.length)}var X;(function(T){function W(ue){return ue<0}T.isLessThan=W;function V(ue){return ue<=0}T.isLessThanOrEqual=V;function ce(ue){return ue>0}T.isGreaterThan=ce;function de(ue){return ue===0}T.isNeitherLessOrGreaterThan=de,T.greaterThan=1,T.lessThan=-1,T.neitherLessOrGreaterThan=0})(X||(e.CompareResult=X={}));function H(T,W){return(V,ce)=>W(T(V),T(ce))}e.$7b=H;function Y(...T){return(W,V)=>{for(const ce of T){const de=ce(W,V);if(!X.isNeitherLessOrGreaterThan(de))return de}return X.neitherLessOrGreaterThan}}e.$8b=Y;const re=(T,W)=>T-W;e.$9b=re;const F=(T,W)=>(0,e.$9b)(T?1:0,W?1:0);e.$0b=F;function O(T){return(W,V)=>-T(W,V)}e.$$b=O;class L{constructor(W){this.g=W,this.c=0,this.d=this.g.length-1}get length(){return this.d-this.c+1}takeWhile(W){let V=this.c;for(;V<this.g.length&&W(this.g[V]);)V++;const ce=V===this.c?null:this.g.slice(this.c,V);return this.c=V,ce}takeFromEndWhile(W){let V=this.d;for(;V>=0&&W(this.g[V]);)V--;const ce=V===this.d?null:this.g.slice(V+1,this.d+1);return this.d=V,ce}peek(){if(this.length!==0)return this.g[this.c]}peekLast(){if(this.length!==0)return this.g[this.d]}dequeue(){const W=this.g[this.c];return this.c++,W}removeLast(){const W=this.g[this.d];return this.d--,W}takeCount(W){const V=this.g.slice(this.c,this.c+W);return this.c+=W,V}}e.$_b=L;class B{static{this.empty=new B(W=>{})}constructor(W){this.iterate=W}forEach(W){this.iterate(V=>(W(V),!0))}toArray(){const W=[];return this.iterate(V=>(W.push(V),!0)),W}filter(W){return new B(V=>this.iterate(ce=>W(ce)?V(ce):!0))}map(W){return new B(V=>this.iterate(ce=>V(W(ce))))}some(W){let V=!1;return this.iterate(ce=>(V=W(ce),!V)),V}findFirst(W){let V;return this.iterate(ce=>W(ce)?(V=ce,!1):!0),V}findLast(W){let V;return this.iterate(ce=>(W(ce)&&(V=ce),!0)),V}findLastMaxBy(W){let V,ce=!0;return this.iterate(de=>((ce||X.isGreaterThan(W(de,V)))&&(ce=!1,V=de),!0)),V}}e.$ac=B}),define(te[135],ie([0,1,14]),function(Q,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7c=e.$6c=e.$5c=e.$4c=e.ok=void 0;function R(f,a){if(!f)throw new Error(a?`Assertion failed (${a})`:"Assertion Failed")}e.ok=R;function s(f,a="Unreachable"){throw new Error(a)}e.$4c=s;function M(f){if(!f)throw new S.$cb("Assertion Failed")}e.$5c=M;function D(f){if(!f()){debugger;f(),(0,S.$1)(new S.$cb("Assertion Failed"))}}e.$6c=D;function P(f,a){let g=0;for(;g<f.length-1;){const w=f[g],y=f[g+1];if(!a(w,y))return!1;g++}return!0}e.$7c=P}),define(te[83],ie([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$db=void 0;function S(R){const s=this;let M=!1,D;return function(){return M||(M=!0,D=R.apply(s,arguments)),D}}e.$db=S}),define(te[70],ie([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var S;(function(R){function s(h){return h&&typeof h=="object"&&typeof h[Symbol.iterator]=="function"}R.is=s;const M=Object.freeze([]);function D(){return M}R.empty=D;function*P(h){yield h}R.single=P;function f(h){return s(h)?h:P(h)}R.wrap=f;function a(h){return h||M}R.from=a;function*g(h){for(let i=h.length-1;i>=0;i--)yield h[i]}R.reverse=g;function w(h){return!h||h[Symbol.iterator]().next().done===!0}R.isEmpty=w;function y(h){return h[Symbol.iterator]().next().value}R.first=y;function d(h,i){for(const c of h)if(i(c))return!0;return!1}R.some=d;function v(h,i){for(const c of h)if(i(c))return c}R.find=v;function*b(h,i){for(const c of h)i(c)&&(yield c)}R.filter=b;function*$(h,i){let c=0;for(const o of h)yield i(o,c++)}R.map=$;function*m(...h){for(const i of h)for(const c of i)yield c}R.concat=m;function u(h,i,c){let o=c;for(const t of h)o=i(o,t);return o}R.reduce=u;function*l(h,i,c=h.length){for(i<0&&(i+=h.length),c<0?c+=h.length:c>h.length&&(c=h.length);i<c;i++)yield h[i]}R.slice=l;function E(h,i=Number.POSITIVE_INFINITY){const c=[];if(i===0)return[c,h];const o=h[Symbol.iterator]();for(let t=0;t<i;t++){const n=o.next();if(n.done)return[c,R.empty()];c.push(n.value)}return[c,{[Symbol.iterator](){return o}}]}R.consume=E})(S||(e.Iterable=S={}))}),define(te[44],ie([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3m=e.$2m=e.$1m=e.$Zm=e.$Ym=e.$Xm=e.$Wm=e.$Vm=e.$Um=e.$Tm=e.$Sm=e.$Rm=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var S;(function(i){i[i.None=0]="None",i[i.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=2]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",i[i.InvalidUnicode=4]="InvalidUnicode",i[i.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",i[i.InvalidCharacter=6]="InvalidCharacter"})(S||(e.ScanError=S={}));var R;(function(i){i[i.OpenBraceToken=1]="OpenBraceToken",i[i.CloseBraceToken=2]="CloseBraceToken",i[i.OpenBracketToken=3]="OpenBracketToken",i[i.CloseBracketToken=4]="CloseBracketToken",i[i.CommaToken=5]="CommaToken",i[i.ColonToken=6]="ColonToken",i[i.NullKeyword=7]="NullKeyword",i[i.TrueKeyword=8]="TrueKeyword",i[i.FalseKeyword=9]="FalseKeyword",i[i.StringLiteral=10]="StringLiteral",i[i.NumericLiteral=11]="NumericLiteral",i[i.LineCommentTrivia=12]="LineCommentTrivia",i[i.BlockCommentTrivia=13]="BlockCommentTrivia",i[i.LineBreakTrivia=14]="LineBreakTrivia",i[i.Trivia=15]="Trivia",i[i.Unknown=16]="Unknown",i[i.EOF=17]="EOF"})(R||(e.SyntaxKind=R={}));var s;(function(i){i[i.InvalidSymbol=1]="InvalidSymbol",i[i.InvalidNumberFormat=2]="InvalidNumberFormat",i[i.PropertyNameExpected=3]="PropertyNameExpected",i[i.ValueExpected=4]="ValueExpected",i[i.ColonExpected=5]="ColonExpected",i[i.CommaExpected=6]="CommaExpected",i[i.CloseBraceExpected=7]="CloseBraceExpected",i[i.CloseBracketExpected=8]="CloseBracketExpected",i[i.EndOfFileExpected=9]="EndOfFileExpected",i[i.InvalidCommentToken=10]="InvalidCommentToken",i[i.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=12]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",i[i.InvalidUnicode=14]="InvalidUnicode",i[i.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",i[i.InvalidCharacter=16]="InvalidCharacter"})(s||(e.ParseErrorCode=s={}));var M;(function(i){i.DEFAULT={allowTrailingComma:!0}})(M||(e.ParseOptions=M={}));function D(i,c=!1){let o=0;const t=i.length;let n="",r=0,p=16,A=0;function C(_){let ae=0,se=0;for(;ae<_;){const oe=i.charCodeAt(o);if(oe>=48&&oe<=57)se=se*16+oe-48;else if(oe>=65&&oe<=70)se=se*16+oe-65+10;else if(oe>=97&&oe<=102)se=se*16+oe-97+10;else break;o++,ae++}return ae<_&&(se=-1),se}function k(_){o=_,n="",r=0,p=16,A=0}function I(){const _=o;if(i.charCodeAt(o)===48)o++;else for(o++;o<i.length&&a(i.charCodeAt(o));)o++;if(o<i.length&&i.charCodeAt(o)===46)if(o++,o<i.length&&a(i.charCodeAt(o)))for(o++;o<i.length&&a(i.charCodeAt(o));)o++;else return A=3,i.substring(_,o);let ae=o;if(o<i.length&&(i.charCodeAt(o)===69||i.charCodeAt(o)===101))if(o++,(o<i.length&&i.charCodeAt(o)===43||i.charCodeAt(o)===45)&&o++,o<i.length&&a(i.charCodeAt(o))){for(o++;o<i.length&&a(i.charCodeAt(o));)o++;ae=o}else A=3;return i.substring(_,ae)}function j(){let _="",ae=o;for(;;){if(o>=t){_+=i.substring(ae,o),A=2;break}const se=i.charCodeAt(o);if(se===34){_+=i.substring(ae,o),o++;break}if(se===92){if(_+=i.substring(ae,o),o++,o>=t){A=2;break}switch(i.charCodeAt(o++)){case 34:_+='"';break;case 92:_+="\\";break;case 47:_+="/";break;case 98:_+="\b";break;case 102:_+="\f";break;case 110:_+=`
`;break;case 114:_+="\r";break;case 116:_+="	";break;case 117:{const K=C(4);K>=0?_+=String.fromCharCode(K):A=4;break}default:A=5}ae=o;continue}if(se>=0&&se<=31)if(f(se)){_+=i.substring(ae,o),A=2;break}else A=6;o++}return _}function U(){if(n="",A=0,r=o,o>=t)return r=t,p=17;let _=i.charCodeAt(o);if(P(_)){do o++,n+=String.fromCharCode(_),_=i.charCodeAt(o);while(P(_));return p=15}if(f(_))return o++,n+=String.fromCharCode(_),_===13&&i.charCodeAt(o)===10&&(o++,n+=`
`),p=14;switch(_){case 123:return o++,p=1;case 125:return o++,p=2;case 91:return o++,p=3;case 93:return o++,p=4;case 58:return o++,p=6;case 44:return o++,p=5;case 34:return o++,n=j(),p=10;case 47:{const ae=o-1;if(i.charCodeAt(o+1)===47){for(o+=2;o<t&&!f(i.charCodeAt(o));)o++;return n=i.substring(ae,o),p=12}if(i.charCodeAt(o+1)===42){o+=2;const se=t-1;let oe=!1;for(;o<se;){if(i.charCodeAt(o)===42&&i.charCodeAt(o+1)===47){o+=2,oe=!0;break}o++}return oe||(o++,A=1),n=i.substring(ae,o),p=13}return n+=String.fromCharCode(_),o++,p=16}case 45:if(n+=String.fromCharCode(_),o++,o===t||!a(i.charCodeAt(o)))return p=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return n+=I(),p=11;default:for(;o<t&&z(_);)o++,_=i.charCodeAt(o);if(r!==o){switch(n=i.substring(r,o),n){case"true":return p=8;case"false":return p=9;case"null":return p=7}return p=16}return n+=String.fromCharCode(_),o++,p=16}}function z(_){if(P(_)||f(_))return!1;switch(_){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function ne(){let _;do _=U();while(_>=12&&_<=15);return _}return{setPosition:k,getPosition:()=>o,scan:c?ne:U,getToken:()=>p,getTokenValue:()=>n,getTokenOffset:()=>r,getTokenLength:()=>o-r,getTokenError:()=>A}}e.$Rm=D;function P(i){return i===32||i===9||i===11||i===12||i===160||i===5760||i>=8192&&i<=8203||i===8239||i===8287||i===12288||i===65279}function f(i){return i===10||i===13||i===8232||i===8233}function a(i){return i>=48&&i<=57}var g;(function(i){i[i.nullCharacter=0]="nullCharacter",i[i.maxAsciiCharacter=127]="maxAsciiCharacter",i[i.lineFeed=10]="lineFeed",i[i.carriageReturn=13]="carriageReturn",i[i.lineSeparator=8232]="lineSeparator",i[i.paragraphSeparator=8233]="paragraphSeparator",i[i.nextLine=133]="nextLine",i[i.space=32]="space",i[i.nonBreakingSpace=160]="nonBreakingSpace",i[i.enQuad=8192]="enQuad",i[i.emQuad=8193]="emQuad",i[i.enSpace=8194]="enSpace",i[i.emSpace=8195]="emSpace",i[i.threePerEmSpace=8196]="threePerEmSpace",i[i.fourPerEmSpace=8197]="fourPerEmSpace",i[i.sixPerEmSpace=8198]="sixPerEmSpace",i[i.figureSpace=8199]="figureSpace",i[i.punctuationSpace=8200]="punctuationSpace",i[i.thinSpace=8201]="thinSpace",i[i.hairSpace=8202]="hairSpace",i[i.zeroWidthSpace=8203]="zeroWidthSpace",i[i.narrowNoBreakSpace=8239]="narrowNoBreakSpace",i[i.ideographicSpace=12288]="ideographicSpace",i[i.mathematicalSpace=8287]="mathematicalSpace",i[i.ogham=5760]="ogham",i[i._=95]="_",i[i.$=36]="$",i[i._0=48]="_0",i[i._1=49]="_1",i[i._2=50]="_2",i[i._3=51]="_3",i[i._4=52]="_4",i[i._5=53]="_5",i[i._6=54]="_6",i[i._7=55]="_7",i[i._8=56]="_8",i[i._9=57]="_9",i[i.a=97]="a",i[i.b=98]="b",i[i.c=99]="c",i[i.d=100]="d",i[i.e=101]="e",i[i.f=102]="f",i[i.g=103]="g",i[i.h=104]="h",i[i.i=105]="i",i[i.j=106]="j",i[i.k=107]="k",i[i.l=108]="l",i[i.m=109]="m",i[i.n=110]="n",i[i.o=111]="o",i[i.p=112]="p",i[i.q=113]="q",i[i.r=114]="r",i[i.s=115]="s",i[i.t=116]="t",i[i.u=117]="u",i[i.v=118]="v",i[i.w=119]="w",i[i.x=120]="x",i[i.y=121]="y",i[i.z=122]="z",i[i.A=65]="A",i[i.B=66]="B",i[i.C=67]="C",i[i.D=68]="D",i[i.E=69]="E",i[i.F=70]="F",i[i.G=71]="G",i[i.H=72]="H",i[i.I=73]="I",i[i.J=74]="J",i[i.K=75]="K",i[i.L=76]="L",i[i.M=77]="M",i[i.N=78]="N",i[i.O=79]="O",i[i.P=80]="P",i[i.Q=81]="Q",i[i.R=82]="R",i[i.S=83]="S",i[i.T=84]="T",i[i.U=85]="U",i[i.V=86]="V",i[i.W=87]="W",i[i.X=88]="X",i[i.Y=89]="Y",i[i.Z=90]="Z",i[i.ampersand=38]="ampersand",i[i.asterisk=42]="asterisk",i[i.at=64]="at",i[i.backslash=92]="backslash",i[i.bar=124]="bar",i[i.caret=94]="caret",i[i.closeBrace=125]="closeBrace",i[i.closeBracket=93]="closeBracket",i[i.closeParen=41]="closeParen",i[i.colon=58]="colon",i[i.comma=44]="comma",i[i.dot=46]="dot",i[i.doubleQuote=34]="doubleQuote",i[i.equals=61]="equals",i[i.exclamation=33]="exclamation",i[i.greaterThan=62]="greaterThan",i[i.lessThan=60]="lessThan",i[i.minus=45]="minus",i[i.openBrace=123]="openBrace",i[i.openBracket=91]="openBracket",i[i.openParen=40]="openParen",i[i.percent=37]="percent",i[i.plus=43]="plus",i[i.question=63]="question",i[i.semicolon=59]="semicolon",i[i.singleQuote=39]="singleQuote",i[i.slash=47]="slash",i[i.tilde=126]="tilde",i[i.backspace=8]="backspace",i[i.formFeed=12]="formFeed",i[i.byteOrderMark=65279]="byteOrderMark",i[i.tab=9]="tab",i[i.verticalTab=11]="verticalTab"})(g||(g={}));function w(i,c){const o=[],t=new Object;let n;const r={value:{},offset:0,length:0,type:"object",parent:void 0};let p=!1;function A(C,k,I,j){r.value=C,r.offset=k,r.length=I,r.type=j,r.colonOffset=void 0,n=r}try{l(i,{onObjectBegin:(C,k)=>{if(c<=C)throw t;n=void 0,p=c>C,o.push("")},onObjectProperty:(C,k,I)=>{if(c<k||(A(C,k,I,"property"),o[o.length-1]=C,c<=k+I))throw t},onObjectEnd:(C,k)=>{if(c<=C)throw t;n=void 0,o.pop()},onArrayBegin:(C,k)=>{if(c<=C)throw t;n=void 0,o.push(0)},onArrayEnd:(C,k)=>{if(c<=C)throw t;n=void 0,o.pop()},onLiteralValue:(C,k,I)=>{if(c<k||(A(C,k,I,h(C)),c<=k+I))throw t},onSeparator:(C,k,I)=>{if(c<=k)throw t;if(C===":"&&n&&n.type==="property")n.colonOffset=k,p=!1,n=void 0;else if(C===","){const j=o[o.length-1];typeof j=="number"?o[o.length-1]=j+1:(p=!0,o[o.length-1]=""),n=void 0}}})}catch(C){if(C!==t)throw C}return{path:o,previousNode:n,isAtPropertyKey:p,matches:C=>{let k=0;for(let I=0;k<C.length&&I<o.length;I++)if(C[k]===o[I]||C[k]==="*")k++;else if(C[k]!=="**")return!1;return k===C.length}}}e.$Sm=w;function y(i,c=[],o=M.DEFAULT){let t=null,n=[];const r=[];function p(C){Array.isArray(n)?n.push(C):t!==null&&(n[t]=C)}return l(i,{onObjectBegin:()=>{const C={};p(C),r.push(n),n=C,t=null},onObjectProperty:C=>{t=C},onObjectEnd:()=>{n=r.pop()},onArrayBegin:()=>{const C=[];p(C),r.push(n),n=C,t=null},onArrayEnd:()=>{n=r.pop()},onLiteralValue:p,onError:(C,k,I)=>{c.push({error:C,offset:k,length:I})}},o),n[0]}e.$Tm=y;function d(i,c=[],o=M.DEFAULT){let t={type:"array",offset:-1,length:-1,children:[],parent:void 0};function n(C){t.type==="property"&&(t.length=C-t.offset,t=t.parent)}function r(C){return t.children.push(C),C}l(i,{onObjectBegin:C=>{t=r({type:"object",offset:C,length:-1,parent:t,children:[]})},onObjectProperty:(C,k,I)=>{t=r({type:"property",offset:k,length:-1,parent:t,children:[]}),t.children.push({type:"string",value:C,offset:k,length:I,parent:t})},onObjectEnd:(C,k)=>{t.length=C+k-t.offset,t=t.parent,n(C+k)},onArrayBegin:(C,k)=>{t=r({type:"array",offset:C,length:-1,parent:t,children:[]})},onArrayEnd:(C,k)=>{t.length=C+k-t.offset,t=t.parent,n(C+k)},onLiteralValue:(C,k,I)=>{r({type:h(C),offset:k,length:I,parent:t,value:C}),n(k+I)},onSeparator:(C,k,I)=>{t.type==="property"&&(C===":"?t.colonOffset=k:C===","&&n(k))},onError:(C,k,I)=>{c.push({error:C,offset:k,length:I})}},o);const A=t.children[0];return A&&delete A.parent,A}e.$Um=d;function v(i,c){if(!i)return;let o=i;for(const t of c)if(typeof t=="string"){if(o.type!=="object"||!Array.isArray(o.children))return;let n=!1;for(const r of o.children)if(Array.isArray(r.children)&&r.children[0].value===t){o=r.children[1],n=!0;break}if(!n)return}else{const n=t;if(o.type!=="array"||n<0||!Array.isArray(o.children)||n>=o.children.length)return;o=o.children[n]}return o}e.$Vm=v;function b(i){if(!i.parent||!i.parent.children)return[];const c=b(i.parent);if(i.parent.type==="property"){const o=i.parent.children[0].value;c.push(o)}else if(i.parent.type==="array"){const o=i.parent.children.indexOf(i);o!==-1&&c.push(o)}return c}e.$Wm=b;function $(i){switch(i.type){case"array":return i.children.map($);case"object":{const c=Object.create(null);for(const o of i.children){const t=o.children[1];t&&(c[o.children[0].value]=$(t))}return c}case"null":case"string":case"number":case"boolean":return i.value;default:return}}e.$Xm=$;function m(i,c,o=!1){return c>=i.offset&&c<i.offset+i.length||o&&c===i.offset+i.length}e.$Ym=m;function u(i,c,o=!1){if(m(i,c,o)){const t=i.children;if(Array.isArray(t))for(let n=0;n<t.length&&t[n].offset<=c;n++){const r=u(t[n],c,o);if(r)return r}return i}}e.$Zm=u;function l(i,c,o=M.DEFAULT){const t=D(i,!1);function n(H){return H?()=>H(t.getTokenOffset(),t.getTokenLength()):()=>!0}function r(H){return H?Y=>H(Y,t.getTokenOffset(),t.getTokenLength()):()=>!0}const p=n(c.onObjectBegin),A=r(c.onObjectProperty),C=n(c.onObjectEnd),k=n(c.onArrayBegin),I=n(c.onArrayEnd),j=r(c.onLiteralValue),U=r(c.onSeparator),z=n(c.onComment),ne=r(c.onError),_=o&&o.disallowComments,ae=o&&o.allowTrailingComma;function se(){for(;;){const H=t.scan();switch(t.getTokenError()){case 4:oe(14);break;case 5:oe(15);break;case 3:oe(13);break;case 1:_||oe(11);break;case 2:oe(12);break;case 6:oe(16);break}switch(H){case 12:case 13:_?oe(10):z();break;case 16:oe(1);break;case 15:case 14:break;default:return H}}}function oe(H,Y=[],re=[]){if(ne(H),Y.length+re.length>0){let F=t.getToken();for(;F!==17;){if(Y.indexOf(F)!==-1){se();break}else if(re.indexOf(F)!==-1)break;F=se()}}}function K(H){const Y=t.getTokenValue();return H?j(Y):A(Y),se(),!0}function J(){switch(t.getToken()){case 11:{let H=0;try{H=JSON.parse(t.getTokenValue()),typeof H!="number"&&(oe(2),H=0)}catch{oe(2)}j(H);break}case 7:j(null);break;case 8:j(!0);break;case 9:j(!1);break;default:return!1}return se(),!0}function G(){return t.getToken()!==10?(oe(3,[],[2,5]),!1):(K(!1),t.getToken()===6?(U(":"),se(),X()||oe(4,[],[2,5])):oe(5,[],[2,5]),!0)}function N(){p(),se();let H=!1;for(;t.getToken()!==2&&t.getToken()!==17;){if(t.getToken()===5){if(H||oe(4,[],[]),U(","),se(),t.getToken()===2&&ae)break}else H&&oe(6,[],[]);G()||oe(4,[],[2,5]),H=!0}return C(),t.getToken()!==2?oe(7,[2],[]):se(),!0}function q(){k(),se();let H=!1;for(;t.getToken()!==4&&t.getToken()!==17;){if(t.getToken()===5){if(H||oe(4,[],[]),U(","),se(),t.getToken()===4&&ae)break}else H&&oe(6,[],[]);X()||oe(4,[],[4,5]),H=!0}return I(),t.getToken()!==4?oe(8,[4],[]):se(),!0}function X(){switch(t.getToken()){case 3:return q();case 1:return N();case 10:return K(!0);default:return J()}}return se(),t.getToken()===17?o.allowEmptyContent?!0:(oe(4,[],[]),!1):X()?(t.getToken()!==17&&oe(9,[],[]),!0):(oe(4,[],[]),!1)}e.$1m=l;function E(i,c){const o=D(i),t=[];let n,r=0,p;do switch(p=o.getPosition(),n=o.scan(),n){case 12:case 13:case 17:r!==p&&t.push(i.substring(r,p)),c!==void 0&&t.push(o.getTokenValue().replace(/[^\r\n]/g,c)),r=o.getPosition();break}while(n!==17);return t.join("")}e.$2m=E;function h(i){switch(typeof i){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(i){if(Array.isArray(i))return"array"}else return"null";return"object"}default:return"null"}}e.$3m=h}),define(te[136],ie([0,1,44]),function(Q,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$WS=e.$VS=e.$US=e.$TS=void 0;function R(a,g,w){let y,d,v,b,$;if(g){for(b=g.offset,$=b+g.length,v=b;v>0&&!f(a,v-1);)v--;let p=$;for(;p<a.length&&!f(a,p);)p++;d=a.substring(v,p),y=D(d,w)}else d=a,y=0,v=0,b=0,$=a.length;const m=P(w,a);let u=!1,l=0,E;w.insertSpaces?E=M(" ",w.tabSize||4):E="	";const h=(0,S.$Rm)(d,!1);let i=!1;function c(){return m+M(E,y+l)}function o(){let p=h.scan();for(u=!1;p===15||p===14;)u=u||p===14,p=h.scan();return i=p===16||h.getTokenError()!==0,p}const t=[];function n(p,A,C){!i&&A<$&&C>b&&a.substring(A,C)!==p&&t.push({offset:A,length:C-A,content:p})}let r=o();if(r!==17){const p=h.getTokenOffset()+v,A=M(E,y);n(A,v,p)}for(;r!==17;){let p=h.getTokenOffset()+h.getTokenLength()+v,A=o(),C="";for(;!u&&(A===12||A===13);){const I=h.getTokenOffset()+v;n(" ",p,I),p=h.getTokenOffset()+h.getTokenLength()+v,C=A===12?c():"",A=o()}if(A===2)r!==1&&(l--,C=c());else if(A===4)r!==3&&(l--,C=c());else{switch(r){case 3:case 1:l++,C=c();break;case 5:case 12:C=c();break;case 13:u?C=c():C=" ";break;case 6:C=" ";break;case 10:if(A===6){C="";break}case 7:case 8:case 9:case 11:case 2:case 4:A===12||A===13?C=" ":A!==5&&A!==17&&(i=!0);break;case 16:i=!0;break}u&&(A===12||A===13)&&(C=c())}const k=h.getTokenOffset()+v;n(C,p,k),r=A}return t}e.$TS=R;function s(a,g){const w=JSON.stringify(a,void 0,g.insertSpaces?g.tabSize||4:"	");return g.eol!==void 0?w.replace(/\r\n|\r|\n/g,g.eol):w}e.$US=s;function M(a,g){let w="";for(let y=0;y<g;y++)w+=a;return w}function D(a,g){let w=0,y=0;const d=g.tabSize||4;for(;w<a.length;){const v=a.charAt(w);if(v===" ")y++;else if(v==="	")y+=d;else break;w++}return Math.floor(y/d)}function P(a,g){for(let w=0;w<g.length;w++){const y=g.charAt(w);if(y==="\r")return w+1<g.length&&g.charAt(w+1)===`
`?`\r
`:"\r";if(y===`
`)return`
`}return a&&a.eol||`
`}e.$VS=P;function f(a,g){return`\r
`.indexOf(a.charAt(g))!==-1}e.$WS=f}),define(te[137],ie([0,1,44,136]),function(Q,e,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2S=e.$1S=e.$ZS=e.$YS=e.$XS=void 0;function s(a,g,w){return M(a,g,void 0,w)}e.$XS=s;function M(a,g,w,y,d){const v=g.slice(),b=[],$=(0,S.$Um)(a,b);let m,u;for(;v.length>0&&(u=v.pop(),m=(0,S.$Vm)($,v),m===void 0&&w!==void 0);)typeof u=="string"?w={[u]:w}:w=[w];if(m)if(m.type==="object"&&typeof u=="string"&&Array.isArray(m.children)){const l=(0,S.$Vm)(m,[u]);if(l!==void 0)if(w===void 0){if(!l.parent)throw new Error("Malformed AST");const E=m.children.indexOf(l.parent);let h,i=l.parent.offset+l.parent.length;if(E>0){const c=m.children[E-1];h=c.offset+c.length}else h=m.offset+1,m.children.length>1&&(i=m.children[1].offset);return D(a,{offset:h,length:i-h,content:""},y)}else return D(a,{offset:l.offset,length:l.length,content:JSON.stringify(w)},y);else{if(w===void 0)return[];const E=`${JSON.stringify(u)}: ${JSON.stringify(w)}`,h=d?d(m.children.map(c=>c.children[0].value)):m.children.length;let i;if(h>0){const c=m.children[h-1];i={offset:c.offset+c.length,length:0,content:","+E}}else m.children.length===0?i={offset:m.offset+1,length:0,content:E}:i={offset:m.offset+1,length:0,content:E+","};return D(a,i,y)}}else if(m.type==="array"&&typeof u=="number"&&Array.isArray(m.children))if(w!==void 0){const l=`${JSON.stringify(w)}`;let E;if(m.children.length===0||u===0)E={offset:m.offset+1,length:0,content:m.children.length===0?l:l+","};else{const h=u===-1||u>m.children.length?m.children.length:u,i=m.children[h-1];E={offset:i.offset+i.length,length:0,content:","+l}}return D(a,E,y)}else{const l=u,E=m.children[l];let h;if(m.children.length===1)h={offset:m.offset+1,length:m.length-2,content:""};else if(m.children.length-1===l){const i=m.children[l-1],c=i.offset+i.length,o=m.offset+m.length;h={offset:c,length:o-2-c,content:""}}else h={offset:E.offset,length:m.children[l+1].offset-E.offset,content:""};return D(a,h,y)}else throw new Error(`Can not add ${typeof u!="number"?"index":"property"} to parent of type ${m.type}`);else{if(w===void 0)throw new Error("Can not delete in empty document");return D(a,{offset:$?$.offset:0,length:$?$.length:0,content:JSON.stringify(w)},y)}}e.$YS=M;function D(a,g,w){let y=P(a,g),d=g.offset,v=g.offset+g.content.length;if(g.length===0||g.content.length===0){for(;d>0&&!(0,R.$WS)(y,d-1);)d--;for(;v<y.length&&!(0,R.$WS)(y,v);)v++}const b=(0,R.$TS)(y,{offset:d,length:v-d},w);for(let m=b.length-1;m>=0;m--){const u=b[m];y=P(y,u),d=Math.min(d,u.offset),v=Math.max(v,u.offset+u.length),v+=u.content.length-u.length}const $=a.length-(y.length-v)-d;return[{offset:d,length:$,content:y.substring(d,v)}]}e.$ZS=D;function P(a,g){return a.substring(0,g.offset)+g.content+a.substring(g.offset+g.length)}e.$1S=P;function f(a,g){const w=g.slice(0).sort((d,v)=>{const b=d.offset-v.offset;return b===0?d.length-v.length:b});let y=a.length;for(let d=w.length-1;d>=0;d--){const v=w[d];if(v.offset+v.length<=y)a=P(a,v);else throw new Error("Overlapping edit");y=v.offset}return a}e.$2S=f}),define(te[71],ie([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$V=void 0;class S{constructor(s){this.d=s,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(s){this.c=s}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}e.$V=S}),define(te[101],ie([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2c=void 0;class S{static{this.Undefined=new S(void 0)}constructor(M){this.element=M,this.next=S.Undefined,this.prev=S.Undefined}}class R{constructor(){this.a=S.Undefined,this.b=S.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===S.Undefined}clear(){let M=this.a;for(;M!==S.Undefined;){const D=M.next;M.prev=S.Undefined,M.next=S.Undefined,M=D}this.a=S.Undefined,this.b=S.Undefined,this.c=0}unshift(M){return this.d(M,!1)}push(M){return this.d(M,!0)}d(M,D){const P=new S(M);if(this.a===S.Undefined)this.a=P,this.b=P;else if(D){const a=this.b;this.b=P,P.prev=a,a.next=P}else{const a=this.a;this.a=P,P.next=a,a.prev=P}this.c+=1;let f=!1;return()=>{f||(f=!0,this.e(P))}}shift(){if(this.a!==S.Undefined){const M=this.a.element;return this.e(this.a),M}}pop(){if(this.b!==S.Undefined){const M=this.b.element;return this.e(this.b),M}}e(M){if(M.prev!==S.Undefined&&M.next!==S.Undefined){const D=M.prev;D.next=M.next,M.next.prev=D}else M.prev===S.Undefined&&M.next===S.Undefined?(this.a=S.Undefined,this.b=S.Undefined):M.next===S.Undefined?(this.b=this.b.prev,this.b.next=S.Undefined):M.prev===S.Undefined&&(this.a=this.a.next,this.a.prev=S.Undefined);this.c-=1}*[Symbol.iterator](){let M=this.a;for(;M!==S.Undefined;)yield M.element,M=M.next}}e.$2c=R}),define(te[31],ie([0,1]),function(Q,e){"use strict";var S,R,s;Object.defineProperty(e,"__esModule",{value:!0}),e.$Gc=e.$Fc=e.$Ec=e.$Dc=e.$Cc=e.Touch=e.$Bc=e.$Ac=e.$zc=e.$yc=e.$xc=void 0;function M(u,l,E){let h=u.get(l);return h===void 0&&(h=E,u.set(l,h)),h}e.$xc=M;function D(u){const l=[];return u.forEach((E,h)=>{l.push(`${h} => ${E}`)}),`Map(${u.size}) {${l.join(", ")}}`}e.$yc=D;function P(u){const l=[];return u.forEach(E=>{l.push(E)}),`Set(${u.size}) {${l.join(", ")}}`}e.$zc=P;class f{constructor(l,E){this.uri=l,this.value=E}}function a(u){return Array.isArray(u)}class g{static{this.a=l=>l.toString()}constructor(l,E){if(this[S]="ResourceMap",l instanceof g)this.b=new Map(l.b),this.c=E??g.a;else if(a(l)){this.b=new Map,this.c=E??g.a;for(const[h,i]of l)this.set(h,i)}else this.b=new Map,this.c=l??g.a}set(l,E){return this.b.set(this.c(l),new f(l,E)),this}get(l){return this.b.get(this.c(l))?.value}has(l){return this.b.has(this.c(l))}get size(){return this.b.size}clear(){this.b.clear()}delete(l){return this.b.delete(this.c(l))}forEach(l,E){typeof E<"u"&&(l=l.bind(E));for(const[h,i]of this.b)l(i.value,i.uri,this)}*values(){for(const l of this.b.values())yield l.value}*keys(){for(const l of this.b.values())yield l.uri}*entries(){for(const l of this.b.values())yield[l.uri,l.value]}*[(S=Symbol.toStringTag,Symbol.iterator)](){for(const[,l]of this.b)yield[l.uri,l.value]}}e.$Ac=g;class w{constructor(l,E){this[R]="ResourceSet",!l||typeof l=="function"?this.a=new g(l):(this.a=new g(E),l.forEach(this.add,this))}get size(){return this.a.size}add(l){return this.a.set(l,l),this}clear(){this.a.clear()}delete(l){return this.a.delete(l)}forEach(l,E){this.a.forEach((h,i)=>l.call(E,i,i,this))}has(l){return this.a.has(l)}entries(){return this.a.entries()}keys(){return this.a.keys()}values(){return this.a.keys()}[(R=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.$Bc=w;var y;(function(u){u[u.None=0]="None",u[u.AsOld=1]="AsOld",u[u.AsNew=2]="AsNew"})(y||(e.Touch=y={}));class d{constructor(){this[s]="LinkedMap",this.a=new Map,this.b=void 0,this.c=void 0,this.d=0,this.e=0}clear(){this.a.clear(),this.b=void 0,this.c=void 0,this.d=0,this.e++}isEmpty(){return!this.b&&!this.c}get size(){return this.d}get first(){return this.b?.value}get last(){return this.c?.value}has(l){return this.a.has(l)}get(l,E=0){const h=this.a.get(l);if(h)return E!==0&&this.j(h,E),h.value}set(l,E,h=0){let i=this.a.get(l);if(i)i.value=E,h!==0&&this.j(i,h);else{switch(i={key:l,value:E,next:void 0,previous:void 0},h){case 0:this.h(i);break;case 1:this.g(i);break;case 2:this.h(i);break;default:this.h(i);break}this.a.set(l,i),this.d++}return this}delete(l){return!!this.remove(l)}remove(l){const E=this.a.get(l);if(E)return this.a.delete(l),this.i(E),this.d--,E.value}shift(){if(!this.b&&!this.c)return;if(!this.b||!this.c)throw new Error("Invalid list");const l=this.b;return this.a.delete(l.key),this.i(l),this.d--,l.value}forEach(l,E){const h=this.e;let i=this.b;for(;i;){if(E?l.bind(E)(i.value,i.key,this):l(i.value,i.key,this),this.e!==h)throw new Error("LinkedMap got modified during iteration.");i=i.next}}keys(){const l=this,E=this.e;let h=this.b;const i={[Symbol.iterator](){return i},next(){if(l.e!==E)throw new Error("LinkedMap got modified during iteration.");if(h){const c={value:h.key,done:!1};return h=h.next,c}else return{value:void 0,done:!0}}};return i}values(){const l=this,E=this.e;let h=this.b;const i={[Symbol.iterator](){return i},next(){if(l.e!==E)throw new Error("LinkedMap got modified during iteration.");if(h){const c={value:h.value,done:!1};return h=h.next,c}else return{value:void 0,done:!0}}};return i}entries(){const l=this,E=this.e;let h=this.b;const i={[Symbol.iterator](){return i},next(){if(l.e!==E)throw new Error("LinkedMap got modified during iteration.");if(h){const c={value:[h.key,h.value],done:!1};return h=h.next,c}else return{value:void 0,done:!0}}};return i}[(s=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}f(l){if(l>=this.size)return;if(l===0){this.clear();return}let E=this.b,h=this.size;for(;E&&h>l;)this.a.delete(E.key),E=E.next,h--;this.b=E,this.d=h,E&&(E.previous=void 0),this.e++}g(l){if(!this.b&&!this.c)this.c=l;else if(this.b)l.next=this.b,this.b.previous=l;else throw new Error("Invalid list");this.b=l,this.e++}h(l){if(!this.b&&!this.c)this.b=l;else if(this.c)l.previous=this.c,this.c.next=l;else throw new Error("Invalid list");this.c=l,this.e++}i(l){if(l===this.b&&l===this.c)this.b=void 0,this.c=void 0;else if(l===this.b){if(!l.next)throw new Error("Invalid list");l.next.previous=void 0,this.b=l.next}else if(l===this.c){if(!l.previous)throw new Error("Invalid list");l.previous.next=void 0,this.c=l.previous}else{const E=l.next,h=l.previous;if(!E||!h)throw new Error("Invalid list");E.previous=h,h.next=E}l.next=void 0,l.previous=void 0,this.e++}j(l,E){if(!this.b||!this.c)throw new Error("Invalid list");if(!(E!==1&&E!==2)){if(E===1){if(l===this.b)return;const h=l.next,i=l.previous;l===this.c?(i.next=void 0,this.c=i):(h.previous=i,i.next=h),l.previous=void 0,l.next=this.b,this.b.previous=l,this.b=l,this.e++}else if(E===2){if(l===this.c)return;const h=l.next,i=l.previous;l===this.b?(h.previous=void 0,this.b=h):(h.previous=i,i.next=h),l.next=void 0,l.previous=this.c,this.c.next=l,this.c=l,this.e++}}}toJSON(){const l=[];return this.forEach((E,h)=>{l.push([h,E])}),l}fromJSON(l){this.clear();for(const[E,h]of l)this.set(E,h)}}e.$Cc=d;class v extends d{constructor(l,E=1){super(),this.k=l,this.l=Math.min(Math.max(0,E),1)}get limit(){return this.k}set limit(l){this.k=l,this.m()}get ratio(){return this.l}set ratio(l){this.l=Math.min(Math.max(0,l),1),this.m()}get(l,E=2){return super.get(l,E)}peek(l){return super.get(l,0)}set(l,E){return super.set(l,E,2),this.m(),this}m(){this.size>this.k&&this.f(Math.round(this.k*this.l))}}e.$Dc=v;class b{constructor(){this.a=new Map}add(l){return this.a.set(l,(this.a.get(l)||0)+1),this}delete(l){let E=this.a.get(l)||0;return E===0?!1:(E--,E===0?this.a.delete(l):this.a.set(l,E),!0)}has(l){return this.a.has(l)}}e.$Ec=b;class ${constructor(l){if(this.a=new Map,this.b=new Map,l)for(const[E,h]of l)this.set(E,h)}clear(){this.a.clear(),this.b.clear()}set(l,E){this.a.set(l,E),this.b.set(E,l)}get(l){return this.a.get(l)}getKey(l){return this.b.get(l)}delete(l){const E=this.a.get(l);return E===void 0?!1:(this.a.delete(l),this.b.delete(E),!0)}forEach(l,E){this.a.forEach((h,i)=>{l.call(E,h,i,this)})}keys(){return this.a.keys()}values(){return this.a.values()}}e.$Fc=$;class m{constructor(){this.a=new Map}add(l,E){let h=this.a.get(l);h||(h=new Set,this.a.set(l,h)),h.add(E)}delete(l,E){const h=this.a.get(l);h&&(h.delete(E),h.size===0&&this.a.delete(l))}forEach(l,E){const h=this.a.get(l);h&&h.forEach(E)}get(l){const E=this.a.get(l);return E||new Set}}e.$Gc=m}),define(te[2],ie([0,1,23,133,31,83,70]),function(Q,e,S,R,s,M,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1c=e.$Zc=e.$Yc=e.$Xc=e.$Wc=e.$Vc=e.$Uc=e.$Tc=e.$Sc=e.$Rc=e.$Qc=e.$Pc=e.$Oc=e.$Nc=e.$Mc=e.$Lc=e.$Kc=e.$Jc=e.$Ic=e.$Hc=void 0;const P=!1;let f=null;class a{constructor(){this.b=new Map}static{this.a=0}c(I){let j=this.b.get(I);return j||(j={parent:null,source:null,isSingleton:!1,value:I,idx:a.a++},this.b.set(I,j)),j}trackDisposable(I){const j=this.c(I);j.source||(j.source=new Error().stack)}setParent(I,j){const U=this.c(I);U.parent=j}markAsDisposed(I){this.b.delete(I)}markAsSingleton(I){this.c(I).isSingleton=!0}f(I,j){const U=j.get(I);if(U)return U;const z=I.parent?this.f(this.c(I.parent),j):I;return j.set(I,z),z}getTrackedDisposables(){const I=new Map;return[...this.b.entries()].filter(([,U])=>U.source!==null&&!this.f(U,I).isSingleton).flatMap(([U])=>U)}computeLeakingDisposables(I=10,j){let U;if(j)U=j;else{const se=new Map,oe=[...this.b.values()].filter(J=>J.source!==null&&!this.f(J,se).isSingleton);if(oe.length===0)return;const K=new Set(oe.map(J=>J.value));if(U=oe.filter(J=>!(J.parent&&K.has(J.parent))),U.length===0)throw new Error("There are cyclic diposable chains!")}if(!U)return;function z(se){function oe(J,G){for(;J.length>0&&G.some(N=>typeof N=="string"?N===J[0]:J[0].match(N));)J.shift()}const K=se.source.split(`
`).map(J=>J.trim().replace("at ","")).filter(J=>J!=="");return oe(K,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),K.reverse()}const ne=new s.$Gc;for(const se of U){const oe=z(se);for(let K=0;K<=oe.length;K++)ne.add(oe.slice(0,K).join(`
`),se)}U.sort((0,S.$7b)(se=>se.idx,S.$9b));let _="",ae=0;for(const se of U.slice(0,I)){ae++;const oe=z(se),K=[];for(let J=0;J<oe.length;J++){let G=oe[J];G=`(shared with ${ne.get(oe.slice(0,J+1).join(`
`)).size}/${U.length} leaks) at ${G}`;const q=ne.get(oe.slice(0,J).join(`
`)),X=(0,R.$J)([...q].map(H=>z(H)[J]),H=>H);delete X[oe[J]];for(const[H,Y]of Object.entries(X))K.unshift(`    - stacktraces of ${Y.length} other leaks continue with ${H}`);K.unshift(G)}_+=`


==================== Leaking disposable ${ae}/${U.length}: ${se.value.constructor.name} ====================
${K.join(`
`)}
============================================================

`}return U.length>I&&(_+=`


... and ${U.length-I} more leaking disposables

`),{leaks:U,details:_}}}e.$Hc=a;function g(k){f=k}if(e.$Ic=g,P){const k="__is_disposable_tracked__";g(new class{trackDisposable(I){const j=new Error("Potentially leaked disposable").stack;setTimeout(()=>{I[k]||console.log(j)},3e3)}setParent(I,j){if(I&&I!==i.None)try{I[k]=!0}catch{}}markAsDisposed(I){if(I&&I!==i.None)try{I[k]=!0}catch{}}markAsSingleton(I){}})}function w(k){return f?.trackDisposable(k),k}e.$Jc=w;function y(k){f?.markAsDisposed(k)}e.$Kc=y;function d(k,I){f?.setParent(k,I)}function v(k,I){if(f)for(const j of k)f.setParent(j,I)}function b(k){return f?.markAsSingleton(k),k}e.$Lc=b;function $(k){return typeof k.dispose=="function"&&k.dispose.length===0}e.$Mc=$;function m(k){if(D.Iterable.is(k)){const I=[];for(const j of k)if(j)try{j.dispose()}catch(U){I.push(U)}if(I.length===1)throw I[0];if(I.length>1)throw new AggregateError(I,"Encountered errors while disposing of store");return Array.isArray(k)?[]:k}else if(k)return k.dispose(),k}e.$Nc=m;function u(k){for(const I of k)$(I)&&I.dispose();return[]}e.$Oc=u;function l(...k){const I=E(()=>m(k));return v(k,I),I}e.$Pc=l;function E(k){const I=w({dispose:(0,M.$db)(()=>{y(I),k()})});return I}e.$Qc=E;class h{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this.f=new Set,this.g=!1,w(this)}dispose(){this.g||(y(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{m(this.f)}finally{this.f.clear()}}add(I){if(!I)return I;if(I===this)throw new Error("Cannot register a disposable on itself!");return d(I,this),this.g?h.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(I),I}delete(I){if(I){if(I===this)throw new Error("Cannot dispose a disposable on itself!");this.f.delete(I),I.dispose()}}deleteAndLeak(I){I&&this.f.has(I)&&(this.f.delete(I),d(I,null))}}e.$Rc=h;class i{static{this.None=Object.freeze({dispose(){}})}constructor(){this.q=new h,w(this),d(this.q,this)}dispose(){y(this),this.q.dispose()}B(I){if(I===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(I)}}e.$Sc=i;class c{constructor(){this.b=!1,w(this)}get value(){return this.b?void 0:this.a}set value(I){this.b||I===this.a||(this.a?.dispose(),I&&d(I,this),this.a=I)}clear(){this.value=void 0}dispose(){this.b=!0,y(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const I=this.a;return this.a=void 0,I&&d(I,null),I}}e.$Tc=c;class o{constructor(I){this.b=I,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.$Uc=o;class t{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,w(this)}set(I){let j=I;return this.unset=()=>j=void 0,this.isset=()=>j!==void 0,this.dispose=()=>{j&&(j(),j=void 0,y(this))},this}}e.$Vc=t;class n{constructor(){this.a=new Map}acquire(I,...j){let U=this.a.get(I);U||(U={counter:0,object:this.b(I,...j)},this.a.set(I,U));const{object:z}=U,ne=(0,M.$db)(()=>{--U.counter===0&&(this.c(I,U.object),this.a.delete(I))});return U.counter++,{object:z,dispose:ne}}}e.$Wc=n;class r{constructor(I){this.a=I}async acquire(I,...j){const U=this.a.acquire(I,...j);try{return{object:await U.object,dispose:()=>U.dispose()}}catch(z){throw U.dispose(),z}}}e.$Xc=r;class p{constructor(I){this.object=I}dispose(){}}e.$Yc=p;function A(k){const I=new h;try{k(I)}finally{I.dispose()}}e.$Zc=A;class C{constructor(){this.a=new Map,this.b=!1,w(this)}dispose(){y(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{m(this.a.values())}finally{this.a.clear()}}has(I){return this.a.has(I)}get size(){return this.a.size}get(I){return this.a.get(I)}set(I,j,U=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),U||this.a.get(I)?.dispose(),this.a.set(I,j)}deleteAndDispose(I){this.a.get(I)?.dispose(),this.a.delete(I)}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.$1c=C}),define(te[84],ie([0,1,31]),function(Q,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ol=e.$nl=e.$ml=void 0;const R=new S.$Dc(1e4);function s(a){return f(a,"NFC",R)}e.$ml=s;const M=new S.$Dc(1e4);function D(a){return f(a,"NFD",M)}e.$nl=D;const P=/[^\u0000-\u0080]/;function f(a,g,w){if(!a)return a;const y=w.get(a);if(y)return y;let d;return P.test(a)?d=a.normalize(g):d=a,w.set(a,d),d}e.$ol=function(){const a=/[\u0300-\u036f]/g;return function(g){return D(g).replace(a,"")}}()}),define(te[138],ie([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ql=e.$Pl=e.$Ol=e.rot=e.$Ml=void 0;function S(P,f,a){return Math.min(Math.max(P,f),a)}e.$Ml=S;function R(P,f){return(f+P%f)%f}e.rot=R;class s{constructor(){this.a=0}getNext(){return this.a++}}e.$Ol=s;class M{constructor(){this.a=1,this.b=0}update(f){return this.b=this.b+(f-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$Pl=M;class D{constructor(f){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(f),this.c.fill(0,0,f)}update(f){const a=this.c[this.d];return this.c[this.d]=f,this.d=(this.d+1)%this.c.length,this.e-=a,this.e+=f,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$Ql=D}),function(){function Q(s){const M=[];typeof s=="number"&&M.push("code/timeOrigin",s);function D(f){M.push(f,Date.now())}function P(){const f=[];for(let a=0;a<M.length;a+=2)f.push({name:M[a],startTime:M[a+1]});return f}return{mark:D,getMarks:P}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?Q():{mark(s){performance.mark(s)},getMarks(){let s=performance.timeOrigin;typeof s!="number"&&(s=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const M=[{name:"code/timeOrigin",startTime:Math.round(s)}];for(const D of performance.getEntriesByType("mark"))M.push({name:D.name,startTime:Math.round(s+D.startTime)});return M}};if(typeof process=="object"){const s=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return Q(s)}else return console.trace("perf-util loaded in UNKNOWN environment"),Q()}function S(s){return s.MonacoPerformanceMarks||(s.MonacoPerformanceMarks=e()),s.MonacoPerformanceMarks}var R;typeof global=="object"?R=global:typeof self=="object"?R=self:R={},typeof define=="function"?define("vs/base/common/performance",[],function(){return S(R)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=S(R):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),R.perf=S(R))}(),function(Q,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var S=e();for(var R in S)(typeof exports=="object"?exports:Q)[R]=S[R]}}(typeof self<"u"?self:this,function(){return function(Q){var e={};function S(R){if(e[R])return e[R].exports;var s=e[R]={i:R,l:!1,exports:{}};return Q[R].call(s.exports,s,s.exports,S),s.l=!0,s.exports}return S.m=Q,S.c=e,S.d=function(R,s,M){S.o(R,s)||Object.defineProperty(R,s,{enumerable:!0,get:M})},S.r=function(R){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(R,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(R,"__esModule",{value:!0})},S.t=function(R,s){if(1&s&&(R=S(R)),8&s||4&s&&typeof R=="object"&&R&&R.__esModule)return R;var M=Object.create(null);if(S.r(M),Object.defineProperty(M,"default",{enumerable:!0,value:R}),2&s&&typeof R!="string")for(var D in R)S.d(M,D,function(P){return R[P]}.bind(null,D));return M},S.n=function(R){var s=R&&R.__esModule?function(){return R.default}:function(){return R};return S.d(s,"a",s),s},S.o=function(R,s){return Object.prototype.hasOwnProperty.call(R,s)},S.p="",S(S.s=0)}([function(Q,e,S){(function(R){var s;e=Q.exports=re,s=typeof R=="object"&&R.env&&R.env.NODE_DEBUG&&/\bsemver\b/i.test(R.env.NODE_DEBUG)?function(){var Z=Array.prototype.slice.call(arguments,0);Z.unshift("SEMVER"),console.log.apply(console,Z)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var M=256,D=Number.MAX_SAFE_INTEGER||9007199254740991,P=e.re=[],f=e.src=[],a=0,g=a++;f[g]="0|[1-9]\\d*";var w=a++;f[w]="[0-9]+";var y=a++;f[y]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var d=a++;f[d]="("+f[g]+")\\.("+f[g]+")\\.("+f[g]+")";var v=a++;f[v]="("+f[w]+")\\.("+f[w]+")\\.("+f[w]+")";var b=a++;f[b]="(?:"+f[g]+"|"+f[y]+")";var $=a++;f[$]="(?:"+f[w]+"|"+f[y]+")";var m=a++;f[m]="(?:-("+f[b]+"(?:\\."+f[b]+")*))";var u=a++;f[u]="(?:-?("+f[$]+"(?:\\."+f[$]+")*))";var l=a++;f[l]="[0-9A-Za-z-]+";var E=a++;f[E]="(?:\\+("+f[l]+"(?:\\."+f[l]+")*))";var h=a++,i="v?"+f[d]+f[m]+"?"+f[E]+"?";f[h]="^"+i+"$";var c="[v=\\s]*"+f[v]+f[u]+"?"+f[E]+"?",o=a++;f[o]="^"+c+"$";var t=a++;f[t]="((?:<|>)?=?)";var n=a++;f[n]=f[w]+"|x|X|\\*";var r=a++;f[r]=f[g]+"|x|X|\\*";var p=a++;f[p]="[v=\\s]*("+f[r]+")(?:\\.("+f[r]+")(?:\\.("+f[r]+")(?:"+f[m]+")?"+f[E]+"?)?)?";var A=a++;f[A]="[v=\\s]*("+f[n]+")(?:\\.("+f[n]+")(?:\\.("+f[n]+")(?:"+f[u]+")?"+f[E]+"?)?)?";var C=a++;f[C]="^"+f[t]+"\\s*"+f[p]+"$";var k=a++;f[k]="^"+f[t]+"\\s*"+f[A]+"$";var I=a++;f[I]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var j=a++;f[j]="(?:~>?)";var U=a++;f[U]="(\\s*)"+f[j]+"\\s+",P[U]=new RegExp(f[U],"g");var z=a++;f[z]="^"+f[j]+f[p]+"$";var ne=a++;f[ne]="^"+f[j]+f[A]+"$";var _=a++;f[_]="(?:\\^)";var ae=a++;f[ae]="(\\s*)"+f[_]+"\\s+",P[ae]=new RegExp(f[ae],"g");var se=a++;f[se]="^"+f[_]+f[p]+"$";var oe=a++;f[oe]="^"+f[_]+f[A]+"$";var K=a++;f[K]="^"+f[t]+"\\s*("+c+")$|^$";var J=a++;f[J]="^"+f[t]+"\\s*("+i+")$|^$";var G=a++;f[G]="(\\s*)"+f[t]+"\\s*("+c+"|"+f[p]+")",P[G]=new RegExp(f[G],"g");var N=a++;f[N]="^\\s*("+f[p]+")\\s+-\\s+("+f[p]+")\\s*$";var q=a++;f[q]="^\\s*("+f[A]+")\\s+-\\s+("+f[A]+")\\s*$";var X=a++;f[X]="(<|>)?=?\\s*\\*";for(var H=0;H<35;H++)s(H,f[H]),P[H]||(P[H]=new RegExp(f[H]));function Y(Z,le){if(Z instanceof re)return Z;if(typeof Z!="string"||Z.length>M||!(le?P[o]:P[h]).test(Z))return null;try{return new re(Z,le)}catch{return null}}function re(Z,le){if(Z instanceof re){if(Z.loose===le)return Z;Z=Z.version}else if(typeof Z!="string")throw new TypeError("Invalid Version: "+Z);if(Z.length>M)throw new TypeError("version is longer than "+M+" characters");if(!(this instanceof re))return new re(Z,le);s("SemVer",Z,le),this.loose=le;var ge=Z.trim().match(le?P[o]:P[h]);if(!ge)throw new TypeError("Invalid Version: "+Z);if(this.raw=Z,this.major=+ge[1],this.minor=+ge[2],this.patch=+ge[3],this.major>D||this.major<0)throw new TypeError("Invalid major version");if(this.minor>D||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>D||this.patch<0)throw new TypeError("Invalid patch version");ge[4]?this.prerelease=ge[4].split(".").map(function(Ce){if(/^[0-9]+$/.test(Ce)){var De=+Ce;if(De>=0&&De<D)return De}return Ce}):this.prerelease=[],this.build=ge[5]?ge[5].split("."):[],this.format()}e.parse=Y,e.valid=function(Z,le){var ge=Y(Z,le);return ge?ge.version:null},e.clean=function(Z,le){var ge=Y(Z.trim().replace(/^[=v]+/,""),le);return ge?ge.version:null},e.SemVer=re,re.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},re.prototype.toString=function(){return this.version},re.prototype.compare=function(Z){return s("SemVer.compare",this.version,this.loose,Z),Z instanceof re||(Z=new re(Z,this.loose)),this.compareMain(Z)||this.comparePre(Z)},re.prototype.compareMain=function(Z){return Z instanceof re||(Z=new re(Z,this.loose)),O(this.major,Z.major)||O(this.minor,Z.minor)||O(this.patch,Z.patch)},re.prototype.comparePre=function(Z){if(Z instanceof re||(Z=new re(Z,this.loose)),this.prerelease.length&&!Z.prerelease.length)return-1;if(!this.prerelease.length&&Z.prerelease.length)return 1;if(!this.prerelease.length&&!Z.prerelease.length)return 0;var le=0;do{var ge=this.prerelease[le],Ce=Z.prerelease[le];if(s("prerelease compare",le,ge,Ce),ge===void 0&&Ce===void 0)return 0;if(Ce===void 0)return 1;if(ge===void 0)return-1;if(ge!==Ce)return O(ge,Ce)}while(++le)},re.prototype.inc=function(Z,le){switch(Z){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",le);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",le);break;case"prepatch":this.prerelease.length=0,this.inc("patch",le),this.inc("pre",le);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",le),this.inc("pre",le);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var ge=this.prerelease.length;--ge>=0;)typeof this.prerelease[ge]=="number"&&(this.prerelease[ge]++,ge=-2);ge===-1&&this.prerelease.push(0)}le&&(this.prerelease[0]===le?isNaN(this.prerelease[1])&&(this.prerelease=[le,0]):this.prerelease=[le,0]);break;default:throw new Error("invalid increment argument: "+Z)}return this.format(),this.raw=this.version,this},e.inc=function(Z,le,ge,Ce){typeof ge=="string"&&(Ce=ge,ge=void 0);try{return new re(Z,ge).inc(le,Ce).version}catch{return null}},e.diff=function(Z,le){if(W(Z,le))return null;var ge=Y(Z),Ce=Y(le);if(ge.prerelease.length||Ce.prerelease.length){for(var De in ge)if((De==="major"||De==="minor"||De==="patch")&&ge[De]!==Ce[De])return"pre"+De;return"prerelease"}for(var De in ge)if((De==="major"||De==="minor"||De==="patch")&&ge[De]!==Ce[De])return De},e.compareIdentifiers=O;var F=/^[0-9]+$/;function O(Z,le){var ge=F.test(Z),Ce=F.test(le);return ge&&Ce&&(Z=+Z,le=+le),ge&&!Ce?-1:Ce&&!ge?1:Z<le?-1:Z>le?1:0}function L(Z,le,ge){return new re(Z,ge).compare(new re(le,ge))}function B(Z,le,ge){return L(Z,le,ge)>0}function T(Z,le,ge){return L(Z,le,ge)<0}function W(Z,le,ge){return L(Z,le,ge)===0}function V(Z,le,ge){return L(Z,le,ge)!==0}function ce(Z,le,ge){return L(Z,le,ge)>=0}function de(Z,le,ge){return L(Z,le,ge)<=0}function ue(Z,le,ge,Ce){var De;switch(le){case"===":typeof Z=="object"&&(Z=Z.version),typeof ge=="object"&&(ge=ge.version),De=Z===ge;break;case"!==":typeof Z=="object"&&(Z=Z.version),typeof ge=="object"&&(ge=ge.version),De=Z!==ge;break;case"":case"=":case"==":De=W(Z,ge,Ce);break;case"!=":De=V(Z,ge,Ce);break;case">":De=B(Z,ge,Ce);break;case">=":De=ce(Z,ge,Ce);break;case"<":De=T(Z,ge,Ce);break;case"<=":De=de(Z,ge,Ce);break;default:throw new TypeError("Invalid operator: "+le)}return De}function fe(Z,le){if(Z instanceof fe){if(Z.loose===le)return Z;Z=Z.value}if(!(this instanceof fe))return new fe(Z,le);s("comparator",Z,le),this.loose=le,this.parse(Z),this.semver===ye?this.value="":this.value=this.operator+this.semver.version,s("comp",this)}e.rcompareIdentifiers=function(Z,le){return O(le,Z)},e.major=function(Z,le){return new re(Z,le).major},e.minor=function(Z,le){return new re(Z,le).minor},e.patch=function(Z,le){return new re(Z,le).patch},e.compare=L,e.compareLoose=function(Z,le){return L(Z,le,!0)},e.rcompare=function(Z,le,ge){return L(le,Z,ge)},e.sort=function(Z,le){return Z.sort(function(ge,Ce){return e.compare(ge,Ce,le)})},e.rsort=function(Z,le){return Z.sort(function(ge,Ce){return e.rcompare(ge,Ce,le)})},e.gt=B,e.lt=T,e.eq=W,e.neq=V,e.gte=ce,e.lte=de,e.cmp=ue,e.Comparator=fe;var ye={};function be(Z,le){if(Z instanceof be)return Z.loose===le?Z:new be(Z.raw,le);if(Z instanceof fe)return new be(Z.value,le);if(!(this instanceof be))return new be(Z,le);if(this.loose=le,this.raw=Z,this.set=Z.split(/\s*\|\|\s*/).map(function(ge){return this.parseRange(ge.trim())},this).filter(function(ge){return ge.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+Z);this.format()}function pe(Z){return!Z||Z.toLowerCase()==="x"||Z==="*"}function Ae(Z,le,ge,Ce,De,Ue,Oe,ze,We,x,he,$e,ve){return((le=pe(ge)?"":pe(Ce)?">="+ge+".0.0":pe(De)?">="+ge+"."+Ce+".0":">="+le)+" "+(ze=pe(We)?"":pe(x)?"<"+(+We+1)+".0.0":pe(he)?"<"+We+"."+(+x+1)+".0":$e?"<="+We+"."+x+"."+he+"-"+$e:"<="+ze)).trim()}function Te(Z,le){for(var ge=0;ge<Z.length;ge++)if(!Z[ge].test(le))return!1;if(le.prerelease.length){for(ge=0;ge<Z.length;ge++)if(s(Z[ge].semver),Z[ge].semver!==ye&&Z[ge].semver.prerelease.length>0){var Ce=Z[ge].semver;if(Ce.major===le.major&&Ce.minor===le.minor&&Ce.patch===le.patch)return!0}return!1}return!0}function me(Z,le,ge){try{le=new be(le,ge)}catch{return!1}return le.test(Z)}function we(Z,le,ge,Ce){var De,Ue,Oe,ze,We;switch(Z=new re(Z,Ce),le=new be(le,Ce),ge){case">":De=B,Ue=de,Oe=T,ze=">",We=">=";break;case"<":De=T,Ue=ce,Oe=B,ze="<",We="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(me(Z,le,Ce))return!1;for(var x=0;x<le.set.length;++x){var he=le.set[x],$e=null,ve=null;if(he.forEach(function(Re){Re.semver===ye&&(Re=new fe(">=0.0.0")),$e=$e||Re,ve=ve||Re,De(Re.semver,$e.semver,Ce)?$e=Re:Oe(Re.semver,ve.semver,Ce)&&(ve=Re)}),$e.operator===ze||$e.operator===We||(!ve.operator||ve.operator===ze)&&Ue(Z,ve.semver)||ve.operator===We&&Oe(Z,ve.semver))return!1}return!0}fe.prototype.parse=function(Z){var le=this.loose?P[K]:P[J],ge=Z.match(le);if(!ge)throw new TypeError("Invalid comparator: "+Z);this.operator=ge[1],this.operator==="="&&(this.operator=""),ge[2]?this.semver=new re(ge[2],this.loose):this.semver=ye},fe.prototype.toString=function(){return this.value},fe.prototype.test=function(Z){return s("Comparator.test",Z,this.loose),this.semver===ye||(typeof Z=="string"&&(Z=new re(Z,this.loose)),ue(Z,this.operator,this.semver,this.loose))},fe.prototype.intersects=function(Z,le){if(!(Z instanceof fe))throw new TypeError("a Comparator is required");var ge;if(this.operator==="")return ge=new be(Z.value,le),me(this.value,ge,le);if(Z.operator==="")return ge=new be(this.value,le),me(Z.semver,ge,le);var Ce=!(this.operator!==">="&&this.operator!==">"||Z.operator!==">="&&Z.operator!==">"),De=!(this.operator!=="<="&&this.operator!=="<"||Z.operator!=="<="&&Z.operator!=="<"),Ue=this.semver.version===Z.semver.version,Oe=!(this.operator!==">="&&this.operator!=="<="||Z.operator!==">="&&Z.operator!=="<="),ze=ue(this.semver,"<",Z.semver,le)&&(this.operator===">="||this.operator===">")&&(Z.operator==="<="||Z.operator==="<"),We=ue(this.semver,">",Z.semver,le)&&(this.operator==="<="||this.operator==="<")&&(Z.operator===">="||Z.operator===">");return Ce||De||Ue&&Oe||ze||We},e.Range=be,be.prototype.format=function(){return this.range=this.set.map(function(Z){return Z.join(" ").trim()}).join("||").trim(),this.range},be.prototype.toString=function(){return this.range},be.prototype.parseRange=function(Z){var le=this.loose;Z=Z.trim(),s("range",Z,le);var ge=le?P[q]:P[N];Z=Z.replace(ge,Ae),s("hyphen replace",Z),Z=Z.replace(P[G],"$1$2$3"),s("comparator trim",Z,P[G]),Z=(Z=(Z=Z.replace(P[U],"$1~")).replace(P[ae],"$1^")).split(/\s+/).join(" ");var Ce=le?P[K]:P[J],De=Z.split(" ").map(function(Ue){return function(Oe,ze){return s("comp",Oe),Oe=function(We,x){return We.trim().split(/\s+/).map(function(he){return function($e,ve){s("caret",$e,ve);var Re=ve?P[oe]:P[se];return $e.replace(Re,function(Fe,je,Ne,Be,He){var Ge;return s("caret",$e,Fe,je,Ne,Be,He),pe(je)?Ge="":pe(Ne)?Ge=">="+je+".0.0 <"+(+je+1)+".0.0":pe(Be)?Ge=je==="0"?">="+je+"."+Ne+".0 <"+je+"."+(+Ne+1)+".0":">="+je+"."+Ne+".0 <"+(+je+1)+".0.0":He?(s("replaceCaret pr",He),He.charAt(0)!=="-"&&(He="-"+He),Ge=je==="0"?Ne==="0"?">="+je+"."+Ne+"."+Be+He+" <"+je+"."+Ne+"."+(+Be+1):">="+je+"."+Ne+"."+Be+He+" <"+je+"."+(+Ne+1)+".0":">="+je+"."+Ne+"."+Be+He+" <"+(+je+1)+".0.0"):(s("no pr"),Ge=je==="0"?Ne==="0"?">="+je+"."+Ne+"."+Be+" <"+je+"."+Ne+"."+(+Be+1):">="+je+"."+Ne+"."+Be+" <"+je+"."+(+Ne+1)+".0":">="+je+"."+Ne+"."+Be+" <"+(+je+1)+".0.0"),s("caret return",Ge),Ge})}(he,x)}).join(" ")}(Oe,ze),s("caret",Oe),Oe=function(We,x){return We.trim().split(/\s+/).map(function(he){return function($e,ve){var Re=ve?P[ne]:P[z];return $e.replace(Re,function(Fe,je,Ne,Be,He){var Ge;return s("tilde",$e,Fe,je,Ne,Be,He),pe(je)?Ge="":pe(Ne)?Ge=">="+je+".0.0 <"+(+je+1)+".0.0":pe(Be)?Ge=">="+je+"."+Ne+".0 <"+je+"."+(+Ne+1)+".0":He?(s("replaceTilde pr",He),He.charAt(0)!=="-"&&(He="-"+He),Ge=">="+je+"."+Ne+"."+Be+He+" <"+je+"."+(+Ne+1)+".0"):Ge=">="+je+"."+Ne+"."+Be+" <"+je+"."+(+Ne+1)+".0",s("tilde return",Ge),Ge})}(he,x)}).join(" ")}(Oe,ze),s("tildes",Oe),Oe=function(We,x){return s("replaceXRanges",We,x),We.split(/\s+/).map(function(he){return function($e,ve){$e=$e.trim();var Re=ve?P[k]:P[C];return $e.replace(Re,function(Fe,je,Ne,Be,He,Ge){s("xRange",$e,Fe,je,Ne,Be,He,Ge);var xe=pe(Ne),Ze=xe||pe(Be),it=Ze||pe(He);return je==="="&&it&&(je=""),xe?Fe=je===">"||je==="<"?"<0.0.0":"*":je&&it?(Ze&&(Be=0),it&&(He=0),je===">"?(je=">=",Ze?(Ne=+Ne+1,Be=0,He=0):it&&(Be=+Be+1,He=0)):je==="<="&&(je="<",Ze?Ne=+Ne+1:Be=+Be+1),Fe=je+Ne+"."+Be+"."+He):Ze?Fe=">="+Ne+".0.0 <"+(+Ne+1)+".0.0":it&&(Fe=">="+Ne+"."+Be+".0 <"+Ne+"."+(+Be+1)+".0"),s("xRange return",Fe),Fe})}(he,x)}).join(" ")}(Oe,ze),s("xrange",Oe),Oe=function(We,x){return s("replaceStars",We,x),We.trim().replace(P[X],"")}(Oe,ze),s("stars",Oe),Oe}(Ue,le)}).join(" ").split(/\s+/);return this.loose&&(De=De.filter(function(Ue){return!!Ue.match(Ce)})),De=De.map(function(Ue){return new fe(Ue,le)})},be.prototype.intersects=function(Z,le){if(!(Z instanceof be))throw new TypeError("a Range is required");return this.set.some(function(ge){return ge.every(function(Ce){return Z.set.some(function(De){return De.every(function(Ue){return Ce.intersects(Ue,le)})})})})},e.toComparators=function(Z,le){return new be(Z,le).set.map(function(ge){return ge.map(function(Ce){return Ce.value}).join(" ").trim().split(" ")})},be.prototype.test=function(Z){if(!Z)return!1;typeof Z=="string"&&(Z=new re(Z,this.loose));for(var le=0;le<this.set.length;le++)if(Te(this.set[le],Z))return!0;return!1},e.satisfies=me,e.maxSatisfying=function(Z,le,ge){var Ce=null,De=null;try{var Ue=new be(le,ge)}catch{return null}return Z.forEach(function(Oe){Ue.test(Oe)&&(Ce&&De.compare(Oe)!==-1||(De=new re(Ce=Oe,ge)))}),Ce},e.minSatisfying=function(Z,le,ge){var Ce=null,De=null;try{var Ue=new be(le,ge)}catch{return null}return Z.forEach(function(Oe){Ue.test(Oe)&&(Ce&&De.compare(Oe)!==1||(De=new re(Ce=Oe,ge)))}),Ce},e.validRange=function(Z,le){try{return new be(Z,le).range||"*"}catch{return null}},e.ltr=function(Z,le,ge){return we(Z,le,"<",ge)},e.gtr=function(Z,le,ge){return we(Z,le,">",ge)},e.outside=we,e.prerelease=function(Z,le){var ge=Y(Z,le);return ge&&ge.prerelease.length?ge.prerelease:null},e.intersects=function(Z,le,ge){return Z=new be(Z,ge),le=new be(le,ge),Z.intersects(le)},e.coerce=function(Z){if(Z instanceof re)return Z;if(typeof Z!="string")return null;var le=Z.match(P[I]);return le==null?null:Y((le[1]||"0")+"."+(le[2]||"0")+"."+(le[3]||"0"))}}).call(this,S(1))},function(Q,e){var S,R,s=Q.exports={};function M(){throw new Error("setTimeout has not been defined")}function D(){throw new Error("clearTimeout has not been defined")}function P($){if(S===setTimeout)return setTimeout($,0);if((S===M||!S)&&setTimeout)return S=setTimeout,setTimeout($,0);try{return S($,0)}catch{try{return S.call(null,$,0)}catch{return S.call(this,$,0)}}}(function(){try{S=typeof setTimeout=="function"?setTimeout:M}catch{S=M}try{R=typeof clearTimeout=="function"?clearTimeout:D}catch{R=D}})();var f,a=[],g=!1,w=-1;function y(){g&&f&&(g=!1,f.length?a=f.concat(a):w=-1,a.length&&d())}function d(){if(!g){var $=P(y);g=!0;for(var m=a.length;m;){for(f=a,a=[];++w<m;)f&&f[w].run();w=-1,m=a.length}f=null,g=!1,function(u){if(R===clearTimeout)return clearTimeout(u);if((R===D||!R)&&clearTimeout)return R=clearTimeout,clearTimeout(u);try{R(u)}catch{try{return R.call(null,u)}catch{return R.call(this,u)}}}($)}}function v($,m){this.fun=$,this.array=m}function b(){}s.nextTick=function($){var m=new Array(arguments.length-1);if(arguments.length>1)for(var u=1;u<arguments.length;u++)m[u-1]=arguments[u];a.push(new v($,m)),a.length!==1||g||P(d)},v.prototype.run=function(){this.fun.apply(null,this.array)},s.title="browser",s.browser=!0,s.env={},s.argv=[],s.version="",s.versions={},s.on=b,s.addListener=b,s.once=b,s.off=b,s.removeListener=b,s.removeAllListeners=b,s.emit=b,s.prependListener=b,s.prependOnceListener=b,s.listeners=function($){return[]},s.binding=function($){throw new Error("process.binding is not supported")},s.cwd=function(){return"/"},s.chdir=function($){throw new Error("process.chdir is not supported")},s.umask=function(){return 0}}])}),define(te[139],ie([0,1]),function(Q,e){"use strict";var S;Object.defineProperty(e,"__esModule",{value:!0}),e.$wr=void 0;class R{constructor(P,f,a){this.level=P,this.key=f,this.value=a,this.forward=[]}}const s=void 0;class M{constructor(P,f=2**16){this.comparator=P,this[S]="SkipList",this.d=0,this.f=0,this.c=Math.max(1,Math.log2(f)|0),this.e=new R(this.c,s,s)}get size(){return this.f}clear(){this.e=new R(this.c,s,s),this.f=0}has(P){return!!M.g(this,P,this.comparator)}get(P){return M.g(this,P,this.comparator)?.value}set(P,f){return M.h(this,P,f,this.comparator)&&(this.f+=1),this}delete(P){const f=M.k(this,P,this.comparator);return f&&(this.f-=1),f}forEach(P,f){let a=this.e.forward[0];for(;a;)P.call(f,a.value,a.key,this),a=a.forward[0]}[(S=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let P=this.e.forward[0];for(;P;)yield[P.key,P.value],P=P.forward[0]}*keys(){let P=this.e.forward[0];for(;P;)yield P.key,P=P.forward[0]}*values(){let P=this.e.forward[0];for(;P;)yield P.value,P=P.forward[0]}toString(){let P="[SkipList]:",f=this.e.forward[0];for(;f;)P+=`node(${f.key}, ${f.value}, lvl:${f.level})`,f=f.forward[0];return P}static g(P,f,a){let g=P.e;for(let w=P.d-1;w>=0;w--)for(;g.forward[w]&&a(g.forward[w].key,f)<0;)g=g.forward[w];if(g=g.forward[0],g&&a(g.key,f)===0)return g}static h(P,f,a,g){const w=[];let y=P.e;for(let d=P.d-1;d>=0;d--){for(;y.forward[d]&&g(y.forward[d].key,f)<0;)y=y.forward[d];w[d]=y}if(y=y.forward[0],y&&g(y.key,f)===0)return y.value=a,!1;{const d=M.j(P);if(d>P.d){for(let v=P.d;v<d;v++)w[v]=P.e;P.d=d}y=new R(d,f,a);for(let v=0;v<d;v++)y.forward[v]=w[v].forward[v],w[v].forward[v]=y;return!0}}static j(P,f=.5){let a=1;for(;Math.random()<f&&a<P.c;)a+=1;return a}static k(P,f,a){const g=[];let w=P.e;for(let y=P.d-1;y>=0;y--){for(;w.forward[y]&&a(w.forward[y].key,f)<0;)w=w.forward[y];g[y]=w}if(w=w.forward[0],!w||a(w.key,f)!==0)return!1;for(let y=0;y<P.d&&g[y].forward[y]===w;y++)g[y].forward[y]=w.forward[y];for(;P.d>0&&P.e.forward[P.d-1]===s;)P.d-=1;return!0}}e.$wr=M}),define(te[72],ie([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jd=void 0;const S=globalThis.performance&&typeof globalThis.performance.now=="function";class R{static create(M){return new R(M)}constructor(M){this.c=S&&M===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}e.$Jd=R}),define(te[3],ie([0,1,14,83,2,101,72]),function(Q,e,S,R,s,M,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wd=e.$Vd=e.$Ud=e.$Td=e.$Sd=e.$Rd=e.$Qd=e.$Pd=e.$Od=e.$Nd=e.$Md=e.$Ld=e.Event=void 0;const P=!1,f=!1;var a;(function(C){C.None=()=>s.$Sc.None;function k(ue){if(f){const{onDidAddListener:fe}=ue,ye=v.create();let be=0;ue.onDidAddListener=()=>{++be===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),ye.print()),fe?.()}}}function I(ue,fe){return J(ue,()=>{},0,void 0,!0,void 0,fe)}C.defer=I;function j(ue){return(fe,ye=null,be)=>{let pe=!1,Ae;return Ae=ue(Te=>{if(!pe)return Ae?Ae.dispose():pe=!0,fe.call(ye,Te)},null,be),pe&&Ae.dispose(),Ae}}C.once=j;function U(ue,fe,ye){return oe((be,pe=null,Ae)=>ue(Te=>be.call(pe,fe(Te)),null,Ae),ye)}C.map=U;function z(ue,fe,ye){return oe((be,pe=null,Ae)=>ue(Te=>{fe(Te),be.call(pe,Te)},null,Ae),ye)}C.forEach=z;function ne(ue,fe,ye){return oe((be,pe=null,Ae)=>ue(Te=>fe(Te)&&be.call(pe,Te),null,Ae),ye)}C.filter=ne;function _(ue){return ue}C.signal=_;function ae(...ue){return(fe,ye=null,be)=>{const pe=(0,s.$Pc)(...ue.map(Ae=>Ae(Te=>fe.call(ye,Te))));return K(pe,be)}}C.any=ae;function se(ue,fe,ye,be){let pe=ye;return U(ue,Ae=>(pe=fe(pe,Ae),pe),be)}C.reduce=se;function oe(ue,fe){let ye;const be={onWillAddFirstListener(){ye=ue(pe.fire,pe)},onDidRemoveLastListener(){ye?.dispose()}};fe||k(be);const pe=new l(be);return fe?.add(pe),pe.event}function K(ue,fe){return fe instanceof Array?fe.push(ue):fe&&fe.add(ue),ue}function J(ue,fe,ye=100,be=!1,pe=!1,Ae,Te){let me,we,Z,le=0,ge;const Ce={leakWarningThreshold:Ae,onWillAddFirstListener(){me=ue(Ue=>{le++,we=fe(we,Ue),be&&!Z&&(De.fire(we),we=void 0),ge=()=>{const Oe=we;we=void 0,Z=void 0,(!be||le>1)&&De.fire(Oe),le=0},typeof ye=="number"?(clearTimeout(Z),Z=setTimeout(ge,ye)):Z===void 0&&(Z=0,queueMicrotask(ge))})},onWillRemoveListener(){pe&&le>0&&ge?.()},onDidRemoveLastListener(){ge=void 0,me.dispose()}};Te||k(Ce);const De=new l(Ce);return Te?.add(De),De.event}C.debounce=J;function G(ue,fe=0,ye){return C.debounce(ue,(be,pe)=>be?(be.push(pe),be):[pe],fe,void 0,!0,void 0,ye)}C.accumulate=G;function N(ue,fe=(be,pe)=>be===pe,ye){let be=!0,pe;return ne(ue,Ae=>{const Te=be||!fe(Ae,pe);return be=!1,pe=Ae,Te},ye)}C.latch=N;function q(ue,fe,ye){return[C.filter(ue,fe,ye),C.filter(ue,be=>!fe(be),ye)]}C.split=q;function X(ue,fe=!1,ye=[],be){let pe=ye.slice(),Ae=ue(we=>{pe?pe.push(we):me.fire(we)});be&&be.add(Ae);const Te=()=>{pe?.forEach(we=>me.fire(we)),pe=null},me=new l({onWillAddFirstListener(){Ae||(Ae=ue(we=>me.fire(we)),be&&be.add(Ae))},onDidAddFirstListener(){pe&&(fe?setTimeout(Te):Te())},onDidRemoveLastListener(){Ae&&Ae.dispose(),Ae=null}});return be&&be.add(me),me.event}C.buffer=X;function H(ue,fe){return(be,pe,Ae)=>{const Te=fe(new re);return ue(function(me){const we=Te.evaluate(me);we!==Y&&be.call(pe,we)},void 0,Ae)}}C.chain=H;const Y=Symbol("HaltChainable");class re{constructor(){this.f=[]}map(fe){return this.f.push(fe),this}forEach(fe){return this.f.push(ye=>(fe(ye),ye)),this}filter(fe){return this.f.push(ye=>fe(ye)?ye:Y),this}reduce(fe,ye){let be=ye;return this.f.push(pe=>(be=fe(be,pe),be)),this}latch(fe=(ye,be)=>ye===be){let ye=!0,be;return this.f.push(pe=>{const Ae=ye||!fe(pe,be);return ye=!1,be=pe,Ae?pe:Y}),this}evaluate(fe){for(const ye of this.f)if(fe=ye(fe),fe===Y)break;return fe}}function F(ue,fe,ye=be=>be){const be=(...me)=>Te.fire(ye(...me)),pe=()=>ue.on(fe,be),Ae=()=>ue.removeListener(fe,be),Te=new l({onWillAddFirstListener:pe,onDidRemoveLastListener:Ae});return Te.event}C.fromNodeEventEmitter=F;function O(ue,fe,ye=be=>be){const be=(...me)=>Te.fire(ye(...me)),pe=()=>ue.addEventListener(fe,be),Ae=()=>ue.removeEventListener(fe,be),Te=new l({onWillAddFirstListener:pe,onDidRemoveLastListener:Ae});return Te.event}C.fromDOMEventEmitter=O;function L(ue){return new Promise(fe=>j(ue)(fe))}C.toPromise=L;function B(ue){const fe=new l;return ue.then(ye=>{fe.fire(ye)},()=>{fe.fire(void 0)}).finally(()=>{fe.dispose()}),fe.event}C.fromPromise=B;function T(ue,fe){return fe(void 0),ue(ye=>fe(ye))}C.runAndSubscribe=T;function W(ue,fe){let ye=null;function be(Ae){ye?.dispose(),ye=new s.$Rc,fe(Ae,ye)}be(void 0);const pe=ue(Ae=>be(Ae));return(0,s.$Qc)(()=>{pe.dispose(),ye?.dispose()})}C.runAndSubscribeWithStore=W;class V{constructor(fe,ye){this._observable=fe,this.f=0,this.g=!1;const be={onWillAddFirstListener:()=>{fe.addObserver(this)},onDidRemoveLastListener:()=>{fe.removeObserver(this)}};ye||k(be),this.emitter=new l(be),ye&&ye.add(this.emitter)}beginUpdate(fe){this.f++}handlePossibleChange(fe){}handleChange(fe,ye){this.g=!0}endUpdate(fe){this.f--,this.f===0&&(this._observable.reportChanges(),this.g&&(this.g=!1,this.emitter.fire(this._observable.get())))}}function ce(ue,fe){return new V(ue,fe).emitter.event}C.fromObservable=ce;function de(ue){return fe=>{let ye=0,be=!1;const pe={beginUpdate(){ye++},endUpdate(){ye--,ye===0&&(ue.reportChanges(),be&&(be=!1,fe()))},handlePossibleChange(){},handleChange(){be=!0}};return ue.addObserver(pe),ue.reportChanges(),{dispose(){ue.removeObserver(pe)}}}}C.fromObservableLight=de})(a||(e.Event=a={}));class g{static{this.all=new Set}static{this.f=0}constructor(k){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${k}_${g.f++}`,g.all.add(this)}start(k){this.g=new D.$Jd,this.listenerCount=k}stop(){if(this.g){const k=this.g.elapsed();this.durations.push(k),this.elapsedOverall+=k,this.invocationCount+=1,this.g=void 0}}}e.$Ld=g;let w=-1;function y(C){const k=w;return w=C,{dispose(){w=k}}}e.$Md=y;class d{constructor(k,I=Math.random().toString(18).slice(2,5)){this.threshold=k,this.name=I,this.g=0}dispose(){this.f?.clear()}check(k,I){const j=this.threshold;if(j<=0||I<j)return;this.f||(this.f=new Map);const U=this.f.get(k.value)||0;if(this.f.set(k.value,U+1),this.g-=1,this.g<=0){this.g=j*.5;let z,ne=0;for(const[_,ae]of this.f)(!z||ne<ae)&&(z=_,ne=ae);console.warn(`[${this.name}] potential listener LEAK detected, having ${I} listeners already. MOST frequent listener (${ne}):`),console.warn(z)}return()=>{const z=this.f.get(k.value)||0;this.f.set(k.value,z-1)}}}class v{static create(){return new v(new Error().stack??"")}constructor(k){this.value=k}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}let b=0;class ${constructor(k){this.value=k,this.id=b++}}const m=2,u=(C,k)=>{if(C instanceof $)k(C);else for(let I=0;I<C.length;I++){const j=C[I];j&&k(j)}};class l{constructor(k){this.w=0,this.f=k,this.g=w>0||this.f?.leakWarningThreshold?new d(this.f?.leakWarningThreshold??w):void 0,this.j=this.f?._profName?new g(this.f._profName):void 0,this.u=this.f?.deliveryQueue}dispose(){if(!this.m){if(this.m=!0,this.u?.current===this&&this.u.reset(),this.t){if(P){const k=this.t;queueMicrotask(()=>{u(k,I=>I.stack?.print())})}this.t=void 0,this.w=0}this.f?.onDidRemoveLastListener?.(),this.g?.dispose()}}get event(){return this.q??=(k,I,j)=>{if(this.g&&this.w>this.g.threshold*3)return console.warn(`[${this.g.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),s.$Sc.None;if(this.m)return s.$Sc.None;I&&(k=k.bind(I));const U=new $(k);let z,ne;this.g&&this.w>=Math.ceil(this.g.threshold*.2)&&(U.stack=v.create(),z=this.g.check(U.stack,this.w+1)),P&&(U.stack=ne??v.create()),this.t?this.t instanceof $?(this.u??=new h,this.t=[this.t,U]):this.t.push(U):(this.f?.onWillAddFirstListener?.(this),this.t=U,this.f?.onDidAddFirstListener?.(this)),this.w++;const _=(0,s.$Qc)(()=>{z?.(),this.x(U)});return j instanceof s.$Rc?j.add(_):Array.isArray(j)&&j.push(_),_},this.q}x(k){if(this.f?.onWillRemoveListener?.(this),!this.t)return;if(this.w===1){this.t=void 0,this.f?.onDidRemoveLastListener?.(this),this.w=0;return}const I=this.t,j=I.indexOf(k);if(j===-1)throw console.log("disposed?",this.m),console.log("size?",this.w),console.log("arr?",JSON.stringify(this.t)),new Error("Attempted to dispose unknown listener");this.w--,I[j]=void 0;const U=this.u.current===this;if(this.w*m<=I.length){let z=0;for(let ne=0;ne<I.length;ne++)I[ne]?I[z++]=I[ne]:U&&(this.u.end--,z<this.u.i&&this.u.i--);I.length=z}}y(k,I){if(!k)return;const j=this.f?.onListenerError||S.$1;if(!j){k.value(I);return}try{k.value(I)}catch(U){j(U)}}z(k){const I=k.current.t;for(;k.i<k.end;)this.y(I[k.i++],k.value);k.reset()}fire(k){if(this.u?.current&&(this.z(this.u),this.j?.stop()),this.j?.start(this.w),this.t)if(this.t instanceof $)this.y(this.t,k);else{const I=this.u;I.enqueue(this,k,this.t.length),this.z(I)}this.j?.stop()}hasListeners(){return this.w>0}}e.$Nd=l;const E=()=>new h;e.$Od=E;class h{constructor(){this.i=-1,this.end=0}enqueue(k,I,j){this.i=0,this.end=j,this.current=k,this.value=I}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class i extends l{async fireAsync(k,I,j){if(this.t)for(this.h||(this.h=new M.$2c),u(this.t,U=>this.h.push([U.value,k]));this.h.size>0&&!I.isCancellationRequested;){const[U,z]=this.h.shift(),ne=[],_={...z,token:I,waitUntil:ae=>{if(Object.isFrozen(ne))throw new Error("waitUntil can NOT be called asynchronous");j&&(ae=j(ae,U)),ne.push(ae)}};try{U(_)}catch(ae){(0,S.$1)(ae);continue}Object.freeze(ne),await Promise.allSettled(ne).then(ae=>{for(const se of ae)se.status==="rejected"&&(0,S.$1)(se.reason)})}}}e.$Pd=i;class c extends l{get isPaused(){return this.h!==0}constructor(k){super(k),this.h=0,this.s=new M.$2c,this.A=k?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.A){if(this.s.size>0){const k=Array.from(this.s);this.s.clear(),super.fire(this.A(k))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(k){this.w&&(this.h!==0?this.s.push(k):super.fire(k))}}e.$Qd=c;class o extends c{constructor(k){super(k),this.k=k.delay??100}fire(k){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(k)}}e.$Rd=o;class t extends l{constructor(k){super(k),this.h=[],this.k=k?.merge}fire(k){this.hasListeners()&&(this.h.push(k),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach(I=>super.fire(I)),this.h=[]}))}}e.$Sd=t;class n{constructor(){this.g=!1,this.h=[],this.f=new l({onWillAddFirstListener:()=>this.j(),onDidRemoveLastListener:()=>this.k()})}get event(){return this.f.event}add(k){const I={event:k,listener:null};this.h.push(I),this.g&&this.m(I);const j=()=>{this.g&&this.o(I);const U=this.h.indexOf(I);this.h.splice(U,1)};return(0,s.$Qc)((0,R.$db)(j))}j(){this.g=!0,this.h.forEach(k=>this.m(k))}k(){this.g=!1,this.h.forEach(k=>this.o(k))}m(k){k.listener=k.event(I=>this.f.fire(I))}o(k){k.listener&&k.listener.dispose(),k.listener=null}dispose(){this.f.dispose()}}e.$Td=n;class r{constructor(k,I,j,U){this.f=new s.$Rc;const z=this.f.add(new n),ne=this.f.add(new s.$1c);function _(ae){ne.set(ae,z.add(U(ae)))}for(const ae of k)_(ae);this.f.add(I(ae=>{_(ae)})),this.f.add(j(ae=>{ne.deleteAndDispose(ae)})),this.event=z.event}dispose(){this.f.dispose()}}e.$Ud=r;class p{constructor(){this.f=[]}wrapEvent(k){return(I,j,U)=>k(z=>{const ne=this.f[this.f.length-1];ne?ne.push(()=>I.call(j,z)):I.call(j,z)},void 0,U)}bufferEvents(k){const I=[];this.f.push(I);const j=k();return this.f.pop(),I.forEach(U=>U()),j}}e.$Vd=p;class A{constructor(){this.f=!1,this.g=a.None,this.h=s.$Sc.None,this.j=new l({onDidAddFirstListener:()=>{this.f=!0,this.h=this.g(this.j.fire,this.j)},onDidRemoveLastListener:()=>{this.f=!1,this.h.dispose()}}),this.event=this.j.event}set input(k){this.g=k,this.f&&(this.h.dispose(),this.h=k(this.j.fire,this.j))}dispose(){this.h.dispose(),this.j.dispose()}}e.$Wd=A}),define(te[22],ie([0,1,3]),function(Q,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xd=e.CancellationToken=void 0;const R=Object.freeze(function(P,f){const a=setTimeout(P.bind(f),0);return{dispose(){clearTimeout(a)}}});var s;(function(P){function f(a){return a===P.None||a===P.Cancelled||a instanceof M?!0:!a||typeof a!="object"?!1:typeof a.isCancellationRequested=="boolean"&&typeof a.onCancellationRequested=="function"}P.isCancellationToken=f,P.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:S.Event.None}),P.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:R})})(s||(e.CancellationToken=s={}));class M{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?R:(this.b||(this.b=new S.$Nd),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class D{constructor(f){this.f=void 0,this.g=void 0,this.g=f&&f.onCancellationRequested(this.cancel,this)}get token(){return this.f||(this.f=new M),this.f}cancel(){this.f?this.f instanceof M&&this.f.cancel():this.f=s.Cancelled}dispose(f=!1){f&&this.cancel(),this.g?.dispose(),this.f?this.f instanceof M&&this.f.dispose():this.f=s.None}}e.$Xd=D}),define(te[140],ie([0,1,22]),function(Q,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ye=e.$xe=e.$we=void 0;class R{constructor(P){this.b=P,this.a=null}get(){if(this.a)return this.a;const P=new S.$Xd,f=this.b(P.token);return this.a={promise:f,dispose:()=>{this.a=null,P.cancel(),P.dispose()}},this.a}}e.$we=R;class s{constructor(P){this.c=P,this.a=void 0,this.b=void 0}get(P){const f=JSON.stringify(P);return this.b!==f&&(this.b=f,this.a=this.c(P)),this.a}}e.$xe=s;class M{get cachedValues(){return this.a}constructor(P){this.b=P,this.a=new Map}get(P){if(this.a.has(P))return this.a.get(P);const f=this.b(P);return this.a.set(P,f),f}}e.$ye=M}),define(te[61],ie([0,1,14,2]),function(Q,e,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ae=e.$_d=e.$$d=e.$0d=e.$9d=e.$8d=e.$7d=e.$6d=e.$5d=e.$4d=e.$3d=e.$2d=e.$1d=e.$Zd=e.$Yd=void 0;function s(E){const h=E;return h?typeof h.read=="function":!1}e.$Yd=s;function M(E){const h=E;return h?[h.on,h.pause,h.resume,h.destroy].every(i=>typeof i=="function"):!1}e.$Zd=M;function D(E){const h=E;return h?M(h.stream)&&Array.isArray(h.buffer)&&typeof h.ended=="boolean":!1}e.$1d=D;function P(E,h){return new f(E,h)}e.$2d=P;class f{constructor(h,i){this.e=h,this.f=i,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(h){if(!this.a.destroyed){if(this.a.flowing)this.g(h);else if(this.b.data.push(h),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(i=>this.d.push(i))}}error(h){this.a.destroyed||(this.a.flowing?this.h(h):this.b.error.push(h))}end(h){this.a.destroyed||(typeof h<"u"&&this.write(h),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(h){this.c.data.slice(0).forEach(i=>i(h))}h(h){this.c.error.length===0?(0,S.$1)(h):this.c.error.slice(0).forEach(i=>i(h))}i(){this.c.end.slice(0).forEach(h=>h())}on(h,i){if(!this.a.destroyed)switch(h){case"data":this.c.data.push(i),this.resume();break;case"end":this.c.end.push(i),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(i),this.a.flowing&&this.k();break}}removeListener(h,i){if(this.a.destroyed)return;let c;switch(h){case"data":c=this.c.data;break;case"end":c=this.c.end;break;case"error":c=this.c.error;break}if(c){const o=c.indexOf(i);o>=0&&c.splice(o,1)}}j(){if(this.b.data.length>0){const h=this.e(this.b.data);this.g(h),this.b.data.length=0;const i=[...this.d];this.d.length=0,i.forEach(c=>c())}}k(){if(this.c.error.length>0){for(const h of this.b.error)this.h(h);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function a(E,h){const i=[];let c;for(;(c=E.read())!==null;)i.push(c);return h(i)}e.$3d=a;function g(E,h,i){const c=[];let o;for(;(o=E.read())!==null&&c.length<i;)c.push(o);return o===null&&c.length>0?h(c):{read:()=>{if(c.length>0)return c.shift();if(typeof o<"u"){const t=o;return o=void 0,t}return E.read()}}}e.$4d=g;function w(E,h){return new Promise((i,c)=>{const o=[];y(E,{onData:t=>{h&&o.push(t)},onError:t=>{h?c(t):i(void 0)},onEnd:()=>{i(h?h(o):void 0)}})})}e.$5d=w;function y(E,h,i){E.on("error",c=>{i?.isCancellationRequested||h.onError(c)}),E.on("end",()=>{i?.isCancellationRequested||h.onEnd()}),E.on("data",c=>{i?.isCancellationRequested||h.onData(c)})}e.$6d=y;function d(E,h){return new Promise((i,c)=>{const o=new R.$Rc,t=[],n=A=>{if(t.push(A),t.length>h)return o.dispose(),E.pause(),i({stream:E,buffer:t,ended:!1})},r=A=>(o.dispose(),c(A)),p=()=>(o.dispose(),i({stream:E,buffer:t,ended:!0}));o.add((0,R.$Qc)(()=>E.removeListener("error",r))),E.on("error",r),o.add((0,R.$Qc)(()=>E.removeListener("end",p))),E.on("end",p),o.add((0,R.$Qc)(()=>E.removeListener("data",n))),E.on("data",n)})}e.$7d=d;function v(E,h){const i=P(h);return i.end(E),i}e.$8d=v;function b(){const E=P(()=>{throw new Error("not supported")});return E.end(),E}e.$9d=b;function $(E){let h=!1;return{read:()=>h?null:(h=!0,E)}}e.$0d=$;function m(E,h,i){const c=P(i);return y(E,{onData:o=>c.write(h.data(o)),onError:o=>c.error(h.error?h.error(o):o),onEnd:()=>c.end()}),c}e.$$d=m;function u(E,h,i){let c=!1;return{read:()=>{const o=h.read();return c?o:(c=!0,o!==null?i([E,o]):E)}}}e.$_d=u;function l(E,h,i){let c=!1;const o=P(i);return y(h,{onData:t=>c?o.write(t):(c=!0,o.write(i([E,t]))),onError:t=>o.error(t),onEnd:()=>{c||(c=!0,o.write(E)),o.end()}}),o}e.$ae=l}),define(te[17],ie([0,1,71,61]),function(Q,e,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ve=e.$ue=e.$te=e.$se=e.$re=e.$qe=e.$pe=e.$oe=e.$ne=e.$me=e.$le=e.$ke=e.$je=e.$ie=e.$he=e.$ge=e.$fe=e.$ee=e.$de=e.$ce=e.$be=void 0;const s=typeof Buffer<"u",M=new S.$V(()=>new Uint8Array(256));let D,P;class f{static alloc(I){return s?new f(Buffer.allocUnsafe(I)):new f(new Uint8Array(I))}static wrap(I){return s&&!Buffer.isBuffer(I)&&(I=Buffer.from(I.buffer,I.byteOffset,I.byteLength)),new f(I)}static fromString(I,j){return!(j?.dontUseNodeBuffer||!1)&&s?new f(Buffer.from(I)):(D||(D=new TextEncoder),new f(D.encode(I)))}static fromByteArray(I){const j=f.alloc(I.length);for(let U=0,z=I.length;U<z;U++)j.buffer[U]=I[U];return j}static concat(I,j){if(typeof j>"u"){j=0;for(let ne=0,_=I.length;ne<_;ne++)j+=I[ne].byteLength}const U=f.alloc(j);let z=0;for(let ne=0,_=I.length;ne<_;ne++){const ae=I[ne];U.set(ae,z),z+=ae.byteLength}return U}constructor(I){this.buffer=I,this.byteLength=this.buffer.byteLength}clone(){const I=f.alloc(this.byteLength);return I.set(this),I}toString(){return s?this.buffer.toString():(P||(P=new TextDecoder),P.decode(this.buffer))}slice(I,j){return new f(this.buffer.subarray(I,j))}set(I,j){if(I instanceof f)this.buffer.set(I.buffer,j);else if(I instanceof Uint8Array)this.buffer.set(I,j);else if(I instanceof ArrayBuffer)this.buffer.set(new Uint8Array(I),j);else if(ArrayBuffer.isView(I))this.buffer.set(new Uint8Array(I.buffer,I.byteOffset,I.byteLength),j);else throw new Error("Unknown argument 'array'")}readUInt32BE(I){return y(this.buffer,I)}writeUInt32BE(I,j){d(this.buffer,I,j)}readUInt32LE(I){return v(this.buffer,I)}writeUInt32LE(I,j){b(this.buffer,I,j)}readUInt8(I){return $(this.buffer,I)}writeUInt8(I,j){m(this.buffer,I,j)}indexOf(I,j=0){return a(this.buffer,I instanceof f?I.buffer:I,j)}}e.$be=f;function a(k,I,j=0){const U=I.byteLength,z=k.byteLength;if(U===0)return 0;if(U===1)return k.indexOf(I[0]);if(U>z-j)return-1;const ne=M.value;ne.fill(I.length);for(let oe=0;oe<I.length;oe++)ne[I[oe]]=I.length-oe-1;let _=j+I.length-1,ae=_,se=-1;for(;_<z;)if(k[_]===I[ae]){if(ae===0){se=_;break}_--,ae--}else _+=Math.max(I.length-ae,ne[k[_]]),ae=I.length-1;return se}e.$ce=a;function g(k,I){return k[I+0]<<0>>>0|k[I+1]<<8>>>0}e.$de=g;function w(k,I,j){k[j+0]=I&255,I=I>>>8,k[j+1]=I&255}e.$ee=w;function y(k,I){return k[I]*2**24+k[I+1]*2**16+k[I+2]*2**8+k[I+3]}e.$fe=y;function d(k,I,j){k[j+3]=I,I=I>>>8,k[j+2]=I,I=I>>>8,k[j+1]=I,I=I>>>8,k[j]=I}e.$ge=d;function v(k,I){return k[I+0]<<0>>>0|k[I+1]<<8>>>0|k[I+2]<<16>>>0|k[I+3]<<24>>>0}e.$he=v;function b(k,I,j){k[j+0]=I&255,I=I>>>8,k[j+1]=I&255,I=I>>>8,k[j+2]=I&255,I=I>>>8,k[j+3]=I&255}e.$ie=b;function $(k,I){return k[I]}e.$je=$;function m(k,I,j){k[j]=I}e.$ke=m;function u(k){return R.$3d(k,I=>f.concat(I))}e.$le=u;function l(k){return R.$0d(k)}e.$me=l;function E(k){return R.$5d(k,I=>f.concat(I))}e.$ne=E;async function h(k){return k.ended?f.concat(k.buffer):f.concat([...k.buffer,await E(k.stream)])}e.$oe=h;function i(k){return R.$8d(k,I=>f.concat(I))}e.$pe=i;function c(k){return R.$$d(k,{data:I=>typeof I=="string"?f.fromString(I):f.wrap(I)},I=>f.concat(I))}e.$qe=c;function o(k){return R.$2d(I=>f.concat(I),k)}e.$re=o;function t(k,I){return R.$_d(k,I,j=>f.concat(j))}e.$se=t;function n(k,I){return R.$ae(k,I,j=>f.concat(j))}e.$te=n;function r(k){let I=0,j=0,U=0;const z=new Uint8Array(Math.floor(k.length/4*3)),ne=ae=>{switch(j){case 3:z[U++]=I|ae,j=0;break;case 2:z[U++]=I|ae>>>2,I=ae<<6,j=3;break;case 1:z[U++]=I|ae>>>4,I=ae<<4,j=2;break;default:I=ae<<2,j=1}};for(let ae=0;ae<k.length;ae++){const se=k.charCodeAt(ae);if(se>=65&&se<=90)ne(se-65);else if(se>=97&&se<=122)ne(se-97+26);else if(se>=48&&se<=57)ne(se-48+52);else if(se===43||se===45)ne(62);else if(se===47||se===95)ne(63);else{if(se===61)break;throw new SyntaxError(`Unexpected base64 character ${k[ae]}`)}}const _=U;for(;j>0;)ne(0);return f.wrap(z).slice(0,_)}e.$ue=r;const p="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",A="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function C({buffer:k},I=!0,j=!1){const U=j?A:p;let z="";const ne=k.byteLength%3;let _=0;for(;_<k.byteLength-ne;_+=3){const ae=k[_+0],se=k[_+1],oe=k[_+2];z+=U[ae>>>2],z+=U[(ae<<4|se>>>4)&63],z+=U[(se<<2|oe>>>6)&63],z+=U[oe&63]}if(ne===1){const ae=k[_+0];z+=U[ae>>>2],z+=U[ae<<4&63],I&&(z+="==")}else if(ne===2){const ae=k[_+0],se=k[_+1];z+=U[ae>>>2],z+=U[(ae<<4|se>>>4)&63],z+=U[se<<2&63],I&&(z+="=")}return z}e.$ve=C}),define(te[27],ie([0,1,140,71]),function(Q,e,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xf=e.$wf=e.$vf=e.$uf=e.GraphemeBreakType=e.$tf=e.$sf=e.$rf=e.$qf=e.$pf=e.$of=e.$nf=e.$mf=e.$lf=e.$kf=e.$jf=e.$if=e.$hf=e.$gf=e.$ff=e.$ef=e.$df=e.$cf=e.$bf=e.$af=e.$_e=e.$$e=e.$0e=e.$9e=e.$8e=e.$7e=e.$6e=e.$5e=e.$4e=e.$3e=e.$2e=e.$1e=e.$Ze=e.$Ye=e.$Xe=e.$We=e.$Ve=e.$Ue=e.$Te=e.$Se=e.$Re=e.$Qe=e.$Pe=e.$Oe=e.$Ne=e.$Me=e.$Le=e.$Ke=e.$Je=e.$Ie=e.$He=e.$Ge=e.$Fe=e.$Ee=e.$De=e.$Ce=e.$Be=void 0;function s(x){return!x||typeof x!="string"?!0:x.trim().length===0}e.$Be=s;const M=/{(\d+)}/g;function D(x,...he){return he.length===0?x:x.replace(M,function($e,ve){const Re=parseInt(ve,10);return isNaN(Re)||Re<0||Re>=he.length?$e:he[Re]})}e.$Ce=D;const P=/{([^}]+)}/g;function f(x,he){return x.replace(P,($e,ve)=>he[ve]??$e)}e.$De=f;function a(x){return x.replace(/[<>&]/g,function(he){switch(he){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return he}})}e.$Ee=a;function g(x){return x.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.$Fe=g;function w(x,he){let $e=0;const ve=he.charCodeAt(0);for(let Re=x.length-1;Re>=0;Re--)x.charCodeAt(Re)===ve&&$e++;return $e}e.$Ge=w;function y(x,he,$e="\u2026"){return x.length<=he?x:`${x.substr(0,he)}${$e}`}e.$He=y;function d(x,he=" "){const $e=v(x,he);return b($e,he)}e.$Ie=d;function v(x,he){if(!x||!he)return x;const $e=he.length;if($e===0||x.length===0)return x;let ve=0;for(;x.indexOf(he,ve)===ve;)ve=ve+$e;return x.substring(ve)}e.$Je=v;function b(x,he){if(!x||!he)return x;const $e=he.length,ve=x.length;if($e===0||ve===0)return x;let Re=ve,Fe=-1;for(;Fe=x.lastIndexOf(he,Re-1),!(Fe===-1||Fe+$e!==Re);){if(Fe===0)return"";Re=Fe}return x.substring(0,Re)}e.$Ke=b;function $(x){return x.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.$Le=$;function m(x){return x.replace(/\*/g,"")}e.$Me=m;function u(x,he,$e={}){if(!x)throw new Error("Cannot create regex from empty string");he||(x=g(x)),$e.wholeWord&&(/\B/.test(x.charAt(0))||(x="\\b"+x),/\B/.test(x.charAt(x.length-1))||(x=x+"\\b"));let ve="";return $e.global&&(ve+="g"),$e.matchCase||(ve+="i"),$e.multiline&&(ve+="m"),$e.unicode&&(ve+="u"),new RegExp(x,ve)}e.$Ne=u;function l(x){return x.source==="^"||x.source==="^$"||x.source==="$"||x.source==="^\\s*$"?!1:!!(x.exec("")&&x.lastIndex===0)}e.$Oe=l;function E(x){return x.split(/\r\n|\r|\n/)}e.$Pe=E;function h(x){for(let he=0,$e=x.length;he<$e;he++){const ve=x.charCodeAt(he);if(ve!==32&&ve!==9)return he}return-1}e.$Qe=h;function i(x,he=0,$e=x.length){for(let ve=he;ve<$e;ve++){const Re=x.charCodeAt(ve);if(Re!==32&&Re!==9)return x.substring(he,ve)}return x.substring(he,$e)}e.$Re=i;function c(x,he=x.length-1){for(let $e=he;$e>=0;$e--){const ve=x.charCodeAt($e);if(ve!==32&&ve!==9)return $e}return-1}e.$Se=c;function o(x,he,$e){const ve=[];let Re=0;for(const Fe of x.matchAll(he)){if(ve.push(x.slice(Re,Fe.index)),Fe.index===void 0)throw new Error("match.index should be defined");Re=Fe.index+Fe[0].length,ve.push($e(Fe[0],...Fe.slice(1),Fe.index,x,Fe.groups))}return ve.push(x.slice(Re)),Promise.all(ve).then(Fe=>Fe.join(""))}e.$Te=o;function t(x,he){return x<he?-1:x>he?1:0}e.$Ue=t;function n(x,he,$e=0,ve=x.length,Re=0,Fe=he.length){for(;$e<ve&&Re<Fe;$e++,Re++){const Be=x.charCodeAt($e),He=he.charCodeAt(Re);if(Be<He)return-1;if(Be>He)return 1}const je=ve-$e,Ne=Fe-Re;return je<Ne?-1:je>Ne?1:0}e.$Ve=n;function r(x,he){return p(x,he,0,x.length,0,he.length)}e.$We=r;function p(x,he,$e=0,ve=x.length,Re=0,Fe=he.length){for(;$e<ve&&Re<Fe;$e++,Re++){let Be=x.charCodeAt($e),He=he.charCodeAt(Re);if(Be===He)continue;if(Be>=128||He>=128)return n(x.toLowerCase(),he.toLowerCase(),$e,ve,Re,Fe);C(Be)&&(Be-=32),C(He)&&(He-=32);const Ge=Be-He;if(Ge!==0)return Ge}const je=ve-$e,Ne=Fe-Re;return je<Ne?-1:je>Ne?1:0}e.$Xe=p;function A(x){return x>=48&&x<=57}e.$Ye=A;function C(x){return x>=97&&x<=122}e.$Ze=C;function k(x){return x>=65&&x<=90}e.$1e=k;function I(x,he){return x.length===he.length&&p(x,he)===0}e.$2e=I;function j(x,he){const $e=he.length;return he.length>x.length?!1:p(x,he,0,$e)===0}e.$3e=j;function U(x,he){const $e=Math.min(x.length,he.length);let ve;for(ve=0;ve<$e;ve++)if(x.charCodeAt(ve)!==he.charCodeAt(ve))return ve;return $e}e.$4e=U;function z(x,he){const $e=Math.min(x.length,he.length);let ve;const Re=x.length-1,Fe=he.length-1;for(ve=0;ve<$e;ve++)if(x.charCodeAt(Re-ve)!==he.charCodeAt(Fe-ve))return ve;return $e}e.$5e=z;function ne(x){return 55296<=x&&x<=56319}e.$6e=ne;function _(x){return 56320<=x&&x<=57343}e.$7e=_;function ae(x,he){return(x-55296<<10)+(he-56320)+65536}e.$8e=ae;function se(x,he,$e){const ve=x.charCodeAt($e);if(ne(ve)&&$e+1<he){const Re=x.charCodeAt($e+1);if(_(Re))return ae(ve,Re)}return ve}e.$9e=se;function oe(x,he){const $e=x.charCodeAt(he-1);if(_($e)&&he>1){const ve=x.charCodeAt(he-2);if(ne(ve))return ae(ve,$e)}return $e}class K{get offset(){return this.e}constructor(he,$e=0){this.c=he,this.d=he.length,this.e=$e}setOffset(he){this.e=he}prevCodePoint(){const he=oe(this.c,this.e);return this.e-=he>=65536?2:1,he}nextCodePoint(){const he=se(this.c,this.d,this.e);return this.e+=he>=65536?2:1,he}eol(){return this.e>=this.d}}e.$0e=K;class J{get offset(){return this.c.offset}constructor(he,$e=0){this.c=new K(he,$e)}nextGraphemeLength(){const he=le.getInstance(),$e=this.c,ve=$e.offset;let Re=he.getGraphemeBreakType($e.nextCodePoint());for(;!$e.eol();){const Fe=$e.offset,je=he.getGraphemeBreakType($e.nextCodePoint());if(we(Re,je)){$e.setOffset(Fe);break}Re=je}return $e.offset-ve}prevGraphemeLength(){const he=le.getInstance(),$e=this.c,ve=$e.offset;let Re=he.getGraphemeBreakType($e.prevCodePoint());for(;$e.offset>0;){const Fe=$e.offset,je=he.getGraphemeBreakType($e.prevCodePoint());if(we(je,Re)){$e.setOffset(Fe);break}Re=je}return ve-$e.offset}eol(){return this.c.eol()}}e.$$e=J;function G(x,he){return new J(x,he).nextGraphemeLength()}e.$_e=G;function N(x,he){return new J(x,he).prevGraphemeLength()}e.$af=N;function q(x,he){he>0&&_(x.charCodeAt(he))&&he--;const $e=he+G(x,he);return[$e-N(x,$e),$e]}e.$bf=q;function X(x){const he=new J(x);let $e=0;for(;!he.eol();)$e++,he.nextGraphemeLength();return $e}e.$cf=X;let H;function Y(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function re(x){return H||(H=Y()),H.test(x)}e.$df=re;const F=/^[\t\n\r\x20-\x7E]*$/;function O(x){return F.test(x)}e.$ef=O,e.$ff=/[\u2028\u2029]/;function L(x){return e.$ff.test(x)}e.$gf=L;function B(x){return x>=11904&&x<=55215||x>=63744&&x<=64255||x>=65281&&x<=65374}e.$hf=B;function T(x){return x>=127462&&x<=127487||x===8986||x===8987||x===9200||x===9203||x>=9728&&x<=10175||x===11088||x===11093||x>=127744&&x<=128591||x>=128640&&x<=128764||x>=128992&&x<=129008||x>=129280&&x<=129535||x>=129648&&x<=129782}e.$if=T;function W(x,he){if(x.length<he)return x;const $e=/\b/g;let ve=0;for(;$e.test(x)&&!(x.length-$e.lastIndex<he);)ve=$e.lastIndex,$e.lastIndex+=1;return x.substring(ve).replace(/^\s/,"")}e.$jf=W;const V=/(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~]/g,ce=/\x1b\].*?\x07/g;function de(x){return x&&(x=x.replace(V,"").replace(ce,"")),x}e.$kf=de,e.$lf=String.fromCharCode(65279);function ue(x){return!!(x&&x.length>0&&x.charCodeAt(0)===65279)}e.$mf=ue;function fe(x){return ue(x)?x.substr(1):x}e.$nf=fe;function ye(x,he){if(!x||!he||x.length<he.length)return!1;const $e=he.length,ve=x.toLowerCase();let Re=0,Fe=-1;for(;Re<$e;){const je=ve.indexOf(he[Re],Fe+1);if(je<0)return!1;Fe=je,Re++}return!0}e.$of=ye;function be(x,he=!1){return x?(he&&(x=x.replace(/\\./g,"")),x.toLowerCase()!==x):!1}e.$pf=be;function pe(x){return x.charAt(0).toUpperCase()+x.slice(1)}e.$qf=pe;function Ae(x,he=1){if(he===0)return"";let $e=-1;do $e=x.indexOf(`
`,$e+1),he--;while(he>0&&$e>=0);return $e===-1?x:(x[$e-1]==="\r"&&$e--,x.substr(0,$e))}e.$rf=Ae;function Te(x){return x=x%(2*26),x<26?String.fromCharCode(97+x):String.fromCharCode(65+x-26)}e.$sf=Te;function me(x){return le.getInstance().getGraphemeBreakType(x)}e.$tf=me;function we(x,he){return x===0?he!==5&&he!==7:x===2&&he===3?!1:x===4||x===2||x===3||he===4||he===2||he===3?!0:!(x===8&&(he===8||he===9||he===11||he===12)||(x===11||x===9)&&(he===9||he===10)||(x===12||x===10)&&he===10||he===5||he===13||he===7||x===1||x===13&&he===14||x===6&&he===6)}var Z;(function(x){x[x.Other=0]="Other",x[x.Prepend=1]="Prepend",x[x.CR=2]="CR",x[x.LF=3]="LF",x[x.Control=4]="Control",x[x.Extend=5]="Extend",x[x.Regional_Indicator=6]="Regional_Indicator",x[x.SpacingMark=7]="SpacingMark",x[x.L=8]="L",x[x.V=9]="V",x[x.T=10]="T",x[x.LV=11]="LV",x[x.LVT=12]="LVT",x[x.ZWJ=13]="ZWJ",x[x.Extended_Pictographic=14]="Extended_Pictographic"})(Z||(e.GraphemeBreakType=Z={}));class le{static{this.c=null}static getInstance(){return le.c||(le.c=new le),le.c}constructor(){this.d=ge()}getGraphemeBreakType(he){if(he<32)return he===10?3:he===13?2:4;if(he<127)return 0;const $e=this.d,ve=$e.length/3;let Re=1;for(;Re<=ve;)if(he<$e[3*Re])Re=2*Re;else if(he>$e[3*Re+1])Re=2*Re+1;else return $e[3*Re+2];return 0}}function ge(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Ce(x,he){if(x===0)return 0;const $e=De(x,he);if($e!==void 0)return $e;const ve=new K(he,x);return ve.prevCodePoint(),ve.offset}e.$uf=Ce;function De(x,he){const $e=new K(he,x);let ve=$e.prevCodePoint();for(;Ue(ve)||ve===65039||ve===8419;){if($e.offset===0)return;ve=$e.prevCodePoint()}if(!T(ve))return;let Re=$e.offset;return Re>0&&$e.prevCodePoint()===8205&&(Re=$e.offset),Re}function Ue(x){return 127995<=x&&x<=127999}var Oe;(function(x){x[x.zwj=8205]="zwj",x[x.emojiVariantSelector=65039]="emojiVariantSelector",x[x.enclosingKeyCap=8419]="enclosingKeyCap"})(Oe||(Oe={})),e.$vf="\xA0";class ze{static{this.c=new R.$V(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.d=new S.$xe(he=>{function $e(Ge){const xe=new Map;for(let Ze=0;Ze<Ge.length;Ze+=2)xe.set(Ge[Ze],Ge[Ze+1]);return xe}function ve(Ge,xe){const Ze=new Map(Ge);for(const[it,nt]of xe)Ze.set(it,nt);return Ze}function Re(Ge,xe){if(!Ge)return xe;const Ze=new Map;for(const[it,nt]of Ge)xe.has(it)&&Ze.set(it,nt);return Ze}const Fe=this.c.value;let je=he.filter(Ge=>!Ge.startsWith("_")&&Ge in Fe);je.length===0&&(je=["_default"]);let Ne;for(const Ge of je){const xe=$e(Fe[Ge]);Ne=Re(Ne,xe)}const Be=$e(Fe._common),He=ve(Be,Ne);return new ze(He)})}static getInstance(he){return ze.d.get(Array.from(he))}static{this.e=new R.$V(()=>Object.keys(ze.c.value).filter(he=>!he.startsWith("_")))}static getLocales(){return ze.e.value}constructor(he){this.f=he}isAmbiguous(he){return this.f.has(he)}getPrimaryConfusable(he){return this.f.get(he)}getConfusableCodePoints(){return new Set(this.f.keys())}}e.$wf=ze;class We{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this.d=void 0}static e(){return this.d||(this.d=new Set(We.c())),this.d}static isInvisibleCharacter(he){return We.e().has(he)}static get codePoints(){return We.e()}}e.$xf=We}),define(te[55],ie([0,1,27]),function(Q,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ii=e.$Hi=e.$Gi=e.$Fi=e.$Ei=e.$Di=e.$Ci=void 0;function R(m){return s(m,0)}e.$Ci=R;function s(m,u){switch(typeof m){case"object":return m===null?M(349,u):Array.isArray(m)?f(m,u):a(m,u);case"string":return P(m,u);case"boolean":return D(m,u);case"number":return M(m,u);case"undefined":return M(937,u);default:return M(617,u)}}e.$Di=s;function M(m,u){return(u<<5)-u+m|0}e.$Ei=M;function D(m,u){return M(m?433:863,u)}function P(m,u){u=M(149417,u);for(let l=0,E=m.length;l<E;l++)u=M(m.charCodeAt(l),u);return u}e.$Fi=P;function f(m,u){return u=M(104579,u),m.reduce((l,E)=>s(E,l),u)}function a(m,u){return u=M(181387,u),Object.keys(m).sort().reduce((l,E)=>(l=P(E,l),s(m[E],l)),u)}class g{constructor(){this.g=0}get value(){return this.g}hash(u){return this.g=s(u,this.g),this.g}}e.$Gi=g;var w;(function(m){m[m.BLOCK_SIZE=64]="BLOCK_SIZE",m[m.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(w||(w={}));function y(m,u,l=32){const E=l-u,h=~((1<<E)-1);return(m<<u|(h&m)>>>E)>>>0}function d(m,u=0,l=m.byteLength,E=0){for(let h=0;h<l;h++)m[u+h]=E}function v(m,u,l="0"){for(;m.length<u;)m=l+m;return m}function b(m,u=32){return m instanceof ArrayBuffer?Array.from(new Uint8Array(m)).map(l=>l.toString(16).padStart(2,"0")).join(""):v((m>>>0).toString(16),u/4)}e.$Hi=b;class ${static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(64+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(u){const l=u.length;if(l===0)return;const E=this.p;let h=this.r,i=this.u,c,o;for(i!==0?(c=i,o=-1,i=0):(c=u.charCodeAt(0),o=0);;){let t=c;if(S.$6e(c))if(o+1<l){const n=u.charCodeAt(o+1);S.$7e(n)?(o++,t=S.$8e(c,n)):t=65533}else{i=c;break}else S.$7e(c)&&(t=65533);if(h=this.w(E,h,t),o++,o<l)c=u.charCodeAt(o);else break}this.r=h,this.u=i}w(u,l,E){return E<128?u[l++]=E:E<2048?(u[l++]=192|(E&1984)>>>6,u[l++]=128|(E&63)>>>0):E<65536?(u[l++]=224|(E&61440)>>>12,u[l++]=128|(E&4032)>>>6,u[l++]=128|(E&63)>>>0):(u[l++]=240|(E&1835008)>>>18,u[l++]=128|(E&258048)>>>12,u[l++]=128|(E&4032)>>>6,u[l++]=128|(E&63)>>>0),l>=64&&(this.y(),l-=64,this.t+=64,u[0]=u[64+0],u[1]=u[64+1],u[2]=u[64+2]),l}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),b(this.h)+b(this.l)+b(this.m)+b(this.n)+b(this.o)}x(){this.p[this.r++]=128,d(this.p,this.r),this.r>56&&(this.y(),d(this.p));const u=8*this.t;this.q.setUint32(56,Math.floor(u/4294967296),!1),this.q.setUint32(60,u%4294967296,!1),this.y()}y(){const u=$.g,l=this.q;for(let p=0;p<64;p+=4)u.setUint32(p,l.getUint32(p,!1),!1);for(let p=64;p<320;p+=4)u.setUint32(p,y(u.getUint32(p-12,!1)^u.getUint32(p-32,!1)^u.getUint32(p-56,!1)^u.getUint32(p-64,!1),1),!1);let E=this.h,h=this.l,i=this.m,c=this.n,o=this.o,t,n,r;for(let p=0;p<80;p++)p<20?(t=h&i|~h&c,n=1518500249):p<40?(t=h^i^c,n=1859775393):p<60?(t=h&i|h&c|i&c,n=2400959708):(t=h^i^c,n=3395469782),r=y(E,5)+t+o+n+u.getUint32(p*4,!1)&4294967295,o=c,c=i,i=y(h,30),h=E,E=r;this.h=this.h+E&4294967295,this.l=this.l+h&4294967295,this.m=this.m+i&4294967295,this.n=this.n+c&4294967295,this.o=this.o+o&4294967295}}e.$Ii=$}),define(te[73],ie([0,1,27]),function(Q,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var R;(function(s){s[s.Ignore=0]="Ignore",s[s.Info=1]="Info",s[s.Warning=2]="Warning",s[s.Error=3]="Error"})(R||(R={})),function(s){const M="error",D="warning",P="warn",f="info",a="ignore";function g(y){return y?S.$2e(M,y)?s.Error:S.$2e(D,y)||S.$2e(P,y)?s.Warning:S.$2e(f,y)?s.Info:s.Ignore:s.Ignore}s.fromValue=g;function w(y){switch(y){case s.Error:return M;case s.Warning:return D;case s.Info:return f;default:return a}}s.toString=w}(R||(R={})),e.default=R}),define(te[141],ie([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kd=void 0,e.$Kd=Symbol("MicrotaskDelay")}),define(te[56],ie([0,1,23,27]),function(Q,e,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uh=e.$Th=e.$Sh=e.$Rh=e.$Qh=void 0;class s{constructor(){this.b="",this.c=0}reset(d){return this.b=d,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(d){const v=d.charCodeAt(0),b=this.b.charCodeAt(this.c);return v-b}value(){return this.b[this.c]}}e.$Qh=s;class M{constructor(d=!0){this.e=d}reset(d){return this.b=d,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let d=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(d)this.c++;else break;else d=!1;return this}cmp(d){return this.e?(0,R.$Ve)(d,this.b,0,d.length,this.c,this.d):(0,R.$Xe)(d,this.b,0,d.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$Rh=M;class D{constructor(d=!0,v=!0){this.f=d,this.g=v}reset(d){this.d=0,this.e=0,this.b=d,this.c=d.length;for(let v=d.length-1;v>=0;v--,this.c--){const b=this.b.charCodeAt(v);if(!(b===47||this.f&&b===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let d=!0;for(;this.e<this.c;this.e++){const v=this.b.charCodeAt(this.e);if(v===47||this.f&&v===92)if(d)this.d++;else break;else d=!1}return this}cmp(d){return this.g?(0,R.$Ve)(d,this.b,0,d.length,this.d,this.e):(0,R.$Xe)(d,this.b,0,d.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$Sh=D;var P;(function(y){y[y.Scheme=1]="Scheme",y[y.Authority=2]="Authority",y[y.Path=3]="Path",y[y.Query=4]="Query",y[y.Fragment=5]="Fragment"})(P||(P={}));class f{constructor(d,v){this.f=d,this.g=v,this.d=[],this.e=0}reset(d){return this.c=d,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new D(!1,!this.f(d)),this.b.reset(d.path),this.b.value()&&this.d.push(3)),this.g(d)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(d){if(this.d[this.e]===1)return(0,R.$We)(d,this.c.scheme);if(this.d[this.e]===2)return(0,R.$We)(d,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(d);if(this.d[this.e]===4)return(0,R.$Ue)(d,this.c.query);if(this.d[this.e]===5)return(0,R.$Ue)(d,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.$Th=f;class a{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const d=this.right;return this.right=d.left,d.left=this,this.updateHeight(),d.updateHeight(),d}rotateRight(){const d=this.left;return this.left=d.right,d.right=this,this.updateHeight(),d.updateHeight(),d}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var g;(function(y){y[y.Left=-1]="Left",y[y.Mid=0]="Mid",y[y.Right=1]="Right"})(g||(g={}));class w{static forUris(d=()=>!1,v=()=>!1){return new w(new f(d,v))}static forPaths(d=!1){return new w(new D(void 0,!d))}static forStrings(){return new w(new s)}static forConfigKeys(){return new w(new M)}constructor(d){this.b=d}clear(){this.c=void 0}fill(d,v){if(v){const b=v.slice(0);(0,S.$Xb)(b);for(const $ of b)this.set($,d)}else{const b=d.slice(0);(0,S.$Xb)(b);for(const $ of b)this.set($[0],$[1])}}set(d,v){const b=this.b.reset(d);let $;this.c||(this.c=new a,this.c.segment=b.value());const m=[];for($=this.c;;){const l=b.cmp($.segment);if(l>0)$.left||($.left=new a,$.left.segment=b.value()),m.push([-1,$]),$=$.left;else if(l<0)$.right||($.right=new a,$.right.segment=b.value()),m.push([1,$]),$=$.right;else if(b.hasNext())b.next(),$.mid||($.mid=new a,$.mid.segment=b.value()),m.push([0,$]),$=$.mid;else break}const u=$.value;$.value=v,$.key=d;for(let l=m.length-1;l>=0;l--){const E=m[l][1];E.updateHeight();const h=E.balanceFactor();if(h<-1||h>1){const i=m[l][0],c=m[l+1][0];if(i===1&&c===1)m[l][1]=E.rotateLeft();else if(i===-1&&c===-1)m[l][1]=E.rotateRight();else if(i===1&&c===-1)E.right=m[l+1][1]=m[l+1][1].rotateRight(),m[l][1]=E.rotateLeft();else if(i===-1&&c===1)E.left=m[l+1][1]=m[l+1][1].rotateLeft(),m[l][1]=E.rotateRight();else throw new Error;if(l>0)switch(m[l-1][0]){case-1:m[l-1][1].left=m[l][1];break;case 1:m[l-1][1].right=m[l][1];break;case 0:m[l-1][1].mid=m[l][1];break}else this.c=m[0][1]}}return u}get(d){return this.d(d)?.value}d(d){const v=this.b.reset(d);let b=this.c;for(;b;){const $=v.cmp(b.segment);if($>0)b=b.left;else if($<0)b=b.right;else if(v.hasNext())v.next(),b=b.mid;else break}return b}has(d){const v=this.d(d);return!(v?.value===void 0&&v?.mid===void 0)}delete(d){return this.e(d,!1)}deleteSuperstr(d){return this.e(d,!0)}e(d,v){const b=this.b.reset(d),$=[];let m=this.c;for(;m;){const u=b.cmp(m.segment);if(u>0)$.push([-1,m]),m=m.left;else if(u<0)$.push([1,m]),m=m.right;else if(b.hasNext())b.next(),$.push([0,m]),m=m.mid;else break}if(m){if(v?(m.left=void 0,m.mid=void 0,m.right=void 0,m.height=1):(m.key=void 0,m.value=void 0),!m.mid&&!m.value)if(m.left&&m.right){const u=this.f(m.right);if(u.key){const{key:l,value:E,segment:h}=u;this.e(u.key,!1),m.key=l,m.value=E,m.segment=h}}else{const u=m.left??m.right;if($.length>0){const[l,E]=$[$.length-1];switch(l){case-1:E.left=u;break;case 0:E.mid=u;break;case 1:E.right=u;break}}else this.c=u}for(let u=$.length-1;u>=0;u--){const l=$[u][1];l.updateHeight();const E=l.balanceFactor();if(E>1?(l.right.balanceFactor()>=0||(l.right=l.right.rotateRight()),$[u][1]=l.rotateLeft()):E<-1&&(l.left.balanceFactor()<=0||(l.left=l.left.rotateLeft()),$[u][1]=l.rotateRight()),u>0)switch($[u-1][0]){case-1:$[u-1][1].left=$[u][1];break;case 1:$[u-1][1].right=$[u][1];break;case 0:$[u-1][1].mid=$[u][1];break}else this.c=$[0][1]}}}f(d){for(;d.left;)d=d.left;return d}findSubstr(d){const v=this.b.reset(d);let b=this.c,$;for(;b;){const m=v.cmp(b.segment);if(m>0)b=b.left;else if(m<0)b=b.right;else if(v.hasNext())v.next(),$=b.value||$,b=b.mid;else break}return b&&b.value||$}findSuperstr(d){return this.g(d,!1)}g(d,v){const b=this.b.reset(d);let $=this.c;for(;$;){const m=b.cmp($.segment);if(m>0)$=$.left;else if(m<0)$=$.right;else if(b.hasNext())b.next(),$=$.mid;else return $.mid?this.h($.mid):v?$.value:void 0}}hasElementOrSubtree(d){return this.g(d,!0)!==void 0}forEach(d){for(const[v,b]of this)d(b,v)}*[Symbol.iterator](){yield*this.h(this.c)}h(d){const v=[];return this.j(d,v),v[Symbol.iterator]()}j(d,v){d&&(d.left&&this.j(d.left,v),d.value&&v.push([d.key,d.value]),d.mid&&this.j(d.mid,v),d.right&&this.j(d.right,v))}_isBalanced(){const d=v=>{if(!v)return!0;const b=v.balanceFactor();return b<-1||b>1?!1:d(v.left)&&d(v.right)};return d(this.c)}}e.$Uh=w}),define(te[12],ie([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pf=e.$Of=e.$Nf=e.$Mf=e.$Lf=e.$Kf=e.$Jf=e.$If=e.$Hf=e.$Gf=e.$Ff=e.$Ef=e.$Df=e.$Cf=e.$Bf=e.$Af=e.$zf=e.$yf=void 0;function S(h){return typeof h=="string"}e.$yf=S;function R(h){return Array.isArray(h)&&h.every(i=>S(i))}e.$zf=R;function s(h){return typeof h=="object"&&h!==null&&!Array.isArray(h)&&!(h instanceof RegExp)&&!(h instanceof Date)}e.$Af=s;function M(h){const i=Object.getPrototypeOf(Uint8Array);return typeof h=="object"&&h instanceof i}e.$Bf=M;function D(h){return typeof h=="number"&&!isNaN(h)}e.$Cf=D;function P(h){return!!h&&typeof h[Symbol.iterator]=="function"}e.$Df=P;function f(h){return h===!0||h===!1}e.$Ef=f;function a(h){return typeof h>"u"}e.$Ff=a;function g(h){return!w(h)}e.$Gf=g;function w(h){return a(h)||h===null}e.$Hf=w;function y(h,i){if(!h)throw new Error(i?`Unexpected type, expected '${i}'`:"Unexpected type")}e.$If=y;function d(h){if(w(h))throw new Error("Assertion Failed: argument is undefined or null");return h}e.$Jf=d;function v(...h){const i=[];for(let c=0;c<h.length;c++){const o=h[c];if(w(o))throw new Error(`Assertion Failed: argument at index ${c} is undefined or null`);i.push(o)}return i}e.$Kf=v;const b=Object.prototype.hasOwnProperty;function $(h){if(!s(h))return!1;for(const i in h)if(b.call(h,i))return!1;return!0}e.$Lf=$;function m(h){return typeof h=="function"}e.$Mf=m;function u(...h){return h.length>0&&h.every(m)}e.$Nf=u;function l(h,i){const c=Math.min(h.length,i.length);for(let o=0;o<c;o++)E(h[o],i[o])}e.$Of=l;function E(h,i){if(S(i)){if(typeof h!==i)throw new Error(`argument does not match constraint: typeof ${i}`)}else if(m(i)){try{if(h instanceof i)return}catch{}if(!w(h)&&h.constructor===i||i.length===1&&i.call(void 0,h)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.$Pf=E}),define(te[74],ie([0,1,12]),function(Q,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tj=e.$Sj=e.$Rj=void 0;const R=Object.create(null);function s(P,f){if((0,S.$yf)(f)){const a=R[f];if(a===void 0)throw new Error(`${P} references an unknown codicon: ${f}`);f=a}return R[P]=f,{id:P}}function M(){return R}e.$Rj=M;function D(){return Object.values(e.$Tj)}e.$Sj=D,e.$Tj={add:s("add",6e4),plus:s("plus",6e4),gistNew:s("gist-new",6e4),repoCreate:s("repo-create",6e4),lightbulb:s("lightbulb",60001),lightBulb:s("light-bulb",60001),repo:s("repo",60002),repoDelete:s("repo-delete",60002),gistFork:s("gist-fork",60003),repoForked:s("repo-forked",60003),gitPullRequest:s("git-pull-request",60004),gitPullRequestAbandoned:s("git-pull-request-abandoned",60004),recordKeys:s("record-keys",60005),keyboard:s("keyboard",60005),tag:s("tag",60006),tagAdd:s("tag-add",60006),tagRemove:s("tag-remove",60006),gitPullRequestLabel:s("git-pull-request-label",60006),person:s("person",60007),personFollow:s("person-follow",60007),personOutline:s("person-outline",60007),personFilled:s("person-filled",60007),gitBranch:s("git-branch",60008),gitBranchCreate:s("git-branch-create",60008),gitBranchDelete:s("git-branch-delete",60008),sourceControl:s("source-control",60008),mirror:s("mirror",60009),mirrorPublic:s("mirror-public",60009),star:s("star",60010),starAdd:s("star-add",60010),starDelete:s("star-delete",60010),starEmpty:s("star-empty",60010),comment:s("comment",60011),commentAdd:s("comment-add",60011),alert:s("alert",60012),warning:s("warning",60012),search:s("search",60013),searchSave:s("search-save",60013),logOut:s("log-out",60014),signOut:s("sign-out",60014),logIn:s("log-in",60015),signIn:s("sign-in",60015),eye:s("eye",60016),eyeUnwatch:s("eye-unwatch",60016),eyeWatch:s("eye-watch",60016),circleFilled:s("circle-filled",60017),primitiveDot:s("primitive-dot",60017),closeDirty:s("close-dirty",60017),debugBreakpoint:s("debug-breakpoint",60017),debugBreakpointDisabled:s("debug-breakpoint-disabled",60017),debugHint:s("debug-hint",60017),primitiveSquare:s("primitive-square",60018),edit:s("edit",60019),pencil:s("pencil",60019),info:s("info",60020),issueOpened:s("issue-opened",60020),gistPrivate:s("gist-private",60021),gitForkPrivate:s("git-fork-private",60021),lock:s("lock",60021),mirrorPrivate:s("mirror-private",60021),close:s("close",60022),removeClose:s("remove-close",60022),x:s("x",60022),repoSync:s("repo-sync",60023),sync:s("sync",60023),clone:s("clone",60024),desktopDownload:s("desktop-download",60024),beaker:s("beaker",60025),microscope:s("microscope",60025),vm:s("vm",60026),deviceDesktop:s("device-desktop",60026),file:s("file",60027),fileText:s("file-text",60027),more:s("more",60028),ellipsis:s("ellipsis",60028),kebabHorizontal:s("kebab-horizontal",60028),mailReply:s("mail-reply",60029),reply:s("reply",60029),organization:s("organization",60030),organizationFilled:s("organization-filled",60030),organizationOutline:s("organization-outline",60030),newFile:s("new-file",60031),fileAdd:s("file-add",60031),newFolder:s("new-folder",60032),fileDirectoryCreate:s("file-directory-create",60032),trash:s("trash",60033),trashcan:s("trashcan",60033),history:s("history",60034),clock:s("clock",60034),folder:s("folder",60035),fileDirectory:s("file-directory",60035),symbolFolder:s("symbol-folder",60035),logoGithub:s("logo-github",60036),markGithub:s("mark-github",60036),github:s("github",60036),terminal:s("terminal",60037),console:s("console",60037),repl:s("repl",60037),zap:s("zap",60038),symbolEvent:s("symbol-event",60038),error:s("error",60039),stop:s("stop",60039),variable:s("variable",60040),symbolVariable:s("symbol-variable",60040),array:s("array",60042),symbolArray:s("symbol-array",60042),symbolModule:s("symbol-module",60043),symbolPackage:s("symbol-package",60043),symbolNamespace:s("symbol-namespace",60043),symbolObject:s("symbol-object",60043),symbolMethod:s("symbol-method",60044),symbolFunction:s("symbol-function",60044),symbolConstructor:s("symbol-constructor",60044),symbolBoolean:s("symbol-boolean",60047),symbolNull:s("symbol-null",60047),symbolNumeric:s("symbol-numeric",60048),symbolNumber:s("symbol-number",60048),symbolStructure:s("symbol-structure",60049),symbolStruct:s("symbol-struct",60049),symbolParameter:s("symbol-parameter",60050),symbolTypeParameter:s("symbol-type-parameter",60050),symbolKey:s("symbol-key",60051),symbolText:s("symbol-text",60051),symbolReference:s("symbol-reference",60052),goToFile:s("go-to-file",60052),symbolEnum:s("symbol-enum",60053),symbolValue:s("symbol-value",60053),symbolRuler:s("symbol-ruler",60054),symbolUnit:s("symbol-unit",60054),activateBreakpoints:s("activate-breakpoints",60055),archive:s("archive",60056),arrowBoth:s("arrow-both",60057),arrowDown:s("arrow-down",60058),arrowLeft:s("arrow-left",60059),arrowRight:s("arrow-right",60060),arrowSmallDown:s("arrow-small-down",60061),arrowSmallLeft:s("arrow-small-left",60062),arrowSmallRight:s("arrow-small-right",60063),arrowSmallUp:s("arrow-small-up",60064),arrowUp:s("arrow-up",60065),bell:s("bell",60066),bold:s("bold",60067),book:s("book",60068),bookmark:s("bookmark",60069),debugBreakpointConditionalUnverified:s("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:s("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:s("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:s("debug-breakpoint-data-unverified",60072),debugBreakpointData:s("debug-breakpoint-data",60073),debugBreakpointDataDisabled:s("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:s("debug-breakpoint-log-unverified",60074),debugBreakpointLog:s("debug-breakpoint-log",60075),debugBreakpointLogDisabled:s("debug-breakpoint-log-disabled",60075),briefcase:s("briefcase",60076),broadcast:s("broadcast",60077),browser:s("browser",60078),bug:s("bug",60079),calendar:s("calendar",60080),caseSensitive:s("case-sensitive",60081),check:s("check",60082),checklist:s("checklist",60083),chevronDown:s("chevron-down",60084),dropDownButton:s("drop-down-button",60084),chevronLeft:s("chevron-left",60085),chevronRight:s("chevron-right",60086),chevronUp:s("chevron-up",60087),chromeClose:s("chrome-close",60088),chromeMaximize:s("chrome-maximize",60089),chromeMinimize:s("chrome-minimize",60090),chromeRestore:s("chrome-restore",60091),circle:s("circle",60092),circleOutline:s("circle-outline",60092),debugBreakpointUnverified:s("debug-breakpoint-unverified",60092),circleSlash:s("circle-slash",60093),circuitBoard:s("circuit-board",60094),clearAll:s("clear-all",60095),clippy:s("clippy",60096),closeAll:s("close-all",60097),cloudDownload:s("cloud-download",60098),cloudUpload:s("cloud-upload",60099),code:s("code",60100),collapseAll:s("collapse-all",60101),colorMode:s("color-mode",60102),commentDiscussion:s("comment-discussion",60103),compareChanges:s("compare-changes",60157),creditCard:s("credit-card",60105),dash:s("dash",60108),dashboard:s("dashboard",60109),database:s("database",60110),debugContinue:s("debug-continue",60111),debugDisconnect:s("debug-disconnect",60112),debugPause:s("debug-pause",60113),debugRestart:s("debug-restart",60114),debugStart:s("debug-start",60115),debugStepInto:s("debug-step-into",60116),debugStepOut:s("debug-step-out",60117),debugStepOver:s("debug-step-over",60118),debugStop:s("debug-stop",60119),debug:s("debug",60120),deviceCameraVideo:s("device-camera-video",60121),deviceCamera:s("device-camera",60122),deviceMobile:s("device-mobile",60123),diffAdded:s("diff-added",60124),diffIgnored:s("diff-ignored",60125),diffModified:s("diff-modified",60126),diffRemoved:s("diff-removed",60127),diffRenamed:s("diff-renamed",60128),diff:s("diff",60129),discard:s("discard",60130),editorLayout:s("editor-layout",60131),emptyWindow:s("empty-window",60132),exclude:s("exclude",60133),extensions:s("extensions",60134),eyeClosed:s("eye-closed",60135),fileBinary:s("file-binary",60136),fileCode:s("file-code",60137),fileMedia:s("file-media",60138),filePdf:s("file-pdf",60139),fileSubmodule:s("file-submodule",60140),fileSymlinkDirectory:s("file-symlink-directory",60141),fileSymlinkFile:s("file-symlink-file",60142),fileZip:s("file-zip",60143),files:s("files",60144),filter:s("filter",60145),flame:s("flame",60146),foldDown:s("fold-down",60147),foldUp:s("fold-up",60148),fold:s("fold",60149),folderActive:s("folder-active",60150),folderOpened:s("folder-opened",60151),gear:s("gear",60152),gift:s("gift",60153),gistSecret:s("gist-secret",60154),gist:s("gist",60155),gitCommit:s("git-commit",60156),gitCompare:s("git-compare",60157),gitMerge:s("git-merge",60158),githubAction:s("github-action",60159),githubAlt:s("github-alt",60160),globe:s("globe",60161),grabber:s("grabber",60162),graph:s("graph",60163),gripper:s("gripper",60164),heart:s("heart",60165),home:s("home",60166),horizontalRule:s("horizontal-rule",60167),hubot:s("hubot",60168),inbox:s("inbox",60169),issueClosed:s("issue-closed",60324),issueReopened:s("issue-reopened",60171),issues:s("issues",60172),italic:s("italic",60173),jersey:s("jersey",60174),json:s("json",60175),bracket:s("bracket",60175),kebabVertical:s("kebab-vertical",60176),key:s("key",60177),law:s("law",60178),lightbulbAutofix:s("lightbulb-autofix",60179),linkExternal:s("link-external",60180),link:s("link",60181),listOrdered:s("list-ordered",60182),listUnordered:s("list-unordered",60183),liveShare:s("live-share",60184),loading:s("loading",60185),location:s("location",60186),mailRead:s("mail-read",60187),mail:s("mail",60188),markdown:s("markdown",60189),megaphone:s("megaphone",60190),mention:s("mention",60191),milestone:s("milestone",60192),gitPullRequestMilestone:s("git-pull-request-milestone",60192),mortarBoard:s("mortar-board",60193),move:s("move",60194),multipleWindows:s("multiple-windows",60195),mute:s("mute",60196),noNewline:s("no-newline",60197),note:s("note",60198),octoface:s("octoface",60199),openPreview:s("open-preview",60200),package:s("package",60201),paintcan:s("paintcan",60202),pin:s("pin",60203),play:s("play",60204),run:s("run",60204),plug:s("plug",60205),preserveCase:s("preserve-case",60206),preview:s("preview",60207),project:s("project",60208),pulse:s("pulse",60209),question:s("question",60210),quote:s("quote",60211),radioTower:s("radio-tower",60212),reactions:s("reactions",60213),references:s("references",60214),refresh:s("refresh",60215),regex:s("regex",60216),remoteExplorer:s("remote-explorer",60217),remote:s("remote",60218),remove:s("remove",60219),replaceAll:s("replace-all",60220),replace:s("replace",60221),repoClone:s("repo-clone",60222),repoForcePush:s("repo-force-push",60223),repoPull:s("repo-pull",60224),repoPush:s("repo-push",60225),report:s("report",60226),requestChanges:s("request-changes",60227),rocket:s("rocket",60228),rootFolderOpened:s("root-folder-opened",60229),rootFolder:s("root-folder",60230),rss:s("rss",60231),ruby:s("ruby",60232),saveAll:s("save-all",60233),saveAs:s("save-as",60234),save:s("save",60235),screenFull:s("screen-full",60236),screenNormal:s("screen-normal",60237),searchStop:s("search-stop",60238),server:s("server",60240),settingsGear:s("settings-gear",60241),settings:s("settings",60242),shield:s("shield",60243),smiley:s("smiley",60244),sortPrecedence:s("sort-precedence",60245),splitHorizontal:s("split-horizontal",60246),splitVertical:s("split-vertical",60247),squirrel:s("squirrel",60248),starFull:s("star-full",60249),starHalf:s("star-half",60250),symbolClass:s("symbol-class",60251),symbolColor:s("symbol-color",60252),symbolCustomColor:s("symbol-customcolor",60252),symbolConstant:s("symbol-constant",60253),symbolEnumMember:s("symbol-enum-member",60254),symbolField:s("symbol-field",60255),symbolFile:s("symbol-file",60256),symbolInterface:s("symbol-interface",60257),symbolKeyword:s("symbol-keyword",60258),symbolMisc:s("symbol-misc",60259),symbolOperator:s("symbol-operator",60260),symbolProperty:s("symbol-property",60261),wrench:s("wrench",60261),wrenchSubaction:s("wrench-subaction",60261),symbolSnippet:s("symbol-snippet",60262),tasklist:s("tasklist",60263),telescope:s("telescope",60264),textSize:s("text-size",60265),threeBars:s("three-bars",60266),thumbsdown:s("thumbsdown",60267),thumbsup:s("thumbsup",60268),tools:s("tools",60269),triangleDown:s("triangle-down",60270),triangleLeft:s("triangle-left",60271),triangleRight:s("triangle-right",60272),triangleUp:s("triangle-up",60273),twitter:s("twitter",60274),unfold:s("unfold",60275),unlock:s("unlock",60276),unmute:s("unmute",60277),unverified:s("unverified",60278),verified:s("verified",60279),versions:s("versions",60280),vmActive:s("vm-active",60281),vmOutline:s("vm-outline",60282),vmRunning:s("vm-running",60283),watch:s("watch",60284),whitespace:s("whitespace",60285),wholeWord:s("whole-word",60286),window:s("window",60287),wordWrap:s("word-wrap",60288),zoomIn:s("zoom-in",60289),zoomOut:s("zoom-out",60290),listFilter:s("list-filter",60291),listFlat:s("list-flat",60292),listSelection:s("list-selection",60293),selection:s("selection",60293),listTree:s("list-tree",60294),debugBreakpointFunctionUnverified:s("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:s("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:s("debug-breakpoint-function-disabled",60296),debugStackframeActive:s("debug-stackframe-active",60297),circleSmallFilled:s("circle-small-filled",60298),debugStackframeDot:s("debug-stackframe-dot",60298),debugStackframe:s("debug-stackframe",60299),debugStackframeFocused:s("debug-stackframe-focused",60299),debugBreakpointUnsupported:s("debug-breakpoint-unsupported",60300),symbolString:s("symbol-string",60301),debugReverseContinue:s("debug-reverse-continue",60302),debugStepBack:s("debug-step-back",60303),debugRestartFrame:s("debug-restart-frame",60304),callIncoming:s("call-incoming",60306),callOutgoing:s("call-outgoing",60307),menu:s("menu",60308),expandAll:s("expand-all",60309),feedback:s("feedback",60310),gitPullRequestReviewer:s("git-pull-request-reviewer",60310),groupByRefType:s("group-by-ref-type",60311),ungroupByRefType:s("ungroup-by-ref-type",60312),account:s("account",60313),gitPullRequestAssignee:s("git-pull-request-assignee",60313),bellDot:s("bell-dot",60314),debugConsole:s("debug-console",60315),library:s("library",60316),output:s("output",60317),runAll:s("run-all",60318),syncIgnored:s("sync-ignored",60319),pinned:s("pinned",60320),githubInverted:s("github-inverted",60321),debugAlt:s("debug-alt",60305),serverProcess:s("server-process",60322),serverEnvironment:s("server-environment",60323),pass:s("pass",60324),stopCircle:s("stop-circle",60325),playCircle:s("play-circle",60326),record:s("record",60327),debugAltSmall:s("debug-alt-small",60328),vmConnect:s("vm-connect",60329),cloud:s("cloud",60330),merge:s("merge",60331),exportIcon:s("export",60332),graphLeft:s("graph-left",60333),magnet:s("magnet",60334),notebook:s("notebook",60335),redo:s("redo",60336),checkAll:s("check-all",60337),pinnedDirty:s("pinned-dirty",60338),passFilled:s("pass-filled",60339),circleLargeFilled:s("circle-large-filled",60340),circleLarge:s("circle-large",60341),circleLargeOutline:s("circle-large-outline",60341),combine:s("combine",60342),gather:s("gather",60342),table:s("table",60343),variableGroup:s("variable-group",60344),typeHierarchy:s("type-hierarchy",60345),typeHierarchySub:s("type-hierarchy-sub",60346),typeHierarchySuper:s("type-hierarchy-super",60347),gitPullRequestCreate:s("git-pull-request-create",60348),runAbove:s("run-above",60349),runBelow:s("run-below",60350),notebookTemplate:s("notebook-template",60351),debugRerun:s("debug-rerun",60352),workspaceTrusted:s("workspace-trusted",60353),workspaceUntrusted:s("workspace-untrusted",60354),workspaceUnspecified:s("workspace-unspecified",60355),terminalCmd:s("terminal-cmd",60356),terminalDebian:s("terminal-debian",60357),terminalLinux:s("terminal-linux",60358),terminalPowershell:s("terminal-powershell",60359),terminalTmux:s("terminal-tmux",60360),terminalUbuntu:s("terminal-ubuntu",60361),terminalBash:s("terminal-bash",60362),arrowSwap:s("arrow-swap",60363),copy:s("copy",60364),personAdd:s("person-add",60365),filterFilled:s("filter-filled",60366),wand:s("wand",60367),debugLineByLine:s("debug-line-by-line",60368),inspect:s("inspect",60369),layers:s("layers",60370),layersDot:s("layers-dot",60371),layersActive:s("layers-active",60372),compass:s("compass",60373),compassDot:s("compass-dot",60374),compassActive:s("compass-active",60375),azure:s("azure",60376),issueDraft:s("issue-draft",60377),gitPullRequestClosed:s("git-pull-request-closed",60378),gitPullRequestDraft:s("git-pull-request-draft",60379),debugAll:s("debug-all",60380),debugCoverage:s("debug-coverage",60381),runErrors:s("run-errors",60382),folderLibrary:s("folder-library",60383),debugContinueSmall:s("debug-continue-small",60384),beakerStop:s("beaker-stop",60385),graphLine:s("graph-line",60386),graphScatter:s("graph-scatter",60387),pieChart:s("pie-chart",60388),bracketDot:s("bracket-dot",60389),bracketError:s("bracket-error",60390),lockSmall:s("lock-small",60391),azureDevops:s("azure-devops",60392),verifiedFilled:s("verified-filled",60393),newLine:s("newline",60394),layout:s("layout",60395),layoutActivitybarLeft:s("layout-activitybar-left",60396),layoutActivitybarRight:s("layout-activitybar-right",60397),layoutPanelLeft:s("layout-panel-left",60398),layoutPanelCenter:s("layout-panel-center",60399),layoutPanelJustify:s("layout-panel-justify",60400),layoutPanelRight:s("layout-panel-right",60401),layoutPanel:s("layout-panel",60402),layoutSidebarLeft:s("layout-sidebar-left",60403),layoutSidebarRight:s("layout-sidebar-right",60404),layoutStatusbar:s("layout-statusbar",60405),layoutMenubar:s("layout-menubar",60406),layoutCentered:s("layout-centered",60407),layoutSidebarRightOff:s("layout-sidebar-right-off",60416),layoutPanelOff:s("layout-panel-off",60417),layoutSidebarLeftOff:s("layout-sidebar-left-off",60418),target:s("target",60408),indent:s("indent",60409),recordSmall:s("record-small",60410),errorSmall:s("error-small",60411),arrowCircleDown:s("arrow-circle-down",60412),arrowCircleLeft:s("arrow-circle-left",60413),arrowCircleRight:s("arrow-circle-right",60414),arrowCircleUp:s("arrow-circle-up",60415),heartFilled:s("heart-filled",60420),map:s("map",60421),mapFilled:s("map-filled",60422),circleSmall:s("circle-small",60423),bellSlash:s("bell-slash",60424),bellSlashDot:s("bell-slash-dot",60425),commentUnresolved:s("comment-unresolved",60426),gitPullRequestGoToChanges:s("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:s("git-pull-request-new-changes",60428),searchFuzzy:s("search-fuzzy",60429),commentDraft:s("comment-draft",60430),send:s("send",60431),sparkle:s("sparkle",60432),insert:s("insert",60433),mic:s("mic",60434),dialogError:s("dialog-error","error"),dialogWarning:s("dialog-warning","warning"),dialogInfo:s("dialog-info","info"),dialogClose:s("dialog-close","close"),treeItemExpanded:s("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:s("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:s("tree-filter-on-type-off","list-selection"),treeFilterClear:s("tree-filter-clear","close"),treeItemLoading:s("tree-item-loading","loading"),menuSelection:s("menu-selection","check"),menuSubmenu:s("menu-submenu","chevron-right"),menuBarMore:s("menubar-more","more"),scrollbarButtonLeft:s("scrollbar-button-left","triangle-left"),scrollbarButtonRight:s("scrollbar-button-right","triangle-right"),scrollbarButtonUp:s("scrollbar-button-up","triangle-up"),scrollbarButtonDown:s("scrollbar-button-down","triangle-down"),toolBarMore:s("toolbar-more","more"),quickInputBack:s("quick-input-back","arrow-left")}}),define(te[37],ie([0,1,12]),function(Q,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cn=e.$bn=e.$an=e.$_m=e.$$m=e.$0m=e.$9m=e.$8m=e.$7m=e.$6m=e.$5m=e.$4m=void 0;function R(m){if(!m||typeof m!="object"||m instanceof RegExp)return m;const u=Array.isArray(m)?[]:{};return Object.entries(m).forEach(([l,E])=>{u[l]=E&&typeof E=="object"?R(E):E}),u}e.$4m=R;function s(m){if(!m||typeof m!="object")return m;const u=[m];for(;u.length>0;){const l=u.shift();Object.freeze(l);for(const E in l)if(M.call(l,E)){const h=l[E];typeof h=="object"&&!Object.isFrozen(h)&&!(0,S.$Bf)(h)&&u.push(h)}}return m}e.$5m=s;const M=Object.prototype.hasOwnProperty;function D(m,u){return P(m,u,new Set)}e.$6m=D;function P(m,u,l){if((0,S.$Hf)(m))return m;const E=u(m);if(typeof E<"u")return E;if(Array.isArray(m)){const h=[];for(const i of m)h.push(P(i,u,l));return h}if((0,S.$Af)(m)){if(l.has(m))throw new Error("Cannot clone recursive data-structure");l.add(m);const h={};for(const i in m)M.call(m,i)&&(h[i]=P(m[i],u,l));return l.delete(m),h}return m}function f(m,u,l=!0){return(0,S.$Af)(m)?((0,S.$Af)(u)&&Object.keys(u).forEach(E=>{E in m?l&&((0,S.$Af)(m[E])&&(0,S.$Af)(u[E])?f(m[E],u[E],l):m[E]=u[E]):m[E]=u[E]}),m):u}e.$7m=f;function a(m,u){if(m===u)return!0;if(m==null||u===null||u===void 0||typeof m!=typeof u||typeof m!="object"||Array.isArray(m)!==Array.isArray(u))return!1;let l,E;if(Array.isArray(m)){if(m.length!==u.length)return!1;for(l=0;l<m.length;l++)if(!a(m[l],u[l]))return!1}else{const h=[];for(E in m)h.push(E);h.sort();const i=[];for(E in u)i.push(E);if(i.sort(),!a(h,i))return!1;for(l=0;l<h.length;l++)if(!a(m[h[l]],u[h[l]]))return!1}return!0}e.$8m=a;function g(m){const u=new Set;return JSON.stringify(m,(l,E)=>{if((0,S.$Af)(E)||Array.isArray(E)){if(u.has(E))return"[Circular]";u.add(E)}return E})}e.$9m=g;function w(m,u){const l=Object.create(null);return!m||!u||Object.keys(u).forEach(h=>{const i=m[h],c=u[h];a(i,c)||(l[h]=c)}),l}e.$0m=w;function y(m,u){const l=u.toLowerCase(),E=Object.keys(m).find(h=>h.toLowerCase()===l);return E?m[E]:m[u]}e.$$m=y;function d(m,u){const l=Object.create(null);for(const[E,h]of Object.entries(m))u(E,h)&&(l[E]=h);return l}e.$_m=d;function v(m){let u=[];for(;Object.prototype!==m;)u=u.concat(Object.getOwnPropertyNames(m)),m=Object.getPrototypeOf(m);return u}e.$an=v;function b(m){const u=[];for(const l of v(m))typeof m[l]=="function"&&u.push(l);return u}e.$bn=b;function $(m,u){const l=h=>function(){const i=Array.prototype.slice.call(arguments,0);return u(h,i)},E={};for(const h of m)E[h]=l(h);return E}e.$cn=$}),define(te[102],ie([0,1,74]),function(Q,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.$Uj=e.ThemeColor=void 0;var R;(function(D){function P(f){return f&&typeof f=="object"&&typeof f.id=="string"}D.isThemeColor=P})(R||(e.ThemeColor=R={}));function s(D){return{id:D}}e.$Uj=s;var M;(function(D){D.iconNameSegment="[A-Za-z0-9]+",D.iconNameExpression="[A-Za-z0-9-]+",D.iconModifierExpression="~[A-Za-z]+",D.iconNameCharacter="[A-Za-z0-9~-]";const P=new RegExp(`^(${D.iconNameExpression})(${D.iconModifierExpression})?$`);function f(u){const l=P.exec(u.id);if(!l)return f(S.$Tj.error);const[,E,h]=l,i=["codicon","codicon-"+E];return h&&i.push("codicon-modifier-"+h.substring(1)),i}D.asClassNameArray=f;function a(u){return f(u).join(" ")}D.asClassName=a;function g(u){return"."+f(u).join(".")}D.asCSSSelector=g;function w(u){return u&&typeof u=="object"&&typeof u.id=="string"&&(typeof u.color>"u"||R.isThemeColor(u.color))}D.isThemeIcon=w;const y=new RegExp(`^\\$\\((${D.iconNameExpression}(?:${D.iconModifierExpression})?)\\)$`);function d(u){const l=y.exec(u);if(!l)return;const[,E]=l;return{id:E}}D.fromString=d;function v(u){return{id:u}}D.fromId=v;function b(u,l){let E=u.id;const h=E.lastIndexOf("~");return h!==-1&&(E=E.substring(0,h)),l&&(E=`${E}~${l}`),{id:E}}D.modify=b;function $(u){const l=u.id.lastIndexOf("~");if(l!==-1)return u.id.substring(l+1)}D.getModifier=$;function m(u,l){return u.id===l.id&&u.color?.id===l.color?.id}D.isEqual=m})(M||(e.ThemeIcon=M={}))}),define(te[32],ie([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eg=e.$dg=void 0;const S=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function R(s){return S.test(s)}e.$dg=R,e.$eg=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let s;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?s=crypto.getRandomValues.bind(crypto):s=function(P){for(let f=0;f<P.length;f++)P[f]=Math.floor(Math.random()*256);return P};const M=new Uint8Array(16),D=[];for(let P=0;P<256;P++)D.push(P.toString(16).padStart(2,"0"));return function(){s(M),M[6]=M[6]&15|64,M[8]=M[8]&63|128;let f=0,a="";return a+=D[M[f++]],a+=D[M[f++]],a+=D[M[f++]],a+=D[M[f++]],a+="-",a+=D[M[f++]],a+=D[M[f++]],a+="-",a+=D[M[f++]],a+=D[M[f++]],a+="-",a+=D[M[f++]],a+=D[M[f++]],a+="-",a+=D[M[f++]],a+=D[M[f++]],a+=D[M[f++]],a+=D[M[f++]],a+=D[M[f++]],a+=D[M[f++]],a}}()}),define(te[142],ie([0,1,85,45,83]),function(Q,e,S,R,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_S=void 0;async function M(D,P){if(await new Promise((g,w)=>{const y=R.createReadStream(D),d=S.createHash("sha1");y.pipe(d);const v=(0,s.$db)((b,$)=>{y.removeAllListeners(),d.removeAllListeners(),b?w(b):g($)});y.once("error",v),y.once("end",v),d.once("error",v),d.once("data",b=>v(void 0,b.toString("hex")))})!==P)throw new Error("Hash mismatch")}e.$_S=M}),define(te[143],ie([0,1,28]),function(Q,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Om=void 0;const R=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function s(D){const P=D.replace(/\-/g,":").toLowerCase();return!R.has(P)}function M(){const D=(0,S.networkInterfaces)();for(const P in D){const f=D[P];if(f){for(const{mac:a}of f)if(s(a))return a}}throw new Error("Unable to retrieve mac address (unexpected format)")}e.$Om=M}),define(te[86],ie([0,1,28,56,32,143]),function(Q,e,S,R,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qm=e.$Pm=void 0,e.$Pm=new class{c(a){return this.a||(this.a=R.$Uh.forStrings(),this.a.set("00-50-56",!0),this.a.set("00-0C-29",!0),this.a.set("00-05-69",!0),this.a.set("00-03-FF",!0),this.a.set("00-1C-42",!0),this.a.set("00-16-3E",!0),this.a.set("08-00-27",!0),this.a.set("00:50:56",!0),this.a.set("00:0C:29",!0),this.a.set("00:05:69",!0),this.a.set("00:03:FF",!0),this.a.set("00:1C:42",!0),this.a.set("00:16:3E",!0),this.a.set("08:00:27",!0)),!!this.a.findSubstr(a)}value(){if(this.b===void 0){let a=0,g=0;const w=(0,S.networkInterfaces)();for(const y in w){const d=w[y];if(d)for(const{mac:v,internal:b}of d)b||(g+=1,this.c(v.toUpperCase())&&(a+=1))}this.b=g>0?a/g:0}return this.b}};let D;async function P(a){return D||(D=(async()=>await f(a)||s.$eg())()),D}e.$Qm=P;async function f(a){try{const g=await new Promise((y,d)=>{Q(["crypto"],y,d)}),w=(0,M.$Om)();return g.createHash("sha256").update(w,"utf8").digest("hex")}catch(g){a(g);return}}}),define(te[103],ie([0,1,87]),function(Q,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ig=e.$hg=e.$gg=void 0;function R(P,f,a,g=1){let w=!1;return new Promise(y=>{const d=setTimeout(()=>{if(!w)return w=!0,y(0)},a);s(P,f,g,v=>{if(!w)return w=!0,clearTimeout(d),y(v)})})}e.$gg=R;function s(P,f,a,g){if(f===0)return g(0);const w=new S.Socket;w.once("connect",()=>(D(w),s(P+a,f-1,a,g))),w.once("data",()=>{}),w.once("error",y=>(D(w),y.code!=="ECONNREFUSED"?s(P+a,f-1,a,g):g(P))),w.connect(P,"127.0.0.1")}e.$hg={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function M(P,f,a,g="127.0.0.1"){let w=!1,y,d=1;const v=S.createServer({pauseOnConnect:!0});function b($,m){w||(w=!0,v.removeAllListeners(),v.close(),y&&clearTimeout(y),m($))}return new Promise($=>{y=setTimeout(()=>{b(0,$)},a),v.on("listening",()=>{b(P,$)}),v.on("error",m=>{m&&(m.code==="EADDRINUSE"||m.code==="EACCES")&&d<f?(P++,d++,v.listen(P,g)):b(0,$)}),v.on("close",()=>{b(0,$)}),v.listen(P,g)})}e.$ig=M;function D(P){try{P.removeAllListeners("connect"),P.removeAllListeners("error"),P.end(),P.destroy(),P.unref()}catch(f){console.error(f)}}}),function(){function Q(){function e(){return process.uncHostAllowlist}function S(f){const a=new Set;if(Array.isArray(f))for(const g of f)typeof g=="string"&&a.add(g);return Array.from(a)}function R(){const f=e();return f?Array.from(f):[]}function s(f){if(process.platform!=="win32")return;const a=e();if(a)if(typeof f=="string")a.add(f.toLowerCase());else for(const g of S(f))s(g)}function M(f){if(typeof f!="string")return;const a=["\\\\.\\UNC\\","\\\\?\\UNC\\","\\\\"];let g;for(const w of a){if(f.indexOf(w)!==0)continue;const d=f.indexOf("\\",w.length);if(d===-1)continue;const v=f.substring(w.length,d);if(v){g=v;break}}return g}function D(){process.platform==="win32"&&(process.restrictUNCAccess=!1)}function P(){return process.platform!=="win32"?!0:process.restrictUNCAccess===!1}return{getUNCHostAllowlist:R,addUNCHostToAllowlist:s,getUNCHost:M,disableUNCAccessRestrictions:D,isUNCAccessRestrictionsDisabled:P}}typeof define=="function"?define("vs/base/node/unc",[],function(){return Q()}):typeof module=="object"&&typeof module.exports=="object"?module.exports=Q():console.trace("vs/base/node/unc defined in UNKNOWN context (neither requirejs or commonjs)")}(),define(te[144],ie([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dT=e.$cT=void 0,e.$cT="vscode:contextmenu",e.$dT="vscode:onCloseContextMenu"}),define(te[145],ie([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kT=void 0;class S{constructor(s,M){this.a=s,this.onMessage=M}send(s){try{this.a.send("vscode:message",s.buffer)}catch{}}disconnect(){this.a.send("vscode:disconnect",null)}}e.$kT=S}),define(te[146],ie([11,10]),function(Q,e){return Q.create("vs/base/common/date",e)}),define(te[147],ie([0,1,146]),function(Q,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cm=e.$bm=void 0;const R=60,s=R*60,M=s*24,D=M*7,P=M*30,f=M*365;function a(w,y,d,v){typeof w!="number"&&(w=w.getTime());const b=Math.round((new Date().getTime()-w)/1e3);if(b<-30)return(0,S.localize)(0,null,a(new Date().getTime()+b*1e3,!1));if(!v&&b<30)return(0,S.localize)(1,null);let $;return b<R?($=b,y?$===1?d?(0,S.localize)(2,null,$):(0,S.localize)(3,null,$):d?(0,S.localize)(4,null,$):(0,S.localize)(5,null,$):$===1?d?(0,S.localize)(6,null,$):(0,S.localize)(7,null,$):d?(0,S.localize)(8,null,$):(0,S.localize)(9,null,$)):b<s?($=Math.floor(b/R),y?$===1?d?(0,S.localize)(10,null,$):(0,S.localize)(11,null,$):d?(0,S.localize)(12,null,$):(0,S.localize)(13,null,$):$===1?d?(0,S.localize)(14,null,$):(0,S.localize)(15,null,$):d?(0,S.localize)(16,null,$):(0,S.localize)(17,null,$)):b<M?($=Math.floor(b/s),y?$===1?d?(0,S.localize)(18,null,$):(0,S.localize)(19,null,$):d?(0,S.localize)(20,null,$):(0,S.localize)(21,null,$):$===1?d?(0,S.localize)(22,null,$):(0,S.localize)(23,null,$):d?(0,S.localize)(24,null,$):(0,S.localize)(25,null,$)):b<D?($=Math.floor(b/M),y?$===1?(0,S.localize)(26,null,$):(0,S.localize)(27,null,$):$===1?(0,S.localize)(28,null,$):(0,S.localize)(29,null,$)):b<P?($=Math.floor(b/D),y?$===1?d?(0,S.localize)(30,null,$):(0,S.localize)(31,null,$):d?(0,S.localize)(32,null,$):(0,S.localize)(33,null,$):$===1?d?(0,S.localize)(34,null,$):(0,S.localize)(35,null,$):d?(0,S.localize)(36,null,$):(0,S.localize)(37,null,$)):b<f?($=Math.floor(b/P),y?$===1?d?(0,S.localize)(38,null,$):(0,S.localize)(39,null,$):d?(0,S.localize)(40,null,$):(0,S.localize)(41,null,$):$===1?d?(0,S.localize)(42,null,$):(0,S.localize)(43,null,$):d?(0,S.localize)(44,null,$):(0,S.localize)(45,null,$)):($=Math.floor(b/f),y?$===1?d?(0,S.localize)(46,null,$):(0,S.localize)(47,null,$):d?(0,S.localize)(48,null,$):(0,S.localize)(49,null,$):$===1?d?(0,S.localize)(50,null,$):(0,S.localize)(51,null,$):d?(0,S.localize)(52,null,$):(0,S.localize)(53,null,$))}e.$bm=a;function g(w){return w.getFullYear()+"-"+String(w.getMonth()+1).padStart(2,"0")+"-"+String(w.getDate()).padStart(2,"0")+"T"+String(w.getHours()).padStart(2,"0")+":"+String(w.getMinutes()).padStart(2,"0")+":"+String(w.getSeconds()).padStart(2,"0")+"."+(w.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.$cm=g}),define(te[148],ie([11,10]),function(Q,e){return Q.create("vs/base/common/errorMessage",e)}),define(te[49],ie([0,1,23,12,148]),function(Q,e,S,R,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bi=e.$Ai=e.$zi=void 0;function M(w,y){return y&&(w.stack||w.stacktrace)?s.localize(0,null,P(w),D(w.stack)||D(w.stacktrace)):P(w)}function D(w){return Array.isArray(w)?w.join(`
`):w}function P(w){return w.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${w.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof w.code=="string"&&typeof w.errno=="number"&&typeof w.syscall=="string"?s.localize(1,null,w.message):w.message||s.localize(2,null)}function f(w=null,y=!1){if(!w)return s.localize(3,null);if(Array.isArray(w)){const d=S.$Hb(w),v=f(d[0],y);return d.length>1?s.localize(4,null,v,d.length):v}if(R.$yf(w))return w;if(w.detail){const d=w.detail;if(d.error)return M(d.error,y);if(d.exception)return M(d.exception,y)}return w.stack?M(w,y):w.message?w.message:s.localize(5,null)}e.$zi=f;function a(w){const y=w;return y instanceof Error&&Array.isArray(y.actions)}e.$Ai=a;function g(w,y){let d;return typeof w=="string"?d=new Error(w):d=w,d.actions=y,d}e.$Bi=g}),define(te[149],ie([11,10]),function(Q,e){return Q.create("vs/base/common/jsonErrorMessages",e)}),define(te[150],ie([0,1,149]),function(Q,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$up=void 0;function R(s){switch(s){case 1:return(0,S.localize)(0,null);case 2:return(0,S.localize)(1,null);case 3:return(0,S.localize)(2,null);case 4:return(0,S.localize)(3,null);case 5:return(0,S.localize)(4,null);case 6:return(0,S.localize)(5,null);case 7:return(0,S.localize)(6,null);case 8:return(0,S.localize)(7,null);case 9:return(0,S.localize)(8,null);default:return""}}e.$up=R}),define(te[151],ie([11,10]),function(Q,e){return Q.create("vs/base/common/platform",e)}),define(te[4],ie([0,1,151]),function(Q,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$I=e.$H=e.$G=e.$F=e.$E=e.$D=e.OS=e.OperatingSystem=e.$B=e.$A=e.$z=e.$y=e.$x=e.Language=e.$w=e.$v=e.$u=e.$t=e.$s=e.$r=e.$q=e.$p=e.$o=e.$n=e.$m=e.$l=e.$k=e.$j=e.$i=e.Platform=e.$h=e.$g=void 0,e.$g="en";let R=!1,s=!1,M=!1,D=!1,P=!1,f=!1,a=!1,g=!1,w=!1,y=!1,d,v=e.$g,b=e.$g,$,m;e.$h=typeof self=="object"?self:typeof global=="object"?global:{};let u;typeof e.$h.vscode<"u"&&typeof e.$h.vscode.process<"u"?u=e.$h.vscode.process:typeof process<"u"&&(u=process);const l=typeof u?.versions?.electron=="string",E=l&&u?.type==="renderer";if(typeof navigator=="object"&&!E)m=navigator.userAgent,R=m.indexOf("Windows")>=0,s=m.indexOf("Macintosh")>=0,g=(m.indexOf("Macintosh")>=0||m.indexOf("iPad")>=0||m.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,M=m.indexOf("Linux")>=0,y=m?.indexOf("Mobi")>=0,f=!0,d=S.getConfiguredDefaultLocale(S.localize(0,null))||e.$g,v=d,b=navigator.language;else if(typeof u=="object"){R=u.platform==="win32",s=u.platform==="darwin",M=u.platform==="linux",D=M&&!!u.env.SNAP&&!!u.env.SNAP_REVISION,a=l,w=!!u.env.CI||!!u.env.BUILD_ARTIFACTSTAGINGDIRECTORY,d=e.$g,v=e.$g;const A=u.env.VSCODE_NLS_CONFIG;if(A)try{const C=JSON.parse(A),k=C.availableLanguages["*"];d=C.locale,b=C.osLocale,v=k||e.$g,$=C._translationsConfigFile}catch{}P=!0}else console.error("Unable to resolve platform.");var h;(function(A){A[A.Web=0]="Web",A[A.Mac=1]="Mac",A[A.Linux=2]="Linux",A[A.Windows=3]="Windows"})(h||(e.Platform=h={}));function i(A){switch(A){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.$i=i;let c=0;s?c=1:R?c=3:M&&(c=2),e.$j=R,e.$k=s,e.$l=M,e.$m=D,e.$n=P,e.$o=a,e.$p=f,e.$q=f&&typeof e.$h.importScripts=="function",e.$r=g,e.$s=y,e.$t=w,e.$u=c,e.$v=m,e.$w=v;var o;(function(A){function C(){return e.$w}A.value=C;function k(){return e.$w.length===2?e.$w==="en":e.$w.length>=3?e.$w[0]==="e"&&e.$w[1]==="n"&&e.$w[2]==="-":!1}A.isDefaultVariant=k;function I(){return e.$w==="en"}A.isDefault=I})(o||(e.Language=o={})),e.$x=d,e.$y=b,e.$z=$,e.$A=typeof e.$h.postMessage=="function"&&!e.$h.importScripts,e.$B=(()=>{if(e.$A){const A=[];e.$h.addEventListener("message",k=>{if(k.data&&k.data.vscodeScheduleAsyncWork)for(let I=0,j=A.length;I<j;I++){const U=A[I];if(U.id===k.data.vscodeScheduleAsyncWork){A.splice(I,1),U.callback();return}}});let C=0;return k=>{const I=++C;A.push({id:I,callback:k}),e.$h.postMessage({vscodeScheduleAsyncWork:I},"*")}}return A=>setTimeout(A)})();var t;(function(A){A[A.Windows=1]="Windows",A[A.Macintosh=2]="Macintosh",A[A.Linux=3]="Linux"})(t||(e.OperatingSystem=t={})),e.OS=s||g?2:R?1:3;let n=!0,r=!1;function p(){if(!r){r=!0;const A=new Uint8Array(2);A[0]=1,A[1]=2,n=new Uint16Array(A.buffer)[0]===(2<<8)+1}return n}e.$D=p,e.$E=!!(e.$v&&e.$v.indexOf("Chrome")>=0),e.$F=!!(e.$v&&e.$v.indexOf("Firefox")>=0),e.$G=!!(!e.$E&&e.$v&&e.$v.indexOf("Safari")>=0),e.$H=!!(e.$v&&e.$v.indexOf("Edg/")>=0),e.$I=!!(e.$v&&e.$v.indexOf("Android")>=0)}),define(te[35],ie([0,1,4]),function(Q,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ec=e.$dc=e.env=e.cwd=void 0;let R;if(typeof S.$h.vscode<"u"&&typeof S.$h.vscode.process<"u"){const s=S.$h.vscode.process;R={get platform(){return s.platform},get arch(){return s.arch},get env(){return s.env},cwd(){return s.cwd()}}}else typeof process<"u"?R={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:R={get platform(){return S.$j?"win32":S.$k?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=R.cwd,e.env=R.env,e.$dc=R.platform,e.$ec=R.arch}),define(te[9],ie([0,1,35]),function(Q,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tc=e.sep=e.$rc=e.$qc=e.$pc=e.$oc=e.$nc=e.$mc=e.$lc=e.$kc=e.$jc=e.$ic=e.$hc=e.$gc=e.$fc=void 0;const R=65,s=97,M=90,D=122,P=46,f=47,a=92,g=58,w=63;class y extends Error{constructor(c,o,t){let n;typeof o=="string"&&o.indexOf("not ")===0?(n="must not be",o=o.replace(/^not /,"")):n="must be";const r=c.indexOf(".")!==-1?"property":"argument";let p=`The "${c}" ${r} ${n} of type ${o}`;p+=`. Received type ${typeof t}`,super(p),this.code="ERR_INVALID_ARG_TYPE"}}function d(i,c){if(i===null||typeof i!="object")throw new y(c,"Object",i)}function v(i,c){if(typeof i!="string")throw new y(c,"string",i)}const b=S.$dc==="win32";function $(i){return i===f||i===a}function m(i){return i===f}function u(i){return i>=R&&i<=M||i>=s&&i<=D}function l(i,c,o,t){let n="",r=0,p=-1,A=0,C=0;for(let k=0;k<=i.length;++k){if(k<i.length)C=i.charCodeAt(k);else{if(t(C))break;C=f}if(t(C)){if(!(p===k-1||A===1))if(A===2){if(n.length<2||r!==2||n.charCodeAt(n.length-1)!==P||n.charCodeAt(n.length-2)!==P){if(n.length>2){const I=n.lastIndexOf(o);I===-1?(n="",r=0):(n=n.slice(0,I),r=n.length-1-n.lastIndexOf(o)),p=k,A=0;continue}else if(n.length!==0){n="",r=0,p=k,A=0;continue}}c&&(n+=n.length>0?`${o}..`:"..",r=2)}else n.length>0?n+=`${o}${i.slice(p+1,k)}`:n=i.slice(p+1,k),r=k-p-1;p=k,A=0}else C===P&&A!==-1?++A:A=-1}return n}function E(i,c){d(c,"pathObject");const o=c.dir||c.root,t=c.base||`${c.name||""}${c.ext||""}`;return o?o===c.root?`${o}${t}`:`${o}${i}${t}`:t}e.$fc={resolve(...i){let c="",o="",t=!1;for(let n=i.length-1;n>=-1;n--){let r;if(n>=0){if(r=i[n],v(r,"path"),r.length===0)continue}else c.length===0?r=S.cwd():(r=S.env[`=${c}`]||S.cwd(),(r===void 0||r.slice(0,2).toLowerCase()!==c.toLowerCase()&&r.charCodeAt(2)===a)&&(r=`${c}\\`));const p=r.length;let A=0,C="",k=!1;const I=r.charCodeAt(0);if(p===1)$(I)&&(A=1,k=!0);else if($(I))if(k=!0,$(r.charCodeAt(1))){let j=2,U=j;for(;j<p&&!$(r.charCodeAt(j));)j++;if(j<p&&j!==U){const z=r.slice(U,j);for(U=j;j<p&&$(r.charCodeAt(j));)j++;if(j<p&&j!==U){for(U=j;j<p&&!$(r.charCodeAt(j));)j++;(j===p||j!==U)&&(C=`\\\\${z}\\${r.slice(U,j)}`,A=j)}}}else A=1;else u(I)&&r.charCodeAt(1)===g&&(C=r.slice(0,2),A=2,p>2&&$(r.charCodeAt(2))&&(k=!0,A=3));if(C.length>0)if(c.length>0){if(C.toLowerCase()!==c.toLowerCase())continue}else c=C;if(t){if(c.length>0)break}else if(o=`${r.slice(A)}\\${o}`,t=k,k&&c.length>0)break}return o=l(o,!t,"\\",$),t?`${c}\\${o}`:`${c}${o}`||"."},normalize(i){v(i,"path");const c=i.length;if(c===0)return".";let o=0,t,n=!1;const r=i.charCodeAt(0);if(c===1)return m(r)?"\\":i;if($(r))if(n=!0,$(i.charCodeAt(1))){let A=2,C=A;for(;A<c&&!$(i.charCodeAt(A));)A++;if(A<c&&A!==C){const k=i.slice(C,A);for(C=A;A<c&&$(i.charCodeAt(A));)A++;if(A<c&&A!==C){for(C=A;A<c&&!$(i.charCodeAt(A));)A++;if(A===c)return`\\\\${k}\\${i.slice(C)}\\`;A!==C&&(t=`\\\\${k}\\${i.slice(C,A)}`,o=A)}}}else o=1;else u(r)&&i.charCodeAt(1)===g&&(t=i.slice(0,2),o=2,c>2&&$(i.charCodeAt(2))&&(n=!0,o=3));let p=o<c?l(i.slice(o),!n,"\\",$):"";return p.length===0&&!n&&(p="."),p.length>0&&$(i.charCodeAt(c-1))&&(p+="\\"),t===void 0?n?`\\${p}`:p:n?`${t}\\${p}`:`${t}${p}`},isAbsolute(i){v(i,"path");const c=i.length;if(c===0)return!1;const o=i.charCodeAt(0);return $(o)||c>2&&u(o)&&i.charCodeAt(1)===g&&$(i.charCodeAt(2))},join(...i){if(i.length===0)return".";let c,o;for(let r=0;r<i.length;++r){const p=i[r];v(p,"path"),p.length>0&&(c===void 0?c=o=p:c+=`\\${p}`)}if(c===void 0)return".";let t=!0,n=0;if(typeof o=="string"&&$(o.charCodeAt(0))){++n;const r=o.length;r>1&&$(o.charCodeAt(1))&&(++n,r>2&&($(o.charCodeAt(2))?++n:t=!1))}if(t){for(;n<c.length&&$(c.charCodeAt(n));)n++;n>=2&&(c=`\\${c.slice(n)}`)}return e.$fc.normalize(c)},relative(i,c){if(v(i,"from"),v(c,"to"),i===c)return"";const o=e.$fc.resolve(i),t=e.$fc.resolve(c);if(o===t||(i=o.toLowerCase(),c=t.toLowerCase(),i===c))return"";let n=0;for(;n<i.length&&i.charCodeAt(n)===a;)n++;let r=i.length;for(;r-1>n&&i.charCodeAt(r-1)===a;)r--;const p=r-n;let A=0;for(;A<c.length&&c.charCodeAt(A)===a;)A++;let C=c.length;for(;C-1>A&&c.charCodeAt(C-1)===a;)C--;const k=C-A,I=p<k?p:k;let j=-1,U=0;for(;U<I;U++){const ne=i.charCodeAt(n+U);if(ne!==c.charCodeAt(A+U))break;ne===a&&(j=U)}if(U!==I){if(j===-1)return t}else{if(k>I){if(c.charCodeAt(A+U)===a)return t.slice(A+U+1);if(U===2)return t.slice(A+U)}p>I&&(i.charCodeAt(n+U)===a?j=U:U===2&&(j=3)),j===-1&&(j=0)}let z="";for(U=n+j+1;U<=r;++U)(U===r||i.charCodeAt(U)===a)&&(z+=z.length===0?"..":"\\..");return A+=j,z.length>0?`${z}${t.slice(A,C)}`:(t.charCodeAt(A)===a&&++A,t.slice(A,C))},toNamespacedPath(i){if(typeof i!="string"||i.length===0)return i;const c=e.$fc.resolve(i);if(c.length<=2)return i;if(c.charCodeAt(0)===a){if(c.charCodeAt(1)===a){const o=c.charCodeAt(2);if(o!==w&&o!==P)return`\\\\?\\UNC\\${c.slice(2)}`}}else if(u(c.charCodeAt(0))&&c.charCodeAt(1)===g&&c.charCodeAt(2)===a)return`\\\\?\\${c}`;return i},dirname(i){v(i,"path");const c=i.length;if(c===0)return".";let o=-1,t=0;const n=i.charCodeAt(0);if(c===1)return $(n)?i:".";if($(n)){if(o=t=1,$(i.charCodeAt(1))){let A=2,C=A;for(;A<c&&!$(i.charCodeAt(A));)A++;if(A<c&&A!==C){for(C=A;A<c&&$(i.charCodeAt(A));)A++;if(A<c&&A!==C){for(C=A;A<c&&!$(i.charCodeAt(A));)A++;if(A===c)return i;A!==C&&(o=t=A+1)}}}}else u(n)&&i.charCodeAt(1)===g&&(o=c>2&&$(i.charCodeAt(2))?3:2,t=o);let r=-1,p=!0;for(let A=c-1;A>=t;--A)if($(i.charCodeAt(A))){if(!p){r=A;break}}else p=!1;if(r===-1){if(o===-1)return".";r=o}return i.slice(0,r)},basename(i,c){c!==void 0&&v(c,"ext"),v(i,"path");let o=0,t=-1,n=!0,r;if(i.length>=2&&u(i.charCodeAt(0))&&i.charCodeAt(1)===g&&(o=2),c!==void 0&&c.length>0&&c.length<=i.length){if(c===i)return"";let p=c.length-1,A=-1;for(r=i.length-1;r>=o;--r){const C=i.charCodeAt(r);if($(C)){if(!n){o=r+1;break}}else A===-1&&(n=!1,A=r+1),p>=0&&(C===c.charCodeAt(p)?--p===-1&&(t=r):(p=-1,t=A))}return o===t?t=A:t===-1&&(t=i.length),i.slice(o,t)}for(r=i.length-1;r>=o;--r)if($(i.charCodeAt(r))){if(!n){o=r+1;break}}else t===-1&&(n=!1,t=r+1);return t===-1?"":i.slice(o,t)},extname(i){v(i,"path");let c=0,o=-1,t=0,n=-1,r=!0,p=0;i.length>=2&&i.charCodeAt(1)===g&&u(i.charCodeAt(0))&&(c=t=2);for(let A=i.length-1;A>=c;--A){const C=i.charCodeAt(A);if($(C)){if(!r){t=A+1;break}continue}n===-1&&(r=!1,n=A+1),C===P?o===-1?o=A:p!==1&&(p=1):o!==-1&&(p=-1)}return o===-1||n===-1||p===0||p===1&&o===n-1&&o===t+1?"":i.slice(o,n)},format:E.bind(null,"\\"),parse(i){v(i,"path");const c={root:"",dir:"",base:"",ext:"",name:""};if(i.length===0)return c;const o=i.length;let t=0,n=i.charCodeAt(0);if(o===1)return $(n)?(c.root=c.dir=i,c):(c.base=c.name=i,c);if($(n)){if(t=1,$(i.charCodeAt(1))){let j=2,U=j;for(;j<o&&!$(i.charCodeAt(j));)j++;if(j<o&&j!==U){for(U=j;j<o&&$(i.charCodeAt(j));)j++;if(j<o&&j!==U){for(U=j;j<o&&!$(i.charCodeAt(j));)j++;j===o?t=j:j!==U&&(t=j+1)}}}}else if(u(n)&&i.charCodeAt(1)===g){if(o<=2)return c.root=c.dir=i,c;if(t=2,$(i.charCodeAt(2))){if(o===3)return c.root=c.dir=i,c;t=3}}t>0&&(c.root=i.slice(0,t));let r=-1,p=t,A=-1,C=!0,k=i.length-1,I=0;for(;k>=t;--k){if(n=i.charCodeAt(k),$(n)){if(!C){p=k+1;break}continue}A===-1&&(C=!1,A=k+1),n===P?r===-1?r=k:I!==1&&(I=1):r!==-1&&(I=-1)}return A!==-1&&(r===-1||I===0||I===1&&r===A-1&&r===p+1?c.base=c.name=i.slice(p,A):(c.name=i.slice(p,r),c.base=i.slice(p,A),c.ext=i.slice(r,A))),p>0&&p!==t?c.dir=i.slice(0,p-1):c.dir=c.root,c},sep:"\\",delimiter:";",win32:null,posix:null};const h=(()=>{if(b){const i=/\\/g;return()=>{const c=S.cwd().replace(i,"/");return c.slice(c.indexOf("/"))}}return()=>S.cwd()})();e.$gc={resolve(...i){let c="",o=!1;for(let t=i.length-1;t>=-1&&!o;t--){const n=t>=0?i[t]:h();v(n,"path"),n.length!==0&&(c=`${n}/${c}`,o=n.charCodeAt(0)===f)}return c=l(c,!o,"/",m),o?`/${c}`:c.length>0?c:"."},normalize(i){if(v(i,"path"),i.length===0)return".";const c=i.charCodeAt(0)===f,o=i.charCodeAt(i.length-1)===f;return i=l(i,!c,"/",m),i.length===0?c?"/":o?"./":".":(o&&(i+="/"),c?`/${i}`:i)},isAbsolute(i){return v(i,"path"),i.length>0&&i.charCodeAt(0)===f},join(...i){if(i.length===0)return".";let c;for(let o=0;o<i.length;++o){const t=i[o];v(t,"path"),t.length>0&&(c===void 0?c=t:c+=`/${t}`)}return c===void 0?".":e.$gc.normalize(c)},relative(i,c){if(v(i,"from"),v(c,"to"),i===c||(i=e.$gc.resolve(i),c=e.$gc.resolve(c),i===c))return"";const o=1,t=i.length,n=t-o,r=1,p=c.length-r,A=n<p?n:p;let C=-1,k=0;for(;k<A;k++){const j=i.charCodeAt(o+k);if(j!==c.charCodeAt(r+k))break;j===f&&(C=k)}if(k===A)if(p>A){if(c.charCodeAt(r+k)===f)return c.slice(r+k+1);if(k===0)return c.slice(r+k)}else n>A&&(i.charCodeAt(o+k)===f?C=k:k===0&&(C=0));let I="";for(k=o+C+1;k<=t;++k)(k===t||i.charCodeAt(k)===f)&&(I+=I.length===0?"..":"/..");return`${I}${c.slice(r+C)}`},toNamespacedPath(i){return i},dirname(i){if(v(i,"path"),i.length===0)return".";const c=i.charCodeAt(0)===f;let o=-1,t=!0;for(let n=i.length-1;n>=1;--n)if(i.charCodeAt(n)===f){if(!t){o=n;break}}else t=!1;return o===-1?c?"/":".":c&&o===1?"//":i.slice(0,o)},basename(i,c){c!==void 0&&v(c,"ext"),v(i,"path");let o=0,t=-1,n=!0,r;if(c!==void 0&&c.length>0&&c.length<=i.length){if(c===i)return"";let p=c.length-1,A=-1;for(r=i.length-1;r>=0;--r){const C=i.charCodeAt(r);if(C===f){if(!n){o=r+1;break}}else A===-1&&(n=!1,A=r+1),p>=0&&(C===c.charCodeAt(p)?--p===-1&&(t=r):(p=-1,t=A))}return o===t?t=A:t===-1&&(t=i.length),i.slice(o,t)}for(r=i.length-1;r>=0;--r)if(i.charCodeAt(r)===f){if(!n){o=r+1;break}}else t===-1&&(n=!1,t=r+1);return t===-1?"":i.slice(o,t)},extname(i){v(i,"path");let c=-1,o=0,t=-1,n=!0,r=0;for(let p=i.length-1;p>=0;--p){const A=i.charCodeAt(p);if(A===f){if(!n){o=p+1;break}continue}t===-1&&(n=!1,t=p+1),A===P?c===-1?c=p:r!==1&&(r=1):c!==-1&&(r=-1)}return c===-1||t===-1||r===0||r===1&&c===t-1&&c===o+1?"":i.slice(c,t)},format:E.bind(null,"/"),parse(i){v(i,"path");const c={root:"",dir:"",base:"",ext:"",name:""};if(i.length===0)return c;const o=i.charCodeAt(0)===f;let t;o?(c.root="/",t=1):t=0;let n=-1,r=0,p=-1,A=!0,C=i.length-1,k=0;for(;C>=t;--C){const I=i.charCodeAt(C);if(I===f){if(!A){r=C+1;break}continue}p===-1&&(A=!1,p=C+1),I===P?n===-1?n=C:k!==1&&(k=1):n!==-1&&(k=-1)}if(p!==-1){const I=r===0&&o?1:r;n===-1||k===0||k===1&&n===p-1&&n===r+1?c.base=c.name=i.slice(I,p):(c.name=i.slice(I,n),c.base=i.slice(I,p),c.ext=i.slice(n,p))}return r>0?c.dir=i.slice(0,r-1):o&&(c.dir="/"),c},sep:"/",delimiter:":",win32:null,posix:null},e.$gc.win32=e.$fc.win32=e.$fc,e.$gc.posix=e.$fc.posix=e.$gc,e.$hc=b?e.$fc.normalize:e.$gc.normalize,e.$ic=b?e.$fc.isAbsolute:e.$gc.isAbsolute,e.$jc=b?e.$fc.join:e.$gc.join,e.$kc=b?e.$fc.resolve:e.$gc.resolve,e.$lc=b?e.$fc.relative:e.$gc.relative,e.$mc=b?e.$fc.dirname:e.$gc.dirname,e.$nc=b?e.$fc.basename:e.$gc.basename,e.$oc=b?e.$fc.extname:e.$gc.extname,e.$pc=b?e.$fc.format:e.$gc.format,e.$qc=b?e.$fc.parse:e.$gc.parse,e.$rc=b?e.$fc.toNamespacedPath:e.$gc.toNamespacedPath,e.sep=b?e.$fc.sep:e.$gc.sep,e.$tc=b?e.$fc.delimiter:e.$gc.delimiter}),define(te[33],ie([0,1,9,4,27,12]),function(Q,e,S,R,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6f=e.$5f=e.$4f=e.$3f=e.$2f=e.$1f=e.$Zf=e.$Yf=e.$Xf=e.$Wf=e.$Vf=e.$Uf=e.$Tf=e.$Sf=e.$Rf=e.$Qf=void 0;function D(r){return r===47||r===92}e.$Qf=D;function P(r){return r.replace(/[\\/]/g,S.$gc.sep)}e.$Rf=P;function f(r){return r.indexOf("/")===-1&&(r=P(r)),/^[a-zA-Z]:(\/|$)/.test(r)&&(r="/"+r),r}e.$Sf=f;function a(r,p=S.$gc.sep){if(!r)return"";const A=r.length,C=r.charCodeAt(0);if(D(C)){if(D(r.charCodeAt(1))&&!D(r.charCodeAt(2))){let I=3;const j=I;for(;I<A&&!D(r.charCodeAt(I));I++);if(j!==I&&!D(r.charCodeAt(I+1))){for(I+=1;I<A;I++)if(D(r.charCodeAt(I)))return r.slice(0,I+1).replace(/[\\/]/g,p)}}return p}else if(m(C)&&r.charCodeAt(1)===58)return D(r.charCodeAt(2))?r.slice(0,2)+p:r.slice(0,2);let k=r.indexOf("://");if(k!==-1){for(k+=3;k<A;k++)if(D(r.charCodeAt(k)))return r.slice(0,k+1)}return""}e.$Tf=a;function g(r){if(!R.$j||!r||r.length<5)return!1;let p=r.charCodeAt(0);if(p!==92||(p=r.charCodeAt(1),p!==92))return!1;let A=2;const C=A;for(;A<r.length&&(p=r.charCodeAt(A),p!==92);A++);return!(C===A||(p=r.charCodeAt(A+1),isNaN(p)||p===92))}e.$Uf=g;const w=/[\\/:\*\?"<>\|]/g,y=/[\\/]/g,d=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function v(r,p=R.$j){const A=p?w:y;return!(!r||r.length===0||/^\s+$/.test(r)||(A.lastIndex=0,A.test(r))||p&&d.test(r)||r==="."||r===".."||p&&r[r.length-1]==="."||p&&r.length!==r.trim().length||r.length>255)}e.$Vf=v;function b(r,p,A){const C=r===p;return!A||C?C:!r||!p?!1:(0,s.$2e)(r,p)}e.$Wf=b;function $(r,p,A,C=S.sep){if(r===p)return!0;if(!r||!p||p.length>r.length)return!1;if(A){if(!(0,s.$3e)(r,p))return!1;if(p.length===r.length)return!0;let I=p.length;return p.charAt(p.length-1)===C&&I--,r.charAt(I)===C}return p.charAt(p.length-1)!==C&&(p+=C),r.indexOf(p)===0}e.$Xf=$;function m(r){return r>=65&&r<=90||r>=97&&r<=122}e.$Yf=m;function u(r,p){return R.$j&&r.endsWith(":")&&(r+=S.sep),(0,S.$ic)(r)||(r=(0,S.$jc)(p,r)),r=(0,S.$hc)(r),R.$j?(r=(0,s.$Ke)(r,S.sep),r.endsWith(":")&&(r+=S.sep)):(r=(0,s.$Ke)(r,S.sep),r||(r=S.sep)),r}e.$Zf=u;function l(r){const p=(0,S.$hc)(r);return R.$j?r.length>3?!1:E(p)&&(r.length===2||p.charCodeAt(2)===92):p===S.$gc.sep}e.$1f=l;function E(r,p=R.$j){return p?m(r.charCodeAt(0))&&r.charCodeAt(1)===58:!1}e.$2f=E;function h(r,p=R.$j){return E(r,p)?r[0]:void 0}e.$3f=h;function i(r,p,A){return p.length>r.length?-1:r===p?0:(A&&(r=r.toLowerCase(),p=p.toLowerCase()),r.indexOf(p))}e.$4f=i;function c(r){const p=r.split(":");let A,C,k;for(const I of p){const j=Number(I);(0,M.$Cf)(j)?C===void 0?C=j:k===void 0&&(k=j):A=A?[A,I].join(":"):I}if(!A)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:A,line:C!==void 0?C:void 0,column:k!==void 0?k:C!==void 0?1:void 0}}e.$5f=c;const o="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",t="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function n(r,p,A=8){let C="";for(let I=0;I<A;I++){let j;I===0&&R.$j&&!p&&(A===3||A===4)?j=t:j=o,C+=j.charAt(Math.floor(Math.random()*j.length))}let k;return p?k=`${p}-${C}`:k=C,r?(0,S.$jc)(r,k):k}e.$6f=n}),define(te[75],ie([0,1,4]),function(Q,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yl=e.$xl=e.TerminateResponseCode=e.Source=void 0;var R;(function(P){P[P.stdout=0]="stdout",P[P.stderr=1]="stderr"})(R||(e.Source=R={}));var s;(function(P){P[P.Success=0]="Success",P[P.Unknown=1]="Unknown",P[P.AccessDenied=2]="AccessDenied",P[P.ProcessNotFound=3]="ProcessNotFound"})(s||(e.TerminateResponseCode=s={}));function M(P,...f){const a=f.reduce((y,d)=>(y[d]=!0,y),{}),g=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(P).filter(y=>!a[y]).forEach(y=>{for(let d=0;d<g.length;d++)if(y.search(g[d])!==-1){delete P[y];break}})}e.$xl=M;function D(P){P&&(delete P.DEBUG,S.$k&&delete P.DYLD_LIBRARY_PATH,S.$l&&delete P.LD_PRELOAD)}e.$yl=D}),define(te[7],ie([0,1,9,4]),function(Q,e,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wc=e.$vc=e.URI=void 0;const s=/^\w[\w\d+.-]*$/,M=/^\//,D=/^\/\//;function P(t,n){if(!t.scheme&&n)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${t.authority}", path: "${t.path}", query: "${t.query}", fragment: "${t.fragment}"}`);if(t.scheme&&!s.test(t.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(t.path){if(t.authority){if(!M.test(t.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(D.test(t.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function f(t,n){return!t&&!n?"file":t}function a(t,n){switch(t){case"https":case"http":case"file":n?n[0]!==w&&(n=w+n):n=w;break}return n}const g="",w="/",y=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class d{static isUri(n){return n instanceof d?!0:n?typeof n.authority=="string"&&typeof n.fragment=="string"&&typeof n.path=="string"&&typeof n.query=="string"&&typeof n.scheme=="string"&&typeof n.fsPath=="string"&&typeof n.with=="function"&&typeof n.toString=="function":!1}constructor(n,r,p,A,C,k=!1){typeof n=="object"?(this.scheme=n.scheme||g,this.authority=n.authority||g,this.path=n.path||g,this.query=n.query||g,this.fragment=n.fragment||g):(this.scheme=f(n,k),this.authority=r||g,this.path=a(this.scheme,p||g),this.query=A||g,this.fragment=C||g,P(this,k))}get fsPath(){return E(this,!1)}with(n){if(!n)return this;let{scheme:r,authority:p,path:A,query:C,fragment:k}=n;return r===void 0?r=this.scheme:r===null&&(r=g),p===void 0?p=this.authority:p===null&&(p=g),A===void 0?A=this.path:A===null&&(A=g),C===void 0?C=this.query:C===null&&(C=g),k===void 0?k=this.fragment:k===null&&(k=g),r===this.scheme&&p===this.authority&&A===this.path&&C===this.query&&k===this.fragment?this:new $(r,p,A,C,k)}static parse(n,r=!1){const p=y.exec(n);return p?new $(p[2]||g,o(p[4]||g),o(p[5]||g),o(p[7]||g),o(p[9]||g),r):new $(g,g,g,g,g)}static file(n){let r=g;if(R.$j&&(n=n.replace(/\\/g,w)),n[0]===w&&n[1]===w){const p=n.indexOf(w,2);p===-1?(r=n.substring(2),n=w):(r=n.substring(2,p),n=n.substring(p)||w)}return new $("file",r,n,g,g)}static from(n,r){return new $(n.scheme,n.authority,n.path,n.query,n.fragment,r)}static joinPath(n,...r){if(!n.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let p;return R.$j&&n.scheme==="file"?p=d.file(S.$fc.join(E(n,!0),...r)).path:p=S.$gc.join(n.path,...r),n.with({path:p})}toString(n=!1){return h(this,n)}toJSON(){return this}static revive(n){if(n){if(n instanceof d)return n;{const r=new $(n);return r._formatted=n.external??null,r._fsPath=n._sep===b?n.fsPath??null:null,r}}else return n}}e.URI=d;function v(t){return!t||typeof t!="object"?!1:typeof t.scheme=="string"&&(typeof t.authority=="string"||typeof t.authority>"u")&&(typeof t.path=="string"||typeof t.path>"u")&&(typeof t.query=="string"||typeof t.query>"u")&&(typeof t.fragment=="string"||typeof t.fragment>"u")}e.$vc=v;const b=R.$j?1:void 0;class $ extends d{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=E(this,!1)),this._fsPath}toString(n=!1){return n?h(this,!0):(this._formatted||(this._formatted=h(this,!1)),this._formatted)}toJSON(){const n={$mid:1};return this._fsPath&&(n.fsPath=this._fsPath,n._sep=b),this._formatted&&(n.external=this._formatted),this.path&&(n.path=this.path),this.scheme&&(n.scheme=this.scheme),this.authority&&(n.authority=this.authority),this.query&&(n.query=this.query),this.fragment&&(n.fragment=this.fragment),n}}const m={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function u(t,n,r){let p,A=-1;for(let C=0;C<t.length;C++){const k=t.charCodeAt(C);if(k>=97&&k<=122||k>=65&&k<=90||k>=48&&k<=57||k===45||k===46||k===95||k===126||n&&k===47||r&&k===91||r&&k===93||r&&k===58)A!==-1&&(p+=encodeURIComponent(t.substring(A,C)),A=-1),p!==void 0&&(p+=t.charAt(C));else{p===void 0&&(p=t.substr(0,C));const I=m[k];I!==void 0?(A!==-1&&(p+=encodeURIComponent(t.substring(A,C)),A=-1),p+=I):A===-1&&(A=C)}}return A!==-1&&(p+=encodeURIComponent(t.substring(A))),p!==void 0?p:t}function l(t){let n;for(let r=0;r<t.length;r++){const p=t.charCodeAt(r);p===35||p===63?(n===void 0&&(n=t.substr(0,r)),n+=m[p]):n!==void 0&&(n+=t[r])}return n!==void 0?n:t}function E(t,n){let r;return t.authority&&t.path.length>1&&t.scheme==="file"?r=`//${t.authority}${t.path}`:t.path.charCodeAt(0)===47&&(t.path.charCodeAt(1)>=65&&t.path.charCodeAt(1)<=90||t.path.charCodeAt(1)>=97&&t.path.charCodeAt(1)<=122)&&t.path.charCodeAt(2)===58?n?r=t.path.substr(1):r=t.path[1].toLowerCase()+t.path.substr(2):r=t.path,R.$j&&(r=r.replace(/\//g,"\\")),r}e.$wc=E;function h(t,n){const r=n?l:u;let p="",{scheme:A,authority:C,path:k,query:I,fragment:j}=t;if(A&&(p+=A,p+=":"),(C||A==="file")&&(p+=w,p+=w),C){let U=C.indexOf("@");if(U!==-1){const z=C.substr(0,U);C=C.substr(U+1),U=z.lastIndexOf(":"),U===-1?p+=r(z,!1,!1):(p+=r(z.substr(0,U),!1,!1),p+=":",p+=r(z.substr(U+1),!1,!0)),p+="@"}C=C.toLowerCase(),U=C.lastIndexOf(":"),U===-1?p+=r(C,!1,!0):(p+=r(C.substr(0,U),!1,!0),p+=C.substr(U))}if(k){if(k.length>=3&&k.charCodeAt(0)===47&&k.charCodeAt(2)===58){const U=k.charCodeAt(1);U>=65&&U<=90&&(k=`/${String.fromCharCode(U+32)}:${k.substr(3)}`)}else if(k.length>=2&&k.charCodeAt(1)===58){const U=k.charCodeAt(0);U>=65&&U<=90&&(k=`${String.fromCharCode(U+32)}:${k.substr(2)}`)}p+=r(k,!0,!1)}return I&&(p+="?",p+=r(I,!1,!1)),j&&(p+="#",p+=n?j:u(j,!1,!1)),p}function i(t){try{return decodeURIComponent(t)}catch{return t.length>3?t.substr(0,3)+i(t.substr(3)):t}}const c=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function o(t){return t.match(c)?t.replace(c,n=>i(n)):t}}),define(te[152],ie([0,1,7]),function(Q,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.$Xp=e.$Wp=e.$Vp=void 0;function R(a){const g=a;return g&&typeof g.type=="string"&&typeof g.severity=="string"}e.$Vp=R;function s(a){const g=[];let w;try{const y=JSON.parse(a.arguments),d=y[y.length-1];d&&d.__$stack&&(y.pop(),w=d.__$stack),g.push(...y)}catch{g.push("Unable to log remote console arguments",a.arguments)}return{args:g,stack:w}}e.$Wp=s;function M(a){if(typeof a!="string")return M(s(a).stack);const g=a;if(g){const w=D(g),y=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(w||"");if(y&&y.length===4)return{uri:S.URI.file(y[1]),line:Number(y[2]),column:Number(y[3])}}}e.$Xp=M;function D(a){if(!a)return a;const g=a.indexOf(`
`);return g===-1?a:a.substring(0,g)}function P(a,g){const{args:w,stack:y}=s(a),d=typeof w[0]=="string"&&w.length===1;let v=D(y);v&&(v=`(${v.trim()})`);let b=[];if(typeof w[0]=="string"?v&&d?b=[`%c[${g}] %c${w[0]} %c${v}`,f("blue"),f(""),f("grey")]:b=[`%c[${g}] %c${w[0]}`,f("blue"),f(""),...w.slice(1)]:b=[`%c[${g}]%`,f("blue"),...w],v&&!d&&b.push(v),typeof console[a.severity]!="function")throw new Error("Unknown console method");console[a.severity].apply(console,b)}e.log=P;function f(a){return`color: ${a}`}}),define(te[76],ie([0,1,17,7]),function(Q,e,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lh=e.$kh=e.$jh=void 0;function s(f){return JSON.stringify(f,D)}e.$jh=s;function M(f){let a=JSON.parse(f);return a=P(a),a}e.$kh=M;function D(f,a){return a instanceof RegExp?{$mid:2,source:a.source,flags:a.flags}:a}function P(f,a=0){if(!f||a>200)return f;if(typeof f=="object"){switch(f.$mid){case 1:return R.URI.revive(f);case 2:return new RegExp(f.source,f.flags);case 17:return new Date(f.source)}if(f instanceof S.$be||f instanceof Uint8Array)return f;if(Array.isArray(f))for(let g=0;g<f.length;++g)f[g]=P(f[g],a+1);else for(const g in f)Object.hasOwnProperty.call(f,g)&&(f[g]=P(f[g],a+1))}return f}e.$lh=P}),define(te[13],ie([0,1,14,4,7]),function(Q,e,S,R,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$cg=e.$bg=e.$ag=e.$_f=e.$$f=e.$0f=e.$9f=e.$8f=e.$7f=e.Schemas=void 0;var M;(function(a){a.inMemory="inmemory",a.vscode="vscode",a.internal="private",a.walkThrough="walkThrough",a.walkThroughSnippet="walkThroughSnippet",a.http="http",a.https="https",a.file="file",a.mailto="mailto",a.untitled="untitled",a.data="data",a.command="command",a.vscodeRemote="vscode-remote",a.vscodeRemoteResource="vscode-remote-resource",a.vscodeManagedRemoteResource="vscode-managed-remote-resource",a.vscodeUserData="vscode-userdata",a.vscodeCustomEditor="vscode-custom-editor",a.vscodeNotebookCell="vscode-notebook-cell",a.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",a.vscodeNotebookCellOutput="vscode-notebook-cell-output",a.vscodeInteractiveInput="vscode-interactive-input",a.vscodeSettings="vscode-settings",a.vscodeWorkspaceTrust="vscode-workspace-trust",a.vscodeTerminal="vscode-terminal",a.vscodeChatSesssion="vscode-chat-editor",a.webviewPanel="webview-panel",a.vscodeWebview="vscode-webview",a.extension="extension",a.vscodeFileResource="vscode-file",a.tmp="tmp",a.vsls="vsls",a.vscodeSourceControl="vscode-scm"})(M||(e.Schemas=M={})),e.$7f="vscode-tkn",e.$8f="tkn";class D{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${M.vscodeRemoteResource}`}setPreferredWebSchema(g){this.d=g}setDelegate(g){this.e=g}setServerRootPath(g){this.f=`${g}/${M.vscodeRemoteResource}`}set(g,w,y){this.a[g]=w,this.b[g]=y}setConnectionToken(g,w){this.c[g]=w}getPreferredWebSchema(){return this.d}rewrite(g){if(this.e)try{return this.e(g)}catch($){return S.$1($),g}const w=g.authority;let y=this.a[w];y&&y.indexOf(":")!==-1&&y.indexOf("[")===-1&&(y=`[${y}]`);const d=this.b[w],v=this.c[w];let b=`path=${encodeURIComponent(g.path)}`;return typeof v=="string"&&(b+=`&${e.$8f}=${encodeURIComponent(v)}`),s.URI.from({scheme:R.$p?this.d:M.vscodeRemoteResource,authority:`${y}:${d}`,path:this.f,query:b})}}e.$9f=new D,e.$0f="vs/../../extensions",e.$$f="vs/../../node_modules",e.$_f="vs/../../node_modules.asar",e.$ag="vs/../../node_modules.asar.unpacked",e.$bg="vscode-app";class P{static{this.a=e.$bg}asBrowserUri(g){const w=this.b(g,Q);return this.uriToBrowserUri(w)}uriToBrowserUri(g){return g.scheme===M.vscodeRemote?e.$9f.rewrite(g):g.scheme===M.file&&(R.$n||R.$q&&R.$h.origin===`${M.vscodeFileResource}://${P.a}`)?g.with({scheme:M.vscodeFileResource,authority:g.authority||P.a,query:null,fragment:null}):g}asFileUri(g){const w=this.b(g,Q);return this.uriToFileUri(w)}uriToFileUri(g){return g.scheme===M.vscodeFileResource?g.with({scheme:M.file,authority:g.authority!==P.a?g.authority:null,query:null,fragment:null}):g}b(g,w){return s.URI.isUri(g)?g:s.URI.parse(w.toUrl(g))}}e.$cg=new P;var f;(function(a){const g=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);a.CoopAndCoep=Object.freeze(g.get("3"));const w="vscode-coi";function y(v){let b;typeof v=="string"?b=new URL(v).searchParams:v instanceof URL?b=v.searchParams:s.URI.isUri(v)&&(b=new URL(v.toString(!0)).searchParams);const $=b?.get(w);if($)return g.get($)}a.getHeadersFromQuery=y;function d(v,b,$){if(!globalThis.crossOriginIsolated)return;const m=b&&$?"3":$?"2":"1";v instanceof URLSearchParams?v.set(w,m):v[w]=m}a.addSearchParam=d})(f||(e.COI=f={}))}),define(te[19],ie([0,1,33,13,9,4,27,7]),function(Q,e,S,R,s,M,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fg=e.DataUri=e.$Eg=e.$Dg=e.$Cg=e.$Bg=e.$Ag=e.$zg=e.$yg=e.$xg=e.$wg=e.$vg=e.$ug=e.$tg=e.$sg=e.$rg=e.$qg=e.$pg=e.$og=e.$ng=e.$mg=e.$lg=e.$kg=e.$jg=void 0;function f(d){return(0,P.$wc)(d,!0)}e.$jg=f;class a{constructor(v){this.a=v}compare(v,b,$=!1){return v===b?0:(0,D.$Ue)(this.getComparisonKey(v,$),this.getComparisonKey(b,$))}isEqual(v,b,$=!1){return v===b?!0:!v||!b?!1:this.getComparisonKey(v,$)===this.getComparisonKey(b,$)}getComparisonKey(v,b=!1){return v.with({path:this.a(v)?v.path.toLowerCase():void 0,fragment:b?null:void 0}).toString()}ignorePathCasing(v){return this.a(v)}isEqualOrParent(v,b,$=!1){if(v.scheme===b.scheme){if(v.scheme===R.Schemas.file)return S.$Xf(f(v),f(b),this.a(v))&&v.query===b.query&&($||v.fragment===b.fragment);if((0,e.$Ag)(v.authority,b.authority))return S.$Xf(v.path,b.path,this.a(v),"/")&&v.query===b.query&&($||v.fragment===b.fragment)}return!1}joinPath(v,...b){return P.URI.joinPath(v,...b)}basenameOrAuthority(v){return(0,e.$sg)(v)||v.authority}basename(v){return s.$gc.basename(v.path)}extname(v){return s.$gc.extname(v.path)}dirname(v){if(v.path.length===0)return v;let b;return v.scheme===R.Schemas.file?b=P.URI.file(s.$mc(f(v))).path:(b=s.$gc.dirname(v.path),v.authority&&b.length&&b.charCodeAt(0)!==47&&(console.error(`dirname("${v.toString})) resulted in a relative path`),b="/")),v.with({path:b})}normalizePath(v){if(!v.path.length)return v;let b;return v.scheme===R.Schemas.file?b=P.URI.file(s.$hc(f(v))).path:b=s.$gc.normalize(v.path),v.with({path:b})}relativePath(v,b){if(v.scheme!==b.scheme||!(0,e.$Ag)(v.authority,b.authority))return;if(v.scheme===R.Schemas.file){const u=s.$lc(f(v),f(b));return M.$j?S.$Rf(u):u}let $=v.path||"/";const m=b.path||"/";if(this.a(v)){let u=0;for(const l=Math.min($.length,m.length);u<l&&!($.charCodeAt(u)!==m.charCodeAt(u)&&$.charAt(u).toLowerCase()!==m.charAt(u).toLowerCase());u++);$=m.substr(0,u)+$.substr(u)}return s.$gc.relative($,m)}resolvePath(v,b){if(v.scheme===R.Schemas.file){const $=P.URI.file(s.$kc(f(v),b));return v.with({authority:$.authority,path:$.path})}return b=S.$Sf(b),v.with({path:s.$gc.resolve(v.path,b)})}isAbsolutePath(v){return!!v.path&&v.path[0]==="/"}isEqualAuthority(v,b){return v===b||v!==void 0&&b!==void 0&&(0,D.$2e)(v,b)}hasTrailingPathSeparator(v,b=s.sep){if(v.scheme===R.Schemas.file){const $=f(v);return $.length>S.$Tf($).length&&$[$.length-1]===b}else{const $=v.path;return $.length>1&&$.charCodeAt($.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(v.fsPath)}}removeTrailingPathSeparator(v,b=s.sep){return(0,e.$Bg)(v,b)?v.with({path:v.path.substr(0,v.path.length-1)}):v}addTrailingPathSeparator(v,b=s.sep){let $=!1;if(v.scheme===R.Schemas.file){const m=f(v);$=m!==void 0&&m.length===S.$Tf(m).length&&m[m.length-1]===b}else{b="/";const m=v.path;$=m.length===1&&m.charCodeAt(m.length-1)===47}return!$&&!(0,e.$Bg)(v,b)?v.with({path:v.path+"/"}):v}}e.$kg=a,e.$lg=new a(()=>!1),e.$mg=new a(d=>d.scheme===R.Schemas.file?!M.$l:!0),e.$ng=new a(d=>!0),e.$og=e.$lg.isEqual.bind(e.$lg),e.$pg=e.$lg.isEqualOrParent.bind(e.$lg),e.$qg=e.$lg.getComparisonKey.bind(e.$lg),e.$rg=e.$lg.basenameOrAuthority.bind(e.$lg),e.$sg=e.$lg.basename.bind(e.$lg),e.$tg=e.$lg.extname.bind(e.$lg),e.$ug=e.$lg.dirname.bind(e.$lg),e.$vg=e.$lg.joinPath.bind(e.$lg),e.$wg=e.$lg.normalizePath.bind(e.$lg),e.$xg=e.$lg.relativePath.bind(e.$lg),e.$yg=e.$lg.resolvePath.bind(e.$lg),e.$zg=e.$lg.isAbsolutePath.bind(e.$lg),e.$Ag=e.$lg.isEqualAuthority.bind(e.$lg),e.$Bg=e.$lg.hasTrailingPathSeparator.bind(e.$lg),e.$Cg=e.$lg.removeTrailingPathSeparator.bind(e.$lg),e.$Dg=e.$lg.addTrailingPathSeparator.bind(e.$lg);function g(d,v){const b=[];for(let $=0;$<d.length;$++){const m=v(d[$]);d.some((u,l)=>l===$?!1:(0,e.$pg)(m,v(u)))||b.push(d[$])}return b}e.$Eg=g;var w;(function(d){d.META_DATA_LABEL="label",d.META_DATA_DESCRIPTION="description",d.META_DATA_SIZE="size",d.META_DATA_MIME="mime";function v(b){const $=new Map;b.path.substring(b.path.indexOf(";")+1,b.path.lastIndexOf(";")).split(";").forEach(l=>{const[E,h]=l.split(":");E&&h&&$.set(E,h)});const u=b.path.substring(0,b.path.indexOf(";"));return u&&$.set(d.META_DATA_MIME,u),$}d.parseMetaData=v})(w||(e.DataUri=w={}));function y(d,v,b){if(v){let $=d.path;return $&&$[0]!==s.$gc.sep&&($=s.$gc.sep+$),d.with({scheme:b,authority:v,path:$})}return d.with({scheme:b})}e.$Fg=y}),define(te[8],ie([0,1,22,14,3,2,19,4,141]),function(Q,e,S,R,s,M,D,P,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fh=e.$eh=e.$dh=e.Promises=e.$ch=e.$bh=e.$ah=e.$_g=e.$$g=e.$0g=e.$9g=e.$8g=e.$7g=e.$6g=e.$5g=e.$4g=e.$3g=e.$2g=e.$1g=e.$Zg=e.$Yg=e.$Xg=e.$Wg=e.$Vg=e.$Ug=e.$Tg=e.$Sg=e.$Rg=e.$Qg=e.$Pg=e.$Og=e.$Ng=e.$Mg=e.$Lg=e.$Kg=e.$Jg=e.$Ig=e.$Hg=e.$Gg=void 0;function a(O){return!!O&&typeof O.then=="function"}e.$Gg=a;function g(O){const L=new S.$Xd,B=O(L.token),T=new Promise((W,V)=>{const ce=L.token.onCancellationRequested(()=>{ce.dispose(),L.dispose(),V(new R.$5)});Promise.resolve(B).then(de=>{ce.dispose(),L.dispose(),W(de)},de=>{ce.dispose(),L.dispose(),V(de)})});return new class{cancel(){L.cancel()}then(W,V){return T.then(W,V)}catch(W){return this.then(void 0,W)}finally(W){return T.finally(W)}}}e.$Hg=g;function w(O,L,B){return new Promise((T,W)=>{const V=L.onCancellationRequested(()=>{V.dispose(),T(B)});O.then(T,W).finally(()=>V.dispose())})}e.$Ig=w;function y(O,L){return new Promise((B,T)=>{const W=L.onCancellationRequested(()=>{W.dispose(),T(new R.$5)});O.then(B,T).finally(()=>W.dispose())})}e.$Jg=y;async function d(O){let L=-1;const B=O.map((T,W)=>T.then(V=>(L=W,V)));try{return await Promise.race(B)}finally{O.forEach((T,W)=>{W!==L&&T.cancel()})}}e.$Kg=d;function v(O,L,B){let T;const W=setTimeout(()=>{T?.(void 0),B?.()},L);return Promise.race([O.finally(()=>clearTimeout(W)),new Promise(V=>T=V)])}e.$Lg=v;function b(O){return new Promise((L,B)=>{const T=O();a(T)?T.then(L,B):L(T)})}e.$Mg=b;class ${constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(L){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=L,!this.b){const B=()=>{if(this.b=null,this.f)return;const T=this.queue(this.d);return this.d=null,T};this.b=new Promise(T=>{this.a.then(B,B).then(T)})}return new Promise((B,T)=>{this.b.then(B,T)})}return this.a=L(),new Promise((B,T)=>{this.a.then(W=>{this.a=null,B(W)},W=>{this.a=null,T(W)})})}dispose(){this.f=!0}}e.$Ng=$;class m{constructor(){this.a=Promise.resolve(null)}queue(L){return this.a=this.a.then(()=>L(),()=>L())}}e.$Og=m;class u{constructor(){this.a=new Map}queue(L,B){const W=(this.a.get(L)??Promise.resolve()).catch(()=>{}).then(B).finally(()=>{this.a.get(L)===W&&this.a.delete(L)});return this.a.set(L,W),W}}e.$Pg=u;const l=(O,L)=>{let B=!0;const T=setTimeout(()=>{B=!1,L()},O);return{isTriggered:()=>B,dispose:()=>{clearTimeout(T),B=!1}}},E=O=>{let L=!0;return queueMicrotask(()=>{L&&(L=!1,O())}),{isTriggered:()=>L,dispose:()=>{L=!1}}};class h{constructor(L){this.defaultDelay=L,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(L,B=this.defaultDelay){this.g=L,this.h(),this.b||(this.b=new Promise((W,V)=>{this.d=W,this.f=V}).then(()=>{if(this.b=null,this.d=null,this.g){const W=this.g;return this.g=null,W()}}));const T=()=>{this.a=null,this.d?.(null)};return this.a=B===f.$Kd?E(T):l(B,T),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new R.$5),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$Qg=h;class i{constructor(L){this.a=new h(L),this.b=new $}trigger(L,B){return this.a.trigger(()=>this.b.queue(L),B)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$Rg=i;class c{constructor(){this.a=!1,this.b=new Promise((L,B)=>{this.d=L})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$Sg=c;class o extends c{constructor(L){super(),this.f=setTimeout(()=>this.open(),L)}open(){clearTimeout(this.f),super.open()}}e.$Tg=o;function t(O,L){return L?new Promise((B,T)=>{const W=setTimeout(()=>{V.dispose(),B()},O),V=L.onCancellationRequested(()=>{clearTimeout(W),V.dispose(),T(new R.$5)})}):g(B=>t(O,B))}e.$Ug=t;function n(O,L=0,B){const T=setTimeout(()=>{O(),B&&W.dispose()},L),W=(0,M.$Qc)(()=>{clearTimeout(T),B?.deleteAndLeak(W)});return B?.add(W),W}e.$Vg=n;function r(O){const L=[];let B=0;const T=O.length;function W(){return B<T?O[B++]():null}function V(ce){ce!=null&&L.push(ce);const de=W();return de?de.then(V):Promise.resolve(L)}return Promise.resolve(null).then(V)}e.$Wg=r;function p(O,L=T=>!!T,B=null){let T=0;const W=O.length,V=()=>{if(T>=W)return Promise.resolve(B);const ce=O[T++];return Promise.resolve(ce()).then(ue=>L(ue)?Promise.resolve(ue):V())};return V()}e.$Xg=p;function A(O,L=T=>!!T,B=null){if(O.length===0)return Promise.resolve(B);let T=O.length;const W=()=>{T=-1;for(const V of O)V.cancel?.()};return new Promise((V,ce)=>{for(const de of O)de.then(ue=>{--T>=0&&L(ue)?(W(),V(ue)):T===0&&V(B)}).catch(ue=>{--T>=0&&(W(),ce(ue))})})}e.$Yg=A;class C{constructor(L){this.a=0,this.d=L,this.f=[],this.b=0,this.g=new s.$Nd}get onDrained(){return this.g.event}get size(){return this.a}queue(L){return this.a++,new Promise((B,T)=>{this.f.push({factory:L,c:B,e:T}),this.h()})}h(){for(;this.f.length&&this.b<this.d;){const L=this.f.shift();this.b++;const B=L.factory();B.then(L.c,L.e),B.then(()=>this.j(),()=>this.j())}}j(){this.a--,this.b--,this.f.length>0?this.h():this.g.fire()}dispose(){this.g.dispose()}}e.$Zg=C;class k extends C{constructor(){super(1)}}e.$1g=k;class I{constructor(){this.a=new J,this.b=0}queue(L){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,L())):this.a.run(this.b++,L())}}e.$2g=I;class j{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const L=new q;return this.b.add(L),L.p}g(){for(const[,L]of this.a)if(L.size>0)return!1;return!0}queueFor(L,B=D.$lg){const T=B.getComparisonKey(L);let W=this.a.get(T);if(!W){W=new k;const V=this.f++,ce=s.Event.once(W.onDrained)(()=>{W?.dispose(),this.a.delete(T),this.h(),this.d?.deleteAndDispose(V),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new M.$1c),this.d.set(V,ce),this.a.set(T,W)}return W}h(){this.g()&&this.j()}j(){for(const L of this.b)L.complete();this.b.clear()}dispose(){for(const[,L]of this.a)L.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$3g=j;class U{constructor(L,B){this.a=-1,typeof L=="function"&&typeof B=="number"&&this.setIfNotSet(L,B)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(L,B){this.cancel(),this.a=setTimeout(()=>{this.a=-1,L()},B)}setIfNotSet(L,B){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,L()},B))}}e.$4g=U;class z{constructor(){this.a=-1}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearInterval(this.a),this.a=-1)}cancelAndSet(L,B){this.cancel(),this.a=setInterval(()=>{L()},B)}}e.$5g=z;class ne{constructor(L,B){this.b=-1,this.a=L,this.d=B,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(L=this.d){this.cancel(),this.b=setTimeout(this.f,L)}get delay(){return this.d}set delay(L){this.d=L}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$6g=ne;class _{constructor(L,B){B%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${B}ms is not a multiple of 1000ms.`),this.a=L,this.b=B,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(L=this.b){L%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${L}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(L/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$7g=_;class ae extends ne{constructor(L,B){super(L,B),this.j=[]}work(L){this.j.push(L),this.isScheduled()||this.schedule()}h(){const L=this.j;this.j=[],this.a?.(L)}dispose(){this.j=[],super.dispose()}}e.$8g=ae;class se extends M.$Sc{constructor(L,B){super(),this.g=L,this.h=B,this.a=[],this.b=this.B(new M.$Tc),this.f=!1}get pending(){return this.a.length}work(L){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+L.length>this.g.maxBufferedWork)return!1}else if(this.pending+L.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const B of L)this.a.push(B);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new ne(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$9g=se,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.$0g=O=>{(0,P.$B)(()=>{if(L)return;const B=Date.now()+15;O(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,B-Date.now())}}))});let L=!1;return{dispose(){L||(L=!0)}}}:e.$0g=(O,L)=>{const B=requestIdleCallback(O,typeof L=="number"?{timeout:L}:void 0);let T=!1;return{dispose(){T||(T=!0,cancelIdleCallback(B))}}}}();class oe{constructor(L){this.d=!1,this.a=()=>{try{this.f=L()}catch(B){this.g=B}finally{this.d=!0}},this.b=(0,e.$0g)(()=>this.a())}dispose(){this.b.dispose()}get value(){if(this.d||(this.b.dispose(),this.a()),this.g)throw this.g;return this.f}get isInitialized(){return this.d}}e.$$g=oe;async function K(O,L,B){let T;for(let W=0;W<B;W++)try{return await O()}catch(V){T=V,await t(L)}throw T}e.$_g=K;class J{isRunning(L){return typeof L=="number"?this.a?.taskId===L:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(L,B,T){return this.a={taskId:L,cancel:()=>T?.(),promise:B},B.then(()=>this.d(L),()=>this.d(L)),B}d(L){this.a&&L===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const L=this.b;this.b=void 0,L.run().then(L.promiseResolve,L.promiseReject)}}queue(L){if(this.b)this.b.run=L;else{let B,T;const W=new Promise((V,ce)=>{B=V,T=ce});this.b={run:L,promise:W,promiseResolve:B,promiseReject:T}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$ah=J;class G{constructor(L,B=()=>Date.now()){this.d=L,this.f=B,this.a=0,this.b=0}increment(){const L=this.f();return L-this.a>this.d&&(this.a=L,this.b=0),this.b++,this.b}}e.$bh=G;var N;(function(O){O[O.Resolved=0]="Resolved",O[O.Rejected=1]="Rejected"})(N||(N={}));class q{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((L,B)=>{this.a=L,this.b=B})}complete(L){return new Promise(B=>{this.a(L),this.d={outcome:0,value:L},B()})}error(L){return new Promise(B=>{this.b(L),this.d={outcome:1,value:L},B()})}cancel(){return this.error(new R.$5)}}e.$ch=q;var X;(function(O){async function L(T){let W;const V=await Promise.all(T.map(ce=>ce.then(de=>de,de=>{W||(W=de)})));if(typeof W<"u")throw W;return V}O.settled=L;function B(T){return new Promise(async(W,V)=>{try{await T(W,V)}catch(ce){V(ce)}})}O.withAsyncBody=B})(X||(e.Promises=X={}));var H;(function(O){O[O.Initial=0]="Initial",O[O.DoneOK=1]="DoneOK",O[O.DoneError=2]="DoneError"})(H||(H={}));class Y{static fromArray(L){return new Y(B=>{B.emitMany(L)})}static fromPromise(L){return new Y(async B=>{B.emitMany(await L)})}static fromPromises(L){return new Y(async B=>{await Promise.all(L.map(async T=>B.emitOne(await T)))})}static merge(L){return new Y(async B=>{await Promise.all(L.map(async T=>{for await(const W of T)B.emitOne(W)}))})}static{this.EMPTY=Y.fromArray([])}constructor(L){this.a=0,this.b=[],this.d=null,this.f=new s.$Nd,queueMicrotask(async()=>{const B={emitOne:T=>this.g(T),emitMany:T=>this.h(T),reject:T=>this.k(T)};try{await Promise.resolve(L(B)),this.j()}catch(T){this.k(T)}finally{B.emitOne=void 0,B.emitMany=void 0,B.reject=void 0}})}[Symbol.asyncIterator](){let L=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(L<this.b.length)return{done:!1,value:this.b[L++]};if(this.a===1)return{done:!0,value:void 0};await s.Event.toPromise(this.f.event)}while(!0)}}}static map(L,B){return new Y(async T=>{for await(const W of L)T.emitOne(B(W))})}map(L){return Y.map(this,L)}static filter(L,B){return new Y(async T=>{for await(const W of L)B(W)&&T.emitOne(W)})}filter(L){return Y.filter(this,L)}static coalesce(L){return Y.filter(L,B=>!!B)}coalesce(){return Y.coalesce(this)}static async toPromise(L){const B=[];for await(const T of L)B.push(T);return B}toPromise(){return Y.toPromise(this)}g(L){this.a===0&&(this.b.push(L),this.f.fire())}h(L){this.a===0&&(this.b=this.b.concat(L),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(L){this.a===0&&(this.a=2,this.d=L,this.f.fire())}}e.$dh=Y;class re extends Y{constructor(L,B){super(B),this.l=L}cancel(){this.l.cancel()}}e.$eh=re;function F(O){const L=new S.$Xd,B=O(L.token);return new re(L,async T=>{const W=L.token.onCancellationRequested(()=>{W.dispose(),L.dispose(),T.reject(new R.$5)});try{for await(const V of B){if(L.token.isCancellationRequested)return;T.emitOne(V)}W.dispose(),L.dispose()}catch(V){W.dispose(),L.dispose(),T.reject(V)}})}e.$fh=F}),define(te[104],ie([0,1,23,8,33,31,9,4,27]),function(Q,e,S,R,s,M,D,P,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zj=e.$yj=e.$xj=e.$wj=e.$vj=e.$uj=e.$tj=e.$sj=e.$rj=e.$qj=void 0;function a(){return Object.create(null)}e.$qj=a,e.$rj="**",e.$sj="/";const g="[/\\\\]",w="[^/\\\\]",y=/\//g;function d(J,G){switch(J){case 0:return"";case 1:return`${w}*?`;default:return`(?:${g}|${w}+${g}${G?`|${g}${w}+`:""})*?`}}function v(J,G){if(!J)return[];const N=[];let q=!1,X=!1,H="";for(const Y of J){switch(Y){case G:if(!q&&!X){N.push(H),H="";continue}break;case"{":q=!0;break;case"}":q=!1;break;case"[":X=!0;break;case"]":X=!1;break}H+=Y}return H&&N.push(H),N}e.$tj=v;function b(J){if(!J)return"";let G="";const N=v(J,e.$sj);if(N.every(q=>q===e.$rj))G=".*";else{let q=!1;N.forEach((X,H)=>{if(X===e.$rj){if(q)return;G+=d(2,H===N.length-1)}else{let Y=!1,re="",F=!1,O="";for(const L of X){if(L!=="}"&&Y){re+=L;continue}if(F&&(L!=="]"||!O)){let B;L==="-"?B=L:(L==="^"||L==="!")&&!O?B="^":L===e.$sj?B="":B=(0,f.$Fe)(L),O+=B;continue}switch(L){case"{":Y=!0;continue;case"[":F=!0;continue;case"}":{const T=`(?:${v(re,",").map(W=>b(W)).join("|")})`;G+=T,Y=!1,re="";break}case"]":{G+="["+O+"]",F=!1,O="";break}case"?":G+=w;continue;case"*":G+=d(1);continue;default:G+=(0,f.$Fe)(L)}}H<N.length-1&&(N[H+1]!==e.$rj||H+2<N.length)&&(G+=g)}q=X===e.$rj})}return G}const $=/^\*\*\/\*\.[\w\.-]+$/,m=/^\*\*\/([\w\.-]+)\/?$/,u=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,l=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,E=/^\*\*((\/[\w\.-]+)+)\/?$/,h=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,i=new M.$Dc(1e4),c=function(){return!1},o=function(){return null};function t(J,G){if(!J)return o;let N;typeof J!="string"?N=J.pattern:N=J,N=N.trim();const q=`${N}_${!!G.trimForExclusions}`;let X=i.get(q);if(X)return n(X,J);let H;return $.test(N)?X=p(N.substr(4),N):(H=m.exec(r(N,G)))?X=A(H[1],N):(G.trimForExclusions?l:u).test(N)?X=C(N,G):(H=E.exec(r(N,G)))?X=k(H[1].substr(1),N,!0):(H=h.exec(r(N,G)))?X=k(H[1],N,!1):X=I(N),i.set(q,X),n(X,J)}function n(J,G){if(typeof G=="string")return J;const N=function(q,X){return(0,s.$Xf)(q,G.base,!P.$l)?J((0,f.$Je)(q.substr(G.base.length),D.sep),X):null};return N.allBasenames=J.allBasenames,N.allPaths=J.allPaths,N.basenames=J.basenames,N.patterns=J.patterns,N}function r(J,G){return G.trimForExclusions&&J.endsWith("/**")?J.substr(0,J.length-2):J}function p(J,G){return function(N,q){return typeof N=="string"&&N.endsWith(J)?G:null}}function A(J,G){const N=`/${J}`,q=`\\${J}`,X=function(Y,re){return typeof Y!="string"?null:re?re===J?G:null:Y===J||Y.endsWith(N)||Y.endsWith(q)?G:null},H=[J];return X.basenames=H,X.patterns=[G],X.allBasenames=H,X}function C(J,G){const N=oe(J.slice(1,-1).split(",").map(re=>t(re,G)).filter(re=>re!==o),J),q=N.length;if(!q)return o;if(q===1)return N[0];const X=function(re,F){for(let O=0,L=N.length;O<L;O++)if(N[O](re,F))return J;return null},H=N.find(re=>!!re.allBasenames);H&&(X.allBasenames=H.allBasenames);const Y=N.reduce((re,F)=>F.allPaths?re.concat(F.allPaths):re,[]);return Y.length&&(X.allPaths=Y),X}function k(J,G,N){const q=D.sep===D.$gc.sep,X=q?J:J.replace(y,D.sep),H=D.sep+X,Y=D.$gc.sep+J;let re;return N?re=function(F,O){return typeof F=="string"&&(F===X||F.endsWith(H)||!q&&(F===J||F.endsWith(Y)))?G:null}:re=function(F,O){return typeof F=="string"&&(F===X||!q&&F===J)?G:null},re.allPaths=[(N?"*/":"./")+J],re}function I(J){try{const G=new RegExp(`^${b(J)}$`);return function(N){return G.lastIndex=0,typeof N=="string"&&G.test(N)?J:null}}catch{return o}}function j(J,G,N){return!J||typeof G!="string"?!1:U(J)(G,void 0,N)}e.$uj=j;function U(J,G={}){if(!J)return c;if(typeof J=="string"||z(J)){const N=t(J,G);if(N===o)return c;const q=function(X,H){return!!N(X,H)};return N.allBasenames&&(q.allBasenames=N.allBasenames),N.allPaths&&(q.allPaths=N.allPaths),q}return ae(J,G)}e.$vj=U;function z(J){const G=J;return G?typeof G.base=="string"&&typeof G.pattern=="string":!1}e.$wj=z;function ne(J){return J.allBasenames||[]}e.$xj=ne;function _(J){return J.allPaths||[]}e.$yj=_;function ae(J,G){const N=oe(Object.getOwnPropertyNames(J).map(re=>se(re,J[re],G)).filter(re=>re!==o)),q=N.length;if(!q)return o;if(!N.some(re=>!!re.requiresSiblings)){if(q===1)return N[0];const re=function(L,B){let T;for(let W=0,V=N.length;W<V;W++){const ce=N[W](L,B);if(typeof ce=="string")return ce;(0,R.$Gg)(ce)&&(T||(T=[]),T.push(ce))}return T?(async()=>{for(const W of T){const V=await W;if(typeof V=="string")return V}return null})():null},F=N.find(L=>!!L.allBasenames);F&&(re.allBasenames=F.allBasenames);const O=N.reduce((L,B)=>B.allPaths?L.concat(B.allPaths):L,[]);return O.length&&(re.allPaths=O),re}const X=function(re,F,O){let L,B;for(let T=0,W=N.length;T<W;T++){const V=N[T];V.requiresSiblings&&O&&(F||(F=(0,D.$nc)(re)),L||(L=F.substr(0,F.length-(0,D.$oc)(re).length)));const ce=V(re,F,L,O);if(typeof ce=="string")return ce;(0,R.$Gg)(ce)&&(B||(B=[]),B.push(ce))}return B?(async()=>{for(const T of B){const W=await T;if(typeof W=="string")return W}return null})():null},H=N.find(re=>!!re.allBasenames);H&&(X.allBasenames=H.allBasenames);const Y=N.reduce((re,F)=>F.allPaths?re.concat(F.allPaths):re,[]);return Y.length&&(X.allPaths=Y),X}function se(J,G,N){if(G===!1)return o;const q=t(J,N);if(q===o)return o;if(typeof G=="boolean")return q;if(G){const X=G.when;if(typeof X=="string"){const H=(Y,re,F,O)=>{if(!O||!q(Y,re))return null;const L=X.replace("$(basename)",()=>F),B=O(L);return(0,R.$Gg)(B)?B.then(T=>T?J:null):B?J:null};return H.requiresSiblings=!0,H}}return q}function oe(J,G){const N=J.filter(re=>!!re.basenames);if(N.length<2)return J;const q=N.reduce((re,F)=>{const O=F.basenames;return O?re.concat(O):re},[]);let X;if(G){X=[];for(let re=0,F=q.length;re<F;re++)X.push(G)}else X=N.reduce((re,F)=>{const O=F.patterns;return O?re.concat(O):re},[]);const H=function(re,F){if(typeof re!="string")return null;if(!F){let L;for(L=re.length;L>0;L--){const B=re.charCodeAt(L-1);if(B===47||B===92)break}F=re.substr(L)}const O=q.indexOf(F);return O!==-1?X[O]:null};H.basenames=q,H.patterns=X,H.allBasenames=q;const Y=J.filter(re=>!re.basenames);return Y.push(H),Y}function K(J,G){return(0,S.$ub)(J,G,(N,q)=>typeof N=="string"&&typeof q=="string"?N===q:typeof N!="string"&&typeof q!="string"?N.base===q.base&&N.pattern===q.pattern:!1)}e.$zj=K}),define(te[46],ie([0,1,23,33,9,4,19,27]),function(Q,e,S,R,s,M,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wv=e.$vv=e.$uv=e.$tv=e.$sv=e.$rv=e.$qv=e.$pv=e.$ov=e.$nv=void 0;function f(t,n){const{os:r,tildify:p,relative:A}=n;if(A){const I=a(t,A,r);if(typeof I=="string")return I}let C=t.fsPath;if(r===1&&!M.$j?C=C.replace(/\//g,"\\"):r!==1&&M.$j&&(C=C.replace(/\\/g,"/")),r!==1&&p?.userHome){const I=p.userHome.fsPath;let j;t.scheme!==p.userHome.scheme&&t.path.startsWith(s.$gc.sep)?j=p.userHome.with({path:t.path}).fsPath:j=t.fsPath,C=y(j,I,r)}return(r===1?s.$fc:s.$gc).normalize(g(C,r===1))}e.$nv=f;function a(t,n,r){const p=r===1?s.$fc:s.$gc,A=r===3?D.$lg:D.$ng,C=n.getWorkspace(),k=(0,S.$Ob)(C.folders);if(!k)return;t.scheme!==k.uri.scheme&&t.path.startsWith(s.$gc.sep)&&(t=k.uri.with({path:t.path}));const I=n.getWorkspaceFolder(t);if(!I)return;let j;if(A.isEqual(I.uri,t)?j="":j=A.relativePath(I.uri,t)??"",j&&(j=p.normalize(j)),C.folders.length>1&&!n.noPrefix){const U=I.name?I.name:A.basenameOrAuthority(I.uri);j=j?`${U} \u2022 ${j}`:U}return j}function g(t,n=M.$j){return(0,R.$2f)(t,n)?t.charAt(0).toUpperCase()+t.slice(1):t}e.$ov=g;let w=Object.create(null);function y(t,n,r=M.OS){if(r===1||!t||!n)return t;let p=w.original===n?w.normalized:void 0;p||(p=n,M.$j&&(p=(0,R.$Rf)(p)),p=`${(0,P.$Ke)(p,s.$gc.sep)}${s.$gc.sep}`,w={original:n,normalized:p});let A=t;return M.$j&&(A=(0,R.$Rf)(A)),(r===3?A.startsWith(p):(0,P.$3e)(A,p))?`~/${A.substr(p.length)}`:t}e.$pv=y;function d(t,n){return t.replace(/^~($|\/|\\)/,`${n}$1`)}e.$qv=d;const v="\u2026",b="\\\\",$="~";function m(t,n=s.sep){const r=new Array(t.length);let p=!1;for(let A=0;A<t.length;A++){const C=t[A];if(C===""){r[A]=`.${n}`;continue}if(!C){r[A]=C;continue}p=!0;let k="",I=C;I.indexOf(b)===0?(k=I.substr(0,I.indexOf(b)+b.length),I=I.substr(I.indexOf(b)+b.length)):I.indexOf(n)===0?(k=I.substr(0,I.indexOf(n)+n.length),I=I.substr(I.indexOf(n)+n.length)):I.indexOf($)===0&&(k=I.substr(0,I.indexOf($)+$.length),I=I.substr(I.indexOf($)+$.length));const j=I.split(n);for(let U=1;p&&U<=j.length;U++)for(let z=j.length-U;p&&z>=0;z--){p=!1;let ne=j.slice(z,z+U).join(n);for(let _=0;!p&&_<t.length;_++)if(_!==A&&t[_]&&t[_].indexOf(ne)>-1){const ae=z+U===j.length,se=z>0&&t[_].indexOf(n)>-1?n+ne:ne,oe=t[_].endsWith(se);p=!ae||oe}if(!p){let _="";(j[0].endsWith(":")||k!=="")&&(z===1&&(z=0,U++,ne=j[0]+n+ne),z>0&&(_=j[0]+n),_=k+_),z>0&&(_=_+v+n),_=_+ne,z+U<j.length&&(_=_+n+v),r[A]=_}}p&&(r[A]=C)}return r}e.$rv=m;var u;(function(t){t[t.TEXT=0]="TEXT",t[t.VARIABLE=1]="VARIABLE",t[t.SEPARATOR=2]="SEPARATOR"})(u||(u={}));function l(t,n=Object.create(null)){const r=[];let p=!1,A="";for(const C of t)if(C==="$"||p&&C==="{")A&&r.push({value:A,type:u.TEXT}),A="",p=!0;else if(C==="}"&&p){const k=n[A];if(typeof k=="string")k.length&&r.push({value:k,type:u.VARIABLE});else if(k){const I=r[r.length-1];(!I||I.type!==u.SEPARATOR)&&r.push({value:k.label,type:u.SEPARATOR})}A="",p=!1}else A+=C;return A&&!p&&r.push({value:A,type:u.TEXT}),r.filter((C,k)=>{if(C.type===u.SEPARATOR){const I=r[k-1],j=r[k+1];return[I,j].every(U=>U&&(U.type===u.VARIABLE||U.type===u.TEXT)&&U.value.length>0)}return!0}).map(C=>C.value).join("")}e.$sv=l;function E(t,n){return M.$k||n?t.replace(/\(&&\w\)|&&/g,"").replace(/&/g,M.$k?"&":"&&"):t.replace(/&&|&/g,r=>r==="&"?"&&":"&")}e.$tv=E;function h(t,n){return M.$k||n?t.replace(/\(&&\w\)|&&/g,""):M.$j?t.replace(/&&|&/g,r=>r==="&"?"&&":"&"):t.replace(/&&/g,"_")}e.$uv=h;function i(t){return t.replace(/&/g,"&&")}e.$vv=i;function c(t){if(t.endsWith("]")){const n=t.lastIndexOf(" [",t.length-2);if(n!==-1){const r=o(t.substring(0,n));return{name:r.name,parentPath:r.parentPath+t.substring(n)}}}return o(t)}e.$wv=c;function o(t){const n=t.indexOf("/")!==-1?s.$gc:s.$fc,r=n.basename(t),p=n.dirname(t);return r.length?{name:r,parentPath:p}:{name:p,parentPath:""}}}),define(te[153],ie([0,1,17,7]),function(Q,e,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nm=e.$Mm=e.$Lm=e.$Km=e.$Jm=void 0;function s(w){return w.toJSON()}class M{constructor(y){this.a=y}transformIncoming(y){const d=this.a.transformIncoming(y);return d===y?y:s(R.URI.from(d))}transformOutgoing(y){const d=this.a.transformOutgoing(y);return d===y?y:s(R.URI.from(d))}transformOutgoingURI(y){const d=this.a.transformOutgoing(y);return d===y?y:R.URI.from(d)}transformOutgoingScheme(y){return this.a.transformOutgoingScheme(y)}}e.$Jm=M,e.$Km=new class{transformIncoming(w){return w}transformOutgoing(w){return w}transformOutgoingURI(w){return w}transformOutgoingScheme(w){return w}};function D(w,y,d){if(!w||d>200)return null;if(typeof w=="object"){if(w instanceof R.URI)return y.transformOutgoing(w);for(const v in w)if(Object.hasOwnProperty.call(w,v)){const b=D(w[v],y,d+1);b!==null&&(w[v]=b)}}return null}function P(w,y){const d=D(w,y,0);return d===null?w:d}e.$Lm=P;function f(w,y,d,v){if(!w||v>200)return null;if(typeof w=="object"){if(w.$mid===1)return d?R.URI.revive(y.transformIncoming(w)):y.transformIncoming(w);if(w instanceof S.$be)return null;for(const b in w)if(Object.hasOwnProperty.call(w,b)){const $=f(w[b],y,d,v+1);$!==null&&(w[b]=$)}}return null}function a(w,y){const d=f(w,y,!1,0);return d===null?w:d}e.$Mm=a;function g(w,y){const d=f(w,y,!0,0);return d===null?w:d}e.$Nm=g}),define(te[21],ie([0,1,45,28,154,8,33,84,9,4,19,7]),function(Q,e,S,R,s,M,D,P,f,a,g,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.configureFlushOnWrite=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var y;(function(se){se[se.UNLINK=0]="UNLINK",se[se.MOVE=1]="MOVE"})(y||(e.RimRafMode=y={}));async function d(se,oe=y.UNLINK,K){if((0,D.$1f)(se))throw new Error("rimraf - will refuse to recursively delete root");return oe===y.UNLINK?b(se):v(se,K)}async function v(se,oe=(0,D.$6f)((0,R.tmpdir)())){try{try{await S.promises.rename(se,oe)}catch(K){return K.code==="ENOENT"?void 0:b(se)}b(oe).catch(K=>{})}catch(K){if(K.code!=="ENOENT")throw K}}async function b(se){return(0,s.promisify)(S.rm)(se,{recursive:!0,force:!0,maxRetries:3})}function $(se){if((0,D.$1f)(se))throw new Error("rimraf - will refuse to recursively delete root");S.rmSync(se,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=$;async function m(se,oe){return E(await(oe?u(se):(0,s.promisify)(S.readdir)(se)))}async function u(se){try{return await(0,s.promisify)(S.readdir)(se,{withFileTypes:!0})}catch(J){console.warn("[node.js fs] readdir with filetypes failed with error: ",J)}const oe=[],K=await m(se);for(const J of K){let G=!1,N=!1,q=!1;try{const X=await e.Promises.lstat((0,f.$jc)(se,J));G=X.isFile(),N=X.isDirectory(),q=X.isSymbolicLink()}catch(X){console.warn("[node.js fs] unexpected error from lstat after readdir: ",X)}oe.push({name:J,isFile:()=>G,isDirectory:()=>N,isSymbolicLink:()=>q})}return oe}function l(se){return E(S.readdirSync(se))}e.readdirSync=l;function E(se){return se.map(oe=>typeof oe=="string"?a.$k?(0,P.$ml)(oe):oe:(oe.name=a.$k?(0,P.$ml)(oe.name):oe.name,oe))}async function h(se){const oe=await m(se),K=[];for(const J of oe)await c.existsDirectory((0,f.$jc)(se,J))&&K.push(J);return K}function i(se,oe=1e3){return new Promise(K=>{let J=!1;const G=setInterval(()=>{J||(J=!0,S.access(se,N=>{J=!1,N&&(clearInterval(G),K(void 0))}))},oe)})}e.whenDeleted=i;var c;(function(se){async function oe(G){let N;try{if(N=await e.Promises.lstat(G),!N.isSymbolicLink())return{stat:N}}catch{}try{return{stat:await e.Promises.stat(G),symbolicLink:N?.isSymbolicLink()?{dangling:!1}:void 0}}catch(q){if(q.code==="ENOENT"&&N)return{stat:N,symbolicLink:{dangling:!0}};if(a.$j&&q.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(G)),symbolicLink:{dangling:!1}}}catch(X){if(X.code==="ENOENT"&&N)return{stat:N,symbolicLink:{dangling:!0}};throw X}throw q}}se.stat=oe;async function K(G){try{const{stat:N,symbolicLink:q}=await se.stat(G);return N.isFile()&&q?.dangling!==!0}catch{}return!1}se.existsFile=K;async function J(G){try{const{stat:N,symbolicLink:q}=await se.stat(G);return N.isDirectory()&&q?.dangling!==!0}catch{}return!1}se.existsDirectory=J})(c||(e.SymlinkSupport=c={}));const o=new M.$3g;function t(se,oe,K){return o.queueFor(w.URI.file(se),g.$mg).queue(()=>{const J=C(K);return new Promise((G,N)=>p(se,oe,J,q=>q?N(q):G()))})}let n=!0;function r(se){n=se}e.configureFlushOnWrite=r;function p(se,oe,K,J){if(!n)return S.writeFile(se,oe,{mode:K.mode,flag:K.flag},J);S.open(se,K.flag,K.mode,(G,N)=>{if(G)return J(G);S.writeFile(N,oe,q=>{if(q)return S.close(N,()=>J(q));S.fdatasync(N,X=>(X&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",X),r(!1)),S.close(N,H=>J(H))))})})}function A(se,oe,K){const J=C(K);if(!n)return S.writeFileSync(se,oe,{mode:J.mode,flag:J.flag});const G=S.openSync(se,J.flag,J.mode);try{S.writeFileSync(G,oe);try{S.fdatasyncSync(G)}catch(N){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",N),r(!1)}}finally{S.closeSync(G)}}e.writeFileSync=A;function C(se){return se?{mode:typeof se.mode=="number"?se.mode:438,flag:typeof se.flag=="string"?se.flag:"w"}:{mode:438,flag:"w"}}async function k(se,oe,K=6e4){if(se!==oe)try{a.$j&&typeof K=="number"?await I(se,oe,Date.now(),K):await(0,s.promisify)(S.rename)(se,oe)}catch(J){if(se.toLowerCase()!==oe.toLowerCase()&&J.code==="EXDEV"||se.endsWith("."))await j(se,oe,{preserveSymlinks:!1}),await d(se,y.MOVE);else throw J}}async function I(se,oe,K,J,G=0){try{return await(0,s.promisify)(S.rename)(se,oe)}catch(N){if(N.code!=="EACCES"&&N.code!=="EPERM"&&N.code!=="EBUSY")throw N;if(Date.now()-K>=J)throw console.error(`[node.js fs] rename failed after ${G} retries with error: ${N}`),N;if(G===0){let q=!1;try{const{stat:X}=await c.stat(oe);X.isFile()||(q=!0)}catch{}if(q)throw N}return await(0,M.$Ug)(Math.min(100,G*10)),I(se,oe,K,J,G+1)}}async function j(se,oe,K){return z(se,oe,{root:{source:se,target:oe},options:K,handledSourcePaths:new Set})}const U=511;async function z(se,oe,K){if(K.handledSourcePaths.has(se))return;K.handledSourcePaths.add(se);const{stat:J,symbolicLink:G}=await c.stat(se);if(G){if(K.options.preserveSymlinks)try{return await ae(se,oe,K)}catch(N){console.warn("[node.js fs] copy of symlink failed: ",N)}if(G.dangling)return}return J.isDirectory()?ne(se,oe,J.mode&U,K):_(se,oe,J.mode&U)}async function ne(se,oe,K,J){await e.Promises.mkdir(oe,{recursive:!0,mode:K});const G=await m(se);for(const N of G)await z((0,f.$jc)(se,N),(0,f.$jc)(oe,N),J)}async function _(se,oe,K){await e.Promises.copyFile(se,oe),await e.Promises.chmod(oe,K)}async function ae(se,oe,K){let J=await e.Promises.readlink(se);(0,D.$Xf)(J,K.root.source,!a.$l)&&(J=(0,f.$jc)(K.root.target,J.substr(K.root.source.length+1))),await e.Promises.symlink(J,oe)}e.Promises=new class{get access(){return(0,s.promisify)(S.access)}get stat(){return(0,s.promisify)(S.stat)}get lstat(){return(0,s.promisify)(S.lstat)}get utimes(){return(0,s.promisify)(S.utimes)}get read(){return(se,oe,K,J,G)=>new Promise((N,q)=>{S.read(se,oe,K,J,G,(X,H,Y)=>X?q(X):N({bytesRead:H,buffer:Y}))})}get readFile(){return(0,s.promisify)(S.readFile)}get write(){return(se,oe,K,J,G)=>new Promise((N,q)=>{S.write(se,oe,K,J,G,(X,H,Y)=>X?q(X):N({bytesWritten:H,buffer:Y}))})}get appendFile(){return(0,s.promisify)(S.appendFile)}get fdatasync(){return(0,s.promisify)(S.fdatasync)}get truncate(){return(0,s.promisify)(S.truncate)}get copyFile(){return(0,s.promisify)(S.copyFile)}get open(){return(0,s.promisify)(S.open)}get close(){return(0,s.promisify)(S.close)}get symlink(){return(0,s.promisify)(S.symlink)}get readlink(){return(0,s.promisify)(S.readlink)}get chmod(){return(0,s.promisify)(S.chmod)}get mkdir(){return(0,s.promisify)(S.mkdir)}get unlink(){return(0,s.promisify)(S.unlink)}get rmdir(){return(0,s.promisify)(S.rmdir)}get realpath(){return(0,s.promisify)(S.realpath)}async exists(se){try{return await e.Promises.access(se),!0}catch{return!1}}get readdir(){return m}get readDirsInDir(){return h}get writeFile(){return t}get rm(){return d}get rename(){return k}get copy(){return j}}}),define(te[105],ie([0,1,45,9,4,27,21]),function(Q,e,S,R,s,M,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6p=e.$5p=e.$4p=e.$3p=void 0;function P(y){if(s.$l)return y;const d=(0,R.$mc)(y);if(y===d)return y;const v=((0,R.$nc)(y)||y).toLowerCase();try{const $=(0,D.readdirSync)(d).filter(m=>m.toLowerCase()===v);if($.length===1){const m=P(d);if(m)return(0,R.$jc)(m,$[0])}else if($.length>1){const m=$.indexOf(v);if(m>=0){const u=P(d);if(u)return(0,R.$jc)(u,$[m])}}}catch{}return null}e.$3p=P;async function f(y){if(s.$l)return y;const d=(0,R.$mc)(y);if(y===d)return y;const v=((0,R.$nc)(y)||y).toLowerCase();try{const $=(await D.Promises.readdir(d)).filter(m=>m.toLowerCase()===v);if($.length===1){const m=await f(d);if(m)return(0,R.$jc)(m,$[0])}else if($.length>1){const m=$.indexOf(v);if(m>=0){const u=await f(d);if(u)return(0,R.$jc)(u,$[m])}}}catch{}return null}e.$4p=f;async function a(y){try{return await D.Promises.realpath(y)}catch{const v=w(y);return await D.Promises.access(v,S.constants.R_OK),v}}e.$5p=a;function g(y){try{return S.realpathSync(y)}catch{const v=w(y);return S.accessSync(v,S.constants.R_OK),v}}e.$6p=g;function w(y){return(0,M.$Ke)((0,R.$hc)(y),R.sep)}}),define(te[106],ie([0,1,28,9,21]),function(Q,e,S,R,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wl=e.$vl=void 0;const M=/^\d+$/,D=/^Microsoft.PowerShell_.*/,P=/^Microsoft.PowerShellPreview_.*/;var f;(function(E){E[E.x64=0]="x64",E[E.x86=1]="x86",E[E.ARM=2]="ARM"})(f||(f={}));let a;switch(process.arch){case"ia32":a=1;break;case"arm":case"arm64":a=2;break;default:a=0;break}let g;process.env.PROCESSOR_ARCHITEW6432?g=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?g=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?g=1:g=0;class w{constructor(h,i,c){this.exePath=h,this.displayName=i,this.a=c}async exists(){return this.a===void 0&&(this.a=await s.SymlinkSupport.existsFile(this.exePath)),this.a}}function y({useAlternateBitness:E=!1}={}){return E?a===0?process.env["ProgramFiles(x86)"]||null:g===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function d({useAlternateBitness:E=!1,findPreview:h=!1}={}){const i=y({useAlternateBitness:E});if(!i)return null;const c=R.$jc(i,"PowerShell");if(!await s.SymlinkSupport.existsDirectory(c))return null;let o=-1,t=null;for(const p of await s.Promises.readdir(c)){let A=-1;if(h){const k=p.indexOf("-");if(k<0)continue;const I=p.substring(0,k);if(!M.test(I)||p.substring(k+1)!=="preview")continue;A=parseInt(I,10)}else{if(!M.test(p))continue;A=parseInt(p,10)}if(A<=o)continue;const C=R.$jc(c,p,"pwsh.exe");await s.SymlinkSupport.existsFile(C)&&(t=C,o=A)}if(!t)return null;const n=i.includes("x86")?" (x86)":"",r=h?" Preview":"";return new w(t,`PowerShell${r}${n}`,!0)}async function v({findPreview:E}={}){if(!process.env.LOCALAPPDATA)return null;const h=R.$jc(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await s.SymlinkSupport.existsDirectory(h))return null;const{pwshMsixDirRegex:i,pwshMsixName:c}=E?{pwshMsixDirRegex:P,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:D,pwshMsixName:"PowerShell (Store)"};for(const o of await s.Promises.readdir(h))if(i.test(o)){const t=R.$jc(h,o,"pwsh.exe");return new w(t,c)}return null}function b(){const E=R.$jc(S.homedir(),".dotnet","tools","pwsh.exe");return new w(E,".NET Core PowerShell Global Tool")}function $(){const E=R.$jc(process.env.windir,a===1&&g!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new w(E,"Windows PowerShell",!0)}async function*m(){let E=await d();E&&(yield E),E=await d({useAlternateBitness:!0}),E&&(yield E),E=await v(),E&&(yield E),E=b(),E&&(yield E),E=await d({findPreview:!0}),E&&(yield E),E=await v({findPreview:!0}),E&&(yield E),E=await d({useAlternateBitness:!0,findPreview:!0}),E&&(yield E),E=$(),E&&(yield E)}async function*u(){for await(const E of m())await E.exists()&&(yield E)}e.$vl=u;async function l(){for await(const E of u())return E;return null}e.$wl=l}),define(te[88],ie([0,1,9,4,35,75,12,21]),function(Q,e,S,R,s,M,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.$Al=e.$zl=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return M.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return M.TerminateResponseCode}});function f(w=s.env){return w.comspec||"cmd.exe"}e.$zl=f;function a(w){let y=[],d=!1;const v=function(b){if(d){y.push(b);return}(!w.send(b,m=>{if(m&&console.error(m),d=!1,y.length>0){const u=y.slice(0);y=[],u.forEach(l=>v(l))}})||R.$j)&&(d=!0)};return{send:v}}e.$Al=a;var g;(function(w){async function y(d,v,b){if(S.$ic(d))return d;if(v===void 0&&(v=s.cwd()),S.$mc(d)!=="."||(b===void 0&&D.$yf(s.env.PATH)&&(b=s.env.PATH.split(S.$tc)),b===void 0||b.length===0))return S.$jc(v,d);async function m(u){if(await P.Promises.exists(u)){let l;try{l=await P.Promises.stat(u)}catch(E){E.message.startsWith("EACCES")&&(l=await P.Promises.lstat(u))}return l?!l.isDirectory():!1}return!1}for(const u of b){let l;if(S.$ic(u)?l=S.$jc(u,d):l=S.$jc(v,u,d),await m(l))return l;let E=l+".com";if(await m(E)||(E=l+".exe",await m(E)))return E}return S.$jc(v,d)}w.findExecutable=y})(g||(e.win32=g={}))}),define(te[107],ie([0,1,47,13]),function(Q,e,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ar=void 0;function s(D){return new Promise((P,f)=>{let a;const g=new Map;function w(d,v,b,$,m){const u=g.get(v);if(d===D||u){const l={name:y(b),cmd:b,pid:d,ppid:v,load:$,mem:m};g.set(d,l),d===D&&(a=l),u&&(u.children||(u.children=[]),u.children.push(l),u.children.length>1&&(u.children=u.children.sort((E,h)=>E.pid-h.pid)))}}function y(d){const v=/--utility-sub-type=network/i,b=/--ms-enable-electron-run-as-node/i,$=/--crashes-directory/i,m=/\\pipe\\winpty-control/i,u=/conhost\.exe.+--headless/i,l=/--type=([a-zA-Z-]+)/;if($.exec(d))return"electron-crash-reporter";if(m.exec(d))return"winpty-agent";if(u.exec(d))return"conpty-agent";let E=l.exec(d);if(E&&E.length===2)return E[1]==="renderer"?"window":E[1]==="utility"?v.exec(d)?"utility-network-service":"utility-process":E[1]==="extensionHost"?"extension-host":E[1];const h=/[a-zA-Z-]+\.js/g;let i="";do E=h.exec(d),E&&(i+=E+" ");while(E);return i&&d.indexOf("node ")<0&&d.indexOf("node.exe")<0?`electron-nodejs (${i})`:b.exec(d)?`electron-nodejs (${d})`:d}if(process.platform==="win32"){const d=v=>v.indexOf("\\\\?\\")===0||v.indexOf("\\??\\")===0?v.substring(4):v.indexOf('"\\\\?\\')===0||v.indexOf('"\\??\\')===0?'"'+v.substring(5):v;new Promise((v,b)=>{Q(["@vscode/windows-process-tree"],v,b)}).then(v=>{v.getProcessList(D,b=>{if(!b){f(new Error(`Root process ${D} not found`));return}v.getProcessCpuUsage(b,$=>{const m=new Map;$.forEach(u=>{const l=d(u.commandLine||"");m.set(u.pid,{name:y(l),cmd:l,pid:u.pid,ppid:u.ppid,load:u.cpu||0,mem:u.memory||0})}),a=m.get(D),a?(m.forEach(u=>{const l=m.get(u.ppid);l&&(l.children||(l.children=[]),l.children.push(u))}),m.forEach(u=>{u.children&&(u.children=u.children.sort((l,E)=>l.pid-E.pid))}),P(a)):f(new Error(`Root process ${D} not found`))})},v.ProcessDataFlag.CommandLine|v.ProcessDataFlag.Memory)})}else{let d=function(){let v=[a];const b=[];for(;v.length;){const m=v.shift();m&&(b.push(m.pid),m.children&&(v=v.concat(m.children)))}let $=JSON.stringify(R.$cg.asFileUri("vs/base/node/cpuUsage.sh").fsPath);$+=" "+b.join(" "),(0,S.exec)($,{},(m,u,l)=>{if(m||l)f(m||new Error(l.toString()));else{const E=u.toString().split(`
`);for(let h=0;h<b.length;h++){const i=g.get(b[h]);i.load=parseFloat(E[h])}if(!a){f(new Error(`Root process ${D} not found`));return}P(a)}})};(0,S.exec)("which ps",{},(v,b,$)=>{if(v||$)if(process.platform!=="linux")f(v||new Error($.toString()));else{const m=JSON.stringify(R.$cg.asFileUri("vs/base/node/ps.sh").fsPath);(0,S.exec)(m,{},(u,l,E)=>{u||E?f(u||new Error(E.toString())):(M(l,w),d())})}else{const m=b.toString().trim(),u="-ax -o pid=,ppid=,pcpu=,pmem=,command=";(0,S.exec)(`${m} ${u}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(l,E,h)=>{l||h&&!h.includes("screen size is bogus")?f(l||new Error(h.toString())):(M(E,w),process.platform==="linux"?d():a?P(a):f(new Error(`Root process ${D} not found`)))})}})}})}e.$Ar=s;function M(D,P){const f=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,a=D.toString().split(`
`);for(const g of a){const w=f.exec(g.trim());w&&w.length===6&&P(parseInt(w[1]),parseInt(w[2]),w[5],parseFloat(w[3]),parseFloat(w[4]))}}}),define(te[108],ie([0,1,28,4,106,88]),function(Q,e,S,R,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bl=void 0;async function D(w,y){return w===1?R.$j?g():M.$zl(y):f(w,y)}e.$Bl=D;let P=null;function f(w,y){if(R.$l&&w===2||R.$k&&w===3)return"/bin/bash";if(!P){let d;if(R.$j)d="/bin/bash";else{if(d=y.SHELL,!d)try{d=(0,S.userInfo)().shell}catch{}d||(d="sh"),d==="/bin/false"&&(d="/bin/bash")}P=d}return P}let a=null;async function g(){return a||(a=(await(0,s.$wl)()).exePath),a}});var ke=this&&this.__decorate||function(Q,e,S,R){var s=arguments.length,M=s<3?e:R===null?R=Object.getOwnPropertyDescriptor(e,S):R,D;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")M=Reflect.decorate(Q,e,S,R);else for(var P=Q.length-1;P>=0;P--)(D=Q[P])&&(M=(s<3?D(M):s>3?D(e,S,M):D(e,S))||M);return s>3&&M&&Object.defineProperty(e,S,M),M};define(te[42],ie([0,1,23,8,17,22,54,14,3,2,76,27,12]),function(Q,e,S,R,s,M,D,P,f,a,g,w,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xh=e.ProxyChannel=e.$wh=e.$vh=e.$uh=e.$th=e.$sh=e.$rh=e.RequestInitiator=e.$qh=e.$ph=e.$oh=e.$nh=e.$mh=void 0;var d;(function(G){G[G.Promise=100]="Promise",G[G.PromiseCancel=101]="PromiseCancel",G[G.EventListen=102]="EventListen",G[G.EventDispose=103]="EventDispose"})(d||(d={}));function v(G){switch(G){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var b;(function(G){G[G.Initialize=200]="Initialize",G[G.PromiseSuccess=201]="PromiseSuccess",G[G.PromiseError=202]="PromiseError",G[G.PromiseErrorObj=203]="PromiseErrorObj",G[G.EventFire=204]="EventFire"})(b||(b={}));function $(G){switch(G){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var m;(function(G){G[G.Uninitialized=0]="Uninitialized",G[G.Idle=1]="Idle"})(m||(m={}));function u(G){let N=0;for(let q=0;;q+=7){const X=G.read(1);if(N|=(X.buffer[0]&127)<<q,!(X.buffer[0]&128))return N}}const l=o(0);function E(G,N){if(N===0){G.write(l);return}let q=0;for(let H=N;H!==0;H=H>>>7)q++;const X=s.$be.alloc(q);for(let H=0;N!==0;H++)X.buffer[H]=N&127,N=N>>>7,N>0&&(X.buffer[H]|=128);G.write(X)}class h{constructor(N){this.b=N,this.a=0}read(N){const q=this.b.slice(this.a,this.a+N);return this.a+=q.byteLength,q}}e.$mh=h;class i{constructor(){this.a=[]}get buffer(){return s.$be.concat(this.a)}write(N){this.a.push(N)}}e.$nh=i;var c;(function(G){G[G.Undefined=0]="Undefined",G[G.String=1]="String",G[G.Buffer=2]="Buffer",G[G.VSBuffer=3]="VSBuffer",G[G.Array=4]="Array",G[G.Object=5]="Object",G[G.Int=6]="Int"})(c||(c={}));function o(G){const N=s.$be.alloc(1);return N.writeUInt8(G,0),N}const t={Undefined:o(c.Undefined),String:o(c.String),Buffer:o(c.Buffer),VSBuffer:o(c.VSBuffer),Array:o(c.Array),Object:o(c.Object),Uint:o(c.Int)},n=typeof Buffer<"u";function r(G,N){if(typeof N>"u")G.write(t.Undefined);else if(typeof N=="string"){const q=s.$be.fromString(N);G.write(t.String),E(G,q.byteLength),G.write(q)}else if(n&&Buffer.isBuffer(N)){const q=s.$be.wrap(N);G.write(t.Buffer),E(G,q.byteLength),G.write(q)}else if(N instanceof s.$be)G.write(t.VSBuffer),E(G,N.byteLength),G.write(N);else if(Array.isArray(N)){G.write(t.Array),E(G,N.length);for(const q of N)r(G,q)}else if(typeof N=="number"&&(N|0)===N)G.write(t.Uint),E(G,N);else{const q=s.$be.fromString(JSON.stringify(N));G.write(t.Object),E(G,q.byteLength),G.write(q)}}e.$oh=r;function p(G){switch(G.read(1).readUInt8(0)){case c.Undefined:return;case c.String:return G.read(u(G)).toString();case c.Buffer:return G.read(u(G)).buffer;case c.VSBuffer:return G.read(u(G));case c.Array:{const q=u(G),X=[];for(let H=0;H<q;H++)X.push(p(G));return X}case c.Object:return JSON.parse(G.read(u(G)).toString());case c.Int:return u(G)}}e.$ph=p;class A{constructor(N,q,X=null,H=1e3){this.h=N,this.j=q,this.k=X,this.l=H,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(Y=>this.q(Y)),this.m({type:200})}registerChannel(N,q){this.b.set(N,q),setTimeout(()=>this.w(N),0)}m(N){switch(N.type){case 200:{const q=this.o([N.type]);this.k?.logOutgoing(q,0,1,$(N.type));return}case 201:case 202:case 204:case 203:{const q=this.o([N.type,N.id],N.data);this.k?.logOutgoing(q,N.id,1,$(N.type),N.data);return}}}o(N,q=void 0){const X=new i;return r(X,N),r(X,q),this.p(X.buffer)}p(N){try{return this.h.send(N),N.byteLength}catch{return 0}}q(N){const q=new h(N),X=p(q),H=p(q),Y=X[0];switch(Y){case 100:return this.k?.logIncoming(N.byteLength,X[1],1,`${v(Y)}: ${X[2]}.${X[3]}`,H),this.s({type:Y,id:X[1],channelName:X[2],name:X[3],arg:H});case 102:return this.k?.logIncoming(N.byteLength,X[1],1,`${v(Y)}: ${X[2]}.${X[3]}`,H),this.t({type:Y,id:X[1],channelName:X[2],name:X[3],arg:H});case 101:return this.k?.logIncoming(N.byteLength,X[1],1,`${v(Y)}`),this.u({type:Y,id:X[1]});case 103:return this.k?.logIncoming(N.byteLength,X[1],1,`${v(Y)}`),this.u({type:Y,id:X[1]})}}s(N){const q=this.b.get(N.channelName);if(!q){this.v(N);return}const X=new M.$Xd;let H;try{H=q.call(this.j,N.name,N.arg,X.token)}catch(F){H=Promise.reject(F)}const Y=N.id;H.then(F=>{this.m({id:Y,data:F,type:201})},F=>{F instanceof Error?this.m({id:Y,data:{message:F.message,name:F.name,stack:F.stack?F.stack.split?F.stack.split(`
`):F.stack:void 0},type:202}):this.m({id:Y,data:F,type:203})}).finally(()=>{re.dispose(),this.d.delete(N.id)});const re=(0,a.$Qc)(()=>X.cancel());this.d.set(N.id,re)}t(N){const q=this.b.get(N.channelName);if(!q){this.v(N);return}const X=N.id,Y=q.listen(this.j,N.name,N.arg)(re=>this.m({id:X,data:re,type:204}));this.d.set(N.id,Y)}u(N){const q=this.d.get(N.id);q&&(q.dispose(),this.d.delete(N.id))}v(N){let q=this.g.get(N.channelName);q||(q=[],this.g.set(N.channelName,q));const X=setTimeout(()=>{console.error(`Unknown channel: ${N.channelName}`),N.type===100&&this.m({id:N.id,data:{name:"Unknown channel",message:`Channel name '${N.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);q.push({request:N,timeoutTimer:X})}w(N){const q=this.g.get(N);if(q){for(const X of q)switch(clearTimeout(X.timeoutTimer),X.request.type){case 100:this.s(X.request);break;case 102:this.t(X.request);break}this.g.delete(N)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,a.$Nc)(this.d.values()),this.d.clear()}}e.$qh=A;var C;(function(G){G[G.LocalSide=0]="LocalSide",G[G.OtherSide=1]="OtherSide"})(C||(e.RequestInitiator=C={}));class k{constructor(N,q=null){this.l=N,this.a=!1,this.b=m.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new f.$Nd,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(X=>this.s(X)),this.j=q}getChannel(N){const q=this;return{call(X,H,Y){return q.a?Promise.reject(new P.$5):q.m(N,X,H,Y)},listen(X,H){return q.a?f.Event.None:q.o(N,X,H)}}}m(N,q,X,H=M.CancellationToken.None){const Y=this.g++,F={id:Y,type:100,channelName:N,name:q,arg:X};if(H.isCancellationRequested)return Promise.reject(new P.$5);let O;return new Promise((B,T)=>{if(H.isCancellationRequested)return T(new P.$5);const W=()=>{const ue=fe=>{switch(fe.type){case 201:this.f.delete(Y),B(fe.data);break;case 202:{this.f.delete(Y);const ye=new Error(fe.data.message);ye.stack=Array.isArray(fe.data.stack)?fe.data.stack.join(`
`):fe.data.stack,ye.name=fe.data.name,T(ye);break}case 203:this.f.delete(Y),T(fe.data);break}};this.f.set(Y,ue),this.p(F)};let V=null;this.b===m.Idle?W():(V=(0,R.$Hg)(ue=>this.u()),V.then(()=>{V=null,W()}));const ce=()=>{V?(V.cancel(),V=null):this.p({id:Y,type:101}),T(new P.$5)},de=H.onCancellationRequested(ce);O=(0,a.$Pc)((0,a.$Qc)(ce),de),this.d.add(O)}).finally(()=>{O.dispose(),this.d.delete(O)})}o(N,q,X){const H=this.g++,re={id:H,type:102,channelName:N,name:q,arg:X};let F=null;const O=new f.$Nd({onWillAddFirstListener:()=>{F=(0,R.$Hg)(B=>this.u()),F.then(()=>{F=null,this.d.add(O),this.p(re)})},onDidRemoveLastListener:()=>{F?(F.cancel(),F=null):(this.d.delete(O),this.p({id:H,type:103}))}}),L=B=>O.fire(B.data);return this.f.set(H,L),O.event}p(N){switch(N.type){case 100:case 102:{const q=this.q([N.type,N.id,N.channelName,N.name],N.arg);this.j?.logOutgoing(q,N.id,0,`${v(N.type)}: ${N.channelName}.${N.name}`,N.arg);return}case 101:case 103:{const q=this.q([N.type,N.id]);this.j?.logOutgoing(q,N.id,0,v(N.type));return}}}q(N,q=void 0){const X=new i;return r(X,N),r(X,q),this.r(X.buffer)}r(N){try{return this.l.send(N),N.byteLength}catch{return 0}}s(N){const q=new h(N),X=p(q),H=p(q),Y=X[0];switch(Y){case 200:return this.j?.logIncoming(N.byteLength,0,0,$(Y)),this.t({type:X[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(N.byteLength,X[1],0,$(Y),H),this.t({type:X[0],id:X[1],data:H})}}t(N){if(N.type===200){this.b=m.Idle,this.k.fire();return}this.f.get(N.id)?.(N)}get onDidInitializePromise(){return f.Event.toPromise(this.onDidInitialize)}u(){return this.b===m.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,a.$Nc)(this.d.values()),this.d.clear()}}e.$rh=k,ke([D.$gh],k.prototype,"onDidInitializePromise",null);class I{get connections(){const N=[];return this.f.forEach(q=>N.push(q)),N}constructor(N){this.a=new Map,this.f=new Set,this.g=new f.$Nd,this.onDidAddConnection=this.g.event,this.h=new f.$Nd,this.onDidRemoveConnection=this.h.event,this.j=new a.$Rc,this.j.add(N(({protocol:q,onDidClientDisconnect:X})=>{const H=f.Event.once(q.onMessage);this.j.add(H(Y=>{const re=new h(Y),F=p(re),O=new A(q,F),L=new k(q);this.a.forEach((T,W)=>O.registerChannel(W,T));const B={channelServer:O,channelClient:L,ctx:F};this.f.add(B),this.g.fire(B),this.j.add(X(()=>{O.dispose(),L.dispose(),this.f.delete(B),this.h.fire(B)}))}))}))}getChannel(N,q){const X=this;return{call(H,Y,re){let F;if((0,y.$Mf)(q)){const L=(0,S.$4b)(X.connections.filter(q));F=L?Promise.resolve(L):f.Event.toPromise(f.Event.filter(X.onDidAddConnection,q))}else F=q.routeCall(X,H,Y);const O=F.then(L=>L.channelClient.getChannel(N));return U(O).call(H,Y,re)},listen(H,Y){if((0,y.$Mf)(q))return X.k(N,q,H,Y);const re=q.routeEvent(X,H,Y).then(F=>F.channelClient.getChannel(N));return U(re).listen(H,Y)}}}k(N,q,X,H){const Y=this;let re;const F=new f.$Nd({onWillAddFirstListener:()=>{re=new a.$Rc;const O=new f.$Td,L=new Map,B=W=>{const ce=W.channelClient.getChannel(N).listen(X,H),de=O.add(ce);L.set(W,de)},T=W=>{const V=L.get(W);V&&(V.dispose(),L.delete(W))};Y.connections.filter(q).forEach(B),f.Event.filter(Y.onDidAddConnection,q)(B,void 0,re),Y.onDidRemoveConnection(T,void 0,re),O.event(F.fire,F,re),re.add(O)},onDidRemoveLastListener:()=>{re?.dispose(),re=void 0}});return F.event}registerChannel(N,q){this.a.set(N,q);for(const X of this.f)X.channelServer.registerChannel(N,q)}dispose(){this.j.dispose();for(const N of this.f)N.channelClient.dispose(),N.channelServer.dispose();this.f.clear(),this.a.clear(),this.g.dispose(),this.h.dispose()}}e.$sh=I;class j{constructor(N,q,X=null){const H=new i;r(H,q),N.send(H.buffer),this.a=new k(N,X),this.d=new A(N,q,X)}getChannel(N){return this.a.getChannel(N)}registerChannel(N,q){this.d.registerChannel(N,q)}dispose(){this.a.dispose(),this.d.dispose()}}e.$th=j;function U(G){return{call(N,q,X){return G.then(H=>H.call(N,q,X))},listen(N,q){const X=new f.$Wd;return G.then(H=>X.input=H.listen(N,q)),X.event}}}e.$uh=U;function z(G){let N=!1;return{call(q,X,H){return N?G.call(q,X,H):(0,R.$Ug)(0).then(()=>N=!0).then(()=>G.call(q,X,H))},listen(q,X){if(N)return G.listen(q,X);const H=new f.$Wd;return(0,R.$Ug)(0).then(()=>N=!0).then(()=>H.input=G.listen(q,X)),H.event}}}e.$vh=z;class ne{constructor(N){this.a=N}routeCall(N){return this.b(N)}routeEvent(N){return this.b(N)}async b(N){for(const q of N.connections)if(await Promise.resolve(this.a(q.ctx)))return Promise.resolve(q);return await f.Event.toPromise(N.onDidAddConnection),await this.b(N)}}e.$wh=ne;var _;(function(G){function N(Y,re,F){const O=Y,L=F&&F.disableMarshalling,B=new Map;for(const T in O)X(T)&&B.set(T,f.Event.buffer(O[T],!0,void 0,re));return new class{listen(T,W,V){const ce=B.get(W);if(ce)return ce;if(H(W)){const de=O[W];if(typeof de=="function")return de.call(O,V)}throw new P.$bb(`Event not found: ${W}`)}call(T,W,V){const ce=O[W];if(typeof ce=="function"){if(!L&&Array.isArray(V))for(let ue=0;ue<V.length;ue++)V[ue]=(0,g.$lh)(V[ue]);let de=ce.apply(O,V);return de instanceof Promise||(de=Promise.resolve(de)),de}throw new P.$bb(`Method not found: ${W}`)}}}G.fromService=N;function q(Y,re){const F=re&&re.disableMarshalling;return new Proxy({},{get(O,L){if(typeof L=="string")return re?.properties?.has(L)?re.properties.get(L):H(L)?function(B){return Y.listen(L,B)}:X(L)?Y.listen(L):async function(...B){let T;re&&!(0,y.$Hf)(re.context)?T=[re.context,...B]:T=B;const W=await Y.call(L,T);return F?W:(0,g.$lh)(W)};throw new P.$bb(`Property not found: ${String(L)}`)}})}G.toService=q;function X(Y){return Y[0]==="o"&&Y[1]==="n"&&w.$1e(Y.charCodeAt(2))}function H(Y){return/^onDynamic/.test(Y)&&w.$1e(Y.charCodeAt(9))}})(_||(e.ProxyChannel=_={}));const ae=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function se(G){if(Array.isArray(G))return G;if(G&&typeof G=="object"&&typeof G.toString=="function"){const N=G.toString();if(N!=="[object Object]")return N}return G}function oe(G){return Array.isArray(G)?G.map(se):se(G)}function K(G,N,q,X,H,Y,re){re=oe(re);const F=ae[H],O=F[X%F.length];let L=[`%c[${G}]%c[${String(N).padStart(7," ")}]%c[len: ${String(q).padStart(5," ")}]%c${String(X).padStart(5," ")} - ${Y}`,"color: darkgreen","color: grey","color: grey",`color: ${O}`];/\($/.test(Y)?(L=L.concat(re),L.push(")")):L.push(re),console.log.apply(console,L)}class J{constructor(N,q){this.d=N,this.f=q,this.a=0,this.b=0}logOutgoing(N,q,X,H,Y){this.b+=N,K(this.d,this.b,N,q,X,H,Y)}logIncoming(N,q,X,H,Y){this.a+=N,K(this.f,this.a,N,q,X,H,Y)}}e.$xh=J}),define(te[155],ie([0,1,17,3,42]),function(Q,e,S,R,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iT=e.$hT=void 0;class M{constructor(f){this.a=f,this.onMessage=R.Event.fromDOMEventEmitter(this.a,"message",a=>S.$be.wrap(a.data)),f.start()}send(f){this.a.postMessage(f.buffer)}disconnect(){this.a.close()}}e.$hT=M;class D extends s.$th{constructor(f,a){const g=new M(f);super(g,a),this.b=g}dispose(){this.b.disconnect(),super.dispose()}}e.$iT=D}),define(te[109],ie([0,1,17,3,2,42]),function(Q,e,S,R,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ch=e.$Bh=e.$Ah=e.$zh=e.ProtocolConstants=e.$yh=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var D;(function(t){t.Created="created",t.Read="read",t.Write="write",t.Open="open",t.Error="error",t.Close="close",t.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",t.NodeEndReceived="nodeEndReceived",t.NodeEndSent="nodeEndSent",t.NodeDrainBegin="nodeDrainBegin",t.NodeDrainEnd="nodeDrainEnd",t.zlibInflateError="zlibInflateError",t.zlibInflateData="zlibInflateData",t.zlibInflateInitialWrite="zlibInflateInitialWrite",t.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",t.zlibInflateWrite="zlibInflateWrite",t.zlibInflateFlushFired="zlibInflateFlushFired",t.zlibDeflateError="zlibDeflateError",t.zlibDeflateData="zlibDeflateData",t.zlibDeflateWrite="zlibDeflateWrite",t.zlibDeflateFlushFired="zlibDeflateFlushFired",t.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",t.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",t.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",t.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",t.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",t.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",t.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",t.ProtocolHeaderRead="protocolHeaderRead",t.ProtocolMessageRead="protocolMessageRead",t.ProtocolHeaderWrite="protocolHeaderWrite",t.ProtocolMessageWrite="protocolMessageWrite",t.ProtocolWrite="protocolWrite"})(D||(e.SocketDiagnosticsEventType=D={}));var P;(function(t){t.enableDiagnostics=!1,t.records=[];const n=new WeakMap;let r=0;function p(C,k){if(!n.has(C)){const I=String(++r);n.set(C,I)}return n.get(C)}function A(C,k,I,j){if(!t.enableDiagnostics)return;const U=p(C,k);if(j instanceof S.$be||j instanceof Uint8Array||j instanceof ArrayBuffer||ArrayBuffer.isView(j)){const z=S.$be.alloc(j.byteLength);z.set(j),t.records.push({timestamp:Date.now(),id:U,label:k,type:I,buff:z})}else t.records.push({timestamp:Date.now(),id:U,label:k,type:I,data:j})}t.traceSocketEvent=A})(P||(e.SocketDiagnostics=P={}));var f;(function(t){t[t.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",t[t.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(f||(e.SocketCloseEventType=f={}));let a=null;function g(){return a||(a=S.$be.alloc(0)),a}class w{get byteLength(){return this.b}constructor(){this.a=[],this.b=0}acceptChunk(n){this.a.push(n),this.b+=n.byteLength}read(n){return this.c(n,!0)}peek(n){return this.c(n,!1)}c(n,r){if(n===0)return g();if(n>this.b)throw new Error("Cannot read so many bytes!");if(this.a[0].byteLength===n){const k=this.a[0];return r&&(this.a.shift(),this.b-=n),k}if(this.a[0].byteLength>n){const k=this.a[0].slice(0,n);return r&&(this.a[0]=this.a[0].slice(n),this.b-=n),k}const p=S.$be.alloc(n);let A=0,C=0;for(;n>0;){const k=this.a[C];if(k.byteLength>n){const I=k.slice(0,n);p.set(I,A),A+=n,r&&(this.a[C]=k.slice(n),this.b-=n),n-=n}else p.set(k,A),A+=k.byteLength,r?(this.a.shift(),this.b-=k.byteLength):C++,n-=k.byteLength}return p}}e.$yh=w;var y;(function(t){t[t.None=0]="None",t[t.Regular=1]="Regular",t[t.Control=2]="Control",t[t.Ack=3]="Ack",t[t.Disconnect=5]="Disconnect",t[t.ReplayRequest=6]="ReplayRequest",t[t.Pause=7]="Pause",t[t.Resume=8]="Resume",t[t.KeepAlive=9]="KeepAlive"})(y||(y={}));function d(t){switch(t){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive"}}var v;(function(t){t[t.HeaderLength=13]="HeaderLength",t[t.AcknowledgeTime=2e3]="AcknowledgeTime",t[t.TimeoutTime=2e4]="TimeoutTime",t[t.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",t[t.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",t[t.KeepAliveSendTime=5e3]="KeepAliveSendTime"})(v||(e.ProtocolConstants=v={}));class b{constructor(n,r,p,A){this.type=n,this.id=r,this.ack=p,this.data=A,this.writtenTime=0}get size(){return this.data.byteLength}}class $ extends s.$Sc{constructor(n){super(),this.f=this.B(new R.$Nd),this.onMessage=this.f.event,this.g={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this.a=n,this.b=!1,this.c=new w,this.B(this.a.onData(r=>this.acceptChunk(r))),this.lastReadTime=Date.now()}acceptChunk(n){if(!(!n||n.byteLength===0))for(this.lastReadTime=Date.now(),this.c.acceptChunk(n);this.c.byteLength>=this.g.readLen;){const r=this.c.read(this.g.readLen);if(this.g.readHead)this.g.readHead=!1,this.g.readLen=r.readUInt32BE(9),this.g.messageType=r.readUInt8(0),this.g.id=r.readUInt32BE(1),this.g.ack=r.readUInt32BE(5),this.a.traceSocketEvent("protocolHeaderRead",{messageType:d(this.g.messageType),id:this.g.id,ack:this.g.ack,messageSize:this.g.readLen});else{const p=this.g.messageType,A=this.g.id,C=this.g.ack;if(this.g.readHead=!0,this.g.readLen=13,this.g.messageType=0,this.g.id=0,this.g.ack=0,this.a.traceSocketEvent("protocolMessageRead",r),this.f.fire(new b(p,A,C,r)),this.b)break}}}readEntireBuffer(){return this.c.read(this.c.byteLength)}dispose(){this.b=!0,super.dispose()}}class m{constructor(n){this.k=null,this.a=!1,this.b=!1,this.c=n,this.d=[],this.f=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this.a=!0}drain(){return this.flush(),this.c.drain()}flush(){this.m()}pause(){this.b=!0}resume(){this.b=!1,this.l()}write(n){if(this.a)return;n.writtenTime=Date.now(),this.lastWriteTime=Date.now();const r=S.$be.alloc(13);r.writeUInt8(n.type,0),r.writeUInt32BE(n.id,1),r.writeUInt32BE(n.ack,5),r.writeUInt32BE(n.data.byteLength,9),this.c.traceSocketEvent("protocolHeaderWrite",{messageType:d(n.type),id:n.id,ack:n.ack,messageSize:n.data.byteLength}),this.c.traceSocketEvent("protocolMessageWrite",n.data),this.j(r,n.data)}g(n,r){const p=this.f===0;return this.d.push(n,r),this.f+=n.byteLength+r.byteLength,p}h(){const n=S.$be.concat(this.d,this.f);return this.d.length=0,this.f=0,n}j(n,r){this.g(n,r)&&this.l()}l(){this.k||(this.k=setTimeout(()=>{this.k=null,this.m()}))}m(){if(this.f===0||this.b)return;const n=this.h();this.c.traceSocketEvent("protocolWrite",{byteLength:n.byteLength}),this.c.write(n)}}class u extends s.$Sc{constructor(n){super(),this.f=new R.$Nd,this.onMessage=this.f.event,this.g=new R.$Nd,this.onDidDispose=this.g.event,this.a=n,this.b=this.B(new m(this.a)),this.c=this.B(new $(this.a)),this.B(this.c.onMessage(r=>{r.type===1&&this.f.fire(r.data)})),this.B(this.a.onClose(()=>this.g.fire()))}drain(){return this.b.drain()}getSocket(){return this.a}sendDisconnect(){}send(n){this.b.write(new b(1,0,0,n))}}e.$zh=u;class l extends M.$th{static fromSocket(n,r){return new l(new u(n),r)}get onDidDispose(){return this.b.onDidDispose}constructor(n,r,p=null){super(n,r,p),this.b=n}dispose(){super.dispose();const n=this.b.getSocket();this.b.sendDisconnect(),this.b.dispose(),n.end()}}e.$Ah=l;class E{constructor(){this.b=!1,this.c=!1,this.d=[],this.a=new R.$Nd({onWillAddFirstListener:()=>{this.b=!0,queueMicrotask(()=>this.f())},onDidRemoveLastListener:()=>{this.b=!1}}),this.event=this.a.event}f(){if(!this.c){for(this.c=!0;this.b&&this.d.length>0;)this.a.fire(this.d.shift());this.c=!1}}fire(n){this.b?this.d.length>0?this.d.push(n):this.a.fire(n):this.d.push(n)}flushBuffer(){this.d=[]}}e.$Bh=E;class h{constructor(n){this.data=n,this.next=null}}class i{constructor(){this.a=null,this.b=null}length(){let n=0,r=this.a;for(;r;)r=r.next,n++;return n}peek(){return this.a?this.a.data:null}toArray(){const n=[];let r=0,p=this.a;for(;p;)n[r++]=p.data,p=p.next;return n}pop(){if(this.a){if(this.a===this.b){this.a=null,this.b=null;return}this.a=this.a.next}}push(n){const r=new h(n);if(!this.a){this.a=r,this.b=r;return}this.b.next=r,this.b=r}}class c{static{this.a=10}static{this.b=null}static getInstance(){return c.b||(c.b=new c),c.b}constructor(){this.c=[];const n=Date.now();for(let r=0;r<c.a;r++)this.c[r]=n-1e3*r;setInterval(()=>{for(let r=c.a;r>=1;r--)this.c[r]=this.c[r-1];this.c[0]=Date.now()},1e3)}d(){const n=Date.now(),r=(1+c.a)*1e3;let p=0;for(let A=0;A<c.a;A++)n-this.c[A]<=r&&p++;return 1-p/c.a}hasHighLoad(){return this.d()>=.5}}class o{get unacknowledgedCount(){return this.c-this.d}constructor(n){this.u=new E,this.onControlMessage=this.u.event,this.v=new E,this.onMessage=this.v.event,this.w=new E,this.onDidDispose=this.w.event,this.x=new E,this.onSocketClose=this.x.event,this.y=new E,this.onSocketTimeout=this.y.event,this.s=n.loadEstimator??c.getInstance(),this.t=n.sendKeepAlive??!0,this.a=!1,this.b=new i,this.c=0,this.d=0,this.f=null,this.g=0,this.h=0,this.j=0,this.k=null,this.m=0,this.n=Date.now(),this.r=new s.$Rc,this.o=n.socket,this.p=this.r.add(new m(this.o)),this.q=this.r.add(new $(this.o)),this.r.add(this.q.onMessage(r=>this.z(r))),this.r.add(this.o.onClose(r=>this.x.fire(r))),n.initialChunk&&this.q.acceptChunk(n.initialChunk),this.t?this.l=setInterval(()=>{this.D()},5e3):this.l=null}dispose(){this.f&&(clearTimeout(this.f),this.f=null),this.k&&(clearTimeout(this.k),this.k=null),this.l&&(clearInterval(this.l),this.l=null),this.r.dispose()}drain(){return this.p.drain()}sendDisconnect(){const n=new b(5,0,0,g());this.p.write(n),this.p.flush()}sendPause(){const n=new b(7,0,0,g());this.p.write(n)}sendResume(){const n=new b(8,0,0,g());this.p.write(n)}pauseSocketWriting(){this.p.pause()}getSocket(){return this.o}getMillisSinceLastIncomingData(){return Date.now()-this.q.lastReadTime}beginAcceptReconnection(n,r){this.a=!0,this.r.dispose(),this.r=new s.$Rc,this.u.flushBuffer(),this.x.flushBuffer(),this.y.flushBuffer(),this.o.dispose(),this.m=0,this.n=Date.now(),this.o=n,this.p=this.r.add(new m(this.o)),this.q=this.r.add(new $(this.o)),this.r.add(this.q.onMessage(p=>this.z(p))),this.r.add(this.o.onClose(p=>this.x.fire(p))),this.q.acceptChunk(r)}endAcceptReconnection(){this.a=!1,this.h=this.g;const n=new b(3,0,this.h,g());this.p.write(n);const r=this.b.toArray();for(let p=0,A=r.length;p<A;p++)this.p.write(r[p]);this.B()}acceptDisconnect(){this.w.fire()}z(n){if(n.ack>this.d){this.d=n.ack;do{const r=this.b.peek();if(r&&r.id<=n.ack)this.b.pop();else break}while(!0)}switch(n.type){case 0:break;case 1:{if(n.id>this.g)if(n.id!==this.g+1){const r=Date.now();r-this.m>1e4&&(this.m=r,this.p.write(new b(6,0,0,g())))}else this.g=n.id,this.j=Date.now(),this.A(),this.v.fire(n.data);break}case 2:{this.u.fire(n.data);break}case 3:break;case 5:{this.w.fire();break}case 6:{const r=this.b.toArray();for(let p=0,A=r.length;p<A;p++)this.p.write(r[p]);this.B();break}case 7:{this.p.pause();break}case 8:{this.p.resume();break}case 9:break}}readEntireBuffer(){return this.q.readEntireBuffer()}flush(){this.p.flush()}send(n){const r=++this.c;this.h=this.g;const p=new b(1,r,this.h,n);this.b.push(p),this.a||(this.p.write(p),this.B())}sendControl(n){const r=new b(2,0,0,n);this.p.write(r)}A(){if(this.g<=this.h||this.k)return;const n=Date.now()-this.j;if(n>=2e3){this.C();return}this.k=setTimeout(()=>{this.k=null,this.A()},2e3-n+5)}B(){if(this.c<=this.d||this.f||this.a)return;const n=this.b.peek(),r=Date.now()-n.writtenTime,p=Date.now()-this.q.lastReadTime,A=Date.now()-this.n;if(r>=2e4&&p>=2e4&&A>=2e4&&!this.s.hasHighLoad()){this.n=Date.now(),this.y.fire({unacknowledgedMsgCount:this.b.length(),timeSinceOldestUnacknowledgedMsg:r,timeSinceLastReceivedSomeData:p});return}const C=Math.max(2e4-r,2e4-p,2e4-A,500);this.f=setTimeout(()=>{this.f=null,this.B()},C)}C(){if(this.g<=this.h)return;this.h=this.g;const n=new b(3,0,this.h,g());this.p.write(n)}D(){this.h=this.g;const n=new b(9,0,this.h,g());this.p.write(n)}}e.$Ch=o}),define(te[38],ie([0,1,15,14,13]),function(Q,e,S,R,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eT=void 0;class M{constructor(){this.a=new WeakMap}on(P,f){const a=(g,...w)=>{this.b(P,g)&&f(g,...w)};return this.a.set(f,a),S.ipcMain.on(P,a),this}once(P,f){return S.ipcMain.once(P,(a,...g)=>{this.b(P,a)&&f(a,...g)}),this}handle(P,f){return S.ipcMain.handle(P,(a,...g)=>this.b(P,a)?f(a,...g):Promise.reject(`Invalid channel '${P}' or sender for ipcMain.handle() usage.`)),this}removeHandler(P){return S.ipcMain.removeHandler(P),this}removeListener(P,f){const a=this.a.get(f);return a&&(S.ipcMain.removeListener(P,a),this.a.delete(f)),this}b(P,f){if(!P||!P.startsWith("vscode:"))return(0,R.$1)(`Refused to handle ipcMain event for channel '${P}' because the channel is unknown.`),!1;const a=f.senderFrame,g=a.url;if(!g||g==="about:blank")return!0;let w="unknown";try{w=new URL(g).host}catch{return(0,R.$1)(`Refused to handle ipcMain event for channel '${P}' because of a malformed URL '${g}'.`),!1}return w!==s.$bg?((0,R.$1)(`Refused to handle ipcMain event for channel '${P}' because of a bad origin of '${w}'.`),!1):a.parent!==null?((0,R.$1)(`Refused to handle ipcMain event for channel '${P}' because sender of origin '${w}' is not a main frame.`),!1):!0}}e.$eT=new M}),define(te[156],ie([0,1,15,38,144]),function(Q,e,S,R,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fT=void 0;function M(){R.$eT.on(s.$cT,(P,f,a,g,w)=>{const y=D(P,g,a);y.popup({x:w?w.x:void 0,y:w?w.y:void 0,positioningItem:w?w.positioningItem:void 0,callback:()=>{y&&P.sender.send(s.$dT,f)}})})}e.$fT=M;function D(P,f,a){const g=new S.Menu;return a.forEach(w=>{let y;w.type==="separator"?y=new S.MenuItem({type:w.type}):Array.isArray(w.submenu)?y=new S.MenuItem({submenu:D(P,f,w.submenu),label:w.label}):y=new S.MenuItem({label:w.label,type:w.type,accelerator:w.accelerator,checked:w.checked,enabled:w.enabled,visible:w.visible,click:(d,v,b)=>P.sender.send(f,w.id,b)}),g.append(y)}),g}}),define(te[157],ie([0,1,38,17,3,2,42,145]),function(Q,e,S,R,s,M,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lT=void 0;function f(g,w){const y=s.Event.fromNodeEventEmitter(S.$eT,w,(v,b)=>({event:v,message:b})),d=s.Event.filter(y,({event:v})=>v.sender.id===g);return s.Event.map(d,({message:v})=>v&&R.$be.wrap(v))}class a extends D.$sh{static{this.b=new Map}static d(){const w=s.Event.fromNodeEventEmitter(S.$eT,"vscode:hello",({sender:y})=>y);return s.Event.map(w,y=>{const d=y.id;a.b.get(d)?.dispose();const b=new s.$Nd;a.b.set(d,(0,M.$Qc)(()=>b.fire()));const $=f(d,"vscode:message"),m=s.Event.any(s.Event.signal(f(d,"vscode:disconnect")),b.event);return{protocol:new P.$kT(y,$),onDidClientDisconnect:m}})}constructor(){super(a.d())}}e.$lT=a}),define(te[110],ie([0,1,38,3,32,155]),function(Q,e,S,R,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nT=e.$mT=void 0;class D extends M.$iT{constructor(a,g){super({addEventListener:(w,y)=>a.addListener(w,y),removeEventListener:(w,y)=>a.removeListener(w,y),postMessage:w=>a.postMessage(w),start:()=>a.start(),close:()=>a.close()},g)}}e.$mT=D;async function P(f){if(f.isDestroyed()||f.webContents.isDestroyed())throw new Error("ipc.mp#connect: Cannot talk to window because it is closed or destroyed");const a=(0,s.$eg)();f.webContents.send("vscode:createMessageChannel",a);const g=R.Event.fromNodeEventEmitter(S.$eT,"vscode:createMessageChannelResult",(y,d)=>({nonce:d,port:y.ports[0]})),{port:w}=await R.Event.toPromise(R.Event.once(R.Event.filter(g,y=>y.nonce===a)));return w}e.$nT=P}),define(te[158],ie([0,1,47,8,17,22,152,14,3,2,37,88,75,42]),function(Q,e,S,R,s,M,D,P,f,a,g,w,y,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1p=e.$Zp=void 0;class v extends d.$qh{constructor(m){super({send:u=>{try{process.send?.(u.buffer.toString("base64"))}catch{}},onMessage:f.Event.fromNodeEventEmitter(process,"message",u=>s.$be.wrap(Buffer.from(u,"base64")))},m),process.once("disconnect",()=>this.dispose())}}e.$Zp=v;class b{constructor(m,u){this.i=m,this.j=u,this.c=new Set,this.g=new Map,this.h=new f.$Nd,this.onDidProcessExit=this.h.event;const l=u&&u.timeout?u.timeout:6e4;this.b=new R.$Qg(l),this.d=null,this.f=null}getChannel(m){const u=this;return{call(l,E,h){return u.k(m,l,E,h)},listen(l,E){return u.l(m,l,E)}}}k(m,u,l,E=M.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(E.isCancellationRequested)return Promise.reject(P.$6());this.b.cancel();const h=this.n(m),i=(0,R.$Hg)(t=>h.call(u,l,t)),c=E.onCancellationRequested(()=>i.cancel()),o=(0,a.$Qc)(()=>i.cancel());return this.c.add(o),i.finally(()=>{c.dispose(),this.c.delete(o),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),i}l(m,u,l){if(!this.b)return f.Event.None;this.b.cancel();let E;const h=new f.$Nd({onWillAddFirstListener:()=>{E=this.n(m).listen(u,l)(h.fire,h),this.c.add(E)},onDidRemoveLastListener:()=>{this.c.delete(E),E.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return h.event}get m(){if(!this.f){const m=this.j&&this.j.args?this.j.args:[],u=Object.create(null);u.env={...(0,g.$4m)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(u.env={...u.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(u.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(u.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(u.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),u.execArgv===void 0&&(u.execArgv=process.execArgv.filter(n=>!/^--inspect(-brk)?=/.test(n)).filter(n=>!n.startsWith("--vscode-"))),(0,y.$yl)(u.env),this.d=(0,S.fork)(this.i,m,u);const l=new f.$Nd;f.Event.fromNodeEventEmitter(this.d,"message",n=>n)(n=>{if((0,D.$Vp)(n)){(0,D.log)(n,`IPC Library: ${this.j.serverName}`);return}l.fire(s.$be.wrap(Buffer.from(n,"base64")))});const h=this.j.useQueue?(0,w.$Al)(this.d):this.d,i=n=>this.d&&this.d.connected&&h.send(n.buffer.toString("base64")),c=l.event,o={send:i,onMessage:c};this.f=new d.$rh(o);const t=()=>this.o();process.once("exit",t),this.d.on("error",n=>console.warn('IPC "'+this.j.serverName+'" errored with '+n)),this.d.on("exit",(n,r)=>{process.removeListener("exit",t),this.c.forEach(p=>(0,a.$Nc)(p)),this.c.clear(),n!==0&&r!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+n+" and signal "+r),this.b?.cancel(),this.o(),this.h.fire({code:n,signal:r})})}return this.f}n(m){let u=this.g.get(m);return u||(u=this.m.getChannel(m),this.g.set(m,u)),u}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.$1p=b}),define(te[111],ie([0,1,8,3,2,76,12]),function(Q,e,S,R,s,M,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1o=e.$Zo=e.StorageState=e.$Yo=e.StorageHint=void 0;var P;(function(y){y[y.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",y[y.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(P||(e.StorageHint=P={}));function f(y){const d=y;return d?.changed instanceof Map||d?.deleted instanceof Set}e.$Yo=f;var a;(function(y){y[y.None=0]="None",y[y.Initialized=1]="Initialized",y[y.Closed=2]="Closed"})(a||(e.StorageState=a={}));class g extends s.$Sc{static{this.a=100}constructor(d,v=Object.create(null)){super(),this.r=d,this.s=v,this.b=this.B(new R.$Qd),this.onDidChangeStorage=this.b.event,this.c=a.None,this.f=new Map,this.g=this.B(new S.$Rg(g.a)),this.h=new Set,this.j=new Map,this.m=void 0,this.n=[],this.t()}t(){this.B(this.r.onDidChangeItemsExternal(d=>this.u(d)))}u(d){this.b.pause();try{d.changed?.forEach((v,b)=>this.w(b,v)),d.deleted?.forEach(v=>this.w(v,void 0))}finally{this.b.resume()}}w(d,v){if(this.c===a.Closed)return;let b=!1;(0,D.$Hf)(v)?b=this.f.delete(d):this.f.get(d)!==v&&(this.f.set(d,v),b=!0),b&&this.b.fire({key:d,external:!0})}get items(){return this.f}get size(){return this.f.size}async init(){this.c===a.None&&(this.c=a.Initialized,this.s.hint!==P.STORAGE_DOES_NOT_EXIST&&(this.f=await this.r.getItems()))}get(d,v){const b=this.f.get(d);return(0,D.$Hf)(b)?v:b}getBoolean(d,v){const b=this.get(d);return(0,D.$Hf)(b)?v:b==="true"}getNumber(d,v){const b=this.get(d);return(0,D.$Hf)(b)?v:parseInt(b,10)}getObject(d,v){const b=this.get(d);return(0,D.$Hf)(b)?v:(0,M.$kh)(b)}async set(d,v,b=!1){if(this.c===a.Closed)return;if((0,D.$Hf)(v))return this.delete(d,b);const $=(0,D.$Af)(v)||Array.isArray(v)?(0,M.$jh)(v):String(v);if(this.f.get(d)!==$)return this.f.set(d,$),this.j.set(d,$),this.h.delete(d),this.b.fire({key:d,external:b}),this.D()}async delete(d,v=!1){if(!(this.c===a.Closed||!this.f.delete(d)))return this.h.has(d)||this.h.add(d),this.j.delete(d),this.b.fire({key:d,external:v}),this.D()}async optimize(){if(this.c!==a.Closed)return await this.flush(0),this.r.optimize()}async close(){return this.m||(this.m=this.y()),this.m}async y(){this.c=a.Closed;try{await this.D(0)}catch{}await this.r.close(()=>this.f)}get z(){return this.j.size>0||this.h.size>0}async C(){if(!this.z)return;const d={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.r.updateItems(d).finally(()=>{if(!this.z)for(;this.n.length;)this.n.pop()?.()})}async flush(d){if(this.z)return this.D(d)}async D(d){return this.s.hint===P.STORAGE_IN_MEMORY?this.C():this.g.trigger(()=>this.C(),d)}async whenFlushed(){if(this.z)return new Promise(d=>this.n.push(d))}isInMemory(){return this.s.hint===P.STORAGE_IN_MEMORY}}e.$Zo=g;class w{constructor(){this.onDidChangeItemsExternal=R.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(d){d.insert?.forEach((v,b)=>this.a.set(b,v)),d.delete?.forEach(v=>this.a.delete(v))}async optimize(){}async close(){}}e.$1o=w}),define(te[159],ie([0,1,8,3,31,9,21]),function(Q,e,S,R,s,M,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$JT=void 0;class P{static{this.IN_MEMORY_PATH=":memory:"}get onDidChangeItemsExternal(){return R.Event.None}static{this.a=2e3}static{this.b=256}constructor(g,w=Object.create(null)){this.g=g,this.h=w,this.c=(0,M.$nc)(this.g),this.d=new f(this.h.logging),this.f=this.n(this.g)}async getItems(){const g=await this.f,w=new Map;return(await this.s(g,"SELECT * FROM ItemTable")).forEach(d=>w.set(d.key,d.value)),this.d.isTracing&&this.d.trace(`[storage ${this.c}] getItems(): ${w.size} rows`),w}async updateItems(g){const w=await this.f;return this.j(w,g)}j(g,w){return this.d.isTracing&&this.d.trace(`[storage ${this.c}] updateItems(): insert(${w.insert?(0,s.$yc)(w.insert):"0"}), delete(${w.delete?(0,s.$zc)(w.delete):"0"})`),this.t(g,()=>{const y=w.insert,d=w.delete;if(y&&y.size>0){const v=[];v.push([]);let b=0;y.forEach(($,m)=>{let u=v[b];u.length>P.b&&(b++,u=[],v.push(u)),u.push(m,$)}),v.forEach($=>{this.u(g,`INSERT INTO ItemTable VALUES ${new Array($.length/2).fill("(?,?)").join(",")}`,m=>m.run($),()=>{const m=[];let u=0;return y.forEach((l,E)=>{m.push(E),u+=l.length}),`Keys: ${m.join(", ")} Length: ${u}`})})}if(d&&d.size){const v=[];v.push([]);let b=0;d.forEach($=>{let m=v[b];m.length>P.b&&(b++,m=[],v.push(m)),m.push($)}),v.forEach($=>{this.u(g,`DELETE FROM ItemTable WHERE key IN (${new Array($.length).fill("?").join(",")})`,m=>m.run($),()=>{const m=[];return d.forEach(u=>{m.push(u)}),`Keys: ${m.join(", ")}`})})}})}async optimize(){this.d.trace(`[storage ${this.c}] vacuum()`);const g=await this.f;return this.q(g,"VACUUM")}async close(g){this.d.trace(`[storage ${this.c}] close()`);const w=await this.f;return this.k(w,g)}k(g,w){return new Promise((y,d)=>{g.db.close(v=>(v&&this.o(g,`[storage ${this.c}] close(): ${v}`),this.g===P.IN_MEMORY_PATH?y():!g.isErroneous&&!g.isInMemory?this.l().then(y,b=>(this.d.error(`[storage ${this.c}] backup(): ${b}`),y())):typeof w=="function"?D.Promises.unlink(this.g).then(()=>this.p(this.g).then(b=>{const $=()=>this.k(b,void 0);return this.j(b,{insert:w()}).then(()=>$(),m=>($(),Promise.reject(m)))})).then(y,d):d(v||new Error("Database has errors or is in-memory without recovery option"))))})}l(){const g=this.m(this.g);return D.Promises.copy(this.g,g,{preserveSymlinks:!1})}m(g){return`${g}.backup`}async checkIntegrity(g){this.d.trace(`[storage ${this.c}] checkIntegrity(full: ${g})`);const w=await this.f,y=await this.r(w,g?"PRAGMA integrity_check":"PRAGMA quick_check"),d=g?y.integrity_check:y.quick_check;return w.isErroneous?`${d} (last error: ${w.lastError})`:w.isInMemory?`${d} (in-memory!)`:d}async n(g,w=!0){this.d.trace(`[storage ${this.c}] open(${g}, retryOnBusy: ${w})`);try{return await this.p(g)}catch(y){if(this.d.error(`[storage ${this.c}] open(): Unable to open DB due to ${y}`),y.code==="SQLITE_BUSY"&&w)return await(0,S.$Ug)(P.a),this.n(g,!1);try{await D.Promises.unlink(g);try{await D.Promises.rename(this.m(g),g,!1)}catch{}return await this.p(g)}catch(d){return this.d.error(`[storage ${this.c}] open(): Unable to use backup due to ${d}`),this.p(P.IN_MEMORY_PATH)}}}o(g,w){g.isErroneous=!0,g.lastError=w,this.d.error(w)}p(g){return new Promise((w,y)=>{new Promise((d,v)=>{Q(["@vscode/sqlite3"],d,v)}).then(d=>{const v={db:new(this.d.isTracing?d.verbose().Database:d.Database)(g,b=>b?v.db&&b.code!=="SQLITE_CANTOPEN"?v.db.close(()=>y(b)):y(b):this.q(v,["PRAGMA user_version = 1;","CREATE TABLE IF NOT EXISTS ItemTable (key TEXT UNIQUE ON CONFLICT REPLACE, value BLOB)"].join("")).then(()=>w(v),$=>v.db.close(()=>y($)))),isInMemory:g===P.IN_MEMORY_PATH};v.db.on("error",b=>this.o(v,`[storage ${this.c}] Error (event): ${b}`)),this.d.isTracing&&v.db.on("trace",b=>this.d.trace(`[storage ${this.c}] Trace (event): ${b}`))},y)})}q(g,w){return new Promise((y,d)=>{g.db.exec(w,v=>v?(this.o(g,`[storage ${this.c}] exec(): ${v}`),d(v)):y())})}r(g,w){return new Promise((y,d)=>{g.db.get(w,(v,b)=>v?(this.o(g,`[storage ${this.c}] get(): ${v}`),d(v)):y(b))})}s(g,w){return new Promise((y,d)=>{g.db.all(w,(v,b)=>v?(this.o(g,`[storage ${this.c}] all(): ${v}`),d(v)):y(b))})}t(g,w){return new Promise((y,d)=>{g.db.serialize(()=>{g.db.run("BEGIN TRANSACTION"),w(),g.db.run("END TRANSACTION",v=>v?(this.o(g,`[storage ${this.c}] transaction(): ${v}`),d(v)):y())})})}u(g,w,y,d){const v=g.db.prepare(w),b=$=>{this.o(g,`[storage ${this.c}] prepare(): ${$} (${w}). Details: ${d()}`)};v.on("error",b),y(v),v.finalize($=>{$&&b($),v.removeListener("error",b)})}}e.$JT=P;class f{static{this.a="VSCODE_TRACE_STORAGE"}constructor(g){g&&typeof g.logTrace=="function"&&process.env[f.a]&&(this.b=g.logTrace),g&&typeof g.logError=="function"&&(this.c=g.logError)}get isTracing(){return!!this.b}trace(g){this.b?.(g)}error(g){this.c?.(g)}}}),define(te[160],ie([11,10]),function(Q,e){return Q.create("vs/code/electron-main/app",e)}),define(te[161],ie([11,10]),function(Q,e){return Q.create("vs/platform/configuration/common/configurationRegistry",e)}),define(te[162],ie([11,10]),function(Q,e){return Q.create("vs/platform/contextkey/common/contextkey",e)}),define(te[163],ie([11,10]),function(Q,e){return Q.create("vs/platform/contextkey/common/scanner",e)}),define(te[164],ie([11,10]),function(Q,e){return Q.create("vs/platform/dialogs/common/dialogs",e)}),define(te[165],ie([11,10]),function(Q,e){return Q.create("vs/platform/dialogs/electron-main/dialogMainService",e)}),define(te[166],ie([11,10]),function(Q,e){return Q.create("vs/platform/environment/node/argv",e)}),define(te[167],ie([11,10]),function(Q,e){return Q.create("vs/platform/environment/node/argvHelper",e)}),define(te[168],ie([11,10]),function(Q,e){return Q.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(te[169],ie([11,10]),function(Q,e){return Q.create("vs/platform/extensionManagement/common/extensionNls",e)}),define(te[170],ie([11,10]),function(Q,e){return Q.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(te[171],ie([11,10]),function(Q,e){return Q.create("vs/platform/extensions/common/extensionValidator",e)}),define(te[172],ie([11,10]),function(Q,e){return Q.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(te[173],ie([11,10]),function(Q,e){return Q.create("vs/platform/files/common/fileService",e)}),define(te[174],ie([11,10]),function(Q,e){return Q.create("vs/platform/files/common/files",e)}),define(te[175],ie([11,10]),function(Q,e){return Q.create("vs/platform/files/common/io",e)}),define(te[176],ie([11,10]),function(Q,e){return Q.create("vs/platform/files/electron-main/diskFileSystemProviderServer",e)}),define(te[177],ie([11,10]),function(Q,e){return Q.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(te[178],ie([11,10]),function(Q,e){return Q.create("vs/platform/issue/electron-main/issueMainService",e)}),define(te[179],ie([11,10]),function(Q,e){return Q.create("vs/platform/menubar/electron-main/menubar",e)}),define(te[180],ie([11,10]),function(Q,e){return Q.create("vs/platform/native/electron-main/nativeHostMainService",e)}),define(te[181],ie([11,10]),function(Q,e){return Q.create("vs/platform/request/common/request",e)}),define(te[182],ie([11,10]),function(Q,e){return Q.create("vs/platform/shell/node/shellEnv",e)}),define(te[183],ie([11,10]),function(Q,e){return Q.create("vs/platform/telemetry/common/telemetryService",e)}),define(te[184],ie([11,10]),function(Q,e){return Q.create("vs/platform/terminal/common/terminalPlatformConfiguration",e)}),define(te[185],ie([11,10]),function(Q,e){return Q.create("vs/platform/terminal/common/terminalProfiles",e)}),define(te[186],ie([11,10]),function(Q,e){return Q.create("vs/platform/update/common/update.config.contribution",e)}),define(te[187],ie([11,10]),function(Q,e){return Q.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(te[188],ie([11,10]),function(Q,e){return Q.create("vs/platform/windows/electron-main/windowImpl",e)}),define(te[189],ie([11,10]),function(Q,e){return Q.create("vs/platform/windows/electron-main/windowsMainService",e)}),define(te[190],ie([11,10]),function(Q,e){return Q.create("vs/platform/workspace/common/workspace",e)}),define(te[191],ie([11,10]),function(Q,e){return Q.create("vs/platform/workspaces/electron-main/workspacesHistoryMainService",e)}),define(te[192],ie([11,10]),function(Q,e){return Q.create("vs/platform/workspaces/electron-main/workspacesManagementMainService",e)}),define(te[193],ie([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$AU=e.$zU=void 0;function S(s){return s&&s.hasOwnProperty("folderUri")}e.$zU=S;function R(s){return s&&s.hasOwnProperty("workspace")}e.$AU=R}),define(te[194],ie([0,1,7]),function(Q,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$k6b=e.$j6b=e.$i6b=void 0;function R(D){return typeof D?.backupFolder=="string"}e.$i6b=R;function s(D){let P=[];try{Array.isArray(D.workspaces)&&(P=D.workspaces.map(f=>({workspace:{id:f.id,configPath:S.URI.parse(f.configURIPath)},remoteAuthority:f.remoteAuthority})))}catch{}return P}e.$j6b=s;function M(D){let P=[];try{Array.isArray(D.folders)&&(P=D.folders.map(f=>({folderUri:S.URI.parse(f.folderUri),remoteAuthority:f.remoteAuthority})))}catch{}return P}e.$k6b=M}),define(te[195],ie([0,1,14,163]),function(Q,e,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ji=e.TokenType=void 0;var s;(function(a){a[a.LParen=0]="LParen",a[a.RParen=1]="RParen",a[a.Neg=2]="Neg",a[a.Eq=3]="Eq",a[a.NotEq=4]="NotEq",a[a.Lt=5]="Lt",a[a.LtEq=6]="LtEq",a[a.Gt=7]="Gt",a[a.GtEq=8]="GtEq",a[a.RegexOp=9]="RegexOp",a[a.RegexStr=10]="RegexStr",a[a.True=11]="True",a[a.False=12]="False",a[a.In=13]="In",a[a.Not=14]="Not",a[a.And=15]="And",a[a.Or=16]="Or",a[a.Str=17]="Str",a[a.QuotedStr=18]="QuotedStr",a[a.Error=19]="Error",a[a.EOF=20]="EOF"})(s||(e.TokenType=s={}));function M(...a){switch(a.length){case 1:return(0,R.localize)(0,null,a[0]);case 2:return(0,R.localize)(1,null,a[0],a[1]);case 3:return(0,R.localize)(2,null,a[0],a[1],a[2]);default:return}}const D=(0,R.localize)(3,null),P=(0,R.localize)(4,null);class f{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(g){switch(g.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return g.isTripleEq?"===":"==";case 4:return g.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return g.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return g.lexeme;case 18:return g.lexeme;case 19:return g.lexeme;case 20:return"EOF";default:throw(0,S.$8)(`unhandled token type: ${JSON.stringify(g)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(g=>g.charCodeAt(0)))}static{this.b=new Map([["not",14],["in",13],["false",12],["true",11]])}get errors(){return this.g}reset(g){return this.c=g,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const w=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:w})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const w=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:w})}else this.h(126)?this.k(9):this.l(M("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(M("&&"));break;case 124:this.h(124)?this.k(16):this.l(M("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(g){return this.r()||this.c.charCodeAt(this.e)!==g?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(g){this.f.push({type:g,offset:this.d})}l(g){const w=this.d,y=this.c.substring(this.d,this.e),d={type:19,offset:this.d,lexeme:y};this.g.push({offset:w,lexeme:y,additionalInfo:g}),this.f.push(d)}n(){this.m.lastIndex=this.d;const g=this.m.exec(this.c);if(g){this.e=this.d+g[0].length;const w=this.c.substring(this.d,this.e),y=f.b.get(w);y?this.k(y):this.f.push({type:17,lexeme:w,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(D);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let g=this.e,w=!1,y=!1;for(;;){if(g>=this.c.length){this.e=g,this.l(P);return}const v=this.c.charCodeAt(g);if(w)w=!1;else if(v===47&&!y){g++;break}else v===91?y=!0:v===92?w=!0:v===93&&(y=!1);g++}for(;g<this.c.length&&f.a.has(this.c.charCodeAt(g));)g++;this.e=g;const d=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:d,offset:this.d})}r(){return this.e>=this.c.length}}e.$Ji=f}),define(te[196],ie([0,1,3,2]),function(Q,e,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kn=e.$Jn=void 0;class s{constructor(){this.a=new S.$Nd,this.b=new S.$Nd,this.c=new S.$Nd,this.d=new S.$Nd}static{this.ChannelName="extensionhostdebugservice"}call(P,f,a){switch(f){case"close":return Promise.resolve(this.a.fire({sessionId:a[0]}));case"reload":return Promise.resolve(this.b.fire({sessionId:a[0]}));case"terminate":return Promise.resolve(this.c.fire({sessionId:a[0]}));case"attach":return Promise.resolve(this.d.fire({sessionId:a[0],port:a[1],subId:a[2]}))}throw new Error("Method not implemented.")}listen(P,f,a){switch(f){case"close":return this.a.event;case"reload":return this.b.event;case"terminate":return this.c.event;case"attach":return this.d.event}throw new Error("Method not implemented.")}}e.$Jn=s;class M extends R.$Sc{constructor(P){super(),this.b=P}reload(P){this.b.call("reload",[P])}get onReload(){return this.b.listen("reload")}close(P){this.b.call("close",[P])}get onClose(){return this.b.listen("close")}attachSession(P,f,a){this.b.call("attach",[P,f,a])}get onAttachSession(){return this.b.listen("attach")}terminateSession(P,f){this.b.call("terminate",[P,f])}get onTerminateSession(){return this.b.listen("terminate")}openExtensionDevelopmentHostWindow(P,f){return this.b.call("openExtensionDevelopmentHostWindow",[P,f])}}e.$Kn=M}),define(te[197],ie([0,1,147,54,13,9,35,19,7]),function(Q,e,S,R,s,M,D,P,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gm=e.$fm=e.$em=e.$dm=void 0,e.$dm=/^([^.]+\..+):(.+)$/;class a{get appRoot(){return(0,M.$mc)(s.$cg.asFileUri("").fsPath)}get userHome(){return f.URI.file(this.b.homeDir)}get userDataPath(){return this.b.userDataDir}get appSettingsHome(){return f.URI.file((0,M.$jc)(this.userDataPath,"User"))}get tmpDir(){return f.URI.file(this.b.tmpDir)}get cacheHome(){return f.URI.file(this.userDataPath)}get stateResource(){return(0,P.$vg)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome.with({scheme:s.Schemas.vscodeUserData})}get userDataSyncHome(){return(0,P.$vg)(this.appSettingsHome,"sync")}get logsHome(){if(!this.args.logsPath){const d=(0,S.$cm)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,M.$jc)(this.userDataPath,"logs",d)}return f.URI.file(this.args.logsPath)}get sync(){return this.args.sync}get machineSettingsResource(){return(0,P.$vg)(f.URI.file((0,M.$jc)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,P.$vg)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,P.$vg)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,P.$vg)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const d=D.env.VSCODE_PORTABLE;return d?f.URI.file((0,M.$jc)(d,"argv.json")):(0,P.$vg)(this.userHome,this.c.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return f.URI.file((0,M.$jc)(this.userDataPath,"Workspaces"))}get builtinExtensionsPath(){const d=this.args["builtin-extensions-dir"];return d?(0,M.$kc)(d):(0,M.$hc)((0,M.$jc)(s.$cg.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const d=this.args["extensions-download-dir"];return d?f.URI.file((0,M.$kc)(d)):f.URI.file((0,M.$jc)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const d=this.args["extensions-dir"];if(d)return(0,M.$kc)(d);const v=D.env.VSCODE_EXTENSIONS;if(v)return v;const b=D.env.VSCODE_PORTABLE;return b?(0,M.$jc)(b,"extensions"):(0,P.$vg)(this.userHome,this.c.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const d=this.args.extensionDevelopmentPath;if(Array.isArray(d))return d.map(v=>/^[^:/?#]+?:\/\//.test(v)?f.URI.parse(v):f.URI.file((0,M.$hc)(v)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(d=>d==="ui"||d==="workspace"||d==="web"?d:"workspace")}get extensionTestsLocationURI(){const d=this.args.extensionTestsPath;if(d)return/^[^:/?#]+?:\/\//.test(d)?f.URI.parse(d):f.URI.file((0,M.$hc)(d))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const d=this.args["disable-extension"];if(d){if(typeof d=="string")return[d];if(Array.isArray(d)&&d.length>0)return d}return!1}get debugExtensionHost(){return g(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!D.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(d=>!e.$dm.test(d))}get extensionLogLevel(){const d=[];for(const v of this.args.log||[]){const b=e.$dm.exec(v);b&&b[1]&&b[2]&&d.push([b[1],b[2]])}return d.length?d:void 0}get serviceMachineIdResource(){return(0,P.$vg)(f.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get useInMemorySecretStorage(){return!!this.args["use-inmemory-secretstorage"]}get policyFile(){if(this.args["__enable-file-policy"]){const d=D.env.VSCODE_PORTABLE;return d?f.URI.file((0,M.$jc)(d,"policy.json")):(0,P.$vg)(this.userHome,this.c.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(d){this.args.continueOn=d}get args(){return this.a}constructor(d,v,b){this.a=d,this.b=v,this.c=b,this.editSessionId=this.args.editSessionId}}e.$em=a,ke([R.$gh],a.prototype,"appRoot",null),ke([R.$gh],a.prototype,"userHome",null),ke([R.$gh],a.prototype,"userDataPath",null),ke([R.$gh],a.prototype,"appSettingsHome",null),ke([R.$gh],a.prototype,"tmpDir",null),ke([R.$gh],a.prototype,"cacheHome",null),ke([R.$gh],a.prototype,"stateResource",null),ke([R.$gh],a.prototype,"userRoamingDataHome",null),ke([R.$gh],a.prototype,"userDataSyncHome",null),ke([R.$gh],a.prototype,"sync",null),ke([R.$gh],a.prototype,"machineSettingsResource",null),ke([R.$gh],a.prototype,"workspaceStorageHome",null),ke([R.$gh],a.prototype,"localHistoryHome",null),ke([R.$gh],a.prototype,"keyboardLayoutResource",null),ke([R.$gh],a.prototype,"argvResource",null),ke([R.$gh],a.prototype,"isExtensionDevelopment",null),ke([R.$gh],a.prototype,"untitledWorkspacesHome",null),ke([R.$gh],a.prototype,"builtinExtensionsPath",null),ke([R.$gh],a.prototype,"extensionsPath",null),ke([R.$gh],a.prototype,"extensionDevelopmentLocationURI",null),ke([R.$gh],a.prototype,"extensionDevelopmentKind",null),ke([R.$gh],a.prototype,"extensionTestsLocationURI",null),ke([R.$gh],a.prototype,"debugExtensionHost",null),ke([R.$gh],a.prototype,"logLevel",null),ke([R.$gh],a.prototype,"extensionLogLevel",null),ke([R.$gh],a.prototype,"serviceMachineIdResource",null),ke([R.$gh],a.prototype,"disableTelemetry",null),ke([R.$gh],a.prototype,"disableWorkspaceTrust",null),ke([R.$gh],a.prototype,"useInMemorySecretStorage",null),ke([R.$gh],a.prototype,"policyFile",null);function g(y,d){return w(y["inspect-extensions"],y["inspect-brk-extensions"],5870,d,y.debugId,y.extensionEnvironment)}e.$fm=g;function w(y,d,v,b,$,m){const l=Number(d||y)||(b?null:v),E=l?!!d:!1;let h;if(m)try{h=JSON.parse(m)}catch{}return{port:l,break:E,debugId:$,env:h}}e.$gm=w}),define(te[112],ie([0,1,307,4,166]),function(Q,e,S,R,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hl=e.$Gl=e.$Fl=e.$El=e.$Dl=e.$Cl=void 0;const M={o:(0,s.localize)(0,null),e:(0,s.localize)(1,null),t:(0,s.localize)(2,null)};e.$Cl=["tunnel","serve-web"],e.$Dl={tunnel:{type:"subcommand",description:"Make the current machine accessible from vscode.dev or other machines through a secure tunnel",options:{"cli-data-dir":{type:"string",args:"dir",description:(0,s.localize)(3,null)},"disable-telemetry":{type:"boolean"},"telemetry-level":{type:"string"},user:{type:"subcommand",options:{login:{type:"subcommand",options:{provider:{type:"string"},"access-token":{type:"string"}}}}}}},"serve-web":{type:"subcommand",description:"Make the current machine accessible from vscode.dev or other machines through a secure tunnel",options:{"cli-data-dir":{type:"string",args:"dir",description:(0,s.localize)(4,null)},"disable-telemetry":{type:"boolean"},"telemetry-level":{type:"string"}}},diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,s.localize)(5,null)},merge:{type:"boolean",cat:"o",alias:"m",args:["path1","path2","base","result"],description:(0,s.localize)(6,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,s.localize)(7,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,s.localize)(8,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,s.localize)(9,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,s.localize)(10,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,s.localize)(11,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,s.localize)(12,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,s.localize)(13,null)},profile:{type:"string",cat:"o",args:"profileName",description:(0,s.localize)(14,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,s.localize)(15,null)},"extensions-dir":{type:"string",deprecates:["extensionHomePath"],cat:"e",args:"dir",description:(0,s.localize)(16,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,s.localize)(17,null)},"show-versions":{type:"boolean",cat:"e",description:(0,s.localize)(18,null)},category:{type:"string",allowEmptyValue:!0,cat:"e",description:(0,s.localize)(19,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"ext-id | path",description:(0,s.localize)(20,null)},"pre-release":{type:"boolean",cat:"e",description:(0,s.localize)(21,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"ext-id",description:(0,s.localize)(22,null)},"enable-proposed-api":{type:"string[]",allowEmptyValue:!0,cat:"e",args:"ext-id",description:(0,s.localize)(23,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,s.localize)(24,null)},verbose:{type:"boolean",cat:"t",global:!0,description:(0,s.localize)(25,null)},log:{type:"string[]",cat:"t",args:"level",global:!0,description:(0,s.localize)(26,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,s.localize)(27,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,s.localize)(28,null)},"prof-append-timers":{type:"string"},"prof-duration-markers":{type:"string[]"},"prof-duration-markers-file":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:["disableExtensions"],cat:"t",description:(0,s.localize)(29,null)},"disable-extension":{type:"string[]",cat:"t",args:"ext-id",description:(0,s.localize)(30,null)},sync:{type:"string",cat:"t",description:(0,s.localize)(31,null),args:["on | off"]},"inspect-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugPluginHost"],args:"port",cat:"t",description:(0,s.localize)(32,null)},"inspect-brk-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugBrkPluginHost"],args:"port",cat:"t",description:(0,s.localize)(33,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,s.localize)(34,null)},"disable-chromium-sandbox":{type:"boolean",cat:"t",description:(0,s.localize)(35,null)},"ms-enable-electron-run-as-node":{type:"boolean",global:!0},telemetry:{type:"boolean",cat:"t",description:(0,s.localize)(36,null)},remote:{type:"string",allowEmptyValue:!0},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},extensionEnvironment:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-brk-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-search":{type:"string",deprecates:["debugSearch"],allowEmptyValue:!0},"inspect-brk-search":{type:"string",deprecates:["debugBrkSearch"],allowEmptyValue:!0},"inspect-sharedprocess":{type:"string",allowEmptyValue:!0},"inspect-brk-sharedprocess":{type:"string",allowEmptyValue:!0},"export-default-configuration":{type:"string"},"install-source":{type:"string"},"enable-smoke-test-driver":{type:"boolean"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"use-inmemory-secretstorage":{type:"boolean",deprecates:["disable-keytar"]},"password-store":{type:"string"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"unity-launch":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},"disable-gpu-sandbox":{type:"boolean"},logsPath:{type:"string"},"__enable-file-policy":{type:"boolean"},editSessionId:{type:"string"},continueOn:{type:"string"},"locate-shell-integration-path":{type:"string",args:["bash","pwsh","zsh","fish"]},"enable-coi":{type:"boolean"},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string",allowEmptyValue:!0},"inspect-brk":{type:"string",allowEmptyValue:!0},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},"disable-dev-shm-usage":{type:"boolean"},"profile-temp":{type:"boolean"},_:{type:"string[]"}};const D={onUnknownOption:()=>{},onMultipleValues:()=>{},onEmptyValue:()=>{},onDeprecatedOption:()=>{}};function P(b,$,m=D){const u=b.find(r=>r.length>0&&r[0]!=="-"),l={},E=["_"],h=[],i={};let c;for(const r in $){const p=$[r];p.type==="subcommand"?r===u&&(c=p):(p.alias&&(l[r]=p.alias),p.type==="string"||p.type==="string[]"?(E.push(r),p.deprecates&&E.push(...p.deprecates)):p.type==="boolean"&&(h.push(r),p.deprecates&&h.push(...p.deprecates)),p.global&&(i[r]=p))}if(c&&u){const r=i;for(const k in c.options)r[k]=c.options[k];const p=b.filter(k=>k!==u),A=m.getSubcommandReporter?m.getSubcommandReporter(u):void 0,C=P(p,r,A);return{[u]:C,_:[]}}const o=S(b,{string:E,boolean:h,alias:l}),t={},n=o;t._=o._.map(r=>String(r)).filter(r=>r.length>0),delete n._;for(const r in $){const p=$[r];if(p.type==="subcommand")continue;p.alias&&delete n[p.alias];let A=n[r];if(p.deprecates)for(const C of p.deprecates)n.hasOwnProperty(C)&&(A||(A=n[C],A&&m.onDeprecatedOption(C,p.deprecationMessage||(0,s.localize)(37,null,r))),delete n[C]);if(typeof A<"u"){if(p.type==="string[]"){if(Array.isArray(A)||(A=[A]),!p.allowEmptyValue){const C=A.filter(k=>k.length>0);C.length!==A.length&&(m.onEmptyValue(r),A=C.length>0?C:void 0)}}else p.type==="string"&&(Array.isArray(A)?(A=A.pop(),m.onMultipleValues(r,A)):!A&&!p.allowEmptyValue&&(m.onEmptyValue(r),A=void 0));t[r]=A,p.deprecationMessage&&m.onDeprecatedOption(r,p.deprecationMessage)}delete n[r]}for(const r in n)m.onUnknownOption(r);return t}e.$El=P;function f(b,$){let m="";return $.args&&(Array.isArray($.args)?m=` <${$.args.join("> <")}>`:m=` <${$.args}>`),$.alias?`-${$.alias} --${b}${m}`:`--${b}${m}`}function a(b,$){const m=[];for(const u in b){const l=b[u],E=f(u,l);m.push([E,l.description])}return g(m,$)}e.$Fl=a;function g(b,$){const u=b.reduce((h,i)=>Math.max(h,i[0].length),12)+2+1;if($-u<25)return b.reduce((h,i)=>h.concat([`  ${i[0]}`,`      ${i[1]}`]),[]);const l=$-u-1,E=[];for(const h of b){const i=h[0],c=y(h[1],l),o=w(u-i.length-2);E.push("  "+i+o+c[0]);for(let t=1;t<c.length;t++)E.push(w(u)+c[t])}return E}function w(b){return" ".repeat(b)}function y(b,$){const m=[];for(;b.length;){const u=b.length<$?b.length:b.lastIndexOf(" ",$),l=b.slice(0,u).trim();b=b.slice(u),m.push(l)}return m}function d(b,$,m,u,l){const E=process.stdout.isTTY&&process.stdout.columns||80,h=l?.noInputFiles!==!0?`[${(0,s.localize)(38,null)}...]`:"",i=[`${b} ${m}`];i.push(""),i.push(`${(0,s.localize)(39,null)}: ${$} [${(0,s.localize)(40,null)}]${h}`),i.push(""),l?.noPipe!==!0&&(R.$j?i.push((0,s.localize)(41,null,$)):i.push((0,s.localize)(42,null,$)),i.push(""));const c={},o=[];for(const t in u){const n=u[t];if(n.type==="subcommand")n.description&&o.push({command:t,description:n.description});else if(n.description&&n.cat){let r=c[n.cat];r||(c[n.cat]=r={}),r[t]=n}}for(const t in c){const n=t,r=c[n];r&&(i.push(M[n]),i.push(...a(r,E)),i.push(""))}return o.length&&(i.push((0,s.localize)(43,null)),i.push(...g(o.map(t=>[t.command,t.description]),E)),i.push("")),i.join(`
`)}e.$Gl=d;function v(b,$){return`${b||(0,s.localize)(44,null)}
${$||(0,s.localize)(45,null)}
${process.arch}`}e.$Hl=v}),define(te[198],ie([0,1,87,196,112]),function(Q,e,S,R,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$r6b=void 0;class M extends R.$Jn{constructor(P){super(),this.f=P}call(P,f,a){return f==="openExtensionDevelopmentHostWindow"?this.g(a[0],a[1]):super.call(P,f,a)}async g(P,f){const a=(0,s.$El)(P,s.$Dl);a.debugRenderer=f;const g=a.extensionDevelopmentPath;if(!g)return{success:!1};const[w]=await this.f.openExtensionDevelopmentHostWindow(g,{context:5,cli:a,forceProfile:a.profile,forceTempProfile:a["profile-temp"]});if(!f)return{success:!0};const y=w.win;if(!y)return{success:!0};const d=y.webContents.debugger;let v=d.isAttached()?1/0:0;const b=(0,S.createServer)($=>{v++===0&&d.attach();let m=!1;const u=h=>{m||$.write(JSON.stringify(h)+"\0")},l=(h,i,c,o)=>u({method:i,params:c,sessionId:o});y.on("close",()=>{d.removeListener("message",l),$.end(),m=!0}),d.addListener("message",l);let E=Buffer.alloc(0);$.on("data",h=>{E=Buffer.concat([E,h]);for(let i=E.indexOf(0);i!==-1;i=E.indexOf(0)){let c;try{const o=E.slice(0,i).toString("utf8");E=E.slice(i+1),c=JSON.parse(o)}catch(o){console.error("error reading cdp line",o)}d.sendCommand(c.method,c.params,c.sessionId).then(o=>u({id:c.id,sessionId:c.sessionId,result:o})).catch(o=>u({id:c.id,sessionId:c.sessionId,error:{code:0,message:o.message}}))}}),$.on("error",h=>{console.error("error on cdp pipe:",h)}),$.on("close",()=>{m=!0,--v===0&&d.detach()})});return await new Promise($=>b.listen(0,$)),y.on("close",()=>b.close()),{rendererDebugPort:b.address().port,success:!0}}}e.$r6b=M}),define(te[62],ie([0,1,308,167,112]),function(Q,e,S,R,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ll=e.$Kl=e.$Jl=e.$Il=void 0;function M(w,y){const d=(l,E)=>{console.warn((0,R.localize)(0,null,l,E))},v=l=>{console.warn((0,R.localize)(1,null,l))},b=(l,E)=>{console.warn((0,R.localize)(2,null,l,E))},$=l=>({onUnknownOption:E=>{s.$Cl.includes(l)||console.warn((0,R.localize)(3,null,E,l))},onMultipleValues:d,onEmptyValue:v,onDeprecatedOption:b,getSubcommandReporter:s.$Cl.includes(l)?$:void 0}),m={onUnknownOption:l=>{console.warn((0,R.localize)(4,null,l))},onMultipleValues:d,onEmptyValue:v,onDeprecatedOption:b,getSubcommandReporter:$},u=(0,s.$El)(w,s.$Dl,y?m:void 0);return u.goto&&u._.forEach(l=>S(/^(\w:)?[^:]+(:\d*){0,2}:?$/.test(l),(0,R.localize)(5,null))),u}function D(w){const y=w.findIndex(d=>!/^-/.test(d));if(y>-1)return[...w.slice(0,y),...w.slice(y+1)]}function P(w){let[,...y]=w;process.env.VSCODE_DEV&&(y=D(y)||[]);const d=!g(process.env);return M(y,d)}e.$Il=P;function f(w){let[,,...y]=w;return process.env.VSCODE_DEV&&(y=D(y)||[]),M(y,!0)}e.$Jl=f;function a(w,...y){const d=w.indexOf("--");return d===-1?w.push(...y):w.splice(d,0,...y),w}e.$Kl=a;function g(w){return w.VSCODE_CLI==="1"}e.$Ll=g}),function(){"use strict";function Q(e,S,R){function s(D,P){const f=M(D,P),a=[f];return e.isAbsolute(f)||a.unshift(R),e.resolve(...a)}function M(D,P){process.env.VSCODE_DEV&&(P="code-oss-dev");const f=process.env.VSCODE_PORTABLE;if(f)return e.join(f,"user-data");let a=process.env.VSCODE_APPDATA;if(a)return e.join(a,P);const g=D["user-data-dir"];if(g)return g;switch(process.platform){case"win32":if(a=process.env.APPDATA,!a){const w=process.env.USERPROFILE;if(typeof w!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");a=e.join(w,"AppData","Roaming")}break;case"darwin":a=e.join(S.homedir(),"Library","Application Support");break;case"linux":a=process.env.XDG_CONFIG_HOME||e.join(S.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(a,P)}return{getUserDataPath:s}}if(typeof define=="function")define(te[199],ie([113,28,35]),function(e,S,R){return Q(e,S,R.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),S=require("os");module.exports=Q(e,S,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(te[89],ie([0,1,28,197,199]),function(Q,e,S,R,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jm=e.$im=e.$hm=void 0;class M extends R.$em{constructor(a,g){super(a,{homeDir:(0,S.homedir)(),tmpDir:(0,S.tmpdir)(),userDataDir:(0,s.getUserDataPath)(a,g.nameShort)},g)}}e.$hm=M;function D(f,a){return(0,R.$gm)(f["inspect-ptyhost"],f["inspect-brk-ptyhost"],5877,a,f.extensionEnvironment)}e.$im=D;function P(f,a){return(0,R.$gm)(f["inspect-sharedprocess"],f["inspect-brk-sharedprocess"],5879,a,f.extensionEnvironment)}e.$jm=P}),define(te[200],ie([0,1,45,28,33]),function(Q,e,S,R,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$S7b=void 0;function M(D){const P=(0,s.$6f)((0,R.tmpdir)());try{return(0,S.writeFileSync)(P,""),D&&console.log(`Marker file for --wait created: ${P}`),P}catch(f){D&&console.error(`Failed to create marker file for --wait: ${f}`);return}}e.$S7b=M}),define(te[201],ie([0,1,12,169]),function(Q,e,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vp=void 0;function s(D,P,f,a){try{M(D,P,f,a)}catch(g){D.error(g?.message??g)}return P}e.$vp=s;function M(D,P,f,a){const g=(w,y,d)=>{const v=w[y];if((0,S.$yf)(v)){const b=v,$=b.length;if($>1&&b[0]==="%"&&b[$-1]==="%"){const m=b.substr(1,$-2);let u=f[m];u===void 0&&a&&(u=a[m]);const l=typeof u=="string"?u:u?.message,E=a?.[m],h=typeof E=="string"?E:E?.message;if(!l){h||D.warn(`[${P.name}]: ${(0,R.localize)(0,null,m)}`);return}if(d&&(y==="title"||y==="category")&&h&&h!==l){const i={value:l,original:h};w[y]=i}else w[y]=l}}else if((0,S.$Af)(v))for(const b in v)v.hasOwnProperty(b)&&(b==="commands"?g(v,b,!0):g(v,b,d));else if(Array.isArray(v))for(let b=0;b<v.length;b++)g(v,b,d)};for(const w in P)P.hasOwnProperty(w)&&g(P,w)}}),define(te[202],ie([0,1,19,73,171,203]),function(Q,e,S,R,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Po=e.$Oo=e.$No=e.$Mo=e.$Lo=e.$Ko=e.$Jo=void 0;const D=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,P=/^-(\d{4})(\d{2})(\d{2})$/;function f(m){return m=m.trim(),m==="*"||D.test(m)}e.$Jo=f;function a(m){if(!f(m))return null;if(m=m.trim(),m==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const u=m.match(D);return u?{hasCaret:u[1]==="^",hasGreaterEquals:u[1]===">=",majorBase:u[2]==="x"?0:parseInt(u[2],10),majorMustEqual:u[2]!=="x",minorBase:u[4]==="x"?0:parseInt(u[4],10),minorMustEqual:u[4]!=="x",patchBase:u[6]==="x"?0:parseInt(u[6],10),patchMustEqual:u[6]!=="x",preRelease:u[8]||null}:null}e.$Ko=a;function g(m){if(!m)return null;const u=m.majorBase,l=m.majorMustEqual,E=m.minorBase;let h=m.minorMustEqual;const i=m.patchBase;let c=m.patchMustEqual;m.hasCaret&&(u===0||(h=!1),c=!1);let o=0;if(m.preRelease){const t=P.exec(m.preRelease);if(t){const[,n,r,p]=t;o=Date.UTC(Number(n),Number(r)-1,Number(p))}}return{majorBase:u,majorMustEqual:l,minorBase:E,minorMustEqual:h,patchBase:i,patchMustEqual:c,isMinimum:m.hasGreaterEquals,notBefore:o}}e.$Lo=g;function w(m,u,l){let E;typeof m=="string"?E=g(a(m)):E=m;let h;u instanceof Date?h=u.getTime():typeof u=="string"&&(h=new Date(u).getTime());let i;if(typeof l=="string"?i=g(a(l)):i=l,!E||!i)return!1;const c=E.majorBase,o=E.minorBase,t=E.patchBase;let n=i.majorBase,r=i.minorBase,p=i.patchBase;const A=i.notBefore;let C=i.majorMustEqual,k=i.minorMustEqual,I=i.patchMustEqual;return i.isMinimum?c>n?!0:c<n?!1:o>r?!0:o<r||h&&h<A?!1:t>=p:(c===1&&n===0&&(!C||!k||!I)&&(n=1,r=0,p=0,C=!0,k=!1,I=!1),c<n?!1:c>n?!C:o<r?!1:o>r?!k:t<p?!1:t>p?!I:!(h&&h<A))}e.$Mo=w;function y(m,u,l,E,h){const i=[];if(typeof E.publisher<"u"&&typeof E.publisher!="string")return i.push([R.default.Error,s.localize(0,null)]),i;if(typeof E.name!="string")return i.push([R.default.Error,s.localize(1,null,"name")]),i;if(typeof E.version!="string")return i.push([R.default.Error,s.localize(2,null,"version")]),i;if(!E.engines)return i.push([R.default.Error,s.localize(3,null,"engines")]),i;if(typeof E.engines.vscode!="string")return i.push([R.default.Error,s.localize(4,null,"engines.vscode")]),i;if(typeof E.extensionDependencies<"u"&&!$(E.extensionDependencies))return i.push([R.default.Error,s.localize(5,null,"extensionDependencies")]),i;if(typeof E.activationEvents<"u"){if(!$(E.activationEvents))return i.push([R.default.Error,s.localize(6,null,"activationEvents")]),i;if(typeof E.main>"u"&&typeof E.browser>"u")return i.push([R.default.Error,s.localize(7,null,"activationEvents","main","browser")]),i}if(typeof E.extensionKind<"u"&&typeof E.main>"u"&&i.push([R.default.Warning,s.localize(8,null,"extensionKind")]),typeof E.main<"u"){if(typeof E.main!="string")return i.push([R.default.Error,s.localize(9,null,"main")]),i;{const t=(0,S.$vg)(l,E.main);(0,S.$pg)(t,l)||i.push([R.default.Warning,s.localize(10,null,t.path,l.path)])}}if(typeof E.browser<"u"){if(typeof E.browser!="string")return i.push([R.default.Error,s.localize(11,null,"browser")]),i;{const t=(0,S.$vg)(l,E.browser);(0,S.$pg)(t,l)||i.push([R.default.Warning,s.localize(12,null,t.path,l.path)])}}if(!M.valid(E.version))return i.push([R.default.Error,s.localize(13,null)]),i;const c=[];if(!d(m,u,E,h,c))for(const t of c)i.push([R.default.Error,t]);return i}e.$No=y;function d(m,u,l,E,h){return E||typeof l.main>"u"&&typeof l.browser>"u"?!0:b(m,u,l.engines.vscode,h)}e.$Oo=d;function v(m,u,l){return m==="*"||b(u,l,m)}e.$Po=v;function b(m,u,l,E=[]){const h=g(a(l));if(!h)return E.push(s.localize(14,null,l)),!1;if(h.majorBase===0){if(!h.majorMustEqual||!h.minorMustEqual)return E.push(s.localize(15,null,l)),!1}else if(!h.majorMustEqual)return E.push(s.localize(16,null,l)),!1;return w(m,u,h)?!0:(E.push(s.localize(17,null,m,l)),!1)}function $(m){if(!Array.isArray(m))return!1;for(let u=0,l=m.length;u<l;u++)if(typeof m[u]!="string")return!1;return!0}}),define(te[204],ie([0,1,17,32]),function(Q,e,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0o=void 0;async function s(M,D,P){let f=P&&P.get("storage.serviceMachineId",-1)||null;if(f)return f;try{const g=(await D.readFile(M.serviceMachineIdResource)).value.toString();f=(0,R.$dg)(g)?g:null}catch{f=null}if(!f){f=(0,R.$eg)();try{await D.writeFile(M.serviceMachineIdResource,S.$be.fromString(f))}catch{}}return P?.store("storage.serviceMachineId",f,-1,1),f}e.$0o=s}),define(te[77],ie([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lh=void 0;class S{constructor(s,M=[],D=!1){this.ctor=s,this.staticArguments=M,this.supportsDelayedInstantiation=D}}e.$Lh=S}),define(te[205],ie([0,1,77]),function(Q,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vr=e.$ur=e.InstantiationType=void 0;const R=[];var s;(function(P){P[P.Eager=0]="Eager",P[P.Delayed=1]="Delayed"})(s||(e.InstantiationType=s={}));function M(P,f,a){f instanceof S.$Lh||(f=new S.$Lh(f,[],!!a)),R.push([P,f])}e.$ur=M;function D(){return R}e.$vr=D}),define(te[206],ie([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aq=e.$_p=void 0;class S{constructor(M,D){this.key=M,this.data=D,this.incoming=new Map,this.outgoing=new Map}}e.$_p=S;class R{constructor(M){this.b=M,this.a=new Map}roots(){const M=[];for(const D of this.a.values())D.outgoing.size===0&&M.push(D);return M}insertEdge(M,D){const P=this.lookupOrInsertNode(M),f=this.lookupOrInsertNode(D);P.outgoing.set(f.key,f),f.incoming.set(P.key,P)}removeNode(M){const D=this.b(M);this.a.delete(D);for(const P of this.a.values())P.outgoing.delete(D),P.incoming.delete(D)}lookupOrInsertNode(M){const D=this.b(M);let P=this.a.get(D);return P||(P=new S(D,M),this.a.set(D,P)),P}lookup(M){return this.a.get(this.b(M))}isEmpty(){return this.a.size===0}toString(){const M=[];for(const[D,P]of this.a)M.push(`${D}
	(-> incoming)[${[...P.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...P.outgoing.keys()].join(",")}]
`);return M.join(`
`)}findCycleSlow(){for(const[M,D]of this.a){const P=new Set([M]),f=this.c(D,P);if(f)return f}}c(M,D){for(const[P,f]of M.outgoing){if(D.has(P))return[...D,P].join(" -> ");D.add(P);const a=this.c(f,D);if(a)return a;D.delete(P)}}}e.$aq=R}),define(te[6],ie([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ph=e.$Oh=e.$Nh=e._util=void 0;var S;(function(D){D.serviceIds=new Map,D.DI_TARGET="$di$target",D.DI_DEPENDENCIES="$di$dependencies";function P(f){return f[D.DI_DEPENDENCIES]||[]}D.getServiceDependencies=P})(S||(e._util=S={})),e.$Nh=s("instantiationService");function R(D,P,f){P[S.DI_TARGET]===P?P[S.DI_DEPENDENCIES].push({id:D,index:f}):(P[S.DI_DEPENDENCIES]=[{id:D,index:f}],P[S.DI_TARGET]=P)}function s(D){if(S.serviceIds.has(D))return S.serviceIds.get(D);const P=function(f,a,g){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");R(P,f,g)};return P.toString=()=>D,S.serviceIds.set(D,P),P}e.$Oh=s;function M(D){return D}e.$Ph=M}),define(te[63],ie([0,1,6]),function(Q,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$l6b=void 0,e.$l6b=(0,S.$Oh)("backupMainService")}),define(te[18],ie([0,1,12,7,6]),function(Q,e,S,R,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$si=e.$ri=e.$qi=e.$pi=e.$oi=e.$ni=e.$mi=e.$li=e.ConfigurationTarget=e.$ki=e.$ji=e.$ii=void 0,e.$ii=(0,s.$Oh)("configurationService");function M(m){return m&&typeof m=="object"&&(!m.overrideIdentifier||typeof m.overrideIdentifier=="string")&&(!m.resource||m.resource instanceof R.URI)}e.$ji=M;function D(m){return m&&typeof m=="object"&&(!m.overrideIdentifiers||Array.isArray(m.overrideIdentifiers))&&!m.overrideIdentifier&&(!m.resource||m.resource instanceof R.URI)}e.$ki=D;var P;(function(m){m[m.APPLICATION=1]="APPLICATION",m[m.USER=2]="USER",m[m.USER_LOCAL=3]="USER_LOCAL",m[m.USER_REMOTE=4]="USER_REMOTE",m[m.WORKSPACE=5]="WORKSPACE",m[m.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",m[m.DEFAULT=7]="DEFAULT",m[m.MEMORY=8]="MEMORY"})(P||(e.ConfigurationTarget=P={}));function f(m){switch(m){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.$li=f;function a(m){return m.applicationValue!==void 0||m.userValue!==void 0||m.userLocalValue!==void 0||m.userRemoteValue!==void 0||m.workspaceValue!==void 0||m.workspaceFolderValue!==void 0}e.$mi=a;function g(m,u){const l=Object.create(null);for(const E in m)w(l,E,m[E],u);return l}e.$ni=g;function w(m,u,l,E){const h=u.split("."),i=h.pop();let c=m;for(let o=0;o<h.length;o++){const t=h[o];let n=c[t];switch(typeof n){case"undefined":n=c[t]=Object.create(null);break;case"object":break;default:E(`Ignoring ${u} as ${h.slice(0,o+1).join(".")} is ${JSON.stringify(n)}`);return}c=n}if(typeof c=="object"&&c!==null)try{c[i]=l}catch{E(`Ignoring ${u} as ${h.join(".")} is ${JSON.stringify(c)}`)}else E(`Ignoring ${u} as ${h.join(".")} is ${JSON.stringify(c)}`)}e.$oi=w;function y(m,u){const l=u.split(".");d(m,l)}e.$pi=y;function d(m,u){const l=u.shift();if(u.length===0){delete m[l];return}if(Object.keys(m).indexOf(l)!==-1){const E=m[l];typeof E=="object"&&!Array.isArray(E)&&(d(E,u),Object.keys(E).length===0&&delete m[l])}}function v(m,u,l){function E(c,o){let t=c;for(const n of o){if(typeof t!="object"||t===null)return;t=t[n]}return t}const h=u.split("."),i=E(m,h);return typeof i>"u"?l:i}e.$qi=v;function b(m,u,l){Object.keys(u).forEach(E=>{E!=="__proto__"&&(E in m?S.$Af(m[E])&&S.$Af(u[E])?b(m[E],u[E],l):l&&(m[E]=u[E]):m[E]=u[E])})}e.$ri=b;function $(m){return m.replace(/[\[\]]/g,"")}e.$si=$}),define(te[114],ie([0,1,4,27,195,6,162,14]),function(Q,e,S,R,s,M,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8i=e.$7i=e.$6i=e.$5i=e.$4i=e.$3i=e.$2i=e.$1i=e.$Zi=e.$Yi=e.$Xi=e.$Wi=e.$Vi=e.$Ui=e.$Ti=e.$Si=e.$Ri=e.$Qi=e.$Pi=e.$Oi=e.$Ni=e.$Mi=e.$Li=e.ContextKeyExprType=e.$Ki=void 0;const f=new Map;f.set("false",!1),f.set("true",!0),f.set("isMac",S.$k),f.set("isLinux",S.$l),f.set("isWindows",S.$j),f.set("isWeb",S.$p),f.set("isMacNative",S.$k&&!S.$p),f.set("isEdge",S.$H),f.set("isFirefox",S.$F),f.set("isChrome",S.$E),f.set("isSafari",S.$G);function a(F,O){if(f.get(F)!==void 0)throw(0,P.$7)("contextkey.setConstant(k, v) invoked with already set constant `k`");f.set(F,O)}e.$Ki=a;const g=Object.prototype.hasOwnProperty;var w;(function(F){F[F.False=0]="False",F[F.True=1]="True",F[F.Defined=2]="Defined",F[F.Not=3]="Not",F[F.Equals=4]="Equals",F[F.NotEquals=5]="NotEquals",F[F.And=6]="And",F[F.Regex=7]="Regex",F[F.NotRegex=8]="NotRegex",F[F.Or=9]="Or",F[F.In=10]="In",F[F.NotIn=11]="NotIn",F[F.Greater=12]="Greater",F[F.GreaterEquals=13]="GreaterEquals",F[F.Smaller=14]="Smaller",F[F.SmallerEquals=15]="SmallerEquals"})(w||(e.ContextKeyExprType=w={}));const y={regexParsingWithErrorRecovery:!0},d=(0,D.localize)(0,null),v=(0,D.localize)(1,null),b=(0,D.localize)(2,null),$=(0,D.localize)(3,null),m=(0,D.localize)(4,null),u=(0,D.localize)(5,null),l=(0,D.localize)(6,null),E=(0,D.localize)(7,null);class h{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(O=y){this.k=O,this.d=new s.$Ji,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(O){if(O===""){this.h.push({message:d,offset:0,lexeme:"",additionalInfo:v});return}this.f=this.d.reset(O).scan(),this.g=0,this.h=[];try{const L=this.l();if(!this.E()){const B=this.D(),T=B.type===17?u:void 0;throw this.h.push({message:m,offset:B.offset,lexeme:s.$Ji.getLexeme(B),additionalInfo:T}),h.c}return L}catch(L){if(L!==h.c)throw L;return}}l(){return this.m()}m(){const O=[this.o()];for(;this.y(16);){const L=this.o();O.push(L)}return O.length===1?O[0]:i.or(...O)}o(){const O=[this.s()];for(;this.y(15);){const L=this.s();O.push(L)}return O.length===1?O[0]:i.and(...O)}s(){if(this.y(2)){const O=this.D();switch(O.type){case 11:return this.z(),n.INSTANCE;case 12:return this.z(),r.INSTANCE;case 0:{this.z();const L=this.l();return this.A(1,$),L?.negate()}case 17:return this.z(),j.create(O.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",O)}}return this.t()}t(){const O=this.D();switch(O.type){case 11:return this.z(),i.true();case 12:return this.z(),i.false();case 0:{this.z();const L=this.l();return this.A(1,$),L}case 17:{const L=O.lexeme;if(this.z(),this.y(9)){const T=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),T.type!==10)throw this.B("REGEX",T);const W=T.lexeme,V=W.lastIndexOf("/"),ce=V===W.length-1?void 0:this.w(W.substring(V+1));let de;try{de=new RegExp(W.substring(1,V),ce)}catch{throw this.B("REGEX",T)}return se.create(L,de)}switch(T.type){case 10:case 19:{const W=[T.lexeme];this.z();let V=this.D(),ce=0;for(let be=0;be<T.lexeme.length;be++)T.lexeme.charCodeAt(be)===40?ce++:T.lexeme.charCodeAt(be)===41&&ce--;for(;!this.E()&&V.type!==15&&V.type!==16;){switch(V.type){case 0:ce++;break;case 1:ce--;break;case 10:case 18:for(let be=0;be<V.lexeme.length;be++)V.lexeme.charCodeAt(be)===40?ce++:T.lexeme.charCodeAt(be)===41&&ce--}if(ce<0)break;W.push(s.$Ji.getLexeme(V)),this.z(),V=this.D()}const de=W.join(""),ue=de.lastIndexOf("/"),fe=ue===de.length-1?void 0:this.w(de.substring(ue+1));let ye;try{ye=new RegExp(de.substring(1,ue),fe)}catch{throw this.B("REGEX",T)}return i.regex(L,ye)}case 18:{const W=T.lexeme;this.z();let V=null;if(!(0,R.$Be)(W)){const ce=W.indexOf("/"),de=W.lastIndexOf("/");if(ce!==de&&ce>=0){const ue=W.slice(ce+1,de),fe=W[de+1]==="i"?"i":"";try{V=new RegExp(ue,fe)}catch{throw this.B("REGEX",T)}}}if(V===null)throw this.B("REGEX",T);return se.create(L,V)}default:throw this.B("REGEX",this.D())}}if(this.y(14)){this.A(13,b);const T=this.u();return i.notIn(L,T)}switch(this.D().type){case 3:{this.z();const T=this.u();if(this.x().type===18)return i.equals(L,T);switch(T){case"true":return i.has(L);case"false":return i.not(L);default:return i.equals(L,T)}}case 4:{this.z();const T=this.u();if(this.x().type===18)return i.notEquals(L,T);switch(T){case"true":return i.not(L);case"false":return i.has(L);default:return i.notEquals(L,T)}}case 5:return this.z(),_.create(L,this.u());case 6:return this.z(),ae.create(L,this.u());case 7:return this.z(),z.create(L,this.u());case 8:return this.z(),ne.create(L,this.u());case 13:return this.z(),i.in(L,this.u());default:return i.has(L)}}case 20:throw this.h.push({message:l,offset:O.offset,lexeme:"",additionalInfo:E}),h.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const O=this.D();switch(O.type){case 17:case 18:return this.z(),O.lexeme;case 11:return this.z(),"true";case 12:return this.z(),"false";case 13:return this.z(),"in";default:return""}}w(O){return O.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(O){return this.C(O)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(O,L){if(this.C(O))return this.z();throw this.B(L,this.D())}B(O,L,B){const T=(0,D.localize)(8,null,O,s.$Ji.getLexeme(L)),W=L.offset,V=s.$Ji.getLexeme(L);return this.h.push({message:T,offset:W,lexeme:V,additionalInfo:B}),h.c}C(O){return this.D().type===O}D(){return this.f[this.g]}E(){return this.D().type===20}}e.$Li=h;class i{static false(){return n.INSTANCE}static true(){return r.INSTANCE}static has(O){return p.create(O)}static equals(O,L){return A.create(O,L)}static notEquals(O,L){return I.create(O,L)}static regex(O,L){return se.create(O,L)}static in(O,L){return C.create(O,L)}static notIn(O,L){return k.create(O,L)}static not(O){return j.create(O)}static and(...O){return J.create(O,null,!0)}static or(...O){return G.create(O,null,!0)}static greater(O,L){return z.create(O,L)}static greaterEquals(O,L){return ne.create(O,L)}static smaller(O,L){return _.create(O,L)}static smallerEquals(O,L){return ae.create(O,L)}static{this.c=new h({regexParsingWithErrorRecovery:!1})}static deserialize(O){return O==null?void 0:this.c.parse(O)}}e.$Mi=i;function c(F){const O=new h({regexParsingWithErrorRecovery:!1});return F.map(L=>(O.parse(L),O.lexingErrors.length>0?O.lexingErrors.map(B=>({errorMessage:B.additionalInfo?(0,D.localize)(9,null,B.additionalInfo):(0,D.localize)(10,null),offset:B.offset,length:B.lexeme.length})):O.parsingErrors.length>0?O.parsingErrors.map(B=>({errorMessage:B.additionalInfo?`${B.message}. ${B.additionalInfo}`:B.message,offset:B.offset,length:B.lexeme.length})):[]))}e.$Ni=c;function o(F,O){const L=F?F.substituteConstants():void 0,B=O?O.substituteConstants():void 0;return!L&&!B?!0:!L||!B?!1:L.equals(B)}e.$Oi=o;function t(F,O){return F.cmp(O)}class n{static{this.INSTANCE=new n}constructor(){this.type=0}cmp(O){return this.type-O.type}equals(O){return O.type===this.type}substituteConstants(){return this}evaluate(O){return!1}serialize(){return"false"}keys(){return[]}map(O){return this}negate(){return r.INSTANCE}}e.$Pi=n;class r{static{this.INSTANCE=new r}constructor(){this.type=1}cmp(O){return this.type-O.type}equals(O){return O.type===this.type}substituteConstants(){return this}evaluate(O){return!0}serialize(){return"true"}keys(){return[]}map(O){return this}negate(){return n.INSTANCE}}e.$Qi=r;class p{static create(O,L=null){const B=f.get(O);return typeof B=="boolean"?B?r.INSTANCE:n.INSTANCE:new p(O,L)}constructor(O,L){this.key=O,this.c=L,this.type=2}cmp(O){return O.type!==this.type?this.type-O.type:q(this.key,O.key)}equals(O){return O.type===this.type?this.key===O.key:!1}substituteConstants(){const O=f.get(this.key);return typeof O=="boolean"?O?r.INSTANCE:n.INSTANCE:this}evaluate(O){return!!O.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(O){return O.mapDefined(this.key)}negate(){return this.c||(this.c=j.create(this.key,this)),this.c}}e.$Ri=p;class A{static create(O,L,B=null){if(typeof L=="boolean")return L?p.create(O,B):j.create(O,B);const T=f.get(O);return typeof T=="boolean"?L===(T?"true":"false")?r.INSTANCE:n.INSTANCE:new A(O,L,B)}constructor(O,L,B){this.c=O,this.d=L,this.f=B,this.type=4}cmp(O){return O.type!==this.type?this.type-O.type:X(this.c,this.d,O.c,O.d)}equals(O){return O.type===this.type?this.c===O.c&&this.d===O.d:!1}substituteConstants(){const O=f.get(this.c);if(typeof O=="boolean"){const L=O?"true":"false";return this.d===L?r.INSTANCE:n.INSTANCE}return this}evaluate(O){return O.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(O){return O.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=I.create(this.c,this.d,this)),this.f}}e.$Si=A;class C{static create(O,L){return new C(O,L)}constructor(O,L){this.d=O,this.f=L,this.type=10,this.c=null}cmp(O){return O.type!==this.type?this.type-O.type:X(this.d,this.f,O.d,O.f)}equals(O){return O.type===this.type?this.d===O.d&&this.f===O.f:!1}substituteConstants(){return this}evaluate(O){const L=O.getValue(this.f),B=O.getValue(this.d);return Array.isArray(L)?L.includes(B):typeof B=="string"&&typeof L=="object"&&L!==null?g.call(L,B):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(O){return O.mapIn(this.d,this.f)}negate(){return this.c||(this.c=k.create(this.d,this.f)),this.c}}e.$Ti=C;class k{static create(O,L){return new k(O,L)}constructor(O,L){this.d=O,this.f=L,this.type=11,this.c=C.create(O,L)}cmp(O){return O.type!==this.type?this.type-O.type:this.c.cmp(O.c)}equals(O){return O.type===this.type?this.c.equals(O.c):!1}substituteConstants(){return this}evaluate(O){return!this.c.evaluate(O)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(O){return O.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$Ui=k;class I{static create(O,L,B=null){if(typeof L=="boolean")return L?j.create(O,B):p.create(O,B);const T=f.get(O);return typeof T=="boolean"?L===(T?"true":"false")?n.INSTANCE:r.INSTANCE:new I(O,L,B)}constructor(O,L,B){this.c=O,this.d=L,this.f=B,this.type=5}cmp(O){return O.type!==this.type?this.type-O.type:X(this.c,this.d,O.c,O.d)}equals(O){return O.type===this.type?this.c===O.c&&this.d===O.d:!1}substituteConstants(){const O=f.get(this.c);if(typeof O=="boolean"){const L=O?"true":"false";return this.d===L?n.INSTANCE:r.INSTANCE}return this}evaluate(O){return O.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(O){return O.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=A.create(this.c,this.d,this)),this.f}}e.$Vi=I;class j{static create(O,L=null){const B=f.get(O);return typeof B=="boolean"?B?n.INSTANCE:r.INSTANCE:new j(O,L)}constructor(O,L){this.c=O,this.d=L,this.type=3}cmp(O){return O.type!==this.type?this.type-O.type:q(this.c,O.c)}equals(O){return O.type===this.type?this.c===O.c:!1}substituteConstants(){const O=f.get(this.c);return typeof O=="boolean"?O?n.INSTANCE:r.INSTANCE:this}evaluate(O){return!O.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(O){return O.mapNot(this.c)}negate(){return this.d||(this.d=p.create(this.c,this)),this.d}}e.$Wi=j;function U(F,O){if(typeof F=="string"){const L=parseFloat(F);isNaN(L)||(F=L)}return typeof F=="string"||typeof F=="number"?O(F):n.INSTANCE}class z{static create(O,L,B=null){return U(L,T=>new z(O,T,B))}constructor(O,L,B){this.c=O,this.d=L,this.f=B,this.type=12}cmp(O){return O.type!==this.type?this.type-O.type:X(this.c,this.d,O.c,O.d)}equals(O){return O.type===this.type?this.c===O.c&&this.d===O.d:!1}substituteConstants(){return this}evaluate(O){return typeof this.d=="string"?!1:parseFloat(O.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(O){return O.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=ae.create(this.c,this.d,this)),this.f}}e.$Xi=z;class ne{static create(O,L,B=null){return U(L,T=>new ne(O,T,B))}constructor(O,L,B){this.c=O,this.d=L,this.f=B,this.type=13}cmp(O){return O.type!==this.type?this.type-O.type:X(this.c,this.d,O.c,O.d)}equals(O){return O.type===this.type?this.c===O.c&&this.d===O.d:!1}substituteConstants(){return this}evaluate(O){return typeof this.d=="string"?!1:parseFloat(O.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(O){return O.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=_.create(this.c,this.d,this)),this.f}}e.$Yi=ne;class _{static create(O,L,B=null){return U(L,T=>new _(O,T,B))}constructor(O,L,B){this.c=O,this.d=L,this.f=B,this.type=14}cmp(O){return O.type!==this.type?this.type-O.type:X(this.c,this.d,O.c,O.d)}equals(O){return O.type===this.type?this.c===O.c&&this.d===O.d:!1}substituteConstants(){return this}evaluate(O){return typeof this.d=="string"?!1:parseFloat(O.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(O){return O.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=ne.create(this.c,this.d,this)),this.f}}e.$Zi=_;class ae{static create(O,L,B=null){return U(L,T=>new ae(O,T,B))}constructor(O,L,B){this.c=O,this.d=L,this.f=B,this.type=15}cmp(O){return O.type!==this.type?this.type-O.type:X(this.c,this.d,O.c,O.d)}equals(O){return O.type===this.type?this.c===O.c&&this.d===O.d:!1}substituteConstants(){return this}evaluate(O){return typeof this.d=="string"?!1:parseFloat(O.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(O){return O.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=z.create(this.c,this.d,this)),this.f}}e.$1i=ae;class se{static create(O,L){return new se(O,L)}constructor(O,L){this.d=O,this.f=L,this.type=7,this.c=null}cmp(O){if(O.type!==this.type)return this.type-O.type;if(this.d<O.d)return-1;if(this.d>O.d)return 1;const L=this.f?this.f.source:"",B=O.f?O.f.source:"";return L<B?-1:L>B?1:0}equals(O){if(O.type===this.type){const L=this.f?this.f.source:"",B=O.f?O.f.source:"";return this.d===O.d&&L===B}return!1}substituteConstants(){return this}evaluate(O){const L=O.getValue(this.d);return this.f?this.f.test(L):!1}serialize(){const O=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${O}`}keys(){return[this.d]}map(O){return O.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=oe.create(this)),this.c}}e.$2i=se;class oe{static create(O){return new oe(O)}constructor(O){this.c=O,this.type=8}cmp(O){return O.type!==this.type?this.type-O.type:this.c.cmp(O.c)}equals(O){return O.type===this.type?this.c.equals(O.c):!1}substituteConstants(){return this}evaluate(O){return!this.c.evaluate(O)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(O){return new oe(this.c.map(O))}negate(){return this.c}}e.$3i=oe;function K(F){let O=null;for(let L=0,B=F.length;L<B;L++){const T=F[L].substituteConstants();if(F[L]!==T&&O===null){O=[];for(let W=0;W<L;W++)O[W]=F[W]}O!==null&&(O[L]=T)}return O===null?F:O}class J{static create(O,L,B){return J.d(O,L,B)}constructor(O,L){this.expr=O,this.c=L,this.type=6}cmp(O){if(O.type!==this.type)return this.type-O.type;if(this.expr.length<O.expr.length)return-1;if(this.expr.length>O.expr.length)return 1;for(let L=0,B=this.expr.length;L<B;L++){const T=t(this.expr[L],O.expr[L]);if(T!==0)return T}return 0}equals(O){if(O.type===this.type){if(this.expr.length!==O.expr.length)return!1;for(let L=0,B=this.expr.length;L<B;L++)if(!this.expr[L].equals(O.expr[L]))return!1;return!0}return!1}substituteConstants(){const O=K(this.expr);return O===this.expr?this:J.create(O,this.c,!1)}evaluate(O){for(let L=0,B=this.expr.length;L<B;L++)if(!this.expr[L].evaluate(O))return!1;return!0}static d(O,L,B){const T=[];let W=!1;for(const V of O)if(V){if(V.type===1){W=!0;continue}if(V.type===0)return n.INSTANCE;if(V.type===6){T.push(...V.expr);continue}T.push(V)}if(T.length===0&&W)return r.INSTANCE;if(T.length!==0){if(T.length===1)return T[0];T.sort(t);for(let V=1;V<T.length;V++)T[V-1].equals(T[V])&&(T.splice(V,1),V--);if(T.length===1)return T[0];for(;T.length>1;){const V=T[T.length-1];if(V.type!==9)break;T.pop();const ce=T.pop(),de=T.length===0,ue=G.create(V.expr.map(fe=>J.create([fe,ce],null,B)),null,de);ue&&(T.push(ue),T.sort(t))}if(T.length===1)return T[0];if(B){for(let V=0;V<T.length;V++)for(let ce=V+1;ce<T.length;ce++)if(T[V].negate().equals(T[ce]))return n.INSTANCE;if(T.length===1)return T[0]}return new J(T,L)}}serialize(){return this.expr.map(O=>O.serialize()).join(" && ")}keys(){const O=[];for(const L of this.expr)O.push(...L.keys());return O}map(O){return new J(this.expr.map(L=>L.map(O)),null)}negate(){if(!this.c){const O=[];for(const L of this.expr)O.push(L.negate());this.c=G.create(O,this,!0)}return this.c}}e.$4i=J;class G{static create(O,L,B){return G.d(O,L,B)}constructor(O,L){this.expr=O,this.c=L,this.type=9}cmp(O){if(O.type!==this.type)return this.type-O.type;if(this.expr.length<O.expr.length)return-1;if(this.expr.length>O.expr.length)return 1;for(let L=0,B=this.expr.length;L<B;L++){const T=t(this.expr[L],O.expr[L]);if(T!==0)return T}return 0}equals(O){if(O.type===this.type){if(this.expr.length!==O.expr.length)return!1;for(let L=0,B=this.expr.length;L<B;L++)if(!this.expr[L].equals(O.expr[L]))return!1;return!0}return!1}substituteConstants(){const O=K(this.expr);return O===this.expr?this:G.create(O,this.c,!1)}evaluate(O){for(let L=0,B=this.expr.length;L<B;L++)if(this.expr[L].evaluate(O))return!0;return!1}static d(O,L,B){let T=[],W=!1;if(O){for(let V=0,ce=O.length;V<ce;V++){const de=O[V];if(de){if(de.type===0){W=!0;continue}if(de.type===1)return r.INSTANCE;if(de.type===9){T=T.concat(de.expr);continue}T.push(de)}}if(T.length===0&&W)return n.INSTANCE;T.sort(t)}if(T.length!==0){if(T.length===1)return T[0];for(let V=1;V<T.length;V++)T[V-1].equals(T[V])&&(T.splice(V,1),V--);if(T.length===1)return T[0];if(B){for(let V=0;V<T.length;V++)for(let ce=V+1;ce<T.length;ce++)if(T[V].negate().equals(T[ce]))return r.INSTANCE;if(T.length===1)return T[0]}return new G(T,L)}}serialize(){return this.expr.map(O=>O.serialize()).join(" || ")}keys(){const O=[];for(const L of this.expr)O.push(...L.keys());return O}map(O){return new G(this.expr.map(L=>L.map(O)),null)}negate(){if(!this.c){const O=[];for(const L of this.expr)O.push(L.negate());for(;O.length>1;){const L=O.shift(),B=O.shift(),T=[];for(const W of re(L))for(const V of re(B))T.push(J.create([W,V],null,!1));O.unshift(G.create(T,null,!1))}this.c=G.create(O,this,!0)}return this.c}}e.$5i=G;class N extends p{static{this.d=[]}static all(){return N.d.values()}constructor(O,L,B){super(O,null),this.f=L,typeof B=="object"?N.d.push({...B,key:O}):B!==!0&&N.d.push({key:O,description:B,type:L!=null?typeof L:void 0})}bindTo(O){return O.createKey(this.key,this.f)}getValue(O){return O.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(O){return A.create(this.key,O)}notEqualsTo(O){return I.create(this.key,O)}}e.$6i=N,e.$7i=(0,M.$Oh)("contextKeyService");function q(F,O){return F<O?-1:F>O?1:0}function X(F,O,L,B){return F<L?-1:F>L?1:O<B?-1:O>B?1:0}function H(F,O){if(F.type===0||O.type===1)return!0;if(F.type===9)return O.type===9?Y(F.expr,O.expr):!1;if(O.type===9){for(const L of O.expr)if(H(F,L))return!0;return!1}if(F.type===6){if(O.type===6)return Y(O.expr,F.expr);for(const L of F.expr)if(H(L,O))return!0;return!1}return F.equals(O)}e.$8i=H;function Y(F,O){let L=0,B=0;for(;L<F.length&&B<O.length;){const T=F[L].cmp(O[B]);if(T<0)return!1;T===0&&L++,B++}return L===F.length}function re(F){return F.type===9?F.expr:[F]}}),define(te[90],ie([0,1,6]),function(Q,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qm=e.$pm=e.$om=e.ID=void 0,e.ID="diagnosticsService",e.$om=(0,S.$Oh)(e.ID);function R(M){return!!M.hostName&&!!M.errorMessage}e.$pm=R;class s{async getPerformanceInfo(D,P){return{}}async getSystemInfo(D,P){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(D,P){return""}async getWorkspaceFileExtensions(D){return{extensions:[]}}async reportWorkspaceStats(D){}}e.$qm=s}),define(te[115],ie([0,1,19,73,164,6,46,4,37]),function(Q,e,S,R,s,M,D,P,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bv=e.$Av=e.ConfirmResult=e.$zv=e.$yv=e.$xv=void 0,e.$xv=(0,M.$Oh)("dialogService");var a;(function(b){b[b.Confirmation=1]="Confirmation",b[b.Prompt=2]="Prompt",b[b.Input=3]="Input"})(a||(a={}));class g{a($){return this.d($,a.Confirmation)}b($){return this.d($,a.Prompt)}c($){return this.d($,a.Input)}d($,m){const u=[];switch(m){case a.Confirmation:{const l=$;l.primaryButton?u.push(l.primaryButton):u.push((0,s.localize)(0,null)),l.cancelButton?u.push(l.cancelButton):u.push((0,s.localize)(1,null));break}case a.Prompt:{const l=$;Array.isArray(l.buttons)&&l.buttons.length>0&&u.push(...l.buttons.map(E=>E.label)),l.cancelButton&&(l.cancelButton===!0?u.push((0,s.localize)(2,null)):typeof l.cancelButton=="string"?u.push(l.cancelButton):l.cancelButton.label?u.push(l.cancelButton.label):u.push((0,s.localize)(3,null))),u.length===0&&u.push((0,s.localize)(4,null));break}case a.Input:{const l=$;l.primaryButton?u.push(l.primaryButton):u.push((0,s.localize)(5,null)),l.cancelButton?u.push(l.cancelButton):u.push((0,s.localize)(6,null));break}}return u}e($){if(typeof $=="string")return $;if(typeof $=="number")return $===R.default.Info?"info":$===R.default.Error?"error":$===R.default.Warning?"warning":"none"}f($,m,u){const l=[...$.buttons??[]];$.cancelButton&&typeof $.cancelButton!="string"&&typeof $.cancelButton!="boolean"&&l.push($.cancelButton);let E=l[m]?.run({checkboxChecked:u});return E instanceof Promise||(E=Promise.resolve(E)),{result:E,checkboxChecked:u}}}e.$yv=g,e.$zv=(0,M.$Oh)("fileDialogService");var w;(function(b){b[b.SAVE=0]="SAVE",b[b.DONT_SAVE=1]="DONT_SAVE",b[b.CANCEL=2]="CANCEL"})(w||(e.ConfirmResult=w={}));const y=10;function d(b){const $=[];return $.push(...b.slice(0,y).map(m=>typeof m=="string"?m:(0,S.$sg)(m))),b.length>y&&(b.length-y===1?$.push((0,s.localize)(7,null)):$.push((0,s.localize)(8,null,b.length-y))),$.push(""),$.join(`
`)}e.$Av=d;function v(b,$){const m=(0,f.$4m)(b);let u=(m.buttons??[]).map(i=>(0,D.$uv)(i)),l=(b.buttons||[]).map((i,c)=>c),E=0,h=m.cancelId??u.length-1;if(u.length>1){const i=typeof h=="number"?u[h]:void 0;if(P.$l||P.$k){if(typeof i=="string"&&u.length>1&&h!==1){u.splice(h,1),u.splice(1,0,i);const c=l[h];l.splice(h,1),l.splice(1,0,c),h=1}P.$l&&u.length>1&&(u=u.reverse(),l=l.reverse(),E=u.length-1,typeof i=="string"&&(h=E-1))}else if(P.$j&&typeof i=="string"&&u.length>1&&h!==u.length-1){u.splice(h,1),u.push(i);const c=l[h];l.splice(h,1),l.push(c),h=u.length-1}}return m.buttons=u,m.defaultId=E,m.cancelId=h,m.noLink=!0,m.title=m.title||$.nameLong,{options:m,buttonIndeces:l}}e.$Bv=v}),define(te[116],ie([0,1,6]),function(Q,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1T=e.$ZT=e.KnownStorageProvider=e.PasswordStoreCLIOption=e.$YT=e.$XT=void 0,e.$XT=(0,S.$Oh)("encryptionService"),e.$YT=(0,S.$Oh)("encryptionMainService");var R;(function(P){P.kwallet="kwallet",P.kwallet5="kwallet5",P.gnome="gnome",P.gnomeKeyring="gnome-keyring",P.gnomeLibsecret="gnome-libsecret",P.basic="basic"})(R||(e.PasswordStoreCLIOption=R={}));var s;(function(P){P.unknown="unknown",P.basicText="basic_text",P.gnomeAny="gnome_any",P.gnomeLibsecret="gnome_libsecret",P.gnomeKeyring="gnome_keyring",P.kwallet="kwallet",P.kwallet5="kwallet5",P.kwallet6="kwallet6",P.dplib="dpapi",P.keychainAccess="keychain_access"})(s||(e.KnownStorageProvider=s={}));function M(P){return P==="kwallet"||P==="kwallet5"||P==="kwallet6"}e.$ZT=M;function D(P){return P==="gnome_any"||P==="gnome_libsecret"||P==="gnome_keyring"}e.$1T=D}),define(te[36],ie([0,1,6]),function(Q,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wh=e.$Vh=void 0,e.$Vh=(0,S.$Oh)("environmentService"),e.$Wh=(0,S.$Ph)(e.$Vh)}),define(te[117],ie([0,1,168,6]),function(Q,e,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eo=e.$do=e.$co=e.$bo=e.$ao=e.$_n=e.$$n=e.$0n=e.$9n=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.$8n=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.$7n=e.$6n=e.$5n=e.$4n=e.$3n=e.$2n=e.$1n=e.$Zn=e.$Yn=e.$Xn=e.$Wn=e.$Vn=e.$Un=void 0,e.$Un="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$Vn=new RegExp(e.$Un),e.$Wn="__web_extension",e.$Xn="skipWalkthrough",e.$Yn="extensionsSync",e.$Zn="dependecyOrPackExtensionInstall";function s(u){switch(u){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.$1n=s;function M(u){switch(u){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.$2n=M;function D(u,l){switch(u){case 3:return l==="x64"?"win32-x64":l==="ia32"?"win32-ia32":l==="arm64"?"win32-arm64":"unknown";case 2:return l==="x64"?"linux-x64":l==="arm64"?"linux-arm64":l==="arm"?"linux-armhf":"unknown";case"alpine":return l==="x64"?"alpine-x64":l==="arm64"?"alpine-arm64":"unknown";case 1:return l==="x64"?"darwin-x64":l==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.$3n=D;function P(u,l){return l==="web"&&!u.includes("web")}e.$4n=P;function f(u,l,E){return P(l,E)?!1:u==="undefined"||u==="universal"?!0:u==="unknown"?!1:u===E?!0:a(E).includes(u)}e.$5n=f;function a(u){switch(u){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.$6n=a;function g(u){return u&&typeof u=="object"&&typeof u.id=="string"&&(!u.uuid||typeof u.uuid=="string")}e.$7n=g;var w;(function(u){u[u.NoneOrRelevance=0]="NoneOrRelevance",u[u.LastUpdatedDate=1]="LastUpdatedDate",u[u.Title=2]="Title",u[u.PublisherName=3]="PublisherName",u[u.InstallCount=4]="InstallCount",u[u.PublishedDate=10]="PublishedDate",u[u.AverageRating=6]="AverageRating",u[u.WeightedRating=12]="WeightedRating"})(w||(e.SortBy=w={}));var y;(function(u){u[u.Default=0]="Default",u[u.Ascending=1]="Ascending",u[u.Descending=2]="Descending"})(y||(e.SortOrder=y={}));var d;(function(u){u.Install="install",u.Uninstall="uninstall"})(d||(e.StatisticType=d={}));var v;(function(u){u[u.None=1]="None",u[u.Install=2]="Install",u[u.Update=3]="Update",u[u.Migrate=4]="Migrate"})(v||(e.InstallOperation=v={})),e.$8n=(0,R.$Oh)("extensionGalleryService");var b;(function(u){u.Unsupported="Unsupported",u.Deprecated="Deprecated",u.Malicious="Malicious",u.Incompatible="Incompatible",u.IncompatibleTargetPlatform="IncompatibleTargetPlatform",u.ReleaseVersionNotFound="ReleaseVersionNotFound",u.Invalid="Invalid",u.Download="Download",u.Extract="Extract",u.Delete="Delete",u.Rename="Rename",u.CorruptZip="CorruptZip",u.IncompleteZip="IncompleteZip",u.Signature="Signature",u.Internal="Internal"})(b||(e.ExtensionManagementErrorCode=b={}));var $;(function(u){u.UnknownError="UnknownError",u.PackageIsInvalidZip="PackageIsInvalidZip",u.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})($||(e.ExtensionSignaturetErrorCode=$={}));class m extends Error{constructor(l,E){super(l),this.code=E,this.name=E}}e.$9n=m,e.$0n=(0,R.$Oh)("extensionManagementService"),e.$$n="extensionsIdentifiers/disabled",e.$_n="extensionsIdentifiers/enabled",e.$ao=(0,R.$Oh)("IGlobalExtensionEnablementService"),e.$bo=(0,R.$Oh)("IExtensionTipsService"),e.$co=(0,S.localize)(0,null),e.$do={value:e.$co,original:"Extensions"},e.$eo={value:(0,S.localize)(1,null),original:"Preferences"}}),define(te[207],ie([0,1,6]),function(Q,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$G6b=e.$F6b=void 0,e.$F6b=(0,S.$Oh)("extensionHostStarter"),e.$G6b="extensionHostStarter"}),define(te[208],ie([0,1,6]),function(Q,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ZXb=e.$YXb=void 0,e.$YXb=(0,S.$Oh)("externalTerminal"),e.$ZXb="Terminal.app"}),define(te[209],ie([0,1,6]),function(Q,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$I6b=void 0,e.$I6b=(0,S.$Oh)("externalTerminal")}),define(te[210],ie([0,1,47,13,9,4,75,21,88,172,208]),function(Q,e,S,R,s,M,D,P,f,a,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$L6b=e.$K6b=e.$J6b=void 0;const w=a.localize(0,null);class y{async getDefaultTerminalForPlatforms(){return{windows:d.getDefaultTerminalWindows(),linux:await b.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class d extends y{static{this.b="cmd.exe"}openTerminal(E,h){return this.spawnTerminal(S,E,f.$zl(),h)}spawnTerminal(E,h,i,c){const o=h.windowsExec||d.getDefaultTerminalWindows();c&&c[1]===":"&&(c=c[0].toUpperCase()+c.substr(1));const t=s.$nc(o,".exe").toLowerCase();if(t==="cmder")return E.spawn(o,c?[c]:void 0),Promise.resolve(void 0);const n=["/c","start","/wait"];return o.indexOf(" ")>=0&&n.push('""'),n.push(o),t==="wt"&&n.push("-d ."),new Promise((r,p)=>{const A=$(process),C=E.spawn(i,n,{cwd:c,env:A});C.on("error",p),C.on("exit",()=>r())})}runInTerminal(E,h,i,c,o){const t="windowsExec"in o&&o.windowsExec?o.windowsExec:d.getDefaultTerminalWindows();return new Promise((n,r)=>{const p=`"${h} - ${w}"`,A=`""${i.join('" "')}" & pause"`,C=Object.assign({},$(process),c);Object.keys(C).filter(z=>C[z]===null).forEach(z=>delete C[z]);const k={cwd:h,env:C,windowsVerbatimArguments:!0};let I,j;s.$nc(t,".exe")==="wt"?(I=t,j=["-d",".",d.b,"/c",A]):(I=d.b,j=["/c","start",p,"/wait",t,"/c",A]),S.spawn(I,j,k).on("error",z=>{r(m(z))}),n(void 0)})}static getDefaultTerminalWindows(){if(!d.d){const E=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");d.d=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${E?"Sysnative":"System32"}\\cmd.exe`}return d.d}}e.$J6b=d;class v extends y{static{this.b="/usr/bin/osascript"}openTerminal(E,h){return this.spawnTerminal(S,E,h)}runInTerminal(E,h,i,c,o){const t=o.osxExec||g.$ZXb;return new Promise((n,r)=>{if(t===g.$ZXb||t==="iTerm.app"){const p=t===g.$ZXb?"TerminalHelper":"iTermHelper",C=[R.$cg.asFileUri(`vs/workbench/contrib/externalTerminal/node/${p}.scpt`).fsPath,"-t",E||w,"-w",h];for(const j of i)C.push("-a"),C.push(j);if(c){const j=Object.assign({},$(process),c);for(const U in j){const z=j[U];z===null?(C.push("-u"),C.push(U)):(C.push("-e"),C.push(`${U}=${z}`))}}let k="";const I=S.spawn(v.b,C);I.on("error",j=>{r(m(j))}),I.stderr.on("data",j=>{k+=j.toString()}),I.on("exit",j=>{if(j===0)n(void 0);else if(k){const U=k.split(`
`,1);r(new Error(U[0]))}else r(new Error(a.localize(1,null,p,j)))})}else r(new Error(a.localize(2,null,t)))})}spawnTerminal(E,h,i){const c=h.osxExec||g.$ZXb;return new Promise((o,t)=>{const n=["-a",c];i&&n.push(i);const r=$(process),p=E.spawn("/usr/bin/open",n,{cwd:i,env:r});p.on("error",t),p.on("exit",()=>o())})}}e.$K6b=v;class b extends y{static{this.b=a.localize(3,null)}openTerminal(E,h){return this.spawnTerminal(S,E,h)}runInTerminal(E,h,i,c,o){const t=o.linuxExec?Promise.resolve(o.linuxExec):b.getDefaultTerminalLinuxReady();return new Promise((n,r)=>{const p=[];t.then(A=>{A.indexOf("gnome-terminal")>=0?p.push("-x"):p.push("-e"),p.push("bash"),p.push("-c");const C=`${u(i)}; echo; read -p "${b.b}" -n1;`;p.push(`''${C}''`);const k=Object.assign({},$(process),c);Object.keys(k).filter(z=>k[z]===null).forEach(z=>delete k[z]);const I={cwd:h,env:k};let j="";const U=S.spawn(A,p,I);U.on("error",z=>{r(m(z))}),U.stderr.on("data",z=>{j+=z.toString()}),U.on("exit",z=>{if(z===0)n(void 0);else if(j){const ne=j.split(`
`,1);r(new Error(ne[0]))}else r(new Error(a.localize(4,null,A,z)))})})})}static async getDefaultTerminalLinuxReady(){if(!b.d)if(!M.$l)b.d=Promise.resolve("xterm");else{const E=await P.Promises.exists("/etc/debian_version");b.d=new Promise(h=>{E?h("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?h("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?h("konsole"):process.env.COLORTERM?h(process.env.COLORTERM):process.env.TERM?h(process.env.TERM):h("xterm")})}return b.d}spawnTerminal(E,h,i){const c=h.linuxExec?Promise.resolve(h.linuxExec):b.getDefaultTerminalLinuxReady();return new Promise((o,t)=>{c.then(n=>{const r=$(process),p=E.spawn(n,[],{cwd:i,env:r});p.on("error",t),p.on("exit",()=>o())})})}}e.$L6b=b;function $(l){const E={...l.env};return(0,D.$xl)(E),E}function m(l){return"errno"in l&&l.errno==="ENOENT"&&"path"in l&&typeof l.path=="string"?new Error(a.localize(5,null,l.path)):l}function u(l){let E="";for(const h of l)h.indexOf(" ")>=0?E+='"'+h+'"':E+=h,E+=" ";return E}}),define(te[16],ie([0,1,56,9,27,12,7,174,6,4,13,71]),function(Q,e,S,R,s,M,D,P,f,a,g,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gk=e.$Fk=e.$Ek=e.$Dk=e.$Ck=e.FileKind=e.$Bk=e.$Ak=e.$zk=e.$yk=e.$xk=e.$wk=e.$vk=e.FileOperationResult=e.$uk=e.$tk=e.$sk=e.$rk=e.$qk=e.FileChangeType=e.$pk=e.FileOperation=e.$ok=e.$nk=e.$mk=e.$lk=e.$kk=e.$jk=e.FileSystemProviderErrorCode=e.$ik=e.$hk=e.$gk=e.$fk=e.$ek=e.$dk=e.$ck=e.$bk=e.$ak=e.FileSystemProviderCapabilities=e.$_j=e.FilePermission=e.FileType=e.$$j=e.$0j=void 0,e.$0j=(0,f.$Oh)("fileService");function y(H){return H.create===!0}e.$$j=y;var d;(function(H){H[H.Unknown=0]="Unknown",H[H.File=1]="File",H[H.Directory=2]="Directory",H[H.SymbolicLink=64]="SymbolicLink"})(d||(e.FileType=d={}));var v;(function(H){H[H.Readonly=1]="Readonly",H[H.Locked=2]="Locked"})(v||(e.FilePermission=v={}));function b(H){const Y=H;return!!Y&&typeof Y.onDidChange=="function"}e.$_j=b;var $;(function(H){H[H.None=0]="None",H[H.FileReadWrite=2]="FileReadWrite",H[H.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",H[H.FileReadStream=16]="FileReadStream",H[H.FileFolderCopy=8]="FileFolderCopy",H[H.PathCaseSensitive=1024]="PathCaseSensitive",H[H.Readonly=2048]="Readonly",H[H.Trash=4096]="Trash",H[H.FileWriteUnlock=8192]="FileWriteUnlock",H[H.FileAtomicRead=16384]="FileAtomicRead",H[H.FileAtomicWrite=32768]="FileAtomicWrite",H[H.FileAtomicDelete=65536]="FileAtomicDelete",H[H.FileClone=131072]="FileClone"})($||(e.FileSystemProviderCapabilities=$={}));function m(H){return!!(H.capabilities&2)}e.$ak=m;function u(H){return!!(H.capabilities&8)}e.$bk=u;function l(H){return!!(H.capabilities&131072)}e.$ck=l;function E(H){return!!(H.capabilities&4)}e.$dk=E;function h(H){return!!(H.capabilities&16)}e.$ek=h;function i(H){return m(H)?!!(H.capabilities&16384):!1}e.$fk=i;function c(H){return m(H)?!!(H.capabilities&32768):!1}e.$gk=c;function o(H){return!!(H.capabilities&65536)}e.$hk=o;function t(H){return!!(H.capabilities&2048)}e.$ik=t;var n;(function(H){H.FileExists="EntryExists",H.FileNotFound="EntryNotFound",H.FileNotADirectory="EntryNotADirectory",H.FileIsADirectory="EntryIsADirectory",H.FileExceedsStorageQuota="EntryExceedsStorageQuota",H.FileTooLarge="EntryTooLarge",H.FileWriteLocked="EntryWriteLocked",H.NoPermissions="NoPermissions",H.Unavailable="Unavailable",H.Unknown="Unknown"})(n||(e.FileSystemProviderErrorCode=n={}));class r extends Error{static create(Y,re){const F=new r(Y.toString(),re);return C(F,re),F}constructor(Y,re){super(Y),this.code=re}}e.$jk=r;function p(H,Y){return r.create(H,Y)}e.$kk=p;function A(H){return H||p((0,P.localize)(0,null),n.Unknown)}e.$lk=A;function C(H,Y){return H.name=Y?`${Y} (FileSystemError)`:"FileSystemError",H}e.$mk=C;function k(H){if(!H)return n.Unknown;if(H instanceof r)return H.code;const Y=/^(.+) \(FileSystemError\)$/.exec(H.name);if(!Y)return n.Unknown;switch(Y[1]){case n.FileExists:return n.FileExists;case n.FileIsADirectory:return n.FileIsADirectory;case n.FileNotADirectory:return n.FileNotADirectory;case n.FileNotFound:return n.FileNotFound;case n.FileTooLarge:return n.FileTooLarge;case n.FileWriteLocked:return n.FileWriteLocked;case n.NoPermissions:return n.NoPermissions;case n.Unavailable:return n.Unavailable}return n.Unknown}e.$nk=k;function I(H){if(H instanceof ae)return H.fileOperationResult;switch(k(H)){case n.FileNotFound:return 1;case n.FileIsADirectory:return 0;case n.FileNotADirectory:return 9;case n.FileWriteLocked:return 5;case n.NoPermissions:return 6;case n.FileExists:return 4;case n.FileTooLarge:return 7;default:return 10}}e.$ok=I;var j;(function(H){H[H.CREATE=0]="CREATE",H[H.DELETE=1]="DELETE",H[H.MOVE=2]="MOVE",H[H.COPY=3]="COPY",H[H.WRITE=4]="WRITE"})(j||(e.FileOperation=j={}));class U{constructor(Y,re,F){this.resource=Y,this.operation=re,this.target=F}isOperation(Y){return this.operation===Y}}e.$pk=U;var z;(function(H){H[H.UPDATED=0]="UPDATED",H[H.ADDED=1]="ADDED",H[H.DELETED=2]="DELETED"})(z||(e.FileChangeType=z={}));class ne{static{this.a=null}constructor(Y,re){this.c=re,this.b=void 0,this.d=new w.$V(()=>{const F=S.$Uh.forUris(()=>this.c);return F.fill(this.rawAdded.map(O=>[O,!0])),F}),this.f=new w.$V(()=>{const F=S.$Uh.forUris(()=>this.c);return F.fill(this.rawUpdated.map(O=>[O,!0])),F}),this.g=new w.$V(()=>{const F=S.$Uh.forUris(()=>this.c);return F.fill(this.rawDeleted.map(O=>[O,!0])),F}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const F of Y){switch(F.type){case 1:this.rawAdded.push(F.resource);break;case 0:this.rawUpdated.push(F.resource);break;case 2:this.rawDeleted.push(F.resource);break}this.b!==ne.a&&(typeof F.cId=="number"?this.b===void 0?this.b=F.cId:this.b!==F.cId&&(this.b=ne.a):this.b!==void 0&&(this.b=ne.a))}}contains(Y,...re){return this.h(Y,{includeChildren:!1},...re)}affects(Y,...re){return this.h(Y,{includeChildren:!0},...re)}h(Y,re,...F){if(!Y)return!1;const O=F.length>0;return!!((!O||F.includes(1))&&(this.d.value.get(Y)||re.includeChildren&&this.d.value.findSuperstr(Y))||(!O||F.includes(0))&&(this.f.value.get(Y)||re.includeChildren&&this.f.value.findSuperstr(Y))||(!O||F.includes(2))&&(this.g.value.findSubstr(Y)||re.includeChildren&&this.g.value.findSuperstr(Y)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(Y){return this.b===Y}hasCorrelation(){return typeof this.b=="number"}}e.$qk=ne;function _(H,Y,re){return!H||!Y||H===Y||Y.length>H.length?!1:(Y.charAt(Y.length-1)!==R.sep&&(Y+=R.sep),re?(0,s.$3e)(H,Y):H.indexOf(Y)===0)}e.$rk=_;class ae extends Error{constructor(Y,re,F){super(Y),this.fileOperationResult=re,this.options=F}}e.$sk=ae;class se extends ae{constructor(Y,re,F,O){super(Y,re,O),this.fileOperationResult=re,this.size=F}}e.$tk=se;class oe extends ae{constructor(Y,re,F){super(Y,2,F),this.stat=re}}e.$uk=oe;var K;(function(H){H[H.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",H[H.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",H[H.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",H[H.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",H[H.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",H[H.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",H[H.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",H[H.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",H[H.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",H[H.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",H[H.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(K||(e.FileOperationResult=K={})),e.$vk={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$wk={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$xk="files.associations",e.$yk="files.exclude",e.$zk="files.readonlyInclude",e.$Ak="files.readonlyExclude",e.$Bk="files.readonlyFromPermissions";var J;(function(H){H[H.FILE=0]="FILE",H[H.FOLDER=1]="FOLDER",H[H.ROOT_FOLDER=2]="ROOT_FOLDER"})(J||(e.FileKind=J={})),e.$Ck="";function G(H){if(!(typeof H.size!="number"||typeof H.mtime!="number"))return H.mtime.toString(29)+H.size.toString(31)}e.$Dk=G;async function N(H,Y){if(!Y.hasProvider(D.URI.from({scheme:H.scheme})))return new Promise(re=>{const F=Y.onDidChangeFileSystemProviderRegistrations(O=>{O.scheme===H.scheme&&O.added&&(F.dispose(),re())})})}e.$Ek=N;class q{static{this.KB=1024}static{this.MB=q.KB*q.KB}static{this.GB=q.MB*q.KB}static{this.TB=q.GB*q.KB}static formatSize(Y){return(0,M.$Cf)(Y)||(Y=0),Y<q.KB?(0,P.localize)(1,null,Y.toFixed(0)):Y<q.MB?(0,P.localize)(2,null,(Y/q.KB).toFixed(2)):Y<q.GB?(0,P.localize)(3,null,(Y/q.MB).toFixed(2)):Y<q.TB?(0,P.localize)(4,null,(Y/q.GB).toFixed(2)):(0,P.localize)(5,null,(Y/q.TB).toFixed(2))}}e.$Fk=q;function X(H){const Y=typeof H=="string"||H?.scheme===g.Schemas.vscodeRemote;return typeof H!="string"&&H?.scheme===g.Schemas.file?1024*q.MB:Y?10*q.MB:a.$p?50*q.MB:1024*q.MB}e.$Gk=X}),define(te[118],ie([0,1,17,14,175,16]),function(Q,e,S,R,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kp=void 0;async function D(g,w,y,d,v,b){let $;try{await P(g,w,y,d,v,b)}catch(m){$=m}finally{$&&v.errorTransformer&&($=v.errorTransformer($)),typeof $<"u"&&y.error($),y.end()}}e.$Kp=D;async function P(g,w,y,d,v,b){f(b);const $=await g.open(w,{create:!1});try{f(b);let m=0,u=0,l=v&&typeof v.length=="number"?v.length:void 0,E=S.$be.alloc(Math.min(v.bufferSize,typeof l=="number"?l:v.bufferSize)),h=v&&typeof v.position=="number"?v.position:0,i=0;do u=await g.read($,h,E.buffer,i,E.byteLength-i),h+=u,i+=u,m+=u,typeof l=="number"&&(l-=u),i===E.byteLength&&(await y.write(d(E)),E=S.$be.alloc(Math.min(v.bufferSize,typeof l=="number"?l:v.bufferSize)),i=0);while(u>0&&(typeof l!="number"||l>0)&&f(b)&&a(m,v));if(i>0){let c=i;typeof l=="number"&&(c=Math.min(i,l)),y.write(d(E.slice(0,c)))}}catch(m){throw(0,M.$lk)(m)}finally{await g.close($)}}function f(g){if(g.isCancellationRequested)throw(0,R.$6)();return!0}function a(g,w){if(typeof w?.limits?.size=="number"&&g>w.limits.size)throw(0,M.$kk)((0,s.localize)(0,null),M.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(te[64],ie([0,1,104,2,9,4,7,16]),function(Q,e,S,R,s,M,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tp=e.$Sp=e.$Rp=e.$Qp=e.$Pp=e.$Op=e.$Np=e.$Mp=void 0;function f(m){return m.recursive===!0}e.$Mp=f;class a extends R.$Sc{static{this.a=5}constructor(u,l,E,h){super(),this.h=u,this.j=l,this.m=E,this.n=h,this.c=this.B(new R.$Tc),this.f=void 0,this.g=0}s(){const u=new R.$Rc;this.c.value=u,this.b=this.r(u),this.b.setVerboseLogging(this.m),u.add(this.b.onDidChangeFile(l=>this.h(l))),u.add(this.b.onDidLogMessage(l=>this.j(l))),u.add(this.b.onDidError(l=>this.t(l)))}t(u){this.n.restartOnError?this.g<a.a&&this.f?(this.w(`restarting watcher after error: ${u}`),this.u(this.f)):this.w(`gave up attempting to restart watcher after error: ${u}`):this.w(u)}u(u){this.g++,this.s(),this.watch(u)}async watch(u){this.f=u,await this.b?.watch(u)}async setVerboseLogging(u){this.m=u,await this.b?.setVerboseLogging(u)}w(u){this.j({type:"error",message:`[File Watcher (${this.n.type})] ${u}`})}y(u){this.j({type:"trace",message:`[File Watcher (${this.n.type})] ${u}`})}dispose(){return this.b=void 0,super.dispose()}}e.$Np=a;class g extends a{constructor(u,l,E){super(u,l,E,{type:"node.js",restartOnError:!1})}}e.$Op=g;class w extends a{constructor(u,l,E){super(u,l,E,{type:"universal",restartOnError:!0})}}e.$Pp=w;function y(m){return m.map(u=>({type:u.type,resource:D.URI.revive(u.resource),cId:u.cId}))}e.$Qp=y;function d(m){const u=new $;for(const l of m)u.processEvent(l);return u.coalesce()}e.$Rp=d;function v(m,u){return typeof u=="string"&&!u.startsWith(S.$rj)&&!(0,s.$ic)(u)?{base:m,pattern:u}:u}e.$Sp=v;function b(m,u){const l=[];for(const E of u)l.push((0,S.$vj)(v(m,E)));return l}e.$Tp=b;class ${constructor(){this.a=new Set,this.b=new Map}c(u){return M.$l?u.resource.fsPath:u.resource.fsPath.toLowerCase()}processEvent(u){const l=this.b.get(this.c(u));let E=!1;if(l){const h=l.type,i=u.type;l.resource.fsPath!==u.resource.fsPath&&(u.type===2||u.type===1)?E=!0:h===1&&i===2?(this.b.delete(this.c(u)),this.a.delete(l)):h===2&&i===1?l.type=0:h===1&&i===0||(l.type=i)}else E=!0;E&&(this.a.add(u),this.b.set(this.c(u),u))}coalesce(){const u=[],l=[];return Array.from(this.a).filter(E=>E.type!==2?(u.push(E),!1):!0).sort((E,h)=>E.resource.fsPath.length-h.resource.fsPath.length).filter(E=>l.some(h=>(0,P.$rk)(E.resource.fsPath,h,!M.$l))?!1:(l.push(E.resource.fsPath),!0)).concat(u)}}}),define(te[211],ie([0,1,17,49,14,3,2,61,32,16,64]),function(Q,e,S,R,s,M,D,P,f,a,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iN=e.$hN=void 0,e.$hN="localFilesystem";class w extends D.$Sc{constructor(d,v){super(),this.a=d,this.b=v,this.onDidChangeCapabilities=M.Event.None,this.f=this.B(new M.$Nd),this.onDidChangeFile=this.f.event,this.g=this.B(new M.$Nd),this.onDidWatchError=this.g.event,this.h=(0,f.$eg)(),this.j()}get capabilities(){return this.c||(this.c=253982,this.b.pathCaseSensitive&&(this.c|=1024),this.b.trash&&(this.c|=4096)),this.c}stat(d){return this.a.call("stat",[d])}readdir(d){return this.a.call("readdir",[d])}async readFile(d,v){const{buffer:b}=await this.a.call("readFile",[d,v]);return b}readFileStream(d,v,b){const $=(0,P.$2d)(u=>S.$be.concat(u.map(l=>S.$be.wrap(l))).buffer),m=new D.$Rc;return m.add(this.a.listen("readFileStream",[d,v])(u=>{if(u instanceof S.$be)$.write(u.buffer);else{if(u==="end")$.end();else{let l;if(u instanceof Error)l=u;else{const E=u;l=(0,a.$kk)(E.message??(0,R.$zi)(E),E.code??a.FileSystemProviderErrorCode.Unknown)}$.error(l),$.end()}m.dispose()}})),m.add(b.onCancellationRequested(()=>{$.error((0,s.$6)()),$.end(),m.dispose()})),$}writeFile(d,v,b){return this.a.call("writeFile",[d,S.$be.wrap(v),b])}open(d,v){return this.a.call("open",[d,v])}close(d){return this.a.call("close",[d])}async read(d,v,b,$,m){const[u,l]=await this.a.call("read",[d,v,m]);return b.set(u.buffer.slice(0,l),$),l}write(d,v,b,$,m){return this.a.call("write",[d,v,S.$be.wrap(b),$,m])}mkdir(d){return this.a.call("mkdir",[d])}delete(d,v){return this.a.call("delete",[d,v])}rename(d,v,b){return this.a.call("rename",[d,v,b])}copy(d,v,b){return this.a.call("copy",[d,v,b])}cloneFile(d,v){return this.a.call("cloneFile",[d,v])}j(){this.B(this.a.listen("fileChange",[this.h])(d=>{if(Array.isArray(d)){const v=d;this.f.fire((0,g.$Qp)(v))}else{const v=d;this.g.fire(v)}}))}watch(d,v){const b=(0,f.$eg)();return this.a.call("watch",[this.h,b,d,v]),(0,D.$Qc)(()=>this.a.call("unwatch",[this.h,b]))}}e.$iN=w}),define(te[212],ie([0,1,45,8,22,33,2,84,9,4,19,7,105,21,64]),function(Q,e,S,R,s,M,D,P,f,a,g,w,y,d,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8p=e.$7p=void 0;class b extends D.$Sc{static{this.a=100}static{this.b=75}constructor(u,l,E,h){super(),this.m=u,this.n=l,this.r=E,this.s=h,this.c=this.B(new R.$9g({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},i=>this.n(i))),this.f=this.B(new R.$8g(i=>this.z(i),b.b)),this.g=(0,v.$Tp)(this.m.path,this.m.excludes),this.h=this.m.includes?(0,v.$Tp)(this.m.path,this.m.includes):void 0,this.j=new s.$Xd,this.ready=this.t()}async t(){try{const u=await this.u(this.m);if(this.j.token.isCancellationRequested)return;const l=await d.Promises.stat(u);this.B(await this.w(u,l.isDirectory()))}catch(u){u.code!=="ENOENT"?this.D(u):this.G(u)}}async u(u){let l=u.path;try{l=await d.Promises.realpath(u.path),u.path===l&&(l=await(0,y.$4p)(u.path)??u.path),u.path!==l&&this.G(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${u.path}, real: ${l})`)}catch{}return l}async w(u,l){if(a.$k&&(0,M.$Xf)(u,"/Volumes/",!0))return this.D(`Refusing to watch ${u} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),D.$Sc.None;const E=new s.$Xd(this.j.token),h=new D.$Rc;try{const i=w.URI.file(this.m.path),c=(0,f.$nc)(u),o=(0,S.watch)(u);h.add((0,D.$Qc)(()=>{o.removeAllListeners(),o.close()})),this.G(`Started watching: '${u}'`);const t=new Set;if(l)try{for(const r of await d.Promises.readdir(u))t.add(r)}catch(r){this.D(r)}const n=new Map;h.add((0,D.$Qc)(()=>{for(const[,r]of n)r.dispose();n.clear()})),o.on("error",(r,p)=>{this.D(`Failed to watch ${u} for changes using fs.watch() (${r}, ${p})`),this.dispose()}),o.on("change",(r,p)=>{if(E.token.isCancellationRequested)return;this.G(`[raw] ["${r}"] ${p}`);let A="";if(p&&(A=p.toString(),a.$k&&(A=(0,P.$ml)(A))),!(!A||r!=="change"&&r!=="rename"))if(l)if(r==="rename"){n.get(A)?.dispose();const C=setTimeout(async()=>{if(n.delete(A),A===c&&!await d.Promises.exists(u)){this.F("Watcher shutdown because watched path got deleted"),this.dispose();return}const k=await this.C((0,f.$jc)(u,A));if(E.token.isCancellationRequested)return;let I;k?t.has(A)?I=0:(I=1,t.add(A)):(t.delete(A),I=2),this.y({resource:(0,g.$vg)(i,A),type:I,cId:this.m.correlationId})},b.a);n.set(A,(0,D.$Qc)(()=>clearTimeout(C)))}else{let C;t.has(A)?C=0:(C=1,t.add(A)),this.y({resource:(0,g.$vg)(i,A),type:C,cId:this.m.correlationId})}else if(r==="rename"||A!==c){const C=setTimeout(async()=>{const k=await d.Promises.exists(u);E.token.isCancellationRequested||(k?(this.y({resource:i,type:0,cId:this.m.correlationId},!0),h.add(await this.w(u,!1))):(this.y({resource:i,type:2,cId:this.m.correlationId},!0),this.f.flush(),this.dispose()))},b.a);h.clear(),h.add((0,D.$Qc)(()=>clearTimeout(C)))}else this.y({resource:i,type:0,cId:this.m.correlationId},!0)})}catch(i){await d.Promises.exists(u)&&!E.token.isCancellationRequested&&this.D(`Failed to watch ${u} for changes using fs.watch() (${i.toString()})`)}return(0,D.$Qc)(()=>{E.dispose(!0),h.dispose()})}y(u,l=!1){this.j.token.isCancellationRequested||(this.s&&this.G(`${u.type===1?"[ADDED]":u.type===2?"[DELETED]":"[CHANGED]"} ${u.resource.fsPath}`),!l&&this.g.some(E=>E(u.resource.fsPath))?this.s&&this.G(` >> ignored (excluded) ${u.resource.fsPath}`):!l&&this.h&&this.h.length>0&&!this.h.some(E=>E(u.resource.fsPath))?this.s&&this.G(` >> ignored (not included) ${u.resource.fsPath}`):this.f.work(u))}z(u){const l=(0,v.$Rp)(u);if(l.length>0){if(this.s)for(const h of l)this.G(` >> normalized ${h.type===1?"[ADDED]":h.type===2?"[DELETED]":"[CHANGED]"} ${h.resource.fsPath}`);this.c.work(l)?this.c.pending>0&&this.G(`started throttling events due to large amount of file change events at once (pending: ${this.c.pending}, most recent change: ${l[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.F(`started ignoring events due to too many file change events at once (incoming: ${l.length}, most recent change: ${l[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}async C(u){if(a.$l)return d.Promises.exists(u);try{const l=(0,f.$nc)(u);return(await d.Promises.readdir((0,f.$mc)(u))).some(h=>h===l)}catch(l){return this.G(l),!1}}setVerboseLogging(u){this.s=u}D(u){this.j.token.isCancellationRequested||this.r?.({type:"error",message:`[File Watcher (node.js)] ${u}`})}F(u){this.j.token.isCancellationRequested||this.r?.({type:"warn",message:`[File Watcher (node.js)] ${u}`})}G(u){!this.j.token.isCancellationRequested&&this.s&&this.r?.({type:"trace",message:`[File Watcher (node.js)] ${u}`})}dispose(){this.G(`stopping file watcher on ${this.m.path}`),this.j.dispose(!0),super.dispose()}}e.$7p=b;async function $(m,u,l,E,h=512){const i=await d.Promises.open(m,"r"),c=Buffer.allocUnsafe(h),o=new s.$Xd(E);let t,n=!1;const r={path:m,excludes:[],recursive:!1},p=new b(r,A=>{(async()=>{for(const{type:C}of A)if(C===0){if(n)return;n=!0;try{for(;!o.token.isCancellationRequested;){const{bytesRead:k}=await d.Promises.read(i,c,0,h,null);if(!k||o.token.isCancellationRequested)break;u(c.slice(0,k))}}catch(k){t=new Error(k),o.dispose(!0)}finally{n=!1}}})()});return await p.ready,l(),new Promise((A,C)=>{o.token.onCancellationRequested(async()=>{p.dispose();try{await d.Promises.close(i)}catch(k){t=new Error(k)}t?C(t):A()})})}e.$8p=$}),define(te[213],ie([0,1,3,104,2,4,212]),function(Q,e,S,R,s,M,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9p=void 0;class P extends s.$Sc{constructor(){super(...arguments),this.a=this.B(new S.$Nd),this.onDidChangeFile=this.a.event,this.b=this.B(new S.$Nd),this.onDidLogMessage=this.b.event,this.onDidError=S.Event.None,this.c=new Map,this.f=!1}async watch(a){const g=this.j(a),w=g.filter(d=>{const v=this.c.get(d.path);return v?!(0,R.$zj)(v.request.excludes,d.excludes)||!(0,R.$zj)(v.request.includes,d.includes):!0}),y=Array.from(this.c.values()).filter(({request:d})=>!g.find(v=>v.path===d.path&&(0,R.$zj)(v.excludes,d.excludes)&&(0,R.$zj)(v.includes,d.includes))).map(({request:d})=>d.path);w.length&&this.m(`Request to start watching: ${w.map(d=>`${d.path} (excludes: ${d.excludes.length>0?d.excludes:"<none>"}, includes: ${d.includes&&d.includes.length>0?JSON.stringify(d.includes):"<all>"}, correlationId: ${typeof d.correlationId=="number"?d.correlationId:"<none>"})`).join(",")}`),y.length&&this.m(`Request to stop watching: ${y.join(",")}`);for(const d of y)this.h(d);for(const d of w)this.g(d)}g(a){const g=new D.$7p(a,y=>this.a.fire(y),y=>this.b.fire(y),this.f),w={request:a,instance:g};this.c.set(a.path,w)}async stop(){for(const[a]of this.c)this.h(a);this.c.clear()}h(a){const g=this.c.get(a);g&&(this.c.delete(a),g.instance.dispose())}j(a){const g=new Map;for(const w of a){const y=M.$l?w.path:w.path.toLowerCase();let d=g.get(w.correlationId);d||(d=new Map,g.set(w.correlationId,d)),d.set(y,w)}return Array.from(g.values()).map(w=>Array.from(w.values())).flat()}async setVerboseLogging(a){this.f=a;for(const[,g]of this.c)g.instance.setVerboseLogging(a)}m(a){this.f&&this.b.fire({type:"trace",message:this.n(a)})}n(a,g){return g?`[File Watcher (node.js)] ${a} (path: ${g.request.path})`:`[File Watcher (node.js)] ${a}`}}e.$9p=P}),define(te[214],ie([0,1,64,213]),function(Q,e,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0p=void 0;class s extends S.$Op{constructor(D,P,f){super(D,P,f),this.s()}r(D){return D.add(new R.$9p)}}e.$0p=s}),define(te[215],ie([0,1,13,42,158,64]),function(Q,e,S,R,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2p=void 0;class D extends M.$Pp{constructor(f,a,g){super(f,a,g),this.s()}r(f){const a=f.add(new s.$1p(S.$cg.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return f.add(a.onDidProcessExit(({code:g,signal:w})=>this.t(`terminated by itself with code ${g}, signal: ${w}`))),R.ProxyChannel.toService((0,R.$vh)(a.getChannel("watcher")))}}e.$2p=D}),define(te[91],ie([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mh=void 0;class S{constructor(...s){this.a=new Map;for(const[M,D]of s)this.set(M,D)}set(s,M){const D=this.a.get(s);return this.a.set(s,M),D}has(s){return this.a.has(s)}get(s){return this.a.get(s)}}e.$Mh=S}),define(te[216],ie([0,1,8,14,2,77,206,6,91,101]),function(Q,e,S,R,s,M,D,P,f,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cq=e.$bq=void 0;const g=!1;class w extends Error{constructor($){super("cyclic dependency between services"),this.message=$.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${$.toString()}`}}class y{constructor($=new f.$Mh,m=!1,u,l=g){this.f=$,this.g=m,this.h=u,this.i=l,this.o=new Set,this.f.set(P.$Nh,this),this._globalGraph=l?u?._globalGraph??new D.$aq(E=>E):void 0}createChild($){return new y($,this.g,this,this.i)}invokeFunction($,...m){const u=v.traceInvocation(this.i,$);let l=!1;try{return $({get:h=>{if(l)throw(0,R.$8)("service accessor is only valid during the invocation of its target method");const i=this.m(h,u);if(!i)throw new Error(`[invokeFunction] unknown service '${h}'`);return i}},...m)}finally{l=!0,u.stop()}}createInstance($,...m){let u,l;return $ instanceof M.$Lh?(u=v.traceCreation(this.i,$.ctor),l=this.j($.ctor,$.staticArguments.concat(m),u)):(u=v.traceCreation(this.i,$),l=this.j($,m,u)),u.stop(),l}j($,m=[],u){const l=P._util.getServiceDependencies($).sort((i,c)=>i.index-c.index),E=[];for(const i of l){const c=this.m(i.id,u);c||this.u(`[createInstance] ${$.name} depends on UNKNOWN service ${i.id}.`,!1),E.push(c)}const h=l.length>0?l[0].index:m.length;if(m.length!==h){console.trace(`[createInstance] First service dependency of ${$.name} at position ${h+1} conflicts with ${m.length} static arguments`);const i=h-m.length;i>0?m=m.concat(new Array(i)):m=m.slice(0,h)}return Reflect.construct($,m.concat(E))}k($,m){if(this.f.get($)instanceof M.$Lh)this.f.set($,m);else if(this.h)this.h.k($,m);else throw new Error("illegalState - setting UNKNOWN service instance")}l($){const m=this.f.get($);return!m&&this.h?this.h.l($):m}m($,m){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String($));const u=this.l($);return u instanceof M.$Lh?this.q($,u,m.branch($,!0)):(m.branch($,!1),u)}q($,m,u){if(this.o.has($))throw new Error(`illegal state - RECURSIVELY instantiating service '${$}'`);this.o.add($);try{return this.r($,m,u)}finally{this.o.delete($)}}r($,m,u){const l=new D.$aq(i=>i.id.toString());let E=0;const h=[{id:$,desc:m,_trace:u}];for(;h.length;){const i=h.pop();if(l.lookupOrInsertNode(i),E++>1e3)throw new w(l);for(const c of P._util.getServiceDependencies(i.desc.ctor)){const o=this.l(c.id);if(o||this.u(`[createInstance] ${$} depends on ${c.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(i.id),String(c.id)),o instanceof M.$Lh){const t={id:c.id,desc:o,_trace:i._trace.branch(c.id,!0)};l.insertEdge(i,t),h.push(t)}}}for(;;){const i=l.roots();if(i.length===0){if(!l.isEmpty())throw new w(l);break}for(const{data:c}of i){if(this.l(c.id)instanceof M.$Lh){const t=this.s(c.id,c.desc.ctor,c.desc.staticArguments,c.desc.supportsDelayedInstantiation,c._trace);this.k(c.id,t)}l.removeNode(c)}}return this.l($)}s($,m,u=[],l,E){if(this.f.get($)instanceof M.$Lh)return this.t($,m,u,l,E);if(this.h)return this.h.s($,m,u,l,E);throw new Error(`illegalState - creating UNKNOWN service instance ${m.name}`)}t($,m,u=[],l,E){if(l){const h=new y(void 0,this.g,this,this.i);h.c=String($);const i=new Map,c=new S.$$g(()=>{const o=h.j(m,u,E);for(const[t,n]of i){const r=o[t];if(typeof r=="function")for(const p of n)r.apply(o,p)}return i.clear(),o});return new Proxy(Object.create(null),{get(o,t){if(!c.isInitialized&&typeof t=="string"&&(t.startsWith("onDid")||t.startsWith("onWill"))){let p=i.get(t);return p||(p=new a.$2c,i.set(t,p)),(C,k,I)=>{const j=p.push([C,k,I]);return(0,s.$Qc)(j)}}if(t in o)return o[t];const n=c.value;let r=n[t];return typeof r!="function"||(r=r.bind(n),o[t]=r),r},set(o,t,n){return c.value[t]=n,!0},getPrototypeOf(o){return m.prototype}})}else return this.j(m,u,E)}u($,m){if(m&&console.warn($),this.g)throw new Error($)}}e.$bq=y;var d;(function(b){b[b.None=0]="None",b[b.Creation=1]="Creation",b[b.Invocation=2]="Invocation",b[b.Branch=3]="Branch"})(d||(d={}));class v{static{this.all=new Set}static{this.c=new class extends v{constructor(){super(0,null)}stop(){}branch(){return this}}}static traceInvocation($,m){return $?new v(2,m.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):v.c}static traceCreation($,m){return $?new v(1,m.name):v.c}static{this.f=0}constructor($,m){this.type=$,this.name=m,this.g=Date.now(),this.h=[]}branch($,m){const u=new v(3,$.toString());return this.h.push([$,m,u]),u}stop(){const $=Date.now()-this.g;v.f+=$;let m=!1;function u(E,h){const i=[],c=new Array(E+1).join("	");for(const[o,t,n]of h.h)if(t&&n){m=!0,i.push(`${c}CREATES -> ${o}`);const r=u(E+1,n);r&&i.push(r)}else i.push(`${c}uses -> ${o}`);return i.join(`
`)}const l=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${u(1,this)}`,`DONE, took ${$.toFixed(2)}ms (grand total ${v.f.toFixed(2)}ms)`];($>2||m)&&v.all.add(l.join(`
`))}}e.$cq=v}),define(te[217],ie([0,1,6]),function(Q,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wwb=e.IssueType=void 0;var R;(function(s){s[s.Bug=0]="Bug",s[s.PerformanceIssue=1]="PerformanceIssue",s[s.FeatureRequest=2]="FeatureRequest"})(R||(e.IssueType=R={})),e.$Wwb=(0,S.$Oh)("issueService")}),define(te[5],ie([0,1,49,3,55,2,31,4,19,12,7,114,6]),function(Q,e,S,R,s,M,D,P,f,a,g,w,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nj=e.$mj=e.$lj=e.$kj=e.$jj=e.$ij=e.$hj=e.$gj=e.$fj=e.$ej=e.$dj=e.$cj=e.$bj=e.log=e.$_i=e.LogLevel=e.$$i=e.$0i=e.$9i=void 0,e.$9i=(0,y.$Oh)("logService"),e.$0i=(0,y.$Oh)("loggerService");function d(){return new Date().toISOString()}function v(C){return(0,a.$Cf)(C)}e.$$i=v;var b;(function(C){C[C.Off=0]="Off",C[C.Trace=1]="Trace",C[C.Debug=2]="Debug",C[C.Info=3]="Info",C[C.Warning=4]="Warning",C[C.Error=5]="Error"})(b||(e.LogLevel=b={})),e.$_i=b.Info;function $(C,k,I){switch(k){case b.Trace:C.trace(I);break;case b.Debug:C.debug(I);break;case b.Info:C.info(I);break;case b.Warning:C.warn(I);break;case b.Error:C.error(I);break;case b.Off:break;default:throw new Error(`Invalid log level ${k}`)}}e.log=$;function m(C,k=!1){let I="";for(let j=0;j<C.length;j++){let U=C[j];if(U instanceof Error&&(U=(0,S.$zi)(U,k)),typeof U=="object")try{U=JSON.stringify(U)}catch{}I+=(j>0?" ":"")+U}return I}class u extends M.$Sc{constructor(){super(...arguments),this.b=e.$_i,this.c=this.B(new R.$Nd),this.onDidChangeLogLevel=this.c.event}setLevel(k){this.b!==k&&(this.b=k,this.c.fire(this.b))}getLevel(){return this.b}f(k){return this.b!==b.Off&&this.b<=k}}e.$bj=u;class l extends u{constructor(k){super(),this.h=k}f(k){return this.h||super.f(k)}trace(k,...I){this.f(b.Trace)&&this.g(b.Trace,m([k,...I],!0))}debug(k,...I){this.f(b.Debug)&&this.g(b.Debug,m([k,...I]))}info(k,...I){this.f(b.Info)&&this.g(b.Info,m([k,...I]))}warn(k,...I){this.f(b.Warning)&&this.g(b.Warning,m([k,...I]))}error(k,...I){if(this.f(b.Error))if(k instanceof Error){const j=Array.prototype.slice.call(arguments);j[0]=k.stack,this.g(b.Error,m(j))}else this.g(b.Error,m([k,...I]))}flush(){}}e.$cj=l;class E extends u{constructor(k=e.$_i){super(),this.setLevel(k),this.g=!P.$j}trace(k,...I){this.f(b.Trace)&&(this.g?console.log(`\x1B[90m[main ${d()}]\x1B[0m`,k,...I):console.log(`[main ${d()}]`,k,...I))}debug(k,...I){this.f(b.Debug)&&(this.g?console.log(`\x1B[90m[main ${d()}]\x1B[0m`,k,...I):console.log(`[main ${d()}]`,k,...I))}info(k,...I){this.f(b.Info)&&(this.g?console.log(`\x1B[90m[main ${d()}]\x1B[0m`,k,...I):console.log(`[main ${d()}]`,k,...I))}warn(k,...I){this.f(b.Warning)&&(this.g?console.warn(`\x1B[93m[main ${d()}]\x1B[0m`,k,...I):console.warn(`[main ${d()}]`,k,...I))}error(k,...I){this.f(b.Error)&&(this.g?console.error(`\x1B[91m[main ${d()}]\x1B[0m`,k,...I):console.error(`[main ${d()}]`,k,...I))}dispose(){}flush(){}}e.$dj=E;class h extends u{constructor(k=e.$_i,I=!0){super(),this.g=I,this.setLevel(k)}trace(k,...I){this.f(b.Trace)&&(this.g?console.log("%cTRACE","color: #888",k,...I):console.log(k,...I))}debug(k,...I){this.f(b.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",k,...I):console.log(k,...I))}info(k,...I){this.f(b.Info)&&(this.g?console.log("%c INFO","color: #33f",k,...I):console.log(k,...I))}warn(k,...I){this.f(b.Warning)&&(this.g?console.log("%c WARN","color: #993",k,...I):console.log(k,...I))}error(k,...I){this.f(b.Error)&&(this.g?console.log("%c  ERR","color: #f33",k,...I):console.error(k,...I))}dispose(){}flush(){}}e.$ej=h;class i extends u{constructor(k,I=e.$_i){super(),this.g=k,this.setLevel(I)}trace(k,...I){this.f(b.Trace)&&this.g.log(b.Trace,[this.h(k),...I])}debug(k,...I){this.f(b.Debug)&&this.g.log(b.Debug,[this.h(k),...I])}info(k,...I){this.f(b.Info)&&this.g.log(b.Info,[this.h(k),...I])}warn(k,...I){this.f(b.Warning)&&this.g.log(b.Warning,[this.h(k),...I])}error(k,...I){this.f(b.Error)&&this.g.log(b.Error,[this.h(k),...I])}h(k){return typeof k=="string"?k:(0,S.$zi)(k,this.f(b.Trace))}dispose(){}flush(){}}e.$fj=i;class c extends u{constructor(k){super(),this.g=k,k.length&&this.setLevel(k[0].getLevel())}setLevel(k){for(const I of this.g)I.setLevel(k);super.setLevel(k)}trace(k,...I){for(const j of this.g)j.trace(k,...I)}debug(k,...I){for(const j of this.g)j.debug(k,...I)}info(k,...I){for(const j of this.g)j.info(k,...I)}warn(k,...I){for(const j of this.g)j.warn(k,...I)}error(k,...I){for(const j of this.g)j.error(k,...I)}flush(){for(const k of this.g)k.flush()}dispose(){for(const k of this.g)k.dispose()}}e.$gj=c;class o extends M.$Sc{constructor(k,I,j){if(super(),this.h=k,this.j=I,this.b=new D.$Ac,this.c=this.B(new R.$Nd),this.onDidChangeLoggers=this.c.event,this.f=this.B(new R.$Nd),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new R.$Nd),this.onDidChangeVisibility=this.g.event,j)for(const U of j)this.b.set(U.resource,{logger:void 0,info:U})}m(k){return(0,a.$yf)(k)?[...this.b.values()].find(I=>I.info.id===k):this.b.get(k)}getLogger(k){return this.m(k)?.logger}createLogger(k,I){const j=this.n(k),U=(0,a.$yf)(k)?k:I?.id??(0,s.$Ci)(j.toString()).toString(16);let z=this.b.get(j)?.logger;const ne=I?.logLevel==="always"?b.Trace:I?.logLevel;z||(z=this.s(j,ne??this.getLogLevel(j)??this.h,{...I,id:U}));const _={logger:z,info:{resource:j,id:U,logLevel:ne,name:I?.name,hidden:I?.hidden,extensionId:I?.extensionId,when:I?.when}};return this.registerLogger(_.info),this.b.set(j,_),z}n(k){return(0,a.$yf)(k)?(0,f.$vg)(this.j,`${k}.log`):k}setLogLevel(k,I){if(g.URI.isUri(k)){const j=k,U=I,z=this.b.get(j);z&&U!==z.info.logLevel&&(z.info.logLevel=U===this.h?void 0:U,z.logger?.setLevel(U),this.b.set(z.info.resource,z),this.f.fire([j,U]))}else{this.h=k;for(const[j,U]of this.b.entries())this.b.get(j)?.info.logLevel===void 0&&U.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(k,I){const j=this.m(k);j&&I!==!j.info.hidden&&(j.info.hidden=!I,this.b.set(j.info.resource,j),this.g.fire([j.info.resource,I]))}getLogLevel(k){let I;return k&&(I=this.b.get(k)?.info.logLevel),I??this.h}registerLogger(k){const I=this.b.get(k.resource);I?I.info.hidden!==k.hidden&&this.setVisibility(k.resource,!k.hidden):(this.b.set(k.resource,{info:k,logger:void 0}),this.c.fire({added:[k],removed:[]}))}deregisterLogger(k){const I=this.b.get(k);I&&(I.logger&&I.logger.dispose(),this.b.delete(k),this.c.fire({added:[],removed:[I.info]}))}*getRegisteredLoggers(){for(const k of this.b.values())yield k.info}getRegisteredLogger(k){return this.b.get(k)?.info}dispose(){this.b.forEach(k=>k.logger?.dispose()),this.b.clear(),super.dispose()}}e.$hj=o;class t{constructor(){this.onDidChangeLogLevel=new R.$Nd().event}setLevel(k){}getLevel(){return b.Info}trace(k,...I){}debug(k,...I){}info(k,...I){}warn(k,...I){}error(k,...I){}critical(k,...I){}dispose(){}flush(){}}e.$ij=t;class n extends t{}e.$jj=n;function r(C){if(C.verbose)return b.Trace;if(typeof C.logLevel=="string"){const k=A(C.logLevel.toLowerCase());if(k!==void 0)return k}return e.$_i}e.$kj=r;function p(C){switch(C){case b.Trace:return"trace";case b.Debug:return"debug";case b.Info:return"info";case b.Warning:return"warn";case b.Error:return"error";case b.Off:return"off"}}e.$lj=p;function A(C){switch(C){case"trace":return b.Trace;case"debug":return b.Debug;case"info":return b.Info;case"warn":return b.Warning;case"error":return b.Error;case"critical":return b.Error;case"off":return b.Off}}e.$mj=A,e.$nj=new w.$6i("logLevel",p(b.Info))});var ee=this&&this.__param||function(Q,e){return function(S,R){e(S,R,Q)}};define(te[218],ie([0,1,15,4,5]),function(Q,e,S,R,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$E6b=void 0;const M=S.safeStorage;let D=class{constructor(f){this.a=f,S.app.commandLine.getSwitchValue("password-store")==="basic"&&M.setUsePlainTextEncryption?.(!0)}async encrypt(f){this.a.trace("[EncryptionMainService] Encrypting value.");try{const a=JSON.stringify(M.encryptString(f));return this.a.trace("[EncryptionMainService] Encrypted value."),a}catch(a){throw this.a.error(a),a}}async decrypt(f){let a;try{if(a=JSON.parse(f),!a.data)throw new Error(`[EncryptionMainService] Invalid encrypted value: ${f}`);const g=Buffer.from(a.data);this.a.trace("[EncryptionMainService] Decrypting value.");const w=M.decryptString(g);return this.a.trace("[EncryptionMainService] Decrypted value."),w}catch(g){throw this.a.error(g),g}}isEncryptionAvailable(){return Promise.resolve(M.isEncryptionAvailable())}getKeyStorageProvider(){if(R.$j)return Promise.resolve("dpapi");if(R.$k)return Promise.resolve("keychain_access");if(M.getSelectedStorageBackend)try{const f=M.getSelectedStorageBackend();return Promise.resolve(f)}catch(f){this.a.error(f)}return Promise.resolve("unknown")}async setUsePlainTextEncryption(){if(R.$j)throw new Error("Setting plain text encryption is not supported on Windows.");if(R.$k)throw new Error("Setting plain text encryption is not supported on macOS.");if(!M.setUsePlainTextEncryption)throw new Error("Setting plain text encryption is not supported.");M.setUsePlainTextEncryption(!0)}};e.$E6b=D,e.$E6b=D=ke([ee(0,s.$9i)],D)}),define(te[219],ie([0,1,23,8,14,3,2,9,64,5]),function(Q,e,S,R,s,M,D,P,f,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Up=void 0;class g extends D.$Sc{constructor(y,d){super(),this.a=y,this.b=d,this.c=this.B(new M.$Nd),this.onDidChangeFile=this.c.event,this.g=this.B(new M.$Nd),this.onDidWatchError=this.g.event,this.j=[],this.m=this.B(new R.$Rg(0)),this.w=[],this.y=this.B(new R.$Rg(0))}watch(y,d){return d.recursive||this.b?.watcher?.forceUniversal?this.n(y,d):this.z(y,d)}n(y,d){const v={path:this.H(y),excludes:d.excludes,includes:d.includes,recursive:d.recursive,correlationId:d.correlationId},b=(0,S.$Ub)(this.j,v);return this.r(),(0,D.$Qc)(()=>{b(),this.r()})}r(){this.m.trigger(()=>this.s()).catch(y=>(0,s.$1)(y))}s(){this.h||(this.h=this.B(this.t(d=>this.c.fire((0,f.$Qp)(d)),d=>this.G(d),this.a.getLevel()===a.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===a.LogLevel.Trace)})));const y=this.b?.watcher?.recursive?.usePolling;if(y===!0)for(const d of this.j)(0,f.$Mp)(d)&&(d.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(y))for(const d of this.j)(0,f.$Mp)(d)&&y.includes(d.path)&&(d.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}z(y,d){const v={path:this.H(y),excludes:d.excludes,includes:d.includes,recursive:!1,correlationId:d.correlationId},b=(0,S.$Ub)(this.w,v);return this.C(),(0,D.$Qc)(()=>{b(),this.C()})}C(){this.y.trigger(()=>this.D()).catch(y=>(0,s.$1)(y))}D(){return this.u||(this.u=this.B(this.F(y=>this.c.fire((0,f.$Qp)(y)),y=>this.G(y),this.a.getLevel()===a.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.u?.setVerboseLogging(this.a.getLevel()===a.LogLevel.Trace)}))),this.u.watch(this.w)}G(y){y.type==="error"&&this.g.fire(y.message),this.a[y.type](y.message)}H(y){return(0,P.$hc)(y.fsPath)}}e.$Up=g}),define(te[220],ie([0,1,23,8,17,22,3,55,70,2,56,13,65,19,61,173,16,118,5,14]),function(Q,e,S,R,s,M,D,P,f,a,g,w,y,d,v,b,$,m,u,l){"use strict";var E;Object.defineProperty(e,"__esModule",{value:!0}),e.$Lp=void 0;let h=class extends a.$Sc{static{E=this}constructor(c){super(),this.b=c,this.a=256*1024,this.c=this.B(new D.$Nd),this.onDidChangeFileSystemProviderRegistrations=this.c.event,this.f=this.B(new D.$Nd),this.onWillActivateFileSystemProvider=this.f.event,this.g=this.B(new D.$Nd),this.onDidChangeFileSystemProviderCapabilities=this.g.event,this.h=new Map,this.r=this.B(new D.$Nd),this.onDidRunOperation=this.r.event,this.X=this.B(new D.$Nd),this.Y=this.B(new D.$Nd),this.onDidFilesChange=this.Y.event,this.Z=this.B(new D.$Nd),this.onDidWatchError=this.Z.event,this.$=new Map,this.cb=this.B(new R.$3g)}registerProvider(c,o){if(this.h.has(c))throw new Error(`A filesystem provider for the scheme '${c}' is already registered.`);(0,y.mark)(`code/registerFilesystem/${c}`);const t=new a.$Rc;return this.h.set(c,o),this.c.fire({added:!0,scheme:c,provider:o}),t.add(o.onDidChangeFile(n=>{const r=new $.$qk(n,!this.S(o));this.X.fire(r),r.hasCorrelation()||this.Y.fire(r)})),typeof o.onDidWatchError=="function"&&t.add(o.onDidWatchError(n=>this.Z.fire(new Error(n)))),t.add(o.onDidChangeCapabilities(()=>this.g.fire({provider:o,scheme:c}))),(0,a.$Qc)(()=>{this.c.fire({added:!1,scheme:c,provider:o}),this.h.delete(c),(0,a.$Nc)(t)})}getProvider(c){return this.h.get(c)}async activateProvider(c){const o=[];this.f.fire({scheme:c,join(t){o.push(t)}}),!this.h.has(c)&&await R.Promises.settled(o)}async canHandleResource(c){return await this.activateProvider(c.scheme),this.hasProvider(c)}hasProvider(c){return this.h.has(c.scheme)}hasCapability(c,o){const t=this.h.get(c.scheme);return!!(t&&t.capabilities&o)}listCapabilities(){return f.Iterable.map(this.h,([c,o])=>({scheme:c,capabilities:o.capabilities}))}async j(c){if(!(0,d.$zg)(c))throw new $.$sk((0,b.localize)(0,null,this.sb(c)),8);await this.activateProvider(c.scheme);const o=this.h.get(c.scheme);if(!o){const t=new l.$bb;throw t.message=(0,b.localize)(1,null,c.toString()),t}return o}async m(c){const o=await this.j(c);if((0,$.$dk)(o)||(0,$.$ak)(o)||(0,$.$ek)(o))return o;throw new Error(`Filesystem provider for scheme '${c.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async n(c){const o=await this.j(c);if((0,$.$dk)(o)||(0,$.$ak)(o))return o;throw new Error(`Filesystem provider for scheme '${c.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(c,o){try{return await this.s(c,o)}catch(t){throw(0,$.$nk)(t)===$.FileSystemProviderErrorCode.FileNotFound?new $.$sk((0,b.localize)(2,null,this.sb(c)),1):(0,$.$lk)(t)}}async s(c,o){const t=await this.j(c),n=this.S(t),r=o?.resolveTo,p=o?.resolveSingleChildDescendants,A=o?.resolveMetadata,C=await t.stat(c);let k;return this.t(t,c,C,void 0,!!A,(I,j)=>(k||(k=g.$Uh.forUris(()=>!n),k.set(c,!0),r&&k.fill(!0,r)),k.get(I.resource)||k.findSuperstr(I.resource.with({query:null,fragment:null}))?!0:I.isDirectory&&p?j===1:!1))}async t(c,o,t,n,r,p){const{providerExtUri:A}=this.R(c),C={resource:o,name:A.basename(o),isFile:(t.type&$.FileType.File)!==0,isDirectory:(t.type&$.FileType.Directory)!==0,isSymbolicLink:(t.type&$.FileType.SymbolicLink)!==0,mtime:t.mtime,ctime:t.ctime,size:t.size,readonly:!!((t.permissions??0)&$.FilePermission.Readonly)||!!(c.capabilities&2048),locked:!!((t.permissions??0)&$.FilePermission.Locked),etag:(0,$.$Dk)({mtime:t.mtime,size:t.size}),children:void 0};if(C.isDirectory&&p(C,n)){try{const k=await c.readdir(o),I=await R.Promises.settled(k.map(async([j,U])=>{try{const z=A.joinPath(o,j),ne=r?await c.stat(z):{type:U};return await this.t(c,z,ne,k.length,r,p)}catch(z){return this.b.trace(z),null}}));C.children=(0,S.$Hb)(I)}catch(k){this.b.trace(k),C.children=[]}return C}return C}async resolveAll(c){return R.Promises.settled(c.map(async o=>{try{return{stat:await this.s(o.resource,o.options),success:!0}}catch(t){return this.b.trace(t),{stat:void 0,success:!1}}}))}async stat(c){const o=await this.j(c),t=await o.stat(c);return this.t(o,c,t,void 0,!0,()=>!1)}async exists(c){const o=await this.j(c);try{return!!await o.stat(c)}catch{return!1}}async canCreateFile(c,o){try{await this.u(c,o)}catch(t){return t}return!0}async u(c,o){if(!o?.overwrite&&await this.exists(c))throw new $.$sk((0,b.localize)(3,null,this.sb(c)),3,o)}async createFile(c,o=s.$be.fromString(""),t){await this.u(c,t);const n=await this.writeFile(c,o);return this.r.fire(new $.$pk(c,0,n)),n}async writeFile(c,o,t){const n=this.qb(await this.n(c),c),{providerExtUri:r}=this.R(n);let p=t;if((0,$.$gk)(n)&&!p?.atomic){const A=n.enforceAtomicWriteFile?.(c);A&&(p={...t,atomic:A})}try{await this.w(n,c,p)||await this.U(n,r.dirname(c));let C;if((0,$.$ak)(n)&&!(o instanceof s.$be))if((0,v.$Zd)(o)){const k=await(0,v.$7d)(o,3);k.ended?C=s.$be.concat(k.buffer):C=k}else C=(0,v.$4d)(o,k=>s.$be.concat(k),3);else C=o;!(0,$.$dk)(n)||(0,$.$ak)(n)&&C instanceof s.$be||(0,$.$ak)(n)&&(0,$.$gk)(n)&&p?.atomic?await this.hb(n,c,p,C):await this.db(n,c,p,C instanceof s.$be?(0,s.$me)(C):C),this.r.fire(new $.$pk(c,4))}catch(A){throw new $.$sk((0,b.localize)(4,null,this.sb(c),(0,$.$lk)(A).toString()),(0,$.$ok)(A),p)}return this.resolve(c,{resolveMetadata:!0})}async w(c,o,t){const n=!!t?.unlock;if(n&&!(c.capabilities&8192))throw new Error((0,b.localize)(5,null,this.sb(o)));if(!!t?.atomic){if(!(c.capabilities&32768))throw new Error((0,b.localize)(6,null,this.sb(o)));if(!(c.capabilities&2))throw new Error((0,b.localize)(7,null,this.sb(o)));if(n)throw new Error((0,b.localize)(8,null,this.sb(o)))}let p;try{p=await c.stat(o)}catch{return}if(p.type&$.FileType.Directory)throw new $.$sk((0,b.localize)(9,null,this.sb(o)),0,t);if(this.rb(o,p),typeof t?.mtime=="number"&&typeof t.etag=="string"&&t.etag!==$.$Ck&&typeof p.mtime=="number"&&typeof p.size=="number"&&t.mtime<p.mtime&&t.etag!==(0,$.$Dk)({mtime:t.mtime,size:p.size}))throw new $.$sk((0,b.localize)(10,null),3,t);return p}async readFile(c,o,t){const n=await this.m(c);return o?.atomic?this.z(n,c,o,t):this.C(n,c,o,t)}async z(c,o,t,n){return new Promise((r,p)=>{this.cb.queueFor(o,this.R(c).providerExtUri).queue(async()=>{try{const A=await this.C(c,o,t,n);r(A)}catch(A){p(A)}})})}async C(c,o,t,n){const r=await this.D(c,o,{...t,preferUnbuffered:!0},n);return{...r,value:await(0,s.$ne)(r.value)}}async readFileStream(c,o,t){const n=await this.m(c);return this.D(n,c,o,t)}async D(c,o,t,n){const r=new M.$Xd(n);let p=t;(0,$.$fk)(c)&&c.enforceAtomicReadFile?.(o)&&(p={...t,atomic:!0});const A=this.J(o,p).then(k=>k,k=>{throw r.dispose(!0),k});let C;try{return typeof p?.etag=="string"&&p.etag!==$.$Ck&&await A,p?.atomic&&(0,$.$fk)(c)||!((0,$.$dk)(c)||(0,$.$ek)(c))||(0,$.$ak)(c)&&p?.preferUnbuffered?C=this.I(c,o,p):(0,$.$ek)(c)?C=this.G(c,o,r.token,p):C=this.H(c,o,r.token,p),C.on("end",()=>r.dispose()),C.on("error",()=>r.dispose()),{...await A,value:C}}catch(k){throw C&&await(0,v.$5d)(C),this.F(k,o,p)}}F(c,o,t){const n=(0,b.localize)(11,null,this.sb(o),(0,$.$lk)(c).toString());return c instanceof $.$uk?new $.$uk(n,c.stat,t):c instanceof $.$tk?new $.$tk(n,c.fileOperationResult,c.size,c.options):new $.$sk(n,(0,$.$ok)(c),t)}G(c,o,t,n=Object.create(null)){const r=c.readFileStream(o,n,t);return(0,v.$$d)(r,{data:p=>p instanceof s.$be?p:s.$be.wrap(p),error:p=>this.F(p,o,n)},p=>s.$be.concat(p))}H(c,o,t,n=Object.create(null)){const r=(0,s.$re)();return(0,m.$Kp)(c,o,r,p=>p,{...n,bufferSize:this.a,errorTransformer:p=>this.F(p,o,n)},t),r}I(c,o,t){const n=(0,v.$2d)(r=>s.$be.concat(r));return(async()=>{try{let r;t?.atomic&&(0,$.$fk)(c)?r=await c.readFile(o,{atomic:!0}):r=await c.readFile(o),typeof t?.position=="number"&&(r=r.slice(t.position)),typeof t?.length=="number"&&(r=r.slice(0,t.length)),this.L(o,r.byteLength,t),n.end(s.$be.wrap(r))}catch(r){n.error(r),n.end()}})(),n}async J(c,o){const t=await this.resolve(c,{resolveMetadata:!0});if(t.isDirectory)throw new $.$sk((0,b.localize)(12,null,this.sb(c)),0,o);if(typeof o?.etag=="string"&&o.etag!==$.$Ck&&o.etag===t.etag)throw new $.$uk((0,b.localize)(13,null),t,o);return this.L(c,t.size,o),t}L(c,o,t){if(typeof t?.limits?.size=="number"&&o>t.limits.size)throw new $.$tk((0,b.localize)(14,null,this.sb(c)),7,o,t)}async canMove(c,o,t){return this.M(c,o,"move",t)}async canCopy(c,o,t){return this.M(c,o,"copy",t)}async M(c,o,t,n){if(c.toString()!==o.toString())try{const r=t==="move"?this.qb(await this.n(c),c):await this.m(c),p=this.qb(await this.n(o),o);await this.Q(r,c,p,o,t,n)}catch(r){return r}return!0}async move(c,o,t){const n=this.qb(await this.n(c),c),r=this.qb(await this.n(o),o),p=await this.N(n,c,r,o,"move",!!t),A=await this.resolve(o,{resolveMetadata:!0});return this.r.fire(new $.$pk(c,p==="move"?2:3,A)),A}async copy(c,o,t){const n=await this.m(c),r=this.qb(await this.n(o),o),p=await this.N(n,c,r,o,"copy",!!t),A=await this.resolve(o,{resolveMetadata:!0});return this.r.fire(new $.$pk(c,p==="copy"?3:2,A)),A}async N(c,o,t,n,r,p){if(o.toString()===n.toString())return r;const{exists:A,isSameResourceWithDifferentPathCase:C}=await this.Q(c,o,t,n,r,p);if(A&&!C&&p&&await this.del(n,{recursive:!0}),await this.U(t,this.R(t).providerExtUri.dirname(n)),r==="copy"){if(c===t&&(0,$.$bk)(c))await c.copy(o,n,{overwrite:p});else{const k=await this.resolve(o);k.isDirectory?await this.P(c,k,t,n):await this.O(c,o,t,n)}return r}else return c===t?(await c.rename(o,n,{overwrite:p}),r):(await this.N(c,o,t,n,"copy",p),await this.del(o,{recursive:!0}),"copy")}async O(c,o,t,n){if((0,$.$dk)(c)&&(0,$.$dk)(t))return this.jb(c,o,t,n);if((0,$.$dk)(c)&&(0,$.$ak)(t))return this.pb(c,o,t,n);if((0,$.$ak)(c)&&(0,$.$dk)(t))return this.nb(c,o,t,n);if((0,$.$ak)(c)&&(0,$.$ak)(t))return this.lb(c,o,t,n)}async P(c,o,t,n){await t.mkdir(n),Array.isArray(o.children)&&await R.Promises.settled(o.children.map(async r=>{const p=this.R(t).providerExtUri.joinPath(n,r.name);return r.isDirectory?this.P(c,await this.resolve(r.resource),t,p):this.O(c,r.resource,t,p)}))}async Q(c,o,t,n,r,p){let A=!1;if(c===t){const{providerExtUri:k,isPathCaseSensitive:I}=this.R(c);if(I||(A=k.isEqual(o,n)),A&&r==="copy")throw new Error((0,b.localize)(15,null,this.sb(o),this.sb(n)));if(!A&&k.isEqualOrParent(n,o))throw new Error((0,b.localize)(16,null,this.sb(o),this.sb(n)))}const C=await this.exists(n);if(C&&!A){if(!p)throw new $.$sk((0,b.localize)(17,null,this.sb(o),this.sb(n)),4);if(c===t){const{providerExtUri:k}=this.R(c);if(k.isEqualOrParent(o,n))throw new Error((0,b.localize)(18,null,this.sb(o),this.sb(n)))}}return{exists:C,isSameResourceWithDifferentPathCase:A}}R(c){const o=this.S(c);return{providerExtUri:o?d.$lg:d.$ng,isPathCaseSensitive:o}}S(c){return!!(c.capabilities&1024)}async createFolder(c){const o=this.qb(await this.j(c),c);await this.U(o,c);const t=await this.resolve(c,{resolveMetadata:!0});return this.r.fire(new $.$pk(c,0,t)),t}async U(c,o){const t=[],{providerExtUri:n}=this.R(c);for(;!n.isEqual(o,n.dirname(o));)try{if(!((await c.stat(o)).type&$.FileType.Directory))throw new Error((0,b.localize)(19,null,this.sb(o)));break}catch(r){if((0,$.$nk)(r)!==$.FileSystemProviderErrorCode.FileNotFound)throw r;t.push(n.basename(o)),o=n.dirname(o)}for(let r=t.length-1;r>=0;r--){o=n.joinPath(o,t[r]);try{await c.mkdir(o)}catch(p){if((0,$.$nk)(p)!==$.FileSystemProviderErrorCode.FileExists)throw p}}}async canDelete(c,o){try{await this.W(c,o)}catch(t){return t}return!0}async W(c,o){const t=this.qb(await this.j(c),c),n=!!o?.useTrash;if(n&&!(t.capabilities&4096))throw new Error((0,b.localize)(20,null,this.sb(c)));const r=o?.atomic;if(r&&!(t.capabilities&65536))throw new Error((0,b.localize)(21,null,this.sb(c)));if(n&&r)throw new Error((0,b.localize)(22,null,this.sb(c)));let p;try{p=await t.stat(c)}catch{}if(p)this.rb(c,p);else throw new $.$sk((0,b.localize)(23,null,this.sb(c)),1);if(!!!o?.recursive){const C=await this.resolve(c);if(C.isDirectory&&Array.isArray(C.children)&&C.children.length>0)throw new Error((0,b.localize)(24,null,this.sb(c)))}return t}async del(c,o){const t=await this.W(c,o);let n=o;if((0,$.$hk)(t)&&!n?.atomic){const C=t.enforceAtomicDelete?.(c);C&&(n={...o,atomic:C})}const r=!!n?.useTrash,p=!!n?.recursive,A=n?.atomic??!1;await t.delete(c,{recursive:p,useTrash:r,atomic:A}),this.r.fire(new $.$pk(c,1))}async cloneFile(c,o){const t=await this.j(c),n=this.qb(await this.n(o),o);if(t===n&&this.R(t).providerExtUri.isEqual(c,o))return;if(t===n&&(0,$.$ck)(t))return t.cloneFile(c,o);await this.U(n,this.R(n).providerExtUri.dirname(o));const r=this.cb.queueFor(c,this.R(t).providerExtUri);return t===n&&(0,$.$bk)(t)?r.queue(()=>t.copy(c,o,{overwrite:!0})):r.queue(()=>this.O(t,c,n,o))}static{this.ab=0}createWatcher(c,o){return this.watch(c,{...o,correlationId:E.ab++})}watch(c,o={recursive:!1,excludes:[]}){const t=new a.$Rc;let n=!1,r=()=>{n=!0};t.add((0,a.$Qc)(()=>r())),(async()=>{try{const A=await this.bb(c,o);n?(0,a.$Nc)(A):r=()=>(0,a.$Nc)(A)}catch(A){this.b.error(A)}})();const p=o.correlationId;if(typeof p=="number"){const A=t.add(new D.$Nd);return t.add(this.X.event(k=>{k.correlates(p)&&A.fire(k)})),{onDidChange:A.event,dispose:()=>t.dispose()}}return t}async bb(c,o){const t=await this.j(c),n=(0,P.$Ci)([this.R(t).providerExtUri.getComparisonKey(c),o]);let r=this.$.get(n);return r||(r={count:0,disposable:t.watch(c,o)},this.$.set(n,r)),r.count+=1,(0,a.$Qc)(()=>{r&&(r.count--,r.count===0&&((0,a.$Nc)(r.disposable),this.$.delete(n)))})}dispose(){super.dispose();for(const[,c]of this.$)(0,a.$Nc)(c.disposable);this.$.clear()}async db(c,o,t,n){return this.cb.queueFor(o,this.R(c).providerExtUri).queue(async()=>{const r=await c.open(o,{create:!0,unlock:t?.unlock??!1});try{(0,v.$Zd)(n)||(0,v.$1d)(n)?await this.eb(c,r,n):await this.fb(c,r,n)}catch(p){throw(0,$.$lk)(p)}finally{await c.close(r)}})}async eb(c,o,t){let n=0,r;if((0,v.$1d)(t)){if(t.buffer.length>0){const p=s.$be.concat(t.buffer);await this.gb(c,o,p,p.byteLength,n,0),n+=p.byteLength}if(t.ended)return;r=t.stream}else r=t;return new Promise((p,A)=>{(0,v.$6d)(r,{onData:async C=>{r.pause();try{await this.gb(c,o,C,C.byteLength,n,0)}catch(k){return A(k)}n+=C.byteLength,setTimeout(()=>r.resume())},onError:C=>A(C),onEnd:()=>p()})})}async fb(c,o,t){let n=0,r;for(;(r=t.read())!==null;)await this.gb(c,o,r,r.byteLength,n,0),n+=r.byteLength}async gb(c,o,t,n,r,p){let A=0;for(;A<n;){const C=await c.write(o,r+A,t.buffer,p+A,n-A);A+=C}}async hb(c,o,t,n){return this.cb.queueFor(o,this.R(c).providerExtUri).queue(()=>this.ib(c,o,t,n))}async ib(c,o,t,n){let r;n instanceof s.$be?r=n:(0,v.$Zd)(n)?r=await(0,s.$ne)(n):(0,v.$1d)(n)?r=await(0,s.$oe)(n):r=(0,s.$le)(n),await c.writeFile(o,r.buffer,{create:!0,overwrite:!0,unlock:t?.unlock??!1,atomic:t?.atomic??!1})}async jb(c,o,t,n){return this.cb.queueFor(n,this.R(t).providerExtUri).queue(()=>this.kb(c,o,t,n))}async kb(c,o,t,n){let r,p;try{r=await c.open(o,{create:!1}),p=await t.open(n,{create:!0,unlock:!1});const A=s.$be.alloc(this.a);let C=0,k=0,I=0;do I=await c.read(r,C,A.buffer,k,A.byteLength-k),await this.gb(t,p,A,I,C,k),C+=I,k+=I,k===A.byteLength&&(k=0);while(I>0)}catch(A){throw(0,$.$lk)(A)}finally{await R.Promises.settled([typeof r=="number"?c.close(r):Promise.resolve(),typeof p=="number"?t.close(p):Promise.resolve()])}}async lb(c,o,t,n){return this.cb.queueFor(n,this.R(t).providerExtUri).queue(()=>this.mb(c,o,t,n))}async mb(c,o,t,n){return t.writeFile(n,await c.readFile(o),{create:!0,overwrite:!0,unlock:!1,atomic:!1})}async nb(c,o,t,n){return this.cb.queueFor(n,this.R(t).providerExtUri).queue(()=>this.ob(c,o,t,n))}async ob(c,o,t,n){const r=await t.open(n,{create:!0,unlock:!1});try{const p=await c.readFile(o);await this.gb(t,r,s.$be.wrap(p),p.byteLength,0,0)}catch(p){throw(0,$.$lk)(p)}finally{await t.close(r)}}async pb(c,o,t,n){const r=await(0,s.$ne)(this.H(c,o,M.CancellationToken.None));await this.hb(t,n,void 0,r)}qb(c,o){if(c.capabilities&2048)throw new $.$sk((0,b.localize)(25,null,this.sb(o)),6);return c}rb(c,o){if((o.permissions??0)&$.FilePermission.Readonly)throw new $.$sk((0,b.localize)(26,null,this.sb(c)),6)}sb(c){return c.scheme===w.Schemas.file?c.fsPath:c.toString(!0)}};e.$Lp=h,e.$Lp=h=E=ke([ee(0,u.$9i)],h)}),define(te[92],ie([0,1,45,309,8,31,17,3,33,2,9,4,19,61,21,177,16,118,219,49,215,214]),function(Q,e,S,R,s,M,D,P,f,a,g,w,y,d,v,b,$,m,u,l,E,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$p=void 0,(()=>{try{(0,R.gracefulify)(S)}catch(c){console.error(`Error enabling graceful-fs: ${(0,l.$zi)(c)}`)}})();class i extends u.$Up{static{this.I=!1}constructor(o,t){super(o,t),this.onDidChangeCapabilities=P.Event.None,this.N=new M.$Ac(n=>y.$mg.getComparisonKey(n)),this.U=new Map,this.W=new Map,this.X=new Map}get capabilities(){return this.J||(this.J=253982,w.$l&&(this.J|=1024)),this.J}async stat(o){try{const{stat:t,symbolicLink:n}=await v.SymlinkSupport.stat(this.H(o));return{type:this.M(t,n),ctime:t.birthtime.getTime(),mtime:t.mtime.getTime(),size:t.size,permissions:t.mode&128?void 0:$.FilePermission.Locked}}catch(t){throw this.fb(t)}}async L(o){try{return await this.stat(o)}catch{return}}async readdir(o){try{const t=await v.Promises.readdir(this.H(o),{withFileTypes:!0}),n=[];return await Promise.all(t.map(async r=>{try{let p;r.isSymbolicLink()?p=(await this.stat((0,y.$vg)(o,r.name))).type:p=this.M(r),n.push([r.name,p])}catch(p){this.a.trace(p)}})),n}catch(t){throw this.fb(t)}}M(o,t){let n;return t?.dangling?n=$.FileType.Unknown:o.isFile()?n=$.FileType.File:o.isDirectory()?n=$.FileType.Directory:n=$.FileType.Unknown,t&&(n|=$.FileType.SymbolicLink),n}async O(o){const t=this.H(o);this.P(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${t})`);let n;for(;n=this.N.get(o);)this.P(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${t})`),await n.wait();const r=new s.$Sg;return this.N.set(o,r),this.P(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${t})`),(0,a.$Qc)(()=>{this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${t})`),this.N.get(o)===r&&(this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${t})`),this.N.delete(o)),this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${t})`),r.open()})}async readFile(o,t){let n;try{t?.atomic&&(this.P(`[Disk FileSystemProvider]: atomic read operation started (${this.H(o)})`),n=await this.O(o));const r=this.H(o);return await v.Promises.readFile(r)}catch(r){throw this.fb(r)}finally{n?.dispose()}}P(o){i.I&&this.a.trace(o)}readFileStream(o,t,n){const r=(0,d.$2d)(p=>D.$be.concat(p.map(A=>D.$be.wrap(A))).buffer);return(0,m.$Kp)(this,o,r,p=>p.buffer,{...t,bufferSize:256*1024},n),r}async writeFile(o,t,n){return n?.atomic!==!1&&n?.atomic?.postfix&&await this.Q(o)?this.R(o,(0,y.$vg)((0,y.$ug)(o),`${(0,y.$sg)(o)}${n.atomic.postfix}`),t,n):this.S(o,t,n)}async Q(o){try{const t=this.H(o),{symbolicLink:n}=await v.SymlinkSupport.stat(t);if(n)return!1}catch{}return!0}async R(o,t,n,r){const p=new a.$Rc;try{p.add(await this.O(o)),p.add(await this.O(t)),await this.S(t,n,r,!0);try{await this.rename(t,o,{overwrite:!0})}catch(A){try{await this.delete(t,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw A}}finally{p.dispose()}}async S(o,t,n,r){let p;try{const A=this.H(o);if(!n.create||!n.overwrite){if(await v.Promises.exists(A)){if(!n.overwrite)throw(0,$.$kk)((0,b.localize)(0,null),$.FileSystemProviderErrorCode.FileExists)}else if(!n.create)throw(0,$.$kk)((0,b.localize)(1,null),$.FileSystemProviderErrorCode.FileNotFound)}p=await this.open(o,{create:!0,unlock:n.unlock},r),await this.write(p,0,t,0,t.byteLength)}catch(A){throw await this.gb(o,A)}finally{typeof p=="number"&&await this.close(p)}}static{this.Y=!0}static configureFlushOnWrite(o){i.Y=o}async open(o,t,n){const r=this.H(o);let p;(0,$.$$j)(t)&&!n&&(p=await this.O(o));let A;try{if((0,$.$$j)(t)&&t.unlock)try{const{stat:k}=await v.SymlinkSupport.stat(r);k.mode&128||await v.Promises.chmod(r,k.mode|128)}catch(k){k.code!=="ENOENT"&&this.a.trace(k)}let C;if((0,$.$$j)(t)){if(w.$j)try{await v.Promises.truncate(r,0),C="r+"}catch(k){k.code!=="ENOENT"&&this.a.trace(k)}C||(C="w")}else C="r";A=await v.Promises.open(r,C)}catch(C){throw p?.dispose(),(0,$.$$j)(t)?await this.gb(o,C):this.fb(C)}if(this.U.set(A,0),(0,$.$$j)(t)&&this.X.set(A,o),p){const C=this.W.get(A);this.P(`[Disk FileSystemProvider]: open() - storing lock for handle ${A} (${r})`),this.W.set(A,p),C&&(this.P(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${A} (${r})`),C.dispose())}return A}async close(o){const t=this.W.get(o);try{if(this.U.delete(o),this.X.delete(o)&&i.Y)try{await v.Promises.fdatasync(o)}catch(n){i.configureFlushOnWrite(!1),this.a.error(n)}return await v.Promises.close(o)}catch(n){throw this.fb(n)}finally{t&&(this.W.get(o)===t&&(this.P(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${o}`),this.W.delete(o)),this.P(`[Disk FileSystemProvider]: close() - disposing lock for handle ${o}`),t.dispose())}}async read(o,t,n,r,p){const A=this.Z(o,t);let C=null;try{C=(await v.Promises.read(o,n,r,p,A)).bytesRead}catch(k){throw this.fb(k)}finally{this.$(o,A,C)}return C}Z(o,t){return t===this.U.get(o)?null:t}$(o,t,n){const r=this.U.get(o);typeof r=="number"&&(typeof t=="number"||(typeof n=="number"?this.U.set(o,r+n):this.U.delete(o)))}async write(o,t,n,r,p){return(0,s.$_g)(()=>this.ab(o,t,n,r,p),100,3)}async ab(o,t,n,r,p){const A=this.Z(o,t);let C=null;try{C=(await v.Promises.write(o,n,r,p,A)).bytesWritten}catch(k){throw await this.gb(this.X.get(o),k)}finally{this.$(o,A,C)}return C}async mkdir(o){try{await v.Promises.mkdir(this.H(o))}catch(t){throw this.fb(t)}}async delete(o,t){try{const n=this.H(o);if(t.recursive){let r;t?.atomic!==!1&&t.atomic.postfix&&(r=(0,g.$jc)((0,g.$mc)(n),`${(0,g.$nc)(n)}${t.atomic.postfix}`)),await v.Promises.rm(n,v.RimRafMode.MOVE,r)}else try{await v.Promises.unlink(n)}catch(r){if(r.code==="EPERM"||r.code==="EISDIR"){let p=!1;try{const{stat:A,symbolicLink:C}=await v.SymlinkSupport.stat(n);p=A.isDirectory()&&!C}catch{}if(p)await v.Promises.rmdir(n);else throw r}else throw r}}catch(n){throw this.fb(n)}}async rename(o,t,n){const r=this.H(o),p=this.H(t);if(r!==p)try{await this.bb(o,t,"move",n.overwrite),await v.Promises.rename(r,p)}catch(A){throw(A.code==="EINVAL"||A.code==="EBUSY"||A.code==="ENAMETOOLONG")&&(A=new Error((0,b.localize)(2,null,(0,g.$nc)(r),(0,g.$nc)((0,g.$mc)(p)),A.toString()))),this.fb(A)}}async copy(o,t,n){const r=this.H(o),p=this.H(t);if(r!==p)try{await this.bb(o,t,"copy",n.overwrite),await v.Promises.copy(r,p,{preserveSymlinks:!0})}catch(A){throw(A.code==="EINVAL"||A.code==="EBUSY"||A.code==="ENAMETOOLONG")&&(A=new Error((0,b.localize)(3,null,(0,g.$nc)(r),(0,g.$nc)((0,g.$mc)(p)),A.toString()))),this.fb(A)}}async bb(o,t,n,r){const p=this.H(o),A=this.H(t);let C=!1;if(!!(this.capabilities&1024)||(C=(0,f.$Wf)(p,A,!0)),C){if(n==="copy")throw(0,$.$kk)((0,b.localize)(4,null),$.FileSystemProviderErrorCode.FileExists);if(n==="move")return}const I=await this.L(o);if(!I)throw(0,$.$kk)((0,b.localize)(5,null),$.FileSystemProviderErrorCode.FileNotFound);const j=await this.L(t);if(j){if(!r)throw(0,$.$kk)((0,b.localize)(6,null),$.FileSystemProviderErrorCode.FileExists);I.type&$.FileType.File&&j.type&$.FileType.File||await this.delete(t,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(o,t){return this.cb(o,t,!1)}async cb(o,t,n){const r=this.H(o),p=this.H(t),A=!!(this.capabilities&1024);if((0,f.$Wf)(r,p,!A))return;const C=new a.$Rc;try{C.add(await this.O(o)),C.add(await this.O(t)),n&&await v.Promises.mkdir((0,g.$mc)(p),{recursive:!0}),await v.Promises.copyFile(r,p)}catch(k){if(k.code==="ENOENT"&&!n)return this.cb(o,t,!0);throw this.fb(k)}finally{C.dispose()}}t(o,t,n){return new E.$2p(r=>o(r),r=>t(r),n)}F(o,t,n){return new h.$0p(r=>o(r),r=>t(r),n)}fb(o){if(o instanceof $.$jk)return o;let t=o,n;switch(o.code){case"ENOENT":n=$.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":n=$.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":n=$.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":n=$.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":n=$.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":t=`${o.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,n=$.FileSystemProviderErrorCode.Unknown;break;default:n=$.FileSystemProviderErrorCode.Unknown}return(0,$.$kk)(t,n)}async gb(o,t){let n=this.fb(t);if(o&&n.code===$.FileSystemProviderErrorCode.NoPermissions)try{const{stat:r}=await v.SymlinkSupport.stat(this.H(o));r.mode&128||(n=(0,$.$kk)(t,$.FileSystemProviderErrorCode.FileWriteLocked))}catch(r){this.a.trace(r)}return n}}e.$$p=i}),define(te[221],ie([0,1,3,92,2,17,61,22]),function(Q,e,S,R,s,M,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hr=e.$Gr=void 0;class f extends s.$Sc{constructor(w,y){super(),this.a=w,this.b=y,this.F=new Map,this.G=new Map}call(w,y,d){const v=this.c(w);switch(y){case"stat":return this.g(v,d[0]);case"readdir":return this.h(v,d[0]);case"open":return this.r(v,d[0],d[1]);case"close":return this.s(d[0]);case"read":return this.t(d[0],d[1],d[2]);case"readFile":return this.j(v,d[0],d[1]);case"write":return this.u(d[0],d[1],d[2],d[3],d[4]);case"writeFile":return this.n(v,d[0],d[1],d[2]);case"rename":return this.z(v,d[0],d[1],d[2]);case"copy":return this.C(v,d[0],d[1],d[2]);case"cloneFile":return this.D(v,d[0],d[1]);case"mkdir":return this.w(v,d[0]);case"delete":return this.y(v,d[0],d[1]);case"watch":return this.I(v,d[0],d[1],d[2],d[3]);case"unwatch":return this.J(d[0],d[1])}throw new Error(`IPC Command ${y} not found`)}listen(w,y,d){const v=this.c(w);switch(y){case"fileChange":return this.H(v,d[0]);case"readFileStream":return this.m(v,d[0],d[1])}throw new Error(`Unknown event ${y}`)}g(w,y){const d=this.f(w,y,!0);return this.a.stat(d)}h(w,y){const d=this.f(w,y);return this.a.readdir(d)}async j(w,y,d){const v=this.f(w,y,!0),b=await this.a.readFile(v,d);return M.$be.wrap(b)}m(w,y,d){const v=this.f(w,y,!0),b=new P.$Xd,$=new S.$Nd({onDidRemoveLastListener:()=>{b.cancel()}}),m=this.a.readFileStream(v,d,b.token);return(0,D.$6d)(m,{onData:u=>$.fire(M.$be.wrap(u)),onError:u=>$.fire(u),onEnd:()=>{$.fire("end"),$.dispose(),b.dispose()}}),$.event}n(w,y,d,v){const b=this.f(w,y);return this.a.writeFile(b,d.buffer,v)}r(w,y,d){const v=this.f(w,y,!0);return this.a.open(v,d)}s(w){return this.a.close(w)}async t(w,y,d){const v=M.$be.alloc(d),b=0,$=await this.a.read(w,y,v.buffer,b,d);return[v,$]}u(w,y,d,v,b){return this.a.write(w,y,d.buffer,v,b)}w(w,y){const d=this.f(w,y);return this.a.mkdir(d)}y(w,y,d){const v=this.f(w,y);return this.a.delete(v,d)}z(w,y,d,v){const b=this.f(w,y),$=this.f(w,d);return this.a.rename(b,$,v)}C(w,y,d,v){const b=this.f(w,y),$=this.f(w,d);return this.a.copy(b,$,v)}D(w,y,d){const v=this.f(w,y),b=this.f(w,d);return this.a.cloneFile(v,b)}H(w,y){const d=new S.$Nd({onWillAddFirstListener:()=>{this.F.set(y,this.L(w,d))},onDidRemoveLastListener:()=>{(0,s.$Nc)(this.F.get(y)),this.F.delete(y)}});return d.event}async I(w,y,d,v,b){const $=this.F.get(y);if($){const m=this.f(w,v),u=$.watch(d,m,b);this.G.set(y+d,u)}}async J(w,y){const d=w+y,v=this.G.get(d);v&&((0,s.$Nc)(v),this.G.delete(d))}dispose(){super.dispose();for(const[,w]of this.G)w.dispose();this.G.clear();for(const[,w]of this.F)w.dispose();this.F.clear()}}e.$Gr=f;class a extends s.$Sc{constructor(w,y,d,v){super(),this.c=w,this.f=d,this.g=v,this.a=new Map,this.b=this.B(new R.$$p(this.f,{watcher:{recursive:this.j(this.g)}})),this.h(y)}h(w){const y=this.B(new S.$Nd);this.B(y.event(d=>{w.fire(d.map(v=>({resource:this.c.transformOutgoingURI(v.resource),type:v.type,cId:v.cId})))})),this.B(this.b.onDidChangeFile(d=>y.fire(d))),this.B(this.b.onDidWatchError(d=>w.fire(d)))}j(w){}m(w){}watch(w,y,d){const v=this.m(this.g);return Array.isArray(v)&&(d.excludes=[...d.excludes,...v]),this.a.set(w,this.b.watch(y,d)),(0,s.$Qc)(()=>{(0,s.$Nc)(this.a.get(w)),this.a.delete(w)})}dispose(){for(const[,w]of this.a)w.dispose();this.a.clear(),super.dispose()}}e.$Hr=a}),define(te[222],ie([0,1,15,176,4,7,16,9,221,153]),function(Q,e,S,R,s,M,D,P,f,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$M6b=void 0;class g extends f.$Gr{constructor(d,v,b){super(d,v),this.M=b}c(d){return a.$Km}f(d,v){return M.URI.revive(v)}async y(d,v,b){if(!b.useTrash)return super.y(d,v,b);const $=this.f(d,v),m=(0,P.$hc)($.fsPath);try{await S.shell.trashItem(m)}catch{throw(0,D.$kk)(s.$j?(0,R.localize)(0,null,(0,P.$nc)(m)):(0,R.localize)(1,null,(0,P.$nc)(m)),D.FileSystemProviderErrorCode.Unknown)}}L(d,v){return new w(d,v,this.b,this.M)}}e.$M6b=g;class w extends f.$Hr{watch(d,v,b){if(b.recursive)throw(0,D.$kk)("Recursive file watching is not supported from main process for performance reasons.",D.FileSystemProviderErrorCode.Unavailable);return super.watch(d,v,b)}}}),define(te[223],ie([0,1,5]),function(Q,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$K3b=void 0;class R extends S.$cj{constructor(M=S.$_i){super(),this.m=[],this.n=void 0,this.setLevel(M),this.B(this.onDidChangeLogLevel(D=>{this.n?.setLevel(D)}))}set logger(M){this.n=M;for(const{level:D,message:P}of this.m)(0,S.log)(M,D,P);this.m=[]}g(M,D){this.n?(0,S.log)(this.n,M,D):this.getLevel()<=M&&this.m.push({level:M,message:D})}dispose(){this.n?.dispose()}flush(){this.n?.flush()}}e.$K3b=R}),define(te[224],ie([0,1,7,3,5,2]),function(Q,e,S,R,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$q=e.$0q=e.$9q=void 0;class D extends s.$hj{constructor(w,y,d,v,b){super(y,d,v),this.r=w,this.t=b,this.B(b.listen("onDidChangeLogLevel",w)($=>{(0,s.$$i)($)?super.setLogLevel($):super.setLogLevel(S.URI.revive($[0]),$[1])})),this.B(b.listen("onDidChangeVisibility",w)(([$,m])=>super.setVisibility(S.URI.revive($),m))),this.B(b.listen("onDidChangeLoggers",w)(({added:$,removed:m})=>{for(const u of $)super.registerLogger({...u,resource:S.URI.revive(u.resource)});for(const u of m)super.deregisterLogger(u.resource)}))}createConsoleMainLogger(){return new s.$fj({log:(w,y)=>{this.t.call("consoleLog",[w,y])}})}registerLogger(w){super.registerLogger(w),this.t.call("registerLogger",[w,this.r])}deregisterLogger(w){super.deregisterLogger(w),this.t.call("deregisterLogger",[w,this.r])}setLogLevel(w,y){super.setLogLevel(w,y),this.t.call("setLogLevel",[w,y])}setVisibility(w,y){super.setVisibility(w,y),this.t.call("setVisibility",[this.n(w),y])}s(w,y,d){return new P(this.t,w,y,d,this.r)}static setLogLevel(w,y,d){return w.call("setLogLevel",[y,d])}}e.$9q=D;class P extends s.$cj{constructor(w,y,d,v,b){super(v?.logLevel==="always"),this.r=w,this.s=y,this.m=!1,this.n=[],this.setLevel(d),this.r.call("createLogger",[y,v,b]).then(()=>{this.u(this.n),this.m=!0})}g(w,y){const d=[[w,y]];this.m?this.u(d):this.n.push(...d)}u(w){this.r.call("log",[this.s,w])}}class f{constructor(w,y){this.a=w,this.b=y}listen(w,y){const d=this.b(w);switch(y){case"onDidChangeLoggers":return R.Event.map(this.a.onDidChangeLoggers,v=>({added:[...v.added].map(b=>this.c(b,d)),removed:[...v.removed].map(b=>this.c(b,d))}));case"onDidChangeVisibility":return R.Event.map(this.a.onDidChangeVisibility,v=>[d.transformOutgoingURI(v[0]),v[1]]);case"onDidChangeLogLevel":return R.Event.map(this.a.onDidChangeLogLevel,v=>(0,s.$$i)(v)?v:[d.transformOutgoingURI(v[0]),v[1]])}throw new Error(`Event not found: ${y}`)}async call(w,y,d){const v=this.b(w);switch(y){case"setLogLevel":return(0,s.$$i)(d[0])?this.a.setLogLevel(d[0]):this.a.setLogLevel(S.URI.revive(v.transformIncoming(d[0][0])),d[0][1]);case"getRegisteredLoggers":return Promise.resolve([...this.a.getRegisteredLoggers()].map(b=>this.c(b,v)))}throw new Error(`Call not found: ${y}`)}c(w,y){return{...w,resource:y.transformOutgoingURI(w.resource)}}}e.$0q=f;class a extends M.$Sc{constructor(w,y){super(),y.call("setLogLevel",[w.getLogLevel()]),this.B(w.onDidChangeLogLevel(d=>y.call("setLogLevel",[d]))),y.call("getRegisteredLoggers").then(d=>{for(const v of d)w.registerLogger({...v,resource:S.URI.revive(v.resource)})}),this.B(y.listen("onDidChangeVisibility")(([d,v])=>w.setVisibility(S.URI.revive(d),v))),this.B(y.listen("onDidChangeLoggers")(({added:d,removed:v})=>{for(const b of d)w.registerLogger({...b,resource:S.URI.revive(b.resource)});for(const b of v)w.deregisterLogger(b.resource)}))}}e.$$q=a}),define(te[225],ie([0,1,2,5]),function(Q,e,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zN=void 0;class s extends S.$Sc{constructor(D,P=[]){super(),this.a=new R.$gj([D,...P]),this.B(D.onDidChangeLogLevel(f=>this.setLevel(f)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(D){this.a.setLevel(D)}getLevel(){return this.a.getLevel()}trace(D,...P){this.a.trace(D,...P)}debug(D,...P){this.a.debug(D,...P)}info(D,...P){this.a.info(D,...P)}warn(D,...P){this.a.warn(D,...P)}error(D,...P){this.a.error(D,...P)}flush(){this.a.flush()}}e.$zN=s}),define(te[226],ie([0,1,31,7,5]),function(Q,e,S,R,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$I7b=void 0;class M{constructor(P){this.b=P,this.a=new S.$Ac}listen(P,f,a){switch(f){case"onDidChangeLoggers":return a?this.b.getOnDidChangeLoggersEvent(a):this.b.onDidChangeLoggers;case"onDidChangeLogLevel":return a?this.b.getOnDidChangeLogLevelEvent(a):this.b.onDidChangeLogLevel;case"onDidChangeVisibility":return a?this.b.getOnDidChangeVisibilityEvent(a):this.b.onDidChangeVisibility}throw new Error(`Event not found: ${f}`)}async call(P,f,a){switch(f){case"createLogger":this.c(R.URI.revive(a[0]),a[1],a[2]);return;case"log":return this.e(R.URI.revive(a[0]),a[1]);case"consoleLog":return this.d(a[0],a[1]);case"setLogLevel":return(0,s.$$i)(a[0])?this.b.setLogLevel(a[0]):this.b.setLogLevel(R.URI.revive(a[0]),a[1]);case"setVisibility":return this.b.setVisibility(R.URI.revive(a[0]),a[1]);case"registerLogger":return this.b.registerLogger({...a[0],resource:R.URI.revive(a[0].resource)},a[1]);case"deregisterLogger":return this.b.deregisterLogger(R.URI.revive(a[0]))}throw new Error(`Call not found: ${f}`)}c(P,f,a){this.a.set(P,this.b.createLogger(P,f,a))}d(P,f){let a=console.log;switch(P){case s.LogLevel.Error:a=console.error;break;case s.LogLevel.Warning:a=console.warn;break;case s.LogLevel.Info:a=console.info;break}a.call(console,...f)}e(P,f){const a=this.a.get(P);if(!a)throw new Error("Create the logger before logging");for(const[g,w]of f)(0,s.log)(a,g,w)}}e.$I7b=M}),define(te[227],ie([0,1,16,5]),function(Q,e,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oN=void 0;var s;(function(a){a[a.Trace=0]="Trace",a[a.Debug=1]="Debug",a[a.Info=2]="Info",a[a.Warning=3]="Warning",a[a.Error=4]="Error",a[a.Critical=5]="Critical",a[a.Off=6]="Off"})(s||(s={}));async function M(a,g,w,y,d){try{const v=await new Promise(($,m)=>{Q(["@vscode/spdlog"],$,m)});v.setFlushOn(s.Trace);const b=await v.createAsyncRotatingLogger(a,g,w,y);return d?b.clearFormatters():b.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),b}catch(v){console.error(v)}return null}function D(a,g,w){switch(g){case R.LogLevel.Trace:a.trace(w);break;case R.LogLevel.Debug:a.debug(w);break;case R.LogLevel.Info:a.info(w);break;case R.LogLevel.Warning:a.warn(w);break;case R.LogLevel.Error:a.error(w);break;case R.LogLevel.Off:break;default:throw new Error(`Invalid log level ${g}`)}}function P(a,g){switch(g){case R.LogLevel.Trace:a.setLevel(s.Trace);break;case R.LogLevel.Debug:a.setLevel(s.Debug);break;case R.LogLevel.Info:a.setLevel(s.Info);break;case R.LogLevel.Warning:a.setLevel(s.Warning);break;case R.LogLevel.Error:a.setLevel(s.Error);break;case R.LogLevel.Off:a.setLevel(s.Off);break;default:throw new Error(`Invalid log level ${g}`)}}class f extends R.$cj{constructor(g,w,y,d,v){super(),this.m=[],this.setLevel(v),this.n=this.s(g,w,y,d),this.B(this.onDidChangeLogLevel(b=>{this.r&&P(this.r,b)}))}async s(g,w,y,d){const v=y?6:1,b=30/v*S.$Fk.MB,$=await M(g,w,b,v,d);if($){this.r=$,P(this.r,this.getLevel());for(const{level:m,message:u}of this.m)D(this.r,m,u);this.m=[]}}g(g,w){this.r?D(this.r,g,w):this.getLevel()<=g&&this.m.push({level:g,message:w})}flush(){this.r?this.r.flush():this.n.then(()=>this.flush())}dispose(){this.r?this.u():this.n.then(()=>this.u())}u(){this.r&&(this.r.drop(),this.r=void 0)}}e.$oN=f}),define(te[228],ie([0,1,32,5,227]),function(Q,e,S,R,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pN=void 0;class M extends R.$hj{s(P,f,a){return new s.$oN((0,S.$eg)(),P.fsPath,!a?.donotRotate,!!a?.donotUseFormatters,f)}}e.$pN=M}),define(te[66],ie([0,1,31,3,6,5,228]),function(Q,e,S,R,s,M,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$06b=e.$96b=void 0,e.$96b=(0,s.$Ph)(M.$0i);class P extends D.$pN{constructor(){super(...arguments),this.u=new S.$Ac}createLogger(a,g,w){w!==void 0&&this.u.set(this.n(a),w);try{return super.createLogger(a,g)}catch(y){throw this.u.delete(this.n(a)),y}}registerLogger(a,g){g!==void 0&&this.u.set(a.resource,g),super.registerLogger(a)}deregisterLogger(a){this.u.delete(a),super.deregisterLogger(a)}getRegisteredLoggers(a){const g=[];for(const w of super.getRegisteredLoggers())a===this.u.get(w.resource)&&g.push(w);return g}getOnDidChangeLogLevelEvent(a){return R.Event.filter(this.onDidChangeLogLevel,g=>(0,M.$$i)(g)||this.w(g[0],a))}getOnDidChangeVisibilityEvent(a){return R.Event.filter(this.onDidChangeVisibility,([g])=>this.w(g,a))}getOnDidChangeLoggersEvent(a){return R.Event.filter(R.Event.map(this.onDidChangeLoggers,g=>({added:[...g.added].filter(y=>this.w(y.resource,a)),removed:[...g.removed].filter(y=>this.w(y.resource,a))})),g=>g.added.length>0||g.removed.length>0)}deregisterLoggers(a){for(const[g,w]of this.u)w===a&&this.deregisterLogger(g)}w(a,g){const w=this.u.get(a);return w===void 0||w===g}dispose(){super.dispose(),this.u.clear()}}e.$06b=P}),define(te[229],ie([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$36b=e.$26b=e.$16b=e.$Z6b=void 0;function S(D){return D.submenu!==void 0}e.$Z6b=S;function R(D){return D.id==="vscode.menubar.separator"}e.$16b=R;function s(D){return D.uri!==void 0}e.$26b=s;function M(D){return!S(D)&&!R(D)&&!s(D)}e.$36b=M}),define(te[39],ie([0,1,3,70,2,6]),function(Q,e,S,R,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hn=e.$gn=e.$fn=void 0,e.$fn=(0,M.$Oh)("policy");class D extends s.$Sc{constructor(){super(...arguments),this.f={},this.g=new Map,this.h=this.B(new S.$Nd),this.onDidChange=this.h.event}async updatePolicyDefinitions(a){const g=Object.keys(this.f).length;return this.f={...a,...this.f},g!==Object.keys(this.f).length&&await this.j(a),R.Iterable.reduce(this.g.entries(),(w,[y,d])=>({...w,[y]:d}),{})}getPolicyValue(a){return this.g.get(a)}serialize(){return R.Iterable.reduce(Object.entries(this.f),(a,[g,w])=>({...a,[g]:{definition:w,value:this.g.get(g)}}),{})}}e.$gn=D;class P{constructor(){this.onDidChange=S.Event.None}async updatePolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.$hn=P}),define(te[230],ie([0,1,8,3,70,12,16,5,39]),function(Q,e,S,R,s,M,D,P,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$27b=void 0;function a(w,y){const d=[];for(const v of new Set(s.Iterable.concat(w.keys(),y.keys())))w.get(v)!==y.get(v)&&d.push(v);return d}let g=class extends f.$gn{constructor(y,d,v){super(),this.m=y,this.n=d,this.s=v,this.c=this.B(new S.$Rg(500));const b=R.Event.filter(d.onDidFilesChange,$=>$.affects(y));this.B(d.watch(y)),this.B(b(()=>this.c.trigger(()=>this.w())))}async j(){await this.w()}async u(){const y=new Map;try{const d=await this.n.readFile(this.m),v=JSON.parse(d.value.toString());if(!(0,M.$Af)(v))throw new Error("Policy file isn't a JSON object");for(const b of Object.keys(v))this.f[b]&&y.set(b,v[b])}catch(d){d.fileOperationResult!==1&&this.s.error("[FilePolicyService] Failed to read policies",d)}return y}async w(){const y=await this.u(),d=a(this.g,y);this.g=y,d.length>0&&this.h.fire(d)}};e.$27b=g,e.$27b=g=ke([ee(1,D.$0j),ee(2,P.$9i)],g)}),define(te[231],ie([0,1,3,2,39]),function(Q,e,S,R,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$C7b=e.$B7b=void 0;class M{constructor(f){this.b=f,this.a=new R.$Rc}listen(f,a){switch(a){case"onDidChange":return S.Event.map(this.b.onDidChange,g=>g.reduce((w,y)=>({...w,[y]:this.b.getPolicyValue(y)??null}),{}),this.a)}throw new Error(`Event not found: ${a}`)}call(f,a,g){switch(a){case"updatePolicyDefinitions":return this.b.updatePolicyDefinitions(g)}throw new Error(`Call not found: ${a}`)}dispose(){this.a.dispose()}}e.$B7b=M;class D extends s.$gn{constructor(f,a){super(),this.a=a;for(const g in f){const{definition:w,value:y}=f[g];this.f[g]=w,y!==void 0&&this.g.set(g,y)}this.a.listen("onDidChange")(g=>{for(const w in g){const y=g[w];y===null?this.g.delete(w):this.g.set(w,y)}this.h.fire(Object.keys(g))})}async j(f){const a=await this.a.call("updatePolicyDefinitions",f);for(const g in a)this.g.set(g,a[g])}}e.$C7b=D}),define(te[232],ie([0,1,39,8,310,2,5]),function(Q,e,S,R,s,M,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$17b=void 0;let P=class extends S.$gn{constructor(a,g){super(),this.m=a,this.n=g,this.a=new R.$Ng,this.b=this.B(new M.$Tc)}async j(a){this.m.trace(`NativePolicyService#_updatePolicyDefinitions - Found ${Object.keys(a).length} policy definitions`),await this.a.queue(()=>new Promise((g,w)=>{try{this.b.value=(0,s.createWatcher)(this.n,a,y=>{this.t(y),g()})}catch(y){this.m.error("NativePolicyService#_updatePolicyDefinitions - Error creating watcher:",y),w(y)}}))}t(a){this.m.trace(`NativePolicyService#_onDidPolicyChange - Updated policy values: ${JSON.stringify(a)}`);for(const g in a){const w=a[g];w===void 0?this.g.delete(g):this.g.set(g,w)}this.h.fire(Object.keys(a))}};e.$17b=P,e.$17b=P=ke([ee(0,D.$9i)],P)}),define(te[78],ie([0,1,4,35]),function(Q,e,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let s;if(typeof S.$h.vscode<"u"&&typeof S.$h.vscode.context<"u"){const M=S.$h.vscode.context.configuration();if(M)s=M.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){if(s=globalThis._VSCODE_PRODUCT_JSON,R.env.VSCODE_DEV&&Object.assign(s,{nameShort:`${s.nameShort} Dev`,nameLong:`${s.nameLong} Dev`,dataFolderName:`${s.dataFolderName}-dev`,serverDataFolderName:s.serverDataFolderName?`${s.serverDataFolderName}-dev`:void 0}),!s.version){const M=globalThis._VSCODE_PACKAGE_JSON;Object.assign(s,{version:M.version})}}else s={},Object.keys(s).length===0&&Object.assign(s,{version:"1.82.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverLicenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=s}),define(te[24],ie([0,1,6]),function(Q,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pj=e.$oj=void 0,e.$oj=(0,S.$Oh)("productService"),e.$pj="vscode://schemas/vscode-product"}),define(te[233],ie([0,1,8,5]),function(Q,e,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$P6b=void 0;let s=class{constructor(D,P,f){this.a=D,this.b=P,this.c=f}async inspect(D){await this.d();const P=this.a.webContents.debugger;await P.sendCommand("Profiler.start"),this.c.warn("[perf] profiling STARTED",this.b),await(0,S.$Ug)(D);const f=await P.sendCommand("Profiler.stop");return this.c.warn("[perf] profiling DONE",this.b),await this.e(),f.profile}async d(){const D=this.a.webContents.debugger;D.attach(),await D.sendCommand("Profiler.enable")}async e(){const D=this.a.webContents.debugger;await D.sendCommand("Profiler.disable"),D.detach()}};e.$P6b=s,e.$P6b=s=ke([ee(2,R.$9i)],s)}),define(te[79],ie([0,1,6]),function(Q,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$S6b=void 0,e.$S6b=(0,S.$Oh)("protocolMainService")}),define(te[43],ie([0,1,135,12]),function(Q,e,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dn=void 0;class s{constructor(){this.a=new Map}add(D,P){S.ok(R.$yf(D)),S.ok(R.$Af(P)),S.ok(!this.a.has(D),"There is already an extension with this id"),this.a.set(D,P)}knows(D){return this.a.has(D)}as(D){return this.a.get(D)||null}}e.$dn=new s}),define(te[234],ie([0,1,3,43]),function(Q,e,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$en=void 0,e.$en={JSONContribution:"base.contributions.json"};function s(P){return P.length>0&&P.charAt(P.length-1)==="#"?P.substring(0,P.length-1):P}class M{constructor(){this.b=new S.$Nd,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(f,a){this.a[s(f)]=a,this.b.fire(f)}notifySchemaChanged(f){this.b.fire(f)}getSchemaContributions(){return{schemas:this.a}}}const D=new M;R.$dn.add(e.$en.JSONContribution,D)}),define(te[57],ie([0,1,23,3,12,161,18,234,43]),function(Q,e,S,R,s,M,D,P,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xn=e.$wn=e.$vn=e.$un=e.$tn=e.$sn=e.$rn=e.$qn=e.$pn=e.$on=e.$nn=e.$mn=e.$ln=e.$kn=e.$jn=e.ConfigurationScope=e.$in=e.EditPresentationTypes=void 0;var a;(function(h){h.Multiline="multilineText",h.Singleline="singlelineText"})(a||(e.EditPresentationTypes=a={})),e.$in={Configuration:"base.contributions.configuration"};var g;(function(h){h[h.APPLICATION=1]="APPLICATION",h[h.MACHINE=2]="MACHINE",h[h.WINDOW=3]="WINDOW",h[h.RESOURCE=4]="RESOURCE",h[h.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",h[h.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(g||(e.ConfigurationScope=g={})),e.$jn={properties:{},patternProperties:{}},e.$kn={properties:{},patternProperties:{}},e.$ln={properties:{},patternProperties:{}},e.$mn={properties:{},patternProperties:{}},e.$nn={properties:{},patternProperties:{}},e.$on={properties:{},patternProperties:{}},e.$pn="vscode://schemas/settings/resourceLanguage",e.$qn="vscode://schemas/settings/configurationDefaults";const w=f.$dn.as(P.$en.JSONContribution);class y{constructor(){this.h=new Set,this.i=new R.$Nd,this.onDidSchemaChange=this.i.event,this.j=new R.$Nd,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:M.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},w.registerSchema(e.$pn,this.g),this.v()}registerConfiguration(i,c=!0){this.registerConfigurations([i],c)}registerConfigurations(i,c=!0){const o=new Set;this.n(i,c,o),w.registerSchema(e.$pn,this.g),this.i.fire(),this.j.fire({properties:o})}deregisterConfigurations(i){const c=new Set;this.o(i,c),w.registerSchema(e.$pn,this.g),this.i.fire(),this.j.fire({properties:c})}updateConfigurations({add:i,remove:c}){const o=new Set;this.o(c,o),this.n(i,!1,o),w.registerSchema(e.$pn,this.g),this.i.fire(),this.j.fire({properties:o})}registerDefaultConfigurations(i){const c=new Set;this.k(i,c),this.i.fire(),this.j.fire({properties:c,defaultsOverrides:!0})}k(i,c){const o=[];for(const{overrides:t,source:n}of i)for(const r in t)if(c.add(r),e.$sn.test(r)){const p=this.a.get(r),A=p?.valuesSources??new Map;if(n)for(const j of Object.keys(t[r]))A.set(j,n);const C={...p?.value||{},...t[r]};this.a.set(r,{source:n,value:C,valuesSources:A});const k=(0,D.$si)(r),I={type:"object",default:C,description:M.localize(1,null,k),$ref:e.$pn,defaultDefaultValue:C,source:s.$yf(n)?void 0:n,defaultValueSource:n};o.push(...b(r)),this.d[r]=I,this.b.properties[r]=I}else{this.a.set(r,{value:t[r],source:n});const p=this.d[r];p&&(this.w(r,p),this.r(r,p))}this.m(o)}deregisterDefaultConfigurations(i){const c=new Set;this.l(i,c),this.i.fire(),this.j.fire({properties:c,defaultsOverrides:!0})}l(i,c){for(const{overrides:o,source:t}of i)for(const n in o){const r=this.a.get(n),p=s.$yf(t)?t:t?.id,A=s.$yf(r?.source)?r?.source:r?.source?.id;if(p===A)if(c.add(n),this.a.delete(n),e.$sn.test(n))delete this.d[n],delete this.b.properties[n];else{const C=this.d[n];C&&(this.w(n,C),this.r(n,C))}}this.u()}deltaConfiguration(i){let c=!1;const o=new Set;i.removedDefaults&&(this.l(i.removedDefaults,o),c=!0),i.addedDefaults&&(this.k(i.addedDefaults,o),c=!0),i.removedConfigurations&&this.o(i.removedConfigurations,o),i.addedConfigurations&&this.n(i.addedConfigurations,!1,o),this.i.fire(),this.j.fire({properties:o,defaultsOverrides:c})}notifyConfigurationSchemaUpdated(...i){this.i.fire()}registerOverrideIdentifiers(i){this.m(i),this.i.fire()}m(i){for(const c of i)this.h.add(c);this.u()}n(i,c,o){i.forEach(t=>{this.p(t,c,t.extensionInfo,t.restrictedProperties,void 0,o),this.c.push(t),this.q(t)})}o(i,c){const o=t=>{if(t.properties)for(const n in t.properties){c.add(n);const r=this.d[n];r?.policy?.name&&this.e.delete(r.policy.name),delete this.d[n],this.s(n,t.properties[n])}t.allOf?.forEach(n=>o(n))};for(const t of i){o(t);const n=this.c.indexOf(t);n!==-1&&this.c.splice(n,1)}}p(i,c=!0,o,t,n=3,r){n=s.$Hf(i.scope)?n:i.scope;const p=i.properties;if(p)for(const C in p){const k=p[C];if(c&&l(C,k)){delete p[C];continue}if(k.source=o,k.defaultDefaultValue=p[C].default,this.w(C,k),e.$sn.test(C)?k.scope=void 0:(k.scope=s.$Hf(k.scope)?n:k.scope,k.restricted=s.$Hf(k.restricted)?!!t?.includes(C):k.restricted),p[C].hasOwnProperty("included")&&!p[C].included){this.f[C]=p[C],delete p[C];continue}else this.d[C]=p[C],p[C].policy?.name&&this.e.set(p[C].policy.name,C);!p[C].deprecationMessage&&p[C].markdownDeprecationMessage&&(p[C].deprecationMessage=p[C].markdownDeprecationMessage),r.add(C)}const A=i.allOf;if(A)for(const C of A)this.p(C,c,o,t,n,r)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(i){const c=o=>{const t=o.properties;if(t)for(const r in t)this.r(r,t[r]);o.allOf?.forEach(c)};c(i)}r(i,c){switch(e.$jn.properties[i]=c,c.scope){case 1:e.$kn.properties[i]=c;break;case 2:e.$ln.properties[i]=c;break;case 6:e.$mn.properties[i]=c;break;case 3:e.$nn.properties[i]=c;break;case 4:e.$on.properties[i]=c;break;case 5:e.$on.properties[i]=c,this.g.properties[i]=c;break}}s(i,c){switch(delete e.$jn.properties[i],c.scope){case 1:delete e.$kn.properties[i];break;case 2:delete e.$ln.properties[i];break;case 6:delete e.$mn.properties[i];break;case 3:delete e.$nn.properties[i];break;case 4:case 5:delete e.$on.properties[i],delete this.g.properties[i];break}}u(){for(const i of this.h.values()){const c=`[${i}]`,o={type:"object",description:M.localize(2,null),errorMessage:M.localize(3,null),$ref:e.$pn};this.w(c,o),e.$jn.properties[c]=o,e.$kn.properties[c]=o,e.$ln.properties[c]=o,e.$mn.properties[c]=o,e.$nn.properties[c]=o,e.$on.properties[c]=o}}v(){const i={type:"object",description:M.localize(4,null),errorMessage:M.localize(5,null),$ref:e.$pn};e.$jn.patternProperties[e.$rn]=i,e.$kn.patternProperties[e.$rn]=i,e.$ln.patternProperties[e.$rn]=i,e.$mn.patternProperties[e.$rn]=i,e.$nn.patternProperties[e.$rn]=i,e.$on.patternProperties[e.$rn]=i,this.i.fire()}w(i,c){const o=this.a.get(i);let t=o?.value,n=o?.source;s.$Ff(t)&&(t=c.defaultDefaultValue,n=void 0),s.$Ff(t)&&(t=m(c.type)),c.default=t,c.defaultValueSource=n}}const d="\\[([^\\]]+)\\]",v=new RegExp(d,"g");e.$rn=`^(${d})+$`,e.$sn=new RegExp(e.$rn);function b(h){const i=[];if(e.$sn.test(h)){let c=v.exec(h);for(;c?.length;){const o=c[1].trim();o&&i.push(o),c=v.exec(h)}}return(0,S.$Mb)(i)}e.$tn=b;function $(h){return h.reduce((i,c)=>`${i}[${c}]`,"")}e.$un=$;function m(h){switch(Array.isArray(h)?h[0]:h){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.$vn=m;const u=new y;f.$dn.add(e.$in.Configuration,u);function l(h,i){return h.trim()?e.$sn.test(h)?M.localize(7,null,h):u.getConfigurationProperties()[h]!==void 0?M.localize(8,null,h):i.policy?.name&&u.getPolicyConfigurations().get(i.policy?.name)!==void 0?M.localize(9,null,h,i.policy?.name,u.getPolicyConfigurations().get(i.policy?.name)):null:M.localize(6,null)}e.$wn=l;function E(){const h=[],i=u.getConfigurationProperties();for(const c of Object.keys(i))h.push([c,i[c].scope]);return h.push(["launch",4]),h.push(["task",4]),h}e.$xn=E}),define(te[119],ie([0,1,23,3,44,2,31,37,12,7,18,57,43]),function(Q,e,S,R,s,M,D,P,f,a,g,w,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dn=e.$Cn=e.$Bn=e.$An=e.$zn=e.$yn=void 0;function d(c){return Object.isFrozen(c)?c:P.$5m(c)}class v{constructor(o={},t=[],n=[],r){this.b=o,this.c=t,this.d=n,this.raw=r,this.a=new Map}get rawConfiguration(){if(!this.f)if(this.raw?.length){const o=this.raw.map(t=>{if(t instanceof v)return t;const n=new b("");return n.parseRaw(t),n.configurationModel});this.f=o.reduce((t,n)=>n===t?n:t.merge(n),o[0])}else this.f=this;return this.f}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(o){return o?(0,g.$qi)(this.contents,o):this.contents}inspect(o,t){const n=this.rawConfiguration.getValue(o),r=t?this.rawConfiguration.getOverrideValue(o,t):void 0,p=t?this.rawConfiguration.override(t).getValue(o):n;return{value:n,override:r,merged:p}}getOverrideValue(o,t){const n=this.i(t);return n?o?(0,g.$qi)(n,o):n:void 0}getKeysForOverrideIdentifier(o){const t=[];for(const n of this.overrides)n.identifiers.includes(o)&&t.push(...n.keys);return S.$Mb(t)}getAllOverrideIdentifiers(){const o=[];for(const t of this.overrides)o.push(...t.identifiers);return S.$Mb(o)}override(o){let t=this.a.get(o);return t||(t=this.g(o),this.a.set(o,t)),t}merge(...o){const t=P.$4m(this.contents),n=P.$4m(this.overrides),r=[...this.keys],p=this.raw?.length?[...this.raw]:[this];for(const A of o)if(p.push(...A.raw?.length?A.raw:[A]),!A.isEmpty()){this.h(t,A.contents);for(const C of A.overrides){const[k]=n.filter(I=>S.$ub(I.identifiers,C.identifiers));k?(this.h(k.contents,C.contents),k.keys.push(...C.keys),k.keys=S.$Mb(k.keys)):n.push(P.$4m(C))}for(const C of A.keys)r.indexOf(C)===-1&&r.push(C)}return new v(t,r,n,p.every(A=>A instanceof v)?void 0:p)}g(o){const t=this.i(o);if(!t||typeof t!="object"||!Object.keys(t).length)return this;const n={};for(const r of S.$Mb([...Object.keys(this.contents),...Object.keys(t)])){let p=this.contents[r];const A=t[r];A&&(typeof p=="object"&&typeof A=="object"?(p=P.$4m(p),this.h(p,A)):p=A),n[r]=p}return new v(n,this.keys,this.overrides)}h(o,t){for(const n of Object.keys(t)){if(n in o&&f.$Af(o[n])&&f.$Af(t[n])){this.h(o[n],t[n]);continue}o[n]=P.$4m(t[n])}}i(o){let t=null,n=null;const r=p=>{p&&(n?this.h(n,p):n=P.$4m(p))};for(const p of this.overrides)p.identifiers.length===1&&p.identifiers[0]===o?t=p.contents:p.identifiers.includes(o)&&r(p.contents);return r(t),n}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(o,t){this.j(o,t,!0)}setValue(o,t){this.j(o,t,!1)}removeValue(o){const t=this.keys.indexOf(o);t!==-1&&(this.keys.splice(t,1),(0,g.$pi)(this.contents,o),w.$sn.test(o)&&this.overrides.splice(this.overrides.findIndex(n=>S.$ub(n.identifiers,(0,w.$tn)(o))),1))}j(o,t,n){(0,g.$oi)(this.contents,o,t,r=>console.error(r)),n=n||this.keys.indexOf(o)===-1,n&&this.keys.push(o),w.$sn.test(o)&&this.overrides.push({identifiers:(0,w.$tn)(o),keys:Object.keys(this.contents[o]),contents:(0,g.$ni)(this.contents[o],r=>console.error(r))})}}e.$yn=v;class b{constructor(o){this.f=o,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new v}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(o,t){if(!f.$Hf(o)){const n=this.g(o);this.parseRaw(n,t)}}reparse(o){this.a&&this.parseRaw(this.a,o)}parseRaw(o,t){this.a=o;const{contents:n,keys:r,overrides:p,restricted:A,hasExcludedProperties:C}=this.h(o,t);this.b=new v(n,r,p,C?[o]:void 0),this.c=A||[]}g(o){let t={},n=null,r=[];const p=[],A=[];function C(I){Array.isArray(r)?r.push(I):n!==null&&(r[n]=I)}const k={onObjectBegin:()=>{const I={};C(I),p.push(r),r=I,n=null},onObjectProperty:I=>{n=I},onObjectEnd:()=>{r=p.pop()},onArrayBegin:()=>{const I=[];C(I),p.push(r),r=I,n=null},onArrayEnd:()=>{r=p.pop()},onLiteralValue:C,onError:(I,j,U)=>{A.push({error:I,offset:j,length:U})}};if(o)try{s.$1m(o,k),t=r[0]||{}}catch(I){console.error(`Error while parsing settings file ${this.f}: ${I}`),this.d=[I]}return t}h(o,t){const n=y.$dn.as(w.$in.Configuration).getConfigurationProperties(),r=this.i(o,n,!0,t);o=r.raw;const p=(0,g.$ni)(o,k=>console.error(`Conflict in settings file ${this.f}: ${k}`)),A=Object.keys(o),C=this.j(o,k=>console.error(`Conflict in settings file ${this.f}: ${k}`));return{contents:p,keys:A,overrides:C,restricted:r.restricted,hasExcludedProperties:r.hasExcludedProperties}}i(o,t,n,r){let p=!1;if(!r?.scopes&&!r?.skipRestricted&&!r?.exclude?.length)return{raw:o,restricted:[],hasExcludedProperties:p};const A={},C=[];for(const k in o)if(w.$sn.test(k)&&n){const I=this.i(o[k],t,!1,r);A[k]=I.raw,p=p||I.hasExcludedProperties,C.push(...I.restricted)}else{const I=t[k],j=I?typeof I.scope<"u"?I.scope:3:void 0;I?.restricted&&C.push(k),!r.exclude?.includes(k)&&(r.include?.includes(k)||(j===void 0||r.scopes===void 0||r.scopes.includes(j))&&!(r.skipRestricted&&I?.restricted))?A[k]=o[k]:p=!0}return{raw:A,restricted:C,hasExcludedProperties:p}}j(o,t){const n=[];for(const r of Object.keys(o))if(w.$sn.test(r)){const p={};for(const A in o[r])p[A]=o[r][A];n.push({identifiers:(0,w.$tn)(r),keys:Object.keys(p),contents:(0,g.$ni)(p,t)})}return n}}e.$zn=b;class $ extends M.$Sc{constructor(o,t,n,r){super(),this.c=o,this.f=t,this.g=r,this.b=this.B(new R.$Nd),this.onDidChange=this.b.event,this.a=new b(this.c.toString()),this.B(this.g.watch(n.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(R.Event.any(R.Event.filter(this.g.onDidFilesChange,p=>p.contains(this.c)),R.Event.filter(this.g.onDidRunOperation,p=>(p.isOperation(0)||p.isOperation(3)||p.isOperation(1)||p.isOperation(4))&&n.isEqual(p.resource,o)))(()=>this.b.fire()))}async loadConfiguration(){try{const o=await this.g.readFile(this.c);return this.a.parse(o.value.toString()||"{}",this.f),this.a.configurationModel}catch{return new v}}reparse(o){return o&&(this.f=o),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$An=$;class m{constructor(o,t,n,r,p,A,C,k,I,j,U,z,ne){this.a=o,this.b=t,this.c=n,this.overrideIdentifiers=r,this.d=p,this.f=A,this.g=C,this.h=k,this.i=I,this.j=j,this.k=U,this.l=z,this.m=ne}get value(){return d(this.c)}n(o,t,n){const r=o.inspect(t,n);return{get value(){return d(r.value)},get override(){return d(r.override)},get merged(){return d(r.merged)}}}get q(){return this.p||(this.p=this.n(this.d,this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.q.value!==void 0||this.q.override!==void 0?{value:this.q.value,override:this.q.override}:void 0}get s(){return this.r===void 0&&(this.r=this.f?this.n(this.f,this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.n(this.g,this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.u?.value!==void 0||this.u?.override!==void 0?{value:this.u.value,override:this.u.override}:void 0}get w(){return this.v||(this.v=this.n(this.h,this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.w.value!==void 0||this.w.override!==void 0?{value:this.w.value,override:this.w.override}:void 0}get y(){return this.x||(this.x=this.n(this.i,this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.y.value!==void 0||this.y.override!==void 0?{value:this.y.value,override:this.y.override}:void 0}get A(){return this.z||(this.z=this.n(this.j,this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.A.value!==void 0||this.A.override!==void 0?{value:this.A.value,override:this.A.override}:void 0}get D(){return this.B===void 0&&(this.B=this.k?this.n(this.k,this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.D?.value!==void 0||this.D?.override!==void 0?{value:this.D.value,override:this.D.override}:void 0}get F(){return this.E===void 0&&(this.E=this.l?this.n(this.l,this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.F?.value!==void 0||this.F?.override!==void 0?{value:this.F.value,override:this.F.override}:void 0}get H(){return this.G===void 0&&(this.G=this.n(this.m,this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.H.value!==void 0||this.H.override!==void 0?{value:this.H.value,override:this.H.override}:void 0}}class u{constructor(o,t,n,r,p=new v,A=new v,C=new D.$Ac,k=new v,I=new D.$Ac){this.c=o,this.d=t,this.f=n,this.g=r,this.h=p,this.i=A,this.j=C,this.l=k,this.m=I,this.a=null,this.b=new D.$Ac,this.n=null}getValue(o,t,n){return this.q(o,t,n).getValue(o)}updateValue(o,t,n={}){let r;n.resource?(r=this.m.get(n.resource),r||(r=new v,this.m.set(n.resource,r))):r=this.l,t===void 0?r.removeValue(o):r.setValue(o,t),n.resource||(this.a=null)}inspect(o,t,n){const r=this.q(o,t,n),p=this.u(t.resource,n),A=t.resource?this.m.get(t.resource)||this.l:this.l,C=new Set;for(const k of r.overrides)for(const I of k.identifiers)r.getOverrideValue(o,I)!==void 0&&C.add(I);return new m(o,t,r.getValue(o),C.size?[...C]:void 0,this.c,this.d.isEmpty()?void 0:this.d,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,n?this.i:void 0,p||void 0,A)}keys(o){const t=this.u(void 0,o);return{default:this.c.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.i.keys.slice(0),workspaceFolder:t?t.keys.slice(0):[]}}updateDefaultConfiguration(o){this.c=o,this.a=null,this.b.clear()}updatePolicyConfiguration(o){this.d=o}updateApplicationConfiguration(o){this.f=o,this.a=null,this.b.clear()}updateLocalUserConfiguration(o){this.g=o,this.n=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(o){this.h=o,this.n=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(o){this.i=o,this.a=null,this.b.clear()}updateFolderConfiguration(o,t){this.j.set(o,t),this.b.delete(o)}deleteFolderConfiguration(o){this.p.delete(o),this.b.delete(o)}compareAndUpdateDefaultConfiguration(o,t){const n=[];if(!t){const{added:r,updated:p,removed:A}=h(this.c,o);t=[...r,...p,...A]}for(const r of t)for(const p of(0,w.$tn)(r)){const A=this.c.getKeysForOverrideIdentifier(p),C=o.getKeysForOverrideIdentifier(p),k=[...C.filter(I=>A.indexOf(I)===-1),...A.filter(I=>C.indexOf(I)===-1),...A.filter(I=>!P.$8m(this.c.override(p).getValue(I),o.override(p).getValue(I)))];n.push([p,k])}return this.updateDefaultConfiguration(o),{keys:t,overrides:n}}compareAndUpdatePolicyConfiguration(o){const{added:t,updated:n,removed:r}=h(this.d,o),p=[...t,...n,...r];return p.length&&this.updatePolicyConfiguration(o),{keys:p,overrides:[]}}compareAndUpdateApplicationConfiguration(o){const{added:t,updated:n,removed:r,overrides:p}=h(this.applicationConfiguration,o),A=[...t,...n,...r];return A.length&&this.updateApplicationConfiguration(o),{keys:A,overrides:p}}compareAndUpdateLocalUserConfiguration(o){const{added:t,updated:n,removed:r,overrides:p}=h(this.localUserConfiguration,o),A=[...t,...n,...r];return A.length&&this.updateLocalUserConfiguration(o),{keys:A,overrides:p}}compareAndUpdateRemoteUserConfiguration(o){const{added:t,updated:n,removed:r,overrides:p}=h(this.remoteUserConfiguration,o),A=[...t,...n,...r];return A.length&&this.updateRemoteUserConfiguration(o),{keys:A,overrides:p}}compareAndUpdateWorkspaceConfiguration(o){const{added:t,updated:n,removed:r,overrides:p}=h(this.workspaceConfiguration,o),A=[...t,...n,...r];return A.length&&this.updateWorkspaceConfiguration(o),{keys:A,overrides:p}}compareAndUpdateFolderConfiguration(o,t){const n=this.p.get(o),{added:r,updated:p,removed:A,overrides:C}=h(n,t),k=[...r,...p,...A];return(k.length||!n)&&this.updateFolderConfiguration(o,t),{keys:k,overrides:C}}compareAndDeleteFolderConfiguration(o){const t=this.p.get(o);if(!t)throw new Error("Unknown folder");this.deleteFolderConfiguration(o);const{added:n,updated:r,removed:p,overrides:A}=h(t,void 0);return{keys:[...n,...r,...p],overrides:A}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.n||(this.n=this.h.isEmpty()?this.g:this.g.merge(this.h)),this.n}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.i}get p(){return this.j}q(o,t,n){let r=this.r(t,n);return t.overrideIdentifier&&(r=r.override(t.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(o)!==void 0&&(r=r.merge(this.d)),r}r({resource:o},t){let n=this.s();if(t&&o){const r=t.getFolder(o);r&&(n=this.t(r.uri)||n);const p=this.m.get(o);p&&(n=n.merge(p))}return n}s(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.i,this.l)),this.a}t(o){let t=this.b.get(o);if(!t){const n=this.s(),r=this.j.get(o);r?(t=n.merge(r),this.b.set(o,t)):t=n}return t}u(o,t){if(t&&o){const n=t.getFolder(o);if(n)return this.j.get(n.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.i.contents,overrides:this.i.overrides,keys:this.i.keys},folders:[...this.j.keys()].reduce((o,t)=>{const{contents:n,overrides:r,keys:p}=this.j.get(t);return o.push([t,{contents:n,overrides:r,keys:p}]),o},[])}}allKeys(){const o=new Set;return this.c.keys.forEach(t=>o.add(t)),this.userConfiguration.keys.forEach(t=>o.add(t)),this.i.keys.forEach(t=>o.add(t)),this.j.forEach(t=>t.keys.forEach(n=>o.add(n))),[...o.values()]}v(){const o=new Set;return this.c.getAllOverrideIdentifiers().forEach(t=>o.add(t)),this.userConfiguration.getAllOverrideIdentifiers().forEach(t=>o.add(t)),this.i.getAllOverrideIdentifiers().forEach(t=>o.add(t)),this.j.forEach(t=>t.getAllOverrideIdentifiers().forEach(n=>o.add(n))),[...o.values()]}w(o){const t=new Set;return this.c.getKeysForOverrideIdentifier(o).forEach(n=>t.add(n)),this.userConfiguration.getKeysForOverrideIdentifier(o).forEach(n=>t.add(n)),this.i.getKeysForOverrideIdentifier(o).forEach(n=>t.add(n)),this.j.forEach(n=>n.getKeysForOverrideIdentifier(o).forEach(r=>t.add(r))),[...t.values()]}static parse(o){const t=this.x(o.defaults),n=this.x(o.policy),r=this.x(o.application),p=this.x(o.user),A=this.x(o.workspace),C=o.folders.reduce((k,I)=>(k.set(a.URI.revive(I[0]),this.x(I[1])),k),new D.$Ac);return new u(t,n,r,p,new v,A,C,new v,new D.$Ac)}static x(o){return new v(o.contents,o.keys,o.overrides)}}e.$Bn=u;function l(...c){if(c.length===0)return{keys:[],overrides:[]};if(c.length===1)return c[0];const o=new Set,t=new Map;for(const r of c)r.keys.forEach(p=>o.add(p)),r.overrides.forEach(([p,A])=>{const C=(0,D.$xc)(t,p,new Set);A.forEach(k=>C.add(k))});const n=[];return t.forEach((r,p)=>n.push([p,[...r.values()]])),{keys:[...o.values()],overrides:n}}e.$Cn=l;class E{constructor(o,t,n,r){this.change=o,this.f=t,this.g=n,this.h=r,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=".".charCodeAt(0),this.affectedKeys=new Set,this.i=void 0;for(const p of o.keys)this.affectedKeys.add(p);for(const[,p]of o.overrides)for(const A of p)this.affectedKeys.add(A);this.d=this.a;for(const p of this.affectedKeys)this.d+=p+this.a}get previousConfiguration(){return!this.i&&this.f&&(this.i=u.parse(this.f.data)),this.i}affectsConfiguration(o,t){const n=this.a+o,r=this.d.indexOf(n);if(r<0)return!1;const p=r+n.length;if(p>=this.d.length)return!1;const A=this.d.charCodeAt(p);if(A!==this.b&&A!==this.c)return!1;if(t){const C=this.previousConfiguration?this.previousConfiguration.getValue(o,t,this.f?.workspace):void 0,k=this.g.getValue(o,t,this.h);return!P.$8m(C,k)}return!0}}e.$Dn=E;function h(c,o){const{added:t,removed:n,updated:r}=i(o?.rawConfiguration,c?.rawConfiguration),p=[],A=c?.getAllOverrideIdentifiers()||[],C=o?.getAllOverrideIdentifiers()||[];if(o){const k=C.filter(I=>!A.includes(I));for(const I of k)p.push([I,o.getKeysForOverrideIdentifier(I)])}if(c){const k=A.filter(I=>!C.includes(I));for(const I of k)p.push([I,c.getKeysForOverrideIdentifier(I)])}if(o&&c){for(const k of A)if(C.includes(k)){const I=i({contents:c.getOverrideValue(void 0,k)||{},keys:c.getKeysForOverrideIdentifier(k)},{contents:o.getOverrideValue(void 0,k)||{},keys:o.getKeysForOverrideIdentifier(k)});p.push([k,[...I.added,...I.removed,...I.updated]])}}return{added:t,removed:n,updated:r,overrides:p}}function i(c,o){const t=c?o?c.keys.filter(p=>o.keys.indexOf(p)===-1):[...c.keys]:[],n=o?c?o.keys.filter(p=>c.keys.indexOf(p)===-1):[...o.keys]:[],r=[];if(c&&o){for(const p of o.keys)if(c.keys.indexOf(p)!==-1){const A=(0,g.$qi)(o.contents,p),C=(0,g.$qi)(c.contents,p);P.$8m(A,C)||r.push(p)}}return{added:t,removed:n,updated:r}}}),define(te[235],ie([0,1,23,3,2,37,12,119,57,5,39,43]),function(Q,e,S,R,s,M,D,P,f,a,g,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gn=e.$Fn=e.$En=void 0;class y extends s.$Sc{constructor(){super(...arguments),this.a=this.B(new R.$Nd),this.onDidChangeConfiguration=this.a.event,this.b=new P.$yn}get configurationModel(){return this.b}async initialize(){return this.g(),this.B(w.$dn.as(f.$in.Configuration).onDidUpdateConfiguration(({properties:$,defaultsOverrides:m})=>this.c(Array.from($),m))),this.configurationModel}reload(){return this.g(),this.configurationModel}c($,m){this.h($,w.$dn.as(f.$in.Configuration).getConfigurationProperties()),this.a.fire({defaults:this.configurationModel,properties:$})}f(){return{}}g(){this.b=new P.$yn;const $=w.$dn.as(f.$in.Configuration).getConfigurationProperties();this.h(Object.keys($),$)}h($,m){const u=this.f();for(const l of $){const E=u[l],h=m[l];E!==void 0?this.b.addValue(l,E):h?this.b.addValue(l,h.default):this.b.removeValue(l)}}}e.$En=y;class d{constructor(){this.onDidChangeConfiguration=R.Event.None,this.configurationModel=new P.$yn}async initialize(){return this.configurationModel}}e.$Fn=d;let v=class extends s.$Sc{get configurationModel(){return this.b}constructor($,m,u){super(),this.c=$,this.f=m,this.g=u,this.a=this.B(new R.$Nd),this.onDidChangeConfiguration=this.a.event,this.b=new P.$yn}async initialize(){return this.g.trace("PolicyConfiguration#initialize"),this.m(await this.h(this.c.configurationModel.keys),!1),this.B(this.f.onDidChange($=>this.j($))),this.B(this.c.onDidChangeConfiguration(async({properties:$})=>this.m(await this.h($),!0))),this.b}async h($){this.g.trace("PolicyConfiguration#updatePolicyDefinitions",$);const m={},u=[],l=w.$dn.as(f.$in.Configuration).getConfigurationProperties();for(const E of $){const h=l[E];if(!h){u.push(E);continue}if(h.policy){if(h.type!=="string"&&h.type!=="number"){this.g.warn(`Policy ${h.policy.name} has unsupported type ${h.type}`);continue}u.push(E),m[h.policy.name]={type:h.type}}}return(0,D.$Lf)(m)||await this.f.updatePolicyDefinitions(m),u}j($){this.g.trace("PolicyConfiguration#onDidChangePolicies",$);const m=w.$dn.as(f.$in.Configuration).getPolicyConfigurations(),u=(0,S.$Hb)($.map(l=>m.get(l)));this.m(u,!0)}m($,m){this.g.trace("PolicyConfiguration#update",$);const u=w.$dn.as(f.$in.Configuration).getConfigurationProperties(),l=[],E=this.b.isEmpty();for(const h of $){const i=u[h]?.policy?.name;if(i){const c=this.f.getPolicyValue(i);(E?c!==void 0:!(0,M.$8m)(this.b.getValue(h),c))&&l.push([h,c])}else this.b.getValue(h)!==void 0&&l.push([h,void 0])}if(l.length){this.g.trace("PolicyConfiguration#changed",l);const h=this.b;this.b=new P.$yn;for(const i of h.keys)this.b.setValue(i,h.getValue(i));for(const[i,c]of l)c===void 0?this.b.removeValue(i):this.b.setValue(i,c);m&&this.a.fire(this.b)}}};e.$Gn=v,e.$Gn=v=ke([ee(1,g.$fn),ee(2,a.$9i)],v)}),define(te[236],ie([0,1,8,3,2,19,18,119,235,39]),function(Q,e,S,R,s,M,D,P,f,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hn=void 0;class g extends s.$Sc{constructor(y,d,v,b){super(),this.j=y,this.h=this.B(new R.$Nd),this.onDidChangeConfiguration=this.h.event,this.b=this.B(new f.$En),this.c=v instanceof a.$hn?new f.$Fn:this.B(new f.$Gn(this.b,v,b)),this.f=this.B(new P.$An(this.j,{},M.$mg,d)),this.a=new P.$Bn(this.b.configurationModel,this.c.configurationModel,new P.$yn,new P.$yn),this.g=this.B(new S.$6g(()=>this.reloadConfiguration(),50)),this.B(this.b.onDidChangeConfiguration(({defaults:$,properties:m})=>this.n($,m))),this.B(this.c.onDidChangeConfiguration($=>this.r($))),this.B(this.f.onDidChange(()=>this.g.schedule()))}async initialize(){const[y,d,v]=await Promise.all([this.b.initialize(),this.c.initialize(),this.f.loadConfiguration()]);this.a=new P.$Bn(y,d,new P.$yn,v)}getConfigurationData(){return this.a.toData()}getValue(y,d){const v=typeof y=="string"?y:void 0,b=(0,D.$ji)(y)?y:(0,D.$ji)(d)?d:{};return this.a.getValue(v,b,void 0)}updateValue(y,d,v,b){return Promise.reject(new Error("not supported"))}inspect(y){return this.a.inspect(y,{},void 0)}keys(){return this.a.keys(void 0)}async reloadConfiguration(){const y=await this.f.loadConfiguration();this.m(y)}m(y){const d=this.a.toData(),v=this.a.compareAndUpdateLocalUserConfiguration(y);this.s(v,d,2)}n(y,d){const v=this.a.toData(),b=this.a.compareAndUpdateDefaultConfiguration(y,d);this.s(b,v,7)}r(y){const d=this.a.toData(),v=this.a.compareAndUpdatePolicyConfiguration(y);this.s(v,d,7)}s(y,d,v){const b=new P.$Dn(y,{data:d},this.a);b.source=v,b.sourceConfig=this.t(v),this.h.fire(b)}t(y){switch(y){case 7:return this.a.defaults.contents;case 2:return this.a.localUserConfiguration.contents}return{}}}e.$Hn=g}),define(te[237],ie([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$P7b=e.$O7b=e.$N7b=void 0,e.$N7b="request",e.$O7b="remoteResourceHandler";class S{async routeCall(s,M,D){if(M!==e.$N7b)throw new Error(`Call not found: ${M}`);const P=D[0];if(P?.authority){const f=s.connections.find(a=>a.ctx===P.authority);if(f)return f}throw new Error("Caller not found")}routeEvent(s,M){throw new Error(`Event not found: ${M}`)}}e.$P7b=S}),define(te[238],ie([0,1,14,6]),function(Q,e,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sk=e.$Rk=e.RemoteAuthorityResolverErrorCode=e.$Qk=e.$Pk=e.RemoteConnectionType=e.$Ok=void 0,e.$Ok=(0,R.$Oh)("remoteAuthorityResolverService");var s;(function(g){g[g.WebSocket=0]="WebSocket",g[g.Managed=1]="Managed"})(s||(e.RemoteConnectionType=s={}));class M{constructor(w){this.id=w,this.type=1}toString(){return`Managed(${this.id})`}}e.$Pk=M;class D{constructor(w,y){this.host=w,this.port=y,this.type=0}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$Qk=D;var P;(function(g){g.Unknown="Unknown",g.NotAvailable="NotAvailable",g.TemporarilyNotAvailable="TemporarilyNotAvailable",g.NoResolverFound="NoResolverFound",g.InvalidAuthority="InvalidAuthority"})(P||(e.RemoteAuthorityResolverErrorCode=P={}));class f extends S.$bb{static isNotAvailable(w){return w instanceof f&&w._code===P.NotAvailable}static isTemporarilyNotAvailable(w){return w instanceof f&&w._code===P.TemporarilyNotAvailable}static isNoResolverFound(w){return w instanceof f&&w._code===P.NoResolverFound}static isInvalidAuthority(w){return w instanceof f&&w._code===P.InvalidAuthority}static isHandled(w){return w instanceof f&&w.isHandled}constructor(w,y=P.Unknown,d){super(w),this._message=w,this._code=y,this._detail=d,this.isHandled=y===P.NotAvailable&&d===!0,Object.setPrototypeOf(this,f.prototype)}}e.$Rk=f;function a(g){const w=g.indexOf("+");return w===-1?g:g.substring(0,w)}e.$Sk=a}),define(te[58],ie([0,1,13]),function(Q,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xk=e.$Wk=e.$Vk=e.$Uk=e.$Tk=void 0;function R(a){return a.scheme===S.Schemas.vscodeRemote?a.authority:void 0}e.$Tk=R;function s(a){if(!a)return;const g=a.indexOf("+");return g<0?a:a.substr(0,g)}e.$Uk=s;function M(a){return`/${a.quality??"oss"}-${a.commit??"dev"}`}e.$Vk=M;function D(a){const{host:g,port:w}=f(a);if(typeof w>"u")throw new Error("Remote authority doesn't contain a port!");return{host:g,port:w}}e.$Wk=D;function P(a,g){let{host:w,port:y}=f(a);return typeof y>"u"&&(y=g),{host:w,port:y}}e.$Xk=P;function f(a){const g=a.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(g)return{host:g[1],port:parseInt(g[2],10)};const w=a.match(/^(\[[0-9a-z:]+\])$/);if(w)return{host:w[1],port:void 0};const y=a.match(/(.*):(\d+)$/);return y?{host:y[1],port:parseInt(y[2],10)}:{host:a,port:void 0}}}),define(te[120],ie([0,1,27,6,58]),function(Q,e,S,R,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$l=e.$0l=e.$9l=e.$8l=e.$7l=e.$6l=e.$5l=e.$4l=e.TargetPlatform=e.ExtensionType=e.$3l=e.$2l=e.$1l=e.$Zl=e.$Yl=e.$Xl=void 0,e.$Xl="extensions.user.cache",e.$Yl="extensions.builtin.cache",e.$Zl="undefined_publisher",e.$1l=["ui","workspace","web"];function M(b){if(typeof b=="object"&&b!==null&&b.supported!==!0)return b.description}e.$2l=M,e.$3l=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var D;(function(b){b[b.System=0]="System",b[b.User=1]="User"})(D||(e.ExtensionType=D={}));var P;(function(b){b.WIN32_X64="win32-x64",b.WIN32_IA32="win32-ia32",b.WIN32_ARM64="win32-arm64",b.LINUX_X64="linux-x64",b.LINUX_ARM64="linux-arm64",b.LINUX_ARMHF="linux-armhf",b.ALPINE_X64="alpine-x64",b.ALPINE_ARM64="alpine-arm64",b.DARWIN_X64="darwin-x64",b.DARWIN_ARM64="darwin-arm64",b.WEB="web",b.UNIVERSAL="universal",b.UNKNOWN="unknown",b.UNDEFINED="undefined"})(P||(e.TargetPlatform=P={}));class f{constructor($){this.value=$,this._lower=$.toLowerCase()}static equals($,m){if(typeof $>"u"||$===null)return typeof m>"u"||m===null;if(typeof m>"u"||m===null)return!1;if(typeof $=="string"||typeof m=="string"){const u=typeof $=="string"?$:$.value,l=typeof m=="string"?m:m.value;return S.$2e(u,l)}return $._lower===m._lower}static toKey($){return typeof $=="string"?$.toLowerCase():$._lower}}e.$4l=f;class a{get size(){return this.c.size}constructor($){if(this.c=new Set,$)for(const m of $)this.add(m)}add($){this.c.add(f.toKey($))}delete($){return this.c.delete(f.toKey($))}has($){return this.c.has(f.toKey($))}}e.$5l=a;class g{constructor(){this.c=new Map}clear(){this.c.clear()}delete($){this.c.delete(f.toKey($))}get($){return this.c.get(f.toKey($))}has($){return this.c.has(f.toKey($))}set($,m){this.c.set(f.toKey($),m)}values(){return this.c.values()}forEach($){this.c.forEach($)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$6l=g;function w(b){return y(b)}e.$7l=w;function y(b){return b.contributes&&b.contributes.localizations?b.contributes.localizations.length>0:!1}e.$8l=y;function d(b){return b.contributes&&b.contributes.authentication?b.contributes.authentication.length>0:!1}e.$9l=d;function v(b,$){if($){const m=`onResolveRemoteAuthority:${(0,s.$Uk)($)}`;return!!b.activationEvents?.includes(m)}return!1}e.$0l=v,e.$$l=(0,R.$Oh)("IBuiltinExtensionsScannerService")}),define(te[239],ie([0,1,8,17,22,14,3,2,65,72,32,109,238,58]),function(Q,e,S,R,s,M,D,P,f,a,g,w,y,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$al=e.$_k=e.$$k=e.$0k=e.$9k=e.$8k=e.$7k=e.$6k=e.PersistentConnectionEventType=e.$5k=e.$4k=e.$3k=e.ConnectionType=void 0;const v=30*1e3;var b;(function(F){F[F.Management=1]="Management",F[F.ExtensionHost=2]="ExtensionHost",F[F.Tunnel=3]="Tunnel"})(b||(e.ConnectionType=b={}));function $(F){switch(F){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function m(F){const O=new s.$Xd;return setTimeout(()=>O.cancel(),F),O.token}function u(F,O){if(F.isCancellationRequested||O.isCancellationRequested)return s.CancellationToken.Cancelled;const L=new s.$Xd;return F.onCancellationRequested(()=>L.cancel()),O.onCancellationRequested(()=>L.cancel()),L.token}class l{get didTimeout(){return this.c==="timedout"}constructor(O){this.c="pending",this.d=new P.$Rc,this.promise=new Promise((L,B)=>{this.f=L,this.g=B}),O.isCancellationRequested?this.h():this.d.add(O.onCancellationRequested(()=>this.h()))}registerDisposable(O){this.c==="pending"?this.d.add(O):O.dispose()}h(){this.c==="pending"&&(this.d.dispose(),this.c="timedout",this.g(this.i()))}i(){const O=new Error("Time limit reached");return O.code="ETIMEDOUT",O.syscall="connect",O}resolve(O){this.c==="pending"&&(this.d.dispose(),this.c="resolved",this.f(O))}reject(O){this.c==="pending"&&(this.d.dispose(),this.c="rejected",this.g(O))}}function E(F,O){const L=new l(O);return L.registerDisposable(F.onControlMessage(B=>{const T=JSON.parse(B.toString()),W=N(T);W?L.reject(W):L.resolve(T)})),L.promise}function h(F,O,L,B,T,W,V,ce){const de=new l(ce),ue=a.$Jd.create(!1);return F.info(`Creating a socket (${V})...`),f.mark(`code/willCreateSocket/${W}`),O.connect(L,B,T,V).then(fe=>{de.didTimeout?(f.mark(`code/didCreateSocketError/${W}`),F.info(`Creating a socket (${V}) finished after ${ue.elapsed()} ms, but this is too late and has timed out already.`),fe?.dispose()):(f.mark(`code/didCreateSocketOK/${W}`),F.info(`Creating a socket (${V}) was successful after ${ue.elapsed()} ms.`),de.resolve(fe))},fe=>{f.mark(`code/didCreateSocketError/${W}`),F.info(`Creating a socket (${V}) returned an error after ${ue.elapsed()} ms.`),F.error(fe),de.reject(fe)}),de.promise}function i(F,O){const L=new l(O);return F.then(B=>{L.didTimeout||L.resolve(B)},B=>{L.didTimeout||L.reject(B)}),L.promise}async function c(F,O,L,B){const T=Y(F,O);F.logService.trace(`${T} 1/6. invoking socketFactory.connect().`);let W;try{W=await h(F.logService,F.remoteSocketFactoryService,F.connectTo,(0,d.$Vk)(F),`reconnectionToken=${F.reconnectionToken}&reconnection=${F.reconnectionProtocol?"true":"false"}`,$(O),`renderer-${$(O)}-${F.reconnectionToken}`,B)}catch(fe){throw F.logService.error(`${T} socketFactory.connect() failed or timed out. Error:`),F.logService.error(fe),fe}F.logService.trace(`${T} 2/6. socketFactory.connect() was successful.`);let V,ce;F.reconnectionProtocol?(F.reconnectionProtocol.beginAcceptReconnection(W,null),V=F.reconnectionProtocol,ce=!1):(V=new w.$Ch({socket:W}),ce=!0),F.logService.trace(`${T} 3/6. sending AuthRequest control message.`);const de=await i(F.signService.createNewMessage((0,g.$eg)()),B),ue={type:"auth",auth:F.connectionToken||"00000000000000000000",data:de.data};V.sendControl(R.$be.fromString(JSON.stringify(ue)));try{const fe=await E(V,u(B,m(1e4)));if(fe.type!=="sign"||typeof fe.data!="string"){const Ae=new Error("Unexpected handshake message");throw Ae.code="VSCODE_CONNECTION_ERROR",Ae}if(F.logService.trace(`${T} 4/6. received SignRequest control message.`),!await i(F.signService.validate(de,fe.signedData),B)){const Ae=new Error("Refused to connect to unsupported server");throw Ae.code="VSCODE_CONNECTION_ERROR",Ae}const be=await i(F.signService.sign(fe.data),B),pe={type:"connectionType",commit:F.commit,signedData:be,desiredConnectionType:O};return L&&(pe.args=L),F.logService.trace(`${T} 5/6. sending ConnectionTypeRequest control message.`),V.sendControl(R.$be.fromString(JSON.stringify(pe))),{protocol:V,ownsProtocol:ce}}catch(fe){throw fe&&fe.code==="ETIMEDOUT"&&(F.logService.error(`${T} the handshake timed out. Error:`),F.logService.error(fe)),fe&&fe.code==="VSCODE_CONNECTION_ERROR"&&(F.logService.error(`${T} received error control message when negotiating connection. Error:`),F.logService.error(fe)),ce&&G(V),fe}}async function o(F,O,L,B){const T=Date.now(),W=Y(F,O),{protocol:V,ownsProtocol:ce}=await c(F,O,L,B),de=new l(B);return de.registerDisposable(V.onControlMessage(ue=>{const fe=JSON.parse(ue.toString()),ye=N(fe);ye?(F.logService.error(`${W} received error control message when negotiating connection. Error:`),F.logService.error(ye),ce&&G(V),de.reject(ye)):(F.reconnectionProtocol?.endAcceptReconnection(),F.logService.trace(`${W} 6/6. handshake finished, connection is up and running after ${re(T)}!`),de.resolve({protocol:V,firstMessage:fe}))})),de.promise}async function t(F,O){const{protocol:L}=await o(F,1,void 0,O);return{protocol:L}}async function n(F,O,L){const{protocol:B,firstMessage:T}=await o(F,2,O,L),W=T&&T.debugPort;return{protocol:B,debugPort:W}}async function r(F,O,L){const B=Date.now(),T=Y(F,3),{protocol:W}=await c(F,3,O,L);return F.logService.trace(`${T} 6/6. handshake finished, connection is up and running after ${re(B)}!`),W}async function p(F,O,L){const{connectTo:B,connectionToken:T}=await F.addressProvider.getAddress();return{commit:F.commit,quality:F.quality,connectTo:B,connectionToken:T,reconnectionToken:O,reconnectionProtocol:L,remoteSocketFactoryService:F.remoteSocketFactoryService,signService:F.signService,logService:F.logService}}async function A(F,O,L){return k(F,async B=>{const{protocol:T}=await t(B,s.CancellationToken.None);return new K(F,O,L,B.reconnectionToken,T)})}e.$3k=A;async function C(F,O){return k(F,async L=>{const{protocol:B,debugPort:T}=await n(L,O,s.CancellationToken.None);return new J(F,O,L.reconnectionToken,B,T)})}e.$4k=C;async function k(F,O){for(let B=1;;B++)try{const T=(0,g.$eg)(),W=await p(F,T,null);return await O(W)}catch(T){if(B<5)F.logService.error(`[remote-connection][attempt ${B}] An error occurred in initial connection! Will retry... Error:`),F.logService.error(T);else throw F.logService.error(`[remote-connection][attempt ${B}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),F.logService.error(T),oe.triggerPermanentFailure(0,0,y.$Rk.isHandled(T)),T}}async function I(F,O,L){const B=await p(F,(0,g.$eg)(),null);return await r(B,{host:O,port:L},s.CancellationToken.None)}e.$5k=I;function j(F){return(0,S.$Hg)(O=>new Promise((L,B)=>{const T=setTimeout(L,F*1e3);O.onCancellationRequested(()=>{clearTimeout(T),L()})}))}var U;(function(F){F[F.ConnectionLost=0]="ConnectionLost",F[F.ReconnectionWait=1]="ReconnectionWait",F[F.ReconnectionRunning=2]="ReconnectionRunning",F[F.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",F[F.ConnectionGain=4]="ConnectionGain"})(U||(e.PersistentConnectionEventType=U={}));class z{constructor(O,L){this.reconnectionToken=O,this.millisSinceLastIncomingData=L,this.type=0}}e.$6k=z;class ne{constructor(O,L,B,T){this.reconnectionToken=O,this.millisSinceLastIncomingData=L,this.durationSeconds=B,this.c=T,this.type=1}skipWait(){this.c.cancel()}}e.$7k=ne;class _{constructor(O,L,B){this.reconnectionToken=O,this.millisSinceLastIncomingData=L,this.attempt=B,this.type=2}}e.$8k=_;class ae{constructor(O,L,B){this.reconnectionToken=O,this.millisSinceLastIncomingData=L,this.attempt=B,this.type=4}}e.$9k=ae;class se{constructor(O,L,B,T){this.reconnectionToken=O,this.millisSinceLastIncomingData=L,this.attempt=B,this.handled=T,this.type=3}}e.$0k=se;class oe extends P.$Sc{static triggerPermanentFailure(O,L,B){this._permanentFailure=!0,this.f=O,this.g=L,this.h=B,this.j.forEach(T=>T.D(this.f,this.g,this.h))}static debugTriggerReconnection(){this.j.forEach(O=>O.y())}static debugPauseSocketWriting(){this.j.forEach(O=>O.F())}static{this._permanentFailure=!1}static{this.f=0}static{this.g=0}static{this.h=!1}static{this.j=[]}get n(){return this.c||oe._permanentFailure}constructor(O,L,B,T,W){super(),this.t=O,this.u=L,this.reconnectionToken=B,this.protocol=T,this.w=W,this.m=this.B(new D.$Nd),this.onDidStateChange=this.m.event,this.c=!1,this.r=!1,this.s=!1,this.m.fire(new ae(this.reconnectionToken,0,0)),this.B(T.onSocketClose(V=>{const ce=H(this.t,this.reconnectionToken,!0);V?V.type===0?(this.u.logService.info(`${ce} received socket close event (hadError: ${V.hadError}).`),V.error&&this.u.logService.error(V.error)):(this.u.logService.info(`${ce} received socket close event (wasClean: ${V.wasClean}, code: ${V.code}, reason: ${V.reason}).`),V.event&&this.u.logService.error(V.event)):this.u.logService.info(`${ce} received socket close event.`),this.y()})),this.B(T.onSocketTimeout(V=>{const ce=H(this.t,this.reconnectionToken,!0);this.u.logService.info(`${ce} received socket timeout event (unacknowledgedMsgCount: ${V.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${V.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${V.timeSinceLastReceivedSomeData}).`),this.y()})),oe.j.push(this),this.B((0,P.$Qc)(()=>{const V=oe.j.indexOf(this);V>=0&&oe.j.splice(V,1)})),this.n&&this.D(oe.f,oe.g,oe.h)}dispose(){super.dispose(),this.s=!0}async y(){if(!this.r)try{this.r=!0,await this.z()}finally{this.r=!1}}async z(){if(this.n||this.s)return;const O=H(this.t,this.reconnectionToken,!0);this.u.logService.info(`${O} starting reconnecting loop. You can get more information with the trace log level.`),this.m.fire(new z(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const L=[0,5,5,10,10,10,10,10,30];let B=-1;do{B++;const T=B<L.length?L[B]:L[L.length-1];try{if(T>0){const V=j(T);this.m.fire(new ne(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),T,V)),this.u.logService.info(`${O} waiting for ${T} seconds before reconnecting...`);try{await V}catch{}}if(this.n){this.u.logService.error(`${O} permanent failure occurred while running the reconnecting loop.`);break}this.m.fire(new _(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),B+1)),this.u.logService.info(`${O} resolving connection...`);const W=await p(this.u,this.reconnectionToken,this.protocol);this.u.logService.info(`${O} connecting to ${W.connectTo}...`),await this.G(W,m(v)),this.u.logService.info(`${O} reconnected!`),this.m.fire(new ae(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),B+1));break}catch(W){if(W.code==="VSCODE_CONNECTION_ERROR"){this.u.logService.error(`${O} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this.u.logService.error(W),this.C(this.protocol.getMillisSinceLastIncomingData(),B+1,!1);break}if(B>360){this.u.logService.error(`${O} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this.u.logService.error(W),this.C(this.protocol.getMillisSinceLastIncomingData(),B+1,!1);break}if(y.$Rk.isTemporarilyNotAvailable(W)){this.u.logService.info(`${O} A temporarily not available error occurred while trying to reconnect, will try again...`),this.u.logService.trace(W);continue}if((W.code==="ETIMEDOUT"||W.code==="ENETUNREACH"||W.code==="ECONNREFUSED"||W.code==="ECONNRESET")&&W.syscall==="connect"){this.u.logService.info(`${O} A network error occurred while trying to reconnect, will try again...`),this.u.logService.trace(W);continue}if((0,M.$4)(W)){this.u.logService.info(`${O} A promise cancelation error occurred while trying to reconnect, will try again...`),this.u.logService.trace(W);continue}if(W instanceof y.$Rk){this.u.logService.error(`${O} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this.u.logService.error(W),this.C(this.protocol.getMillisSinceLastIncomingData(),B+1,y.$Rk.isHandled(W));break}this.u.logService.error(`${O} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this.u.logService.error(W),this.C(this.protocol.getMillisSinceLastIncomingData(),B+1,!1);break}}while(!this.n&&!this.s)}C(O,L,B){this.w?oe.triggerPermanentFailure(O,L,B):this.D(O,L,B)}D(O,L,B){this.m.fire(new se(this.reconnectionToken,O,L,B)),G(this.protocol)}F(){this.protocol.pauseSocketWriting()}}e.$$k=oe;class K extends oe{constructor(O,L,B,T,W){super(1,O,T,W,!0),this.client=this.B(new w.$Ah(W,{remoteAuthority:L,clientId:B},O.ipcLogger))}async G(O,L){await t(O,L)}}e.$_k=K;class J extends oe{constructor(O,L,B,T,W){super(2,O,B,T,!1),this.H=L,this.debugPort=W}async G(O,L){await n(O,this.H,L)}}e.$al=J;function G(F){try{F.acceptDisconnect();const O=F.getSocket();F.dispose(),O.dispose()}catch(O){(0,M.$1)(O)}}function N(F){if(F&&F.type==="error"){const O=new Error(`Connection error: ${F.reason}`);return O.code="VSCODE_CONNECTION_ERROR",O}return null}function q(F,O){for(;F.length<O;)F+=" ";return F}function X(F,O){return`[remote-connection][${q($(F),13)}][${O.substr(0,5)}\u2026]`}function H(F,O,L){return`${X(F,O)}[${L?"reconnect":"initial"}]`}function Y(F,O){return`${H(O,F.reconnectionToken,!!F.reconnectionProtocol)}[${F.connectTo}]`}function re(F){return`${Date.now()-F} ms`}}),define(te[240],ie([0,1,2,6]),function(Q,e,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zk=e.$Yk=void 0,e.$Yk=(0,R.$Oh)("remoteSocketFactoryService");class s{constructor(){this.a={}}register(D,P){return this.a[D]??=[],this.a[D].push(P),(0,S.$Qc)(()=>{const f=this.a[D]?.indexOf(P);typeof f=="number"&&f>=0&&this.a[D]?.splice(f,1)})}b(D){return(this.a[D.type]||[]).find(f=>f.supports(D))}connect(D,P,f,a){const g=this.b(D);if(!g)throw new Error(`No socket factory found for ${D}`);return g.connect(D,P,f,a)}}e.$Zk=s}),define(te[241],ie([0,1,28,47,21,113]),function(Q,e,S,R,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$O6b=void 0;let D;async function P(d=!1){return(D===void 0||d)&&(D=f()),D}e.$O6b=P;async function f(){const d=a();if(d===void 0)return!1;if(d>=22e3){const v=w();if(v)return new Promise(b=>{R.execFile(v,["--status"],$=>b(!$))})}else{const v=y();if(v)try{if((await s.Promises.stat(v)).isFile())return!0}catch{}}return!1}function a(){const d=/(\d+)\.(\d+)\.(\d+)/g.exec(S.release());if(d)return parseInt(d[3])}function g(d){const v=process.env.SystemRoot;if(v){const b=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");return M.join(v,b?"Sysnative":"System32",d)}}function w(){return g("wsl.exe")}function y(){return g("lxss\\LxssManager.dll")}}),define(te[50],ie([0,1,17,14,2,181,57,6,5,43]),function(Q,e,S,R,s,M,D,P,f,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xo=e.$Wo=e.$Vo=e.$Uo=e.$To=e.$So=e.$Ro=e.$Qo=void 0,e.$Qo=(0,P.$Oh)("requestService");class g{constructor(h){this.b=h}toJSON(){if(!this.a){const h=Object.create(null);for(const i in this.b)i.toLowerCase()==="authorization"||i.toLowerCase()==="proxy-authorization"?h[i]="*****":h[i]=this.b[i];this.a=h}return this.a}}class w extends s.$Sc{constructor(h){super(),this.b=0,this.a=h.createLogger("network",{name:(0,M.localize)(0,null),when:f.$nj.isEqualTo((0,f.$lj)(f.LogLevel.Trace)).serialize()})}async c(h,i,c){const o=`${h} #${++this.b}: ${i.url}`;this.a.trace(`${o} - begin`,i.type,new g(i.headers??{}));try{const t=await c();return this.a.trace(`${o} - end`,i.type,t.res.statusCode,t.res.headers),t}catch(t){throw this.a.error(`${o} - error`,i.type,(0,R.$0)(t)),t}}}e.$Ro=w;function y(E){return E.res.statusCode&&E.res.statusCode>=200&&E.res.statusCode<300||E.res.statusCode===1223}e.$So=y;function d(E){return E.res.statusCode===204}e.$To=d;async function v(E){return d(E)?null:(await(0,S.$ne)(E.stream)).toString()}e.$Uo=v;async function b(E){if(!y(E))throw new Error("Server returned "+E.res.statusCode);return v(E)}e.$Vo=b;async function $(E){if(!y(E))throw new Error("Server returned "+E.res.statusCode);if(d(E))return null;const i=(await(0,S.$ne)(E.stream)).toString();try{return JSON.parse(i)}catch(c){throw c.message+=`:
`+i,c}}e.$Wo=$;function m(E){l(E)}e.$Xo=m;let u;function l(E){const h=a.$dn.as(D.$in.Configuration),i=u;u={id:"http",order:15,title:(0,M.localize)(1,null),type:"object",scope:E,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks|socks4a?|socks5h?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,M.localize)(2,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,M.localize)(3,null),restricted:!0},"http.proxyKerberosServicePrincipal":{type:"string",markdownDescription:(0,M.localize)(4,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,M.localize)(5,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,M.localize)(6,null),(0,M.localize)(7,null),(0,M.localize)(8,null),(0,M.localize)(9,null)],default:"override",description:(0,M.localize)(10,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,M.localize)(11,null),restricted:!0},"http.experimental.systemCertificatesV2":{type:"boolean",tags:["experimental"],default:!1,description:(0,M.localize)(12,null),restricted:!0}}},h.updateConfigurations({add:[u],remove:i?[i]:[]})}l(1)}),define(te[242],ie([0,1,17,22]),function(Q,e,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uq=e.$Tq=void 0;class s{constructor(P){this.a=P}listen(P,f){throw new Error("Invalid listen")}call(P,f,a,g=R.CancellationToken.None){switch(f){case"request":return this.a.request(a[0],g).then(async({res:w,stream:y})=>{const d=await(0,S.$ne)(y);return[{statusCode:w.statusCode,headers:w.headers},d]});case"resolveProxy":return this.a.resolveProxy(a[0])}throw new Error("Invalid call")}}e.$Tq=s;class M{constructor(P){this.a=P}async request(P,f){const[a,g]=await this.a.call("request",[P],f);return{res:a,stream:(0,S.$pe)(g)}}async resolveProxy(P){return this.a.call("resolveProxy",[P])}}e.$Uq=M}),define(te[243],ie([0,1,244,12]),function(Q,e,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vq=void 0;function s(D,P){return D.protocol==="http:"?P.HTTP_PROXY||P.http_proxy||null:D.protocol==="https:"&&(P.HTTPS_PROXY||P.https_proxy||P.HTTP_PROXY||P.http_proxy)||null}async function M(D,P,f={}){const a=(0,S.parse)(D),g=f.proxyUrl||s(a,P);if(!g)return null;const w=(0,S.parse)(g);if(!/^https?:$/.test(w.protocol||""))return null;const y={host:w.hostname||"",port:w.port||(w.protocol==="https"?"443":"80"),auth:w.auth,rejectUnauthorized:(0,R.$Ef)(f.strictSSL)?f.strictSSL:!0};return a.protocol==="http:"?new(await new Promise((d,v)=>{Q(["http-proxy-agent"],d,v)}))(y):new(await new Promise((d,v)=>{Q(["https-proxy-agent"],d,v)}))(y)}e.$Vq=M}),define(te[245],ie([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$a7b=e.$_6b=e.$$6b=void 0,e.$$6b={exit:"vscode:electron-main->shared-process=exit",ipcReady:"vscode:shared-process->electron-main=ipc-ready",initDone:"vscode:shared-process->electron-main=init-done"},e.$_6b={request:"vscode:createSharedProcessChannelConnection",response:"vscode:createSharedProcessChannelConnectionResult"},e.$a7b={request:"vscode:createSharedProcessRawConnection",response:"vscode:createSharedProcessRawConnectionResult"}}),define(te[93],ie([0,1,47,9,182,22,49,14,4,32,108,62,8,138]),function(Q,e,S,R,s,M,D,P,f,a,g,w,y,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rl=void 0;let v;async function b(m,u,l,E){return l["force-disable-user-env"]?(u.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):f.$j?(u.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,w.$Ll)(E)&&!l["force-user-env"]?(u.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,w.$Ll)(E)?u.trace("resolveShellEnv(): running (--force-user-env)"):u.trace("resolveShellEnv(): running (macOS/Linux)"),v||(v=y.Promises.withAsyncBody(async(h,i)=>{const c=new M.$Xd;let o=1e4;const t=m.getValue("application.shellEnvironmentResolutionTimeout");typeof t=="number"&&(o=(0,d.$Ml)(t,1,120)*1e3);const n=setTimeout(()=>{c.dispose(!0),i(new Error((0,s.localize)(0,null)))},o);try{h(await $(u,c.token))}catch(r){!(0,P.$4)(r)&&!c.token.isCancellationRequested?i(new Error((0,s.localize)(1,null,(0,D.$zi)(r)))):h({})}finally{clearTimeout(n),c.dispose()}})),v)}e.$Rl=b;async function $(m,u){const l=process.env.ELECTRON_RUN_AS_NODE;m.trace("getUnixShellEnvironment#runAsNode",l);const E=process.env.ELECTRON_NO_ATTACH_CONSOLE;m.trace("getUnixShellEnvironment#noAttach",E);const h=(0,a.$eg)().replace(/-/g,"").substr(0,12),i=new RegExp(h+"({.*})"+h),c={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1",VSCODE_RESOLVING_ENVIRONMENT:"1"};m.trace("getUnixShellEnvironment#env",c);const o=await(0,g.$Bl)(f.OS,c);return m.trace("getUnixShellEnvironment#shell",o),new Promise((t,n)=>{if(u.isCancellationRequested)return n(new P.$5);const r=(0,R.$nc)(o);let p,A;const C=process.versions.electron&&process.versions["microsoft-build"]?"--ms-enable-electron-run-as-node":"";/^pwsh(-preview)?$/.test(r)?(p=`& '${process.execPath}' ${C} -p '''${h}'' + JSON.stringify(process.env) + ''${h}'''`,A=["-Login","-Command"]):r==="nu"?(p=`^'${process.execPath}' ${C} -p '"${h}" + JSON.stringify(process.env) + "${h}"'`,A=["-i","-l","-c"]):(p=`'${process.execPath}' ${C} -p '"${h}" + JSON.stringify(process.env) + "${h}"'`,r==="tcsh"||r==="csh"?A=["-ic"]:A=["-i","-l","-c"]),m.trace("getUnixShellEnvironment#spawn",JSON.stringify(A),p);const k=(0,S.spawn)(o,[...A,p],{detached:!0,stdio:["ignore","pipe","pipe"],env:c});u.onCancellationRequested(()=>(k.kill(),n(new P.$5))),k.on("error",U=>{m.error("getUnixShellEnvironment#errorChildProcess",(0,D.$zi)(U)),n(U)});const I=[];k.stdout.on("data",U=>I.push(U));const j=[];k.stderr.on("data",U=>j.push(U)),k.on("close",(U,z)=>{const ne=Buffer.concat(I).toString("utf8");m.trace("getUnixShellEnvironment#raw",ne);const _=Buffer.concat(j).toString("utf8");if(_.trim()&&m.trace("getUnixShellEnvironment#stderr",_),U||z)return n(new Error((0,s.localize)(2,null,U,z)));const ae=i.exec(ne),se=ae?ae[1]:"{}";try{const oe=JSON.parse(se);l?oe.ELECTRON_RUN_AS_NODE=l:delete oe.ELECTRON_RUN_AS_NODE,E?oe.ELECTRON_NO_ATTACH_CONSOLE=E:delete oe.ELECTRON_NO_ATTACH_CONSOLE,delete oe.VSCODE_RESOLVING_ENVIRONMENT,delete oe.XDG_RUNTIME_DIR,m.trace("getUnixShellEnvironment#result",oe),t(oe)}catch(oe){m.error("getUnixShellEnvironment#errorCaught",(0,D.$zi)(oe)),n(oe)}})})}}),define(te[246],ie([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_2b=void 0;class S{constructor(){this.b=new Map}static{this.a=1}async createNewMessage(s){try{const M=await this.c();if(M){const D=String(S.a++);return this.b.set(D,M),{id:D,data:M.createNewMessage(s)}}}catch{}return{id:"",data:s}}async validate(s,M){if(!s.id)return!0;const D=this.b.get(s.id);if(!D)return!1;this.b.delete(s.id);try{return D.validate(M)==="ok"}catch{return!1}finally{D.dispose?.()}}async sign(s){try{return await this.d(s)}catch{}return s}}e.$_2b=S}),define(te[94],ie([0,1,6]),function(Q,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2k=e.$1k=void 0,e.$1k="signService",e.$2k=(0,S.$Oh)(e.$1k)}),define(te[247],ie([0,1,246]),function(Q,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Z7b=void 0;class R extends S.$_2b{c(){return this.h().then(M=>new M.validator)}d(M){return this.h().then(D=>new D.signer().sign(M))}h(){return new Promise((M,D)=>Q(["vsda"],M,D))}}e.$Z7b=R}),define(te[34],ie([0,1,6]),function(Q,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rN=e.$qN=void 0,e.$qN=(0,S.$Oh)("stateReadService"),e.$rN=(0,S.$Oh)("stateService")}),define(te[121],ie([0,1,8,17,2,12,36,16,5]),function(Q,e,S,R,s,M,D,P,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uN=e.$tN=e.$sN=e.SaveStrategy=void 0;var a;(function(d){d[d.IMMEDIATE=0]="IMMEDIATE",d[d.DELAYED=1]="DELAYED"})(a||(e.SaveStrategy=a={}));class g extends s.$Sc{constructor(v,b,$,m){super(),this.h=v,this.j=$,this.m=m,this.a=Object.create(null),this.b="",this.f=void 0,this.g=void 0,this.c=b===0?void 0:this.B(new S.$Rg(100))}init(){return this.f||(this.f=this.n()),this.f}async n(){try{this.b=(await this.m.readFile(this.h)).value.toString(),this.a=JSON.parse(this.b)}catch(v){v.fileOperationResult!==1&&this.j.error(v)}}getItem(v,b){const $=this.a[v];return(0,M.$Hf)($)?b:$}setItem(v,b){this.setItems([{key:v,data:b}])}setItems(v){let b=!1;for(const{key:$,data:m}of v)this.a[$]!==m&&((0,M.$Hf)(m)?(0,M.$Ff)(this.a[$])||(this.a[$]=void 0,b=!0):(this.a[$]=m,b=!0));b&&this.r()}removeItem(v){(0,M.$Ff)(this.a[v])||(this.a[v]=void 0,this.r())}async r(){if(!this.g)return this.c?this.c.trigger(()=>this.s()):this.s()}async s(){if(!this.f)return;await this.f;const v=JSON.stringify(this.a,null,4);if(v!==this.b)try{await this.m.writeFile(this.h,R.$be.fromString(v),{atomic:{postfix:".vsctmp"}}),this.b=v}catch(b){this.j.error(b)}}async close(){return this.g||(this.g=this.c?this.c.trigger(()=>this.s(),0):this.s()),this.g}}e.$sN=g;let w=class extends s.$Sc{constructor(v,b,$,m){super(),this.a=this.B(new g(b.stateResource,v,$,m))}async init(){await this.a.init()}getItem(v,b){return this.a.getItem(v,b)}};e.$tN=w,e.$tN=w=ke([ee(1,D.$Vh),ee(2,f.$9i),ee(3,P.$0j)],w);class y extends w{setItem(v,b){this.a.setItem(v,b)}setItems(v){this.a.setItems(v)}removeItem(v){this.a.removeItem(v)}close(){return this.a.close()}}e.$uN=y}),define(te[122],ie([0,1,4,35,32]),function(Q,e,S,R,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$go=e.$fo=void 0;function M(f){if(S.$u===2&&/^penguin(\.|$)/i.test(f))return"chromebook"}function D(f,a,g,w,y,d,v,b){const $=Object.create(null);$["common.machineId"]=d,$.sessionID=(0,s.$eg)()+Date.now(),$.commitHash=w,$.version=y,$["common.platformVersion"]=(f||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),$["common.platform"]=(0,S.$i)(S.$u),$["common.nodePlatform"]=R.$dc,$["common.nodeArch"]=g,$["common.product"]=b||"desktop",v&&($["common.msftInternal"]=v);let m=0;const u=Date.now();Object.defineProperties($,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-u,enumerable:!0},"common.sequence":{get:()=>m++,enumerable:!0}}),S.$m&&($["common.snap"]="true");const l=M(a);return l&&($["common.platformDetail"]=l),$}e.$fo=D;function P(f){const a=R.env.USERDNSDOMAIN;if(!a)return!1;const g=a.toLowerCase();return f.some(w=>g===w)}e.$go=P}),define(te[26],ie([0,1,6]),function(Q,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$kl=e.$jl=e.$il=e.$hl=e.$gl=e.$fl=e.$el=e.$dl=e.$cl=e.$bl=void 0,e.$bl=(0,S.$Oh)("telemetryService"),e.$cl=(0,S.$Oh)("customEndpointTelemetryService"),e.$dl="telemetry.currentSessionDate",e.$el="telemetry.firstSessionDate",e.$fl="telemetry.lastSessionDate",e.$gl="telemetry.machineId",e.$hl="telemetry",e.$il="telemetry.telemetryLevel",e.$jl="telemetry.enableCrashReporter",e.$kl="telemetry.enableTelemetry";var R;(function(M){M[M.NONE=0]="NONE",M[M.CRASH=1]="CRASH",M[M.ERROR=2]="ERROR",M[M.USAGE=3]="USAGE"})(R||(e.TelemetryLevel=R={}));var s;(function(M){M.OFF="off",M.CRASH="crash",M.ERROR="error",M.ON="all"})(s||(e.TelemetryConfiguration=s={}))}),define(te[248],ie([0,1,28,8,44,13,9,4,7,86,21,107,90,16,24,26]),function(Q,e,S,R,s,M,D,P,f,a,g,w,y,d,v,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Er=e.$Dr=e.$Cr=e.$Br=void 0;const $=new Map;async function m(i,c){const o=`${i}::${c.join(":")}`,t=$.get(o);if(t)return t;const n=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.ya?ml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}],r=new Map,p=new Map,A=2e4;function C(I,j,U,z){const ne=j.substring(I.length+1);return R.Promises.withAsyncBody(async _=>{let ae;try{ae=await g.Promises.readdir(j,{withFileTypes:!0})}catch{_();return}if(z.count>=A){z.count+=ae.length,z.maxReached=!0,_();return}let se=ae.length;if(se===0){_();return}let oe=ae;z.count+ae.length>A&&(z.maxReached=!0,se=A-z.count,oe=ae.slice(0,se)),z.count+=ae.length;for(const K of oe)if(K.isDirectory()){if(U.includes(K.name)||await C(I,(0,D.$jc)(j,K.name),U,z),--se===0){_();return}}else{const J=K.name.lastIndexOf(".");if(J>=0){const G=K.name.substring(J+1);G&&r.set(G,(r.get(G)??0)+1)}for(const G of n)G.relativePathPattern?.test(ne)!==!1&&G.filePattern.test(K.name)&&p.set(G.tag,(p.get(G.tag)??0)+1);if(--se===0){_();return}}})}const k=R.Promises.withAsyncBody(async I=>{const j={count:0,maxReached:!1};await C(i,i,c,j);const U=await E(i);I({configFiles:u(p),fileTypes:u(r),fileCount:j.count,maxFilesReached:j.maxReached,launchConfigFiles:U})});return $.set(o,k),k}e.$Br=m;function u(i){return Array.from(i.entries(),([c,o])=>({name:c,count:o})).sort((c,o)=>o.count-c.count)}function l(){const i={os:`${S.type()} ${S.arch()} ${S.release()}`,memory:`${(S.totalmem()/d.$Fk.GB).toFixed(2)}GB (${(S.freemem()/d.$Fk.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(a.$Pm.value()*100)}%`},c=S.cpus();return c&&c.length>0&&(i.cpus=`${c[0].model} (${c.length} x ${c[0].speed})`),i}e.$Cr=l;async function E(i){try{const c=new Map,o=(0,D.$jc)(i,".vscode","launch.json"),t=await g.Promises.readFile(o),n=[],r=(0,s.$Tm)(t.toString(),n);if(n.length)return console.log(`Unable to parse ${o}`),[];if((0,s.$3m)(r)==="object"&&r.configurations)for(const p of r.configurations){const A=p.type;A&&(c.has(A)?c.set(A,c.get(A)+1):c.set(A,1))}return u(c)}catch{return[]}}e.$Dr=E;let h=class{constructor(c,o){this.c=c,this.d=o}f(c){const o=[];return o.push(`OS Version:       ${c.os}`),o.push(`CPUs:             ${c.cpus}`),o.push(`Memory (System):  ${c.memory}`),o.push(`VM:               ${c.vmHint}`),o.join(`
`)}g(c){const o=[];o.push(`Version:          ${this.d.nameShort} ${this.d.version} (${this.d.commit||"Commit unknown"}, ${this.d.date||"Date unknown"})`),o.push(`OS Version:       ${S.type()} ${S.arch()} ${S.release()}`);const t=S.cpus();return t&&t.length>0&&o.push(`CPUs:             ${t[0].model} (${t.length} x ${t[0].speed})`),o.push(`Memory (System):  ${(S.totalmem()/d.$Fk.GB).toFixed(2)}GB (${(S.freemem()/d.$Fk.GB).toFixed(2)}GB free)`),P.$j||o.push(`Load (avg):       ${S.loadavg().map(n=>Math.round(n)).join(", ")}`),o.push(`VM:               ${Math.round(a.$Pm.value()*100)}%`),o.push(`Screen Reader:    ${c.screenReader?"yes":"no"}`),o.push(`Process Argv:     ${c.mainArguments.join(" ")}`),o.push(`GPU Status:       ${this.j(c.gpuFeatureStatus)}`),o.join(`
`)}async getPerformanceInfo(c,o){return Promise.all([(0,w.$Ar)(c.mainPID),this.k(c)]).then(async t=>{let[n,r]=t,p=this.m(c,n);return o.forEach(A=>{if((0,y.$pm)(A))p+=`
${A.errorMessage}`,r+=`
${A.errorMessage}`;else if(p+=`

Remote: ${A.hostName}`,A.processes&&(p+=`
${this.m(c,A.processes)}`),A.workspaceMetadata){r+=`
|  Remote: ${A.hostName}`;for(const C of Object.keys(A.workspaceMetadata)){const k=A.workspaceMetadata[C];let I=`${k.fileCount} files`;k.maxFilesReached&&(I=`more than ${I}`),r+=`|    Folder (${C}): ${I}`,r+=this.h(k)}}}),{processInfo:p,workspaceInfo:r}})}async getSystemInfo(c,o){const{memory:t,vmHint:n,os:r,cpus:p}=l(),A={os:r,memory:t,cpus:p,vmHint:n,processArgs:`${c.mainArguments.join(" ")}`,gpuStatus:c.gpuFeatureStatus,screenReader:`${c.screenReader?"yes":"no"}`,remoteData:o};return P.$j||(A.load=`${S.loadavg().map(C=>Math.round(C)).join(", ")}`),P.$l&&(A.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(A)}async getDiagnostics(c,o){const t=[];return(0,w.$Ar)(c.mainPID).then(async n=>(t.push(""),t.push(this.g(c)),t.push(""),t.push(this.m(c,n)),c.windows.some(r=>r.folderURIs&&r.folderURIs.length>0&&!r.remoteAuthority)&&(t.push(""),t.push("Workspace Stats: "),t.push(await this.k(c))),o.forEach(r=>{if((0,y.$pm)(r))t.push(`
${r.errorMessage}`);else if(t.push(`

`),t.push(`Remote:           ${r.hostName}`),t.push(this.f(r.machineInfo)),r.processes&&t.push(this.m(c,r.processes)),r.workspaceMetadata)for(const p of Object.keys(r.workspaceMetadata)){const A=r.workspaceMetadata[p];let C=`${A.fileCount} files`;A.maxFilesReached&&(C=`more than ${C}`),t.push(`Folder (${p}): ${C}`),t.push(this.h(A))}}),t.push(""),t.push(""),t.join(`
`)))}h(c){const o=[];let n=0;const r=(k,I)=>{const j=` ${k}(${I})`;n+j.length>60?(o.push(p),p="|                 ",n=p.length):n+=j.length,p+=j};let p="|      File types:";const A=10,C=c.fileTypes.length>A?A:c.fileTypes.length;for(let k=0;k<C;k++){const I=c.fileTypes[k];r(I.name,I.count)}if(o.push(p),c.configFiles.length>=0&&(p="|      Conf files:",n=0,c.configFiles.forEach(k=>{r(k.name,k.count)}),o.push(p)),c.launchConfigFiles.length>0){let k="|      Launch Configs:";c.launchConfigFiles.forEach(I=>{const j=I.count>1?` ${I.name}(${I.count})`:` ${I.name}`;k+=j}),o.push(k)}return o.join(`
`)}j(c){const o=Math.max(...Object.keys(c).map(t=>t.length));return Object.keys(c).map(t=>`${t}:  ${" ".repeat(o-t.length)}  ${c[t]}`).join(`
                  `)}k(c){const o=[],t=[];return c.windows.forEach(n=>{n.folderURIs.length===0||n.remoteAuthority||(o.push(`|  Window (${n.title})`),n.folderURIs.forEach(r=>{const p=f.URI.revive(r);if(p.scheme===M.Schemas.file){const A=p.fsPath;t.push(m(A,["node_modules",".git"]).then(C=>{let k=`${C.fileCount} files`;C.maxFilesReached&&(k=`more than ${k}`),o.push(`|    Folder (${(0,D.$nc)(A)}): ${k}`),o.push(this.h(C))}).catch(C=>{o.push(`|      Error: Unable to collect workspace stats for folder ${A} (${C.toString()})`)}))}else o.push(`|    Folder (${p.toString()}): Workspace stats not available.`)}))}),Promise.all(t).then(n=>o.join(`
`)).catch(n=>`Unable to collect workspace stats: ${n}`)}m(c,o){const t=new Map;c.windows.forEach(r=>t.set(r.pid,`window [${r.id}] (${r.title})`)),c.pidToNames.forEach(({pid:r,name:p})=>t.set(r,p));const n=[];return n.push("CPU %	Mem MB	   PID	Process"),o&&this.n(c.mainPID,t,n,o,0),n.join(`
`)}n(c,o,t,n,r){const p=r===0;let A;p?A=n.pid===c?`${this.d.applicationName} main`:"remote agent":o.has(n.pid)?A=o.get(n.pid):A=`${"  ".repeat(r)} ${n.name}`;const C=process.platform==="win32"?n.mem:S.totalmem()*(n.mem/100);t.push(`${n.load.toFixed(0).padStart(5," ")}	${(C/d.$Fk.MB).toFixed(0).padStart(6," ")}	${n.pid.toFixed(0).padStart(6," ")}	${A}`),Array.isArray(n.children)&&n.children.forEach(k=>this.n(c,o,t,k,r+1))}async getWorkspaceFileExtensions(c){const o=new Set;for(const{uri:t}of c.folders){const n=f.URI.revive(t);if(n.scheme!==M.Schemas.file)continue;const r=n.fsPath;try{(await m(r,["node_modules",".git"])).fileTypes.forEach(A=>o.add(A.name))}catch{}}return{extensions:[...o]}}async reportWorkspaceStats(c){for(const{uri:o}of c.folders){const t=f.URI.revive(o);if(t.scheme!==M.Schemas.file)continue;const n=t.fsPath;try{const r=await m(n,["node_modules",".git"]);this.c.publicLog2("workspace.stats",{"workspace.id":c.telemetryId,rendererSessionId:c.rendererSessionId}),r.fileTypes.forEach(p=>{this.c.publicLog2("workspace.stats.file",{rendererSessionId:c.rendererSessionId,type:p.name,count:p.count})}),r.launchConfigFiles.forEach(p=>{this.c.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:c.rendererSessionId,type:p.name,count:p.count})}),r.configFiles.forEach(p=>{this.c.publicLog2("workspace.stats.configFiles",{rendererSessionId:c.rendererSessionId,type:p.name,count:p.count})})}catch{}}}};e.$Er=h,e.$Er=h=ke([ee(0,b.$bl),ee(1,v.$oj)],h)}),define(te[249],ie([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$e7b=e.$d7b=void 0;class S{constructor(M){this.b=M}listen(M,D){throw new Error(`Event not found: ${D}`)}call(M,D,{eventName:P,data:f}){return this.b.forEach(a=>a.log(P,f)),Promise.resolve(null)}}e.$d7b=S;class R{constructor(M){this.b=M}log(M,D){return this.b.call("log",{eventName:M,data:D}).then(void 0,P=>`Failed to log telemetry: ${console.warn(P)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.$e7b=R}),define(te[51],ie([0,1,37,12,3,18,58,122,26]),function(Q,e,S,R,s,M,D,P,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wo=e.$vo=e.$uo=e.$to=e.$so=e.$ro=e.$qo=e.$po=e.$oo=e.$no=e.$mo=e.$lo=e.$ko=e.$jo=e.$io=e.$ho=void 0;class a{constructor(n){this.value=n,this.isTrustedTelemetryValue=!0}}e.$ho=a;class g{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$io=g,e.$jo=new g;class w{async publicLog(n,r,p){}async publicLogError(n,r,p){}}e.$ko=w,e.$lo="telemetry",e.$mo="extensionTelemetryLog",e.$no={log:()=>null,flush:()=>Promise.resolve(null)};function y(t,n){return s.Event.debounce(n.onDidChangeConfiguration,(p,A)=>{const C=p?new Set([...p.affectedKeys,...A.affectedKeys]):A.affectedKeys;return{...A,affectedKeys:C}},1e3,!0)(p=>{p.source!==7&&t.publicLog2("updateConfiguration",{configurationSource:(0,M.$li)(p.source),configurationKeys:Array.from(p.affectedKeys)})})}e.$oo=y;function d(t,n){return!n.isBuilt&&!n.disableTelemetry?!0:!(n.disableTelemetry||!t.enableTelemetry)}e.$po=d;function v(t,n){return n.extensionTestsLocationURI?!0:!(n.isBuilt||n.disableTelemetry||t.enableTelemetry&&t.aiConfig?.ariaKey)}e.$qo=v;function b(t){const n=t.getValue(f.$il),r=t.getValue(f.$jl);if(t.getValue(f.$kl)===!1||r===!1)return 0;switch(n??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.$ro=b;function $(t){const n={},r={},p={};l(t,p);for(let A in p){A=A.length>150?A.substr(A.length-149):A;const C=p[A];typeof C=="number"?r[A]=C:typeof C=="boolean"?r[A]=C?1:0:typeof C=="string"?(C.length>8192&&console.warn(`Telemetry property: ${A} has been trimmed to 8192, the original length is ${C.length}`),n[A]=C.substring(0,8191)):typeof C<"u"&&C!==null&&(n[A]=C)}return{properties:n,measurements:r}}e.$so=$;const m=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function u(t){if(!t)return"none";const n=(0,D.$Uk)(t);return m.has(n)?n:"other"}e.$to=u;function l(t,n,r=0,p){if(t)for(const A of Object.getOwnPropertyNames(t)){const C=t[A],k=p?p+A:A;Array.isArray(C)?n[k]=(0,S.$9m)(C):C instanceof Date?n[k]=C.toISOString():(0,R.$Af)(C)?r<2?l(C,n,r+1,k+"."):n[k]=(0,S.$9m)(C):n[k]=C}}function E(t,n){const r=t.msftInternalDomains||[],p=n.getValue("telemetry.internalTesting");return(0,P.$go)(r)||p}e.$uo=E;function h(t){return[t.appRoot,t.extensionsPath,t.userHome.fsPath,t.tmpDir.fsPath,t.userDataPath]}e.$vo=h;function i(t,n){if(!t||!t.includes("/")&&!t.includes("\\"))return t;let r=t;const p=[];for(const I of n)for(;;){const j=I.exec(t);if(!j)break;p.push([j.index,I.lastIndex])}const A=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,C=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let k=0;for(r="";;){const I=C.exec(t);if(!I)break;const j=p.some(([U,z])=>I.index<z&&U<C.lastIndex);!A.test(I[0])&&!j&&(r+=t.substring(k,I.index)+"<REDACTED: user-file-path>",k=C.lastIndex)}return k<t.length&&(r+=t.substr(k)),r}function c(t){if(!t)return t;const n=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const r of n)if(r.regex.test(t))return`<REDACTED: ${r.label}>`;return t}function o(t,n){return(0,S.$6m)(t,r=>{if(r instanceof a||Object.hasOwnProperty.call(r,"isTrustedTelemetryValue"))return r.value;if(typeof r=="string"){let p=r.replaceAll("%20"," ");p=i(p,n);for(const A of n)p=p.replace(A,"");return p=c(p),p}})}e.$wo=o}),define(te[123],ie([0,1,27,117,120,4,7,14,35,51]),function(Q,e,S,R,s,M,D,P,f,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Io=e.$Ho=e.$Go=e.$Fo=e.$Eo=e.$Do=e.$Co=e.$Bo=e.$Ao=e.$zo=e.$yo=e.$xo=void 0;function g(o,t){return o.uuid&&t.uuid?o.uuid===t.uuid:o.id===t.id?!0:(0,S.$We)(o.id,t.id)===0}e.$xo=g;const w=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class y{static create(t){const n=t.manifest?t.manifest.version:t.version,r=t.manifest?t.targetPlatform:t.properties.targetPlatform;return new y(t.identifier,n,r)}static parse(t){const n=w.exec(t);return n&&n[1]&&n[2]?new y({id:n[1]},n[2],n[4]||void 0):null}constructor(t,n,r="undefined"){this.version=n,this.targetPlatform=r,this.id=t.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(t){return t instanceof y?g(this,t)&&this.version===t.version&&this.targetPlatform===t.targetPlatform:!1}}e.$yo=y;const d=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function v(o){const t=d.exec(o);return t&&t[1]?[$(t[1]),t[2]]:[$(o),void 0]}e.$zo=v;function b(o,t){return`${o}.${t}`}e.$Ao=b;function $(o){return o.toLowerCase()}e.$Bo=$;function m(o,t){return $(b(o??s.$Zl,t))}e.$Co=m;function u(o,t){const n=[],r=p=>{for(const A of n)if(A.some(C=>g(t(C),t(p))))return A;return null};for(const p of o){const A=r(p);A?A.push(p):n.push([p])}return n}e.$Do=u;function l(o){return{id:o.identifier.id,name:o.manifest.name,galleryId:null,publisherId:o.publisherId,publisherName:o.manifest.publisher,publisherDisplayName:o.publisherDisplayName,dependencies:o.manifest.extensionDependencies&&o.manifest.extensionDependencies.length>0}}e.$Eo=l;function E(o){return{id:new a.$ho(o.identifier.id),name:new a.$ho(o.name),galleryId:o.identifier.uuid,publisherId:o.publisherId,publisherName:o.publisher,publisherDisplayName:o.publisherDisplayName,isPreReleaseVersion:o.properties.isPreReleaseVersion,dependencies:!!(o.properties.dependencies&&o.properties.dependencies.length>0),isSigned:o.isSigned,...o.telemetryData}}e.$Fo=E,e.$Go=new s.$4l("pprice.better-merge");function h(o,t){const n=[],r=t.manifest.extensionDependencies?.slice(0)??[];for(;r.length;){const p=r.shift();if(p&&n.every(A=>!g(A.identifier,{id:p}))){const A=o.filter(C=>g(C.identifier,{id:p}));A.length===1&&(n.push(A[0]),r.push(...A[0].manifest.extensionDependencies?.slice(0)??[]))}}return n}e.$Ho=h;async function i(o,t){if(!M.$l)return!1;let n;try{n=(await o.readFile(D.URI.file("/etc/os-release"))).value.toString()}catch{try{n=(await o.readFile(D.URI.file("/usr/lib/os-release"))).value.toString()}catch(p){t.debug("Error while getting the os-release file.",(0,P.$0)(p))}}return!!n&&(n.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function c(o,t){const n=await i(o,t),r=(0,R.$3n)(n?"alpine":M.$u,f.$ec);return t.debug("ComputeTargetPlatform:",r),r}e.$Io=c}),define(te[250],ie([0,1,204,51]),function(Q,e,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$o=void 0;async function s(M,D,P,f,a,g,w){const y={"X-Market-Client-Id":`VSCode ${M}`,"User-Agent":`VSCode ${M} (${D.nameShort})`};if((0,R.$po)(D,P)&&(0,R.$ro)(f)===3){const d=await(0,S.$0o)(P,a,g);y["X-Market-User-Id"]=d,y["VSCode-SessionId"]=w.machineId||d}return y}e.$$o=s}),define(te[251],ie([0,1,2,37,4,27,183,18,57,78,24,43,26,51]),function(Q,e,S,R,s,M,D,P,f,a,g,w,y,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yq=void 0;let v=class{static{this.IDLE_START_EVENT_NAME="UserIdleStart"}static{this.IDLE_STOP_EVENT_NAME="UserIdleStop"}constructor(m,u,l){this.k=u,this.l=l,this.d={},this.i=new S.$Rc,this.j=[],this.b=m.appenders,this.c=m.commonProperties??Object.create(null),this.sessionId=this.c.sessionID,this.machineId=this.c["common.machineId"],this.firstSessionDate=this.c["common.firstSessionDate"],this.msftInternal=this.c["common.msftInternal"],this.f=m.piiPaths||[],this.g=3,this.h=!!m.sendErrorTelemetry,this.j=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const E of this.f)this.j.push(new RegExp((0,M.$Fe)(E),"gi")),E.indexOf("\\")>=0&&this.j.push(new RegExp((0,M.$Fe)(E.replace(/\\/g,"/")),"gi"));this.m(),this.i.add(this.k.onDidChangeConfiguration(E=>{(E.affectsConfiguration(y.$il)||E.affectsConfiguration(y.$kl)||E.affectsConfiguration(y.$jl))&&this.m()}))}setExperimentProperty(m,u){this.d[m]=u}m(){let m=(0,d.$ro)(this.k);const u=this.l.enabledTelemetryLevels;if(u){this.h=this.sendErrorTelemetry?u.error:!1;const l=u.usage?3:u.error?2:0;m=Math.min(m,l)}this.g=m}get sendErrorTelemetry(){return this.h}get telemetryLevel(){return this.g}dispose(){this.i.dispose()}n(m,u,l){this.g<u||(l=(0,R.$7m)(l,this.d),l=(0,d.$wo)(l,this.j),l=(0,R.$7m)(l,this.c),this.b.forEach(E=>E.log(m,l)))}publicLog(m,u){this.n(m,3,u)}publicLog2(m,u){this.publicLog(m,u)}publicLogError(m,u){this.h&&this.n(m,2,u)}publicLogError2(m,u){this.publicLogError(m,u)}};e.$Yq=v,e.$Yq=v=ke([ee(1,P.$ii),ee(2,g.$oj)],v);function b(){const $=(0,D.localize)(0,null,a.default.nameLong),m=a.default.privacyStatementUrl?(0,D.localize)(2,null,"https://aka.ms/vscode-telemetry",a.default.privacyStatementUrl):(0,D.localize)(1,null,"https://aka.ms/vscode-telemetry"),u=s.$p?"":(0,D.localize)(3,null),l=(0,D.localize)(4,null),E=(0,D.localize)(5,null),h=(0,D.localize)(6,null),i=(0,D.localize)(7,null),c=`
|       | ${l} | ${E} | ${h} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,o=(0,D.localize)(8,null);return`
${$} ${m} ${u}

&nbsp;

${i}
${c}

&nbsp;

${o}
`}w.$dn.as(f.$in.Configuration).registerConfiguration({id:y.$hl,order:1,type:"object",title:(0,D.localize)(9,null),properties:{[y.$il]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,D.localize)(10,null),(0,D.localize)(11,null),(0,D.localize)(12,null),(0,D.localize)(13,null)],markdownDescription:b(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),w.$dn.as(f.$in.Configuration).registerConfiguration({id:y.$hl,order:110,type:"object",title:(0,D.localize)(14,null),properties:{[y.$kl]:{type:"boolean",markdownDescription:a.default.privacyStatementUrl?(0,D.localize)(16,null,a.default.nameLong,a.default.privacyStatementUrl):(0,D.localize)(15,null,a.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,D.localize)(17,null,`\`#${y.$il}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(te[252],ie([0,1,4,86,26]),function(Q,e,S,R,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$G7b=void 0;async function M(D,P){let f=D.getItem(s.$gl);return(typeof f!="string"||S.$k&&f==="6c9d2bc8f91b89624add29c0abeae7fb42bf539fa1cdb2e3e57cd668fa9bcead")&&(f=await(0,R.$Qm)(P.error.bind(P))),f}e.$G7b=M}),define(te[253],ie([0,1,26,252]),function(Q,e,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$H7b=void 0;async function s(M,D){const P=await(0,R.$G7b)(M,D);return M.setItem(S.$gl,P),P}e.$H7b=s}),define(te[124],ie([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EnvironmentVariableMutatorType=void 0;var S;(function(R){R[R.Replace=1]="Replace",R[R.Append=2]="Append",R[R.Prepend=3]="Prepend"})(S||(e.EnvironmentVariableMutatorType=S={}))}),define(te[254],ie([0,1,4,124]),function(Q,e,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$or=void 0;const s=new Map([[R.EnvironmentVariableMutatorType.Append,"APPEND"],[R.EnvironmentVariableMutatorType.Prepend,"PREPEND"],[R.EnvironmentVariableMutatorType.Replace,"REPLACE"]]);class M{constructor(g){this.collections=g,this.a=new Map,this.b=new Map,g.forEach((w,y)=>{this.d(w,y);const d=w.map.entries();let v=d.next();for(;!v.done;){const b=v.value[1],$=v.value[0];let m=this.a.get($);if(m||(m=[],this.a.set($,m)),m.length>0&&m[0].type===R.EnvironmentVariableMutatorType.Replace){v=d.next();continue}const u={extensionIdentifier:y,value:b.value,type:b.type,scope:b.scope,variable:b.variable,options:b.options};u.scope||delete u.scope,m.unshift(u),v=d.next()}})}async applyToProcessEnvironment(g,w,y){let d;S.$j&&(d={},Object.keys(g).forEach(v=>d[v.toLowerCase()]=v));for(const[v,b]of this.getVariableMap(w)){const $=S.$j&&d[v.toLowerCase()]||v;for(const m of b){const u=y?await y(m.value):m.value;if(m.options?.applyAtProcessCreation??!0)switch(m.type){case R.EnvironmentVariableMutatorType.Append:g[$]=(g[$]||"")+u;break;case R.EnvironmentVariableMutatorType.Prepend:g[$]=u+(g[$]||"");break;case R.EnvironmentVariableMutatorType.Replace:g[$]=u;break}if(m.options?.applyAtShellIntegration??!1){const l=`VSCODE_ENV_${s.get(m.type)}`;g[l]=(g[l]?g[l]+":":"")+v+"="+this.c(u)}}}}c(g){return g.replaceAll(":","\\x3a")}diff(g,w){const y=new Map,d=new Map,v=new Map;if(g.getVariableMap(w).forEach((b,$)=>{const m=this.getVariableMap(w).get($),u=P(b,m);u&&y.set($,u)}),this.getVariableMap(w).forEach((b,$)=>{const m=g.getVariableMap(w).get($),u=P(b,m);u&&v.set($,u)}),this.getVariableMap(w).forEach((b,$)=>{const m=g.getVariableMap(w).get($),u=f(b,m);u&&d.set($,u)}),!(y.size===0&&d.size===0&&v.size===0))return{added:y,changed:d,removed:v}}getVariableMap(g){const w=new Map;for(const y of this.a.values()){const d=y.filter(v=>D(v,g));d.length>0&&w.set(d[0].variable,d)}return w}getDescriptionMap(g){const w=new Map;for(const y of this.b.values()){const d=y.filter(v=>D(v,g,!0));for(const v of d)w.set(v.extensionIdentifier,v.description)}return w}d(g,w){if(!g.descriptionMap)return;const y=g.descriptionMap.entries();let d=y.next();for(;!d.done;){const v=d.value[1],b=d.value[0];let $=this.b.get(b);$||($=[],this.b.set(b,$));const m={extensionIdentifier:w,scope:v.scope,description:v.description};m.scope||delete m.scope,$.push(m),d=y.next()}}}e.$or=M;function D(a,g,w=!1){return a.scope?!!(a.scope.workspaceFolder&&g?.workspaceFolder&&a.scope.workspaceFolder.index===g.workspaceFolder.index):w?g===a.scope:!0}function P(a,g){if(!g)return a;const w=new Set;g.forEach(d=>w.add(d.extensionIdentifier));const y=[];return a.forEach(d=>{w.has(d.extensionIdentifier)||y.push(d)}),y.length===0?void 0:y}function f(a,g){if(!g)return;const w=new Map;g.forEach(d=>w.set(d.extensionIdentifier,d));const y=[];return a.forEach(d=>{const v=w.get(d.extensionIdentifier);v&&(d.type!==v.type||d.value!==v.value||d.scope?.workspaceFolder?.index!==v.scope?.workspaceFolder?.index)&&y.push(v)}),y.length===0?void 0:y}}),define(te[255],ie([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nr=e.$mr=e.$lr=e.$kr=e.$jr=e.$ir=void 0;function S(f){return[...f.entries()]}e.$ir=S;function R(f){return f?[...f.entries()]:[]}e.$jr=R;function s(f){return new Map(f)}e.$kr=s;function M(f){return new Map(f??[])}e.$lr=M;function D(f){return Array.from(f.entries()).map(a=>[a[0],S(a[1].map),R(a[1].descriptionMap)])}e.$mr=D;function P(f){return new Map(f.map(a=>[a[0],{map:s(a[1]),descriptionMap:M(a[2])}]))}e.$nr=P}),define(te[256],ie([0,1,8,22,3,2,5]),function(Q,e,S,R,s,M,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_q=void 0;let P=class extends M.$Sc{constructor(a,g){super(),this.h=g,this.a=0,this.c=new Map,this.f=new Map,this.g=this.B(new s.$Nd),this.onCreateRequest=this.g.event,this.b=a===void 0?15e3:a,this.B((0,M.$Qc)(()=>{for(const w of this.f.values())(0,M.$Nc)(w)}))}createRequest(a){return new Promise((g,w)=>{const y=++this.a;this.c.set(y,g),this.g.fire({requestId:y,...a});const d=new R.$Xd;(0,S.$Ug)(this.b,d.token).then(()=>w(`Request ${y} timed out (${this.b}ms)`)),this.f.set(y,[(0,M.$Qc)(()=>d.cancel())])})}acceptReply(a,g){const w=this.c.get(a);w?(this.c.delete(a),(0,M.$Nc)(this.f.get(a)||[]),this.f.delete(a),w(g)):this.h.warn(`RequestStore#acceptReply was called without receiving a matching request ${a}`)}};e.$_q=P,e.$_q=P=ke([ee(1,D.$9i)],P)}),define(te[125],ie([0,1,6,114,43]),function(Q,e,S,R,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8q=e.$7q=e.$6q=e.TerminalExitReason=e.ShellIntegrationStatus=e.ProfileSource=e.FlowControlConstants=e.LocalReconnectConstants=e.TerminalLocationString=e.TerminalLocation=e.HeartbeatConstants=e.$5q=e.ProcessPropertyType=e.TerminalIpcChannels=e.TitleEventSource=e.WindowsShellType=e.PosixShellType=e.TerminalSettingId=e.TerminalSettingPrefix=e.$4q=void 0,e.$4q=new R.$6i("terminalTabFocusMode",!1,!0);var M;(function(h){h.AutomationProfile="terminal.integrated.automationProfile.",h.DefaultProfile="terminal.integrated.defaultProfile.",h.Profiles="terminal.integrated.profiles."})(M||(e.TerminalSettingPrefix=M={}));var D;(function(h){h.SendKeybindingsToShell="terminal.integrated.sendKeybindingsToShell",h.AutomationProfileLinux="terminal.integrated.automationProfile.linux",h.AutomationProfileMacOs="terminal.integrated.automationProfile.osx",h.AutomationProfileWindows="terminal.integrated.automationProfile.windows",h.ProfilesWindows="terminal.integrated.profiles.windows",h.ProfilesMacOs="terminal.integrated.profiles.osx",h.ProfilesLinux="terminal.integrated.profiles.linux",h.DefaultProfileLinux="terminal.integrated.defaultProfile.linux",h.DefaultProfileMacOs="terminal.integrated.defaultProfile.osx",h.DefaultProfileWindows="terminal.integrated.defaultProfile.windows",h.UseWslProfiles="terminal.integrated.useWslProfiles",h.TabsDefaultColor="terminal.integrated.tabs.defaultColor",h.TabsDefaultIcon="terminal.integrated.tabs.defaultIcon",h.TabsEnabled="terminal.integrated.tabs.enabled",h.TabsEnableAnimation="terminal.integrated.tabs.enableAnimation",h.TabsHideCondition="terminal.integrated.tabs.hideCondition",h.TabsShowActiveTerminal="terminal.integrated.tabs.showActiveTerminal",h.TabsShowActions="terminal.integrated.tabs.showActions",h.TabsLocation="terminal.integrated.tabs.location",h.TabsFocusMode="terminal.integrated.tabs.focusMode",h.MacOptionIsMeta="terminal.integrated.macOptionIsMeta",h.MacOptionClickForcesSelection="terminal.integrated.macOptionClickForcesSelection",h.AltClickMovesCursor="terminal.integrated.altClickMovesCursor",h.CopyOnSelection="terminal.integrated.copyOnSelection",h.EnableMultiLinePasteWarning="terminal.integrated.enableMultiLinePasteWarning",h.DrawBoldTextInBrightColors="terminal.integrated.drawBoldTextInBrightColors",h.FontFamily="terminal.integrated.fontFamily",h.FontSize="terminal.integrated.fontSize",h.LetterSpacing="terminal.integrated.letterSpacing",h.LineHeight="terminal.integrated.lineHeight",h.MinimumContrastRatio="terminal.integrated.minimumContrastRatio",h.TabStopWidth="terminal.integrated.tabStopWidth",h.FastScrollSensitivity="terminal.integrated.fastScrollSensitivity",h.MouseWheelScrollSensitivity="terminal.integrated.mouseWheelScrollSensitivity",h.BellDuration="terminal.integrated.bellDuration",h.FontWeight="terminal.integrated.fontWeight",h.FontWeightBold="terminal.integrated.fontWeightBold",h.CursorBlinking="terminal.integrated.cursorBlinking",h.CursorStyle="terminal.integrated.cursorStyle",h.CursorStyleInactive="terminal.integrated.cursorStyleInactive",h.CursorWidth="terminal.integrated.cursorWidth",h.Scrollback="terminal.integrated.scrollback",h.DetectLocale="terminal.integrated.detectLocale",h.DefaultLocation="terminal.integrated.defaultLocation",h.GpuAcceleration="terminal.integrated.gpuAcceleration",h.TerminalTitleSeparator="terminal.integrated.tabs.separator",h.TerminalTitle="terminal.integrated.tabs.title",h.TerminalDescription="terminal.integrated.tabs.description",h.RightClickBehavior="terminal.integrated.rightClickBehavior",h.Cwd="terminal.integrated.cwd",h.ConfirmOnExit="terminal.integrated.confirmOnExit",h.ConfirmOnKill="terminal.integrated.confirmOnKill",h.EnableBell="terminal.integrated.enableBell",h.CommandsToSkipShell="terminal.integrated.commandsToSkipShell",h.AllowChords="terminal.integrated.allowChords",h.AllowMnemonics="terminal.integrated.allowMnemonics",h.TabFocusMode="terminal.integrated.tabFocusMode",h.EnvMacOs="terminal.integrated.env.osx",h.EnvLinux="terminal.integrated.env.linux",h.EnvWindows="terminal.integrated.env.windows",h.EnvironmentChangesIndicator="terminal.integrated.environmentChangesIndicator",h.EnvironmentChangesRelaunch="terminal.integrated.environmentChangesRelaunch",h.ShowExitAlert="terminal.integrated.showExitAlert",h.SplitCwd="terminal.integrated.splitCwd",h.WindowsEnableConpty="terminal.integrated.windowsEnableConpty",h.WordSeparators="terminal.integrated.wordSeparators",h.EnableFileLinks="terminal.integrated.enableFileLinks",h.UnicodeVersion="terminal.integrated.unicodeVersion",h.LocalEchoLatencyThreshold="terminal.integrated.localEchoLatencyThreshold",h.LocalEchoEnabled="terminal.integrated.localEchoEnabled",h.LocalEchoExcludePrograms="terminal.integrated.localEchoExcludePrograms",h.LocalEchoStyle="terminal.integrated.localEchoStyle",h.EnablePersistentSessions="terminal.integrated.enablePersistentSessions",h.PersistentSessionReviveProcess="terminal.integrated.persistentSessionReviveProcess",h.HideOnStartup="terminal.integrated.hideOnStartup",h.CustomGlyphs="terminal.integrated.customGlyphs",h.PersistentSessionScrollback="terminal.integrated.persistentSessionScrollback",h.InheritEnv="terminal.integrated.inheritEnv",h.ShowLinkHover="terminal.integrated.showLinkHover",h.IgnoreProcessNames="terminal.integrated.ignoreProcessNames",h.AutoReplies="terminal.integrated.autoReplies",h.ShellIntegrationEnabled="terminal.integrated.shellIntegration.enabled",h.ShellIntegrationShowWelcome="terminal.integrated.shellIntegration.showWelcome",h.ShellIntegrationDecorationsEnabled="terminal.integrated.shellIntegration.decorationsEnabled",h.ShellIntegrationCommandHistory="terminal.integrated.shellIntegration.history",h.ShellIntegrationSuggestEnabled="terminal.integrated.shellIntegration.suggestEnabled",h.EnableImages="terminal.integrated.enableImages",h.SmoothScrolling="terminal.integrated.smoothScrolling",h.IgnoreBracketedPasteMode="terminal.integrated.ignoreBracketedPasteMode",h.FocusAfterRun="terminal.integrated.focusAfterRun",h.AccessibleViewPreserveCursorPosition="terminal.integrated.accessibleViewPreserveCursorPosition",h.DeveloperPtyHostLatency="terminal.integrated.developer.ptyHost.latency",h.DeveloperPtyHostStartupDelay="terminal.integrated.developer.ptyHost.startupDelay",h.DevMode="terminal.integrated.developer.devMode"})(D||(e.TerminalSettingId=D={}));var P;(function(h){h.PowerShell="pwsh",h.Bash="bash",h.Fish="fish",h.Sh="sh",h.Csh="csh",h.Ksh="ksh",h.Zsh="zsh"})(P||(e.PosixShellType=P={}));var f;(function(h){h.CommandPrompt="cmd",h.PowerShell="pwsh",h.Wsl="wsl",h.GitBash="gitbash"})(f||(e.WindowsShellType=f={}));var a;(function(h){h[h.Api=0]="Api",h[h.Process=1]="Process",h[h.Sequence=2]="Sequence",h[h.Config=3]="Config"})(a||(e.TitleEventSource=a={}));var g;(function(h){h.LocalPty="localPty",h.PtyHost="ptyHost",h.PtyHostWindow="ptyHostWindow",h.Logger="logger",h.Heartbeat="heartbeat"})(g||(e.TerminalIpcChannels=g={}));var w;(function(h){h.Cwd="cwd",h.InitialCwd="initialCwd",h.FixedDimensions="fixedDimensions",h.Title="title",h.ShellType="shellType",h.HasChildProcesses="hasChildProcesses",h.ResolvedShellLaunchConfig="resolvedShellLaunchConfig",h.OverrideDimensions="overrideDimensions",h.FailedShellIntegrationActivation="failedShellIntegrationActivation",h.UsedShellIntegrationInjection="usedShellIntegrationInjection"})(w||(e.ProcessPropertyType=w={})),e.$5q=(0,S.$Oh)("ptyService");var y;(function(h){h[h.BeatInterval=5e3]="BeatInterval",h[h.ConnectingBeatInterval=2e4]="ConnectingBeatInterval",h[h.FirstWaitMultiplier=1.2]="FirstWaitMultiplier",h[h.SecondWaitMultiplier=1]="SecondWaitMultiplier",h[h.CreateProcessTimeout=5e3]="CreateProcessTimeout"})(y||(e.HeartbeatConstants=y={}));var d;(function(h){h[h.Panel=1]="Panel",h[h.Editor=2]="Editor"})(d||(e.TerminalLocation=d={}));var v;(function(h){h.TerminalView="view",h.Editor="editor"})(v||(e.TerminalLocationString=v={}));var b;(function(h){h[h.GraceTime=6e4]="GraceTime",h[h.ShortGraceTime=6e3]="ShortGraceTime"})(b||(e.LocalReconnectConstants=b={}));var $;(function(h){h[h.HighWatermarkChars=1e5]="HighWatermarkChars",h[h.LowWatermarkChars=5e3]="LowWatermarkChars",h[h.CharCountAckSize=5e3]="CharCountAckSize"})($||(e.FlowControlConstants=$={}));var m;(function(h){h.GitBash="Git Bash",h.Pwsh="PowerShell"})(m||(e.ProfileSource=m={}));var u;(function(h){h[h.Off=0]="Off",h[h.FinalTerm=1]="FinalTerm",h[h.VSCode=2]="VSCode"})(u||(e.ShellIntegrationStatus=u={}));var l;(function(h){h[h.Unknown=0]="Unknown",h[h.Shutdown=1]="Shutdown",h[h.Process=2]="Process",h[h.User=3]="User",h[h.Extension=4]="Extension"})(l||(e.TerminalExitReason=l={})),e.$6q={Backend:"workbench.contributions.terminal.processBackend"};class E{constructor(){this.a=new Map}get backends(){return this.a}registerTerminalBackend(i){const c=this.b(i.remoteAuthority);if(this.a.has(c))throw new Error(`A terminal backend with remote authority '${c}' was already registered.`);this.a.set(c,i)}getTerminalBackend(i){return this.a.get(this.b(i))}b(i){return i?.toLowerCase()??""}}s.$dn.add(e.$6q.Backend,new E),e.$7q=(0,S.$Oh)("localPtyService"),e.$8q=(0,S.$Oh)("terminalLogService")}),define(te[257],ie([0,1,74,7,185,102]),function(Q,e,S,R,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dr=e.$cr=e.$br=e.$ar=void 0;function D(y,d){const v=[{name:null,description:(0,s.localize)(0,null)}];return v.push(...y.map(b=>({name:b.profileName,description:P(b)}))),d&&v.push(...d.map(b=>({name:b.title,description:f(b)}))),{values:v.map(b=>b.name),markdownDescriptions:v.map(b=>b.description)}}e.$ar=D;function P(y){let d=`$(${M.ThemeIcon.isThemeIcon(y.icon)?y.icon.id:y.icon?y.icon:S.$Tj.terminal.id}) ${y.profileName}
- path: ${y.path}`;return y.args&&(typeof y.args=="string"?d+=`
- args: "${y.args}"`:d+=`
- args: [${y.args.length===0?"":`'${y.args.join("','")}'`}]`),y.overrideName!==void 0&&(d+=`
- overrideName: ${y.overrideName}`),y.color&&(d+=`
- color: ${y.color}`),y.env&&(d+=`
- env: ${JSON.stringify(y.env)}`),d}function f(y){return`$(${M.ThemeIcon.isThemeIcon(y.icon)?y.icon.id:y.icon?y.icon:S.$Tj.terminal.id}) ${y.title}
- extensionIdentifier: ${y.extensionIdentifier}`}function a(y,d){if(!y&&!d)return!0;if(typeof y=="string"&&typeof d=="string")return y===d;if(Array.isArray(y)&&Array.isArray(d)){if(y.length!==d.length)return!1;for(let v=0;v<y.length;v++)if(y[v]!==d[v])return!1;return!0}return!1}e.$br=a;function g(y,d){if(!y&&!d)return!0;if(!y||!d)return!1;if(M.ThemeIcon.isThemeIcon(y)&&M.ThemeIcon.isThemeIcon(d))return y.id===d.id&&y.color===d.color;if(typeof y=="object"&&"light"in y&&"dark"in y&&typeof d=="object"&&"light"in d&&"dark"in d){const v=y,b=d;if((R.URI.isUri(v.light)||w(v.light))&&(R.URI.isUri(v.dark)||w(v.dark))&&(R.URI.isUri(b.light)||w(b.light))&&(R.URI.isUri(b.dark)||w(b.dark)))return v.light.path===b.light.path&&v.dark.path===b.dark.path}if(R.URI.isUri(y)&&R.URI.isUri(d)||w(y)||w(d)){const v=y,b=d;return v.path===b.path&&v.scheme===b.scheme}return!1}e.$cr=g;function w(y){return y?typeof y.path=="string"&&typeof y.scheme=="string":!1}e.$dr=w}),define(te[258],ie([0,1,74,4,184,57,43,257]),function(Q,e,S,R,s,M,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hr=e.$gr=e.$fr=e.$er=void 0,e.$er={type:["string","null"],enum:["terminal.ansiBlack","terminal.ansiRed","terminal.ansiGreen","terminal.ansiYellow","terminal.ansiBlue","terminal.ansiMagenta","terminal.ansiCyan","terminal.ansiWhite"],default:null},e.$fr={type:"string",enum:Array.from((0,S.$Sj)(),$=>$.id),markdownEnumDescriptions:Array.from((0,S.$Sj)(),$=>`$(${$.id})`)};const f={args:{description:(0,s.localize)(0,null),type:"array",items:{type:"string"}},overrideName:{description:(0,s.localize)(1,null),type:"boolean"},icon:{description:(0,s.localize)(2,null),...e.$fr},color:{description:(0,s.localize)(3,null),...e.$er},env:{markdownDescription:(0,s.localize)(4,null),type:"object",additionalProperties:{type:["string","null"]},default:{}}},a={type:"object",required:["path"],properties:{path:{description:(0,s.localize)(5,null),type:["string","array"],items:{type:"string"}},...f}},g={type:"object",required:["path"],properties:{path:{description:(0,s.localize)(6,null),type:["string"],items:{type:"string"}},...f}};function w($){const m=$===2?"linux":$===1?"osx":"windows";return(0,s.localize)(7,null,(0,R.$i)($),'```json\n"terminal.integrated.profile.'+m+'": {\n  "bash": null\n}\n```',"[","](https://code.visualstudio.com/docs/terminal/profiles)")}const y={id:"terminal",order:100,title:(0,s.localize)(8,null),type:"object",properties:{["terminal.integrated.automationProfile.linux"]:{restricted:!0,markdownDescription:(0,s.localize)(9,null),type:["object","null"],default:null,anyOf:[{type:"null"},g],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.automationProfile.osx"]:{restricted:!0,markdownDescription:(0,s.localize)(10,null),type:["object","null"],default:null,anyOf:[{type:"null"},g],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.automationProfile.windows"]:{restricted:!0,markdownDescription:(0,s.localize)(11,null,"`terminal.integrated.automationShell.windows`"),type:["object","null"],default:null,anyOf:[{type:"null"},g],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.profiles.windows"]:{restricted:!0,markdownDescription:w(3),type:"object",default:{PowerShell:{source:"PowerShell",icon:"terminal-powershell"},"Command Prompt":{path:["${env:windir}\\Sysnative\\cmd.exe","${env:windir}\\System32\\cmd.exe"],args:[],icon:"terminal-cmd"},"Git Bash":{source:"Git Bash"}},additionalProperties:{anyOf:[{type:"object",required:["source"],properties:{source:{description:(0,s.localize)(12,null),enum:["PowerShell","Git Bash"]},...f}},{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,s.localize)(13,null),type:"string"},id:{description:(0,s.localize)(14,null),type:"string"},title:{description:(0,s.localize)(15,null),type:"string"},...f}},{type:"null"},a]}},["terminal.integrated.profiles.osx"]:{restricted:!0,markdownDescription:w(1),type:"object",default:{bash:{path:"bash",args:["-l"],icon:"terminal-bash"},zsh:{path:"zsh",args:["-l"]},fish:{path:"fish",args:["-l"]},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,s.localize)(16,null),type:"string"},id:{description:(0,s.localize)(17,null),type:"string"},title:{description:(0,s.localize)(18,null),type:"string"},...f}},{type:"null"},a]}},["terminal.integrated.profiles.linux"]:{restricted:!0,markdownDescription:w(2),type:"object",default:{bash:{path:"bash",icon:"terminal-bash"},zsh:{path:"zsh"},fish:{path:"fish"},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,s.localize)(19,null),type:"string"},id:{description:(0,s.localize)(20,null),type:"string"},title:{description:(0,s.localize)(21,null),type:"string"},...f}},{type:"null"},a]}},["terminal.integrated.useWslProfiles"]:{description:(0,s.localize)(22,null),type:"boolean",default:!0},["terminal.integrated.inheritEnv"]:{scope:1,description:(0,s.localize)(23,null),type:"boolean",default:!0},["terminal.integrated.persistentSessionScrollback"]:{scope:1,markdownDescription:(0,s.localize)(24,null),type:"number",default:100},["terminal.integrated.showLinkHover"]:{scope:1,description:(0,s.localize)(25,null),type:"boolean",default:!0},["terminal.integrated.ignoreProcessNames"]:{markdownDescription:(0,s.localize)(26,null,"`#terminal.integrated.confirmOnKill#`"),type:"array",items:{type:"string",uniqueItems:!0},default:["starship","oh-my-posh","bash","zsh"]}}};function d(){D.$dn.as(M.$in.Configuration).registerConfiguration(y),b()}e.$gr=d;let v;function b($,m){const u=D.$dn.as(M.$in.Configuration);let l;$&&(l=(0,P.$ar)($?.profiles,m));const E=v;v={id:"terminal",order:100,title:(0,s.localize)(27,null),type:"object",properties:{["terminal.integrated.defaultProfile.linux"]:{restricted:!0,markdownDescription:(0,s.localize)(28,null),type:["string","null"],default:null,enum:$?.os===3?l?.values:void 0,markdownEnumDescriptions:$?.os===3?l?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.osx"]:{restricted:!0,markdownDescription:(0,s.localize)(29,null),type:["string","null"],default:null,enum:$?.os===2?l?.values:void 0,markdownEnumDescriptions:$?.os===2?l?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.windows"]:{restricted:!0,markdownDescription:(0,s.localize)(30,null),type:["string","null"],default:null,enum:$?.os===1?l?.values:void 0,markdownEnumDescriptions:$?.os===1?l?.markdownDescriptions:void 0}}},u.updateConfigurations({add:[v],remove:E?[E]:[]})}e.$hr=b}),define(te[259],ie([0,1,28,13,37,9,4,35,27,12,21,124,255,254]),function(Q,e,S,R,s,M,D,P,f,a,g,w,y,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rr=e.$qr=e.$pr=void 0;function v(){const t=/(\d+)\.(\d+)\.(\d+)/g.exec(S.release());let n=0;return t&&t.length===4&&(n=parseInt(t[3])),n}e.$pr=v;async function b(t,n,r,p=P.env,A=g.Promises.exists){if(M.$ic(t))return await A(t)?t:void 0;if(n===void 0&&(n=P.cwd()),M.$mc(t)!=="."){const j=M.$jc(n,t);return await A(j)?j:void 0}const k=(0,s.$$m)(p,"PATH");if(r===void 0&&(0,a.$yf)(k)&&(r=k.split(M.$tc)),r===void 0||r.length===0){const j=M.$jc(n,t);return await A(j)?j:void 0}for(const j of r){let U;if(M.$ic(j)?U=M.$jc(j,t):U=M.$jc(n,j,t),await A(U))return U;if(D.$j){let z=U+".com";if(await A(z)||(z=U+".exe",await A(z)))return z}}const I=M.$jc(n,t);return await A(I)?I:void 0}e.$qr=b;function $(t,n,r,p,A){const C=D.$j&&(!n.windowsEnableConpty||v()<18309);if(!n.shellIntegration.enabled||!t.executable||t.isFeatureTerminal||t.hideFromUser||t.ignoreShellIntegration||C)return;const k=t.args,I=P.$dc==="win32"?M.$nc(t.executable).toLowerCase():M.$nc(t.executable),j=M.$mc(R.$cg.asFileUri("").fsPath);let U;const z={VSCODE_INJECTION:"1"};if(n.shellIntegration.nonce&&(z.VSCODE_NONCE=n.shellIntegration.nonce),D.$j){if(I==="pwsh.exe"||I==="powershell.exe")return!k||c(k)?U=l.get(u.WindowsPwsh):i(k)&&(U=l.get(u.WindowsPwshLogin)),U?(U=[...U],U[U.length-1]=(0,f.$Ce)(U[U.length-1],j,""),{newArgs:U,envMixin:z}):void 0;p.warn(`Shell integration cannot be enabled for executable "${t.executable}" and args`,t.args);return}switch(I){case"bash":return!k||k.length===0?U=l.get(u.Bash):o(k)&&(z.VSCODE_SHELL_LOGIN="1",m(n,z),U=l.get(u.Bash)),U?(U=[...U],U[U.length-1]=(0,f.$Ce)(U[U.length-1],j),{newArgs:U,envMixin:z}):void 0;case"fish":{const ne=r?.XDG_DATA_DIRS??"/usr/local/share:/usr/share",_=M.$jc(j,"out/vs/workbench/contrib/terminal/browser/media/fish_xdg_data");return z.XDG_DATA_DIRS=`${ne}:${_}`,m(n,z),{newArgs:void 0,envMixin:z}}case"pwsh":return!k||c(k)?U=l.get(u.Pwsh):i(k)&&(U=l.get(u.PwshLogin)),U?(U=[...U],U[U.length-1]=(0,f.$Ce)(U[U.length-1],j,""),{newArgs:U,envMixin:z}):void 0;case"zsh":{if(!k||k.length===0?U=l.get(u.Zsh):o(k)?(U=l.get(u.ZshLogin),m(n,z)):(k===l.get(u.Zsh)||k===l.get(u.ZshLogin))&&(U=k),!U)return;U=[...U],U[U.length-1]=(0,f.$Ce)(U[U.length-1],j);let ne;try{ne=S.userInfo().username}catch{ne="unknown"}const _=M.$jc(S.tmpdir(),`${ne}-${A.applicationName}-zsh`);z.ZDOTDIR=_;const ae=r?.ZDOTDIR??S.homedir()??"~";z.USER_ZDOTDIR=ae;const se=[];return se.push({source:M.$jc(j,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-rc.zsh"),dest:M.$jc(_,".zshrc")}),se.push({source:M.$jc(j,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-profile.zsh"),dest:M.$jc(_,".zprofile")}),se.push({source:M.$jc(j,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-env.zsh"),dest:M.$jc(_,".zshenv")}),se.push({source:M.$jc(j,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-login.zsh"),dest:M.$jc(_,".zlogin")}),{newArgs:U,envMixin:z,filesToCopy:se}}}p.warn(`Shell integration cannot be enabled for executable "${t.executable}" and args`,t.args)}e.$rr=$;function m(t,n){if(D.$k&&t.environmentVariableCollections){const r=(0,y.$nr)(t.environmentVariableCollections),A=new d.$or(r).getVariableMap({workspaceFolder:t.workspaceFolder}).get("PATH"),C=[];if(A)for(const k of A)k.type===w.EnvironmentVariableMutatorType.Prepend&&C.push(k.value);C.length>0&&(n.VSCODE_PATH_PREFIX=C.join(""))}}var u;(function(t){t.WindowsPwsh="windows-pwsh",t.WindowsPwshLogin="windows-pwsh-login",t.Pwsh="pwsh",t.PwshLogin="pwsh-login",t.Zsh="zsh",t.ZshLogin="zsh-login",t.Bash="bash"})(u||(u={}));const l=new Map;l.set(u.WindowsPwsh,["-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),l.set(u.WindowsPwshLogin,["-l","-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),l.set(u.Pwsh,["-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"{1}']),l.set(u.PwshLogin,["-l","-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"']),l.set(u.Zsh,["-i"]),l.set(u.ZshLogin,["-il"]),l.set(u.Bash,["--init-file","{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration-bash.sh"]);const E=["-login","-l"],h=["-nol","-nologo"];function i(t){return typeof t=="string"?E.includes(t.toLowerCase()):t.length===1&&E.includes(t[0].toLowerCase())||t.length===2&&(E.includes(t[0].toLowerCase())||E.includes(t[1].toLowerCase()))&&(h.includes(t[0].toLowerCase())||h.includes(t[1].toLowerCase()))}function c(t){return typeof t=="string"?h.includes(t.toLowerCase()):t.length===0||t?.length===1&&h.includes(t[0].toLowerCase())}function o(t){return t==="string"&&E.includes(t.toLowerCase())||typeof t!="string"&&t.length===1&&E.includes(t[0].toLowerCase())}}),define(te[260],ie([0,1,47,74,9,4,12,21,106,259,113]),function(Q,e,S,R,s,M,D,P,f,a,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sr=void 0;let w,y=!0;function d(n,r,p,A,C=process.env,k,I,j,U){return k=k||{existsFile:P.SymlinkSupport.existsFile,readFile:P.Promises.readFile},M.$j?v(p,k,C,I,A.getValue("terminal.integrated.useWslProfiles")!==!1,n&&typeof n=="object"?{...n}:A.getValue("terminal.integrated.profiles.windows"),typeof r=="string"?r:A.getValue("terminal.integrated.defaultProfile.windows"),U,j):c(k,I,p,n&&typeof n=="object"?{...n}:A.getValue(M.$l?"terminal.integrated.profiles.linux":"terminal.integrated.profiles.osx"),typeof r=="string"?r:A.getValue(M.$l?"terminal.integrated.defaultProfile.linux":"terminal.integrated.defaultProfile.osx"),U,j,C)}e.$sr=d;async function v(n,r,p,A,C,k,I,j,U){const z=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432"),ne=`${process.env.windir}\\${z?"Sysnative":"System32"}`;let _=!1;(0,a.$pr)()>=16299&&(_=!0),await u(j);const ae=new Map;if(n){ae.set("PowerShell",{source:"PowerShell",icon:R.$Tj.terminalPowershell,isAutoDetected:!0}),ae.set("Windows PowerShell",{path:`${ne}\\WindowsPowerShell\\v1.0\\powershell.exe`,icon:R.$Tj.terminalPowershell,isAutoDetected:!0}),ae.set("Git Bash",{source:"Git Bash",isAutoDetected:!0}),ae.set("Command Prompt",{path:`${ne}\\cmd.exe`,icon:R.$Tj.terminalCmd,isAutoDetected:!0}),ae.set("Cygwin",{path:[{path:`${process.env.HOMEDRIVE}\\cygwin64\\bin\\bash.exe`,isUnsafe:!0},{path:`${process.env.HOMEDRIVE}\\cygwin\\bin\\bash.exe`,isUnsafe:!0}],args:["--login"],isAutoDetected:!0}),ae.set("bash (MSYS2)",{path:[{path:`${process.env.HOMEDRIVE}\\msys64\\usr\\bin\\bash.exe`,isUnsafe:!0}],args:["--login","-i"],icon:R.$Tj.terminalBash,isAutoDetected:!0});const oe=`${process.env.CMDER_ROOT||`${process.env.HOMEDRIVE}\\cmder`}\\vendor\\bin\\vscode_init.cmd`;ae.set("Cmder",{path:`${ne}\\cmd.exe`,args:["/K",oe],requiresPath:process.env.CMDER_ROOT?oe:{path:oe,isUnsafe:!0},isAutoDetected:!0})}o(k,ae);const se=await b(ae.entries(),I,r,p,A,U);if(n&&C)try{const oe=await h(`${ne}\\${_?"wsl":"bash"}.exe`,I);for(const K of oe)(!k||!(K.profileName in k))&&se.push(K)}catch{y&&(A?.info("WSL is not installed, so could not detect WSL profiles"),y=!1)}return se}async function b(n,r,p,A=process.env,C,k){const I=[];for(const[j,U]of n)I.push($(j,U,r,p,A,C,k));return(await Promise.all(I)).filter(j=>!!j)}async function $(n,r,p,A,C=process.env,k,I){if(r===null)return;let j,U,z;if("source"in r&&!("path"in r)){const se=w?.get(r.source);if(!se)return;j=se.paths,U=r.args||se.args,r.icon?z=m(r.icon):se.icon&&(z=se.icon)}else j=Array.isArray(r.path)?r.path:[r.path],U=M.$j||Array.isArray(r.args)?r.args:void 0,z=m(r.icon);let ne;if(I){const se=j.map(K=>typeof K=="string"?K:K.path),oe=await I(se);ne=new Array(j.length);for(let K=0;K<j.length;K++)typeof j[K]=="string"?ne[K]=oe[K]:ne[K]={path:oe[K],isUnsafe:!0}}else ne=j.slice();let _;if(r.requiresPath){let se;if((0,D.$yf)(r.requiresPath)?se=r.requiresPath:(se=r.requiresPath.path,r.requiresPath.isUnsafe&&(_=se)),!await A.existsFile(se))return}const ae=await t(n,p,ne,A,C,U,r.env,r.overrideName,r.isAutoDetected,_);if(!ae){k?.debug("Terminal profile not validated",n,j);return}return ae.isAutoDetected=r.isAutoDetected,ae.icon=z,ae.color=r.color,ae}function m(n){return typeof n=="string"?{id:n}:n}async function u(n){if(w&&!n)return;const[r,p]=await Promise.all([l(),n||E()]);w=new Map,w.set("Git Bash",{profileName:"Git Bash",paths:r,args:["--login","-i"]}),w.set("PowerShell",{profileName:"PowerShell",paths:p,icon:R.$Tj.terminalPowershell})}async function l(){const n=new Set,r=await(0,a.$qr)("git.exe");if(r){const C=(0,g.dirname)(r);n.add((0,g.resolve)(C,"../.."))}function p(C,k){k&&C.add(k)}p(n,process.env.ProgramW6432),p(n,process.env.ProgramFiles),p(n,process.env["ProgramFiles(X86)"]),p(n,`${process.env.LocalAppData}\\Program`);const A=[];for(const C of n)A.push(`${C}\\Git\\bin\\bash.exe`,`${C}\\Git\\usr\\bin\\bash.exe`,`${C}\\usr\\bin\\bash.exe`);return A.push(`${process.env.UserProfile}\\scoop\\apps\\git\\current\\bin\\bash.exe`),A.push(`${process.env.UserProfile}\\scoop\\apps\\git-with-openssh\\current\\bin\\bash.exe`),A}async function E(){const n=[];for await(const r of(0,f.$vl)())n.push(r.exePath);return n}async function h(n,r){const p=[],A=await new Promise((I,j)=>{S.exec("wsl.exe -l -q",{encoding:"utf16le",timeout:1e3},(U,z)=>{if(U)return j("Problem occurred when getting wsl distros");I(z)})});if(!A)return[];const C=new RegExp(/[\r?\n]/),k=A.split(C).filter(I=>I.trim().length>0&&I!=="");for(const I of k){if(I===""||I.startsWith("docker-desktop"))continue;const j=`${I} (WSL)`,U={profileName:j,path:n,args:["-d",`${I}`],isDefault:j===r,icon:i(I),isAutoDetected:!1};p.push(U)}return p}function i(n){return n.includes("Ubuntu")?R.$Tj.terminalUbuntu:n.includes("Debian")?R.$Tj.terminalDebian:R.$Tj.terminalLinux}async function c(n,r,p,A,C,k,I,j){const U=new Map;if(p){const z=(await n.readFile("/etc/shells")).toString(),ne=(k||z.split(`
`)).map(ae=>{const se=ae.indexOf("#");return se===-1?ae:ae.substring(0,se)}).filter(ae=>ae.trim().length>0),_=new Map;for(const ae of ne){let se=(0,s.$nc)(ae),oe=_.get(se)||0;oe++,oe>1&&(se=`${se} (${oe})`),_.set(se,oe),U.set(se,{path:ae,isAutoDetected:!0})}}return o(A,U),await b(U.entries(),C,n,j,r,I)}function o(n,r){if(n)for(const[p,A]of Object.entries(n))A===null||typeof A!="object"||!("path"in A)&&!("source"in A)?r.delete(p):(A.icon=A.icon||r.get(p)?.icon,r.set(p,A))}async function t(n,r,p,A,C,k,I,j,U,z){if(p.length===0)return Promise.resolve(void 0);const ne=p.shift();if(ne==="")return t(n,r,p,A,C,k,I,j,U);const _=typeof ne!="string"&&ne.isUnsafe,ae=typeof ne=="string"?ne:ne.path,se={profileName:n,path:ae,args:k,env:I,overrideName:j,isAutoDetected:U,isDefault:n===r,isUnsafePath:_,requiresUnsafePath:z};if((0,s.$nc)(ae)===ae){const K=C.PATH?C.PATH.split(s.$tc):void 0,J=await(0,a.$qr)(ae,void 0,K,void 0,A.existsFile);return J?(se.path=J,se.isFromPath=!0,se):t(n,r,p,A,C,k)}return await A.existsFile((0,s.$hc)(ae))?se:t(n,r,p,A,C,k,I,j,U)}}),define(te[261],ie([0,1,3,2,4,42,18,5,224,93,256,125,258,260,108,72]),function(Q,e,S,R,s,M,D,P,f,a,g,w,y,d,v,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tr=void 0;var $;(function(u){u[u.MaxRestarts=5]="MaxRestarts"})($||($={}));let m=class extends R.$Sc{get c(){return this.h(),this.a}get f(){return this.h(),this.b}get g(){return this.b}h(){this.a||this.U()}constructor(l,E,h,i){super(),this.M=l,this.N=E,this.O=h,this.P=i,this.m=!1,this.n=0,this.r=!0,this.u=this.B(new S.$Nd),this.onPtyHostExit=this.u.event,this.w=this.B(new S.$Nd),this.onPtyHostStart=this.w.event,this.y=this.B(new S.$Nd),this.onPtyHostUnresponsive=this.y.event,this.z=this.B(new S.$Nd),this.onPtyHostResponsive=this.z.event,this.C=this.B(new S.$Nd),this.onPtyHostRequestResolveVariables=this.C.event,this.D=this.B(new S.$Nd),this.onProcessData=this.D.event,this.F=this.B(new S.$Nd),this.onProcessReady=this.F.event,this.G=this.B(new S.$Nd),this.onProcessReplay=this.G.event,this.H=this.B(new S.$Nd),this.onProcessOrphanQuestion=this.H.event,this.I=this.B(new S.$Nd),this.onDidRequestDetach=this.I.event,this.J=this.B(new S.$Nd),this.onDidChangeProperty=this.J.event,this.L=this.B(new S.$Nd),this.onProcessExit=this.L.event,(0,y.$gr)(),this.B(this.M),this.B((0,R.$Qc)(()=>this.W())),this.j=this.B(new g.$_q(void 0,this.O)),this.j.onCreateRequest(this.C.fire,this.C),this.M.onRequestConnection&&S.Event.once(this.M.onRequestConnection)(()=>this.h()),this.M.onWillShutdown?.(()=>this.m=!0)}get Q(){return this.N.getValue("terminal.integrated.ignoreProcessNames")}async R(){return this.g?.refreshIgnoreProcessNames?.(this.Q)}async S(){if(s.$j)return process.env;try{return await(0,a.$Rl)(this.N,this.O,{_:[]},process.env)}catch(l){return this.O.error("ptyHost was unable to resolve shell environment",l),{}}}U(){const l=this.M.start(),E=l.client;this.O.getLevel()===P.LogLevel.Trace&&this.O.trace("PtyHostService#_startPtyHost",new Error().stack?.replace(/^Error/,"")),M.ProxyChannel.toService(E.getChannel(w.TerminalIpcChannels.Heartbeat)).onBeat(()=>this.X()),this.X(!0),this.B(l.onDidProcessExit(c=>{this.u.fire(c.code),!this.m&&!this.q.isDisposed&&(this.n<=$.MaxRestarts?(this.O.error(`ptyHost terminated unexpectedly with code ${c.code}`),this.n++,this.restartPtyHost()):this.O.error(`ptyHost terminated unexpectedly with code ${c.code}, giving up`))}));const i=M.ProxyChannel.toService(E.getChannel(w.TerminalIpcChannels.PtyHost));return this.B(i.onProcessData(c=>this.D.fire(c))),this.B(i.onProcessReady(c=>this.F.fire(c))),this.B(i.onProcessExit(c=>this.L.fire(c))),this.B(i.onDidChangeProperty(c=>this.J.fire(c))),this.B(i.onProcessReplay(c=>this.G.fire(c))),this.B(i.onProcessOrphanQuestion(c=>this.H.fire(c))),this.B(i.onDidRequestDetach(c=>this.I.fire(c))),this.B(new f.$$q(this.P,E.getChannel(w.TerminalIpcChannels.Logger))),this.a=l,this.b=i,this.w.fire(),this.B(this.N.onDidChangeConfiguration(async c=>{c.affectsConfiguration("terminal.integrated.ignoreProcessNames")&&await this.R()})),this.R(),[l,i]}async createProcess(l,E,h,i,c,o,t,n,r,p,A){const C=setTimeout(()=>this.$(),w.HeartbeatConstants.CreateProcessTimeout),k=await this.f.createProcess(l,E,h,i,c,o,t,n,r,p,A);return clearTimeout(C),k}updateTitle(l,E,h){return this.f.updateTitle(l,E,h)}updateIcon(l,E,h,i){return this.f.updateIcon(l,E,h,i)}attachToProcess(l){return this.f.attachToProcess(l)}detachFromProcess(l,E){return this.f.detachFromProcess(l,E)}shutdownAll(){return this.f.shutdownAll()}listProcesses(){return this.f.listProcesses()}async getPerformanceMarks(){return this.g?.getPerformanceMarks()??[]}async reduceConnectionGraceTime(){return this.g?.reduceConnectionGraceTime()}start(l){return this.f.start(l)}shutdown(l,E){return this.f.shutdown(l,E)}input(l,E){return this.f.input(l,E)}processBinary(l,E){return this.f.processBinary(l,E)}resize(l,E,h){return this.f.resize(l,E,h)}clearBuffer(l){return this.f.clearBuffer(l)}acknowledgeDataEvent(l,E){return this.f.acknowledgeDataEvent(l,E)}setUnicodeVersion(l,E){return this.f.setUnicodeVersion(l,E)}getInitialCwd(l){return this.f.getInitialCwd(l)}getCwd(l){return this.f.getCwd(l)}async getLatency(){const l=new b.$Jd,E=await this.f.getLatency();return l.stop(),[{label:"ptyhostservice<->ptyhost",latency:l.elapsed()},...E]}orphanQuestionReply(l){return this.f.orphanQuestionReply(l)}installAutoReply(l,E){return this.f.installAutoReply(l,E)}uninstallAllAutoReplies(){return this.f.uninstallAllAutoReplies()}uninstallAutoReply(l){return this.f.uninstallAutoReply(l)}getDefaultSystemShell(l){return this.g?.getDefaultSystemShell(l)??(0,v.$Bl)(l??s.OS,process.env)}async getProfiles(l,E,h,i=!1){const c=await this.S();return(0,d.$sr)(E,h,i,this.N,c,void 0,this.O,this.bb.bind(this,l))}async getEnvironment(){return this.b?this.f.getEnvironment():{...process.env}}getWslPath(l,E){return this.f.getWslPath(l,E)}getRevivedPtyNewId(l,E){return this.f.getRevivedPtyNewId(l,E)}setTerminalLayoutInfo(l){return this.f.setTerminalLayoutInfo(l)}async getTerminalLayoutInfo(l){return this.g?.getTerminalLayoutInfo(l)}async requestDetachInstance(l,E){return this.f.requestDetachInstance(l,E)}async acceptDetachInstanceReply(l,E){return this.f.acceptDetachInstanceReply(l,E)}async freePortKillProcess(l){if(!this.f.freePortKillProcess)throw new Error("freePortKillProcess does not exist on the pty proxy");return this.f.freePortKillProcess(l)}async serializeTerminalState(l){return this.f.serializeTerminalState(l)}async reviveTerminalProcesses(l,E,h){return this.f.reviveTerminalProcesses(l,E,h)}async refreshProperty(l,E){return this.f.refreshProperty(l,E)}async updateProperty(l,E,h){return this.f.updateProperty(l,E,h)}async restartPtyHost(){this.W(),this.r=!0,this.U()}W(){this.f.shutdownAll(),this.c.store.dispose()}X(l){this.ab(),this.s=setTimeout(()=>this.Y(),l?w.HeartbeatConstants.ConnectingBeatInterval:w.HeartbeatConstants.BeatInterval*w.HeartbeatConstants.FirstWaitMultiplier),this.r||(this.r=!0,this.z.fire())}Y(){this.O.warn(`No ptyHost heartbeat after ${w.HeartbeatConstants.BeatInterval*w.HeartbeatConstants.FirstWaitMultiplier/1e3} seconds`),this.s=void 0,this.t=setTimeout(()=>this.Z(),w.HeartbeatConstants.BeatInterval*w.HeartbeatConstants.SecondWaitMultiplier)}Z(){this.O.error(`No ptyHost heartbeat after ${(w.HeartbeatConstants.BeatInterval*w.HeartbeatConstants.FirstWaitMultiplier+w.HeartbeatConstants.BeatInterval*w.HeartbeatConstants.FirstWaitMultiplier)/1e3} seconds`),this.t=void 0,this.r&&(this.r=!1,this.y.fire())}$(){this.ab(),this.O.error(`No ptyHost response to createProcess after ${w.HeartbeatConstants.CreateProcessTimeout/1e3} seconds`),this.r&&(this.r=!1,this.y.fire())}ab(){this.s&&(clearTimeout(this.s),this.s=void 0),this.t&&(clearTimeout(this.t),this.t=void 0)}bb(l,E){return this.j.createRequest({workspaceId:l,originalText:E})}async acceptPtyHostResolvedVariables(l,E){this.j.acceptReply(l,E)}};e.$tr=m,e.$tr=m=ke([ee(1,D.$ii),ee(2,P.$9i),ee(3,P.$0i)],m)}),define(te[67],ie([0,1,15,3,2,4,18,6,34]),function(Q,e,S,R,s,M,D,P,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$e6b=e.$d6b=void 0;const a="#FFFFFF",g="#1E1E1E",w="#000000",y="#FFFFFF",d="theme",v="themeBackground",b="windowSplash";e.$d6b=(0,P.$Oh)("themeMainService");let $=class extends s.$Sc{constructor(u,l){super(),this.b=u,this.c=l,this.a=this.B(new R.$Nd),this.onDidChangeColorScheme=this.a.event,S.nativeTheme.on("updated",()=>{this.a.fire(this.getColorScheme())})}getColorScheme(){if(M.$j){if(S.nativeTheme.shouldUseHighContrastColors)return{dark:S.nativeTheme.shouldUseInvertedColorScheme,highContrast:!0}}else if(M.$k){if(S.nativeTheme.shouldUseInvertedColorScheme||S.nativeTheme.shouldUseHighContrastColors)return{dark:S.nativeTheme.shouldUseDarkColors,highContrast:!0}}else if(M.$l&&S.nativeTheme.shouldUseHighContrastColors)return{dark:!0,highContrast:!0};return{dark:S.nativeTheme.shouldUseDarkColors,highContrast:!1}}getBackgroundColor(){const u=this.getColorScheme();if(u.highContrast&&this.c.getValue("window.autoDetectHighContrast"))return u.dark?w:y;let l=this.b.getItem(v,null);if(!l)switch(this.b.getItem(d,"vs-dark").split(" ")[0]){case"vs":l=a;break;case"hc-black":l=w;break;case"hc-light":l=y;break;default:l=g}return M.$k&&l.toUpperCase()===g&&(l="#171717"),l}saveWindowSplash(u,l){this.b.setItems([{key:d,data:l.baseTheme},{key:v,data:l.colorInfo.background},{key:b,data:l}]),typeof u=="number"&&this.f(u,l)}f(u,l){for(const E of S.BrowserWindow.getAllWindows())if(E.id===u){E.setBackgroundColor(l.colorInfo.background);break}}getWindowSplash(){return this.b.getItem(b)}};e.$e6b=$,e.$e6b=$=ke([ee(0,f.$rN),ee(1,D.$ii)],$)}),define(te[126],ie([0,1,3,18,6,5]),function(Q,e,S,R,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dv=e.$cv=e.$bv=e.$av=e.$_u=e.$$u=e.$0u=e.$9u=e.ProvidedOnAutoForward=e.$8u=e.TunnelPrivacyId=e.TunnelProtocol=e.$7u=e.$6u=void 0,e.$6u=(0,s.$Oh)("tunnelService"),e.$7u=(0,s.$Oh)("sharedTunnelsService");var D;(function($){$.Http="http",$.Https="https"})(D||(e.TunnelProtocol=D={}));var P;(function($){$.ConstantPrivate="constantPrivate",$.Private="private",$.Public="public"})(P||(e.TunnelPrivacyId=P={}));function f($){return!!$.forwardPort}e.$8u=f;var a;(function($){$[$.Notify=1]="Notify",$[$.OpenBrowser=2]="OpenBrowser",$[$.OpenPreview=3]="OpenPreview",$[$.Silent=4]="Silent",$[$.Ignore=5]="Ignore",$[$.OpenBrowserOnce=6]="OpenBrowserOnce"})(a||(e.ProvidedOnAutoForward=a={}));function g($){if($.scheme!=="http"&&$.scheme!=="https")return;const m=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec($.authority);if(m)return{address:m[1],port:+m[2]}}e.$9u=g,e.$0u=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function w($){return e.$0u.indexOf($)>=0}e.$$u=w,e.$_u=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function y($){return e.$_u.indexOf($)>=0}e.$av=y;function d($,m,u,l){if(u===1)return!1;if(u===2&&y(m)){const E=/(\d+)\.(\d+)\.(\d+)/g.exec(l);if(E?.length===4&&parseInt(E[1])>=18)return!1}return $<1024}e.$bv=d;class v{constructor(m,u,l){this.remoteAddress=m,this.localAddress=u,this.b=l,this.a=new S.$Nd,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.$cv=v;let b=class{constructor(m,u){this.j=m,this.k=u,this.a=new S.$Nd,this.onTunnelOpened=this.a.event,this.b=new S.$Nd,this.onTunnelClosed=this.b.event,this.c=new S.$Nd,this.onAddedTunnelProvider=this.c.event,this.e=new Map,this.g=!1,this.h=[],this.i=new Set}get hasTunnelProvider(){return!!this.f}get l(){const m=this.k.getValue("remote.localPortHost");return!m||m==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(m){return this.f=m,m?(this.c.fire(),{dispose:()=>{this.f=void 0,this.g=!1,this.h=[]}}):(this.g=!1,this.h=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(m){this.g=m.elevation,this.h=m.privacyOptions}get canElevate(){return this.g}get canChangePrivacy(){return this.h.length>0}get privacyOptions(){return this.h}get tunnels(){return this.m()}async m(){const m=[],u=Array.from(this.e.values());for(const l of u){const E=Array.from(l.values());for(const h of E){const i=await h.value;i&&typeof i!="string"&&m.push(i)}}return m}async dispose(){for(const m of this.e.values()){for(const{value:u}of m.values())await u.then(l=>typeof l!="string"?l?.dispose():void 0);m.clear()}this.e.clear()}setEnvironmentTunnel(m,u,l,E,h){this.p(m,u,Promise.resolve({tunnelRemoteHost:m,tunnelRemotePort:u,localAddress:l,privacy:E,protocol:h,dispose:()=>Promise.resolve()}))}async getExistingTunnel(m,u){(y(m)||w(m))&&(m=e.$0u[0]);const l=this.r(m,u);if(l)return++l.refcount,l.value}openTunnel(m,u,l,E,h,i=!1,c,o){this.j.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${u}:${l} on local port ${h}.`);const t=this.f??m;if(!t)return;if(u||(u="localhost"),E||(E=this.l),this.f&&this.i.has(l)){this.j.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const n=this.s(t,u,l,E,h,i,c,o);return n?n.then(r=>{if(r){if(typeof r=="string")return this.j.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.q(u,l),r}else{this.j.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.q(u,l);return}this.j.trace("ForwardedPorts: (TunnelService) New tunnel established.");const p=this.n(r);return(r.tunnelRemoteHost!==u||r.tunnelRemotePort!==l)&&this.j.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),c&&r.privacy!==c&&this.j.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this.a.fire(p),p}):(this.j.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),n)}n(m){return{tunnelRemotePort:m.tunnelRemotePort,tunnelRemoteHost:m.tunnelRemoteHost,tunnelLocalPort:m.tunnelLocalPort,localAddress:m.localAddress,privacy:m.privacy,protocol:m.protocol,dispose:async()=>{this.j.trace(`ForwardedPorts: (TunnelService) dispose request for ${m.tunnelRemoteHost}:${m.tunnelRemotePort} `);const u=this.e.get(m.tunnelRemoteHost);if(u){const l=u.get(m.tunnelRemotePort);l&&(l.refcount--,await this.o(m.tunnelRemoteHost,m.tunnelRemotePort,l))}}}}async o(m,u,l){if(l.refcount<=0){this.j.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${m}:${u}.`);const E=l.value.then(async h=>{h&&typeof h!="string"&&(await h.dispose(!0),this.b.fire({host:h.tunnelRemoteHost,port:h.tunnelRemotePort}))});return this.e.has(m)&&this.e.get(m).delete(u),E}}async closeTunnel(m,u){this.j.trace(`ForwardedPorts: (TunnelService) close request for ${m}:${u} `);const l=this.e.get(m);if(l&&l.has(u)){const E=l.get(u);E.refcount=0,await this.o(m,u,E)}}p(m,u,l){this.e.has(m)||this.e.set(m,new Map),this.e.get(m).set(u,{refcount:1,value:l})}async q(m,u){const l=this.e.get(m);if(l){const E=l.get(u),h=E?await E.value:void 0;(!h||typeof h=="string")&&l.delete(u),l.size===0&&this.e.delete(m)}}r(m,u){const l=[m];w(m)?(l.push(...e.$0u),l.push(...e.$_u)):y(m)&&l.push(...e.$_u);const E=l.map(h=>this.e.get(h));for(const h of E){const i=h?.get(u);if(i)return i}}canTunnel(m){return!!g(m)}t(m,u,l,E,h,i,c){this.j.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${u}:${l} on local port ${E}.`);const o=l;this.i.add(o);const t=E===void 0?l:E,n={elevationRequired:h?this.isPortPrivileged(t):!1},r={remoteAddress:{host:u,port:l},localAddressPort:E,privacy:i,public:i?i!==P.Private:void 0,protocol:c},p=m.forwardPort(r,n);return p?(this.p(u,l,p),p.finally(()=>{this.j.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.i.delete(o)})):this.i.delete(o),p}};e.$dv=b,e.$dv=b=ke([ee(0,M.$9i),ee(1,R.$ii)],b)}),define(te[48],ie([0,1,6]),function(Q,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eU=e.$dU=e.DisablementReason=e.UpdateType=e.StateType=void 0;var R;(function(D){D.Uninitialized="uninitialized",D.Idle="idle",D.Disabled="disabled",D.CheckingForUpdates="checking for updates",D.AvailableForDownload="available for download",D.Downloading="downloading",D.Downloaded="downloaded",D.Updating="updating",D.Ready="ready"})(R||(e.StateType=R={}));var s;(function(D){D[D.Setup=0]="Setup",D[D.Archive=1]="Archive",D[D.Snap=2]="Snap"})(s||(e.UpdateType=s={}));var M;(function(D){D[D.NotBuilt=0]="NotBuilt",D[D.DisabledByEnvironment=1]="DisabledByEnvironment",D[D.ManuallyDisabled=2]="ManuallyDisabled",D[D.MissingConfiguration=3]="MissingConfiguration",D[D.InvalidConfiguration=4]="InvalidConfiguration",D[D.RunningAsAdmin=5]="RunningAsAdmin"})(M||(e.DisablementReason=M={})),e.$dU={Uninitialized:{type:"uninitialized"},Disabled:D=>({type:"disabled",reason:D}),Idle:(D,P)=>({type:"idle",updateType:D,error:P}),CheckingForUpdates:D=>({type:"checking for updates",explicit:D}),AvailableForDownload:D=>({type:"available for download",update:D}),Downloading:D=>({type:"downloading",update:D}),Downloaded:D=>({type:"downloaded",update:D}),Updating:D=>({type:"updating",update:D}),Ready:D=>({type:"ready",update:D})},e.$eU=(0,S.$Oh)("updateService")}),define(te[262],ie([0,1,4,186,57,43]),function(Q,e,S,R,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),M.$dn.as(s.$in.Configuration).registerConfiguration({id:"update",order:15,title:(0,R.localize)(0,null),type:"object",properties:{"update.mode":{type:"string",enum:["none","manual","start","default"],default:"default",scope:1,description:(0,R.localize)(1,null),tags:["usesOnlineServices"],enumDescriptions:[(0,R.localize)(2,null),(0,R.localize)(3,null),(0,R.localize)(4,null),(0,R.localize)(5,null)],policy:{name:"UpdateMode",minimumVersion:"1.67"}},"update.channel":{type:"string",default:"default",scope:1,description:(0,R.localize)(6,null),deprecationMessage:(0,R.localize)(7,null,"update.mode")},"update.enableWindowsBackgroundUpdates":{type:"boolean",default:!0,scope:1,title:(0,R.localize)(8,null),description:(0,R.localize)(9,null),included:S.$j&&!S.$p},"update.showReleaseNotes":{type:"boolean",default:!0,scope:1,description:(0,R.localize)(10,null),tags:["usesOnlineServices"]}}})}),define(te[263],ie([0,1,3,48]),function(Q,e,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$g7b=e.$f7b=void 0;class s{constructor(P){this.a=P}listen(P,f){switch(f){case"onStateChange":return this.a.onStateChange}throw new Error(`Event not found: ${f}`)}call(P,f,a){switch(f){case"checkForUpdates":return this.a.checkForUpdates(a);case"downloadUpdate":return this.a.downloadUpdate();case"applyUpdate":return this.a.applyUpdate();case"quitAndInstall":return this.a.quitAndInstall();case"_getInitialState":return Promise.resolve(this.a.state);case"isLatestVersion":return this.a.isLatestVersion();case"_applySpecificUpdate":return this.a._applySpecificUpdate(a)}throw new Error(`Call not found: ${f}`)}}e.$f7b=s;class M{get state(){return this.b}set state(P){this.b=P,this.a.fire(P)}constructor(P){this.c=P,this.a=new S.$Nd,this.onStateChange=this.a.event,this.b=R.$dU.Uninitialized,this.c.listen("onStateChange")(f=>this.state=f),this.c.call("_getInitialState").then(f=>this.state=f)}checkForUpdates(P){return this.c.call("checkForUpdates",P)}downloadUpdate(){return this.c.call("downloadUpdate")}applyUpdate(){return this.c.call("applyUpdate")}quitAndInstall(){return this.c.call("quitAndInstall")}isLatestVersion(){return this.c.call("isLatestVersion")}_applySpecificUpdate(P){return this.c.call("_applySpecificUpdate",P)}}e.$g7b=M}),define(te[40],ie([0,1,6]),function(Q,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hk=void 0,e.$Hk=(0,S.$Oh)("IUriIdentityService")}),define(te[264],ie([0,1,40,205,16,19,139,3,2]),function(Q,e,S,R,s,M,D,P,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xr=void 0;class a{static{this._clock=0}constructor(y){this.uri=y,this.time=a._clock++}touch(){return this.time=a._clock++,this}}let g=class{constructor(y){this.g=y,this.c=new f.$Rc,this.f=2**16;const d=new Map,v=b=>{let $=d.get(b.scheme);return $===void 0&&($=y.hasProvider(b)&&!this.g.hasCapability(b,1024),d.set(b.scheme,$)),$};this.c.add(P.Event.any(y.onDidChangeFileSystemProviderRegistrations,y.onDidChangeFileSystemProviderCapabilities)(b=>{d.delete(b.scheme)})),this.extUri=new M.$kg(v),this.d=new D.$wr((b,$)=>this.extUri.compare(b,$,!0),this.f)}dispose(){this.c.dispose(),this.d.clear()}asCanonicalUri(y){this.g.hasProvider(y)&&(y=(0,M.$wg)(y));const d=this.d.get(y);return d?d.touch().uri.with({fragment:y.fragment}):(this.d.set(y,new a(y)),this.h(),y)}h(){if(this.d.size<this.f)return;const y=[...this.d.entries()].sort((v,b)=>v[1].time<b[1].time?1:v[1].time>b[1].time?-1:0);a._clock=0,this.d.clear();const d=this.f*.5;for(let v=0;v<d;v++)this.d.set(y[v][0],y[v][1].touch())}};e.$xr=g,e.$xr=g=ke([ee(0,s.$0j)],g),(0,R.$ur)(S.$Hk,g,1)}),define(te[127],ie([0,1,6]),function(Q,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5T=void 0,e.$5T=(0,S.$Oh)("urlService")}),define(te[265],ie([0,1,7]),function(Q,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$p7b=e.$o7b=e.$n7b=void 0;class R{constructor(P){this.a=P}listen(P,f){throw new Error(`Event not found: ${f}`)}call(P,f,a){switch(f){case"handleURL":return this.a.handleURL(S.URI.revive(a[0]),a[1])}throw new Error(`Call not found: ${f}`)}}e.$n7b=R;class s{constructor(P){this.a=P}handleURL(P,f){return this.a.call("handleURL",[P.toJSON(),f])}}e.$o7b=s;class M{constructor(P,f){this.a=P,this.b=f}async routeCall(P,f,a,g){if(f!=="handleURL")throw new Error(`Call not found: ${f}`);if(Array.isArray(a)&&a.length>0){const w=S.URI.revive(a[0]);if(this.b.trace("URLHandlerRouter#routeCall() with URI argument",w.toString(!0)),w.query){const y=/\bwindowId=(\d+)/.exec(w.query);if(y){const d=y[1];this.b.trace(`URLHandlerRouter#routeCall(): found windowId query parameter with value "${d}"`,w.toString(!0));const v=new RegExp(`window:${d}`),b=P.connections.find($=>(this.b.trace("URLHandlerRouter#routeCall(): testing connection",$.ctx),v.test($.ctx)));if(b)return this.b.trace("URLHandlerRouter#routeCall(): found a connection to route",w.toString(!0)),b;this.b.trace("URLHandlerRouter#routeCall(): did not find a connection to route",w.toString(!0))}else this.b.trace("URLHandlerRouter#routeCall(): did not find windowId query parameter",w.toString(!0))}}else this.b.trace("URLHandlerRouter#routeCall() without URI argument");return this.a.routeCall(P,f,a,g)}routeEvent(P,f){throw new Error(`Event not found: ${f}`)}}e.$p7b=M}),define(te[266],ie([0,1,8,2,7,24]),function(Q,e,S,R,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7T=e.$6T=void 0;class D extends R.$Sc{constructor(){super(...arguments),this.a=new Set}open(a,g){const w=[...this.a.values()];return(0,S.$Xg)(w.map(y=>()=>y.handleURL(a,g)),void 0,!1).then(y=>y||!1)}registerHandler(a){return this.a.add(a),(0,R.$Qc)(()=>this.a.delete(a))}}e.$6T=D;let P=class extends D{constructor(a){super(),this.b=a}create(a){let{authority:g,path:w,query:y,fragment:d}=a||{authority:void 0,path:void 0,query:void 0,fragment:void 0};return g&&w&&w.indexOf("/")!==0&&(w=`/${w}`),s.URI.from({scheme:this.b.urlProtocol,authority:g,path:w,query:y,fragment:d})}};e.$7T=P,e.$7T=P=ke([ee(0,M.$oj)],P)}),define(te[267],ie([0,1,15,8,3,2,4,7]),function(Q,e,S,R,s,M,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$q7b=void 0;class f extends M.$Sc{constructor(g,w,y,d,v,b){if(super(),this.c=w,this.f=b,this.a=[],this.b=0,g&&(b.trace("ElectronURLListener initialUrisToHandle:",g.map(u=>u.originalUrl)),this.a=g),D.$j){const u=d.isBuilt?[]:[`"${d.appRoot}"`];u.push("--open-url","--"),S.app.setAsDefaultProtocolClient(v.urlProtocol,process.execPath,u)}const $=s.Event.map(s.Event.fromNodeEventEmitter(S.app,"open-url",(u,l)=>({event:u,url:l})),({event:u,url:l})=>(u.preventDefault(),l));this.B($(u=>{const l=this.g(u);l&&this.c.open(l,{originalUrl:u})})),y.getWindows().filter(u=>u.isReady).length>0?(b.trace("ElectronURLListener: window is ready to handle URLs"),this.h()):(b.trace("ElectronURLListener: waiting for window to be ready to handle URLs..."),this.B(s.Event.once(y.onDidSignalReadyWindow)(()=>this.h())))}g(g){try{return P.URI.parse(g)}catch{return}}async h(){if(this.b++>10){this.f.trace("ElectronURLListener#flush(): giving up after 10 retries");return}this.f.trace("ElectronURLListener#flush(): flushing URLs");const g=[];for(const w of this.a)await this.c.open(w.uri,{originalUrl:w.originalUrl})?this.f.trace("ElectronURLListener#flush(): URL was handled",w.originalUrl):(this.f.trace("ElectronURLListener#flush(): URL was not yet handled",w.originalUrl),g.push(w));g.length!==0&&(this.a=g,(0,R.$Vg)(()=>this.h(),500,this.q))}}e.$q7b=f}),define(te[268],ie([0,1,3,2,16,56,31]),function(Q,e,S,R,s,M,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$37b=void 0;class P extends R.$Sc{constructor(a,g,w,y,d,v){super(),this.f=a,this.g=g,this.h=w,this.j=y,this.m=d,this.n=v,this.capabilities=this.g.capabilities,this.onDidChangeCapabilities=this.g.onDidChangeCapabilities,this.a=this.B(new S.$Nd),this.onDidChangeFile=this.a.event,this.b=M.$Uh.forUris(()=>!(this.capabilities&1024)),this.c=new D.$Bc(b=>this.m.extUri.getComparisonKey(this.t(b))),this.r(),this.B(y.onDidChangeProfiles(()=>this.r())),this.B(this.g.onDidChangeFile(b=>this.s(b)))}r(){this.c.clear();for(const a of this.j.profiles)this.c.add(a.settingsResource),this.c.add(a.keybindingsResource),this.c.add(a.tasksResource),this.c.add(a.extensionsResource)}open(a,g){return this.g.open(this.t(a),g)}close(a){return this.g.close(a)}read(a,g,w,y,d){return this.g.read(a,g,w,y,d)}write(a,g,w,y,d){return this.g.write(a,g,w,y,d)}watch(a,g){this.b.set(a,a);const w=this.g.watch(this.t(a),g);return(0,R.$Qc)(()=>{this.b.delete(a),w.dispose()})}stat(a){return this.g.stat(this.t(a))}mkdir(a){return this.g.mkdir(this.t(a))}rename(a,g,w){return this.g.rename(this.t(a),this.t(g),w)}readFile(a,g){return this.g.readFile(this.t(a),g)}readFileStream(a,g,w){return this.g.readFileStream(this.t(a),g,w)}readdir(a){return this.g.readdir(this.t(a))}enforceAtomicReadFile(a){return this.c.has(a)}writeFile(a,g,w){return this.g.writeFile(this.t(a),g,w)}enforceAtomicWriteFile(a){return this.c.has(a)?{postfix:".vsctmp"}:!1}delete(a,g){return this.g.delete(this.t(a),g)}copy(a,g,w){if((0,s.$bk)(this.g))return this.g.copy(this.t(a),this.t(g),w);throw new Error("copy not supported")}cloneFile(a,g){if((0,s.$ck)(this.g))return this.g.cloneFile(this.t(a),this.t(g));throw new Error("clone not supported")}s(a){const g=[];for(const w of a){if(w.resource.scheme!==this.f)continue;const y=this.u(w.resource);this.b.findSubstr(y)&&g.push({resource:y,type:w.type,cId:w.cId})}g.length&&(this.n.debug("User data changed"),this.a.fire(g))}t(a){return a.with({scheme:this.f})}u(a){return a.with({scheme:this.h})}}e.$37b=P}),define(te[269],ie([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$J7b=void 0,e.$J7b="utilityProcessWorker"}),define(te[270],ie([0,1,6]),function(Q,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$r7b=void 0,e.$r7b=(0,S.$Oh)("webviewManagerService")}),define(te[271],ie([0,1,15,2,13,7]),function(Q,e,S,R,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$s7b=void 0;class D extends R.$Sc{static{this.a=new Map([["/index.html","index.html"],["/fake.html","fake.html"],["/service-worker.js","service-worker.js"]])}constructor(){super();const f=this.b.bind(this);S.protocol.registerFileProtocol(s.Schemas.vscodeWebview,f)}b(f,a){try{const g=M.URI.parse(f.url),w=D.a.get(g.path);if(typeof w=="string"){const y=`vs/workbench/contrib/webview/browser/pre/${w}`,d=s.$cg.asFileUri(y);return a({path:d.fsPath,headers:{...s.COI.getHeadersFromQuery(f.url),"Cross-Origin-Resource-Policy":"cross-origin"}})}else return a({error:-10})}catch{}return a({error:-2})}}e.$s7b=D}),define(te[68],ie([0,1,4]),function(Q,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5C=e.$4C=e.$3C=e.$2C=e.$1C=e.$ZC=e.$YC=e.$XC=void 0,e.$XC={WIDTH:400,WIDTH_WITH_VERTICAL_PANEL:600,HEIGHT:270};function R(g){return!!g.workspaceUri}e.$YC=R;function s(g){return!!g.folderUri}e.$ZC=s;function M(g){return!!g.fileUri}e.$1C=M;function D(g){const w=P(g),y=g.getValue("window.menuBarVisibility");return y==="default"||w==="native"&&y==="compact"||S.$k&&S.$n?"classic":y}e.$2C=D;function P(g){if(S.$p)return"custom";const w=g.getValue("window");if(w){if(S.$k&&w.nativeTabs===!0||S.$k&&w.nativeFullScreen===!1)return"native";const v=w.titleBarStyle;if(v==="native"||v==="custom")return v}return S.$l?"native":"custom"}e.$3C=P;function f(g){return!(!S.$j||S.$p||P(g)==="native")}e.$4C=f;function a(g=0){return Math.pow(1.2,g)}e.$5C=a}),define(te[95],ie([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowError=e.WindowMode=e.$15b=e.UnloadReason=e.LoadReason=void 0;var S;(function(P){P[P.INITIAL=1]="INITIAL",P[P.LOAD=2]="LOAD",P[P.RELOAD=3]="RELOAD"})(S||(e.LoadReason=S={}));var R;(function(P){P[P.CLOSE=1]="CLOSE",P[P.QUIT=2]="QUIT",P[P.RELOAD=3]="RELOAD",P[P.LOAD=4]="LOAD"})(R||(e.UnloadReason=R={}));const s=function(P=1){return{width:1024,height:768,mode:P}};e.$15b=s;var M;(function(P){P[P.Maximized=0]="Maximized",P[P.Normal=1]="Normal",P[P.Minimized=2]="Minimized",P[P.Fullscreen=3]="Fullscreen"})(M||(e.WindowMode=M={}));var D;(function(P){P[P.UNRESPONSIVE=1]="UNRESPONSIVE",P[P.PROCESS_GONE=2]="PROCESS_GONE",P[P.LOAD=3]="LOAD"})(D||(e.WindowError=D={}))}),define(te[272],ie([0,1,8,3,2]),function(Q,e,S,R,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$z7b=void 0;class M extends s.$Sc{constructor({onDidOpenWindow:P,onDidFocusWindow:f,getActiveWindowId:a}){super(),this.a=this.B(new s.$Rc),R.Event.latch(R.Event.any(P,f))(this.f,this,this.a),this.b=(0,S.$Hg)(()=>a()),(async()=>{try{const w=await this.b;this.c=typeof this.c=="number"?this.c:w}catch{}finally{this.b=void 0}})()}f(P){this.b&&(this.b.cancel(),this.b=void 0),this.c=P}async getActiveClientId(){return`window:${this.b?await this.b:this.c}`}}e.$z7b=M}),define(te[29],ie([0,1,190,9,56,19,7,6,13]),function(Q,e,S,R,s,M,D,P,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hi=e.$gi=e.$fi=e.$ei=e.$di=e.$ci=e.$bi=e.$ai=e.$_h=e.$$h=e.$0h=e.$9h=e.$8h=e.$7h=e.$6h=e.WorkbenchState=e.$5h=e.$4h=e.$3h=e.$2h=e.$1h=e.$Zh=e.$Yh=e.$Xh=void 0,e.$Xh=(0,P.$Oh)("contextService");function a(t){const n=t;return typeof n?.id=="string"&&D.URI.isUri(n.uri)}e.$Yh=a;function g(t){return typeof t?.id=="string"&&!a(t)&&!y(t)}e.$Zh=g,e.$1h={id:"ext-dev"},e.$2h={id:"empty-window"};function w(t,n){if(typeof t=="string"||typeof t>"u")return typeof t=="string"?{id:(0,R.$nc)(t)}:n?e.$1h:e.$2h;const r=t;return r.configuration?{id:r.id,configPath:r.configuration}:r.folders.length===1?{id:r.id,uri:r.folders[0].uri}:{id:r.id}}e.$3h=w;function y(t){const n=t;return typeof n?.id=="string"&&D.URI.isUri(n.configPath)}e.$4h=y;function d(t){const n=t;if(n?.uri)return{id:n.id,uri:D.URI.revive(n.uri)};const r=t;if(r?.configPath)return{id:r.id,configPath:D.URI.revive(r.configPath)};if(t?.id)return{id:t.id}}e.$5h=d;var v;(function(t){t[t.EMPTY=1]="EMPTY",t[t.FOLDER=2]="FOLDER",t[t.WORKSPACE=3]="WORKSPACE"})(v||(e.WorkbenchState=v={}));function b(t){const n=t;return!!(n&&typeof n=="object"&&typeof n.id=="string"&&Array.isArray(n.folders))}e.$6h=b;function $(t){const n=t;return!!(n&&typeof n=="object"&&D.URI.isUri(n.uri)&&typeof n.name=="string"&&typeof n.toResource=="function")}e.$7h=$;class m{constructor(n,r,p,A,C){this.h=n,this.j=p,this.k=A,this.l=C,this.c=s.$Uh.forUris(this.l,()=>!0),this.folders=r}update(n){this.h=n.id,this.k=n.configuration,this.j=n.transient,this.l=n.l,this.folders=n.folders}get folders(){return this.g}set folders(n){this.g=n,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(n){this.k=n}getFolder(n){return n&&this.c.findSubstr(n)||null}n(){this.c=s.$Uh.forUris(this.l,()=>!0);for(const n of this.folders)this.c.set(n.uri,n)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$8h=m;class u{constructor(n,r){this.raw=r,this.uri=n.uri,this.index=n.index,this.name=n.name}toResource(n){return(0,M.$vg)(this.uri,n)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$9h=u;function l(t){return new u({uri:t,index:0,name:(0,M.$rg)(t)},{uri:t.toString()})}e.$0h=l,e.$$h="code-workspace",e.$_h=`.${e.$$h}`,e.$ai=[{name:(0,S.localize)(0,null),extensions:[e.$$h]}],e.$bi="workspace.json";function E(t,n){return M.$mg.isEqualOrParent(t,n.untitledWorkspacesHome)}e.$ci=E;function h(t){let n;return D.URI.isUri(t)?n=t:n=t.configuration,n?.scheme===f.Schemas.tmp}e.$di=h,e.$ei="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function i(t){return t.id===e.$ei}e.$fi=i;function c(t,n){return!E(t,n)&&!h(t)}e.$gi=c;function o(t){return(typeof t=="string"?(0,R.$oc)(t):(0,M.$tg)(t))===e.$_h}e.$hi=o}),define(te[59],ie([0,1,15,8,55,46,2,84,4,21,165,115,6,5,24,29]),function(Q,e,S,R,s,M,D,P,f,a,g,w,y,d,v,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$t6b=e.$s6b=void 0,e.$s6b=(0,y.$Oh)("dialogMainService");let $=class{constructor(u,l){this.d=u,this.e=l,this.a=new Map,this.b=new Map,this.c=new R.$1g}pickFileFolder(u,l){return this.f({...u,pickFolders:!0,pickFiles:!0,title:(0,g.localize)(0,null)},l)}pickFolder(u,l){return this.f({...u,pickFolders:!0,title:(0,g.localize)(1,null)},l)}pickFile(u,l){return this.f({...u,pickFiles:!0,title:(0,g.localize)(2,null)},l)}pickWorkspace(u,l){const E=(0,g.localize)(3,null),h=(0,M.$uv)((0,g.localize)(4,null)),i=b.$ai;return this.f({...u,pickFiles:!0,title:E,filters:i,buttonLabel:h},l)}async f(u,l){const E={title:u.title,buttonLabel:u.buttonLabel,filters:u.filters,defaultPath:u.defaultPath};(typeof u.pickFiles=="boolean"||typeof u.pickFolders=="boolean")&&(E.properties=void 0,u.pickFiles&&u.pickFolders&&(E.properties=["multiSelections","openDirectory","openFile","createDirectory"])),E.properties||(E.properties=["multiSelections",u.pickFolders?"openDirectory":"openFile","createDirectory"]),f.$k&&E.properties.push("treatPackageAsDirectory");const h=await this.showOpenDialog(E,(l||S.BrowserWindow.getFocusedWindow())??void 0);if(h&&h.filePaths&&h.filePaths.length>0)return h.filePaths}g(u){if(u){let l=this.b.get(u.id);return l||(l=new R.$1g,this.b.set(u.id,l)),l}else return this.c}showMessageBox(u,l){return this.g(l).queue(async()=>{const{options:E,buttonIndeces:h}=(0,w.$Bv)(u,this.e);let i;return l?i=await S.dialog.showMessageBox(l,E):i=await S.dialog.showMessageBox(E),{response:h[i.response],checkboxChecked:i.checkboxChecked}})}async showSaveDialog(u,l){const E=this.j(u,l);if(!E)return this.d.error("[DialogMainService]: file save dialog is already or will be showing for the window with the same configuration"),{canceled:!0};try{return await this.g(l).queue(async()=>{let h;return l?h=await S.dialog.showSaveDialog(l,u):h=await S.dialog.showSaveDialog(u),h.filePath=this.h(h.filePath),h})}finally{(0,D.$Nc)(E)}}h(u){return u&&f.$k&&(u=(0,P.$ml)(u)),u}i(u){return u.map(l=>this.h(l))}async showOpenDialog(u,l){u.defaultPath&&(await a.Promises.exists(u.defaultPath)||(u.defaultPath=void 0));const E=this.j(u,l);if(!E)return this.d.error("[DialogMainService]: file open dialog is already or will be showing for the window with the same configuration"),{canceled:!0,filePaths:[]};try{return await this.g(l).queue(async()=>{let h;return l?h=await S.dialog.showOpenDialog(l,u):h=await S.dialog.showOpenDialog(u),h.filePaths=this.i(h.filePaths),h})}finally{(0,D.$Nc)(E)}}j(u,l){if(!l)return D.$Sc.None;this.d.trace("[DialogMainService]: request to acquire file dialog lock",u);let E=this.a.get(l.id);E||(E=new Set,this.a.set(l.id,E));const h=(0,s.$Ci)(u);if(!E.has(h))return this.d.trace("[DialogMainService]: new file dialog lock created",u),E.add(h),(0,D.$Qc)(()=>{this.d.trace("[DialogMainService]: file dialog lock disposed",u),E?.delete(h),E?.size===0&&this.a.delete(l.id)})}};e.$t6b=$,e.$t6b=$=ke([ee(0,d.$9i),ee(1,v.$oj)],$)}),define(te[273],ie([0,1,3,2,76,29]),function(Q,e,S,R,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$c7b=void 0;class D extends R.$Sc{static{this.a=100}constructor(f,a){super(),this.f=f,this.g=a,this.b=this.B(new S.$Nd),this.c=new Map,this.h(a.applicationStorage,this.b)}h(f,a){this.B(S.Event.debounce(f.onDidChangeStorage,(g,w)=>(g?g.push(w):g=[w],g),D.a)(g=>{g.length&&a.fire(this.j(g,f))}))}j(f,a){const g=new Map,w=new Set;return f.forEach(y=>{const d=a.get(y.key);typeof d=="string"?g.set(y.key,d):w.add(y.key)}),{changed:Array.from(g.entries()),deleted:Array.from(w.values())}}listen(f,a,g){switch(a){case"onDidChangeStorage":{const w=g.profile?(0,s.$lh)(g.profile):void 0;if(!w)return this.b.event;let y=this.c.get(w.id);return y||(y=this.B(new S.$Nd),this.h(this.g.profileStorage(w),y),this.c.set(w.id,y)),y.event}}throw new Error(`Event not found: ${a}`)}async call(f,a,g){const w=g.profile?(0,s.$lh)(g.profile):void 0,y=(0,M.$5h)(g.workspace),d=await this.m(w,y);switch(a){case"getItems":return Array.from(d.items.entries());case"updateItems":{const v=g;if(v.insert)for(const[b,$]of v.insert)d.set(b,$);v.delete?.forEach(b=>d.delete(b));break}case"optimize":return d.optimize();case"isUsed":{const v=g.payload;if(typeof v=="string")return this.g.isUsed(v)}default:throw new Error(`Call not found: ${a}`)}}async m(f,a){let g;a?g=this.g.workspaceStorage(a):f?g=this.g.profileStorage(f):g=this.g.applicationStorage;try{await g.init()}catch(w){this.f.error(`StorageIPC#init: Unable to init ${a?"workspace":f?"profile":"application"} storage due to ${w}`)}return g}}e.$c7b=D}),define(te[41],ie([0,1,55,3,2,19,7,187,36,16,6,5,29,31,40,8,32,27,12]),function(Q,e,S,R,s,M,D,P,f,a,g,w,y,d,v,b,$,m,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nk=e.$Mk=e.$Lk=e.$Kk=e.$Jk=e.$Ik=e.ProfileResourceType=void 0;var l;(function(t){t.Settings="settings",t.Keybindings="keybindings",t.Snippets="snippets",t.Tasks="tasks",t.Extensions="extensions",t.GlobalState="globalState"})(l||(e.ProfileResourceType=l={}));function E(t){const n=t;return!!(n&&typeof n=="object"&&typeof n.id=="string"&&typeof n.isDefault=="boolean"&&typeof n.name=="string"&&D.URI.isUri(n.location)&&D.URI.isUri(n.globalStorageHome)&&D.URI.isUri(n.settingsResource)&&D.URI.isUri(n.keybindingsResource)&&D.URI.isUri(n.tasksResource)&&D.URI.isUri(n.snippetsHome)&&D.URI.isUri(n.extensionsResource))}e.$Ik=E,e.$Jk=(0,g.$Oh)("IUserDataProfilesService");function h(t,n){return{id:t.id,isDefault:t.isDefault,name:t.name,shortName:t.shortName,icon:t.icon,location:D.URI.revive(t.location).with({scheme:n}),globalStorageHome:D.URI.revive(t.globalStorageHome).with({scheme:n}),settingsResource:D.URI.revive(t.settingsResource).with({scheme:n}),keybindingsResource:D.URI.revive(t.keybindingsResource).with({scheme:n}),tasksResource:D.URI.revive(t.tasksResource).with({scheme:n}),snippetsHome:D.URI.revive(t.snippetsHome).with({scheme:n}),extensionsResource:D.URI.revive(t.extensionsResource).with({scheme:n}),cacheHome:D.URI.revive(t.cacheHome).with({scheme:n}),useDefaultFlags:t.useDefaultFlags,isTransient:t.isTransient}}e.$Kk=h;function i(t,n,r,p,A,C){return{id:t,name:n,location:r,isDefault:!1,shortName:A?.shortName,icon:A?.icon,globalStorageHome:C&&A?.useDefaultFlags?.globalState?C.globalStorageHome:(0,M.$vg)(r,"globalStorage"),settingsResource:C&&A?.useDefaultFlags?.settings?C.settingsResource:(0,M.$vg)(r,"settings.json"),keybindingsResource:C&&A?.useDefaultFlags?.keybindings?C.keybindingsResource:(0,M.$vg)(r,"keybindings.json"),tasksResource:C&&A?.useDefaultFlags?.tasks?C.tasksResource:(0,M.$vg)(r,"tasks.json"),snippetsHome:C&&A?.useDefaultFlags?.snippets?C.snippetsHome:(0,M.$vg)(r,"snippets"),extensionsResource:C&&A?.useDefaultFlags?.extensions?C.extensionsResource:(0,M.$vg)(r,"extensions.json"),cacheHome:(0,M.$vg)(p,t),useDefaultFlags:A?.useDefaultFlags,isTransient:A?.transient}}e.$Lk=i;let c=class extends s.$Sc{static{this.b="userDataProfiles"}static{this.c="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.C.profiles,...this.s.profiles]}constructor(n,r,p,A){super(),this.t=n,this.u=r,this.w=p,this.y=A,this.f=!0,this.h=this.B(new R.$Nd),this.onDidChangeProfiles=this.h.event,this.j=this.B(new R.$Nd),this.onWillCreateProfile=this.j.event,this.m=this.B(new R.$Nd),this.onWillRemoveProfile=this.m.event,this.n=this.B(new R.$Nd),this.onDidResetWorkspaces=this.n.event,this.r=new Map,this.s={profiles:[],workspaces:new d.$Ac,emptyWindows:new Map},this.profilesHome=(0,M.$vg)(this.t.userRoamingDataHome,"profiles"),this.g=(0,M.$vg)(this.t.cacheHome,"CachedProfilesData")}init(){this.z=void 0}setEnablement(n){this.f!==n&&(this.z=void 0,this.f=n)}isEnabled(){return this.f}get C(){if(!this.z){const n=this.D(),r=[n];if(this.f)try{for(const C of this.O()){if(!C.name||!(0,u.$yf)(C.name)||!C.location){this.y.warn("Skipping the invalid stored profile",C.location||C.name);continue}r.push(i((0,M.$sg)(C.location),C.name,C.location,this.g,{shortName:C.shortName,icon:C.icon,useDefaultFlags:C.useDefaultFlags},n))}}catch(C){this.y.error(C)}const p=new d.$Ac,A=new Map;if(r.length)try{const C=this.Q();if(C.workspaces)for(const[k,I]of Object.entries(C.workspaces)){const j=D.URI.parse(k),U=r.find(z=>z.id===I);U&&p.set(j,U)}if(C.emptyWindows)for(const[k,I]of Object.entries(C.emptyWindows)){const j=r.find(U=>U.id===I);j&&A.set(k,j)}}catch(C){this.y.error(C)}this.z={profiles:r,workspaces:p,emptyWindows:A}}return this.z}D(){const n=i("__default__profile__",(0,P.localize)(0,null),this.t.userRoamingDataHome,this.g);return{...n,extensionsResource:this.S()??n.extensionsResource,isDefault:!0}}async createTransientProfile(n){const r="Temp",p=new RegExp(`${(0,m.$Fe)(r)}\\s(\\d+)`);let A=0;for(const k of this.profiles){const I=p.exec(k.name),j=I?parseInt(I[1]):0;A=j>A?j:A}const C=`${r} ${A+1}`;return this.createProfile((0,S.$Ci)((0,$.$eg)()).toString(16),C,{transient:!0},n)}async createNamedProfile(n,r,p){return this.createProfile((0,S.$Ci)((0,$.$eg)()).toString(16),n,r,p)}async createProfile(n,r,p,A){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const C=await this.F(n,r,p);return A&&await this.setProfileForWorkspace(A,C),C}async F(n,r,p){if(!(0,u.$yf)(r)||!r)throw new Error("Name of the profile is mandatory and must be of type `string`");let A=this.r.get(r);return A||(A=(async()=>{try{const C=this.profiles.find(j=>j.name===r||j.id===n);if(C)return C;const k=i(n,r,(0,M.$vg)(this.profilesHome,n),this.g,p,this.defaultProfile);await this.u.createFolder(k.location);const I=[];return this.j.fire({profile:k,join(j){I.push(j)}}),await b.Promises.settled(I),this.I([k],[],[]),k}finally{this.r.delete(r)}})(),this.r.set(r,A)),A}async updateProfile(n,r){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let p=this.profiles.find(A=>A.id===n.id);if(!p)throw new Error(`Profile '${n.name}' does not exist`);return p=i(p.id,r.name??p.name,p.location,this.g,{shortName:r.shortName??p.shortName,icon:r.icon===null?void 0:r.icon??p.icon,transient:r.transient??p.isTransient,useDefaultFlags:r.useDefaultFlags??p.useDefaultFlags},this.defaultProfile),this.I([],[],[p]),p}async removeProfile(n){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(n.isDefault)throw new Error("Cannot remove default profile");const r=this.profiles.find(A=>A.id===n.id);if(!r)throw new Error(`Profile '${n.name}' does not exist`);const p=[];this.m.fire({profile:r,join(A){p.push(A)}});try{await Promise.allSettled(p)}catch(A){this.y.error(A)}for(const A of[...this.C.emptyWindows.keys()])r.id===this.C.emptyWindows.get(A)?.id&&this.C.emptyWindows.delete(A);for(const A of[...this.C.workspaces.keys()])r.id===this.C.workspaces.get(A)?.id&&this.C.workspaces.delete(A);this.M(),this.I([],[r],[]);try{await this.u.del(r.cacheHome,{recursive:!0})}catch(A){(0,a.$ok)(A)!==1&&this.y.error(A)}}async setProfileForWorkspace(n,r){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const p=this.profiles.find(A=>A.id===r.id);if(!p)throw new Error(`Profile '${r.name}' does not exist`);this.L(n,p)}unsetWorkspace(n,r){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.L(n,void 0,r)}async resetWorkspaces(){this.s.workspaces.clear(),this.s.emptyWindows.clear(),this.C.workspaces.clear(),this.C.emptyWindows.clear(),this.M(),this.n.fire()}async cleanUp(){if(this.f&&await this.u.exists(this.profilesHome)){const n=await this.u.resolve(this.profilesHome);await Promise.all((n.children||[]).filter(r=>r.isDirectory&&this.profiles.every(p=>!this.w.extUri.isEqual(p.location,r.resource))).map(r=>this.u.del(r.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const n=this.s.profiles.filter(r=>!this.H(r));await Promise.allSettled(n.map(r=>this.removeProfile(r)))}getProfileForWorkspace(n){const r=this.G(n);return D.URI.isUri(r)?this.s.workspaces.get(r)??this.C.workspaces.get(r):this.s.emptyWindows.get(r)??this.C.emptyWindows.get(r)}G(n){return(0,y.$Yh)(n)?n.uri:(0,y.$4h)(n)?n.configPath:n.id}H(n){return!!([...this.s.emptyWindows.values()].some(r=>this.w.extUri.isEqual(r.location,n.location))||[...this.s.workspaces.values()].some(r=>this.w.extUri.isEqual(r.location,n.location))||[...this.C.emptyWindows.values()].some(r=>this.w.extUri.isEqual(r.location,n.location))||[...this.C.workspaces.values()].some(r=>this.w.extUri.isEqual(r.location,n.location)))}I(n,r,p){const A=[...this.profiles,...n],C=[];this.s.profiles=[];for(let k of A)k.isDefault||r.some(I=>k.id===I.id)||(k=p.find(I=>k.id===I.id)??k,k.isTransient?this.s.profiles.push(k):C.push({location:k.location,name:k.name,shortName:k.shortName,icon:k.icon,useDefaultFlags:k.useDefaultFlags}));this.P(C),this.z=void 0,this.J(n,r,p)}J(n,r,p){this.h.fire({added:n,removed:r,updated:p,all:this.profiles})}L(n,r,p){p=r?.isTransient?!0:p,p||this.L(n,void 0,!0);const A=this.G(n),C=p?this.s:this.C;D.URI.isUri(A)?(C.workspaces.delete(A),r&&C.workspaces.set(A,r)):(C.emptyWindows.delete(A),r&&C.emptyWindows.set(A,r)),p||this.M()}M(){const n={};for(const[p,A]of this.C.workspaces.entries())n[p.toString()]=A.id;const r={};for(const[p,A]of this.C.emptyWindows.entries())r[p.toString()]=A.id;this.R({workspaces:n,emptyWindows:r}),this.z=void 0}N(n){const r={},p=this.D();if(n.workspaces)for(const[C,k]of Object.entries(n.workspaces)){const I=D.URI.parse(k);r[C]=this.w.extUri.isEqual(I,p.location)?p.id:this.w.extUri.basename(I)}const A={};if(n.emptyWindows)for(const[C,k]of Object.entries(n.emptyWindows)){const I=D.URI.parse(k);A[C]=this.w.extUri.isEqual(I,p.location)?p.id:this.w.extUri.basename(I)}return{workspaces:r,emptyWindows:A}}O(){return[]}P(n){throw new Error("not implemented")}Q(){return{}}R(n){throw new Error("not implemented")}S(){}};e.$Mk=c,e.$Mk=c=ke([ee(0,f.$Vh),ee(1,a.$0j),ee(2,v.$Hk),ee(3,w.$9i)],c);class o extends c{constructor(){super(...arguments),this.a=[],this.X={}}O(){return this.a}P(n){this.a=n}Q(){return this.X}R(n){this.X=n}}e.$Nk=o}),define(te[80],ie([0,1,8,17,2,3,31,7,117,123,16,6,5,41,40,12,14,26]),function(Q,e,S,R,s,M,D,P,f,a,g,w,y,d,v,b,$,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tp=e.$sp=e.$rp=e.ExtensionsProfileScanningErrorCode=void 0;var u;(function(c){c.ERROR_PROFILE_NOT_FOUND="ERROR_PROFILE_NOT_FOUND",c.ERROR_INVALID_CONTENT="ERROR_INVALID_CONTENT"})(u||(e.ExtensionsProfileScanningErrorCode=u={}));class l extends Error{constructor(o,t){super(o),this.code=t}}e.$rp=l,e.$sp=(0,w.$Oh)("IExtensionsProfileScannerService");let E=class extends s.$Sc{constructor(o,t,n,r,p,A){super(),this.j=o,this.m=t,this.n=n,this.r=r,this.s=p,this.t=A,this.b=this.B(new M.$Nd),this.onAddExtensions=this.b.event,this.c=this.B(new M.$Nd),this.onDidAddExtensions=this.c.event,this.f=this.B(new M.$Nd),this.onRemoveExtensions=this.f.event,this.g=this.B(new M.$Nd),this.onDidRemoveExtensions=this.g.event,this.h=new D.$Ac}scanProfileExtensions(o,t){return this.u(o,void 0,t)}async addExtensionsToProfile(o,t){const n=[],r=[];try{return await this.u(t,p=>{const A=[];for(const C of p)o.some(([k])=>(0,a.$xo)(k.identifier,C.identifier)&&k.manifest.version!==C.version)?n.push(C):A.push(C);for(const[C,k]of o){const I=A.findIndex(U=>(0,a.$xo)(U.identifier,C.identifier)&&U.version===C.manifest.version),j={identifier:C.identifier,version:C.manifest.version,location:C.location,metadata:k};I===-1?(r.push(j),A.push(j)):A.splice(I,1,j)}return r.length&&this.b.fire({extensions:r,profileLocation:t}),n.length&&this.f.fire({extensions:n,profileLocation:t}),A}),r.length&&this.c.fire({extensions:r,profileLocation:t}),n.length&&this.g.fire({extensions:n,profileLocation:t}),r}catch(p){throw r.length&&this.c.fire({extensions:r,error:p,profileLocation:t}),n.length&&this.g.fire({extensions:n,error:p,profileLocation:t}),p}}async updateMetadata(o,t){const n=[];return await this.u(t,r=>{const p=[];for(const A of r){const C=o.find(([k])=>(0,a.$xo)(k.identifier,A.identifier)&&k.manifest.version===A.version);C&&(A.metadata={...A.metadata,...C[1]},n.push(A)),p.push(A)}return p}),n}async removeExtensionFromProfile(o,t){const n=[];try{await this.u(t,r=>{const p=[];for(const A of r)(0,a.$xo)(A.identifier,o.identifier)?n.push(A):p.push(A);return n.length&&this.f.fire({extensions:n,profileLocation:t}),p}),n.length&&this.g.fire({extensions:n,profileLocation:t})}catch(r){throw n.length&&this.g.fire({extensions:n,error:r,profileLocation:t}),r}}async u(o,t,n){return this.F(o).queue(async()=>{let r=[],p;try{const A=await this.m.readFile(o);p=JSON.parse(A.value.toString().trim()||"[]")}catch(A){if((0,g.$ok)(A)!==1)throw A;if(this.r.extUri.isEqual(o,this.n.defaultProfile.extensionsResource)&&(p=await this.D()),!p&&n?.bailOutWhenFileNotFound)throw new l((0,$.$0)(A),"ERROR_PROFILE_NOT_FOUND")}if(p){Array.isArray(p)||this.w(o);let A=!1;for(const C of p){h(C)||this.w(o);let k;if((0,b.$yf)(C.relativeLocation)&&C.relativeLocation)k=this.z(C.relativeLocation);else if((0,b.$yf)(C.location))k=this.z(C.location),A=!0,C.relativeLocation=C.location,C.location=k.toJSON();else{k=P.URI.revive(C.location);const I=this.y(k);I&&(A=!0,C.relativeLocation=I)}r.push({identifier:C.identifier,location:k,version:C.version,metadata:C.metadata})}A&&await this.m.writeFile(o,R.$be.fromString(JSON.stringify(p)))}if(t){r=t(r);const A=r.map(C=>({identifier:C.identifier,version:C.version,location:C.location.toJSON(),relativeLocation:this.y(C.location),metadata:C.metadata}));await this.m.writeFile(o,R.$be.fromString(JSON.stringify(A)))}return r})}w(o){const t=new l(`Invalid extensions content in ${o.toString()}`,"ERROR_INVALID_CONTENT");throw this.s.publicLogError2("extensionsProfileScanningError",{code:t.code}),t}y(o){return this.r.extUri.isEqual(this.r.extUri.dirname(o),this.j)?this.r.extUri.basename(o):void 0}z(o){return this.r.extUri.joinPath(this.j,o)}async D(){return this.C||(this.C=(async()=>{const o=this.r.extUri.joinPath(this.n.defaultProfile.location,"extensions.json"),t=this.r.extUri.joinPath(this.j,".init-default-profile-extensions");let n;try{n=(await this.m.readFile(o)).value.toString()}catch(p){if((0,g.$ok)(p)===1)return;throw p}this.t.info("Migrating extensions from old default profile location",o.toString());let r;try{const p=JSON.parse(n);Array.isArray(p)&&p.every(A=>h(A))?r=p:this.t.warn("Skipping migrating from old default profile locaiton: Found invalid data",p)}catch(p){this.t.error(p)}if(r)try{await this.m.createFile(this.n.defaultProfile.extensionsResource,R.$be.fromString(JSON.stringify(r)),{overwrite:!1}),this.t.info("Migrated extensions from old default profile location to new location",o.toString(),this.n.defaultProfile.extensionsResource.toString())}catch(p){if((0,g.$ok)(p)===3)this.t.info("Migration from old default profile location to new location is done by another window",o.toString(),this.n.defaultProfile.extensionsResource.toString());else throw p}try{await this.m.del(o)}catch(p){(0,g.$ok)(p)!==1&&this.t.error(p)}try{await this.m.del(t)}catch(p){(0,g.$ok)(p)!==1&&this.t.error(p)}return r})()),this.C}F(o){let t=this.h.get(o);return t||(t=new S.$1g,this.h.set(o,t)),t}};e.$tp=E,e.$tp=E=ke([ee(1,g.$0j),ee(2,d.$Jk),ee(3,v.$Hk),ee(4,m.$bl),ee(5,y.$9i)],E);function h(c){return(0,b.$Af)(c)&&(0,f.$7n)(c.identifier)&&(i(c.location)||(0,b.$yf)(c.location)&&c.location)&&((0,b.$Ff)(c.relativeLocation)||(0,b.$yf)(c.relativeLocation))&&c.version&&(0,b.$yf)(c.version)}function i(c){return c?(0,b.$yf)(c.path)&&(0,b.$yf)(c.scheme):!1}}),define(te[128],ie([0,1,23,8,37,17,14,44,150,2,13,9,4,19,203,73,12,7,170,36,123,120,202,16,6,5,24,3,76,80,41,40,201]),function(Q,e,S,R,s,M,D,P,f,a,g,w,y,d,v,b,$,m,u,l,E,h,i,c,o,t,n,r,p,A,C,k,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ap=e.$zp=e.$yp=e.$xp=e.$wp=e.Translations=void 0;var j;(function(oe){function K(J,G){if(J===G)return!0;const N=Object.keys(J),q=new Set;for(const X of Object.keys(G))q.add(X);if(N.length!==q.size)return!1;for(const X of N){if(J[X]!==G[X])return!1;q.delete(X)}return q.size===0}oe.equals=K})(j||(e.Translations=j={})),e.$wp=(0,o.$Oh)("IExtensionsScannerService");let U=class extends a.$Sc{constructor(K,J,G,N,q,X,H,Y,re,F,O,L){super(),this.systemExtensionsLocation=K,this.userExtensionsLocation=J,this.r=G,this.s=N,this.t=q,this.u=X,this.w=H,this.y=Y,this.z=re,this.C=F,this.D=O,this.F=L,this.g=this.B(new r.$Nd),this.onDidChangeCache=this.g.event,this.h=(0,d.$vg)(this.userExtensionsLocation,".obsolete"),this.j=this.B(this.F.createInstance(_,this.s,this.h)),this.m=this.B(this.F.createInstance(_,this.s,this.h)),this.n=this.B(this.F.createInstance(ne,this.h)),this.H=void 0,this.B(this.j.onDidChangeCache(()=>this.g.fire(0))),this.B(this.m.onDidChangeCache(()=>this.g.fire(1)))}getTargetPlatform(){return this.G||(this.G=(0,E.$Io)(this.w,this.y)),this.G}async scanAllExtensions(K,J,G){const[N,q]=await Promise.all([this.scanSystemExtensions(K),this.scanUserExtensions(J)]),X=G?await this.scanExtensionsUnderDevelopment(K,[...N,...q]):[];return this.L(N,q,X,await this.getTargetPlatform(),!0)}async scanSystemExtensions(K){const J=[];J.push(this.M(!!K.useCache,K.language)),J.push(this.N(K.language,!!K.checkControlFile));const[G,N]=await Promise.all(J);return this.J([...G,...N],0,K,!1)}async scanUserExtensions(K){const J=K.profileLocation??this.userExtensionsLocation;this.y.trace("Started scanning user extensions",J);const G=this.D.extUri.isEqual(K.profileLocation,this.t.defaultProfile.extensionsResource)?{bailOutWhenFileNotFound:!0}:void 0,N=await this.P(J,!!K.profileLocation,1,!K.includeUninstalled,K.language,!0,G),q=K.useCache&&!N.devMode&&N.excludeObsolete?this.m:this.n;let X;try{X=await q.scanExtensions(N)}catch(H){if(H instanceof A.$rp&&H.code==="ERROR_PROFILE_NOT_FOUND")await this.I(),X=await q.scanExtensions(N);else throw H}return X=await this.J(X,1,K,!0),this.y.trace("Scanned user extensions:",X.length),X}async scanExtensionsUnderDevelopment(K,J){if(this.z.isExtensionDevelopment&&this.z.extensionDevelopmentLocationURI){const G=(await Promise.all(this.z.extensionDevelopmentLocationURI.filter(N=>N.scheme===g.Schemas.file).map(async N=>{const q=await this.P(N,!1,1,!0,K.language,!1,void 0);return(await this.n.scanOneOrMultipleExtensions(q)).map(H=>(H.type=J.find(Y=>(0,E.$xo)(Y.identifier,H.identifier))?.type??H.type,this.n.validate(H,q)))}))).flat();return this.J(G,"development",K,!0)}return[]}async scanExistingExtension(K,J,G){const N=await this.P(K,!1,J,!0,G.language,!0,void 0),q=await this.n.scanExtension(N);return!q||!G.includeInvalid&&!q.isValid?null:q}async scanOneOrMultipleExtensions(K,J,G){const N=await this.P(K,!1,J,!0,G.language,!0,void 0),q=await this.n.scanOneOrMultipleExtensions(N);return this.J(q,J,G,!0)}async scanMetadata(K){const J=(0,d.$vg)(K,"package.json"),G=(await this.w.readFile(J)).value.toString();return JSON.parse(G).__metadata}async updateMetadata(K,J){const G=(0,d.$vg)(K,"package.json"),N=(await this.w.readFile(G)).value.toString(),q=JSON.parse(N);J.isMachineScoped===!1&&delete J.isMachineScoped,J.isBuiltin===!1&&delete J.isBuiltin,q.__metadata={...q.__metadata,...J},await this.w.writeFile((0,d.$vg)(K,"package.json"),M.$be.fromString(JSON.stringify(q,null,"	")))}async initializeDefaultProfileExtensions(){try{await this.u.scanProfileExtensions(this.t.defaultProfile.extensionsResource,{bailOutWhenFileNotFound:!0})}catch(K){if(K instanceof A.$rp&&K.code==="ERROR_PROFILE_NOT_FOUND")await this.I();else throw K}}async I(){return this.H||(this.H=(async()=>{try{this.y.info("Started initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString());const K=await this.scanUserExtensions({includeInvalid:!0});if(K.length)await this.u.addExtensionsToProfile(K.map(J=>[J,J.metadata]),this.t.defaultProfile.extensionsResource);else try{await this.w.createFile(this.t.defaultProfile.extensionsResource,M.$be.fromString(JSON.stringify([])))}catch(J){(0,c.$ok)(J)!==1&&this.y.warn("Failed to create default profile extensions manifest in extensions installation folder.",this.userExtensionsLocation.toString(),(0,D.$0)(J))}this.y.info("Completed initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString())}catch(K){this.y.error(K)}finally{this.H=void 0}})()),this.H}async J(K,J,G,N){return G.includeAllVersions||(K=this.L(J===0?K:void 0,J===1?K:void 0,J==="development"?K:void 0,await this.getTargetPlatform(),N)),G.includeInvalid||(K=K.filter(q=>q.isValid)),K.sort((q,X)=>{const H=w.$nc(q.location.fsPath),Y=w.$nc(X.location.fsPath);return H<Y?-1:H>Y?1:0})}L(K,J,G,N,q){const X=(Y,re,F)=>{if(Y.isValid&&!re.isValid)return!1;if(Y.isValid===re.isValid){if(q&&v.gt(Y.manifest.version,re.manifest.version))return this.y.debug(`Skipping extension ${re.location.path} with lower version ${re.manifest.version} in favour of ${Y.location.path} with version ${Y.manifest.version}`),!1;if(v.eq(Y.manifest.version,re.manifest.version)){if(Y.type===0)return this.y.debug(`Skipping extension ${re.location.path} in favour of system extension ${Y.location.path} with same version`),!1;if(Y.targetPlatform===N)return this.y.debug(`Skipping extension ${re.location.path} from different target platform ${re.targetPlatform}`),!1}}return F?this.y.warn(`Overwriting user extension ${Y.location.path} with ${re.location.path}.`):this.y.debug(`Overwriting user extension ${Y.location.path} with ${re.location.path}.`),!0},H=new h.$6l;return K?.forEach(Y=>{const re=H.get(Y.identifier.id);(!re||X(re,Y,!1))&&H.set(Y.identifier.id,Y)}),J?.forEach(Y=>{const re=H.get(Y.identifier.id);if(!re&&K&&Y.type===0){this.y.debug(`Skipping obsolete system extension ${Y.location.path}.`);return}(!re||X(re,Y,!1))&&H.set(Y.identifier.id,Y)}),G?.forEach(Y=>{const re=H.get(Y.identifier.id);(!re||X(re,Y,!0))&&H.set(Y.identifier.id,Y),H.set(Y.identifier.id,Y)}),[...H.values()]}async M(K,J){this.y.trace("Started scanning system extensions");const G=await this.P(this.systemExtensionsLocation,!1,0,!0,J,!0,void 0),q=await(K&&!G.devMode?this.j:this.n).scanExtensions(G);return this.y.trace("Scanned system extensions:",q.length),q}async N(K,J){const G=this.z.isBuilt?[]:this.C.builtInExtensions;if(!G?.length)return[];this.y.trace("Started scanning dev system extensions");const N=J?await this.O():{},q=[],X=m.URI.file(w.$hc(w.$jc(g.$cg.asFileUri("").fsPath,"..",".build","builtInExtensions")));for(const Y of G){const re=N[Y.name]||"marketplace";switch(re){case"disabled":break;case"marketplace":q.push((0,d.$vg)(X,Y.name));break;default:q.push(m.URI.file(re));break}}const H=await Promise.all(q.map(async Y=>this.n.scanExtension(await this.P(Y,!1,0,!0,K,!0,void 0))));return this.y.trace("Scanned dev system extensions:",H.length),(0,S.$Hb)(H)}async O(){try{const K=await this.w.readFile(this.r);return JSON.parse(K.value.toString())}catch{return{}}}async P(K,J,G,N,q,X,H){const Y=await this.f(q??y.$w),re=await this.Q(K),F=J&&!this.D.extUri.isEqual(K,this.t.defaultProfile.extensionsResource)?this.t.defaultProfile.extensionsResource:void 0,O=F?await this.Q(F):void 0;return new z(K,re,F,O,J,H,G,N,X,this.C.version,this.C.date,this.C.commit,!this.z.isBuilt,q,Y)}async Q(K){try{const J=await this.w.stat(K);if(typeof J.mtime=="number")return J.mtime}catch{}}};e.$xp=U,e.$xp=U=ke([ee(4,C.$Jk),ee(5,A.$sp),ee(6,c.$0j),ee(7,t.$9i),ee(8,l.$Vh),ee(9,n.$oj),ee(10,k.$Hk),ee(11,o.$Nh)],U);class z{constructor(K,J,G,N,q,X,H,Y,re,F,O,L,B,T,W){this.location=K,this.mtime=J,this.applicationExtensionslocation=G,this.applicationExtensionslocationMtime=N,this.profile=q,this.profileScanOptions=X,this.type=H,this.excludeObsolete=Y,this.validate=re,this.productVersion=F,this.productDate=O,this.productCommit=L,this.devMode=B,this.language=T,this.translations=W}static createNlsConfiguration(K){return{language:K.language,pseudo:K.language==="pseudo",devMode:K.devMode,translations:K.translations}}static equals(K,J){return(0,d.$og)(K.location,J.location)&&K.mtime===J.mtime&&(0,d.$og)(K.applicationExtensionslocation,J.applicationExtensionslocation)&&K.applicationExtensionslocationMtime===J.applicationExtensionslocationMtime&&K.profile===J.profile&&s.$8m(K.profileScanOptions,J.profileScanOptions)&&K.type===J.type&&K.excludeObsolete===J.excludeObsolete&&K.validate===J.validate&&K.productVersion===J.productVersion&&K.productDate===J.productDate&&K.productCommit===J.productCommit&&K.devMode===J.devMode&&K.language===J.language&&j.equals(K.translations,J.translations)}}e.$yp=z;let ne=class extends a.$Sc{constructor(K,J,G,N,q){super(),this.f=K,this.g=J,this.h=G,this.j=N,this.m=q}async scanExtensions(K){const J=K.profile?await this.r(K):await this.n(K);let G={};if(K.excludeObsolete&&K.type===1)try{const N=(await this.j.readFile(this.f)).value.toString();G=JSON.parse(N)}catch{}return(0,$.$Lf)(G)?J:J.filter(N=>!G[E.$yo.create(N).toString()])}async n(K){const J=await this.j.resolve(K.location);if(!J.children?.length)return[];const G=await Promise.all(J.children.map(async N=>{if(!N.isDirectory||K.type===1&&(0,d.$sg)(N.resource).indexOf(".")===0)return null;const q=new z(N.resource,K.mtime,K.applicationExtensionslocation,K.applicationExtensionslocationMtime,K.profile,K.profileScanOptions,K.type,K.excludeObsolete,K.validate,K.productVersion,K.productDate,K.productCommit,K.devMode,K.language,K.translations);return this.scanExtension(q)}));return(0,S.$Hb)(G).sort((N,q)=>N.location.path<q.location.path?-1:1)}async r(K){let J=await this.s(K.location,()=>!0,K);if(K.applicationExtensionslocation&&!this.h.extUri.isEqual(K.location,K.applicationExtensionslocation)){J=J.filter(N=>!N.metadata?.isApplicationScoped);const G=await this.s(K.applicationExtensionslocation,N=>!!N.metadata?.isBuiltin||!!N.metadata?.isApplicationScoped,K);J.push(...G)}return J}async s(K,J,G){const N=await this.g.scanProfileExtensions(K,G.profileScanOptions);if(!N.length)return[];const q=await Promise.all(N.map(async X=>{if(J(X)){const H=new z(X.location,G.mtime,G.applicationExtensionslocation,G.applicationExtensionslocationMtime,G.profile,G.profileScanOptions,G.type,G.excludeObsolete,G.validate,G.productVersion,G.productDate,G.productCommit,G.devMode,G.language,G.translations);return this.scanExtension(H,X.metadata)}return null}));return(0,S.$Hb)(q)}async scanOneOrMultipleExtensions(K){try{if(await this.j.exists((0,d.$vg)(K.location,"package.json"))){const J=await this.scanExtension(K);return J?[J]:[]}else return await this.scanExtensions(K)}catch(J){return this.m.error(`Error scanning extensions at ${K.location.path}:`,(0,D.$0)(J)),[]}}async scanExtension(K,J){try{let G=await this.scanExtensionManifest(K.location);if(G){G.publisher||(G.publisher=h.$Zl),J=J??G.__metadata,delete G.__metadata;const N=(0,E.$Co)(G.publisher,G.name),q=J?.id?{id:N,uuid:J.id}:{id:N},X=J?.isSystem?0:K.type,H=X===0||!!J?.isBuiltin;G=await this.t(K.location,G,z.createNlsConfiguration(K));const Y={type:X,identifier:q,manifest:G,location:K.location,isBuiltin:H,targetPlatform:J?.targetPlatform??"undefined",metadata:J,isValid:!0,validations:[]};return K.validate?this.validate(Y,K):Y}}catch(G){K.type!==0&&this.m.error(G)}return null}validate(K,J){let G=!0;const N=(0,i.$No)(J.productVersion,J.productDate,J.location,K.manifest,K.isBuiltin);for(const[q,X]of N)q===b.default.Error&&(G=!1,this.m.error(this.z(J.location,X)));return K.isValid=G,K.validations=N,K}async scanExtensionManifest(K){const J=(0,d.$vg)(K,"package.json");let G;try{G=(await this.j.readFile(J)).value.toString()}catch(q){return(0,c.$ok)(q)!==1&&this.m.error(this.z(K,(0,u.localize)(0,null,J.path,q.message))),null}let N;try{N=JSON.parse(G)}catch{const X=[];(0,P.$Tm)(G,X);for(const H of X)this.m.error(this.z(K,(0,u.localize)(1,null,J.path,H.offset,H.length,(0,f.$up)(H.error))));return null}return(0,P.$3m)(N)!=="object"?(this.m.error(this.z(K,(0,u.localize)(2,null,J.path))),null):N}async t(K,J,G){const N=await this.u(K,J,G);if(N)try{const q=[],X=await this.w(N.default,q);if(q.length>0)return q.forEach(Y=>{this.m.error(this.z(K,(0,u.localize)(3,null,N.default?.path,(0,f.$up)(Y.error))))}),J;if((0,P.$3m)(N)!=="object")return this.m.error(this.z(K,(0,u.localize)(4,null,N.default?.path))),J;const H=N.values||Object.create(null);return(0,I.$vp)(this.m,J,H,X)}catch{}return J}async u(K,J,G){const N=(0,d.$vg)(K,"package.nls.json"),q=(re,F)=>{F.forEach(O=>{this.m.error(this.z(K,(0,u.localize)(5,null,re?.path,(0,f.$up)(O.error))))})},X=re=>{this.m.error(this.z(K,(0,u.localize)(6,null,re?.path)))},H=`${J.publisher}.${J.name}`,Y=G.translations[H];if(Y)try{const re=m.URI.file(Y),F=(await this.j.readFile(re)).value.toString(),O=[],L=(0,P.$Tm)(F,O);return O.length>0?(q(re,O),{values:void 0,default:N}):(0,P.$3m)(L)!=="object"?(X(re),{values:void 0,default:N}):{values:L.contents?L.contents.package:void 0,default:N}}catch{return{values:void 0,default:N}}else{if(!await this.j.exists(N))return;let F;try{F=await this.y(K,G)}catch{return}if(!F.localized)return{values:void 0,default:F.original};try{const O=(await this.j.readFile(F.localized)).value.toString(),L=[],B=(0,P.$Tm)(O,L);return L.length>0?(q(F.localized,L),{values:void 0,default:F.original}):(0,P.$3m)(B)!=="object"?(X(F.localized),{values:void 0,default:F.original}):{values:B,default:F.original}}catch{return{values:void 0,default:F.original}}}}async w(K,J){if(K)try{const G=(await this.j.readFile(K)).value.toString();return(0,P.$Tm)(G,J)}catch{}}y(K,J){return new Promise((G,N)=>{const q=X=>{const H=(0,d.$vg)(K,`package.nls.${X}.json`);this.j.exists(H).then(Y=>{Y&&G({localized:H,original:(0,d.$vg)(K,"package.nls.json")});const re=X.lastIndexOf("-");re===-1?G({localized:(0,d.$vg)(K,"package.nls.json"),original:null}):(X=X.substring(0,re),q(X))})};if(J.devMode||J.pseudo||!J.language)return G({localized:(0,d.$vg)(K,"package.nls.json"),original:null});q(J.language)})}z(K,J){return`[${K.path}]: ${J}`}};ne=ke([ee(1,A.$sp),ee(2,k.$Hk),ee(3,c.$0j),ee(4,t.$9i)],ne);let _=class extends ne{constructor(K,J,G,N,q,X,H){super(J,N,q,X,H),this.G=K,this.H=G,this.D=this.B(new R.$Rg(3e3)),this.F=this.B(new r.$Nd),this.onDidChangeCache=this.F.event}async scanExtensions(K){const J=this.M(K),G=await this.I(J);if(this.C=K,G&&G.input&&z.equals(G.input,this.C))return this.m.debug("Using cached extensions scan result",K.location.toString()),this.D.trigger(()=>this.L()),G.result.map(q=>(q.location=m.URI.revive(q.location),q));const N=await super.scanExtensions(K);return await this.J(J,{input:K,result:N}),N}async I(K){try{const J=await this.j.readFile(K),G=JSON.parse(J.value.toString());return{result:G.result,input:(0,p.$lh)(G.input)}}catch(J){this.m.debug("Error while reading the extension cache file:",K.path,(0,D.$0)(J))}return null}async J(K,J){try{await this.j.writeFile(K,M.$be.fromString(JSON.stringify(J)))}catch(G){this.m.debug("Error while writing the extension cache file:",K.path,(0,D.$0)(G))}}async L(){if(!this.C)return;const K=this.M(this.C),J=await this.I(K);if(!J)return;const G=J.result,N=JSON.parse(JSON.stringify(await super.scanExtensions(this.C)));if(!s.$8m(N,G))try{this.m.info("Invalidating Cache",G,N),await this.j.del(K),this.F.fire()}catch(q){this.m.error(q)}}M(K){const J=this.N(K);return this.h.extUri.joinPath(J.cacheHome,K.type===0?h.$Yl:h.$Xl)}N(K){return K.type===0?this.H.defaultProfile:K.profile?this.h.extUri.isEqual(K.location,this.G.extensionsResource)?this.G:this.H.profiles.find(J=>this.h.extUri.isEqual(K.location,J.extensionsResource))??this.G:this.H.defaultProfile}};_=ke([ee(2,C.$Jk),ee(3,A.$sp),ee(4,k.$Hk),ee(5,c.$0j),ee(6,t.$9i)],_);function ae(oe,K){const J=(0,E.$Ao)(oe.manifest.publisher,oe.manifest.name);return{id:J,identifier:new h.$4l(J),isBuiltin:oe.type===0,isUserBuiltin:oe.type===1&&oe.isBuiltin,isUnderDevelopment:K,extensionLocation:oe.location,uuid:oe.identifier.uuid,targetPlatform:oe.targetPlatform,...oe.manifest}}e.$zp=ae;class se extends U{constructor(K,J,G,N,q,X,H,Y,re,F,O,L){super(K,J,(0,d.$vg)(G,".vscode-oss-dev","extensions","control.json"),N,q,X,H,Y,re,F,O,L),this.R=(async()=>{if(y.$z)try{const B=await this.w.readFile(m.URI.file(y.$z));return JSON.parse(B.value.toString())}catch{}return Object.create(null)})()}f(K){return this.R}}e.$Ap=se}),define(te[274],ie([0,1,5,41,40,26,80,16,36,7]),function(Q,e,S,R,s,M,D,P,f,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yN=void 0;let g=class extends D.$tp{constructor(y,d,v,b,$,m){super(a.URI.file(y.extensionsPath),d,v,b,$,m)}};e.$yN=g,e.$yN=g=ke([ee(0,f.$Wh),ee(1,P.$0j),ee(2,R.$Jk),ee(3,s.$Hk),ee(4,M.$bl),ee(5,S.$9i)],g)}),define(te[275],ie([0,1,7,36,80,128,16,6,5,24,40,41]),function(Q,e,S,R,s,M,D,P,f,a,g,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$D7b=void 0;let y=class extends M.$Ap{constructor(v,b,$,m,u,l,E,h){super(S.URI.file(u.builtinExtensionsPath),S.URI.file(u.extensionsPath),u.userHome,v.defaultProfile,v,b,$,m,u,l,E,h)}};e.$D7b=y,e.$D7b=y=ke([ee(0,w.$Jk),ee(1,s.$sp),ee(2,D.$0j),ee(3,f.$9i),ee(4,R.$Wh),ee(5,a.$oj),ee(6,g.$Hk),ee(7,P.$Nh)],y)}),define(te[276],ie([0,1,15,2,13,9,4,56,7,32,38,36,5,41]),function(Q,e,S,R,s,M,D,P,f,a,g,w,y,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$T7b=void 0;let v=class extends R.$Sc{constructor($,m,u){super(),this.c=$,this.f=u,this.a=P.$Uh.forPaths(!D.$l),this.b=new Set([".svg",".png",".jpg",".jpeg",".gif",".bmp",".webp"]),this.addValidFileRoot($.appRoot),this.addValidFileRoot($.extensionsPath),this.addValidFileRoot(m.defaultProfile.globalStorageHome.with({scheme:s.Schemas.file}).fsPath),this.addValidFileRoot($.workspaceStorageHome.with({scheme:s.Schemas.file}).fsPath),this.g()}g(){const{defaultSession:$}=S.session;$.protocol.registerFileProtocol(s.Schemas.vscodeFileResource,(m,u)=>this.j(m,u)),$.protocol.interceptFileProtocol(s.Schemas.file,(m,u)=>this.h(m,u)),this.B((0,R.$Qc)(()=>{$.protocol.unregisterProtocol(s.Schemas.vscodeFileResource),$.protocol.uninterceptProtocol(s.Schemas.file)}))}addValidFileRoot($){const m=(0,M.$hc)($);return this.a.get(m)?R.$Sc.None:(this.a.set(m,!0),(0,R.$Qc)(()=>this.a.delete(m)))}h($,m){const u=f.URI.parse($.url);return this.f.error(`Refused to load resource ${u.fsPath} from ${s.Schemas.file}: protocol (original URL: ${$.url})`),m({error:-3})}j($,m){const u=this.m($);let l;return this.c.crossOriginIsolated&&((0,M.$nc)(u)==="workbench.html"||(0,M.$nc)(u)==="workbench-dev.html"?l=s.COI.CoopAndCoep:l=s.COI.getHeadersFromQuery($.url)),this.a.findSubstr(u)?m({path:u,headers:l}):this.b.has((0,M.$oc)(u).toLowerCase())?m({path:u}):(this.f.error(`${s.Schemas.vscodeFileResource}: Refused to load resource ${u} from ${s.Schemas.vscodeFileResource}: protocol (original URL: ${$.url})`),m({error:-3}))}m($){const m=f.URI.parse($.url),u=s.$cg.uriToFileUri(m);return(0,M.$hc)(u.fsPath)}createIPCObjectUrl(){let $;const m=f.URI.from({scheme:"vscode",path:(0,a.$eg)()}),u=m.toString(),l=async()=>$;return g.$eT.handle(u,l),this.f.trace(`IPC Object URL: Registered new channel ${u}.`),{resource:m,update:E=>$=E,dispose:()=>{this.f.trace(`IPC Object URL: Removed channel ${u}.`),g.$eT.removeHandler(u)}}}};e.$T7b=v,e.$T7b=v=ke([ee(0,w.$Wh),ee(1,d.$Jk),ee(2,y.$9i)],v)}),define(te[96],ie([0,1,8,3,2,65,12,111,6,41]),function(Q,e,S,R,s,M,D,P,f,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9o=e.$8o=e.$7o=e.$6o=e.$5o=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.$4o=e.$3o=e.$2o=void 0,e.$2o="__$__isNewStorageMarker",e.$3o="__$__targetStorageMarker",e.$4o=(0,f.$Oh)("storageService");var g;(function(u){u[u.NONE=0]="NONE",u[u.SHUTDOWN=1]="SHUTDOWN"})(g||(e.WillSaveStateReason=g={}));var w;(function(u){u[u.APPLICATION=-1]="APPLICATION",u[u.PROFILE=0]="PROFILE",u[u.WORKSPACE=1]="WORKSPACE"})(w||(e.StorageScope=w={}));var y;(function(u){u[u.USER=0]="USER",u[u.MACHINE=1]="MACHINE"})(y||(e.StorageTarget=y={}));function d(u){const l=u.get(e.$3o);if(l)try{return JSON.parse(l)}catch{}return Object.create(null)}e.$5o=d;class v extends s.$Sc{static{this.a=60*1e3}constructor(l={flushInterval:v.a}){super(),this.m=l,this.b=this.B(new R.$Qd),this.c=this.B(new R.$Qd),this.onDidChangeTarget=this.c.event,this.f=this.B(new R.$Nd),this.onWillSaveState=this.f.event,this.h=this.B(new S.$6g(()=>this.n(),this.m.flushInterval)),this.j=this.B(new s.$Tc),this.C=void 0,this.F=void 0,this.H=void 0}onDidChangeValue(l,E,h){return R.Event.filter(this.b.event,i=>i.scope===l&&(E===void 0||i.key===E),h)}n(){this.j.value=(0,S.$0g)(()=>{this.r()&&this.flush(),this.h.schedule()})}r(){return!0}t(){(0,s.$Nc)([this.j,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,M.mark)("code/willInitStorage");try{await this.O()}finally{(0,M.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}u(l,E){const{key:h,external:i}=E;if(h===e.$3o){switch(l){case-1:this.H=void 0;break;case 0:this.F=void 0;break;case 1:this.C=void 0;break}this.c.fire({scope:l})}else this.b.fire({scope:l,key:h,target:this.J(l)[h],external:i})}w(l){this.f.fire({reason:l})}get(l,E,h){return this.P(E)?.get(l,h)}getBoolean(l,E,h){return this.P(E)?.getBoolean(l,h)}getNumber(l,E,h){return this.P(E)?.getNumber(l,h)}getObject(l,E,h){return this.P(E)?.getObject(l,h)}storeAll(l,E){this.y(()=>{for(const h of l)this.store(h.key,h.value,h.scope,h.target,E)})}store(l,E,h,i,c=!1){if((0,D.$Hf)(E)){this.remove(l,h,c);return}this.y(()=>{this.z(l,h,i),this.P(h)?.set(l,E,c)})}remove(l,E,h=!1){this.y(()=>{this.z(l,E,void 0),this.P(E)?.delete(l,h)})}y(l){this.b.pause(),this.c.pause();try{l()}finally{this.b.resume(),this.c.resume()}}keys(l,E){const h=[],i=this.J(l);for(const c of Object.keys(i))i[c]===E&&h.push(c);return h}z(l,E,h,i=!1){const c=this.J(E);typeof h=="number"?c[l]!==h&&(c[l]=h,this.P(E)?.set(e.$3o,JSON.stringify(c),i)):typeof c[l]=="number"&&(delete c[l],this.P(E)?.set(e.$3o,JSON.stringify(c),i))}get D(){return this.C||(this.C=this.L(1)),this.C}get G(){return this.F||(this.F=this.L(0)),this.F}get I(){return this.H||(this.H=this.L(-1)),this.H}J(l){switch(l){case-1:return this.I;case 0:return this.G;default:return this.D}}L(l){const E=this.P(l);return E?d(E):Object.create(null)}isNew(l){return this.getBoolean(e.$2o,l)===!0}async flush(l=g.NONE){this.f.fire({reason:l});const E=this.P(-1),h=this.P(0),i=this.P(1);switch(l){case g.NONE:await S.Promises.settled([E?.whenFlushed()??Promise.resolve(),h?.whenFlushed()??Promise.resolve(),i?.whenFlushed()??Promise.resolve()]);break;case g.SHUTDOWN:await S.Promises.settled([E?.flush(0)??Promise.resolve(),h?.flush(0)??Promise.resolve(),i?.flush(0)??Promise.resolve()]);break}}async log(){const l=this.P(-1)?.items??new Map,E=this.P(0)?.items??new Map,h=this.P(1)?.items??new Map;return m(l,E,h,this.Q(-1)??"",this.Q(0)??"",this.Q(1)??"")}async optimize(l){return await this.flush(),this.P(l)?.optimize()}async switch(l,E){return this.w(g.NONE),(0,a.$Ik)(l)?this.R(l,E):this.S(l,E)}M(l,E){return!(l.id===E.id||b(E)&&b(l))}N(l,E,h){this.y(()=>{const i=new Set;for(const[c,o]of l)i.add(c),E.get(c)!==o&&this.u(h,{key:c,external:!0});for(const[c]of E.items)i.has(c)||this.u(h,{key:c,external:!0})})}}e.$6o=v;function b(u){return u.isDefault||!!u.useDefaultFlags?.globalState}e.$7o=b;class $ extends v{constructor(){super(),this.U=this.B(new P.$Zo(new P.$1o,{hint:P.StorageHint.STORAGE_IN_MEMORY})),this.W=this.B(new P.$Zo(new P.$1o,{hint:P.StorageHint.STORAGE_IN_MEMORY})),this.X=this.B(new P.$Zo(new P.$1o,{hint:P.StorageHint.STORAGE_IN_MEMORY})),this.B(this.X.onDidChangeStorage(l=>this.u(1,l))),this.B(this.W.onDidChangeStorage(l=>this.u(0,l))),this.B(this.U.onDidChangeStorage(l=>this.u(-1,l)))}P(l){switch(l){case-1:return this.U;case 0:return this.W;default:return this.X}}Q(l){switch(l){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async O(){}async R(){}async S(){}r(){return!1}hasScope(l){return!1}}e.$8o=$;async function m(u,l,E,h,i,c){const o=j=>{try{return JSON.parse(j)}catch{return j}},t=new Map,n=new Map;u.forEach((j,U)=>{t.set(U,j),n.set(U,o(j))});const r=new Map,p=new Map;l.forEach((j,U)=>{r.set(U,j),p.set(U,o(j))});const A=new Map,C=new Map;E.forEach((j,U)=>{A.set(U,j),C.set(U,o(j))}),console.group(h!==i?`Storage: Application (path: ${h})`:`Storage: Application & Profile (path: ${h}, default profile)`);const k=[];if(t.forEach((j,U)=>{k.push({key:U,value:j})}),console.table(k),console.groupEnd(),console.log(n),h!==i){console.group(`Storage: Profile (path: ${i}, profile specific)`);const j=[];r.forEach((U,z)=>{j.push({key:z,value:U})}),console.table(j),console.groupEnd(),console.log(p)}console.group(`Storage: Workspace (path: ${c})`);const I=[];A.forEach((j,U)=>{I.push({key:U,value:j})}),console.table(I),console.groupEnd(),console.log(C)}e.$9o=m}),define(te[277],ie([0,1,23,8,3,2,9,72,7,21,111,159,5,96,26,29,13]),function(Q,e,S,R,s,M,D,P,f,a,g,w,y,d,v,b,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$95b=e.$85b=e.$75b=e.$65b=void 0;class m extends M.$Sc{static{this.a=2e3}get storage(){return this.f}constructor(o,t){super(),this.m=o,this.n=t,this.b=this.B(new s.$Nd),this.onDidChangeStorage=this.b.event,this.c=this.B(new s.$Nd),this.onDidCloseStorage=this.c.event,this.f=this.B(new g.$Zo(new g.$1o,{hint:g.StorageHint.STORAGE_IN_MEMORY})),this.g=void 0,this.h=new R.$ch,this.whenInit=this.h.p,this.j=g.StorageState.None}isInMemory(){return this.f.isInMemory()}init(){return this.g||(this.g=(async()=>{if(this.j===g.StorageState.None)try{const o=this.B(await this.t());this.f.dispose(),this.f=o,this.B(o.onDidChangeStorage(n=>this.b.fire(n))),await this.s(o);const t=o.getBoolean(d.$2o);t===void 0?o.set(d.$2o,!0):t&&o.set(d.$2o,!1)}catch(o){this.m.error(`[storage main] initialize(): Unable to init storage due to ${o}`)}finally{this.j=g.StorageState.Initialized,this.h.complete()}})()),this.g}r(){return{logTrace:this.m.getLevel()===y.LogLevel.Trace?o=>this.m.trace(o):void 0,logError:o=>this.m.error(o)}}s(o){return o.init()}get items(){return this.f.items}get(o,t){return this.f.get(o,t)}set(o,t){return this.f.set(o,t)}delete(o){return this.f.delete(o)}optimize(){return this.f.optimize()}async close(){const o=new P.$Jd(!1);await this.w(),o.stop(),o.elapsed()>m.a&&await this.u(o),this.c.fire()}async u(o){if(this.path)try{const t=(0,S.top)(Array.from(this.f.items.entries()).map(([r,p])=>({key:r,length:p.length})),(r,p)=>p.length-r.length,5).map(r=>`${r.key}:${r.length}`).join(", "),n=(await this.n.stat(f.URI.file(this.path))).size;this.m.warn(`[storage main] detected slow close() operation: Time: ${o.elapsed()}ms, DB size: ${n}b, Large Keys: ${t}`)}catch(t){this.m.error("[storage main] figuring out stats for slow DB on close() resulted in an error",t)}}async w(){this.g&&await this.g,this.j=g.StorageState.Closed,await this.f.close()}}class u extends m{static{this.y="state.vscdb"}get path(){if(!this.C.useInMemoryStorage)return(0,D.$jc)(this.z.globalStorageHome.with({scheme:$.Schemas.file}).fsPath,u.y)}constructor(o,t,n,r){super(n,r),this.z=o,this.C=t}async t(){return new g.$Zo(new w.$JT(this.path??w.$JT.IN_MEMORY_PATH,{logging:this.r()}),this.path?void 0:{hint:g.StorageHint.STORAGE_IN_MEMORY})}}class l extends u{constructor(o,t,n,r){super(o,t,n,r)}}e.$65b=l;class E extends u{constructor(o,t,n,r){super(t.defaultProfile,o,n,r)}async s(o){await super.s(o),this.G(o)}G(o){o.get(v.$el,void 0)===void 0&&o.set(v.$el,new Date().toUTCString());const n=o.get(v.$dl,void 0),r=new Date().toUTCString();o.set(v.$fl,typeof n>"u"?null:n),o.set(v.$dl,r)}}e.$75b=E;class h extends m{static{this.y="state.vscdb"}static{this.z="workspace.json"}get path(){if(!this.D.useInMemoryStorage)return(0,D.$jc)(this.F.workspaceStorageHome.with({scheme:$.Schemas.file}).fsPath,this.C.id,h.y)}constructor(o,t,n,r,p){super(n,p),this.C=o,this.D=t,this.F=r}async t(){const{storageFilePath:o,wasCreated:t}=await this.H();return new g.$Zo(new w.$JT(o,{logging:this.r()}),{hint:this.D.useInMemoryStorage?g.StorageHint.STORAGE_IN_MEMORY:t?g.StorageHint.STORAGE_DOES_NOT_EXIST:void 0})}async H(){if(this.D.useInMemoryStorage)return{storageFilePath:w.$JT.IN_MEMORY_PATH,wasCreated:!0};const o=(0,D.$jc)(this.F.workspaceStorageHome.with({scheme:$.Schemas.file}).fsPath,this.C.id),t=(0,D.$jc)(o,h.y);return await a.Promises.exists(o)?{storageFilePath:t,wasCreated:!1}:(await a.Promises.mkdir(o,{recursive:!0}),this.I(o),{storageFilePath:t,wasCreated:!0})}async I(o){let t;if((0,b.$Yh)(this.C)?t={folder:this.C.uri.toString()}:(0,b.$4h)(this.C)&&(t={workspace:this.C.configPath.toString()}),t)try{const n=(0,D.$jc)(o,h.z);await a.Promises.exists(n)||await a.Promises.writeFile(n,JSON.stringify(t,void 0,2))}catch(n){this.m.error(`[storage main] ensureWorkspaceStorageFolderMeta(): Unable to create workspace storage metadata due to ${n}`)}}}e.$85b=h;class i extends m{get path(){}async t(){return new g.$Zo(new g.$1o,{hint:g.StorageHint.STORAGE_IN_MEMORY})}}e.$95b=i}),define(te[278],ie([0,1,3,2,96]),function(Q,e,S,R,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$F7b=void 0;class M extends R.$Sc{constructor(P,f,a){super(),this.b=P,this.c=f,this.f=a;const g=this.B(new R.$Tc);this.a=this.B(new S.$Nd({onWillAddFirstListener:()=>g.value=this.g(),onDidRemoveLastListener:()=>g.value=void 0}))}g(){this.f.debug("ProfileStorageChangesListenerChannel#registerStorageChangeListeners");const P=new R.$Rc;return P.add(S.Event.debounce(this.b.applicationStorage.onDidChangeStorage,(f,a)=>(f?f.push(a.key):f=[a.key],f),100)(f=>this.h(f))),P.add(S.Event.debounce(this.b.onDidChangeProfileStorage,(f,a)=>{f||(f=new Map);let g=f.get(a.profile.id);return g||f.set(a.profile.id,g={profile:a.profile,keys:[],storage:a.storage}),g.keys.push(a.key),f},100)(f=>this.j(f))),P}h(P){const f=P.includes(s.$3o)?[this.c.defaultProfile]:[],a=[];if(P=P.filter(g=>g!==s.$3o),P.length){const g=(0,s.$5o)(this.b.applicationStorage.storage);a.push({profile:this.c.defaultProfile,changes:P.map(w=>({key:w,scope:0,target:g[w]}))})}this.m(f,a)}j(P){const f=[],a=new Map;for(const[g,w]of P.entries()){w.keys.includes(s.$3o)&&f.push(w.profile);const y=w.keys.filter(d=>d!==s.$3o);if(y.length){const d=(0,s.$5o)(w.storage.storage);a.set(g,{profile:w.profile,changes:y.map(v=>({key:v,scope:0,target:d[v]}))})}}this.m(f,[...a.values()])}m(P,f){(P.length||f.length)&&this.a.fire({valueChanges:f,targetChanges:P})}listen(P,f,a){switch(f){case"onDidChange":return this.a.event}throw new Error(`Event not found: ${f}`)}async call(P,f){throw new Error(`Call not found: ${f}`)}}e.$F7b=M}),define(te[279],ie([0,1,7,36,16,5,34,40,41,12,121]),function(Q,e,S,R,s,M,D,P,f,a,g){"use strict";var w,y;Object.defineProperty(e,"__esModule",{value:!0}),e.$xN=e.$wN=e.$vN=void 0;let d=class extends f.$Mk{static{w=this}static{this.a="profileAssociationsMigration"}constructor(m,u,l,E,h){super(l,E,u,h),this.U=m,this.W=l}O(){return this.U.getItem(w.b,[]).map(u=>({...u,location:(0,a.$yf)(u.location)?this.w.extUri.joinPath(this.profilesHome,u.location):S.URI.revive(u.location)}))}Q(){const m=this.U.getItem(w.c,{});return this.U.getItem(w.a,!1)?m:this.N(m)}S(){return this.w.extUri.joinPath(S.URI.file(this.W.extensionsPath).with({scheme:this.profilesHome.scheme}),"extensions.json")}};e.$vN=d,e.$vN=d=w=ke([ee(0,D.$qN),ee(1,P.$Hk),ee(2,R.$Wh),ee(3,s.$0j),ee(4,M.$9i)],d);let v=y=class extends d{constructor(m,u,l,E,h){super(m,u,l,E,h),this.$=m}P(m){m.length?this.$.setItem(y.b,m.map(u=>({...u,location:this.w.extUri.basename(u.location)}))):this.$.removeItem(y.b)}O(){const m=super.O();return this.$.getItem("userDataProfilesMigration",!1)||(this.P(m),this.$.setItem("userDataProfilesMigration",!0)),m}R(m){m.emptyWindows||m.workspaces?this.$.setItem(y.c,m):this.$.removeItem(y.c)}Q(){const m="workspaceAndProfileInfo",u=this.$.getItem(m,void 0);if(u){this.$.removeItem(m);const E=u.reduce((h,{workspace:i,profile:c})=>(h[S.URI.revive(i).toString()]=S.URI.revive(c).toString(),h),{});this.$.setItem(y.c,{workspaces:E})}const l=super.Q();return this.$.getItem(y.a,!1)||(this.R(l),this.$.setItem(y.a,!0)),l}};e.$wN=v,e.$wN=v=y=ke([ee(0,D.$rN),ee(1,P.$Hk),ee(2,R.$Wh),ee(3,s.$0j),ee(4,M.$9i)],v);let b=class extends v{constructor(m,u,l,E){super(new g.$uN(0,u,E,l),m,u,l,E)}async init(){return await this.$.init(),super.init()}};e.$xN=b,e.$xN=b=ke([ee(0,P.$Hk),ee(1,R.$Wh),ee(2,s.$0j),ee(3,M.$9i)],b)}),define(te[52],ie([0,1,36,16,6,5,40,41,279,34]),function(Q,e,S,R,s,M,D,P,f,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$5b=e.$05b=void 0,e.$05b=(0,s.$Ph)(P.$Jk);let g=class extends f.$wN{constructor(y,d,v,b,$){super(y,d,v,b,$)}getAssociatedEmptyWindows(){const y=[];for(const d of this.C.emptyWindows.keys())y.push({id:d});return y}};e.$$5b=g,e.$$5b=g=ke([ee(0,a.$rN),ee(1,D.$Hk),ee(2,S.$Wh),ee(3,R.$0j),ee(4,M.$9i)],g)}),define(te[129],ie([0,1,19,7,29]),function(Q,e,S,R,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$w6b=e.$v6b=e.$u6b=void 0;async function M(f,a,g){for(const y of f){const d=y.openedWorkspace;if((0,s.$4h)(d)){const v=await g(d);if(v){if(v.folders.some(b=>S.$mg.isEqualOrParent(a,b.uri)))return y}else if(S.$mg.isEqualOrParent(a,d.configPath))return y}}const w=f.filter(y=>(0,s.$Yh)(y.openedWorkspace)&&S.$mg.isEqualOrParent(a,y.openedWorkspace.uri));if(w.length)return w.sort((y,d)=>-(y.openedWorkspace.uri.path.length-d.openedWorkspace.uri.path.length))[0]}e.$u6b=M;function D(f,a){for(const g of f)if((0,s.$4h)(g.openedWorkspace)&&S.$mg.isEqual(g.openedWorkspace.configPath,a)||(0,s.$Yh)(g.openedWorkspace)&&S.$mg.isEqual(g.openedWorkspace.uri,a))return g}e.$v6b=D;function P(f,a){const g=w=>a.some(y=>S.$mg.isEqual(R.URI.file(y),R.URI.file(w)));for(const w of f)if(w.config?.extensionDevelopmentPath?.some(y=>g(y)))return w}e.$w6b=P}),define(te[97],ie([0,1,33,44,137,46,13,9,4,19,7,6,58,29]),function(Q,e,S,R,s,M,D,P,f,a,g,w,y,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$KU=e.$JU=e.$IU=e.$HU=e.$GU=e.$FU=e.$EU=e.$DU=e.$CU=e.$BU=void 0,e.$BU=(0,w.$Oh)("workspacesService");function v(C){return C.hasOwnProperty("workspace")}e.$CU=v;function b(C){return C.hasOwnProperty("folderUri")}e.$DU=b;function $(C){return C.hasOwnProperty("fileUri")}e.$EU=$;function m(C){return u(C)||l(C)}e.$FU=m;function u(C){const k=C;return typeof k?.path=="string"&&(!k.name||typeof k.name=="string")}function l(C){const k=C;return typeof k?.uri=="string"&&(!k.name||typeof k.name=="string")}function E(C,k,I,j,U){if(C.scheme!==j.scheme)return{name:I,uri:C.toString(!0)};let z=k?void 0:U.relativePath(j,C);if(z!==void 0)z.length===0?z=".":f.$j&&(z=h(z));else if(C.scheme===D.Schemas.file)z=C.fsPath,f.$j&&(z=h(z));else if(U.isEqualAuthority(C.authority,j.authority))z=C.path;else return{name:I,uri:C.toString(!0)};return{name:I,path:z}}e.$GU=E;function h(C){return C=(0,M.$ov)(C),(0,S.$Uf)(C)||(C=(0,S.$Rf)(C)),C}function i(C,k,I){const j=[],U=new Set,z=I.dirname(k);for(const ne of C){let _;if(u(ne))ne.path&&(_=I.resolvePath(z,ne.path));else if(l(ne))try{_=g.URI.parse(ne.uri),_.path[0]!==P.$gc.sep&&(_=_.with({path:P.$gc.sep+_.path}))}catch(ae){console.warn(ae)}if(_){const ae=I.getComparisonKey(_);if(!U.has(ae)){U.add(ae);const se=ne.name||I.basenameOrAuthority(_);j.push(new d.$9h({uri:_,name:se,index:j.length},ne))}}}return j}e.$HU=i;function c(C,k,I,j,U){const z=o(k,C),ne=U.dirname(k),_=U.dirname(j),ae=[];for(const J of z.folders){const G=u(J)?U.resolvePath(ne,J.path):g.URI.parse(J.uri);let N;I?N=!1:N=!u(J)||(0,P.$ic)(J.path),ae.push(E(G,N,J.name,_,U))}const se={insertSpaces:!1,tabSize:4,eol:f.$l||f.$k?`
`:`\r
`},oe=s.$YS(C,["folders"],ae,se);let K=s.$2S(C,oe);return(0,a.$Ag)(z.remoteAuthority,(0,y.$Tk)(j))&&(K=s.$2S(K,s.$XS(K,["remoteAuthority"],se))),K}e.$IU=c;function o(C,k){const I=R.$Tm(k);if(I&&Array.isArray(I.folders))I.folders=I.folders.filter(j=>m(j));else throw new Error(`${C} looks like an invalid workspace file.`);return I}function t(C){return C.workspace&&typeof C.workspace=="object"&&typeof C.workspace.id=="string"&&typeof C.workspace.configPath=="string"}function n(C){return typeof C.folderUri=="string"}function r(C){return typeof C.fileUri=="string"}function p(C,k){const I={workspaces:[],files:[]};if(C){const j=function(z,ne){for(let _=0;_<z.length;_++)try{ne(z[_],_)}catch(ae){k.warn(`Error restoring recent entry ${JSON.stringify(z[_])}: ${ae.toString()}. Skip entry.`)}},U=C;Array.isArray(U.entries)&&j(U.entries,z=>{const ne=z.label,_=z.remoteAuthority;t(z)?I.workspaces.push({label:ne,remoteAuthority:_,workspace:{id:z.workspace.id,configPath:g.URI.parse(z.workspace.configPath)}}):n(z)?I.workspaces.push({label:ne,remoteAuthority:_,folderUri:g.URI.parse(z.folderUri)}):r(z)&&I.files.push({label:ne,remoteAuthority:_,fileUri:g.URI.parse(z.fileUri)})})}return I}e.$JU=p;function A(C){const k={entries:[]};for(const I of C.workspaces)b(I)?k.entries.push({folderUri:I.folderUri.toString(),label:I.label,remoteAuthority:I.remoteAuthority}):k.entries.push({workspace:{id:I.workspace.id,configPath:I.workspace.configPath.toString()},label:I.label,remoteAuthority:I.remoteAuthority});for(const I of C.files)k.entries.push({fileUri:I.fileUri.toString(),label:I.label,remoteAuthority:I.remoteAuthority});return k}e.$KU=A}),define(te[98],ie([0,1,85,13,4,19]),function(Q,e,S,R,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$p6b=e.$o6b=e.$n6b=e.$m6b=void 0,e.$m6b=128/4;function D(a){function g(){let w=a.scheme===R.Schemas.file?(0,M.$jg)(a):a.toString();return s.$l||(w=w.toLowerCase()),(0,S.createHash)("md5").update(w).digest("hex")}return{id:g(),configPath:a}}e.$n6b=D;function P(a,g){function w(){if(a.scheme!==R.Schemas.file)return(0,S.createHash)("md5").update(a.toString()).digest("hex");if(!g)return;let d;return s.$l?d=g.ino:s.$k?d=g.birthtime.getTime():s.$j&&(typeof g.birthtimeMs=="number"?d=Math.floor(g.birthtimeMs):d=g.birthtime.getTime()),(0,S.createHash)("md5").update(a.fsPath).update(d?String(d):"").digest("hex")}const y=w();if(typeof y=="string")return{id:y,uri:a}}e.$o6b=P;function f(){return{id:(Date.now()+Math.round(Math.random()*1e3)).toString()}}e.$p6b=f}),define(te[99],ie([0,1,85,87,28,280,17,14,3,2,9,4,32,42,109]),function(Q,e,S,R,s,M,D,P,f,a,g,w,y,d,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kh=e.$Jh=e.$Ih=e.$Hh=e.$Gh=e.$Fh=e.$Eh=e.$Dh=void 0;class b{traceSocketEvent(k,I){v.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,k,I)}constructor(k,I=""){this.f=!0,this.debugLabel=I,this.socket=k,this.traceSocketEvent("created",{type:"NodeSocket"}),this.a=j=>{if(this.traceSocketEvent("error",{code:j?.code,message:j?.message}),j){if(j.code==="EPIPE")return;(0,P.$1)(j)}},this.socket.on("error",this.a),this.b=j=>{this.traceSocketEvent("close",{hadError:j}),this.f=!1},this.socket.on("close",this.b),this.d=()=>{this.traceSocketEvent("nodeEndReceived"),this.f=!1},this.socket.on("end",this.d)}dispose(){this.socket.off("error",this.a),this.socket.off("close",this.b),this.socket.off("end",this.d),this.socket.destroy()}onData(k){const I=j=>{this.traceSocketEvent("read",j),k(D.$be.wrap(j))};return this.socket.on("data",I),{dispose:()=>this.socket.off("data",I)}}onClose(k){const I=j=>{k({type:0,hadError:j,error:void 0})};return this.socket.on("close",I),{dispose:()=>this.socket.off("close",I)}}onEnd(k){const I=()=>{k()};return this.socket.on("end",I),{dispose:()=>this.socket.off("end",I)}}write(k){if(!(this.socket.destroyed||!this.f))try{this.traceSocketEvent("write",k),this.socket.write(k.buffer,I=>{if(I){if(I.code==="EPIPE")return;(0,P.$1)(I)}})}catch(I){if(I.code==="EPIPE")return;(0,P.$1)(I)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((k,I)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),k();return}const j=()=>{this.socket.off("close",j),this.socket.off("end",j),this.socket.off("error",j),this.socket.off("timeout",j),this.socket.off("drain",j),this.traceSocketEvent("nodeDrainEnd"),k()};this.socket.on("close",j),this.socket.on("end",j),this.socket.on("error",j),this.socket.on("timeout",j),this.socket.on("drain",j)})}}e.$Dh=b;var $;(function(C){C[C.MinHeaderByteSize=2]="MinHeaderByteSize",C[C.MaxWebSocketMessageLength=262144]="MaxWebSocketMessageLength"})($||($={}));var m;(function(C){C[C.PeekHeader=1]="PeekHeader",C[C.ReadHeader=2]="ReadHeader",C[C.ReadBody=3]="ReadBody",C[C.Fin=4]="Fin"})(m||(m={}));class u extends a.$Sc{get permessageDeflate(){return this.a.permessageDeflate}get recordedInflateBytes(){return this.a.recordedInflateBytes}traceSocketEvent(k,I){this.socket.traceSocketEvent(k,I)}constructor(k,I,j,U){super(),this.f=this.B(new f.$Nd),this.g=this.B(new f.$Nd),this.h=!1,this.j={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0,opcode:0},this.socket=k,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:I,inflateBytesLength:j?.byteLength||0,recordInflateBytes:U}),this.a=this.B(new l(this,I,j,U,this.f,(z,ne)=>this.m(z,ne))),this.B(this.a.onError(z=>{console.error(z),(0,P.$1)(z),this.g.fire({type:0,hadError:!0,error:z})})),this.b=new v.$yh,this.B(this.socket.onData(z=>this.n(z))),this.B(this.socket.onClose(async z=>{this.a.isProcessingReadQueue()&&await f.Event.toPromise(this.a.onDidFinishProcessingReadQueue),this.g.fire(z)}))}dispose(){this.a.isProcessingWriteQueue()?this.B(this.a.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(k){return this.f.event(k)}onClose(k){return this.g.event(k)}onEnd(k){return this.socket.onEnd(k)}write(k){let I=0;for(;I<k.byteLength;)this.a.writeMessage(k.slice(I,Math.min(I+262144,k.byteLength)),{compressed:!0,opcode:2}),I+=262144}m(k,{compressed:I,opcode:j}){if(this.h)return;this.traceSocketEvent("webSocketNodeSocketWrite",k);let U=2;k.byteLength<126?U+=0:k.byteLength<2**16?U+=2:U+=8;const z=D.$be.alloc(U),ne=I?64:0,_=j&15;if(z.writeUInt8(128|ne|_,0),k.byteLength<126)z.writeUInt8(k.byteLength,1);else if(k.byteLength<2**16){z.writeUInt8(126,1);let ae=1;z.writeUInt8(k.byteLength>>>8&255,++ae),z.writeUInt8(k.byteLength>>>0&255,++ae)}else{z.writeUInt8(127,1);let ae=1;z.writeUInt8(0,++ae),z.writeUInt8(0,++ae),z.writeUInt8(0,++ae),z.writeUInt8(0,++ae),z.writeUInt8(k.byteLength>>>24&255,++ae),z.writeUInt8(k.byteLength>>>16&255,++ae),z.writeUInt8(k.byteLength>>>8&255,++ae),z.writeUInt8(k.byteLength>>>0&255,++ae)}this.socket.write(D.$be.concat([z,k]))}end(){this.h=!0,this.socket.end()}n(k){if(k.byteLength!==0){for(this.b.acceptChunk(k);this.b.byteLength>=this.j.readLen;)if(this.j.state===1){const I=this.b.peek(this.j.readLen),j=I.readUInt8(0),U=(j&128)>>>7,z=(j&64)>>>6,ne=j&15,_=I.readUInt8(1),ae=(_&128)>>>7,se=_&127;this.j.state=2,this.j.readLen=2+(ae?4:0)+(se===126?2:0)+(se===127?8:0),this.j.fin=U,this.j.firstFrameOfMessage&&(this.j.compressed=!!z),this.j.firstFrameOfMessage=!!U,this.j.mask=0,this.j.opcode=ne,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,opcode:this.j.opcode})}else if(this.j.state===2){const I=this.b.read(this.j.readLen),j=I.readUInt8(1),U=(j&128)>>>7;let z=j&127,ne=1;z===126?z=I.readUInt8(++ne)*2**8+I.readUInt8(++ne):z===127&&(z=I.readUInt8(++ne)*0+I.readUInt8(++ne)*0+I.readUInt8(++ne)*0+I.readUInt8(++ne)*0+I.readUInt8(++ne)*2**24+I.readUInt8(++ne)*2**16+I.readUInt8(++ne)*2**8+I.readUInt8(++ne));let _=0;U&&(_=I.readUInt8(++ne)*2**24+I.readUInt8(++ne)*2**16+I.readUInt8(++ne)*2**8+I.readUInt8(++ne)),this.j.state=3,this.j.readLen=z,this.j.mask=_,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,mask:this.j.mask,opcode:this.j.opcode})}else if(this.j.state===3){const I=this.b.read(this.j.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",I),i(I,this.j.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",I),this.j.state=1,this.j.readLen=2,this.j.mask=0,this.j.opcode<=2?this.a.acceptFrame(I,this.j.compressed,!!this.j.fin):this.j.opcode===9&&this.a.writeMessage(I,{compressed:!1,opcode:10})}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this.a.isProcessingWriteQueue()&&await f.Event.toPromise(this.a.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.$Eh=u;class l extends a.$Sc{get permessageDeflate(){return!!(this.b&&this.f)}get recordedInflateBytes(){return this.b?this.b.recordedInflateBytes:D.$be.alloc(0)}constructor(k,I,j,U,z,ne){super(),this.n=k,this.r=z,this.s=ne,this.a=this.B(new f.$Nd),this.onError=this.a.event,this.g=[],this.h=[],this.j=this.B(new f.$Nd),this.onDidFinishProcessingReadQueue=this.j.event,this.m=this.B(new f.$Nd),this.onDidFinishProcessingWriteQueue=this.m.event,this.t=!1,this.y=!1,I?(this.b=this.B(new E(this.n,U,j,{windowBits:15})),this.f=this.B(new h(this.n,{windowBits:15})),this.B(this.b.onError(_=>this.a.fire(_))),this.B(this.f.onError(_=>this.a.fire(_)))):(this.b=null,this.f=null)}writeMessage(k,I){this.g.push({data:k,options:I}),this.u()}async u(){if(!this.t){for(this.t=!0;this.g.length>0;){const{data:k,options:I}=this.g.shift();if(this.f&&I.compressed){const j=await this.w(this.f,k);this.s(j,I)}else this.s(k,{...I,compressed:!1})}this.t=!1,this.m.fire()}}isProcessingWriteQueue(){return this.t}w(k,I){return new Promise((j,U)=>{k.write(I),k.flush(z=>j(z))})}acceptFrame(k,I,j){this.h.push({data:k,isCompressed:I,isLastFrameOfMessage:j}),this.z()}async z(){if(!this.y){for(this.y=!0;this.h.length>0;){const k=this.h.shift();if(this.b&&k.isCompressed){const I=await this.C(this.b,k.data,k.isLastFrameOfMessage);this.r.fire(I)}else this.r.fire(k.data)}this.y=!1,this.j.fire()}}isProcessingReadQueue(){return this.y}C(k,I,j){return new Promise((U,z)=>{k.write(I),j&&k.write(D.$be.fromByteArray([0,0,255,255])),k.flush(ne=>U(ne))})}}class E extends a.$Sc{get recordedInflateBytes(){return this.j?D.$be.concat(this.f):D.$be.alloc(0)}constructor(k,I,j,U){super(),this.h=k,this.j=I,this.a=this.B(new f.$Nd),this.onError=this.a.event,this.f=[],this.g=[],this.b=(0,M.createInflateRaw)(U),this.b.on("error",z=>{this.h.traceSocketEvent("zlibInflateError",{message:z?.message,code:z?.code}),this.a.fire(z)}),this.b.on("data",z=>{this.h.traceSocketEvent("zlibInflateData",z),this.g.push(D.$be.wrap(z))}),j&&(this.h.traceSocketEvent("zlibInflateInitialWrite",j.buffer),this.b.write(j.buffer),this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateInitialFlushFired"),this.g.length=0}))}write(k){this.j&&this.f.push(k.clone()),this.h.traceSocketEvent("zlibInflateWrite",k),this.b.write(k.buffer)}flush(k){this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateFlushFired");const I=D.$be.concat(this.g);this.g.length=0,k(I)})}}class h extends a.$Sc{constructor(k,I){super(),this.g=k,this.a=this.B(new f.$Nd),this.onError=this.a.event,this.f=[],this.b=(0,M.createDeflateRaw)({windowBits:15}),this.b.on("error",j=>{this.g.traceSocketEvent("zlibDeflateError",{message:j?.message,code:j?.code}),this.a.fire(j)}),this.b.on("data",j=>{this.g.traceSocketEvent("zlibDeflateData",j),this.f.push(D.$be.wrap(j))})}write(k){this.g.traceSocketEvent("zlibDeflateWrite",k.buffer),this.b.write(k.buffer)}flush(k){this.b.flush(2,()=>{this.g.traceSocketEvent("zlibDeflateFlushFired");let I=D.$be.concat(this.f);this.f.length=0,I=I.slice(0,I.byteLength-4),k(I)})}}function i(C,k){if(k===0)return;const I=C.byteLength>>>2;for(let ae=0;ae<I;ae++){const se=C.readUInt32BE(ae*4);C.writeUInt32BE(se^k,ae*4)}const j=I*4,U=C.byteLength-j,z=k>>>24&255,ne=k>>>16&255,_=k>>>8&255;U>=1&&C.writeUInt8(C.readUInt8(j)^z,j),U>=2&&C.writeUInt8(C.readUInt8(j+1)^ne,j+1),U>=3&&C.writeUInt8(C.readUInt8(j+2)^_,j+2)}e.$Fh=process.env.XDG_RUNTIME_DIR;const c={[2]:107,[1]:103};function o(){const C=(0,y.$eg)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${C}-sock`;const k=process.platform!=="darwin"&&e.$Fh?e.$Fh:(0,s.tmpdir)(),I=(0,g.$jc)(k,`vscode-ipc-${C}.sock`);return n(I),I}e.$Gh=o;function t(C,k,I){const j=(0,S.createHash)("md5").update(C).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${j}-${I}-${k}-sock`;const U=I.substr(0,4),z=k.substr(0,6),ne=j.substr(0,8);let _;return process.platform!=="darwin"&&e.$Fh&&!process.env.VSCODE_PORTABLE?_=(0,g.$jc)(e.$Fh,`vscode-${ne}-${U}-${z}.sock`):_=(0,g.$jc)(C,`${U}-${z}.sock`),n(_),_}e.$Hh=t;function n(C){const k=c[w.$u];typeof k=="number"&&C.length>=k&&console.warn(`WARNING: IPC handle "${C}" is longer than ${k} chars, try a shorter --user-data-dir`)}class r extends d.$sh{static b(k){const I=f.Event.fromNodeEventEmitter(k,"connection");return f.Event.map(I,j=>({protocol:new v.$zh(new b(j,"ipc-server-connection")),onDidClientDisconnect:f.Event.once(f.Event.fromNodeEventEmitter(j,"close"))}))}constructor(k){super(r.b(k)),this.d=k}dispose(){super.dispose(),this.d&&(this.d.close(),this.d=null)}}e.$Ih=r;function p(C){return new Promise((k,I)=>{const j=(0,R.createServer)();j.on("error",I),j.listen(C,()=>{j.removeListener("error",I),k(new r(j))})})}e.$Jh=p;function A(C,k){return new Promise((I,j)=>{const U=(0,R.createConnection)(C,()=>{U.removeListener("error",j),I(v.$Ah.fromSocket(new b(U,`ipc-client${k}`),k))});U.once("error",j)})}e.$Kh=A}),define(te[25],ie([0,1,54,9,4,99,36,89,6]),function(Q,e,S,R,s,M,D,P,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$35b=e.$25b=void 0,e.$25b=(0,f.$Ph)(D.$Vh);class a extends P.$hm{constructor(){super(...arguments),this.d={}}get cachedLanguagesPath(){return(0,R.$jc)(this.userDataPath,"clp")}get backupHome(){return(0,R.$jc)(this.userDataPath,"Backups")}get mainIPCHandle(){return(0,M.$Hh)(this.userDataPath,"main",this.c.version)}get mainLockfile(){return(0,R.$jc)(this.userDataPath,"code.lock")}get disableUpdates(){return!!this.args["disable-updates"]}get crossOriginIsolated(){return!!this.args["enable-coi"]}get codeCachePath(){return process.env.VSCODE_CODE_CACHE_PATH||void 0}get useCodeCache(){return!!this.codeCachePath}unsetSnapExportedVariables(){if(s.$l){for(const w in process.env)if(w.endsWith("_VSCODE_SNAP_ORIG")){const y=w.slice(0,-17);if(this.d[y])continue;process.env[y]&&(this.d[y]=process.env[y]),process.env[w]?process.env[y]=process.env[w]:delete process.env[y]}}}restoreSnapExportedVariables(){if(s.$l)for(const w in this.d)process.env[w]=this.d[w],delete this.d[w]}}e.$35b=a,ke([S.$gh],a.prototype,"cachedLanguagesPath",null),ke([S.$gh],a.prototype,"backupHome",null),ke([S.$gh],a.prototype,"mainIPCHandle",null),ke([S.$gh],a.prototype,"mainLockfile",null),ke([S.$gh],a.prototype,"disableUpdates",null),ke([S.$gh],a.prototype,"crossOriginIsolated",null),ke([S.$gh],a.prototype,"codeCachePath",null),ke([S.$gh],a.prototype,"useCodeCache",null)}),define(te[281],ie([0,1,85,33,13,9,4,19,21,194,18,25,34,16,5,193,29,98]),function(Q,e,S,R,s,M,D,P,f,a,g,w,y,d,v,b,$,m){"use strict";var u;Object.defineProperty(e,"__esModule",{value:!0}),e.$q6b=void 0;let l=class{static{u=this}static{this.a="backupWorkspaces"}constructor(h,i,c,o){this.j=h,this.k=i,this.l=c,this.m=o,this.c=this.j.backupHome,this.d=[],this.e=[],this.g=[],this.h=P.$mg,this.i={isEqual:(t,n)=>(0,R.$Wf)(t,n,!D.$l)}}async initialize(){const h=this.m.getItem(u.a)??{workspaces:[],folders:[],emptyWindows:[]};this.g=await this.w(h.emptyWindows),this.d=await this.u((0,a.$j6b)(h)),this.e=await this.v((0,a.$k6b)(h)),this.C()}n(){return this.q()?[]:this.d.slice(0)}o(){return this.q()?[]:this.e.slice(0)}isHotExitEnabled(){return this.s()!==d.$wk.OFF}q(){return this.s()===d.$wk.ON_EXIT_AND_WINDOW_CLOSE}s(){return this.k.getValue()?.files?.hotExit||d.$wk.ON_EXIT}getEmptyWindowBackups(){return this.g.slice(0)}registerWorkspaceBackup(h,i){this.d.some(o=>h.workspace.id===o.workspace.id)||(this.d.push(h),this.C());const c=(0,M.$jc)(this.c,h.workspace.id);return i?this.t(c,i).then(()=>c):c}async t(h,i){if(await f.Promises.exists(h)&&await this.z(h),await f.Promises.exists(i))try{await f.Promises.rename(i,h,!1)}catch(c){this.l.error(`Backup: Could not move backup folder to new location: ${c.toString()}`)}}registerFolderBackup(h){return this.e.some(i=>this.h.isEqual(h.folderUri,i.folderUri))||(this.e.push(h),this.C()),(0,M.$jc)(this.c,this.D(h))}registerEmptyWindowBackup(h){return this.g.some(i=>!!i.backupFolder&&this.i.isEqual(i.backupFolder,h.backupFolder))||(this.g.push(h),this.C()),(0,M.$jc)(this.c,h.backupFolder)}async u(h){if(!Array.isArray(h))return[];const i=new Set,c=[];for(const o of h){const t=o.workspace;if(!(0,$.$4h)(t))return[];if(!i.has(t.id)){i.add(t.id);const n=(0,M.$jc)(this.c,t.id);await this.B(n)?t.configPath.scheme!==s.Schemas.file||await f.Promises.exists(t.configPath.fsPath)?c.push(o):await this.z(n):await this.x(n)}}return c}async v(h){if(!Array.isArray(h))return[];const i=[],c=new Set;for(const o of h){const t=o.folderUri,n=this.h.getComparisonKey(t);if(!c.has(n)){c.add(n);const r=(0,M.$jc)(this.c,this.D(o));await this.B(r)?t.scheme!==s.Schemas.file||await f.Promises.exists(t.fsPath)?i.push(o):await this.z(r):await this.x(r)}}return i}async w(h){if(!Array.isArray(h))return[];const i=[],c=new Set;for(const o of h){const t=o.backupFolder;if(typeof t!="string")return[];if(!c.has(t)){c.add(t);const n=(0,M.$jc)(this.c,t);await this.B(n)?i.push(o):await this.x(n)}}return i}async x(h){try{await f.Promises.rm(h,f.RimRafMode.MOVE)}catch(i){this.l.error(`Backup: Could not delete stale backup: ${i.toString()}`)}}y(){let h=(0,m.$p6b)();for(;this.g.some(i=>!!i.backupFolder&&this.i.isEqual(i.backupFolder,h.id));)h=(0,m.$p6b)();return{backupFolder:h.id}}async z(h){const i=this.y(),c=(0,M.$jc)(this.c,i.backupFolder);try{await f.Promises.rename(h,c,!1)}catch(o){return this.l.error(`Backup: Could not rename backup folder: ${o.toString()}`),!1}return this.g.push(i),!0}async getDirtyWorkspaces(){const h=[];for(const i of this.d)await this.A(i)&&h.push(i);for(const i of this.e)await this.A(i)&&h.push(i);return h}A(h){let i;return(0,a.$i6b)(h)?i=(0,M.$jc)(this.c,h.backupFolder):(0,b.$zU)(h)?i=(0,M.$jc)(this.c,this.D(h)):i=(0,M.$jc)(this.c,h.workspace.id),this.B(i)}async B(h){try{const i=await f.Promises.readdir(h);for(const c of i)try{if((await f.Promises.readdir((0,M.$jc)(h,c))).length>0)return!0}catch{}}catch{}return!1}C(){const h={workspaces:this.d.map(({workspace:i,remoteAuthority:c})=>{const o={id:i.id,configURIPath:i.configPath.toString()};return c&&(o.remoteAuthority=c),o}),folders:this.e.map(({folderUri:i,remoteAuthority:c})=>{const o={folderUri:i.toString()};return c&&(o.remoteAuthority=c),o}),emptyWindows:this.g.map(({backupFolder:i,remoteAuthority:c})=>{const o={backupFolder:i};return c&&(o.remoteAuthority=c),o})};this.m.setItem(u.a,h)}D(h){const i=h.folderUri;let c;return i.scheme===s.Schemas.file?c=D.$l?i.fsPath:i.fsPath.toLowerCase():c=i.toString().toLowerCase(),(0,S.createHash)("md5").update(c).digest("hex")}};e.$q6b=l,e.$q6b=l=u=ke([ee(0,w.$25b),ee(1,g.$ii),ee(2,v.$9i),ee(3,y.$rN)],l)}),define(te[20],ie([0,1,15,38,8,3,2,4,35,12,6,5,34,25]),function(Q,e,S,R,s,M,D,P,f,a,g,w,y,d){"use strict";var v;Object.defineProperty(e,"__esModule",{value:!0}),e.$55b=e.LifecycleMainPhase=e.ShutdownReason=e.$45b=void 0,e.$45b=(0,g.$Oh)("lifecycleMainService");var b;(function(u){u[u.QUIT=1]="QUIT",u[u.KILL=2]="KILL"})(b||(e.ShutdownReason=b={}));var $;(function(u){u[u.Starting=1]="Starting",u[u.Ready=2]="Ready",u[u.AfterWindowOpen=3]="AfterWindowOpen",u[u.Eventually=4]="Eventually"})($||(e.LifecycleMainPhase=$={}));let m=class extends D.$Sc{static{v=this}static{this.b="lifecycle.quitAndRestart"}get quitRequested(){return this.j}get wasRestarted(){return this.m}get phase(){return this.n}constructor(l,E,h){super(),this.F=l,this.G=E,this.H=h,this.c=this.B(new M.$Nd),this.onBeforeShutdown=this.c.event,this.f=this.B(new M.$Nd),this.onWillShutdown=this.f.event,this.g=this.B(new M.$Nd),this.onWillLoadWindow=this.g.event,this.h=this.B(new M.$Nd),this.onBeforeCloseWindow=this.h.event,this.j=!1,this.m=!1,this.n=1,this.r=new Set,this.s=0,this.t=0,this.u=void 0,this.w=void 0,this.y=void 0,this.z=new Map,this.C=new Map,this.D=void 0,this.I(),this.when(2).then(()=>this.J())}I(){this.m=!!this.G.getItem(v.b),this.m&&this.G.removeItem(v.b)}J(){const l=()=>{this.j||(this.S("Lifecycle#app.on(before-quit)"),this.j=!0,this.S("Lifecycle#onBeforeShutdown.fire()"),this.c.fire(),P.$k&&this.t===0&&this.L(1))};S.app.addListener("before-quit",l);const E=()=>{this.S("Lifecycle#app.on(window-all-closed)"),(this.j||!P.$k)&&S.app.quit()};S.app.addListener("window-all-closed",E),S.app.once("will-quit",h=>{this.S("Lifecycle#app.on(will-quit) - begin"),h.preventDefault(),this.L(1).finally(()=>{this.S("Lifecycle#app.on(will-quit) - after fireOnWillShutdown"),this.O(!1),S.app.removeListener("before-quit",l),S.app.removeListener("window-all-closed",E),this.S("Lifecycle#app.on(will-quit) - calling app.quit()"),S.app.quit()})})}L(l){if(this.y)return this.y;const E=this.F;this.S("Lifecycle#onWillShutdown.fire()");const h=[];return this.f.fire({reason:l,join(i,c){E.trace(`Lifecycle#onWillShutdown - begin '${i}'`),h.push(c.finally(()=>{E.trace(`Lifecycle#onWillShutdown - end '${i}'`)}))}}),this.y=(async()=>{try{await s.Promises.settled(h)}catch(i){this.F.error(i)}try{await this.G.close()}catch(i){this.F.error(i)}})(),this.y}set phase(l){if(l<this.phase)throw new Error("Lifecycle cannot go backwards");if(this.n===l)return;this.S(`lifecycle (main): phase changed (value: ${l})`),this.n=l;const E=this.C.get(this.n);E&&(E.open(),this.C.delete(this.n))}async when(l){if(l<=this.n)return;let E=this.C.get(l);E||(E=new s.$Sg,this.C.set(l,E)),await E.wait()}registerWindow(l){const E=new D.$Rc;this.t++,E.add(l.onWillLoad(i=>this.g.fire({window:l,workspace:i.workspace,reason:i.reason})));const h=(0,a.$Jf)(l.win);h.on("close",i=>{const c=l.id;if(this.r.has(c)){this.r.delete(c);return}this.S(`Lifecycle#window.on('close') - window ID ${l.id}`),i.preventDefault(),this.unload(l,1).then(o=>{if(o){this.r.delete(c);return}this.r.add(c),this.S(`Lifecycle#onBeforeCloseWindow.fire() - window ID ${c}`),this.h.fire(l),l.close()})}),h.on("closed",()=>{this.S(`Lifecycle#window.on('closed') - window ID ${l.id}`),this.t--,E.dispose(),this.t===0&&(!P.$k||this.j)&&this.L(1)})}async reload(l,E){await this.unload(l,3)||l.reload(E)}unload(l,E){const h=this.z.get(l.id);if(h)return h;const i=this.M(l,E).finally(()=>{this.z.delete(l.id)});return this.z.set(l.id,i),i}async M(l,E){if(!l.isReady)return!1;this.S(`Lifecycle#unload() - window ID ${l.id}`);const h=this.j?2:E,i=await this.P(l,h);return i?(this.S(`Lifecycle#unload() - veto in renderer (window ID ${l.id})`),this.N(i)):(await this.Q(l,h),!1)}N(l){return l?(this.O(!0),this.j=!1,!0):!1}O(l){this.w&&(this.w(l),this.w=void 0,this.u=void 0)}P(l,E){return new Promise(h=>{const i=this.s++,c=`vscode:ok${i}`,o=`vscode:cancel${i}`;R.$eT.once(c,()=>{h(!1)}),R.$eT.once(o,()=>{h(!0)}),l.send("vscode:onBeforeUnload",{okChannel:c,cancelChannel:o,reason:E})})}Q(l,E){return new Promise(h=>{const c=`vscode:reply${this.s++}`;R.$eT.once(c,()=>h()),l.send("vscode:onWillUnload",{replyChannel:c,reason:E})})}quit(l){return this.R(l).then(E=>{if(!E&&l)try{if(P.$j){const h=(0,f.cwd)();h!==process.cwd()&&process.chdir(h)}}catch(h){this.F.error(h)}return E})}R(l){return this.S(`Lifecycle#quit() - begin (willRestart: ${l})`),this.u?(this.S("Lifecycle#quit() - returning pending quit promise"),this.u):(l&&this.G.setItem(v.b,!0),this.u=new Promise(E=>{this.w=E,this.S("Lifecycle#quit() - calling app.quit()"),S.app.quit()}),this.u)}S(l){this.H.args["enable-smoke-test-driver"]?this.F.info(l):this.F.trace(l)}setRelaunchHandler(l){this.D=l}async relaunch(l){this.S("Lifecycle#relaunch()");const E=process.argv.slice(1);if(l?.addArgs&&E.push(...l.addArgs),l?.removeArgs)for(const c of l.removeArgs){const o=E.indexOf(c);o>=0&&E.splice(o,1)}const h=()=>{this.D?.handleRelaunch(l)||(this.S("Lifecycle#relaunch() - calling app.relaunch()"),S.app.relaunch({args:E}))};S.app.once("quit",h),await this.quit(!0)&&S.app.removeListener("quit",h)}async kill(l){this.S("Lifecycle#kill()"),await this.L(2),await Promise.race([(0,s.$Ug)(1e3),(async()=>{for(const E of S.BrowserWindow.getAllWindows())if(E&&!E.isDestroyed()){let h;E.webContents&&!E.webContents.isDestroyed()?h=new Promise(i=>E.once("closed",i)):h=Promise.resolve(),E.destroy(),await h}})()]),S.app.exit(l)}};e.$55b=m,e.$55b=m=v=ke([ee(0,w.$9i),ee(1,y.$rN),ee(2,d.$25b)],m)}),define(te[282],ie([0,1,4,3,2,6,20]),function(Q,e,S,R,s,M,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$V6b=e.$U6b=void 0,e.$U6b=(0,M.$Oh)("keyboardLayoutMainService");let P=class extends s.$Sc{constructor(g){super(),this.a=this.B(new R.$Nd),this.onDidChangeKeyboardLayout=this.a.event,this.b=null,this.c=null,g.when(3).then(()=>this.f())}f(){return this.b||(this.b=this.g()),this.b}async g(){const g=await new Promise((w,y)=>{Q(["native-keymap"],w,y)});this.c=f(g),S.$t||g.onDidChangeKeyboardLayout(()=>{this.c=f(g),this.a.fire(this.c)})}async getKeyboardLayoutData(){return await this.f(),this.c}};e.$V6b=P,e.$V6b=P=ke([ee(0,D.$45b)],P);function f(a){const g=a.getKeyMap(),w=a.getCurrentKeyboardLayout();return{keyboardMapping:g,keyboardLayoutInfo:w}}}),define(te[283],ie([0,1,244,8,17,14,12,18,36,93,5,50,243,280]),function(Q,e,S,R,s,M,D,P,f,a,g,w,y,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xq=e.$Wq=void 0;let v=class extends w.$Ro{constructor(u,l,E,h){super(h),this.m=u,this.n=l,this.r=E,this.s(),this.B(u.onDidChangeConfiguration(i=>{i.affectsConfiguration("http")&&this.s()}))}s(){const u=this.m.getValue("http");this.f=u?.proxy,this.g=!!u?.proxyStrictSSL,this.h=u?.proxyAuthorization}async request(u,l){const{f:E,g:h}=this;let i;try{i=await(0,a.$Rl)(this.m,this.r,this.n.args,process.env)}catch(t){this.j||(this.j=!0,this.r.error("resolving shell environment failed",(0,M.$0)(t)))}const c={...process.env,...i},o=u.agent?u.agent:await(0,y.$Vq)(u.url||"",c,{proxyUrl:E,strictSSL:h});return u.agent=o,u.strictSSL=h,this.h&&(u.headers={...u.headers||{},"Proxy-Authorization":this.h}),this.c(u.isChromiumNetwork?"electron":"node",u,()=>$(u,l))}async resolveProxy(u){}};e.$Wq=v,e.$Wq=v=ke([ee(0,P.$ii),ee(1,f.$Wh),ee(2,g.$9i),ee(3,g.$0i)],v);async function b(m){return((0,S.parse)(m.url).protocol==="https:"?await new Promise((E,h)=>{Q(["https"],E,h)}):await new Promise((E,h)=>{Q(["http"],E,h)})).request}async function $(m,u){return R.Promises.withAsyncBody(async(l,E)=>{const h=(0,S.parse)(m.url),i=m.getRawRequest?m.getRawRequest(m):await b(m),c={hostname:h.hostname,port:h.port?parseInt(h.port):h.protocol==="https:"?443:80,protocol:h.protocol,path:h.path,method:m.type||"GET",headers:m.headers,agent:m.agent,rejectUnauthorized:(0,D.$Ef)(m.strictSSL)?m.strictSSL:!0};m.user&&m.password&&(c.auth=m.user+":"+m.password);const o=i(c,t=>{const n=(0,D.$Cf)(m.followRedirects)?m.followRedirects:3;if(t.statusCode&&t.statusCode>=300&&t.statusCode<400&&n>0&&t.headers.location)$({...m,url:t.headers.location,followRedirects:n-1},u).then(l,E);else{let r=t;!m.isChromiumNetwork&&t.headers["content-encoding"]==="gzip"&&(r=t.pipe((0,d.createGunzip)())),l({res:t,stream:(0,s.$qe)(r)})}});o.on("error",E),m.timeout&&o.setTimeout(m.timeout),m.isChromiumNetwork&&o.removeHeader("Content-Length"),m.data&&typeof m.data=="string"&&o.write(m.data),o.end(),u.onCancellationRequested(()=>{o.abort(),E(new M.$5)})})}e.$Xq=$}),define(te[284],ie([0,1,15,283]),function(Q,e,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Y7b=void 0;function s(D){return S.net.request}class M extends R.$Wq{request(P,f){return super.request({...P||{},getRawRequest:s,isChromiumNetwork:!0},f)}}e.$Y7b=M}),define(te[81],ie([0,1,7,3,2,36,16,6,20,5,96,277,41,52,40,13]),function(Q,e,S,R,s,M,D,P,f,a,g,w,y,d,v,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$c6b=e.$b6b=e.$a6b=e.$_5b=void 0,e.$_5b=(0,P.$Oh)("storageMainService");let $=class extends s.$Sc{constructor(l,E,h,i,c,o){super(),this.c=l,this.f=E,this.g=h,this.h=i,this.j=c,this.m=o,this.a=void 0,this.b=this.B(new R.$Nd),this.onDidChangeProfileStorage=this.b.event,this.applicationStorage=this.B(this.s()),this.t=new Map,this.w=new Map,this.r()}n(){return{useInMemoryStorage:!!this.f.extensionTestsLocationURI}}r(){(async()=>(await this.h.when(3),this.applicationStorage.init()))(),this.B(this.h.onWillLoadWindow(l=>{l.window.profile&&this.profileStorage(l.window.profile).init(),l.workspace&&this.workspaceStorage(l.workspace).init()})),this.B(this.h.onWillShutdown(l=>{this.c.trace("storageMainService#onWillShutdown()"),this.a=l.reason,l.join("applicationStorage",this.applicationStorage.close());for(const[,E]of this.t)l.join("profileStorage",E.close());for(const[,E]of this.w)l.join("workspaceStorage",E.close())})),this.B(this.g.onWillCreateProfile(l=>{l.join((async()=>{await this.j.exists(l.profile.globalStorageHome)||await this.j.createFolder(l.profile.globalStorageHome)})())})),this.B(this.g.onWillRemoveProfile(l=>{const E=this.t.get(l.profile.id);E&&l.join(E.close())}))}s(){this.c.trace("StorageMainService: creating application storage");const l=new w.$75b(this.n(),this.g,this.c,this.j);return this.B(R.Event.once(l.onDidCloseStorage)(()=>{this.c.trace("StorageMainService: closed application storage")})),l}profileStorage(l){if((0,g.$7o)(l))return this.applicationStorage;let E=this.t.get(l.id);if(!E){this.c.trace(`StorageMainService: creating profile storage (${l.name})`),E=this.B(this.u(l)),this.t.set(l.id,E);const h=this.B(E.onDidChangeStorage(i=>this.b.fire({...i,storage:E,profile:l})));this.B(R.Event.once(E.onDidCloseStorage)(()=>{this.c.trace(`StorageMainService: closed profile storage (${l.name})`),this.t.delete(l.id),h.dispose()}))}return E}u(l){return this.a===2?new w.$95b(this.c,this.j):new w.$65b(l,this.n(),this.c,this.j)}workspaceStorage(l){let E=this.w.get(l.id);return E||(this.c.trace(`StorageMainService: creating workspace storage (${l.id})`),E=this.B(this.y(l)),this.w.set(l.id,E),this.B(R.Event.once(E.onDidCloseStorage)(()=>{this.c.trace(`StorageMainService: closed workspace storage (${l.id})`),this.w.delete(l.id)}))),E}y(l){return this.a===2?new w.$95b(this.c,this.j):new w.$85b(l,this.n(),this.c,this.f,this.j)}isUsed(l){const E=S.URI.file(l);for(const h of[this.applicationStorage,...this.t.values(),...this.w.values()])if(h.path&&this.m.extUri.isEqualOrParent(S.URI.file(h.path),E))return!0;return!1}};e.$a6b=$,e.$a6b=$=ke([ee(0,a.$9i),ee(1,M.$Vh),ee(2,d.$05b),ee(3,f.$45b),ee(4,D.$0j),ee(5,v.$Hk)],$),e.$b6b=(0,P.$Oh)("applicationStorageMainService");let m=class extends g.$6o{constructor(l,E){super(),this.s=l,this.U=E,this.whenReady=this.U.applicationStorage.whenInit}O(){return this.U.applicationStorage.whenInit}P(l){if(l===-1)return this.U.applicationStorage.storage}Q(l){if(l===-1)return this.s.defaultProfile.globalStorageHome.with({scheme:b.Schemas.file}).fsPath}r(){return!1}switch(){throw new Error("Migrating storage is unsupported from main process")}R(){throw new Error("Switching storage profile is unsupported from main process")}S(){throw new Error("Switching storage workspace is unsupported from main process")}hasScope(){throw new Error("Main process is never profile or workspace scoped")}};e.$c6b=m,e.$c6b=m=ke([ee(0,y.$Jk),ee(1,e.$_5b)],m)}),define(te[285],ie([0,1,87,28,103,99,8,2,4,18,5,24,239,240,94,126,17]),function(Q,e,S,R,s,M,D,P,f,a,g,w,y,d,v,b,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$X7b=e.$W7b=e.$V7b=e.$U7b=void 0;async function m(i,c,o,t,n){let r;for(let p=3;p&&(r?.dispose(),r=await new u(i,c,o,t,n).waitForReady(),!(n&&s.$hg[n]||!s.$hg[r.tunnelLocalPort]));p--);return r}class u extends P.$Sc{constructor(c,o,t,n,r){super(),this.m=o,this.n=r,this.privacy=b.TunnelPrivacyId.Private,this.j=new Map,this.a=c,this.b=S.createServer(),this.c=new D.$Sg,this.f=()=>this.c.open(),this.b.on("listening",this.f),this.g=p=>this.r(p),this.b.on("connection",this.g),this.h=()=>{},this.b.on("error",this.h),this.tunnelRemotePort=n,this.tunnelRemoteHost=t}async dispose(){super.dispose(),this.b.removeListener("listening",this.f),this.b.removeListener("connection",this.g),this.b.removeListener("error",this.h),this.b.close(),Array.from(this.j.values()).forEach(o=>{o()})}async waitForReady(){const c=this.n??this.tunnelRemotePort,o=(0,b.$av)(this.m)?"0.0.0.0":"127.0.0.1";let t=await(0,s.$ig)(c,2,1e3,o),n=null;return this.b.listen(t,this.m),await this.c.wait(),n=this.b.address(),n||(t=0,this.b.listen(t,this.m),await this.c.wait(),n=this.b.address()),this.tunnelLocalPort=n.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${n.port}`,this}async r(c){c.pause();const o=(0,b.$$u)(this.tunnelRemoteHost)||(0,b.$av)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,t=await(0,y.$5k)(this.a,o,this.tunnelRemotePort),n=t.getSocket(),r=t.readEntireBuffer();t.dispose(),r.byteLength>0&&c.write(r.buffer),c.on("end",()=>{c.localAddress&&this.j.delete(c.localAddress),n.end()}),c.on("close",()=>n.end()),c.on("error",()=>{c.localAddress&&this.j.delete(c.localAddress),n instanceof M.$Dh?n.socket.destroy():n.end()}),n instanceof M.$Dh?this.t(c,n):this.s(c,n),c.localAddress&&this.j.set(c.localAddress,()=>{c.end(),n.end()})}s(c,o){o.onClose(()=>c.destroy()),o.onEnd(()=>c.end()),o.onData(t=>c.write(t.buffer)),c.on("data",t=>o.write($.$be.wrap(t))),c.resume()}t(c,o){const t=o.socket;t.on("end",()=>c.end()),t.on("close",()=>c.end()),t.on("error",()=>{c.destroy()}),t.pipe(c),c.pipe(t)}}e.$U7b=u;let l=class extends b.$dv{constructor(c,o,t,n,r){super(o,r),this.u=c,this.v=t,this.w=n}isPortPrivileged(c){return(0,b.$bv)(c,this.l,f.OS,R.release())}s(c,o,t,n,r,p,A,C){const k=this.r(o,t);if(k)return++k.refcount,k.value;if((0,b.$8u)(c))return this.t(c,o,t,r,p,A,C);{this.j.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${o}:${t} on local port ${r}.`);const I={commit:this.w.commit,quality:this.w.quality,addressProvider:c,remoteSocketFactoryService:this.u,signService:this.v,logService:this.j,ipcLogger:null},j=m(I,n,o,t,r);return this.j.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.p(o,t,j),j}}};e.$V7b=l,e.$V7b=l=ke([ee(0,d.$Yk),ee(1,g.$9i),ee(2,v.$2k),ee(3,w.$oj),ee(4,a.$ii)],l);let E=class extends l{constructor(c,o,t,n,r){super(c,o,t,n,r)}};e.$W7b=E,e.$W7b=E=ke([ee(0,d.$Yk),ee(1,g.$9i),ee(2,v.$2k),ee(3,w.$oj),ee(4,a.$ii)],E);let h=class extends P.$Sc{constructor(c,o,t,n,r){super(),this.b=c,this.c=o,this.f=t,this.g=n,this.h=r,this.a=new Map}async openTunnel(c,o,t,n,r,p,A,C,k){if(this.c.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${t}:${n} on local port ${p}.`),!this.a.has(c)){const I=new E(this.b,this.c,this.g,this.f,this.h);this.B(I),this.a.set(c,I),I.onTunnelClosed(async()=>{(await I.tunnels).length===0&&(I.dispose(),this.a.delete(c))})}return this.a.get(c).openTunnel(o,t,n,r,p,A,C,k)}};e.$X7b=h,e.$X7b=h=ke([ee(0,d.$Yk),ee(1,g.$9i),ee(2,w.$oj),ee(3,v.$2k),ee(4,a.$ii)],h)}),define(te[100],ie([0,1,8,22,3,18,25,20,5,24,50,48]),function(Q,e,S,R,s,M,D,P,f,a,g,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$i7b=e.$h7b=void 0;function y(v,b,$){return`${$.updateUrl}/api/update/${v}/${b}/${$.commit}`}e.$h7b=y;let d=class{get state(){return this.b}d(b){this.j.info("update#setState",b.type),this.b=b,this.c.fire(b)}constructor(b,$,m,u,l,E){this.f=b,this.g=$,this.h=m,this.i=u,this.j=l,this.k=E,this.b=w.$dU.Uninitialized,this.c=new s.$Nd,this.onStateChange=this.c.event,b.when(3).finally(()=>this.l())}async l(){if(!this.h.isBuilt){this.d(w.$dU.Disabled(0));return}if(this.h.disableUpdates){this.d(w.$dU.Disabled(1)),this.j.info("update#ctor - updates are disabled by the environment");return}if(!this.k.updateUrl||!this.k.commit){this.d(w.$dU.Disabled(3)),this.j.info("update#ctor - updates are disabled as there is no update URL");return}const b=this.g.getValue("update.mode"),$=this.m(b);if(!$){this.d(w.$dU.Disabled(2)),this.j.info("update#ctor - updates are disabled by user preference");return}if(this.a=this.s($),!this.a){this.d(w.$dU.Disabled(4)),this.j.info("update#ctor - updates are disabled as the update URL is badly formed");return}if(this.d(w.$dU.Idle(this.q())),b==="manual"){this.j.info("update#ctor - manual checks only; automatic updates are disabled by user preference");return}b==="start"?(this.j.info("update#ctor - startup checks only; automatic updates are disabled by user preference"),setTimeout(()=>this.checkForUpdates(!1),30*1e3)):this.n(30*1e3).then(void 0,m=>this.j.error(m))}m(b){return b==="none"?void 0:this.k.quality}n(b=60*60*1e3){return(0,S.$Ug)(b).then(()=>this.checkForUpdates(!1)).then(()=>this.n(60*60*1e3))}async checkForUpdates(b){this.j.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.t(b)}async downloadUpdate(){this.j.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.o(this.state)}async o(b){}async applyUpdate(){this.j.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.p()}async p(){}quitAndInstall(){return this.j.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.j.trace("update#quitAndInstall(): before lifecycle quit()"),this.f.quit(!0).then(b=>{this.j.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${b}`),!b&&(this.j.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.r())})),Promise.resolve(void 0)}async isLatestVersion(){if(!this.a)return;if(this.g.getValue("update.mode")==="none")return!1;try{return(await this.i.request({url:this.a},R.CancellationToken.None)).res.statusCode===204}catch($){this.j.error("update#isLatestVersion(): failed to check for updates"),this.j.error($);return}}async _applySpecificUpdate(b){}q(){return 1}r(){}};e.$i7b=d,e.$i7b=d=ke([ee(0,P.$45b),ee(1,M.$ii),ee(2,D.$25b),ee(3,g.$Qo),ee(4,f.$9i),ee(5,a.$oj)],d)}),define(te[286],ie([0,1,15,54,3,2,18,25,20,5,24,50,26,48,100]),function(Q,e,S,R,s,M,D,P,f,a,g,w,y,d,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$j7b=void 0;let b=class extends v.$i7b{get v(){return s.Event.fromNodeEventEmitter(S.autoUpdater,"error",(m,u)=>u)}get w(){return s.Event.fromNodeEventEmitter(S.autoUpdater,"update-not-available")}get x(){return s.Event.fromNodeEventEmitter(S.autoUpdater,"update-available",(m,u,l)=>({url:u,version:l,productVersion:l}))}get y(){return s.Event.fromNodeEventEmitter(S.autoUpdater,"update-downloaded",(m,u,l,E)=>({releaseNotes:u,version:l,productVersion:l,date:E}))}constructor(m,u,l,E,h,i,c){super(m,u,E,h,i,c),this.z=l,this.u=new M.$Rc,m.setRelaunchHandler(this)}handleRelaunch(m){return m?.addArgs||m?.removeArgs||this.state.type!=="ready"?!1:(this.j.trace("update#handleRelaunch(): running raw#quitAndInstall()"),this.r(),!0)}async l(){await super.l(),this.v(this.B,this,this.u),this.x(this.E,this,this.u),this.y(this.F,this,this.u),this.w(this.G,this,this.u)}B(m){this.j.error("UpdateService error:",m);const u=this.state.type==="checking for updates"&&this.state.explicit?m:void 0;this.d(d.$dU.Idle(1,u))}s(m){let u;this.k.darwinUniversalAssetId?u=this.k.darwinUniversalAssetId:u=process.arch==="x64"?"darwin":"darwin-arm64";const l=(0,v.$h7b)(u,m,this.k);try{S.autoUpdater.setFeedURL({url:l})}catch(E){this.j.error("Failed to set update feed URL",E);return}return l}t(m){this.d(d.$dU.CheckingForUpdates(m)),S.autoUpdater.checkForUpdates()}E(m){this.state.type==="checking for updates"&&this.d(d.$dU.Downloading(m))}F(m){this.state.type==="downloading"&&(this.z.publicLog2("update:downloaded",{version:m.version}),this.d(d.$dU.Ready(m)))}G(){this.state.type==="checking for updates"&&(this.z.publicLog2("update:notAvailable",{explicit:this.state.explicit}),this.d(d.$dU.Idle(1)))}r(){this.j.trace("update#quitAndInstall(): running raw#quitAndInstall()"),S.autoUpdater.quitAndInstall()}dispose(){this.u.dispose()}};e.$j7b=b,ke([R.$gh],b.prototype,"v",null),ke([R.$gh],b.prototype,"w",null),ke([R.$gh],b.prototype,"x",null),ke([R.$gh],b.prototype,"y",null),e.$j7b=b=ke([ee(0,f.$45b),ee(1,D.$ii),ee(2,y.$bl),ee(3,P.$25b),ee(4,w.$Qo),ee(5,a.$9i),ee(6,g.$oj)],b)}),define(te[287],ie([0,1,47,45,8,3,9,25,20,5,26,48]),function(Q,e,S,R,s,M,D,P,f,a,g,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$l7b=void 0;let y=class{get state(){return this.a}d(b){this.g.info("update#setState",b.type),this.a=b,this.b.fire(b)}constructor(b,$,m){if(this.f=b,this.g=m,this.a=w.$dU.Uninitialized,this.b=new M.$Nd,this.onStateChange=this.b.event,$.disableUpdates){this.g.info("update#ctor - updates are disabled");return}this.d(w.$dU.Idle(this.k())),this.h(30*1e3).then(void 0,u=>this.g.error(u))}h(b=60*60*1e3){return(0,s.$Ug)(b).then(()=>this.checkForUpdates(!1)).then(()=>this.h(60*60*1e3))}async checkForUpdates(b){this.g.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.m(b)}async downloadUpdate(){this.g.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.i(this.state)}i(b){return Promise.resolve(void 0)}async applyUpdate(){this.g.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.j()}j(){return Promise.resolve(void 0)}quitAndInstall(){return this.g.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.g.trace("update#quitAndInstall(): before lifecycle quit()"),this.f.quit(!0).then(b=>{this.g.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${b}`),!b&&(this.g.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.l())})),Promise.resolve(void 0)}k(){return 2}l(){}async _applySpecificUpdate(b){}};y=ke([ee(0,f.$45b),ee(1,P.$25b),ee(2,a.$9i)],y);let d=class extends y{constructor(b,$,m,u,l,E){super(m,u,l),this.o=b,this.p=$,this.q=E;const h=(0,R.watch)(D.$mc(this.o)),i=M.Event.fromNodeEventEmitter(h,"change",(n,r)=>r),c=M.Event.filter(i,n=>n==="current"),t=M.Event.debounce(c,(n,r)=>r,2e3)(()=>this.checkForUpdates(!1));m.onWillShutdown(()=>{t.dispose(),h.close()})}m(){this.d(w.$dU.CheckingForUpdates(!1)),this.u().then(b=>{b?this.d(w.$dU.Ready({version:"something",productVersion:"something"})):(this.q.publicLog2("update:notAvailable",{explicit:!1}),this.d(w.$dU.Idle(2)))},b=>{this.g.error(b),this.q.publicLog2("update:notAvailable",{explicit:!1}),this.d(w.$dU.Idle(2,b.message||b))})}l(){this.g.trace("update#quitAndInstall(): running raw#quitAndInstall()"),(0,S.spawn)("sleep 3 && "+D.$nc(process.argv[0]),{shell:!0,detached:!0,stdio:"ignore"})}async u(){const b=await new Promise((m,u)=>(0,R.realpath)(`${D.$mc(this.o)}/current`,(l,E)=>l?u(l):m(E))),$=D.$nc(b);return this.p!==$}isLatestVersion(){return this.u().then(void 0,b=>{this.g.error("update#checkForSnapUpdate(): Could not get realpath of application.")})}};e.$l7b=d,e.$l7b=d=ke([ee(2,f.$45b),ee(3,P.$25b),ee(4,a.$9i),ee(5,g.$bl)],d)}),define(te[30],ie([0,1,4,6,95,68,67,24,18,25,9]),function(Q,e,S,R,s,M,D,P,f,a,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$g6b=e.OpenContext=e.$f6b=void 0,e.$f6b=(0,R.$Oh)("windowsMainService");var w;(function(d){d[d.CLI=0]="CLI",d[d.DOCK=1]="DOCK",d[d.MENU=2]="MENU",d[d.DIALOG=3]="DIALOG",d[d.DESKTOP=4]="DESKTOP",d[d.API=5]="API"})(w||(e.OpenContext=w={}));function y(d,v=(0,s.$15b)(),b){const $=d.get(D.$d6b),m=d.get(P.$oj),u=d.get(f.$ii),l=d.get(a.$25b),E=u.getValue("window"),h={width:v.width,height:v.height,x:v.x,y:v.y,backgroundColor:$.getBackgroundColor(),minWidth:M.$XC.WIDTH,minHeight:M.$XC.HEIGHT,title:m.nameLong,...b,webPreferences:{enableWebSQL:!1,spellcheck:!1,zoomFactor:(0,M.$5C)(E?.zoomLevel),autoplayPolicy:"user-gesture-required",enableBlinkFeatures:"HighlightAPI",...b?.webPreferences,sandbox:!0},experimentalDarkMode:!0};return S.$l?h.icon=(0,g.$jc)(l.appRoot,"resources/linux/code.png"):S.$j&&!l.isBuilt&&(h.icon=(0,g.$jc)(l.appRoot,"resources/win32/code_150x150.png")),S.$k&&(h.acceptFirstMouse=!0,E?.clickThroughInactive===!1&&(h.acceptFirstMouse=!1)),h}e.$g6b=y}),define(te[288],ie([0,1,15,22,3,55,2,32,116,5,81,30]),function(Q,e,S,R,s,M,D,P,f,a,g,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$h6b=void 0;var y;(function(v){v[v.Initial=1]="Initial",v[v.StoredCredentialsUsed=2]="StoredCredentialsUsed",v[v.LoginDialogShown=3]="LoginDialogShown"})(y||(y={}));let d=class extends D.$Sc{constructor(b,$,m,u){super(),this.g=b,this.h=$,this.j=m,this.m=u,this.a="proxy-credentials://",this.b=void 0,this.c=y.Initial,this.f=void 0,this.n()}n(){const b=s.Event.fromNodeEventEmitter(S.app,"login",($,m,u,l,E)=>({event:$,webContents:m,req:u,authInfo:l,callback:E}));this.B(b(this.r,this))}async r({event:b,authInfo:$,req:m,callback:u}){if(!$.isProxy)return;if(!this.b&&this.c===y.LoginDialogShown&&m.firstAuthAttempt){this.g.trace("auth#onLogin (proxy) - exit - proxy dialog already shown");return}b.preventDefault();let l;if(this.b)this.g.trace("auth#onLogin (proxy) - pending proxy handling found"),l=await this.b;else{this.g.trace("auth#onLogin (proxy) - no pending proxy handling found, starting new"),this.b=this.s($);try{l=await this.b}finally{this.b=void 0}}u(l?.username,l?.password)}async s(b){this.g.trace("auth#resolveProxyCredentials (proxy) - enter");try{const $=await this.t(b);if($)return this.g.trace("auth#resolveProxyCredentials (proxy) - got credentials"),$;this.g.trace("auth#resolveProxyCredentials (proxy) - did not get credentials")}finally{this.g.trace("auth#resolveProxyCredentials (proxy) - exit")}}async t(b){this.g.trace("auth#doResolveProxyCredentials - enter",b);const $=String((0,M.$Ci)({scheme:b.scheme,host:b.host,port:b.port}));let m,u;try{const i=this.m.get(this.a+$,-1);if(i){const c=JSON.parse(await this.j.decrypt(i));m=c.username,u=c.password}}catch(i){this.g.error(i)}if(this.c!==y.StoredCredentialsUsed&&typeof m=="string"&&typeof u=="string")return this.g.trace("auth#doResolveProxyCredentials (proxy) - exit - found stored credentials to use"),this.c=y.StoredCredentialsUsed,{username:m,password:u};const l=this.h.getFocusedWindow()||this.h.getLastActiveWindow();if(!l){this.g.trace("auth#doResolveProxyCredentials (proxy) - exit - no opened window found to show dialog in");return}this.g.trace(`auth#doResolveProxyCredentials (proxy) - asking window ${l.id} to handle proxy login`);const E={authInfo:b,username:this.f?.username??m,password:this.f?.password??u,replyChannel:`vscode:proxyAuthResponse:${(0,P.$eg)()}`};l.sendWhenReady("vscode:openProxyAuthenticationDialog",R.CancellationToken.None,E),this.c=y.LoginDialogShown;const h=await new Promise(i=>{const c=async(o,t,n)=>{if(t===E.replyChannel)if(this.g.trace(`auth#doResolveProxyCredentials - exit - received credentials from window ${l.id}`),l.win?.webContents.off("ipc-message",c),n){const r={username:n.username,password:n.password};try{if(n.remember){const p=await this.j.encrypt(JSON.stringify(r));this.m.store(this.a+$,p,-1,1)}else this.m.remove(this.a+$,-1)}catch(p){this.g.error(p)}i({username:r.username,password:r.password})}else i(void 0)};l.win?.webContents.on("ipc-message",c)});return this.f=h,h}};e.$h6b=d,e.$h6b=d=ke([ee(0,a.$9i),ee(1,w.$f6b),ee(2,f.$YT),ee(3,g.$b6b)],d)}),define(te[289],ie([0,1,15,23,4,7,21,18,62,6,5,127,30]),function(Q,e,S,R,s,M,D,P,f,a,g,w,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Y6b=e.$X6b=e.ID=void 0,e.ID="launchMainService",e.$X6b=(0,a.$Oh)(e.ID);let d=class{constructor(b,$,m,u){this.a=b,this.b=$,this.c=m,this.d=u}async start(b,$){this.a.trace("Received data from other instance: ",b,$),s.$k&&S.app.focus({steal:!0});const m=this.e(b);if(m.length){let u=Promise.resolve();if(this.b.getWindowCount()===0){const l=(0,R.$Ob)(await this.b.openEmptyWindow({context:4}));l&&(u=l.ready())}u.then(()=>{for(const{uri:l,originalUrl:E}of m)this.c.open(l,{originalUrl:E})})}else return this.f(b,$)}e(b){return b["open-url"]&&b._urls&&b._urls.length>0?(0,R.$Hb)(b._urls.map($=>{try{return{uri:M.URI.parse($),originalUrl:$}}catch{return null}})):[]}async f(b,$){const m=(0,f.$Ll)($)?0:4;let u=[];const l=b.wait&&b.waitMarkerFilePath?M.URI.file(b.waitMarkerFilePath):void 0,E=b.remote||void 0,h={context:m,cli:b,userEnv:$,waitMarkerFileURI:l,remoteAuthority:E,forceProfile:b.profile,forceTempProfile:b["profile-temp"]};if(b.extensionDevelopmentPath)await this.b.openExtensionDevelopmentHostWindow(b.extensionDevelopmentPath,h);else if(!b._.length&&!b["folder-uri"]&&!b["file-uri"]){let i=!1;if(b["new-window"]||b["unity-launch"]||h.forceProfile||h.forceTempProfile)i=!0;else if(b["reuse-window"])i=!1;else switch(this.d.getValue("window")?.openWithoutArgumentsInNewWindow||"default"){case"on":i=!0;break;case"off":i=!1;break;default:i=!s.$k}if(i)u=await this.b.open({...h,forceNewWindow:!0,forceEmpty:!0});else{const c=this.b.getLastActiveWindow();c?(this.b.openExistingWindow(c,h),u=[c]):u=await this.b.open({...h,forceEmpty:!0})}}else u=await this.b.open({...h,forceNewWindow:b["new-window"],preferNewWindow:!b["reuse-window"]&&!b.wait,forceReuseWindow:b["reuse-window"],diffMode:b.diff,mergeMode:b.merge,addMode:b.add,noRecentEntry:!!b["skip-add-to-recently-opened"],gotoLineMode:b.goto});if(l&&u.length===1&&u[0])return Promise.race([u[0].whenClosedOrLoaded,(0,D.whenDeleted)(l.fsPath)]).then(()=>{},()=>{})}async getMainProcessId(){return this.a.trace("Received request for process ID from other instance."),process.pid}};e.$Y6b=d,e.$Y6b=d=ke([ee(0,g.$9i),ee(1,y.$f6b),ee(2,w.$5T),ee(3,P.$ii)],d)}),define(te[290],ie([0,1,2,20,52,29,8,30]),function(Q,e,S,R,s,M,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$E7b=void 0;let f=class extends S.$Sc{constructor(g,w,y){super(),this.a=w,this.b=y,this.B(g.onWillLoadWindow(d=>{d.reason===2&&this.c(d.window)})),this.B(g.onBeforeCloseWindow(d=>this.c(d))),this.B(new D.$6g(()=>this.g(),30*1e3)).schedule()}async c(g){const w=this.f(g),y=this.a.getProfileForWorkspace(w);y?.isTransient&&(this.a.unsetWorkspace(w,y.isTransient),y.isTransient&&await this.a.cleanUpTransientProfiles())}f(g){return g.openedWorkspace??(0,M.$3h)(g.backupPath,g.isExtensionDevelopmentHost)}g(){const g=this.a.getAssociatedEmptyWindows();if(g.length===0)return;const w=this.b.getWindows().map(y=>this.f(y));for(const y of g)w.some(d=>d.id===y.id)||this.a.unsetWorkspace(y,!1)}};e.$E7b=f,e.$E7b=f=ke([ee(0,R.$45b),ee(1,s.$05b),ee(2,P.$f6b)],f)}),define(te[60],ie([0,1,15,2,3,5,311,8,13,30,73,26,20,75,37,4,130]),function(Q,e,S,R,s,M,D,P,f,a,g,w,y,d,v,b,$){"use strict";var m;Object.defineProperty(e,"__esModule",{value:!0}),e.$A6b=e.$z6b=void 0;function u(h){return typeof h.responseWindowId=="number"}let l=class extends R.$Sc{static{m=this}static{this.a=0}static{this.b=new Map}static getAll(){return Array.from(m.b.values())}constructor(i,c,o){super(),this.t=i,this.u=c,this.w=o,this.c=String(++m.a),this.f=this.B(new s.$Nd),this.onStdout=this.f.event,this.g=this.B(new s.$Nd),this.onStderr=this.g.event,this.h=this.B(new s.$Nd),this.onMessage=this.h.event,this.j=this.B(new s.$Nd),this.onExit=this.j.event,this.m=this.B(new s.$Nd),this.onCrash=this.m.event,this.n=void 0,this.r=void 0,this.s=void 0}y(i,c){let o;switch(this.s?.correlationId?o=`[UtilityProcess id: ${this.s?.correlationId}, type: ${this.s?.type}, pid: ${this.r??"<none>"}]: ${i}`:o=`[UtilityProcess type: ${this.s?.type}, pid: ${this.r??"<none>"}]: ${i}`,c){case g.default.Error:this.t.error(o);break;case g.default.Warning:this.t.warn(o);break;case g.default.Info:this.t.trace(o);break}}z(){return this.n?(this.y("Cannot start utility process because it is already running...",g.default.Error),!1):!0}start(i){const c=this.C(i);return c&&i.payload&&this.postMessage(i.payload),c}C(i){if(!this.z())return!1;this.s=i;const c=`${this.s.type}-${this.c}`,o=f.$cg.asFileUri("bootstrap-fork.js").fsPath,t=this.s.args??[],n=this.s.execArgv??[],r=this.s.allowLoadingUnsignedLibraries,p=this.s.forceAllocationsToV8Sandbox,A="pipe",C=this.D(i);return this.y("creating new...",g.default.Info),this.n=S.utilityProcess.fork(o,t,{serviceName:c,env:C,execArgv:n,allowLoadingUnsignedLibraries:r,forceAllocationsToV8Sandbox:p,stdio:A}),this.F(this.n,this.s,c),!0}D(i){const c=i.env?{...i.env}:{...(0,v.$4m)(process.env)};c.VSCODE_AMD_ENTRYPOINT=i.entryPoint,typeof i.parentLifecycleBound=="number"&&(c.VSCODE_PARENT_PID=String(i.parentLifecycleBound)),c.VSCODE_CRASH_REPORTER_PROCESS_TYPE=i.type,b.$j&&((0,$.isUNCAccessRestrictionsDisabled)()?c.NODE_DISABLE_UNC_ACCESS_CHECKS="1":c.NODE_UNC_HOST_ALLOWLIST=(0,$.getUNCHostAllowlist)().join("\\")),(0,d.$yl)(c);for(const o of Object.keys(c))c[o]=String(c[o]);return c}F(i,c,o){if(i.stdout){const t=new D.StringDecoder("utf-8");this.B(s.Event.fromNodeEventEmitter(i.stdout,"data")(n=>this.f.fire(typeof n=="string"?n:t.write(n))))}if(i.stderr){const t=new D.StringDecoder("utf-8");this.B(s.Event.fromNodeEventEmitter(i.stderr,"data")(n=>this.g.fire(typeof n=="string"?n:t.write(n))))}this.B(s.Event.fromNodeEventEmitter(i,"message")(t=>this.h.fire(t))),this.B(s.Event.fromNodeEventEmitter(i,"spawn")(()=>{this.r=i.pid,typeof i.pid=="number"&&m.b.set(i.pid,{pid:i.pid,name:u(c)?`${c.type} [${c.responseWindowId}]`:c.type}),this.y("successfully created",g.default.Info)})),this.B(s.Event.fromNodeEventEmitter(i,"exit")(t=>{this.y(`received exit event with code ${t}`,g.default.Info),this.j.fire({pid:this.r,code:t,signal:"unknown"}),this.G()})),this.B(s.Event.fromNodeEventEmitter(S.app,"child-process-gone",(t,n)=>({event:t,details:n}))(({details:t})=>{t.type==="Utility"&&t.name===o&&(this.y(`crashed with code ${t.exitCode} and reason '${t.reason}'`,g.default.Error),this.u.publicLog2("utilityprocesscrash",{type:c.type,reason:t.reason,code:t.exitCode}),this.m.fire({pid:this.r,code:t.exitCode,reason:t.reason}),this.G())}))}once(i,c){const o=this.B(this.h.event(t=>{t===i&&(o.dispose(),c())}))}postMessage(i,c){this.n&&this.n.postMessage(i,c)}connect(i){const{port1:c,port2:o}=new S.MessageChannelMain;return this.postMessage(i,[o]),c}enableInspectPort(){if(!this.n||typeof this.r!="number")return!1;this.y("enabling inspect port",g.default.Info);const i=process;return typeof i._debugProcess=="function"?(i._debugProcess(this.r),!0):!1}kill(){if(!this.n)return;this.y("attempting to kill the process...",g.default.Info),this.n.kill()?(this.y("successfully killed the process",g.default.Info),this.G()):this.y("unable to kill the process",g.default.Warning)}G(){typeof this.r=="number"&&m.b.delete(this.r),this.n=void 0}async waitForExit(i){this.n&&(this.y("waiting to exit...",g.default.Info),await Promise.race([s.Event.toPromise(this.onExit),(0,P.$Ug)(i)]),this.n&&(this.y(`did not exit within ${i}ms, will kill it now...`,g.default.Info),this.kill()))}};e.$z6b=l,e.$z6b=l=m=ke([ee(0,M.$9i),ee(1,w.$bl),ee(2,y.$45b)],l);let E=class extends l{constructor(i,c,o,t){super(i,o,t),this.H=c}start(i){const c=this.H.getWindowById(i.responseWindowId);if(!c?.win||c.win.isDestroyed()||c.win.webContents.isDestroyed())return this.y("Refusing to start utility process because requesting window cannot be found or is destroyed...",g.default.Error),!0;if(!super.C(i))return!1;this.I(c.win,i);const t=this.connect(i.payload);return c.win.webContents.postMessage(i.responseChannel,i.responseNonce,[t]),!0}I(i,c){c.windowLifecycleBound&&(this.B(s.Event.filter(this.w.onWillLoadWindow,o=>o.window.win===i)(()=>this.kill())),this.B(s.Event.fromNodeEventEmitter(i,"closed")(()=>this.kill())))}};e.$A6b=E,e.$A6b=E=ke([ee(0,M.$9i),ee(1,a.$f6b),ee(2,w.$bl),ee(3,y.$45b)],E)}),define(te[291],ie([0,1,14,5,20,8,60,30,26]),function(Q,e,S,R,s,M,D,P,f){"use strict";var a;Object.defineProperty(e,"__esModule",{value:!0}),e.$H6b=void 0;let g=class{static{a=this}static{this.a=0}constructor(y,d,v,b){this.d=y,this.f=d,this.g=v,this.h=b,this.b=new Map,this.c=!1,this.f.onWillShutdown($=>{this.c=!0,$.join("extHostStarter",this._waitForAllExit(6e3))})}dispose(){}i(y){const d=this.b.get(y);if(!d)throw new Error("Unknown extension host!");return d}onDynamicStdout(y){return this.i(y).onStdout}onDynamicStderr(y){return this.i(y).onStderr}onDynamicMessage(y){return this.i(y).onMessage}onDynamicExit(y){return this.i(y).onExit}async createExtensionHost(){if(this.c)throw(0,S.$6)();const y=String(++a.a),d=new D.$A6b(this.d,this.g,this.h,this.f);return this.b.set(y,d),d.onExit(({pid:v,code:b,signal:$})=>{this.d.info(`Extension host with pid ${v} exited with code: ${b}, signal: ${$}.`),setTimeout(()=>{d.dispose(),this.b.delete(y)})}),{id:y}}async start(y,d){if(this.c)throw(0,S.$6)();this.i(y).start({...d,type:"extensionHost",entryPoint:"vs/workbench/api/node/extensionHostProcess",args:["--skipWorkspaceStorageLock"],execArgv:d.execArgv,allowLoadingUnsignedLibraries:!0,forceAllocationsToV8Sandbox:!0,correlationId:y})}async enableInspectPort(y){if(this.c)throw(0,S.$6)();const d=this.b.get(y);return d?d.enableInspectPort():!1}async kill(y){if(this.c)throw(0,S.$6)();const d=this.b.get(y);d&&d.kill()}async _killAllNow(){for(const[,y]of this.b)y.kill()}async _waitForAllExit(y){const d=[];for(const[,v]of this.b)d.push(v.waitForExit(y));return M.Promises.settled(d).then(()=>{})}};e.$H6b=g,e.$H6b=g=a=ke([ee(0,R.$9i),ee(1,s.$45b),ee(2,P.$f6b),ee(3,f.$bl)],g)}),define(te[292],ie([0,1,38,8,2,25,20,5,41,39,66,60,51,89,12,245,24]),function(Q,e,S,R,s,M,D,P,f,a,g,w,y,d,v,b,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$b7b=void 0;let m=class extends s.$Sc{constructor(l,E,h,i,c,o,t,n){super(),this.c=l,this.f=E,this.g=h,this.h=i,this.j=c,this.m=o,this.n=t,this.r=n,this.a=new R.$Sg,this.b=void 0,this.w=void 0,this.y=void 0,this.s()}s(){S.$eT.on(b.$_6b.request,(l,E)=>this.t(l,E,b.$_6b.response)),S.$eT.on(b.$a7b.request,(l,E)=>this.t(l,E,b.$a7b.response)),this.B(this.h.onWillShutdown(()=>this.u()))}async t(l,E,h){this.j.trace(`[SharedProcess] onWindowConnection for: ${h}`),this.a.isOpen()||this.a.open(),await this.whenReady();const i=await this.connect(h);if(l.sender.isDestroyed())return i.close();l.sender.postMessage(h,E,[i])}u(){this.j.trace("[SharedProcess] onWillShutdown"),this.b?.postMessage(b.$$6b.exit),this.b=void 0}whenReady(){return this.w||(this.w=(async()=>{await this.z;const l=new R.$ch;this.b?this.b.once(b.$$6b.initDone,()=>l.complete()):S.$eT.once(b.$$6b.initDone,()=>l.complete()),await l.p,this.j.trace("[SharedProcess] Overall ready")})()),this.w}get z(){return this.y||(this.y=(async()=>{await this.a.wait(),this.C();const l=new R.$ch;this.b?this.b.once(b.$$6b.ipcReady,()=>l.complete()):S.$eT.once(b.$$6b.ipcReady,()=>l.complete()),await l.p,this.j.trace("[SharedProcess] IPC ready")})()),this.y}C(){this.b=this.B(new w.$z6b(this.j,y.$jo,this.h));const l=(0,d.$jm)(this.f.args,this.f.isBuilt);let E;l.port&&(E=["--nolazy"],l.break?E.push(`--inspect-brk=${l.port}`):E.push(`--inspect=${l.port}`)),this.b.start({type:"shared-process",entryPoint:"vs/code/node/sharedProcess/sharedProcessMain",payload:this.D(),execArgv:E,allowLoadingUnsignedLibraries:!!process.env.VSCODE_VOICE_MODULE_PATH&&this.r.quality!=="stable"})}D(){return{machineId:this.c,codeCachePath:this.f.codeCachePath,profiles:{home:this.g.profilesHome,all:this.g.profiles},args:this.f.args,logLevel:this.m.getLogLevel(),loggers:this.m.getRegisteredLoggers(),policiesData:this.n.serialize()}}async connect(l){return await this.z,(0,v.$Jf)(this.b).connect(l)}};e.$b7b=m,e.$b7b=m=ke([ee(1,M.$25b),ee(2,f.$Jk),ee(3,D.$45b),ee(4,P.$9i),ee(5,g.$96b),ee(6,a.$fn),ee(7,$.$oj)],m)}),define(te[293],ie([0,1,25,89,20,5,51,60,110,38,2,3,37,18,13]),function(Q,e,S,R,s,M,D,P,f,a,g,w,y,d,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$M7b=void 0;let b=class extends g.$Sc{constructor(m,u,l,E,h){super(),this.f=m,this.g=u,this.h=l,this.j=E,this.m=h,this.a=void 0,this.b=new w.$Nd,this.onRequestConnection=this.b.event,this.c=new w.$Nd,this.onWillShutdown=this.c.event,this.j.onWillShutdown(()=>this.c.fire()),a.$eT.on("vscode:createPtyHostMessageChannel",(i,c)=>this.r(i,c)),this.B((0,g.$Qc)(()=>{a.$eT.removeHandler("vscode:createPtyHostMessageChannel")}))}start(){this.a=new P.$z6b(this.m,D.$jo,this.j);const m=(0,R.$im)(this.h.args,this.h.isBuilt),u=m.port?["--nolazy",`--inspect${m.break?"-brk":""}=${m.port}`]:void 0;this.a.start({type:"ptyHost",entryPoint:"vs/platform/terminal/node/ptyHostMain",execArgv:u,args:["--logsPath",this.h.logsHome.with({scheme:v.Schemas.file}).fsPath],env:this.n()});const l=this.a.connect(),E=new f.$mT(l,"ptyHost"),h=new g.$Rc;return h.add(E),h.add((0,g.$Qc)(()=>{this.a?.kill(),this.a?.dispose(),this.a=void 0})),{client:E,store:h,onDidProcessExit:this.a.onExit}}n(){this.h.unsetSnapExportedVariables();const m={...(0,y.$4m)(process.env),VSCODE_AMD_ENTRYPOINT:"vs/platform/terminal/node/ptyHostMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true",VSCODE_RECONNECT_GRACE_TIME:String(this.f.graceTime),VSCODE_RECONNECT_SHORT_GRACE_TIME:String(this.f.shortGraceTime),VSCODE_RECONNECT_SCROLLBACK:String(this.f.scrollback)},u=this.g.getValue("terminal.integrated.developer.ptyHost.latency");u&&typeof u=="number"&&(m.VSCODE_LATENCY=String(u));const l=this.g.getValue("terminal.integrated.developer.ptyHost.startupDelay");return l&&typeof l=="number"&&(m.VSCODE_STARTUP_DELAY=String(l)),this.h.restoreSnapExportedVariables(),m}r(m,u){this.b.fire();const l=this.a.connect();if(m.sender.isDestroyed()){l.close();return}m.sender.postMessage("vscode:createPtyHostMessageChannelResult",u,[l])}};e.$M7b=b,e.$M7b=b=ke([ee(1,d.$ii),ee(2,S.$25b),ee(3,s.$45b),ee(4,M.$9i)],b)}),define(te[294],ie([0,1,2,6,5,30,60,26,55,3,8,20]),function(Q,e,S,R,s,M,D,P,f,a,g,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$L7b=e.$K7b=void 0,e.$K7b=(0,R.$Oh)("utilityProcessWorker");let y=class extends S.$Sc{constructor(b,$,m,u){super(),this.b=b,this.c=$,this.f=m,this.g=u,this.a=new Map}async createWorker(b){const $=`window: ${b.reply.windowId}, moduleId: ${b.process.moduleId}`;this.b.trace(`[UtilityProcessWorker]: createWorker(${$})`);const m=this.h(b);this.a.has(m)&&(this.b.warn(`[UtilityProcessWorker]: createWorker() found an existing worker that will be terminated (${$})`),this.disposeWorker(b));const u=new d(this.b,this.c,this.f,this.g,b);if(!u.spawn())return{reason:{code:1,signal:"EINVALID"}};this.a.set(m,u);const l=new g.$ch;return a.Event.once(u.onDidTerminate)(E=>{E.code===0?this.b.trace(`[UtilityProcessWorker]: terminated normally with code ${E.code}, signal: ${E.signal}`):this.b.error(`[UtilityProcessWorker]: terminated unexpectedly with code ${E.code}, signal: ${E.signal}`),this.a.delete(m),l.complete({reason:E})}),l.p}h(b){return(0,f.$Ci)({moduleId:b.process.moduleId,windowId:b.reply.windowId})}async disposeWorker(b){const $=this.h(b),m=this.a.get($);m&&(this.b.trace(`[UtilityProcessWorker]: disposeWorker(window: ${b.reply.windowId}, moduleId: ${b.process.moduleId})`),m.kill(),this.a.delete($))}};e.$L7b=y,e.$L7b=y=ke([ee(0,s.$9i),ee(1,M.$f6b),ee(2,P.$bl),ee(3,w.$45b)],y);let d=class extends S.$Sc{constructor(b,$,m,u,l){super(),this.c=b,this.f=$,this.g=m,this.h=u,this.j=l,this.a=this.B(new a.$Nd),this.onDidTerminate=this.a.event,this.b=new D.$A6b(this.c,this.f,this.g,this.h),this.m()}m(){this.B(this.b.onExit(b=>this.a.fire({code:b.code,signal:b.signal}))),this.B(this.b.onCrash(b=>this.a.fire({code:b.code,signal:"ECRASH"})))}spawn(){const $=this.f.getWindowById(this.j.reply.windowId)?.win?.webContents.getOSProcessId();return this.b.start({type:this.j.process.type,entryPoint:this.j.process.moduleId,parentLifecycleBound:$,windowLifecycleBound:!0,correlationId:`${this.j.reply.windowId}`,responseWindowId:this.j.reply.windowId,responseChannel:this.j.reply.channel,responseNonce:this.j.reply.nonce})}kill(){this.b.kill()}};d=ke([ee(0,s.$9i),ee(1,M.$f6b),ee(2,P.$bl),ee(3,w.$45b)],d)}),define(te[295],ie([0,1,15,3,2,271,30]),function(Q,e,S,R,s,M,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$t7b=void 0;let P=class extends s.$Sc{constructor(a){super(),this.b=a,this.a=this.B(new R.$Nd),this.onFoundInFrame=this.a.event,this.B(new M.$s7b)}async setIgnoreMenuShortcuts(a,g){let w;if(typeof a.windowId=="number"){const{windowId:y}=a,d=this.b.getWindowById(y);if(!d?.win)throw new Error(`Invalid windowId: ${y}`);w=d.win.webContents}else{const{webContentsId:y}=a;if(w=S.webContents.fromId(y),!w)throw new Error(`Invalid webContentsId: ${y}`)}w.isDestroyed()||w.setIgnoreMenuShortcuts(g)}async findInFrame(a,g,w,y){const v=this.c(a,g);if(typeof v.findInFrame=="function"){v.findInFrame(w,{findNext:y.findNext,forward:y.forward});const b=($,m)=>{m.finalUpdate&&(this.a.fire(m),v.removeListener("found-in-frame",b))};v.on("found-in-frame",b)}}async stopFindInFrame(a,g,w){const d=this.c(a,g);typeof d.stopFindInFrame=="function"&&d.stopFindInFrame(w.keepSelection?"keepSelection":"clearSelection")}c(a,g){const w=this.b.getWindowById(a.windowId);if(!w?.win)throw new Error(`Invalid windowId: ${a}`);const y=w.win.webContents.mainFrame.framesInSubtree.find(d=>d.name===g);if(!y)throw new Error(`Unknown frame: ${g}`);return y}};e.$t7b=P,e.$t7b=P=ke([ee(0,D.$f6b)],P)}),define(te[296],ie([0,1,15,13,25,30]),function(Q,e,S,R,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Q7b=void 0;let D=class{static open(f){return f.invokeFunction(M.$g6b,void 0,{webPreferences:{preload:R.$cg.asFileUri("vs/base/parts/sandbox/electron-sandbox/preload-slim.js").fsPath}})}constructor(f,a){this.a=f,this.b=a,this.c(),this.d()}c(){this.b.args["open-devtools"]===!0&&this.a.openDevTools({mode:"bottom"})}d(){this.a.ipc.on("vscode:focusAuxiliaryWindow",()=>{this.e(f=>f.focus(),!0)}),this.a.ipc.on("vscode:moveAuxiliaryWindowTop",()=>{this.e(f=>f.moveTop(),!0)})}e(f,a){const g=S.BrowserWindow.fromWebContents(this.a);g&&(a&&g.isMinimized()&&g.restore(),f(g))}};e.$Q7b=D,e.$Q7b=D=ke([ee(1,s.$25b)],D)}),define(te[297],ie([0,1,15,2,4,19,7,18,20,5,34,30,95,29]),function(Q,e,S,R,s,M,D,P,f,a,g,w,y,d){"use strict";var v;Object.defineProperty(e,"__esModule",{value:!0}),e.$x7b=e.$w7b=e.$v7b=void 0;let b=class extends R.$Sc{static{v=this}static{this.a="windowsState"}get state(){return this.b}constructor(h,i,c,o,t){super(),this.g=h,this.h=i,this.j=c,this.m=o,this.n=t,this.b=$(this.h.getItem(v.a)),this.c=void 0,this.f=!1,this.r()}r(){S.app.on("browser-window-blur",()=>{this.f||this.t()}),this.j.onBeforeCloseWindow(h=>this.u(h)),this.j.onBeforeShutdown(()=>this.s()),this.g.onDidChangeWindowsCount(h=>{h.newCount-h.oldCount>0&&(this.c=void 0)}),this.g.onDidDestroyWindow(h=>this.u(h))}s(){this.f=!0,this.t()}t(){const h=new Set,i={openedWindows:[],lastPluginDevelopmentHostWindow:this.b.lastPluginDevelopmentHostWindow,lastActiveWindow:this.c};if(!i.lastActiveWindow){let t=this.g.getLastActiveWindow();(!t||t.isExtensionDevelopmentHost)&&(t=this.g.getWindows().find(n=>!n.isExtensionDevelopmentHost)),t&&(i.lastActiveWindow=this.w(t),i.lastActiveWindow.uiState.mode===3&&h.add(i.lastActiveWindow.uiState.display))}const c=this.g.getWindows().find(t=>t.isExtensionDevelopmentHost&&!t.isExtensionTestHost);c&&(i.lastPluginDevelopmentHostWindow=this.w(c),i.lastPluginDevelopmentHostWindow.uiState.mode===3&&(h.has(i.lastPluginDevelopmentHostWindow.uiState.display)?s.$k&&!c.win?.isSimpleFullScreen()&&(i.lastPluginDevelopmentHostWindow.uiState.mode=1):h.add(i.lastPluginDevelopmentHostWindow.uiState.display))),this.g.getWindowCount()>1&&(i.openedWindows=this.g.getWindows().filter(t=>!t.isExtensionDevelopmentHost).map(t=>{const n=this.w(t);return n.uiState.mode===3&&(h.has(n.uiState.display)?s.$k&&n.windowId!==i.lastActiveWindow?.windowId&&!t.win?.isSimpleFullScreen()&&(n.uiState.mode=1):h.add(n.uiState.display)),n}));const o=u(i);this.h.setItem(v.a,o),this.f&&this.m.trace("[WindowsStateHandler] onBeforeShutdown",o)}u(h){if(this.j.quitRequested)return;const i=this.w(h);h.isExtensionDevelopmentHost&&!h.isExtensionTestHost?this.b.lastPluginDevelopmentHostWindow=i:!h.isExtensionDevelopmentHost&&h.openedWorkspace&&this.b.openedWindows.forEach(c=>{const o=(0,d.$4h)(h.openedWorkspace)&&c.workspace?.id===h.openedWorkspace.id,t=(0,d.$Yh)(h.openedWorkspace)&&c.folderUri&&M.$mg.isEqual(c.folderUri,h.openedWorkspace.uri);(o||t)&&(c.uiState=i.uiState)}),this.g.getWindowCount()===1&&(this.c=i)}w(h){return{windowId:h.id,workspace:(0,d.$4h)(h.openedWorkspace)?h.openedWorkspace:void 0,folderUri:(0,d.$Yh)(h.openedWorkspace)?h.openedWorkspace.uri:void 0,backupPath:h.backupPath,remoteAuthority:h.remoteAuthority,uiState:h.serializeWindowState()}}getNewWindowState(h){const i=this.z(h),c=this.n.getValue("window");if(i.mode===3){let o;i.hasDefaultState?o=!!(c?.newWindowDimensions&&["fullscreen","inherit","offset"].indexOf(c.newWindowDimensions)>=0):o=!!(this.j.wasRestarted||c?.restoreFullscreen),o||(i.mode=1)}return i}z(h){const i=this.g.getLastActiveWindow();if(!h.extensionTestsPath){if(h.extensionDevelopmentPath&&this.state.lastPluginDevelopmentHostWindow)return this.state.lastPluginDevelopmentHostWindow.uiState;const p=h.workspace;if((0,d.$4h)(p)){const C=this.state.openedWindows.filter(k=>k.workspace&&k.workspace.id===p.id).map(k=>k.uiState);if(C.length)return C[0]}if((0,d.$Yh)(p)){const C=this.state.openedWindows.filter(k=>k.folderUri&&M.$mg.isEqual(k.folderUri,p.uri)).map(k=>k.uiState);if(C.length)return C[0]}else if(h.backupPath){const C=this.state.openedWindows.filter(k=>k.backupPath===h.backupPath).map(k=>k.uiState);if(C.length)return C[0]}const A=this.c||this.state.lastActiveWindow;if(!i&&A)return A.uiState}let c;const o=S.screen.getAllDisplays();if(o.length===1)c=o[0];else{if(s.$k){const p=S.screen.getCursorScreenPoint();c=S.screen.getDisplayNearestPoint(p)}!c&&i&&(c=S.screen.getDisplayMatching(i.getBounds())),c||(c=S.screen.getPrimaryDisplay()||o[0])}let t=(0,y.$15b)();t.x=Math.round(c.bounds.x+c.bounds.width/2-t.width/2),t.y=Math.round(c.bounds.y+c.bounds.height/2-t.height/2);const n=this.n.getValue("window");let r=!0;if(n?.newWindowDimensions){if(n.newWindowDimensions==="maximized")t.mode=0,r=!1;else if(n.newWindowDimensions==="fullscreen")t.mode=3,r=!1;else if((n.newWindowDimensions==="inherit"||n.newWindowDimensions==="offset")&&i){const p=i.serializeWindowState();p.mode===3?t.mode=3:t=p,r=t.mode!==3&&n.newWindowDimensions==="offset"}}return r&&(t=this.C(t)),t.hasDefaultState=!0,t}C(h){if(this.g.getWindows().length===0)return h;h.x=typeof h.x=="number"?h.x:0,h.y=typeof h.y=="number"?h.y:0;const i=this.g.getWindows().map(c=>c.getBounds());for(;i.some(c=>c.x===h.x||c.y===h.y);)h.x+=30,h.y+=30;return h}};e.$v7b=b,e.$v7b=b=v=ke([ee(0,w.$f6b),ee(1,g.$rN),ee(2,f.$45b),ee(3,a.$9i),ee(4,P.$ii)],b);function $(E){const h={openedWindows:[]},i=E||{openedWindows:[]};return i.lastActiveWindow&&(h.lastActiveWindow=m(i.lastActiveWindow)),i.lastPluginDevelopmentHostWindow&&(h.lastPluginDevelopmentHostWindow=m(i.lastPluginDevelopmentHostWindow)),Array.isArray(i.openedWindows)&&(h.openedWindows=i.openedWindows.map(c=>m(c))),h}e.$w7b=$;function m(E){const h={uiState:E.uiState};return E.backupPath&&(h.backupPath=E.backupPath),E.remoteAuthority&&(h.remoteAuthority=E.remoteAuthority),E.folder&&(h.folderUri=D.URI.parse(E.folder)),E.workspaceIdentifier&&(h.workspace={id:E.workspaceIdentifier.id,configPath:D.URI.parse(E.workspaceIdentifier.configURIPath)}),h}function u(E){return{lastActiveWindow:E.lastActiveWindow&&l(E.lastActiveWindow),lastPluginDevelopmentHostWindow:E.lastPluginDevelopmentHostWindow&&l(E.lastPluginDevelopmentHostWindow),openedWindows:E.openedWindows.map(h=>l(h))}}e.$x7b=u;function l(E){return{workspaceIdentifier:E.workspace&&{id:E.workspace.id,configURIPath:E.workspace.configPath.toString()},folder:E.folderUri&&E.folderUri.toString(),backupPath:E.backupPath,remoteAuthority:E.remoteAuthority,uiState:E.uiState}}}),define(te[53],ie([0,1,15,3,44,2,13,9,19,21,192,63,59,25,6,5,52,129,29,97,98]),function(Q,e,S,R,s,M,D,P,f,a,g,w,y,d,v,b,$,m,u,l,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$y6b=e.$x6b=void 0,e.$x6b=(0,v.$Oh)("workspacesManagementMainService");let h=class extends M.$Sc{constructor(c,o,t,n,r){super(),this.g=c,this.h=o,this.j=t,this.m=n,this.n=r,this.a=this.B(new R.$Nd),this.onDidDeleteUntitledWorkspace=this.a.event,this.b=this.B(new R.$Nd),this.onDidEnterWorkspace=this.b.event,this.c=this.g.untitledWorkspacesHome,this.f=[]}async initialize(){this.f=[];try{const c=(await a.Promises.readdir(this.c.with({scheme:D.Schemas.file}).fsPath)).map(o=>(0,f.$vg)(this.c,o,u.$bi));for(const o of c){const t=(0,E.$n6b)(o),n=await this.resolveLocalWorkspace(o);n?this.f.push({workspace:t,remoteAuthority:n.remoteAuthority}):await this.deleteUntitledWorkspace(t)}}catch(c){c.code!=="ENOENT"&&this.h.warn(`Unable to read folders in ${this.c} (${c}).`)}}resolveLocalWorkspace(c){return this.r(c,o=>a.Promises.readFile(o,"utf8"))}r(c,o){if(this.s(c)&&c.scheme===D.Schemas.file)try{const t=o(c.fsPath);return t instanceof Promise?t.then(n=>this.t(c,n),n=>{}):this.t(c,t)}catch{return}}s(c){return(0,u.$ci)(c,this.g)||(0,u.$hi)(c)}t(c,o){try{const t=this.u(c,o),n=(0,E.$n6b)(c);return{id:n.id,configPath:n.configPath,folders:(0,l.$HU)(t.folders,n.configPath,f.$mg),remoteAuthority:t.remoteAuthority,transient:t.transient}}catch(t){this.h.warn(t.toString())}}u(c,o){const t=(0,s.$Tm)(o);if(t&&Array.isArray(t.folders))t.folders=t.folders.filter(n=>(0,l.$FU)(n));else throw new Error(`${c.toString(!0)} looks like an invalid workspace file.`);return t}async createUntitledWorkspace(c,o){const{workspace:t,storedWorkspace:n}=this.w(c,o),r=t.configPath.fsPath;return await a.Promises.mkdir((0,P.$mc)(r),{recursive:!0}),await a.Promises.writeFile(r,JSON.stringify(n,null,"	")),this.f.push({workspace:t,remoteAuthority:o}),t}w(c=[],o){const t=(Date.now()+Math.round(Math.random()*1e3)).toString(),n=(0,f.$vg)(this.c,t),r=(0,f.$vg)(n,u.$bi),p=[];for(const A of c)p.push((0,l.$GU)(A.uri,!0,A.name,n,f.$mg));return{workspace:(0,E.$n6b)(r),storedWorkspace:{folders:p,remoteAuthority:o}}}async getWorkspaceIdentifier(c){return(0,E.$n6b)(c)}isUntitledWorkspace(c){return(0,u.$ci)(c.configPath,this.g)}async deleteUntitledWorkspace(c){this.isUntitledWorkspace(c)&&(await this.y(c),this.j.isEnabled()&&this.j.unsetWorkspace(c),this.a.fire(c))}async y(c){const o=(0,f.$jg)(c.configPath);try{await a.Promises.rm((0,P.$mc)(o));const t=(0,P.$jc)(this.g.workspaceStorageHome.with({scheme:D.Schemas.file}).fsPath,c.id);await a.Promises.exists(t)&&await a.Promises.writeFile((0,P.$jc)(t,"obsolete"),""),this.f=this.f.filter(n=>n.workspace.id!==c.id)}catch(t){this.h.warn(`Unable to delete untitled workspace ${o} (${t}).`)}}getUntitledWorkspaces(){return this.f}async enterWorkspace(c,o,t){if(!c||!c.win||!c.isReady||!await this.z(c,o,t))return;const r=await this.C(c,(0,E.$n6b)(t));if(r)return this.b.fire({window:c,workspace:r.workspace}),r}async z(c,o,t){return t?(0,u.$4h)(c.openedWorkspace)&&f.$mg.isEqual(c.openedWorkspace.configPath,t)?!1:(0,m.$v6b)(o,t)?(await this.n.showMessageBox({type:"info",buttons:[(0,g.localize)(0,null)],message:(0,g.localize)(1,null,(0,f.$sg)(t)),detail:(0,g.localize)(2,null)},S.BrowserWindow.getFocusedWindow()??void 0),!1):!0:!0}async C(c,o){if(!c.config)return;c.focus();let t;return c.config.extensionDevelopmentPath||(c.config.backupPath?t=await this.m.registerWorkspaceBackup({workspace:o,remoteAuthority:c.remoteAuthority},c.config.backupPath):t=this.m.registerWorkspaceBackup({workspace:o,remoteAuthority:c.remoteAuthority})),(0,u.$4h)(c.openedWorkspace)&&this.isUntitledWorkspace(c.openedWorkspace)&&await this.deleteUntitledWorkspace(c.openedWorkspace),c.config.workspace=o,c.config.backupPath=t,{workspace:o,backupPath:t}}};e.$y6b=h,e.$y6b=h=ke([ee(0,d.$25b),ee(1,b.$9i),ee(2,$.$05b),ee(3,w.$l6b),ee(4,y.$s6b)],h)}),define(te[131],ie([0,1,15,38,22,6,30,29,53,12,5,60]),function(Q,e,S,R,s,M,D,P,f,a,g,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$D6b=e.$C6b=e.ID=void 0,e.ID="diagnosticsMainService",e.$C6b=(0,M.$Oh)(e.ID);let y=class{constructor(v,b,$){this.a=v,this.b=b,this.c=$}async getRemoteDiagnostics(v){const b=this.a.getWindows();return(await Promise.all(b.map(async m=>{const u=m.remoteAuthority;if(!u)return;const l=`vscode:getDiagnosticInfoResponse${m.id}`,E={includeProcesses:v.includeProcesses,folders:v.includeWorkspaceMetadata?await this.f(m):void 0};return new Promise(h=>{m.sendWhenReady("vscode:getDiagnosticInfo",s.CancellationToken.None,{replyChannel:l,args:E}),R.$eT.once(l,(i,c)=>{c||h({hostName:u,errorMessage:`Unable to resolve connection to '${u}'.`}),h(c)}),setTimeout(()=>{h({hostName:u,errorMessage:`Connection to '${u}' could not be established`})},5e3)})}))).filter(m=>!!m)}async getMainDiagnostics(){this.c.trace("Received request for main process info from other instance.");const v=[];for(const $ of S.BrowserWindow.getAllWindows()){const m=this.a.getWindowById($.id);m?v.push(await this.d(m)):v.push(this.e($))}const b=[];for(const{pid:$,name:m}of w.$z6b.getAll())b.push({pid:$,name:m});return{mainPID:process.pid,mainArguments:process.argv.slice(1),windows:v,pidToNames:b,screenReader:!!S.app.accessibilitySupportEnabled,gpuFeatureStatus:S.app.getGPUFeatureStatus()}}async d(v){const b=await this.f(v),$=(0,a.$Jf)(v.win);return this.e($,b,v.remoteAuthority)}e(v,b=[],$){return{id:v.id,pid:v.webContents.getOSProcessId(),title:v.getTitle(),folderURIs:b,remoteAuthority:$}}async f(v){const b=[],$=v.openedWorkspace;if((0,P.$Yh)($))b.push($.uri);else if((0,P.$4h)($)){const m=await this.b.resolveLocalWorkspace($.configPath);m&&m.folders.forEach(l=>{b.push(l.uri)})}return b}};e.$D6b=y,e.$D6b=y=ke([ee(0,D.$f6b),ee(1,f.$x6b),ee(2,g.$9i)],y)}),define(te[69],ie([0,1,47,15,28,154,54,3,2,13,9,4,7,105,86,21,103,180,59,25,6,20,5,24,67,30,29,53,17,241,233]),function(Q,e,S,R,s,M,D,P,f,a,g,w,y,d,v,b,$,m,u,l,E,h,i,c,o,t,n,r,p,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$R6b=e.$Q6b=void 0,e.$Q6b=(0,E.$Oh)("nativeHostMainService");let k=class extends f.$Sc{constructor(j,U,z,ne,_,ae,se,oe){super(),this.a=j,this.b=U,this.c=z,this.f=ne,this.g=_,this.h=ae,this.j=se,this.m=oe,this.onDidOpenWindow=P.Event.map(this.a.onDidOpenWindow,K=>K.id),this.onDidTriggerSystemContextMenu=P.Event.filter(P.Event.map(this.a.onDidTriggerSystemContextMenu,({window:K,x:J,y:G})=>({windowId:K.id,x:J,y:G})),({windowId:K})=>!!this.a.getWindowById(K)),this.onDidMaximizeWindow=P.Event.filter(P.Event.fromNodeEventEmitter(R.app,"browser-window-maximize",(K,J)=>J.id),K=>!!this.a.getWindowById(K)),this.onDidUnmaximizeWindow=P.Event.filter(P.Event.fromNodeEventEmitter(R.app,"browser-window-unmaximize",(K,J)=>J.id),K=>!!this.a.getWindowById(K)),this.onDidBlurWindow=P.Event.filter(P.Event.fromNodeEventEmitter(R.app,"browser-window-blur",(K,J)=>J.id),K=>!!this.a.getWindowById(K)),this.onDidFocusWindow=P.Event.any(P.Event.map(P.Event.filter(P.Event.map(this.a.onDidChangeWindowsCount,()=>this.a.getLastActiveWindow()),K=>!!K),K=>K.id),P.Event.filter(P.Event.fromNodeEventEmitter(R.app,"browser-window-focus",(K,J)=>J.id),K=>!!this.a.getWindowById(K))),this.onDidResumeOS=P.Event.fromNodeEventEmitter(R.powerMonitor,"resume"),this.onDidChangeColorScheme=this.j.onDidChangeColorScheme,this.n=this.B(new P.$Nd),this.onDidChangePassword=this.n.event,this.onDidChangeDisplay=P.Event.debounce(P.Event.any(P.Event.filter(P.Event.fromNodeEventEmitter(R.screen,"display-metrics-changed",(K,J,G)=>G),K=>!(Array.isArray(K)&&K.length===1&&K[0]==="workArea")),P.Event.fromNodeEventEmitter(R.screen,"display-added"),P.Event.fromNodeEventEmitter(R.screen,"display-removed")),()=>{},100)}get windowId(){throw new Error("Not implemented in electron-main")}async getWindows(){return this.a.getWindows().map(U=>({id:U.id,workspace:U.openedWorkspace??(0,n.$3h)(U.backupPath,U.isExtensionDevelopmentHost),title:U.win?.getTitle()??"",filename:U.getRepresentedFilename(),dirty:U.isDocumentEdited()}))}async getWindowCount(j){return this.a.getWindowCount()}async getActiveWindowId(j){const U=R.BrowserWindow.getFocusedWindow()||this.a.getLastActiveWindow();if(U)return U.id}openWindow(j,U,z){return Array.isArray(U)?this.r(j,U,z):this.s(j,U)}async r(j,U,z=Object.create(null)){U.length>0&&await this.a.open({context:5,contextWindowId:j,urisToOpen:U,cli:this.f.args,forceNewWindow:z.forceNewWindow,forceReuseWindow:z.forceReuseWindow,preferNewWindow:z.preferNewWindow,diffMode:z.diffMode,mergeMode:z.mergeMode,addMode:z.addMode,gotoLineMode:z.gotoLineMode,noRecentEntry:z.noRecentEntry,waitMarkerFileURI:z.waitMarkerFileURI,remoteAuthority:z.remoteAuthority||void 0,forceProfile:z.forceProfile,forceTempProfile:z.forceTempProfile})}async s(j,U){await this.a.openEmptyWindow({context:5,contextWindowId:j},U)}async toggleFullScreen(j){this.C(j)?.toggleFullScreen()}async handleTitleDoubleClick(j){this.C(j)?.handleTitleDoubleClick()}async isMaximized(j){const U=this.C(j);return U?.win?U.win.isMaximized():!1}async maximizeWindow(j){const U=this.C(j);U?.win&&U.win.maximize()}async unmaximizeWindow(j){const U=this.C(j);U?.win&&U.win.unmaximize()}async minimizeWindow(j){const U=this.C(j);U?.win&&U.win.minimize()}async moveWindowTop(j){const U=this.C(j);U?.win&&U.win.moveTop()}async updateWindowControls(j,U){const z=this.C(j);z&&z.updateWindowControls(U)}async focusWindow(j,U){U&&typeof U.windowId=="number"&&(j=U.windowId),this.C(j)?.focus({force:U?.force??!1})}async setMinimumSize(j,U,z){const ne=this.C(j);if(ne?.win){const[_,ae]=ne.win.getSize(),[se,oe]=ne.win.getMinimumSize(),[K,J]=[U??se,z??oe],[G,N]=[Math.max(_,K),Math.max(ae,J)];(se!==K||oe!==J)&&ne.win.setMinimumSize(K,J),(_!==G||ae!==N)&&ne.win.setSize(G,N)}}async saveWindowSplash(j,U){this.j.saveWindowSplash(j,U)}async installShellCommand(j){const{source:U,target:z}=await this.t();try{const{symbolicLink:ne}=await b.SymlinkSupport.stat(U);if(ne&&!ne.dangling){const _=await(0,d.$5p)(U);if(z===_)return}await b.Promises.unlink(U)}catch(ne){if(ne.code!=="ENOENT")throw ne}try{await b.Promises.symlink(z,U)}catch(ne){if(ne.code!=="EACCES"&&ne.code!=="ENOENT")throw ne;const{response:_}=await this.showMessageBox(j,{type:"info",message:(0,m.localize)(0,null,this.h.nameShort),buttons:[(0,m.localize)(1,null),(0,m.localize)(2,null)]});if(_===0)try{const ae=`osascript -e "do shell script \\"mkdir -p /usr/local/bin && ln -sf '${z}' '${U}'\\" with administrator privileges"`;await(0,M.promisify)(S.exec)(ae)}catch{throw new Error((0,m.localize)(3,null,U))}}}async uninstallShellCommand(j){const{source:U}=await this.t();try{await b.Promises.unlink(U)}catch(z){switch(z.code){case"EACCES":{const{response:ne}=await this.showMessageBox(j,{type:"info",message:(0,m.localize)(4,null,this.h.nameShort),buttons:[(0,m.localize)(5,null),(0,m.localize)(6,null)]});if(ne===0)try{const _=`osascript -e "do shell script \\"rm '${U}'\\" with administrator privileges"`;await(0,M.promisify)(S.exec)(_)}catch{throw new Error((0,m.localize)(7,null,U))}break}case"ENOENT":break;default:throw z}}}async t(){const j=(0,g.$kc)(this.f.appRoot,"bin","code"),U=`/usr/local/bin/${this.h.applicationName}`;if(!await b.Promises.exists(j))throw new Error((0,m.localize)(8,null,j));return{source:U,target:j}}async showMessageBox(j,U){return this.b.showMessageBox(U,this.u(j))}async showSaveDialog(j,U){return this.b.showSaveDialog(U,this.u(j))}async showOpenDialog(j,U){return this.b.showOpenDialog(U,this.u(j))}u(j){const U=this.C(j);if(U?.win)return U.win}async pickFileFolderAndOpen(j,U){const z=await this.b.pickFileFolder(U);z&&await this.w(await Promise.all(z.map(async ne=>await b.SymlinkSupport.existsDirectory(ne)?{folderUri:y.URI.file(ne)}:{fileUri:y.URI.file(ne)})),U,j)}async pickFolderAndOpen(j,U){const z=await this.b.pickFolder(U);z&&await this.w(z.map(ne=>({folderUri:y.URI.file(ne)})),U,j)}async pickFileAndOpen(j,U){const z=await this.b.pickFile(U);z&&await this.w(z.map(ne=>({fileUri:y.URI.file(ne)})),U,j)}async pickWorkspaceAndOpen(j,U){const z=await this.b.pickWorkspace(U);z&&await this.w(z.map(ne=>({workspaceUri:y.URI.file(ne)})),U,j)}async w(j,U,z){await this.a.open({context:3,contextWindowId:z,cli:this.f.args,urisToOpen:j,forceNewWindow:U.forceNewWindow})}async showItemInFolder(j,U){R.shell.showItemInFolder(U)}async setRepresentedFilename(j,U){this.C(j)?.setRepresentedFilename(U)}async setDocumentEdited(j,U){this.C(j)?.setDocumentEdited(U)}async openExternal(j,U){return this.f.unsetSnapExportedVariables(),R.shell.openExternal(U),this.f.restoreSnapExportedVariables(),!0}moveItemToTrash(j,U){return R.shell.trashItem(U)}async isAdmin(){let j;return w.$j?j=(await new Promise((U,z)=>{Q(["native-is-elevated"],U,z)}))():j=process.getuid?.()===0,j}async writeElevated(j,U,z,ne){const _=await new Promise((ae,se)=>{Q(["@vscode/sudo-prompt"],ae,se)});return new Promise((ae,se)=>{const oe=[`"${this.z}"`];ne?.unlock&&oe.push("--file-chmod"),oe.push("--file-write",`"${U.fsPath}"`,`"${z.fsPath}"`);const K={name:this.h.nameLong.replace("-",""),icns:w.$k&&this.f.isBuilt?(0,g.$jc)((0,g.$mc)(this.f.appRoot),`${this.h.nameShort}.icns`):void 0};_.exec(oe.join(" "),K,(J,G,N)=>{G&&this.g.trace(`[sudo-prompt] received stdout: ${G}`),N&&this.g.trace(`[sudo-prompt] received stderr: ${N}`),J?se(J):ae(void 0)})})}async isRunningUnderARM64Translation(){return w.$l||w.$j?!1:R.app.runningUnderARM64Translation}get z(){return w.$j?this.f.isBuilt?(0,g.$jc)((0,g.$mc)(process.execPath),"bin",`${this.h.applicationName}.cmd`):(0,g.$jc)(this.f.appRoot,"scripts","code-cli.bat"):w.$l?this.f.isBuilt?(0,g.$jc)((0,g.$mc)(process.execPath),"bin",`${this.h.applicationName}`):(0,g.$jc)(this.f.appRoot,"scripts","code-cli.sh"):this.f.isBuilt?(0,g.$jc)(this.f.appRoot,"bin","code"):(0,g.$jc)(this.f.appRoot,"scripts","code-cli.sh")}async getOSStatistics(){return{totalmem:(0,s.totalmem)(),freemem:(0,s.freemem)(),loadavg:(0,s.loadavg)()}}async getOSProperties(){return{arch:(0,s.arch)(),platform:(0,s.platform)(),release:(0,s.release)(),type:(0,s.type)(),cpus:(0,s.cpus)()}}async getOSVirtualMachineHint(){return v.$Pm.value()}async getOSColorScheme(){return this.j.getColorScheme()}async hasWSLFeatureInstalled(){return w.$j&&(0,A.$O6b)()}async killProcess(j,U,z){process.kill(U,z)}async readClipboardText(j,U){return R.clipboard.readText(U)}async writeClipboardText(j,U,z){return R.clipboard.writeText(U,z)}async readClipboardFindText(j){return R.clipboard.readFindText()}async writeClipboardFindText(j,U){return R.clipboard.writeFindText(U)}async writeClipboardBuffer(j,U,z,ne){return R.clipboard.writeBuffer(U,Buffer.from(z.buffer),ne)}async readClipboardBuffer(j,U){return p.$be.wrap(R.clipboard.readBuffer(U))}async hasClipboard(j,U,z){return R.clipboard.has(U,z)}async newWindowTab(){await this.a.open({context:5,cli:this.f.args,forceNewTabbedWindow:!0,forceEmpty:!0,remoteAuthority:this.f.args.remote||void 0})}async showPreviousWindowTab(){R.Menu.sendActionToFirstResponder("selectPreviousTab:")}async showNextWindowTab(){R.Menu.sendActionToFirstResponder("selectNextTab:")}async moveWindowTabToNewWindow(){R.Menu.sendActionToFirstResponder("moveTabToNewWindow:")}async mergeAllWindowTabs(){R.Menu.sendActionToFirstResponder("mergeAllWindows:")}async toggleWindowTabsBar(){R.Menu.sendActionToFirstResponder("toggleTabBar:")}async updateTouchBar(j,U){this.C(j)?.updateTouchBar(U)}async notifyReady(j){this.C(j)?.setReady()}async relaunch(j,U){return this.c.relaunch(U)}async reload(j,U){const z=this.C(j);if(z){if((0,n.$4h)(z.openedWorkspace)){const ne=z.openedWorkspace.configPath;if(ne.scheme===a.Schemas.file&&(await this.m.resolveLocalWorkspace(ne))?.transient)return this.openWindow(z.id,{forceReuseWindow:!0})}return this.c.reload(z,U?.disableExtensions!==void 0?{_:[],"disable-extensions":U.disableExtensions}:void 0)}}async closeWindow(j){this.closeWindowById(j,j)}async closeWindowById(j,U){const z=this.C(U);if(z?.win)return z.win.close()}async quit(j){const U=this.a.getLastActiveWindow();U?.isExtensionDevelopmentHost&&this.a.getWindowCount()>1&&U.win?U.win.close():this.c.quit()}async exit(j,U){await this.c.kill(U)}async resolveProxy(j,U){return this.C(j)?.win?.webContents?.session?.resolveProxy(U)}findFreePort(j,U,z,ne,_=1){return(0,$.$gg)(U,z,ne,_)}async openDevTools(j,U){const z=this.C(j);z?.win&&z.win.webContents.openDevTools(U)}async toggleDevTools(j){const U=this.C(j);U?.win&&U.win.webContents.toggleDevTools();for(const z of R.BrowserWindow.getAllWindows())z.webContents.getURL()==="about:blank"&&z.webContents.toggleDevTools()}async sendInputEvent(j,U){const z=this.C(j);z?.win&&(U.type==="mouseDown"||U.type==="mouseUp")&&z.win.webContents.sendInputEvent(U)}async profileRenderer(j,U,z){const ne=this.C(j);if(!ne||!ne.win)throw new Error;return await new C.$P6b(ne.win,U,this.g).inspect(z)}async windowsGetStringRegKey(j,U,z,ne){if(!w.$j)return;const _=await new Promise((ae,se)=>{Q(["@vscode/windows-registry"],ae,se)});try{return _.GetStringRegKey(U,z,ne)}catch{return}}C(j){if(typeof j=="number")return this.a.getWindowById(j)}};e.$R6b=k,ke([D.$gh],k.prototype,"z",null),e.$R6b=k=ke([ee(0,t.$f6b),ee(1,u.$s6b),ee(2,h.$45b),ee(3,l.$25b),ee(4,i.$9i),ee(5,c.$oj),ee(6,o.$d6b),ee(7,r.$x6b)],k)}),define(te[298],ie([0,1,15,38,28,2,13,4,107,178,90,131,59,25,5,69,78,24,79,68,33,34,60,22,7,30,8]),function(Q,e,S,R,s,M,D,P,f,a,g,w,y,d,v,b,$,m,u,l,E,h,i,c,o,t,n){"use strict";var r;Object.defineProperty(e,"__esModule",{value:!0}),e.$T6b=void 0;const p="issue.processExplorerWindowState";let A=class{static{r=this}static{this.a="#1E1E1E"}constructor(I,j,U,z,ne,_,ae,se,oe,K,J){this.g=I,this.h=j,this.i=U,this.j=z,this.k=ne,this.l=_,this.m=ae,this.n=se,this.o=oe,this.p=K,this.q=J,this.b=null,this.c=null,this.d=null,this.f=null,this.r()}r(){R.$eT.on("vscode:listProcesses",async I=>{const j=[];try{j.push({name:(0,a.localize)(0,null),rootProcess:await(0,f.$Ar)(process.pid)}),(await this.k.getRemoteDiagnostics({includeProcesses:!0})).forEach(z=>{(0,g.$pm)(z)?j.push({name:z.hostName,rootProcess:z}):z.processes&&j.push({name:z.hostName,rootProcess:z.processes})})}catch(U){this.i.error(`Listing processes failed: ${U}`)}this.t(I,"vscode:listProcessesResponse",j)}),R.$eT.on("vscode:workbenchCommand",(I,j)=>{const{id:U,from:z,args:ne}=j;let _;switch(z){case"processExplorer":_=this.f;break;default:throw new Error(`Unexpected command source: ${z}`)}_?.webContents.send("vscode:runAction",{id:U,from:z,args:ne})}),R.$eT.on("vscode:closeProcessExplorer",I=>{this.d?.close()}),R.$eT.on("vscode:pidToNameRequest",async I=>{const j=await this.k.getMainDiagnostics(),U=[];for(const z of j.windows)U.push([z.pid,`window [${z.id}] (${z.title})`]);for(const{pid:z,name:ne}of i.$z6b.getAll())U.push([z,ne]);this.t(I,"vscode:pidToNameResponse",U)})}async openReporter(I){if(!this.b&&(this.c=S.BrowserWindow.getFocusedWindow(),this.c)){const j=new M.$Rc,U=j.add(this.n.createIPCObjectUrl()),z=this.v(this.c,700,800);this.b=this.u(z,U,{backgroundColor:I.styles.backgroundColor,title:(0,a.localize)(1,null),zoomLevel:I.zoomLevel,alwaysOnTop:!1},"issue-reporter"),U.update({appRoot:this.h.appRoot,windowId:this.b.id,userEnv:this.g,data:I,disableExtensions:!!this.h.disableExtensions,os:{type:(0,s.type)(),arch:(0,s.arch)(),release:(0,s.release)()},product:$.default}),this.b.loadURL(D.$cg.asBrowserUri(`vs/code/electron-sandbox/issue/issueReporter${this.h.isBuilt?"":"-dev"}.html`).toString(!0)),this.b.on("close",()=>{this.b=null,j.dispose()}),this.c.on("closed",()=>{this.b&&(this.b.close(),this.b=null,j.dispose())})}this.b&&this.s(this.b)}async openProcessExplorer(I){if(!this.d&&(this.f=S.BrowserWindow.getFocusedWindow(),this.f)){const j=new M.$Rc,U=j.add(this.n.createIPCObjectUrl()),z=this.p.getItem(p,void 0),ne=C(z)?z:this.v(this.f,800,500);this.d=this.u(ne,U,{backgroundColor:I.styles.backgroundColor,title:(0,a.localize)(2,null),zoomLevel:I.zoomLevel,alwaysOnTop:!0},"process-explorer"),U.update({appRoot:this.h.appRoot,windowId:this.d.id,userEnv:this.g,data:I,product:$.default}),this.d.loadURL(D.$cg.asBrowserUri(`vs/code/electron-sandbox/processExplorer/processExplorer${this.h.isBuilt?"":"-dev"}.html`).toString(!0)),this.d.on("close",()=>{this.d=null,j.dispose()}),this.f.on("close",()=>{this.d&&(this.d.close(),this.d=null,j.dispose())});const _=()=>{if(!this.d)return;const ae=this.d.getSize(),se=this.d.getPosition();if(!ae||!se)return;const oe={width:ae[0],height:ae[1],x:se[0],y:se[1]};this.p.setItem(p,oe)};this.d.on("moved",_),this.d.on("resized",_)}this.d&&this.s(this.d)}async stopTracing(){if(!this.h.args.trace)return;const I=await S.contentTracing.stopRecording(`${(0,E.$6f)(this.h.userHome.fsPath,this.o.applicationName)}.trace.txt`);await this.l.showMessageBox({type:"info",message:(0,a.localize)(3,null),detail:(0,a.localize)(4,null,I),buttons:[(0,a.localize)(5,null)]},S.BrowserWindow.getFocusedWindow()??void 0),this.m.showItemInFolder(void 0,I)}async getSystemStatus(){const[I,j]=await Promise.all([this.k.getMainDiagnostics(),this.k.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]);return this.j.getDiagnostics(I,j)}async $getSystemInfo(){const[I,j]=await Promise.all([this.k.getMainDiagnostics(),this.k.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]);return await this.j.getSystemInfo(I,j)}async $getPerformanceInfo(){try{const[I,j]=await Promise.all([this.k.getMainDiagnostics(),this.k.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0})]);return await this.j.getPerformanceInfo(I,j)}catch(I){throw this.i.warn("issueService#getPerformanceInfo ",I.message),I}}async $reloadWithExtensionsDisabled(){if(this.c)try{await this.m.reload(this.c.id,{disableExtensions:!0})}catch(I){this.i.error(I)}}async $showConfirmCloseDialog(){if(this.b){const{response:I}=await this.l.showMessageBox({type:"warning",message:(0,a.localize)(6,null),buttons:[(0,a.localize)(7,null),(0,a.localize)(8,null)]},this.b);I===0&&this.b&&(this.b.destroy(),this.b=null)}}async $showClipboardDialog(){if(this.b){const{response:I}=await this.l.showMessageBox({type:"warning",message:(0,a.localize)(9,null),buttons:[(0,a.localize)(10,null),(0,a.localize)(11,null)]},this.b);return I===0}return!1}async $getIssueReporterUri(I){if(!this.c)throw new Error("Issue reporter window not available");const j=this.q.getWindowById(this.c.id);if(!j)throw new Error("Window not found");const U=`vscode:triggerIssueUriRequestHandlerResponse${j.id}`;return n.Promises.withAsyncBody(async(z,ne)=>{const _=new c.$Xd;j.sendWhenReady("vscode:triggerIssueUriRequestHandler",_.token,{replyChannel:U,extensionId:I}),R.$eT.once(U,(ae,se)=>{z(o.URI.parse(se))});try{await(0,n.$Ug)(5e3),_.cancel(),ne(new Error("Timed out waiting for issue reporter URI"))}finally{R.$eT.removeHandler(U)}})}async $closeReporter(){this.b?.close()}async closeProcessExplorer(){this.d?.close()}s(I){I.isMinimized()&&I.restore(),I.focus()}t(I,j,...U){I.sender.isDestroyed()||I.sender.send(j,...U)}u(I,j,U,z){const ne=new S.BrowserWindow({fullscreen:!1,skipTaskbar:!1,resizable:!0,width:I.width,height:I.height,minWidth:300,minHeight:200,x:I.x,y:I.y,title:U.title,backgroundColor:U.backgroundColor||r.a,webPreferences:{preload:D.$cg.asFileUri("vs/base/parts/sandbox/electron-sandbox/preload.js").fsPath,additionalArguments:[`--vscode-window-config=${j.resource.toString()}`],v8CacheOptions:this.h.useCodeCache?"bypassHeatCheck":"none",enableWebSQL:!1,spellcheck:!1,zoomFactor:(0,l.$5C)(U.zoomLevel),sandbox:!0},alwaysOnTop:U.alwaysOnTop,experimentalDarkMode:!0});return ne.setMenuBarVisibility(!1),ne}v(I,j,U){let z;const ne=S.screen.getAllDisplays();if(ne.length===1)z=ne[0];else{if(P.$k){const se=S.screen.getCursorScreenPoint();z=S.screen.getDisplayNearestPoint(se)}!z&&I&&(z=S.screen.getDisplayMatching(I.getBounds())),z||(z=S.screen.getPrimaryDisplay()||ne[0])}const _=z.bounds,ae={width:j,height:U,x:_.x+_.width/2-j/2,y:_.y+_.height/2-U/2};return _.width>0&&_.height>0&&(ae.x<_.x&&(ae.x=_.x),ae.y<_.y&&(ae.y=_.y),ae.x>_.x+_.width&&(ae.x=_.x),ae.y>_.y+_.height&&(ae.y=_.y),ae.width>_.width&&(ae.width=_.width),ae.height>_.height&&(ae.height=_.height)),ae}};e.$T6b=A,e.$T6b=A=r=ke([ee(1,d.$25b),ee(2,v.$9i),ee(3,g.$om),ee(4,w.$C6b),ee(5,y.$s6b),ee(6,b.$Q6b),ee(7,u.$S6b),ee(8,m.$oj),ee(9,h.$rN),ee(10,t.$f6b)],A);function C(k){return typeof k!="object"||k===null?!1:"x"in k&&"y"in k&&"width"in k&&"height"in k}}),define(te[299],ie([0,1,22,18,25,20,5,69,24,50,26,48,100]),function(Q,e,S,R,s,M,D,P,f,a,g,w,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$k7b=void 0;let d=class extends y.$i7b{constructor(b,$,m,u,l,E,h,i){super(b,$,u,l,E,i),this.e=m,this.u=h}s(b){return(0,y.$h7b)(`linux-${process.arch}`,b,this.k)}t(b){this.a&&(this.d(w.$dU.CheckingForUpdates(b)),this.i.request({url:this.a},S.CancellationToken.None).then(a.$Wo).then($=>{!$||!$.url||!$.version||!$.productVersion?(this.e.publicLog2("update:notAvailable",{explicit:!!b}),this.d(w.$dU.Idle(1))):this.d(w.$dU.AvailableForDownload($))}).then(void 0,$=>{this.j.error($),this.e.publicLog2("update:notAvailable",{explicit:!!b});const m=b?$.message||$:void 0;this.d(w.$dU.Idle(1,m))}))}async o(b){this.k.downloadUrl&&this.k.downloadUrl.length>0?this.u.openExternal(void 0,this.k.downloadUrl):b.update.url&&this.u.openExternal(void 0,b.update.url),this.d(w.$dU.Idle(1))}};e.$k7b=d,e.$k7b=d=ke([ee(0,M.$45b),ee(1,R.$ii),ee(2,g.$bl),ee(3,s.$25b),ee(4,a.$Qo),ee(5,D.$9i),ee(6,P.$Q6b),ee(7,f.$oj)],d)}),define(te[300],ie([0,1,47,45,28,8,22,54,9,7,142,21,18,25,16,20,5,69,24,50,26,48,100]),function(Q,e,S,R,s,M,D,P,f,a,g,w,y,d,v,b,$,m,u,l,E,h,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$m7b=void 0;async function c(r,p=1e3){for(;!r();)await(0,M.$Ug)(p)}let o;function t(){return typeof o>"u"&&(o=R.existsSync(f.$jc(f.$mc(process.execPath),"unins000.exe"))?0:1),o}let n=class extends i.$i7b{get cachePath(){const p=f.$jc((0,s.tmpdir)(),`vscode-${this.k.quality}-${this.k.target}-${process.arch}`);return w.Promises.mkdir(p,{recursive:!0}).then(()=>p)}constructor(p,A,C,k,I,j,U,z,ne){super(p,A,k,I,j,ne),this.u=C,this.v=U,this.w=z,p.setRelaunchHandler(this)}handleRelaunch(p){return p?.addArgs||p?.removeArgs||this.state.type!=="ready"||!this.e?!1:(this.j.trace("update#handleRelaunch(): running raw#quitAndInstall()"),this.r(),!0)}async l(){if(this.k.target==="user"&&await this.w.isAdmin(void 0)){this.d(h.$dU.Disabled(5)),this.j.info("update#ctor - updates are disabled due to running as Admin in user setup");return}await super.l()}s(p){let A="win32";return process.arch!=="ia32"&&(A+=`-${process.arch}`),t()===1?A+="-archive":this.k.target==="user"&&(A+="-user"),(0,i.$h7b)(A,p,this.k)}t(p){this.a&&(this.d(h.$dU.CheckingForUpdates(p)),this.i.request({url:this.a},D.CancellationToken.None).then(l.$Wo).then(A=>{const C=t();return!A||!A.url||!A.version||!A.productVersion?(this.u.publicLog2("update:notAvailable",{explicit:!!p}),this.d(h.$dU.Idle(C)),Promise.resolve(null)):C===1?(this.d(h.$dU.AvailableForDownload(A)),Promise.resolve(null)):(this.d(h.$dU.Downloading(A)),this.C(A.version).then(()=>this.B(A.version).then(k=>w.Promises.exists(k).then(I=>{if(I)return Promise.resolve(k);const j=A.url,U=A.hash,z=`${k}.tmp`;return this.i.request({url:j},D.CancellationToken.None).then(ne=>this.v.writeFile(a.URI.file(z),ne.stream)).then(U?()=>(0,g.$_S)(z,A.hash):()=>{}).then(()=>w.Promises.rename(z,k,!1)).then(()=>k)})).then(k=>{const I=this.g.getValue("update.enableWindowsBackgroundUpdates");this.e={packagePath:k},I?this.k.target==="user"?this.p():this.d(h.$dU.Downloaded(A)):this.d(h.$dU.Ready(A))})))}).then(void 0,A=>{this.j.error(A),this.u.publicLog2("update:notAvailable",{explicit:!!p});const C=p?A.message||A:void 0;this.d(h.$dU.Idle(t(),C))}))}async o(p){p.update.url&&this.w.openExternal(void 0,p.update.url),this.d(h.$dU.Idle(t()))}async B(p){const A=await this.cachePath;return f.$jc(A,`CodeSetup-${this.k.quality}-${p}.exe`)}async C(p=null){const A=p?j=>!new RegExp(`${this.k.quality}-${p}\\.exe$`).test(j):()=>!0,C=await this.cachePath,I=(await w.Promises.readdir(C)).filter(A).map(async j=>{try{await w.Promises.unlink(f.$jc(C,j))}catch{}});await Promise.all(I)}async p(){if(this.state.type!=="downloaded"&&this.state.type!=="downloading"||!this.e)return Promise.resolve(void 0);const p=this.state.update;this.d(h.$dU.Updating(p));const A=await this.cachePath;this.e.updateFilePath=f.$jc(A,`CodeSetup-${this.k.quality}-${p.version}.flag`),await w.Promises.writeFile(this.e.updateFilePath,"flag"),(0,S.spawn)(this.e.packagePath,["/verysilent","/log",`/update="${this.e.updateFilePath}"`,"/nocloseapplications","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"],windowsVerbatimArguments:!0}).once("exit",()=>{this.e=void 0,this.d(h.$dU.Idle(t()))});const k=`${this.k.win32MutexName}-ready`,I=await new Promise((j,U)=>{Q(["@vscode/windows-mutex"],j,U)});c(()=>I.isActive(k)).then(()=>this.d(h.$dU.Ready(p)))}r(){this.state.type!=="ready"||!this.e||(this.j.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.e.updateFilePath?R.unlinkSync(this.e.updateFilePath):(0,S.spawn)(this.e.packagePath,["/silent","/log","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"]}))}q(){return t()}async _applySpecificUpdate(p){if(this.state.type!=="idle")return;const A=this.g.getValue("update.enableWindowsBackgroundUpdates"),C={version:"unknown",productVersion:"unknown"};this.d(h.$dU.Downloading(C)),this.e={packagePath:p},A?this.k.target==="user"?this.p():this.d(h.$dU.Downloaded(C)):this.d(h.$dU.Ready(C))}};e.$m7b=n,ke([P.$gh],n.prototype,"cachePath",null),e.$m7b=n=ke([ee(0,b.$45b),ee(1,y.$ii),ee(2,E.$bl),ee(3,d.$25b),ee(4,l.$Qo),ee(5,$.$9i),ee(6,v.$0j),ee(7,m.$Q6b),ee(8,u.$oj)],n)}),define(te[301],ie([0,1,15,8,22,49,3,2,13,65,4,7,188,63,18,59,25,62,16,20,5,24,79,250,81,26,102,67,68,30,29,53,95,134,39,34,52,66,23,6]),function(Q,e,S,R,s,M,D,P,f,a,g,w,y,d,v,b,$,m,u,l,E,h,i,c,o,t,n,r,p,A,C,k,I,j,U,z,ne,_,ae,se){"use strict";var oe;Object.defineProperty(e,"__esModule",{value:!0}),e.$u7b=void 0;var K;(function(G){G[G.NONE=0]="NONE",G[G.NAVIGATING=1]="NAVIGATING",G[G.READY=2]="READY"})(K||(K={}));let J=class extends P.$Sc{static{oe=this}static{this.a="windowControlHeight"}get id(){return this.j}get win(){return this.m}get lastFocusTime(){return this.n}get backupPath(){return this.r?.backupPath}get openedWorkspace(){return this.r?.workspace}get profile(){if(!this.config)return;const N=this.R.profiles.find(q=>q.id===this.config?.profiles.profile.id);return this.isExtensionDevelopmentHost&&N?N:this.R.getProfileForWorkspace(this.config.workspace??(0,C.$3h)(this.backupPath,this.isExtensionDevelopmentHost))??this.R.defaultProfile}get remoteAuthority(){return this.r?.remoteAuthority}get config(){return this.r}get isExtensionDevelopmentHost(){return!!this.r?.extensionDevelopmentPath}get isExtensionTestHost(){return!!this.r?.extensionTestsPath}get isExtensionDevelopmentTestFromCli(){return this.isExtensionDevelopmentHost&&this.isExtensionTestHost&&!this.r?.debugId}constructor(N,q,X,H,Y,re,F,O,L,B,T,W,V,ce,de,ue,fe,ye,be,pe,Ae){super(),this.N=q,this.O=X,this.P=H,this.Q=Y,this.R=re,this.S=F,this.U=O,this.W=L,this.X=B,this.Y=T,this.Z=W,this.$=V,this.ab=ce,this.bb=de,this.db=ue,this.eb=fe,this.fb=ye,this.gb=be,this.hb=pe,this.b=this.B(new D.$Nd),this.onWillLoad=this.b.event,this.c=this.B(new D.$Nd),this.onDidSignalReady=this.c.event,this.f=this.B(new D.$Nd),this.onDidTriggerSystemContextMenu=this.f.event,this.g=this.B(new D.$Nd),this.onDidClose=this.g.event,this.h=this.B(new D.$Nd),this.onDidDestroy=this.h.event,this.n=-1,this.u=void 0,this.w=void 0,this.D=!1,this.F=[],this.G=[],this.H=void 0,this.I=void 0,this.J=this.B(this.fb.createIPCObjectUrl()),this.M=!1,this.jb=0;{const[Te,me]=this.tb(N.state);this.s=Te,this.N.trace("window#ctor: using window state",Te);const we=this.s.mode===0||this.s.mode===3,Z=this.X.getValue("window"),le=Ae.invokeFunction(A.$g6b,this.s,{show:!we,webPreferences:{preload:f.$cg.asFileUri("vs/base/parts/sandbox/electron-sandbox/preload.js").fsPath,additionalArguments:[`--vscode-window-config=${this.J.resource.toString()}`],v8CacheOptions:this.P.useCodeCache?"bypassHeatCheck":"none"}});g.$k&&!this.Ab()&&(le.fullscreenable=!1);const ge=g.$k&&Z?.nativeTabs===!0;ge&&(le.tabbingIdentifier=this.eb.nameShort);const Ce=(0,p.$3C)(this.X)==="custom";if(Ce&&(le.titleBarStyle="hidden",g.$k||(le.frame=!1),(0,p.$4C)(this.X))){const De=this.Y.getWindowSplash()?.colorInfo.titleBarBackground??this.Y.getBackgroundColor(),Ue=j.$Us.fromHex(De).isDarker()?"#FFFFFF":"#000000";le.titleBarOverlay={height:29,color:De,symbolColor:Ue},this.D=!0}if((0,a.mark)("code/willCreateCodeBrowserWindow"),this.m=new S.BrowserWindow(le),(0,a.mark)("code/didCreateCodeBrowserWindow"),this.j=this.m.id,g.$k&&Ce&&this.m.setSheetOffset(22),Ce&&(g.$j&&(0,p.$4C)(this.X)||g.$k)){const De=this.hb.getItem(oe.a);De&&this.updateWindowControls({height:De})}g.$j&&Ce&&this.m.hookWindowMessage(278,()=>{const[Ue,Oe]=this.m.getPosition(),ze=S.screen.getCursorScreenPoint(),We=ze.x-Ue,x=ze.y-Oe;return(()=>!(We>30&&x>=0&&x<=Math.max(this.m.getBounds().height*.15,35)))()||(this.m.setEnabled(!1),this.m.setEnabled(!0),this.f.fire({x:We,y:x})),0}),(g.$k||g.$j)&&me&&(!ge||S.BrowserWindow.getAllWindows().length===1)&&[this.s.width,this.s.height,this.s.x,this.s.y].every(De=>typeof De=="number")&&this.m.setBounds({width:this.s.width,height:this.s.height,x:this.s.x,y:this.s.y}),we&&((0,a.mark)("code/willMaximizeCodeWindow"),this.m.maximize(),this.s.mode===3?(this.ib("WindowMode.Fullscreen"),this.wb(!0)):this.ib("WindowMode.Maximized"),this.m.show(),(0,a.mark)("code/didMaximizeCodeWindow")),this.n=Date.now()}this.P.args["open-devtools"]===!0&&this.m.webContents.openDevTools(),this.qb(),this.Eb(),this.kb()}ib(N){this.X.getValue("window.logFullScreenTransitions")&&this.N.info(`window-fullscreen-bug: ${N})`)}setRepresentedFilename(N){g.$k?this.m.setRepresentedFilename(N):this.z=N}getRepresentedFilename(){return g.$k?this.m.getRepresentedFilename():this.z}setDocumentEdited(N){g.$k&&this.m.setDocumentEdited(N),this.C=N}isDocumentEdited(){return g.$k?this.m.isDocumentEdited():!!this.C}focus(N){g.$k&&N?.force&&S.app.focus({steal:!0}),this.m&&(this.m.isMinimized()&&this.m.restore(),this.m.focus())}setReady(){for(this.N.trace(`window#load: window reported ready (id: ${this.j})`),this.jb=2;this.F.length;)this.F.pop()(this);this.c.fire()}ready(){return new Promise(N=>{if(this.isReady)return N(this);this.F.push(N)})}get isReady(){return this.jb===2}get whenClosedOrLoaded(){return new Promise(N=>{function q(){X.dispose(),H.dispose(),N()}const X=this.onDidClose(()=>q()),H=this.onWillLoad(()=>q())})}kb(){this.m.on("unresponsive",()=>this.nb(1)),this.m.webContents.on("render-process-gone",(q,X)=>this.nb(2,{...X})),this.m.webContents.on("did-fail-load",(q,X,H)=>this.nb(3,{reason:H,exitCode:X})),this.m.webContents.on("will-prevent-unload",q=>{q.preventDefault()}),this.m.on("closed",()=>{this.g.fire(),this.dispose()}),this.m.webContents.on("did-finish-load",()=>{this.L&&(this.r=this.L,this.L=void 0)}),this.m.on("focus",()=>{this.n=Date.now()}),this.m.on("maximize",q=>{this.r&&(this.r.maximized=!0),S.app.emit("browser-window-maximize",q,this.m)}),this.m.on("unmaximize",q=>{this.r&&(this.r.maximized=!1),S.app.emit("browser-window-unmaximize",q,this.m)}),this.m.on("enter-full-screen",()=>{this.sendWhenReady("vscode:enterFullScreen",s.CancellationToken.None),this.ib(`enter-full-screen: ${Date.now()}`),this.w?.complete(),this.w=void 0}),this.m.on("leave-full-screen",()=>{this.sendWhenReady("vscode:leaveFullScreen",s.CancellationToken.None),this.ib(`leave-full-screen: ${Date.now()}`),this.w?.complete(),this.w=void 0}),this.B(this.X.onDidChangeConfiguration(q=>this.qb(q))),this.B(this.Z.onDidDeleteUntitledWorkspace(q=>this.pb(q)));const N=["https://marketplace.visualstudio.com/*","https://*.vsassets.io/*"];this.m.webContents.session.webRequest.onBeforeSendHeaders({urls:N},async(q,X)=>{const H=await this.mb();X({cancel:!1,requestHeaders:Object.assign(q.requestHeaders,H)})})}mb(){return this.lb||(this.lb=(0,c.$$o)(this.eb.version,this.eb,this.P,this.X,this.S,this.U,this.ab)),this.lb}async nb(N,q){switch(N){case 2:this.N.error(`CodeWindow: renderer process gone (reason: ${q?.reason||"<unknown>"}, code: ${q?.exitCode||"<unknown>"})`);break;case 1:this.N.error("CodeWindow: detected unresponsive");break;case 3:this.N.error(`CodeWindow: failed to load (reason: ${q?.reason||"<unknown>"}, code: ${q?.exitCode||"<unknown>"})`);break}switch(this.ab.publicLog2("windowerror",{type:N,reason:q?.reason,code:q?.exitCode}),N){case 1:case 2:if(this.isExtensionDevelopmentTestFromCli){this.db.kill(1);return}if(this.P.args["enable-smoke-test-driver"]){await this.ob(!1,!1),this.db.quit();return}if(N===1){if(this.isExtensionDevelopmentHost||this.isExtensionTestHost||this.m&&this.m.webContents&&this.m.webContents.isDevToolsOpened())return;const{response:X,checkboxChecked:H}=await this.bb.showMessageBox({type:"warning",buttons:[(0,y.localize)(0,null),(0,y.localize)(1,null),(0,y.localize)(2,null)],message:(0,y.localize)(3,null),detail:(0,y.localize)(4,null),checkboxLabel:this.r?.workspace?(0,y.localize)(5,null):void 0},this.m);if(X!==2){const Y=X===0;await this.ob(Y,H)}}else if(N===2){let X;q?X=(0,y.localize)(7,null,q.reason,q.exitCode??"<unknown>"):X=(0,y.localize)(6,null);const{response:H,checkboxChecked:Y}=await this.bb.showMessageBox({type:"warning",buttons:[this.r?.workspace?(0,y.localize)(8,null):(0,y.localize)(9,null),(0,y.localize)(10,null)],message:X,detail:this.r?.workspace?(0,y.localize)(11,null):(0,y.localize)(12,null),checkboxLabel:this.r?.workspace?(0,y.localize)(13,null):void 0},this.m),re=H===0;await this.ob(re,Y)}break}}async ob(N,q){const X=this.r?.workspace;if(q&&X)try{const H=this.W.workspaceStorage(X);await H.init(),H.delete("memento/workbench.parts.editor"),await H.close()}catch(H){this.N.error(H)}if(this.h.fire(),this.m?.destroy(),N&&this.r){let H,Y;(0,C.$Yh)(X)?H={folderUri:X.uri}:(0,C.$4h)(X)?H={workspaceUri:X.configPath}:Y=!0,(0,ae.$Ob)(await this.gb.open({context:5,userEnv:this.r.userEnv,cli:{...this.P.args,_:[]},urisToOpen:H?[H]:void 0,forceEmpty:Y,forceNewWindow:!0,remoteAuthority:this.remoteAuthority}))?.focus()}}pb(N){this.r?.workspace?.id===N.id&&(this.r.workspace=void 0)}qb(N){if(!N||N.affectsConfiguration("window.menuBarVisibility")){const q=this.Bb();q!==this.t&&(this.t=q,this.Cb(q))}if(!N||N.affectsConfiguration("http.proxy")){let q=(this.X.getValue("http.proxy")||"").trim()||(process.env.https_proxy||process.env.HTTPS_PROXY||process.env.http_proxy||process.env.HTTP_PROXY||"").trim()||void 0;q?.endsWith("/")&&(q=q.substr(0,q.length-1));const X=(process.env.no_proxy||process.env.NO_PROXY||"").trim()||void 0;if((q||"").indexOf("@")===-1&&(q!==this.H||X!==this.I)){this.H=q,this.I=X;const H=q||"",Y=X?`${X},<local>`:"<local>";this.N.trace(`Setting proxy to '${H}', bypassing '${Y}'`),this.m.webContents.session.setProxy({proxyRules:H,proxyBypassRules:Y,pacScript:""})}}}addTabbedWindow(N){g.$k&&N.win&&this.m.addTabbedWindow(N.win)}load(N,q=Object.create(null)){this.N.trace(`window#load: attempt to load window (id: ${this.j})`),this.isDocumentEdited()&&(!q.isReload||!this.$.isHotExitEnabled())&&this.setDocumentEdited(!1),q.isReload||(this.getRepresentedFilename()&&this.setRepresentedFilename(""),this.m.setTitle(this.eb.nameLong)),this.rb(N,q),this.jb===0?this.r=N:this.L=N,this.jb=1,this.m.loadURL(f.$cg.asBrowserUri(`vs/code/electron-sandbox/workbench/workbench${this.P.isBuilt?"":"-dev"}.html`).toString(!0));const X=this.M;this.M=!0,!this.P.isBuilt&&!this.P.extensionTestsLocationURI&&this.B(new R.$6g(()=>{this.m&&!this.m.isVisible()&&!this.m.isMinimized()&&(this.m.show(),this.focus({force:!0}),this.m.webContents.openDevTools())},1e4)).schedule(),this.b.fire({workspace:N.workspace,reason:q.isReload?3:X?2:1})}rb(N,q){const X=(this.r??this.L)?.userEnv;if(X){const H=(0,m.$Ll)(X)&&!(0,m.$Ll)(N.userEnv),Y=this.isExtensionDevelopmentHost;(H||Y)&&(N.userEnv={...X,...N.userEnv})}process.env.CHROME_CRASHPAD_PIPE_NAME&&Object.assign(N.userEnv,{CHROME_CRASHPAD_PIPE_NAME:process.env.CHROME_CRASHPAD_PIPE_NAME}),q.disableExtensions!==void 0&&(N["disable-extensions"]=q.disableExtensions),N.fullscreen=this.isFullScreen,N.maximized=this.m.isMaximized(),N.partsSplash=this.Y.getWindowSplash(),(0,a.mark)("code/willOpenNewWindow"),N.perfMarks=(0,a.getMarks)(),this.J.update(N)}async reload(N){const q=Object.assign({},this.r);q.workspace=await this.sb(q),delete q.filesToOpenOrCreate,delete q.filesToDiff,delete q.filesToMerge,delete q.filesToWait,this.isExtensionDevelopmentHost&&N&&(q.verbose=N.verbose,q.debugId=N.debugId,q.extensionEnvironment=N.extensionEnvironment,q["inspect-extensions"]=N["inspect-extensions"],q["inspect-brk-extensions"]=N["inspect-brk-extensions"],q["extensions-dir"]=N["extensions-dir"]),q.accessibilitySupport=S.app.isAccessibilitySupportEnabled(),q.isInitialStartup=!1,q.policiesData=this.Q.serialize(),q.continueOn=this.P.continueOn,q.profiles={all:this.R.profiles,profile:this.profile||this.R.defaultProfile,home:this.R.profilesHome},q.logLevel=this.O.getLogLevel(),q.loggers={window:this.O.getRegisteredLoggers(this.id),global:this.O.getRegisteredLoggers()},this.load(q,{isReload:!0,disableExtensions:N?.["disable-extensions"]})}async sb(N){if((0,C.$4h)(N.workspace)){const q=N.workspace.configPath;if(q.scheme===f.Schemas.file&&!await this.S.exists(q))return}else if((0,C.$Yh)(N.workspace)){const q=N.workspace.uri;if(q.scheme===f.Schemas.file&&!await this.S.exists(q))return}return N.workspace}serializeWindowState(){if(!this.m)return(0,I.$15b)();if(this.isFullScreen){let X;try{X=S.screen.getDisplayMatching(this.getBounds())}catch{}const H=(0,I.$15b)();return{mode:3,display:X?X.id:void 0,width:this.s.width||H.width,height:this.s.height||H.height,x:this.s.x||0,y:this.s.y||0}}const N=Object.create(null);let q;if(!g.$k&&this.m.isMaximized()?q=0:q=1,q===0?N.mode=0:N.mode=1,q===1||q===0){let X;q===1?X=this.getBounds():X=this.m.getNormalBounds(),N.x=X.x,N.y=X.y,N.width=X.width,N.height=X.height}return N}updateWindowControls(N){if(N.height&&this.hb.setItem(oe.a,N.height),g.$j&&this.D)this.m.setTitleBarOverlay({color:N.backgroundColor?.trim()===""?void 0:N.backgroundColor,symbolColor:N.foregroundColor?.trim()===""?void 0:N.foregroundColor,height:N.height?N.height-1:void 0});else if(g.$k&&N.height!==void 0){const q=(N.height-15)/2;q?this.m.setWindowButtonPosition({x:q,y:q}):this.m.setWindowButtonPosition(null)}}tb(N){(0,a.mark)("code/willRestoreCodeWindowState");let q=!1;if(N)try{const X=S.screen.getAllDisplays();q=X.length>1,N=this.ub(N,X)}catch(X){this.N.warn(`Unexpected error validating window state: ${X}
${X.stack}`)}return(0,a.mark)("code/didRestoreCodeWindowState"),[N||(0,I.$15b)(),q]}ub(N,q){if(this.N.trace(`window#validateWindowState: validating window state on ${q.length} display(s)`,N),typeof N.x!="number"||typeof N.y!="number"||typeof N.width!="number"||typeof N.height!="number"){this.N.trace("window#validateWindowState: unexpected type of state values");return}if(N.width<=0||N.height<=0){this.N.trace("window#validateWindowState: unexpected negative values");return}if(q.length===1){const Y=this.vb(q[0]);if(Y){let re=function(){!N||typeof N.x!="number"||typeof N.y!="number"||!Y||(N.x<Y.x&&(N.x=Y.x),N.y<Y.y&&(N.y=Y.y))};this.N.trace("window#validateWindowState: 1 monitor working area",Y),re(),N.width>Y.width&&(N.width=Y.width),N.height>Y.height&&(N.height=Y.height),N.x>Y.x+Y.width-128&&(N.x=Y.x+Y.width-N.width),N.y>Y.y+Y.height-128&&(N.y=Y.y+Y.height-N.height),re()}return N}if(N.display&&N.mode===3){const Y=q.find(re=>re.id===N.display);if(Y&&typeof Y.bounds?.x=="number"&&typeof Y.bounds?.y=="number"){this.N.trace("window#validateWindowState: restoring fullscreen to previous display");const re=(0,I.$15b)(3);return re.x=Y.bounds.x,re.y=Y.bounds.y,re}}let X,H;try{X=S.screen.getDisplayMatching({x:N.x,y:N.y,width:N.width,height:N.height}),H=this.vb(X)}catch{}if(X&&H&&N.x+N.width>H.x&&N.y+N.height>H.y&&N.x<H.x+H.width&&N.y<H.y+H.height)return this.N.trace("window#validateWindowState: multi-monitor working area",H),N}vb(N){if(N.workArea.width>0&&N.workArea.height>0)return N.workArea;if(N.bounds.width>0&&N.bounds.height>0)return N.bounds}getBounds(){const[N,q]=this.m.getPosition(),[X,H]=this.m.getSize();return{x:N,y:q,width:X,height:H}}toggleFullScreen(){this.wb(!this.isFullScreen)}wb(N){this.Ab()?this.xb(N):this.zb(N),this.sendWhenReady(N?"vscode:enterFullScreen":"vscode:leaveFullScreen",s.CancellationToken.None),this.t&&this.Cb(this.t,!1)}get isFullScreen(){if(this.ib(`isFullScreen(): begin at ${Date.now()}`),g.$k&&typeof this.u=="boolean")return this.ib(`isFullScreen(): returning transientIsNativeFullScreen = ${this.u}`),this.u;const N=this.m.isFullScreen(),q=this.m.isSimpleFullScreen();return this.ib(`isFullScreen(): returning natively, isFullScreen = ${N}, isSimpleFullScreen = ${q}`),N||q}xb(N){this.m.isSimpleFullScreen()&&this.m.setSimpleFullScreen(!1),this.yb(N)}yb(N){g.$k&&(this.ib(`doSetNativeFullScreen(${N}): begin at ${Date.now()}`),this.u=N,this.w=new R.$ch,Promise.race([this.w.p,(0,R.$Ug)(1e3)]).finally(()=>{this.ib(`doSetNativeFullScreen(${N}): finish at ${Date.now()}`),this.u=void 0})),this.m.setFullScreen(N)}zb(N){this.m.isFullScreen()&&this.yb(!1),this.m.setSimpleFullScreen(N),this.m.webContents.focus()}Ab(){const N=this.X.getValue("window");return!N||typeof N.nativeFullScreen!="boolean"||N.nativeTabs?!0:N.nativeFullScreen!==!1}isMinimized(){return this.m.isMinimized()}Bb(){let N=(0,p.$2C)(this.X);return["visible","toggle","hidden"].indexOf(N)<0&&(N="classic"),N}Cb(N,q=!0){g.$k||(N==="toggle"&&q&&this.send("vscode:showInfoMessage",(0,y.localize)(14,null)),N==="hidden"?setTimeout(()=>{this.Db(N)}):this.Db(N))}Db(N){const q=this.isFullScreen;switch(N){case"classic":this.m.setMenuBarVisibility(!q),this.m.autoHideMenuBar=q;break;case"visible":this.m.setMenuBarVisibility(!0),this.m.autoHideMenuBar=!1;break;case"toggle":this.m.setMenuBarVisibility(!1),this.m.autoHideMenuBar=!0;break;case"hidden":this.m.setMenuBarVisibility(!1),this.m.autoHideMenuBar=!1;break}}handleTitleDoubleClick(){if(g.$k)switch(S.systemPreferences.getUserDefault("AppleActionOnDoubleClick","string")){case"Minimize":this.m.minimize();break;case"None":break;case"Maximize":default:this.m.isMaximized()?this.m.unmaximize():this.m.maximize()}else this.m.isMaximized()?this.m.unmaximize():this.m.maximize()}close(){this.m?.close()}sendWhenReady(N,q,...X){this.isReady?this.send(N,...X):this.ready().then(()=>{q.isCancellationRequested||this.send(N,...X)})}send(N,...q){if(this.m){if(this.m.isDestroyed()||this.m.webContents.isDestroyed()){this.N.warn(`Sending IPC message to channel '${N}' for window that is destroyed`);return}try{this.m.webContents.send(N,...q)}catch(X){this.N.warn(`Error sending IPC message to channel '${N}' of window ${this.j}: ${(0,M.$zi)(X)}`)}}}updateTouchBar(N){g.$k&&this.G.forEach((q,X)=>{const H=N[X];q.segments=this.Gb(H)})}Eb(){if(g.$k){for(let N=0;N<10;N++){const q=this.Fb();this.G.push(q)}this.m.setTouchBar(new S.TouchBar({items:this.G}))}}Fb(N=[]){const q=this.Gb(N),X=new S.TouchBar.TouchBarSegmentedControl({segments:q,mode:"buttons",segmentStyle:"automatic",change:H=>{this.sendWhenReady("vscode:runAction",s.CancellationToken.None,{id:X.segments[H].id,from:"touchbar"})}});return X}Gb(N=[]){return N.map(X=>{let H;X.icon&&!n.ThemeIcon.isThemeIcon(X.icon)&&X.icon?.dark?.scheme===f.Schemas.file&&(H=S.nativeImage.createFromPath(w.URI.revive(X.icon.dark).fsPath),H.isEmpty()&&(H=void 0));let Y;return typeof X.title=="string"?Y=X.title:Y=X.title.value,{id:X.id,label:H?void 0:Y,icon:H}})}dispose(){super.dispose(),this.O.deregisterLoggers(this.id),this.m=null}};e.$u7b=J,e.$u7b=J=oe=ke([ee(1,E.$9i),ee(2,_.$96b),ee(3,$.$25b),ee(4,U.$fn),ee(5,ne.$05b),ee(6,u.$0j),ee(7,o.$b6b),ee(8,o.$_5b),ee(9,v.$ii),ee(10,r.$d6b),ee(11,k.$x6b),ee(12,d.$l6b),ee(13,t.$bl),ee(14,b.$s6b),ee(15,l.$45b),ee(16,h.$oj),ee(17,i.$S6b),ee(18,A.$f6b),ee(19,z.$rN),ee(20,se.$Nh)],J)}),define(te[82],ie([0,1,15,23,8,3,46,2,13,4,19,7,21,191,6,20,5,81,97,29,53,31]),function(Q,e,S,R,s,M,D,P,f,a,g,w,y,d,v,b,$,m,u,l,E,h){"use strict";var i;Object.defineProperty(e,"__esModule",{value:!0}),e.$56b=e.$46b=void 0,e.$46b=(0,v.$Oh)("workspacesHistoryMainService");let c=class extends P.$Sc{static{i=this}static{this.a=500}static{this.b="history.recentlyOpenedPathsList"}constructor(t,n,r,p){super(),this.f=t,this.g=n,this.h=r,this.j=p,this.c=this.B(new M.$Nd),this.onDidChangeRecentlyOpened=this.c.event,this.G=this.B(new s.$Rg(800)),this.m()}m(){this.h.when(4).then(()=>this.H()),this.B(this.g.onDidEnterWorkspace(t=>this.addRecentlyOpened([{workspace:t.workspace,remoteAuthority:t.window.remoteAuthority}])))}async addRecentlyOpened(t){let n=[],r=[];for(const A of t)if((0,u.$CU)(A))!this.g.isUntitledWorkspace(A.workspace)&&!this.u(n,A.workspace)&&n.push(A);else if((0,u.$DU)(A))this.w(n,A.folderUri)||n.push(A);else{const C=this.y(r,A.fileUri),k=A.fileUri.scheme===f.Schemas.file&&i.F.indexOf((0,g.$sg)(A.fileUri))>=0;!C&&!k&&(r.push(A),a.$j&&A.fileUri.scheme===f.Schemas.file&&S.app.addRecentDocument(A.fileUri.fsPath))}const p=await this.n({workspaces:n,files:r});n=p.workspaces,r=p.files,n.length>i.a&&(n.length=i.a),r.length>i.a&&(r.length=i.a),await this.s({workspaces:n,files:r}),this.c.fire(),a.$k&&this.G.trigger(()=>this.M())}async removeRecentlyOpened(t){const n=C=>{const k=this.t(C);for(const I of t)if(g.$mg.isEqual(I,k))return!1;return!0},r=await this.getRecentlyOpened(),p=r.workspaces.filter(n),A=r.files.filter(n);(p.length!==r.workspaces.length||A.length!==r.files.length)&&(await this.s({files:A,workspaces:p}),this.c.fire(),a.$k&&this.G.trigger(()=>this.M()))}async clearRecentlyOpened(){await this.s({workspaces:[],files:[]}),S.app.clearRecentDocuments(),this.c.fire()}async getRecentlyOpened(){return this.n()}async n(t){const n=new h.$Ac(A=>g.$mg.getComparisonKey(A));if(t?.workspaces)for(const A of t.workspaces)n.set(this.t(A),A);const r=new h.$Ac(A=>g.$mg.getComparisonKey(A));if(t?.files)for(const A of t.files)r.set(this.t(A),A);const p=await this.r();for(const A of p.workspaces){const C=n.get(this.t(A));C?C.label=C.label??A.label:n.set(this.t(A),A)}for(const A of p.files){const C=r.get(this.t(A));C?C.label=C.label??A.label:r.set(this.t(A),A)}return{workspaces:[...n.values()],files:[...r.values()]}}async r(){await this.j.whenReady;let t;const n=this.j.get(i.b,-1);if(typeof n=="string")try{t=JSON.parse(n)}catch(r){this.f.error("Unexpected error parsing opened paths list",r)}return(0,u.$JU)(t,this.f)}async s(t){await this.j.whenReady,this.j.store(i.b,JSON.stringify((0,u.$KU)(t)),-1,1)}t(t){return(0,u.$DU)(t)?t.folderUri:(0,u.$EU)(t)?t.fileUri:t.workspace.configPath}u(t,n){return!!t.find(r=>(0,u.$CU)(r)&&r.workspace.id===n.id)}w(t,n){return!!t.find(r=>(0,u.$DU)(r)&&g.$mg.isEqual(r.folderUri,n))}y(t,n){return!!t.find(r=>g.$mg.isEqual(r.fileUri,n))}static{this.z=7}static{this.C=10}static{this.D=7}static{this.F=["COMMIT_EDITMSG","MERGE_MSG"]}async H(){a.$j&&(await this.I(),this.B(this.onDidChangeRecentlyOpened(()=>this.I())))}async I(){if(!a.$j)return;const t=[];if(t.push({type:"tasks",items:[{type:"task",title:(0,d.localize)(0,null),description:(0,d.localize)(1,null),program:process.execPath,args:"-n",iconPath:process.execPath,iconIndex:0}]}),(await this.getRecentlyOpened()).workspaces.length>0){const n=[];for(const A of S.app.getJumpListSettings().removedItems){const C=A.args;if(C){const k=/^--(folder|file)-uri\s+"([^"]+)"$/.exec(C);k&&n.push(w.URI.parse(k[2]))}}await this.removeRecentlyOpened(n);let r=!1;const p=(0,R.$Hb)((await this.getRecentlyOpened()).workspaces.slice(0,i.D).map(A=>{const C=(0,u.$CU)(A)?A.workspace:A.folderUri,{title:k,description:I}=this.J(C,A.label);let j;return w.URI.isUri(C)?j=`--folder-uri "${C.toString()}"`:(r=!0,j=`--file-uri "${C.configPath.toString()}"`),{type:"task",title:k.substr(0,255),description:I.substr(0,255),program:process.execPath,args:j,iconPath:"explorer.exe",iconIndex:0}}));p.length>0&&t.push({type:"custom",name:r?(0,d.localize)(2,null):(0,d.localize)(3,null),items:p})}t.push({type:"recent"});try{const n=S.app.setJumpList(t);n&&n!=="ok"&&this.f.warn(`updateWindowsJumpList#setJumpList unexpected result: ${n}`)}catch(n){this.f.warn("updateWindowsJumpList#setJumpList",n)}}J(t,n){if(n)return{title:(0,D.$wv)(n).name,description:n};if(w.URI.isUri(t))return{title:(0,g.$sg)(t),description:this.L(t)};if(this.g.isUntitledWorkspace(t))return{title:(0,d.localize)(4,null),description:""};let r=(0,g.$sg)(t.configPath);return r.endsWith(l.$$h)&&(r=r.substr(0,r.length-l.$$h.length-1)),{title:(0,d.localize)(5,null,r),description:this.L(t.configPath)}}L(t){return t.scheme==="file"?(0,D.$ov)(t.fsPath):t.toString()}async M(){if(!a.$k)return;S.app.clearRecentDocuments();const t=await this.getRecentlyOpened(),n=[];let r=0;for(let A=0;A<t.workspaces.length&&r<i.z;A++){const C=this.t(t.workspaces[A]);if(C.scheme===f.Schemas.file){const k=(0,g.$jg)(C);await y.Promises.exists(k)&&(n.push(k),r++)}}const p=[];for(let A=0;A<t.files.length&&r<i.C;A++){const C=this.t(t.files[A]);if(C.scheme===f.Schemas.file){const k=(0,g.$jg)(C);if(i.F.includes((0,g.$sg)(C))||n.includes(k))continue;await y.Promises.exists(k)&&(p.push(k),r++)}}p.reverse().forEach(A=>S.app.addRecentDocument(A)),n.reverse().forEach(A=>S.app.addRecentDocument(A))}};e.$56b=c,e.$56b=c=i=ke([ee(0,$.$9i),ee(1,E.$x6b),ee(2,b.$45b),ee(3,m.$b6b)],c)}),define(te[302],ie([0,1,15,8,22,46,4,7,179,18,25,20,5,229,69,24,34,26,48,68,30,82]),function(Q,e,S,R,s,M,D,P,f,a,g,w,y,d,v,b,$,m,u,l,E,h){"use strict";var i;Object.defineProperty(e,"__esModule",{value:!0}),e.$66b=void 0;const c="menu";let o=class{static{i=this}static{this.a="lastKnownMenubarData"}constructor(r,p,A,C,k,I,j,U,z,ne,_){this.n=r,this.o=p,this.p=A,this.q=C,this.r=k,this.s=I,this.t=j,this.u=U,this.v=z,this.w=ne,this.x=_,this.m=Object.create(null),this.g=new R.$6g(()=>this.E(),0),this.h=new R.$6g(()=>{this.j=[]},1e4),this.k=Object.create(null),this.l=Object.create(null),(D.$k||(0,l.$3C)(this.o)==="native")&&this.y(),this.z(),this.d=!1,this.f=!1,this.j=[],this.H(),this.A()}y(){const r=this.t.getItem(i.a);r&&(r.menus&&(this.k=r.menus),r.keybindings&&(this.l=r.keybindings))}z(){this.m["workbench.action.files.newUntitledFile"]=(I,j,U)=>this.p.openEmptyWindow({context:2,contextWindowId:j?.id}),this.m["workbench.action.newWindow"]=(I,j,U)=>this.p.openEmptyWindow({context:2,contextWindowId:j?.id}),this.m["workbench.action.files.openFileFolder"]=(I,j,U)=>this.w.pickFileFolderAndOpen(void 0,{forceNewWindow:this.P(U),telemetryExtraData:{from:c}}),this.m["workbench.action.files.openFolder"]=(I,j,U)=>this.w.pickFolderAndOpen(void 0,{forceNewWindow:this.P(U),telemetryExtraData:{from:c}}),this.m["workbench.action.openWorkspace"]=(I,j,U)=>this.w.pickWorkspaceAndOpen(void 0,{forceNewWindow:this.P(U),telemetryExtraData:{from:c}}),this.m["workbench.action.clearRecentFiles"]=()=>this.s.clearRecentlyOpened();const r=this.x.youTubeUrl;r&&(this.m["workbench.action.openYouTubeUrl"]=()=>this.Z(r,"openYouTubeUrl"));const p=this.x.requestFeatureUrl;p&&(this.m["workbench.action.openRequestFeatureUrl"]=()=>this.Z(p,"openUserVoiceUrl"));const A=this.x.reportIssueUrl;A&&(this.m["workbench.action.openIssueReporter"]=()=>this.Z(A,"openReportIssues"));const C=this.x.licenseUrl;C&&(this.m["workbench.action.openLicenseUrl"]=()=>{if(D.$w){const I=C.indexOf("?")>0?"&":"?";this.Z(`${C}${I}lang=${D.$w}`,"openLicenseUrl")}else this.Z(C,"openLicenseUrl")});const k=this.x.privacyStatementUrl;k&&C&&(this.m["workbench.action.openPrivacyStatementUrl"]=()=>{this.Z(k,"openPrivacyStatement")})}A(){this.u.onWillShutdown(()=>this.b=!0),this.p.onDidChangeWindowsCount(r=>this.F(r)),this.w.onDidBlurWindow(()=>this.G()),this.w.onDidFocusWindow(()=>this.G())}get B(){const r=this.o.getValue("window.enableMenuBarMnemonics");return typeof r!="boolean"?!0:r}get C(){if(!D.$k)return!1;const r=this.o.getValue("window.nativeTabs");return typeof r!="boolean"?!1:r}updateMenu(r,p){this.k=r.menus,this.l=r.keybindings,this.t.setItem(i.a,r),this.D()}D(){this.g.schedule()}E(){this.b||setTimeout(()=>{this.b||this.H()},10)}F(r){D.$k&&(r.oldCount===0&&r.newCount>0||r.oldCount>0&&r.newCount===0)&&(this.d=r.newCount===0,this.D())}G(){D.$k&&(this.f=!S.BrowserWindow.getFocusedWindow(),this.D())}H(){const r=S.Menu.getApplicationMenu();if(r&&this.j.push(r),Object.keys(this.k).length===0){S.Menu.setApplicationMenu(D.$k?new S.Menu:null);return}const p=new S.Menu;let A;if(D.$k){const k=new S.Menu;A=new S.MenuItem({label:this.x.nameShort,submenu:k}),this.I(k),p.append(A)}if(D.$k&&!this.c){this.c=!0;const k=new S.Menu;k.append(new S.MenuItem({label:this.ab(f.localize(0,null)),click:()=>this.p.openEmptyWindow({context:1})})),S.app.dock.setMenu(k)}if(this.K("File")){const k=new S.Menu,I=new S.MenuItem({label:this.ab(f.localize(1,null)),submenu:k});this.M(k,"File"),p.append(I)}if(this.K("Edit")){const k=new S.Menu,I=new S.MenuItem({label:this.ab(f.localize(2,null)),submenu:k});this.M(k,"Edit"),p.append(I)}if(this.K("Selection")){const k=new S.Menu,I=new S.MenuItem({label:this.ab(f.localize(3,null)),submenu:k});this.M(k,"Selection"),p.append(I)}if(this.K("View")){const k=new S.Menu,I=new S.MenuItem({label:this.ab(f.localize(4,null)),submenu:k});this.M(k,"View"),p.append(I)}if(this.K("Go")){const k=new S.Menu,I=new S.MenuItem({label:this.ab(f.localize(5,null)),submenu:k});this.M(k,"Go"),p.append(I)}if(this.K("Run")){const k=new S.Menu,I=new S.MenuItem({label:this.ab(f.localize(6,null)),submenu:k});this.M(k,"Run"),p.append(I)}if(this.K("Terminal")){const k=new S.Menu,I=new S.MenuItem({label:this.ab(f.localize(7,null)),submenu:k});this.M(k,"Terminal"),p.append(I)}let C;if(this.K("Window")){const k=new S.Menu;C=new S.MenuItem({label:this.ab(f.localize(8,null)),submenu:k,role:"window"}),this.S(k)}if(C&&p.append(C),this.K("Help")){const k=new S.Menu,I=new S.MenuItem({label:this.ab(f.localize(9,null)),submenu:k,role:"help"});this.M(k,"Help"),p.append(I)}p.items&&p.items.length>0?S.Menu.setApplicationMenu(p):S.Menu.setApplicationMenu(null),this.h.schedule()}I(r){const p=this.U(f.localize(10,null,this.x.nameLong),"workbench.action.showAboutDialog"),A=this.T();let C;if(this.K("Preferences")){const ae=new S.Menu;this.M(ae,"Preferences"),C=new S.MenuItem({label:this.ab(f.localize(11,null)),submenu:ae})}const k=new S.Menu,I=new S.MenuItem({label:f.localize(12,null),role:"services",submenu:k}),j=new S.MenuItem({label:f.localize(13,null,this.x.nameLong),role:"hide",accelerator:"Command+H"}),U=new S.MenuItem({label:f.localize(14,null),role:"hideOthers",accelerator:"Command+Alt+H"}),z=new S.MenuItem({label:f.localize(15,null),role:"unhide"}),ne=new S.MenuItem(this.Y("workbench.action.quit",{label:f.localize(16,null,this.x.nameLong),click:async(ae,se,oe)=>{const K=this.p.getLastActiveWindow();(this.p.getWindowCount()===0||S.BrowserWindow.getFocusedWindow()||K?.isMinimized())&&await this.J(oe)&&this.w.quit(void 0)}})),_=[p];_.push(...A),C&&_.push(t(),C),_.push(t(),I,t(),j,U,z,t(),ne),_.forEach(ae=>r.append(ae))}async J(r){if(this.p.getWindowCount()===0)return!0;const p=this.o.getValue("window.confirmBeforeClose");if(p==="always"||p==="keyboardOnly"&&this.Q(r)){const{response:A}=await this.w.showMessageBox(this.p.getFocusedWindow()?.id,{type:"question",buttons:[f.localize(17,null),f.localize(18,null)],message:f.localize(19,null)});return A===0}return!0}K(r){if(!D.$k&&(0,l.$3C)(this.o)==="custom")return!1;switch(r){case"File":case"Help":if(D.$k)return this.p.getWindowCount()===0&&this.d||this.p.getWindowCount()>0&&this.f||!!this.k&&!!this.k[r];case"Window":if(D.$k)return this.p.getWindowCount()===0&&this.d||this.p.getWindowCount()>0&&this.f||!!this.k;default:return this.p.getWindowCount()>0&&!!this.k&&!!this.k[r]}}L(r,p){p.forEach(A=>{if((0,d.$16b)(A))r.append(t());else if((0,d.$Z6b)(A)){const C=new S.Menu,k=new S.MenuItem({label:this.ab(A.label),submenu:C});this.L(C,A.submenu.items),r.append(k)}else(0,d.$26b)(A)?r.append(this.O(A)):(0,d.$36b)(A)&&(A.id==="workbench.action.showAboutDialog"&&this.N(r),D.$k?this.p.getWindowCount()===0&&this.d||this.p.getWindowCount()>0&&this.f?this.m[A.id]?r.append(new S.MenuItem(this.Y(A.id,{label:this.ab(A.label),click:this.m[A.id]}))):r.append(this.U(A.label,A.id,!1,A.checked)):r.append(this.U(A.label,A.id,A.enabled!==!1,!!A.checked)):r.append(this.U(A.label,A.id,A.enabled!==!1,!!A.checked)))})}M(r,p){this.k&&this.k[p]&&this.L(r,this.k[p].items)}N(r){const p=this.T();p.length&&(p.forEach(A=>r.append(A)),r.append(t()))}O(r){const p=P.URI.revive(r.uri),A=r.id,C=A==="openRecentFile"?{fileUri:p}:A==="openRecentWorkspace"?{workspaceUri:p}:{folderUri:p};return new S.MenuItem(this.Y(A,{label:r.label,click:async(k,I,j)=>{const U=this.P(j);(await this.p.open({context:2,cli:this.q.args,urisToOpen:[C],forceNewWindow:U,gotoLineMode:!1,remoteAuthority:r.remoteAuthority})).length>0||await this.s.removeRecentlyOpened([p])}},!1))}P(r){return!!(r&&(!D.$k&&(r.ctrlKey||r.shiftKey)||D.$k&&(r.metaKey||r.altKey)))}Q(r){return!!(r.triggeredByAccelerator||r.altKey||r.ctrlKey||r.metaKey||r.shiftKey)}R(r,p,A){const C={label:this.ab(r),role:A,enabled:!0};return new S.MenuItem(this.X(p,C))}S(r){const p=new S.MenuItem({label:f.localize(20,null),role:"minimize",accelerator:"Command+M",enabled:this.p.getWindowCount()>0}),A=new S.MenuItem({label:f.localize(21,null),role:"zoom",enabled:this.p.getWindowCount()>0}),C=new S.MenuItem({label:f.localize(22,null),role:"front",enabled:this.p.getWindowCount()>0}),k=this.U(f.localize(23,null),"workbench.action.switchWindow"),I=[];this.C&&(I.push(t()),I.push(this.U(f.localize(24,null),"workbench.action.newWindowTab")),I.push(this.R(f.localize(25,null),"workbench.action.showPreviousWindowTab","selectPreviousTab")),I.push(this.R(f.localize(26,null),"workbench.action.showNextWindowTab","selectNextTab")),I.push(this.R(f.localize(27,null),"workbench.action.moveWindowTabToNewWindow","moveTabToNewWindow")),I.push(this.R(f.localize(28,null),"workbench.action.mergeAllWindowTabs","mergeAllWindows"))),[p,A,t(),k,...I,t(),C].forEach(j=>r.append(j))}T(){switch(this.n.state.type){case"idle":return[new S.MenuItem({label:this.ab(f.localize(29,null)),click:()=>setTimeout(()=>{this.$("CheckForUpdate"),this.n.checkForUpdates(!0)},0)})];case"checking for updates":return[new S.MenuItem({label:f.localize(30,null),enabled:!1})];case"available for download":return[new S.MenuItem({label:this.ab(f.localize(31,null)),click:()=>{this.n.downloadUpdate()}})];case"downloading":return[new S.MenuItem({label:f.localize(32,null),enabled:!1})];case"downloaded":return[new S.MenuItem({label:this.ab(f.localize(33,null)),click:()=>{this.$("InstallUpdate"),this.n.applyUpdate()}})];case"updating":return[new S.MenuItem({label:f.localize(34,null),enabled:!1})];case"ready":return[new S.MenuItem({label:this.ab(f.localize(35,null)),click:()=>{this.$("RestartToUpdate"),this.n.quitAndInstall()}})];default:return[]}}U(r,p,A,C){const k=this.ab(r),I=typeof p=="function"?p:(_,ae,se)=>{const oe=_?_.userSettingsLabel:null;let K=p;Array.isArray(p)&&(K=this.P(se)?p[1]:p[0]),oe&&se.triggeredByAccelerator?this.W({type:"keybinding",userSettingsLabel:oe}):this.W({type:"commandId",commandId:K})},j=typeof A=="boolean"?A:this.p.getWindowCount()>0,U=typeof C=="boolean"?C:!1,z={label:k,click:I,enabled:j};U&&(z.type="checkbox",z.checked=U);let ne;return typeof p=="string"?ne=p:Array.isArray(p)&&(ne=p[0]),D.$k&&(ne==="editor.action.clipboardCutAction"?z.role="cut":ne==="editor.action.clipboardCopyAction"?z.role="copy":ne==="editor.action.clipboardPasteAction"&&(z.role="paste"),ne==="undo"?z.click=this.V(I,{inDevTools:_=>_.undo(),inNoWindow:()=>S.Menu.sendActionToFirstResponder("undo:")}):ne==="redo"?z.click=this.V(I,{inDevTools:_=>_.redo(),inNoWindow:()=>S.Menu.sendActionToFirstResponder("redo:")}):ne==="editor.action.selectAll"&&(z.click=this.V(I,{inDevTools:_=>_.selectAll(),inNoWindow:()=>S.Menu.sendActionToFirstResponder("selectAll:")}))),new S.MenuItem(this.X(ne,z))}V(r,p){return(A,C,k)=>{const I=S.BrowserWindow.getFocusedWindow();if(!I)return p.inNoWindow();if(I.webContents.isDevToolsFocused()&&I.webContents.devToolsWebContents)return p.inDevTools(I.webContents.devToolsWebContents);r(A,C||I,k)}}W(r){let p=S.BrowserWindow.getFocusedWindow();if(!p){const C=this.p.getLastActiveWindow();C?.isMinimized()&&(p=C.win)}const A=p?this.p.getWindowById(p.id):void 0;if(A){if(this.v.trace("menubar#runActionInRenderer",r),D.$k&&!this.q.isBuilt&&!A.isReady&&(r.type==="commandId"&&r.commandId==="workbench.action.toggleDevTools"||r.type!=="commandId"&&r.userSettingsLabel==="alt+cmd+i"))return;if(r.type==="commandId"){const C={id:r.commandId,from:"menu"};A.sendWhenReady("vscode:runAction",s.CancellationToken.None,C)}else{const C={userSettingsLabel:r.userSettingsLabel};A.sendWhenReady("vscode:runKeybinding",s.CancellationToken.None,C)}}else this.v.trace("menubar#runActionInRenderer: no active window found",r)}X(r,p){const A=typeof r=="string"?this.l[r]:void 0;if(A?.label){if(A.isNative!==!1)p.accelerator=A.label,p.userSettingsLabel=A.userSettingsLabel;else if(typeof p.label=="string"){const C=p.label.indexOf("[");C>=0?p.label=`${p.label.substr(0,C)} [${A.label}]`:p.label=`${p.label} [${A.label}]`}}else p.accelerator=void 0;return p}Y(r,p,A=!p.accelerator){A&&(p=this.X(r,p));const C=p.click;return p.click=(k,I,j)=>{this.$(r),C?.(k,I,j)},p}Z(r,p){this.w.openExternal(void 0,r),this.$(p)}$(r){this.r.publicLog2("workbenchActionExecuted",{id:r,from:c})}ab(r){return(0,M.$tv)(r,!this.B)}};e.$66b=o,e.$66b=o=i=ke([ee(0,u.$eU),ee(1,a.$ii),ee(2,E.$f6b),ee(3,g.$25b),ee(4,m.$bl),ee(5,h.$46b),ee(6,$.$rN),ee(7,w.$45b),ee(8,y.$9i),ee(9,v.$Q6b),ee(10,b.$oj)],o);function t(){return new S.MenuItem({type:"separator"})}}),define(te[303],ie([0,1,6,20,5,302]),function(Q,e,S,R,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$86b=e.$76b=void 0,e.$76b=(0,S.$Oh)("menubarMainService");let D=class{constructor(f,a,g){this.b=f,this.c=a,this.d=g,this.a=this.e()}async e(){return await this.c.when(3),this.b.createInstance(M.$66b)}async updateMenubar(f,a){this.d.trace("menubarService#updateMenubar",f),(await this.a).updateMenu(a,f)}};e.$86b=D,e.$86b=D=ke([ee(0,S.$Nh),ee(1,R.$45b),ee(2,s.$9i)],D)}),define(te[304],ie([0,1,15,21,130,28,23,22,3,33,46,2,13,9,65,4,35,19,12,7,189,63,18,59,25,16,6,20,5,78,79,58,34,68,301,129,297,29,98,82,53,67,39,52,66]),function(Q,e,S,R,s,M,D,P,f,a,g,w,y,d,v,b,$,m,u,l,E,h,i,c,o,t,n,r,p,A,C,k,I,j,U,z,ne,_,ae,se,oe,K,J,G,N){"use strict";var q;Object.defineProperty(e,"__esModule",{value:!0}),e.$y7b=void 0;function X(re){return(0,_.$4h)(re?.workspace)}function H(re){return(0,_.$Yh)(re?.workspace)}let Y=class extends w.$Sc{static{q=this}static{this.a=[]}constructor(F,O,L,B,T,W,V,ce,de,ue,fe,ye,be,pe,Ae,Te,me,we){super(),this.m=F,this.n=O,this.r=L,this.s=B,this.t=T,this.u=W,this.w=V,this.z=ce,this.C=de,this.D=ue,this.F=fe,this.G=ye,this.H=be,this.I=pe,this.J=Ae,this.L=Te,this.M=me,this.N=we,this.b=this.B(new f.$Nd),this.onDidOpenWindow=this.b.event,this.c=this.B(new f.$Nd),this.onDidSignalReadyWindow=this.c.event,this.f=this.B(new f.$Nd),this.onDidDestroyWindow=this.f.event,this.g=this.B(new f.$Nd),this.onDidChangeWindowsCount=this.g.event,this.h=this.B(new f.$Nd),this.onDidTriggerSystemContextMenu=this.h.event,this.j=this.B(new ne.$v7b(this,this.t,this.C,this.r,this.F)),this.O()}O(){this.B(this.H.onDidEnterWorkspace(F=>this.c.fire(F.window))),this.B(this.onDidSignalReadyWindow(F=>{if(F.config?.extensionDevelopmentPath||F.config?.extensionTestsPath){const O=new w.$Rc;if(O.add(f.Event.any(F.onDidClose,F.onDidDestroy)(()=>O.dispose())),F.config.extensionDevelopmentPath)for(const L of F.config.extensionDevelopmentPath)O.add(this.M.addValidFileRoot(L));F.config.extensionTestsPath&&O.add(this.M.addValidFileRoot(F.config.extensionTestsPath))}}))}openEmptyWindow(F,O){const L=this.w.args,B=O?.remoteAuthority||void 0,T=!0,W=O?.forceReuseWindow,V=!W;return this.open({...F,cli:L,forceEmpty:T,forceNewWindow:V,forceReuseWindow:W,remoteAuthority:B})}openExistingWindow(F,O){F.focus(),this.P(O,[F])}async open(F){this.r.trace("windowsManager#open"),F.addMode&&(F.initialStartup||!this.getLastActiveWindow())&&(F.addMode=!1);const O=[],L=[],B=[],T=[],W=[];let V,ce=0;const de=await this.X(F);this.r.trace("windowsManager#open pathsToOpen",de);for(const pe of de)H(pe)?F.addMode?O.push(pe):L.push(pe):X(pe)?B.push(pe):pe.fileUri?(V||(V={filesToOpenOrCreate:[],filesToDiff:[],filesToMerge:[],remoteAuthority:pe.remoteAuthority}),V.filesToOpenOrCreate.push(pe)):pe.backupPath?W.push({backupFolder:(0,d.$nc)(pe.backupPath),remoteAuthority:pe.remoteAuthority}):ce++;F.diffMode&&V&&V.filesToOpenOrCreate.length>=2&&(V.filesToDiff=V.filesToOpenOrCreate.slice(0,2),V.filesToOpenOrCreate=[]),F.mergeMode&&V&&V.filesToOpenOrCreate.length===4&&(V.filesToMerge=V.filesToOpenOrCreate.slice(0,4),V.filesToOpenOrCreate=[],V.filesToDiff=[]),V&&F.waitMarkerFileURI&&(V.filesToWait={paths:(0,D.$Hb)([...V.filesToDiff,V.filesToMerge[3],...V.filesToOpenOrCreate]),waitMarkerFileUri:F.waitMarkerFileURI}),F.initialStartup?(T.push(...this.H.getUntitledWorkspaces()),B.push(...T),W.push(...this.D.getEmptyWindowBackups())):W.length=0;const{windows:ue,filesOpenedInWindow:fe}=await this.Q(F,B,L,W,ce,V,O);if(this.r.trace(`windowsManager#open used window count ${ue.length} (workspacesToOpen: ${B.length}, foldersToOpen: ${L.length}, emptyToRestore: ${W.length}, emptyToOpen: ${ce})`),ue.length>1)if(fe)fe.focus();else{const pe=this.j.state.lastActiveWindow&&!F.forceEmpty&&!F.cli._.length&&!F.cli["file-uri"]&&!F.cli["folder-uri"]&&!(F.urisToOpen&&F.urisToOpen.length);let Ae=!0,Te=!0;if(pe){const me=ue.filter(we=>this.j.state.lastActiveWindow&&we.backupPath===this.j.state.lastActiveWindow.backupPath);me.length&&(me[0].focus(),Ae=!1,Te=!1)}if(Ae)for(let me=ue.length-1;me>=0;me--){const we=ue[me];if(!(we.openedWorkspace&&T.some(Z=>we.openedWorkspace&&Z.workspace.id===we.openedWorkspace.id)||we.backupPath&&W.some(Z=>we.backupPath&&Z.backupFolder===(0,d.$nc)(we.backupPath)))){we.focus(),Te=!1;break}}Te&&ue[ue.length-1].focus()}const ye=V&&V.filesToDiff.length>0,be=V&&V.filesToMerge.length>0;if(!ue.some(pe=>pe.isExtensionDevelopmentHost)&&!ye&&!be&&!F.noRecentEntry){const pe=[];for(const Ae of de)X(Ae)&&!Ae.transient?pe.push({label:Ae.label,workspace:Ae.workspace,remoteAuthority:Ae.remoteAuthority}):H(Ae)?pe.push({label:Ae.label,folderUri:Ae.workspace.uri,remoteAuthority:Ae.remoteAuthority}):Ae.fileUri&&pe.push({label:Ae.label,fileUri:Ae.fileUri,remoteAuthority:Ae.remoteAuthority});this.G.addRecentlyOpened(pe)}return this.P(F,ue),ue}P(F,O){const L=F.waitMarkerFileURI;F.context===0&&L&&O.length===1&&O[0]&&(async()=>{await O[0].whenClosedOrLoaded;try{await this.L.del(L)}catch{}})()}async Q(F,O,L,B,T,W,V){const ce=[];let de;function ue(me,we){ce.push(me),we&&(de=me,W=void 0)}let{openFolderInNewWindow:fe,openFilesInNewWindow:ye}=this.ib(F);if(!F.initialStartup&&V.length>0){const me=V[0].remoteAuthority,we=this.nb(me);we&&ue(this.S(we,V.map(Z=>Z.workspace.uri)))}const be=L.length+O.length+B.length;if(W&&be===0){const me=W.filesToOpenOrCreate[0]||W.filesToDiff[0]||W.filesToMerge[3],we=this.getWindows().filter(le=>W&&(0,m.$Ag)(le.remoteAuthority,W.remoteAuthority));let Z;me?.fileUri&&!ye&&((F.context===4||F.context===0||F.context===1)&&(Z=await(0,z.$u6b)(we,me.fileUri,async le=>le.configPath.scheme===y.Schemas.file?this.H.resolveLocalWorkspace(le.configPath):void 0)),Z||(Z=this.ob(we))),Z?(0,_.$4h)(Z.openedWorkspace)?O.push({workspace:Z.openedWorkspace,remoteAuthority:Z.remoteAuthority}):(0,_.$Yh)(Z.openedWorkspace)?L.push({workspace:Z.openedWorkspace,remoteAuthority:Z.remoteAuthority}):ue(this.R(F,Z,W),!0):ue(await this.jb({userEnv:F.userEnv,cli:F.cli,initialStartup:F.initialStartup,filesToOpen:W,forceNewWindow:!0,remoteAuthority:W.remoteAuthority,forceNewTabbedWindow:F.forceNewTabbedWindow,forceProfile:F.forceProfile,forceTempProfile:F.forceTempProfile}),!0)}const pe=(0,D.$Mb)(O,me=>me.workspace.id);if(pe.length>0){const me=(0,D.$Hb)(pe.map(we=>(0,z.$v6b)(this.getWindows(),we.workspace.configPath)));if(me.length>0){const we=me[0],Z=(0,m.$Ag)(W?.remoteAuthority,we.remoteAuthority)?W:void 0;ue(this.R(F,we,Z),!!Z),fe=!0}for(const we of pe){if(me.some(ge=>ge.openedWorkspace&&ge.openedWorkspace.id===we.workspace.id))continue;const Z=we.remoteAuthority,le=(0,m.$Ag)(W?.remoteAuthority,Z)?W:void 0;ue(await this.W(F,we,fe,le),!!le),fe=!0}}const Ae=(0,D.$Mb)(L,me=>m.$mg.getComparisonKey(me.workspace.uri));if(Ae.length>0){const me=(0,D.$Hb)(Ae.map(we=>(0,z.$v6b)(this.getWindows(),we.workspace.uri)));if(me.length>0){const we=me[0],Z=(0,m.$Ag)(W?.remoteAuthority,we.remoteAuthority)?W:void 0;ue(this.R(F,we,Z),!!Z),fe=!0}for(const we of Ae){if(me.some(ge=>(0,_.$Yh)(ge.openedWorkspace)&&m.$mg.isEqual(ge.openedWorkspace.uri,we.workspace.uri)))continue;const Z=we.remoteAuthority,le=(0,m.$Ag)(W?.remoteAuthority,Z)?W:void 0;ue(await this.W(F,we,fe,le),!!le),fe=!0}}const Te=(0,D.$Mb)(B,me=>me.backupFolder);if(Te.length>0)for(const me of Te){const we=me.remoteAuthority,Z=(0,m.$Ag)(W?.remoteAuthority,we)?W:void 0;ue(await this.U(F,!0,we,Z,me),!!Z),fe=!0}if(ce.length===0||W){W&&!T&&T++;const me=W?W.remoteAuthority:F.remoteAuthority;for(let we=0;we<T;we++)ue(await this.U(F,fe,me,W),!!W),fe=!0}return{windows:(0,D.$Mb)(ce),filesOpenedInWindow:de}}R(F,O,L){this.r.trace("windowsManager#doOpenFilesInExistingWindow",{filesToOpen:L}),O.focus();const B={filesToOpenOrCreate:L?.filesToOpenOrCreate,filesToDiff:L?.filesToDiff,filesToMerge:L?.filesToMerge,filesToWait:L?.filesToWait,termProgram:F?.userEnv?.TERM_PROGRAM};return O.sendWhenReady("vscode:openFiles",P.CancellationToken.None,B),O}S(F,O){this.r.trace("windowsManager#doAddFoldersToExistingWindow",{foldersToAdd:O}),F.focus();const L={foldersToAdd:O};return F.sendWhenReady("vscode:addFolders",P.CancellationToken.None,L),F}U(F,O,L,B,T){this.r.trace("windowsManager#doOpenEmpty",{restore:!!T,remoteAuthority:L,filesToOpen:B,forceNewWindow:O});let W;return!O&&typeof F.contextWindowId=="number"&&(W=this.getWindowById(F.contextWindowId)),this.jb({userEnv:F.userEnv,cli:F.cli,initialStartup:F.initialStartup,remoteAuthority:L,forceNewWindow:O,forceNewTabbedWindow:F.forceNewTabbedWindow,filesToOpen:B,windowToUse:W,emptyWindowBackupInfo:T,forceProfile:F.forceProfile,forceTempProfile:F.forceTempProfile})}W(F,O,L,B,T){return this.r.trace("windowsManager#doOpenFolderOrWorkspace",{folderOrWorkspace:O,filesToOpen:B}),!L&&!T&&typeof F.contextWindowId=="number"&&(T=this.getWindowById(F.contextWindowId)),this.jb({workspace:O.workspace,userEnv:F.userEnv,cli:F.cli,initialStartup:F.initialStartup,remoteAuthority:O.remoteAuthority,forceNewWindow:L,forceNewTabbedWindow:F.forceNewTabbedWindow,filesToOpen:B,windowToUse:T,forceProfile:F.forceProfile,forceTempProfile:F.forceTempProfile})}async X(F){let O,L=!1,B=!1;if(F.urisToOpen&&F.urisToOpen.length>0?(O=await this.Y(F),L=!0):F.forceEmpty?O=[Object.create(null)]:F.cli._.length||F.cli["folder-uri"]||F.cli["file-uri"]?(O=await this.Z(F.cli),O.length===0&&O.push(Object.create(null)),L=!0):(O=await this.ab(),O.length===0&&O.push(Object.create(null)),B=!0),!F.addMode&&L){const T=O.filter(W=>H(W));if(T.length>1){const W=T[0].remoteAuthority;if(T.every(V=>(0,m.$Ag)(V.remoteAuthority,W))){const V=await this.H.createUntitledWorkspace(T.map(ce=>({uri:ce.workspace.uri})));O.push({workspace:V,remoteAuthority:W}),O=O.filter(ce=>!H(ce))}}}if(F.initialStartup&&!B&&this.F.getValue("window")?.restoreWindows==="preserve"){const T=await this.ab();O.unshift(...T.filter(W=>X(W)||H(W)||W.backupPath))}return O}async Y(F){const O={gotoLineMode:F.gotoLineMode,remoteAuthority:F.remoteAuthority},L=await Promise.all((0,D.$Hb)(F.urisToOpen||[]).map(async B=>{const T=await this.cb(B,O);if(T)return T.label=B.label,T;const W=this.eb(B);this.J.showMessageBox({type:"info",buttons:[(0,E.localize)(0,null)],message:W.scheme===y.Schemas.file?(0,E.localize)(1,null):(0,E.localize)(2,null),detail:W.scheme===y.Schemas.file?(0,E.localize)(3,null,(0,g.$nv)(W,{os:b.OS,tildify:this.w})):(0,E.localize)(4,null,W.toString(!0))},S.BrowserWindow.getFocusedWindow()??void 0)}));return(0,D.$Hb)(L)}async Z(F){const O=[],L={ignoreFileNotFound:!0,gotoLineMode:F.goto,remoteAuthority:F.remote||void 0,forceOpenWorkspaceAsFile:F.diff&&F._.length===2||F.merge&&F._.length===4},B=F["folder-uri"];if(B){const V=await Promise.all(B.map(ce=>{const de=this.$(ce);if(de)return this.cb({folderUri:de},L)}));O.push(...(0,D.$Hb)(V))}const T=F["file-uri"];if(T){const V=await Promise.all(T.map(ce=>{const de=this.$(ce);if(de)return this.cb((0,_.$hi)(ce)?{workspaceUri:de}:{fileUri:de},L)}));O.push(...(0,D.$Hb)(V))}const W=await Promise.all(F._.map(V=>L.remoteAuthority?this.hb(V,L):this.fb(V,L)));return O.push(...(0,D.$Hb)(W)),O}$(F){try{const O=l.URI.parse(F);if(!O.scheme){this.r.error(`Invalid URI input string, scheme missing: ${F}`);return}return O.path?O:O.with({path:"/"})}catch(O){this.r.error(`Invalid URI input string: ${F}, ${O.message}`)}}async ab(){const F=this.bb();switch(F){case"none":return[];case"one":case"all":case"preserve":case"folders":{const O=[];F!=="one"&&O.push(...this.j.state.openedWindows),this.j.state.lastActiveWindow&&O.push(this.j.state.lastActiveWindow);const L=await Promise.all(O.map(async B=>{if(B.workspace){const T=await this.cb({workspaceUri:B.workspace.configPath},{remoteAuthority:B.remoteAuthority,rejectTransientWorkspaces:!0});if(X(T))return T}else if(B.folderUri){const T=await this.cb({folderUri:B.folderUri},{remoteAuthority:B.remoteAuthority});if(H(T))return T}else if(F!=="folders"&&B.backupPath)return{backupPath:B.backupPath,remoteAuthority:B.remoteAuthority}}));return(0,D.$Hb)(L)}}}bb(){let F;return this.C.wasRestarted?F="all":(F=this.F.getValue("window")?.restoreWindows||"all",["preserve","all","folders","one","none"].includes(F)||(F="all")),F}async cb(F,O=Object.create(null)){const L=this.eb(F);return L.scheme===y.Schemas.file?((0,j.$1C)(F)&&(O={...O,forceOpenWorkspaceAsFile:!0}),this.fb(L.fsPath,O)):this.db(F,O)}db(F,O){let L=this.eb(F);const B=(0,k.$Tk)(L)||O.remoteAuthority;if(L=(0,m.$Cg)((0,m.$wg)(L)),(0,j.$1C)(F)){if(O.gotoLineMode){const{path:T,line:W,column:V}=(0,a.$5f)(L.path);return{fileUri:L.with({path:T}),options:{selection:W?{startLineNumber:W,startColumn:V||1}:void 0},remoteAuthority:B}}return{fileUri:L,remoteAuthority:B}}else if((0,j.$YC)(F))return{workspace:(0,ae.$n6b)(L),remoteAuthority:B};return{workspace:(0,ae.$o6b)(L),remoteAuthority:B}}eb(F){return(0,j.$YC)(F)?F.workspaceUri:(0,j.$ZC)(F)?F.folderUri:F.fileUri}async fb(F,O,L){let B,T;O.gotoLineMode&&({path:F,line:B,column:T}=(0,a.$5f)(F)),F=(0,a.$Zf)((0,d.$hc)(F),(0,$.cwd)());try{const W=await R.Promises.stat(F);if(W.isFile()){if(!O.forceOpenWorkspaceAsFile){const V=await this.H.resolveLocalWorkspace(l.URI.file(F));if(V)return V.transient&&O.rejectTransientWorkspaces?void 0:{workspace:{id:V.id,configPath:V.configPath},type:t.FileType.File,exists:!0,remoteAuthority:V.remoteAuthority,transient:V.transient}}return{fileUri:l.URI.file(F),type:t.FileType.File,exists:!0,options:{selection:B?{startLineNumber:B,startColumn:T||1}:void 0}}}else{if(W.isDirectory())return{workspace:(0,ae.$o6b)(l.URI.file(F),W),type:t.FileType.Directory,exists:!0};if(!b.$j&&F==="/dev/null")return{fileUri:l.URI.file(F),type:t.FileType.File,exists:!0}}}catch(W){if(W.code==="ERR_UNC_HOST_NOT_ALLOWED"&&!L)return this.gb(F,O);const V=l.URI.file(F);if(this.G.removeRecentlyOpened([V]),O.ignoreFileNotFound)return{fileUri:V,type:t.FileType.File,exists:!1}}}async gb(F,O){const L=l.URI.file(F),{response:B,checkboxChecked:T}=await this.J.showMessageBox({type:"warning",buttons:[(0,E.localize)(5,null),(0,E.localize)(6,null),(0,E.localize)(7,null)],message:(0,E.localize)(8,null,L.authority),detail:(0,E.localize)(9,null,(0,g.$nv)(L,{os:b.OS,tildify:this.w})),checkboxLabel:(0,E.localize)(10,null,L.authority),cancelId:1});if(B===0)return(0,s.addUNCHostToAllowlist)(L.authority),T&&this.sendToOpeningWindow("vscode:configureAllowedUNCHost",L.authority),this.fb(F,O,!0);if(B===2)return S.shell.openExternal("https://aka.ms/vscode-windows-unc"),this.gb(F,O)}hb(F,O){const L=F.charCodeAt(0),B=O.remoteAuthority;let T,W;O.gotoLineMode&&({path:F,line:T,column:W}=(0,a.$5f)(F)),L!==47&&((0,a.$Yf)(L)&&F.charCodeAt(F.charCodeAt(1))===58&&(F=(0,a.$Rf)(F)),F=`/${F}`);const V=l.URI.from({scheme:y.Schemas.vscodeRemote,authority:B,path:F});if(F.charCodeAt(F.length-1)!==47){if((0,_.$hi)(F))return O.forceOpenWorkspaceAsFile?{fileUri:V,options:{selection:T?{startLineNumber:T,startColumn:W||1}:void 0},remoteAuthority:O.remoteAuthority}:{workspace:(0,ae.$n6b)(V),remoteAuthority:B};if(O.gotoLineMode||d.$gc.basename(F).indexOf(".")!==-1)return{fileUri:V,options:{selection:T?{startLineNumber:T,startColumn:W||1}:void 0},remoteAuthority:B}}return{workspace:(0,ae.$o6b)(V),remoteAuthority:B}}ib(F){const O=this.F.getValue("window"),L=O?.openFoldersInNewWindow||"default",B=O?.openFilesInNewWindow||"off";let T=(F.preferNewWindow||F.forceNewWindow)&&!F.forceReuseWindow;!F.forceNewWindow&&!F.forceReuseWindow&&(L==="on"||L==="off")&&(T=L==="on");let W=!1;return F.forceNewWindow||F.forceReuseWindow?W=!!F.forceNewWindow&&!F.forceReuseWindow:(b.$k?F.context===1&&(W=!0):F.context!==3&&F.context!==2&&!(F.userEnv&&F.userEnv.TERM_PROGRAM==="vscode")&&(W=!0),!F.cli.extensionDevelopmentPath&&(B==="on"||B==="off")&&(W=B==="on")),{openFolderInNewWindow:!!T,openFilesInNewWindow:W}}async openExtensionDevelopmentHostWindow(F,O){const L=(0,z.$w6b)(this.getWindows(),F);if(L)return this.C.reload(L,O.cli),L.focus(),[L];let B=O.cli["folder-uri"]||[],T=O.cli["file-uri"]||[],W=O.cli._;if(!W.length&&!B.length&&!T.length&&!O.cli.extensionTestsPath){const de=this.j.state.lastPluginDevelopmentHostWindow,ue=de?.workspace??de?.folderUri;ue&&(l.URI.isUri(ue)?ue.scheme===y.Schemas.file?W=[ue.fsPath]:B=[ue.toString()]:ue.configPath.scheme===y.Schemas.file?W=[(0,m.$jg)(ue.configPath)]:T=[ue.configPath.toString()])}let V=O.remoteAuthority;for(const de of F)if(de.match(/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/)){const ue=l.URI.parse(de),fe=(0,k.$Tk)(ue);fe&&(V?(0,m.$Ag)(fe,V)||this.r.error("more than one extension development path authority"):V=fe)}W=W.filter(de=>{const ue=l.URI.file(de);return(0,z.$v6b)(this.getWindows(),ue)?!1:(0,m.$Ag)((0,k.$Tk)(ue),V)}),B=B.filter(de=>{const ue=this.$(de);return ue&&(0,z.$v6b)(this.getWindows(),ue)?!1:ue?(0,m.$Ag)((0,k.$Tk)(ue),V):!1}),T=T.filter(de=>{const ue=this.$(de);return ue&&(0,z.$v6b)(this.getWindows(),ue)?!1:ue?(0,m.$Ag)((0,k.$Tk)(ue),V):!1}),O.cli._=W,O.cli["folder-uri"]=B,O.cli["file-uri"]=T;const ce={context:O.context,cli:O.cli,forceNewWindow:!0,forceEmpty:!W.length&&!B.length&&!T.length,userEnv:O.userEnv,noRecentEntry:!0,waitMarkerFileURI:O.waitMarkerFileURI,remoteAuthority:V,forceProfile:O.forceProfile,forceTempProfile:O.forceTempProfile};return this.open(ce)}async jb(F){const O=this.F.getValue("window"),L=this.getLastActiveWindow(),B=L?.profile??this.z.defaultProfile;let T;!F.forceNewWindow&&!F.forceNewTabbedWindow&&(T=F.windowToUse||L,T&&T.focus());const W={...this.w.args,...F.cli,machineId:this.m,windowId:-1,mainPid:process.pid,appRoot:this.w.appRoot,execPath:process.execPath,codeCachePath:this.w.codeCachePath,backupPath:F.emptyWindowBackupInfo?(0,d.$jc)(this.w.backupHome,F.emptyWindowBackupInfo.backupFolder):void 0,profiles:{home:this.z.profilesHome,all:this.z.profiles,profile:B},homeDir:this.w.userHome.with({scheme:y.Schemas.file}).fsPath,tmpDir:this.w.tmpDir.with({scheme:y.Schemas.file}).fsPath,userDataDir:this.w.userDataPath,remoteAuthority:F.remoteAuthority,workspace:F.workspace,userEnv:{...this.n,...F.userEnv},filesToOpenOrCreate:F.filesToOpen?.filesToOpenOrCreate,filesToDiff:F.filesToOpen?.filesToDiff,filesToMerge:F.filesToOpen?.filesToMerge,filesToWait:F.filesToOpen?.filesToWait,logLevel:this.s.getLogLevel(),loggers:{window:[],global:this.s.getRegisteredLoggers()},logsPath:this.w.logsHome.with({scheme:y.Schemas.file}).fsPath,product:A.default,isInitialStartup:F.initialStartup,perfMarks:(0,v.getMarks)(),os:{release:(0,M.release)(),hostname:(0,M.hostname)(),arch:(0,M.arch)()},zoomLevel:typeof O?.zoomLevel=="number"?O.zoomLevel:void 0,autoDetectHighContrast:O?.autoDetectHighContrast??!0,autoDetectColorScheme:O?.autoDetectColorScheme??!1,accessibilitySupport:S.app.accessibilitySupportEnabled,colorScheme:this.N.getColorScheme(),policiesData:this.u.serialize(),continueOn:this.w.continueOn};if(T){const V=T.config;!W.extensionDevelopmentPath&&V?.extensionDevelopmentPath&&(W.extensionDevelopmentPath=V.extensionDevelopmentPath,W.extensionDevelopmentKind=V.extensionDevelopmentKind,W["enable-proposed-api"]=V["enable-proposed-api"],W.verbose=V.verbose,W["inspect-extensions"]=V["inspect-extensions"],W["inspect-brk-extensions"]=V["inspect-brk-extensions"],W.debugId=V.debugId,W.extensionEnvironment=V.extensionEnvironment,W["extensions-dir"]=V["extensions-dir"],W["disable-extensions"]=V["disable-extensions"]),W.loggers={global:W.loggers.global,window:V?.loggers.window??W.loggers.window}}else{const V=this.j.getNewWindowState(W);(0,v.mark)("code/willCreateCodeWindow");const ce=T=this.I.createInstance(U.$u7b,{state:V,extensionDevelopmentPath:W.extensionDevelopmentPath,isExtensionTestHost:!!W.extensionTestsPath});(0,v.mark)("code/didCreateCodeWindow"),F.forceNewTabbedWindow&&this.getLastActiveWindow()?.addTabbedWindow(ce),q.a.push(ce),this.b.fire(ce),this.g.fire({oldCount:this.getWindowCount()-1,newCount:this.getWindowCount()});const de=new w.$Rc;de.add(ce.onDidSignalReady(()=>this.c.fire(ce))),de.add(f.Event.once(ce.onDidClose)(()=>this.mb(ce,de))),de.add(f.Event.once(ce.onDidDestroy)(()=>this.f.fire(ce))),de.add(ce.onDidTriggerSystemContextMenu(({x:fe,y:ye})=>this.h.fire({window:ce,x:fe,y:ye})));const ue=(0,u.$Jf)(ce.win?.webContents);ue.removeAllListeners("devtools-reload-page"),ue.on("devtools-reload-page",()=>this.C.reload(ce)),this.C.registerWindow(ce)}return W.windowId=T.id,T.isReady?this.C.unload(T,4).then(async V=>{V||await this.kb(T,W,F,B)}):await this.kb(T,W,F,B),T}async kb(F,O,L,B){if(O.extensionDevelopmentPath||((0,_.$4h)(O.workspace)?O.backupPath=this.D.registerWorkspaceBackup({workspace:O.workspace,remoteAuthority:O.remoteAuthority}):(0,_.$Yh)(O.workspace)?O.backupPath=this.D.registerFolderBackup({folderUri:O.workspace.uri,remoteAuthority:O.remoteAuthority}):O.backupPath=this.D.registerEmptyWindowBackup({backupFolder:L.emptyWindowBackupInfo?.backupFolder??(0,ae.$p6b)().id,remoteAuthority:O.remoteAuthority})),this.z.isEnabled()){const T=O.workspace??(0,_.$3h)(O.backupPath,!1),W=this.lb(L,T,B),V=W instanceof Promise?await W:W;O.profiles.profile=V,O.extensionDevelopmentPath||await this.z.setProfileForWorkspace(T,V)}F.load(O)}lb(F,O,L){return F.forceProfile?this.z.profiles.find(B=>B.name===F.forceProfile)??this.z.createNamedProfile(F.forceProfile):F.forceTempProfile?this.z.createTransientProfile():this.z.getProfileForWorkspace(O)??L}mb(F,O){const L=q.a.indexOf(F);q.a.splice(L,1),this.g.fire({oldCount:this.getWindowCount()+1,newCount:this.getWindowCount()}),O.dispose()}getFocusedWindow(){const F=S.BrowserWindow.getFocusedWindow();if(F)return this.getWindowById(F.id)}getLastActiveWindow(){return this.ob(this.getWindows())}nb(F){return this.ob(this.getWindows().filter(O=>(0,m.$Ag)(O.remoteAuthority,F)))}ob(F){const O=Math.max.apply(Math,F.map(L=>L.lastFocusTime));return F.find(L=>L.lastFocusTime===O)}sendToFocused(F,...O){(this.getFocusedWindow()||this.getLastActiveWindow())?.sendWhenReady(F,P.CancellationToken.None,...O)}sendToOpeningWindow(F,...O){this.B(f.Event.once(this.onDidSignalReadyWindow)(L=>{L.sendWhenReady(F,P.CancellationToken.None,...O)}))}sendToAll(F,O,L){for(const B of this.getWindows())L&&L.indexOf(B.id)>=0||B.sendWhenReady(F,P.CancellationToken.None,O)}getWindows(){return q.a}getWindowCount(){return q.a.length}getWindowById(F){const O=this.getWindows().filter(L=>L.id===F);return(0,D.$Ob)(O)}getWindowByWebContents(F){const O=S.BrowserWindow.fromWebContents(F);if(O)return this.getWindowById(O.id)}};e.$y7b=Y,e.$y7b=Y=q=ke([ee(2,p.$9i),ee(3,N.$96b),ee(4,I.$rN),ee(5,J.$fn),ee(6,o.$25b),ee(7,G.$05b),ee(8,r.$45b),ee(9,h.$l6b),ee(10,i.$ii),ee(11,se.$46b),ee(12,oe.$x6b),ee(13,n.$Nh),ee(14,c.$s6b),ee(15,t.$0j),ee(16,C.$S6b),ee(17,K.$d6b)],Y)}),define(te[305],ie([0,1,63,30,82,53]),function(Q,e,S,R,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$A7b=void 0;let D=class{constructor(f,a,g,w){this.a=f,this.b=a,this.c=g,this.d=w,this.onDidChangeRecentlyOpened=this.c.onDidChangeRecentlyOpened}async enterWorkspace(f,a){const g=this.b.getWindowById(f);if(g)return this.a.enterWorkspace(g,this.b.getWindows(),a)}createUntitledWorkspace(f,a,g){return this.a.createUntitledWorkspace(a,g)}deleteUntitledWorkspace(f,a){return this.a.deleteUntitledWorkspace(a)}getWorkspaceIdentifier(f,a){return this.a.getWorkspaceIdentifier(a)}getRecentlyOpened(f){return this.c.getRecentlyOpened()}addRecentlyOpened(f,a){return this.c.addRecentlyOpened(a)}removeRecentlyOpened(f,a){return this.c.removeRecentlyOpened(a)}clearRecentlyOpened(f){return this.c.clearRecentlyOpened()}async getDirtyWorkspaces(){return this.d.getDirtyWorkspaces()}};e.$A7b=D,e.$A7b=D=ke([ee(0,M.$x6b),ee(1,R.$f6b),ee(2,s.$46b),ee(3,S.$l6b)],D)}),define(te[306],ie([0,1,15,130,38,28,17,49,14,33,3,44,46,2,13,9,4,12,7,32,156,42,157,110,288,160,63,281,18,198,90,131,59,116,218,25,62,93,207,291,209,210,211,16,222,92,77,6,91,217,298,282,289,20,5,303,69,24,58,292,94,34,273,81,122,26,249,251,51,48,263,286,299,287,300,127,265,266,267,270,295,30,304,272,29,97,82,305,53,39,231,52,242,50,80,128,275,290,278,8,253,274,226,66,294,269,23,125,293,261,237,71,296]),function(Q,e,S,R,s,M,D,P,f,a,g,w,y,d,v,b,$,m,u,l,E,h,i,c,o,t,n,r,p,A,C,k,I,j,U,z,ne,_,ae,se,oe,K,J,G,N,q,X,H,Y,re,F,O,L,B,T,W,V,ce,de,ue,fe,ye,be,pe,Ae,Te,me,we,Z,le,ge,Ce,De,Ue,Oe,ze,We,x,he,$e,ve,Re,Fe,je,Ne,Be,He,Ge,xe,Ze,it,nt,mt,wt,bt,pt,yt,vt,kt,rt,Et,St,Pt,It,ot,At,ht,at,Ct,Dt,ct,Rt,ft){"use strict";var lt;Object.defineProperty(e,"__esModule",{value:!0}),e.$R7b=void 0;let ut=class extends d.$Sc{static{lt=this}static{this.a={[v.Schemas.file]:"security.promptForLocalFileProtocolHandling",[v.Schemas.vscodeRemote]:"security.promptForRemoteFileProtocolHandling"}}constructor(Pe,Ie,Ee,Se,Me,Le,qe,Qe,Ke,Ve,Je,Xe){super(),this.f=Pe,this.g=Ie,this.h=Ee,this.j=Se,this.m=Me,this.n=Le,this.s=qe,this.t=Qe,this.u=Ke,this.w=Ve,this.y=Je,this.z=Xe,this.C(),this.D()}C(){const Pe=Ve=>Ve?.startsWith(`${v.Schemas.vscodeWebview}://`),Ie=new Set(this.y.quality==="stable"?[]:["media"]),Ee=new Set(["clipboard-read","clipboard-sanitized-write"]);S.session.defaultSession.setPermissionRequestHandler((Ve,Je,Xe,Ye)=>Pe(Ye.requestingUrl)?Xe(Ee.has(Je)):Ye.isMainFrame&&Ye.securityOrigin===`${v.Schemas.vscodeFileResource}://${v.$bg}/`?Xe(Ie.has(Je)):Xe(!1)),S.session.defaultSession.setPermissionCheckHandler((Ve,Je,Xe,Ye)=>Pe(Ye.requestingUrl)?Ee.has(Je):Ye.isMainFrame&&Ye.securityOrigin===`${v.Schemas.vscodeFileResource}://${v.$bg}/`?Ie.has(Je):!1);const Se=new Set([v.Schemas.file,v.Schemas.vscodeFileResource,v.Schemas.vscodeRemoteResource,v.Schemas.vscodeManagedRemoteResource,"devtools"]),Me=Ve=>{for(let Je=Ve;Je;Je=Je.parent)if(Je.url.startsWith(`${v.Schemas.vscodeWebview}://`))return!0;return!1},Le=Ve=>Ve.resourceType==="xhr"||Me(Ve.frame),qe=Ve=>{const Je=Ve.frame;if(!Je||!this.b)return!1;const Xe=S.BrowserWindow.getAllWindows();for(const Ye of Xe)if(Je.processId===Ye.webContents.mainFrame.processId)return!0;return!1},Qe=(Ve,Je)=>{if(Ve.path!=="/index.html")return!0;const Xe=Je.frame;if(!Xe||!this.b)return!1;for(const Ye of this.b.getWindows())if(Ye.win&&Xe.processId===Ye.win.webContents.mainFrame.processId)return!0;return!1};S.session.defaultSession.webRequest.onBeforeRequest((Ve,Je)=>{const Xe=u.URI.parse(Ve.url);return Xe.scheme===v.Schemas.vscodeWebview&&!Qe(Xe,Ve)?(this.j.error("Blocked vscode-webview request",Ve.url),Je({cancel:!0})):Xe.scheme===v.Schemas.vscodeFileResource&&!qe(Ve)?(this.j.error("Blocked vscode-file request",Ve.url),Je({cancel:!0})):Xe.path.endsWith(".svg")&&!Se.has(Xe.scheme)?Je({cancel:!Le(Ve)}):Je({cancel:!1})}),S.session.defaultSession.webRequest.onHeadersReceived((Ve,Je)=>{const Xe=Ve.responseHeaders,Ye=Xe["content-type"]||Xe["Content-Type"];if(Ye&&Array.isArray(Ye)){const _e=u.URI.parse(Ve.url);if(_e.path.endsWith(".svg")&&Se.has(_e.scheme))return Xe["Content-Type"]=["image/svg+xml"],Je({cancel:!1,responseHeaders:Xe});if(!_e.path.endsWith(v.Schemas.vscodeRemoteResource)&&Ye.some(et=>et.toLowerCase().includes("image/svg")))return Je({cancel:!Le(Ve)})}return Je({cancel:!1})});const Ke=S.session.defaultSession;typeof Ke.setCodeCachePath=="function"&&this.n.codeCachePath&&Ke.setCodeCachePath((0,b.$jc)(this.n.codeCachePath,"chrome")),$.$j&&(this.t.getValue("security.restrictUNCAccess")===!1?(0,R.disableUNCAccessRestrictions)():(0,R.addUNCHostToAllowlist)(this.t.getValue("security.allowedUNCHosts")))}D(){(0,f.setUnexpectedErrorHandler)(Ee=>this.G(Ee)),process.on("uncaughtException",Ee=>{(0,f.$Z)(Ee)||(0,f.$1)(Ee)}),process.on("unhandledRejection",Ee=>(0,f.$1)(Ee)),this.s.onWillShutdown(()=>this.dispose()),(0,E.$fT)(),S.app.on("accessibility-support-changed",(Ee,Se)=>{this.b?.sendToAll("vscode:accessibilitySupportChanged",Se)}),S.app.on("activate",async(Ee,Se)=>{this.j.trace("app#activate"),Se||await this.b?.openEmptyWindow({context:1})}),S.app.on("web-contents-created",(Ee,Se)=>{Se?.opener?.url.startsWith(`${v.Schemas.vscodeFileResource}://${v.$bg}/`)&&this.h.createInstance(ft.$Q7b,Se),Se.on("will-navigate",Le=>{this.j.error("webContents#will-navigate: Prevented webcontent navigation"),Le.preventDefault()}),Se.setWindowOpenHandler(Le=>Le.url==="about:blank"?(this.j.trace("webContents#setWindowOpenHandler: Allowing about:blank window to open"),{action:"allow",overrideBrowserWindowOptions:ft.$Q7b.open(this.h)}):(this.j.trace(`webContents#setWindowOpenHandler: Prevented opening window with URL ${Le.url}}`),this.c?.openExternal(void 0,Le.url),{action:"deny"}))});let Pe=[],Ie;S.app.on("open-file",(Ee,Se)=>{this.j.trace("app#open-file: ",Se),Ee.preventDefault(),Pe.push((0,Ne.$hi)(Se)?{workspaceUri:u.URI.file(Se)}:{fileUri:u.URI.file(Se)}),Ie!==void 0&&(clearTimeout(Ie),Ie=void 0),Ie=setTimeout(async()=>{await this.b?.open({context:1,cli:this.n.args,urisToOpen:Pe,gotoLineMode:!1,preferNewWindow:!0}),Pe=[],Ie=void 0},100)}),S.app.on("new-window-for-tab",async()=>{await this.b?.openEmptyWindow({context:4})}),s.$eT.handle("vscode:fetchShellEnv",Ee=>{const Se=this.b?.getWindowByWebContents(Ee.sender);let Me,Le;return Se?.config?(Me=Se.config,Le={...process.env,...Se.config.userEnv}):(Me=this.n.args,Le=process.env),this.W(Me,Le,!1)}),s.$eT.handle("vscode:writeNlsFile",(Ee,Se,Me)=>{const Le=this.F([Se]);if(!Le||typeof Me!="string")throw new Error("Invalid operation (vscode:writeNlsFile)");return this.w.writeFile(Le,D.$be.fromString(Me))}),s.$eT.handle("vscode:readNlsFile",async(Ee,...Se)=>{const Me=this.F(Se);if(!Me)throw new Error("Invalid operation (vscode:readNlsFile)");return(await this.w.readFile(Me)).value.toString()}),s.$eT.on("vscode:toggleDevTools",Ee=>Ee.sender.toggleDevTools()),s.$eT.on("vscode:openDevTools",Ee=>Ee.sender.openDevTools()),s.$eT.on("vscode:reloadWindow",Ee=>Ee.sender.reload())}F(Pe){let Ie;for(const Ee of Pe)typeof Ee=="string"&&(typeof Ie!="string"?Ie=Ee:Ie=(0,b.$jc)(Ie,Ee));if(!(typeof Ie!="string"||!(0,b.$ic)(Ie)||!(0,a.$Xf)(Ie,this.n.cachedLanguagesPath,!$.$l)))return u.URI.file(Ie)}G(Pe){if(Pe){const Ie={message:`[uncaught exception in main]: ${Pe.message}`,stack:Pe.stack};this.b?.sendToFocused("vscode:reportError",JSON.stringify(Ie))}this.j.error(`[uncaught exception in main]: ${Pe}`),Pe.stack&&this.j.error(Pe.stack)}async startup(){this.j.debug("Starting VS Code"),this.j.debug(`from: ${this.n.appRoot}`),this.j.debug("args:",this.n.args);const Pe=this.y.win32AppUserModelId;$.$j&&Pe&&S.app.setAppUserModelId(Pe);try{$.$k&&this.t.getValue("window.nativeTabs")===!0&&!S.systemPreferences.getUserDefault("NSUseImprovedLayoutPass","boolean")&&S.systemPreferences.setUserDefault("NSUseImprovedLayoutPass","boolean",!0)}catch(Ke){this.j.error(Ke)}const Ie=new i.$lT;this.s.onWillShutdown(Ke=>{Ke.reason===2&&Ie.dispose()}),this.j.trace("Resolving machine identifier...");const Ee=await(0,Et.$H7b)(this.u,this.j);this.j.trace(`Resolved machine identifier: ${Ee}`);const{sharedProcessReady:Se,sharedProcessClient:Me}=this.O(Ee),Le=await this.P(Ee,Se);this.B(Le.createInstance(o.$h6b)),this.B(Le.createInstance(vt.$E7b)),Le.invokeFunction(Ke=>this.Q(Ke,Ie,Me));const qe=await Le.invokeFunction(Ke=>this.H(Ke,Ie));this.I(Ie),this.s.phase=2,await Le.invokeFunction(Ke=>this.R(Ke,qe)),this.s.phase=3,this.S(),this.B(new rt.$6g(()=>{this.B((0,rt.$0g)(()=>this.s.phase=4,2500))},2500)).schedule()}async H(Pe,Ie){const Ee=this.b=Pe.get(Re.$f6b),Se=Pe.get(ze.$5T),Me=this.c=Pe.get(V.$Q6b),Le=Pe.get(I.$s6b),qe=this;Se.registerHandler({async handleURL(Ye,_e){return qe.N(Ee,Le,Se,Ye,_e)}});const Qe=this.B(new je.$z7b({onDidOpenWindow:Me.onDidOpenWindow,onDidFocusWindow:Me.onDidFocusWindow,getActiveWindowId:()=>Me.getActiveWindowId(-1)})),Ke=new h.$wh(Ye=>Qe.getActiveClientId().then(_e=>Ye===_e)),Ve=new We.$p7b(Ke,this.j),Je=Ie.getChannel("urlHandler",Ve);Se.registerHandler(new We.$o7b(Je));const Xe=await this.J(Ee,Le);return this.B(new he.$q7b(Xe?.urls,Se,Ee,this.n,this.y,this.j)),Xe}I(Pe){const Ie=()=>({statusCode:404,data:"Not found"}),Ee=new Rt.$V(()=>Pe.getChannel(ct.$O7b,new ct.$P7b));S.protocol.registerBufferProtocol(v.Schemas.vscodeManagedRemoteResource,(Se,Me)=>{const Le=u.URI.parse(Se.url);if(!Le.authority.startsWith("window:"))return Me(Ie());Ee.value.call(ct.$N7b,[Le]).then(qe=>Me({...qe,data:Buffer.from(qe.body,"base64")}),qe=>{this.j.warn("error dispatching remote resource call",qe),Me({statusCode:500,data:String(qe)})})})}async J(Pe,Ie){const Ee=this.n.args["open-url"]?this.n.args._urls||[]:[];Ee.length>0&&this.j.trace("app#resolveInitialProtocolUrls() protocol urls from command line:",Ee);const Se=global.getOpenUrls()||[];if(Se.length>0&&this.j.trace("app#resolveInitialProtocolUrls() protocol urls from macOS 'open-url' event:",Se),Ee.length+Se.length===0)return;const Me=[...Ee,...Se].map(Qe=>{try{return{uri:u.URI.parse(Qe),originalUrl:Qe}}catch{this.j.trace("app#resolveInitialProtocolUrls() protocol url failed to parse:",Qe);return}}),Le=[],qe=[];for(const Qe of Me){if(!Qe)continue;if(await this.L(Qe.uri,Pe,Ie)){this.j.trace("app#resolveInitialProtocolUrls() protocol url was blocked:",Qe.uri.toString(!0));continue}const Ke=this.M(Qe.uri);Ke?(this.j.trace("app#resolveInitialProtocolUrls() protocol url will be handled as window to open:",Qe.uri.toString(!0),Ke),Le.push(Ke)):(this.j.trace("app#resolveInitialProtocolUrls() protocol url will be passed to active window for handling:",Qe.uri.toString(!0)),qe.push(Qe))}return{urls:qe,openables:Le}}async L(Pe,Ie,Ee){if(Pe.authority!==v.Schemas.file&&Pe.authority!==v.Schemas.vscodeRemote||this.t.getValue(lt.a[Pe.authority])===!1)return!1;const{response:Me,checkboxChecked:Le}=await Ee.showMessageBox({type:"warning",buttons:[(0,t.localize)(0,null),(0,t.localize)(1,null)],message:(0,t.localize)(2,null,Pe.authority===v.Schemas.file?(0,y.$nv)(Pe,{os:$.OS,tildify:this.n}):Pe.toString(!0),this.y.nameShort),detail:(0,t.localize)(3,null),checkboxLabel:(0,t.localize)(4,null),cancelId:1});return Me!==0?!0:(Le&&Ie.sendToOpeningWindow("vscode:disablePromptForProtocolHandling",Pe.authority===v.Schemas.file?"local":"remote"),!1)}M(Pe){if(Pe.path){if(Pe.authority===v.Schemas.file){const Ie=u.URI.file(Pe.fsPath);return(0,Ne.$hi)(Ie)?{workspaceUri:Ie}:{fileUri:Ie}}else if(Pe.authority===v.Schemas.vscodeRemote){const Ie=Pe.path.indexOf(b.$gc.sep,1);if(Ie!==-1){const Ee=Pe.path.substring(1,Ie),Se=Pe.path.substring(Ie);let Me=Pe.query;const Le=new URLSearchParams(Pe.query);Le.get("windowId")==="_blank"&&(Le.delete("windowId"),Me=Le.toString());const qe=u.URI.from({scheme:v.Schemas.vscodeRemote,authority:Ee,path:Se,query:Me,fragment:Pe.fragment});return(0,Ne.$hi)(Se)?{workspaceUri:qe}:/:[\d]+$/.test(Se)?{fileUri:qe}:{folderUri:qe}}}}}async N(Pe,Ie,Ee,Se,Me){if(this.j.trace("app#handleProtocolUrl():",Se.toString(!0),Me),Se.scheme===this.y.urlProtocol&&Se.path==="workspace"&&(Se=Se.with({authority:"file",path:u.URI.parse(Se.query).path,query:""})),await this.L(Se,Pe,Ie))return this.j.trace("app#handleProtocolUrl() protocol url was blocked:",Se.toString(!0)),!0;let Le=!1;const qe=new URLSearchParams(Se.query);qe.get("windowId")==="_blank"?(this.j.trace("app#handleProtocolUrl() found 'windowId=_blank' as parameter, setting shouldOpenInNewWindow=true:",Se.toString(!0)),qe.delete("windowId"),Se=Se.with({query:qe.toString()}),Le=!0):$.$k&&Pe.getWindowCount()===0&&(this.j.trace("app#handleProtocolUrl() running on macOS with no window open, setting shouldOpenInNewWindow=true:",Se.toString(!0)),Le=!0);const Qe=qe.get("continueOn");Qe!==null&&(this.j.trace("app#handleProtocolUrl() found 'continueOn' as parameter:",Se.toString(!0)),qe.delete("continueOn"),Se=Se.with({query:qe.toString()}),this.n.continueOn=Qe??void 0);const Ke=this.M(Se);return Ke?(this.j.trace("app#handleProtocolUrl() opening protocol url as window:",Ke,Se.toString(!0)),(0,ht.$Ob)(await Pe.open({context:5,cli:{...this.n.args},urisToOpen:[Ke],forceNewWindow:Le,gotoLineMode:!0}))?.focus(),!0):Le?(this.j.trace("app#handleProtocolUrl() opening empty window and passing in protocol url:",Se.toString(!0)),await(0,ht.$Ob)(await Pe.open({context:5,cli:{...this.n.args},forceNewWindow:!0,forceEmpty:!0,gotoLineMode:!0,remoteAuthority:(0,de.$Tk)(Se)}))?.ready(),Ee.open(Se,Me)):(this.j.trace("app#handleProtocolUrl(): not handled",Se.toString(!0),Me),!1)}O(Pe){const Ie=this.B(this.h.createInstance(ue.$b7b,Pe)),Ee=(async()=>{this.j.trace("Main->SharedProcess#connect");const Me=await Ie.connect();return this.j.trace("Main->SharedProcess#connect: connection established"),new c.$mT(Me,"main")})();return{sharedProcessReady:(async()=>(await Ie.whenReady(),Ee))(),sharedProcessClient:Ee}}async P(Pe,Ie){const Ee=new Y.$Mh;switch(process.platform){case"win32":Ee.set(le.$eU,new X.$Lh(Oe.$m7b));break;case"linux":$.$m?Ee.set(le.$eU,new X.$Lh(Ue.$l7b,[process.env.SNAP,process.env.SNAP_REVISION])):Ee.set(le.$eU,new X.$Lh(De.$k7b));break;case"darwin":Ee.set(le.$eU,new X.$Lh(Ce.$j7b));break}Ee.set(Re.$f6b,new X.$Lh(Fe.$y7b,[Pe,this.g],!1));const Se=new I.$t6b(this.j,this.y);Ee.set(I.$s6b,Se),Ee.set(L.$X6b,new X.$Lh(L.$Y6b,void 0,!1)),Ee.set(k.$C6b,new X.$Lh(k.$D6b,void 0,!1)),Ee.set(C.$om,h.ProxyChannel.toService((0,h.$uh)(Ie.then(Ke=>Ke.getChannel("diagnostics"))))),Ee.set(re.$Wwb,new X.$Lh(F.$T6b,[this.g])),Ee.set(j.$YT,new X.$Lh(U.$E6b)),Ee.set(O.$U6b,new X.$Lh(O.$V6b)),Ee.set(V.$Q6b,new X.$Lh(V.$R6b,void 0,!1)),Ee.set($e.$r7b,new X.$Lh(ve.$t7b)),Ee.set(W.$76b,new X.$Lh(W.$86b)),Ee.set(ae.$F6b,new X.$Lh(se.$H6b)),Ee.set(pe.$_5b,new X.$Lh(pe.$a6b)),Ee.set(pe.$b6b,new X.$Lh(pe.$c6b));const Me=new Ct.$M7b({graceTime:6e4,shortGraceTime:6e3,scrollback:this.t.getValue("terminal.integrated.persistentSessionScrollback")??100},this.t,this.n,this.s,this.j),Le=new Dt.$tr(Me,this.t,this.j,this.m);Ee.set(at.$7q,Le),$.$j?Ee.set(oe.$I6b,new X.$Lh(K.$J6b)):$.$k?Ee.set(oe.$I6b,new X.$Lh(K.$K6b)):$.$l&&Ee.set(oe.$I6b,new X.$Lh(K.$L6b));const qe=new r.$q6b(this.n,this.t,this.j,this.u);Ee.set(n.$l6b,qe);const Qe=new xe.$y6b(this.n,this.j,this.z,qe,Se);if(Ee.set(xe.$x6b,Qe),Ee.set(Be.$BU,new X.$Lh(Ge.$A7b,void 0,!1)),Ee.set(He.$46b,new X.$Lh(He.$56b,void 0,!1)),Ee.set(ze.$5T,new X.$Lh(x.$7T,void 0,!1)),(0,Z.$po)(this.y,this.n)){const Ke=(0,Z.$uo)(this.y,this.t),Ve=(0,h.$uh)(Ie.then(et=>et.getChannel("telemetryAppender"))),Je=new me.$e7b(Ve),Xe=(0,Ae.$fo)((0,M.release)(),(0,M.hostname)(),process.arch,this.y.commit,this.y.version,Pe,Ke),Ye=(0,Z.$vo)(this.n),_e={appenders:[Je],commonProperties:Xe,piiPaths:Ye,sendErrorTelemetry:!0};Ee.set(Te.$bl,new X.$Lh(we.$Yq,[_e],!1))}else Ee.set(Te.$bl,Z.$jo);return Ee.set(bt.$sp,new X.$Lh(St.$yN,void 0,!0)),Ee.set(pt.$wp,new X.$Lh(yt.$D7b,void 0,!0)),Ee.set(ot.$K7b,new X.$Lh(ot.$L7b,void 0,!0)),await rt.Promises.settled([qe.initialize(),Qe.initialize()]),this.h.createChild(Ee)}Q(Pe,Ie,Ee){const Se=this.B(new d.$Rc),Me=h.ProxyChannel.fromService(Pe.get(L.$X6b),Se,{disableMarshalling:!0});this.f.registerChannel("launch",Me);const Le=h.ProxyChannel.fromService(Pe.get(k.$C6b),Se,{disableMarshalling:!0});this.f.registerChannel("diagnostics",Le);const qe=new it.$B7b(Pe.get(Ze.$fn));Ie.registerChannel("policy",qe),Ee.then(tt=>tt.registerChannel("policy",qe));const Qe=this.w.getProvider(v.Schemas.file);(0,m.$If)(Qe instanceof q.$$p);const Ke=new N.$M6b(Qe,this.j,this.n);Ie.registerChannel(J.$hN,Ke),Ee.then(tt=>tt.registerChannel(J.$hN,Ke));const Ve=h.ProxyChannel.fromService(Pe.get(nt.$05b),Se);Ie.registerChannel("userDataProfiles",Ve),Ee.then(tt=>tt.registerChannel("userDataProfiles",Ve));const Je=new mt.$Tq(Pe.get(wt.$Qo));Ee.then(tt=>tt.registerChannel("request",Je));const Xe=new ge.$f7b(Pe.get(le.$eU));Ie.registerChannel("update",Xe);const Ye=h.ProxyChannel.fromService(Pe.get(re.$Wwb),Se);Ie.registerChannel("issue",Ye);const _e=h.ProxyChannel.fromService(Pe.get(j.$YT),Se);Ie.registerChannel("encryption",_e);const et=h.ProxyChannel.fromService(Pe.get(fe.$2k),Se);Ie.registerChannel("sign",et);const st=h.ProxyChannel.fromService(Pe.get(O.$U6b),Se);Ie.registerChannel("keyboardLayout",st),this.c=Pe.get(V.$Q6b);const dt=h.ProxyChannel.fromService(this.c,Se);Ie.registerChannel("nativeHost",dt),Ee.then(tt=>tt.registerChannel("nativeHost",dt));const Ot=h.ProxyChannel.fromService(Pe.get(Be.$BU),Se);Ie.registerChannel("workspaces",Ot);const Mt=h.ProxyChannel.fromService(Pe.get(W.$76b),Se);Ie.registerChannel("menubar",Mt);const jt=h.ProxyChannel.fromService(Pe.get(ze.$5T),Se);Ie.registerChannel("url",jt);const Lt=h.ProxyChannel.fromService(Pe.get($e.$r7b),Se);Ie.registerChannel("webview",Lt);const gt=this.B(new be.$c7b(this.j,Pe.get(pe.$_5b)));Ie.registerChannel("storage",gt),Ee.then(tt=>tt.registerChannel("storage",gt));const Nt=this.B(new kt.$F7b(Pe.get(pe.$_5b),Pe.get(nt.$05b),this.j));Ee.then(tt=>tt.registerChannel("profileStorageListener",Nt));const Ut=h.ProxyChannel.fromService(Pe.get(at.$7q),Se);Ie.registerChannel(at.TerminalIpcChannels.LocalPty,Ut);const Ft=h.ProxyChannel.fromService(Pe.get(oe.$I6b),Se);Ie.registerChannel("externalTerminal",Ft);const $t=new Pt.$I7b(Pe.get(It.$96b));Ie.registerChannel("logger",$t),Ee.then(tt=>tt.registerChannel("logger",$t));const Tt=new A.$r6b(Pe.get(Re.$f6b));Ie.registerChannel("extensionhostdebugservice",Tt);const Wt=h.ProxyChannel.fromService(Pe.get(ae.$F6b),Se);Ie.registerChannel(ae.$G6b,Wt);const zt=h.ProxyChannel.fromService(Pe.get(ot.$K7b),Se);Ie.registerChannel(At.$J7b,zt)}async R(Pe,Ie){const Ee=this.b=Pe.get(Re.$f6b),Se=(0,ne.$Ll)(process.env)?0:4,Me=this.n.args;if(Ie){if(Ie.openables.length>0)return Ee.open({context:Se,cli:Me,urisToOpen:Ie.openables,gotoLineMode:!0,initialStartup:!0});if(Ie.urls.length>0)for(const et of Ie.urls){const st=new URLSearchParams(et.uri.query);if(st.get("windowId")==="_blank")return st.delete("windowId"),et.originalUrl=et.uri.toString(!0),et.uri=et.uri.with({query:st.toString()}),Ee.open({context:Se,cli:Me,forceNewWindow:!0,forceEmpty:!0,gotoLineMode:!0,initialStartup:!0})}}const Le=global.macOpenFiles,qe=Me._.length,Qe=!!Me["folder-uri"],Ke=!!Me["file-uri"],Ve=Me["skip-add-to-recently-opened"]===!0,Je=Me.wait&&Me.waitMarkerFilePath?u.URI.file(Me.waitMarkerFilePath):void 0,Xe=Me.remote||void 0,Ye=Me.profile,_e=Me["profile-temp"];if(!qe&&!Qe&&!Ke){if(Me["new-window"]||Ye||_e)return Ee.open({context:Se,cli:Me,forceNewWindow:!0,forceEmpty:!0,noRecentEntry:Ve,waitMarkerFileURI:Je,initialStartup:!0,remoteAuthority:Xe,forceProfile:Ye,forceTempProfile:_e});if(Le.length)return Ee.open({context:1,cli:Me,urisToOpen:Le.map(et=>(0,Ne.$hi)(et)?{workspaceUri:u.URI.file(et)}:{fileUri:u.URI.file(et)}),noRecentEntry:Ve,waitMarkerFileURI:Je,initialStartup:!0})}return Ee.open({context:Se,cli:Me,forceNewWindow:Me["new-window"]||!qe&&Me["unity-launch"],diffMode:Me.diff,mergeMode:Me.merge,noRecentEntry:Ve,waitMarkerFileURI:Je,gotoLineMode:Me.goto,initialStartup:!0,remoteAuthority:Xe,forceProfile:Ye,forceTempProfile:_e})}S(){this.U(),S.protocol.registerHttpProtocol(v.Schemas.vscodeRemoteResource,(Pe,Ie)=>{Ie({url:Pe.url.replace(/^vscode-remote-resource:/,"http:"),method:Pe.method})}),this.W(this.n.args,process.env,!0),this.X(),$.$k&&S.app.runningUnderARM64Translation&&this.b?.sendToFocused("vscode:showTranslatedBuildWarning")}async U(){const Pe=this.y.win32MutexName;if($.$j&&Pe)try{const Ie=await new Promise((Se,Me)=>{Q(["@vscode/windows-mutex"],Se,Me)}),Ee=new Ie.Mutex(Pe);g.Event.once(this.s.onWillShutdown)(()=>Ee.release())}catch(Ie){this.j.error(Ie)}}async W(Pe,Ie,Ee){try{return await(0,_.$Rl)(this.t,this.j,Pe,Ie)}catch(Se){const Me=(0,P.$zi)(Se);Ee?this.b?.sendToFocused("vscode:showResolveShellEnvError",Me):this.j.error(Me)}return{}}async X(){try{const Ie=(await this.w.readFile(this.n.argvResource)).value.toString(),Ee=JSON.parse((0,w.$2m)(Ie)),Me=(0,Z.$ro)(this.t)>=1;if(Ee["enable-crash-reporter"]===void 0){const Le=["","	// Allows to disable crash reporting.","	// Should restart the app if the value is changed.",`	"enable-crash-reporter": ${Me},`,"","	// Unique id used for correlating crash reports sent from this instance.","	// Do not edit this value.",`	"crash-reporter-id": "${(0,l.$eg)()}"`,"}"],qe=Ie.substring(0,Ie.length-2).concat(`,
`,Le.join(`
`));await this.w.writeFile(this.n.argvResource,D.$be.fromString(qe))}else{const Le=Ie.replace(/"enable-crash-reporter": .*,/,`"enable-crash-reporter": ${Me},`);Le!==Ie&&await this.w.writeFile(this.n.argvResource,D.$be.fromString(Le))}}catch(Pe){this.j.error(Pe)}}};e.$R7b=ut,e.$R7b=ut=lt=ke([ee(2,H.$Nh),ee(3,T.$9i),ee(4,T.$0i),ee(5,z.$25b),ee(6,B.$45b),ee(7,p.$ii),ee(8,ye.$rN),ee(9,G.$0j),ee(10,ce.$oj),ee(11,nt.$05b)],ut)}),define(te[312],ie([0,1,15,45,7,23,8,49,14,33,3,46,13,9,65,4,35,27,21,42,99,306,10,18,236,248,25,62,200,16,220,92,77,216,91,20,223,5,78,24,79,276,126,285,50,284,94,247,34,51,67,52,39,232,230,2,40,264,66,225,115,121,268,262]),function(Q,e,S,R,s,M,D,P,f,a,g,w,y,d,v,b,$,m,u,l,E,h,i,c,o,t,n,r,p,A,C,k,I,j,U,z,ne,_,ae,se,oe,K,J,G,N,q,X,H,Y,re,F,O,L,B,T,W,V,ce,de,ue,fe,ye,be){"use strict";Object.defineProperty(e,"__esModule",{value:!0});class pe{main(){try{this.a()}catch(me){console.error(me.message),S.app.exit(1)}}async a(){(0,f.setUnexpectedErrorHandler)(Oe=>console.error(Oe));const[me,we,Z,le,ge,Ce,De,Ue]=this.b();try{try{await this.d(Z,Ue,le,ge,De)}catch(Oe){throw this.f(Z,De,Oe),Oe}await me.invokeFunction(async Oe=>{const ze=Oe.get(_.$9i),We=Oe.get(z.$45b),x=Oe.get(A.$0j),he=Oe.get(_.$0i),$e=await this.e(ze,Z,We,me,De,!0);return u.Promises.writeFile(Z.mainLockfile,String(process.pid)).catch(ve=>{ze.warn(`app#startup(): Error writing main lockfile: ${ve.stack}`)}),Ce.logger=he.createLogger("main",{name:(0,i.localize)(0,null)}),g.Event.once(We.onWillShutdown)(ve=>{x.dispose(),le.dispose(),ve.join("instanceLockfile",u.Promises.unlink(Z.mainLockfile).catch(()=>{}))}),me.createInstance(h.$R7b,$e,we).startup()})}catch(Oe){me.invokeFunction(this.i,Oe)}}b(){const me=new U.$Mh,we=new W.$Rc;process.once("exit",()=>we.dispose());const Z={_serviceBrand:void 0,...ae.default};me.set(se.$oj,Z);const le=new n.$35b(this.j(),Z),ge=this.c(le);me.set(n.$25b,le);const Ce=new de.$06b((0,_.$kj)(le),le.logsHome);me.set(de.$96b,Ce);const De=new ne.$K3b(Ce.getLogLevel()),Ue=we.add(new ue.$zN(De,[new _.$dj(Ce.getLogLevel())]));me.set(_.$9i,Ue);const Oe=new C.$Lp(Ue);me.set(A.$0j,Oe);const ze=new k.$$p(Ue);Oe.registerProvider(y.Schemas.file,ze);const We=new ce.$xr(Oe);me.set(V.$Hk,We);const x=new ye.$uN(1,le,Ue,Oe);me.set(Y.$qN,x),me.set(Y.$rN,x);const he=new O.$$5b(x,We,le,Oe,Ue);me.set(O.$05b,he),Oe.registerProvider(y.Schemas.vscodeUserData,new be.$37b(y.Schemas.file,ze,y.Schemas.vscodeUserData,he,We,Ue));const $e=b.$j&&Z.win32RegValueName?we.add(new B.$17b(Ue,Z.win32RegValueName)):le.policyFile?we.add(new T.$27b(le.policyFile,Oe,Ue)):new L.$hn;me.set(L.$fn,$e);const ve=new o.$Hn(he.defaultProfile.settingsResource,Oe,$e,Ue);return me.set(c.$ii,ve),me.set(z.$45b,new I.$Lh(z.$55b,void 0,!1)),me.set(N.$Qo,new I.$Lh(q.$Y7b,void 0,!0)),me.set(F.$d6b,new I.$Lh(F.$e6b)),me.set(X.$2k,new I.$Lh(H.$Z7b,void 0,!1)),me.set(J.$6u,new I.$Lh(G.$W7b)),me.set(oe.$S6b,new K.$T7b(le,he,Ue)),[new j.$bq(me,!0),ge,le,ve,x,De,Z,he]}c(me){const we={VSCODE_IPC_HOOK:me.mainIPCHandle};return["VSCODE_NLS_CONFIG","VSCODE_PORTABLE"].forEach(Z=>{const le=process.env[Z];typeof le=="string"&&(we[Z]=le)}),Object.assign(process.env,we),we}async d(me,we,Z,le,ge){await D.Promises.settled([Promise.all([me.extensionsPath,me.codeCachePath,me.logsHome.with({scheme:y.Schemas.file}).fsPath,we.defaultProfile.globalStorageHome.with({scheme:y.Schemas.file}).fsPath,me.workspaceStorageHome.with({scheme:y.Schemas.file}).fsPath,me.localHistoryHome.with({scheme:y.Schemas.file}).fsPath,me.backupHome].map(Ce=>Ce?u.Promises.mkdir(Ce,{recursive:!0}):void 0)),le.init(),Z.initialize()]),we.init()}async e(me,we,Z,le,ge,Ce){let De;try{(0,v.mark)("code/willStartMainServer"),De=await(0,E.$Jh)(we.mainIPCHandle),(0,v.mark)("code/didStartMainServer"),g.Event.once(Z.onWillShutdown)(()=>De.dispose())}catch(Ue){if(Ue.code!=="EADDRINUSE")throw this.f(we,ge,Ue),Ue;let Oe;try{Oe=await(0,E.$Kh)(we.mainIPCHandle,"main")}catch(he){if(!Ce||b.$j||he.code!=="ECONNREFUSED")throw he.code==="EPERM"&&this.g((0,i.localize)(1,null,ge.nameShort),(0,i.localize)(2,null),ge),he;try{(0,R.unlinkSync)(we.mainIPCHandle)}catch($e){throw me.warn("Could not delete obsolete instance handle",$e),$e}return this.e(me,we,Z,le,ge,!1)}if(we.extensionTestsLocationURI&&!we.debugExtensionHost.break){const he=`Running extension tests from the command line is currently only supported if no other instance of ${ge.nameShort} is running.`;throw me.error(he),Oe.dispose(),new Error(he)}let ze;!we.args.wait&&!we.args.status&&(ze=setTimeout(()=>{this.g((0,i.localize)(3,null,ge.nameShort),(0,i.localize)(4,null),ge)},1e4));const We=l.ProxyChannel.toService(Oe.getChannel("launch"),{disableMarshalling:!0}),x=l.ProxyChannel.toService(Oe.getChannel("diagnostics"),{disableMarshalling:!0});if(we.args.status)return le.invokeFunction(async()=>{const he=new t.$Er(re.$jo,ge),$e=await x.getMainDiagnostics(),ve=await x.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0}),Re=await he.getDiagnostics($e,ve);throw console.log(Re),new f.$ab});throw b.$j&&await this.h(We,me),me.trace("Sending env to running instance..."),await We.start(we.args,process.env),Oe.dispose(),ze&&clearTimeout(ze),new f.$ab("Sent env to running instance. Terminating...")}if(we.args.status)throw console.log((0,i.localize)(5,null,ge.nameShort)),new f.$ab("Terminating...");return process.env.VSCODE_PID=String(process.pid),De}f(me,we,Z){if(Z.code==="EACCES"||Z.code==="EPERM"){const le=(0,M.$Hb)([me.userDataPath,me.extensionsPath,E.$Fh]).map(ge=>(0,w.$nv)(s.URI.file(ge),{os:b.OS,tildify:me}));this.g((0,i.localize)(6,null),(0,i.localize)(7,null,(0,P.$zi)(Z),le.join(`
`)),we)}}g(me,we,Z){S.dialog.showMessageBoxSync((0,fe.$Bv)({type:"warning",buttons:[(0,i.localize)(8,null)],message:me,detail:we},Z).options)}async h(me,we){if(b.$j){const Z=await me.getMainProcessId();we.trace("Sending some foreground love to the running instance:",Z);try{(await new Promise((le,ge)=>{Q(["windows-foreground-love"],le,ge)})).allowSetForegroundWindow(Z)}catch(le){we.error(le)}}}i(me,we){const Z=me.get(_.$9i),le=me.get(z.$45b);let ge=0;we&&(we.isExpected?we.message&&Z.trace(we.message):(ge=1,we.stack?Z.error(we.stack):Z.error(`Startup error: ${we.toString()}`))),le.kill(ge)}j(){const me=this.k((0,r.$Il)(process.argv));if(me.wait&&!me.waitMarkerFilePath){const we=(0,p.$S7b)(me.verbose);we&&((0,r.$Kl)(process.argv,"--waitMarkerFilePath",we),me.waitMarkerFilePath=we)}return me}k(me){if(me["open-url"]&&(me._urls=me._,me._=[]),!me.remote){const we=this.l(me._,me.goto);me._=we}return me}l(me,we){const Z=(0,$.cwd)(),le=me.map(De=>{let Ue=String(De),Oe;we&&(Oe=(0,a.$5f)(Ue),Ue=Oe.path),Ue&&(Ue=this.m(Z,Ue));const ze=(0,a.$Zf)(Ue,Z),We=(0,d.$nc)(ze);return We&&!(0,a.$Vf)(We)?null:we&&Oe?(Oe.path=ze,this.n(Oe)):ze}),ge=b.$j||b.$k,Ce=(0,M.$Mb)(le,De=>De&&ge?De.toLowerCase():De||"");return(0,M.$Hb)(Ce)}m(me,we){return b.$j&&(we=(0,m.$Ke)(we,'"')),we=(0,m.$Ie)((0,m.$Ie)(we," "),"	"),b.$j&&(we=(0,d.$kc)(me,we),we=(0,m.$Ke)(we,".")),we}n(me){const we=[me.path];return typeof me.line=="number"&&we.push(String(me.line)),typeof me.column=="number"&&we.push(String(me.column)),we.join(":")}}new pe().main()})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/6a7a661757dec1983ff05ef908a2bbb75ce841e0/core/vs/code/electron-main/main.js.map
